/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var V=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/range","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],G=function(F){for(var t=[],P=0,R=F.length;P<R;P++)t[P]=V[F[P]];return t},Ee=this,Se=typeof global=="object"?global:{},ee;(function(F){F.global=Ee;var t=function(){function P(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(P.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),P.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=P._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof F.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},P._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},P}();F.Environment=t})(ee||(ee={}));var ee;(function(F){var t=function(){function C(l,S,a){this.type=l,this.detail=S,this.timestamp=a}return C}();F.LoaderEvent=t;var P=function(){function C(l){this._events=[new t(1,"",l)]}return C.prototype.record=function(l,S){this._events.push(new t(l,S,F.Utilities.getHighPerformanceTimestamp()))},C.prototype.getEvents=function(){return this._events},C}();F.LoaderEventRecorder=P;var R=function(){function C(){}return C.prototype.record=function(l,S){},C.prototype.getEvents=function(){return[]},C.INSTANCE=new C,C}();F.NullLoaderEventRecorder=R})(ee||(ee={}));var ee;(function(F){var t=function(){function P(){}return P.fileUriToFilePath=function(R,C){if(C=decodeURI(C).replace(/%23/g,"#"),R){if(/^file:\/\/\//.test(C))return C.substr(8);if(/^file:\/\//.test(C))return C.substr(5)}else if(/^file:\/\//.test(C))return C.substr(7);return C},P.startsWith=function(R,C){return R.length>=C.length&&R.substr(0,C.length)===C},P.endsWith=function(R,C){return R.length>=C.length&&R.substr(R.length-C.length)===C},P.containsQueryString=function(R){return/^[^\#]*\?/gi.test(R)},P.isAbsolutePath=function(R){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(R)},P.forEachProperty=function(R,C){if(R){var l=void 0;for(l in R)R.hasOwnProperty(l)&&C(l,R[l])}},P.isEmpty=function(R){var C=!0;return P.forEachProperty(R,function(){C=!1}),C},P.recursiveClone=function(R){if(!R||typeof R!="object"||R instanceof RegExp||!Array.isArray(R)&&Object.getPrototypeOf(R)!==Object.prototype)return R;var C=Array.isArray(R)?[]:{};return P.forEachProperty(R,function(l,S){S&&typeof S=="object"?C[l]=P.recursiveClone(S):C[l]=S}),C},P.generateAnonymousModule=function(){return"===anonymous"+P.NEXT_ANONYMOUS_ID+++"==="},P.isAnonymousModule=function(R){return P.startsWith(R,"===anonymous")},P.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=F.global.performance&&typeof F.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?F.global.performance.now():Date.now()},P.NEXT_ANONYMOUS_ID=1,P.PERFORMANCE_NOW_PROBED=!1,P.HAS_PERFORMANCE_NOW=!1,P}();F.Utilities=t})(ee||(ee={}));var ee;(function(F){function t(C){if(C instanceof Error)return C;var l=new Error(C.message||String(C)||"Unknown Error");return C.stack&&(l.stack=C.stack),l}F.ensureError=t;var P=function(){function C(){}return C.validateConfigurationOptions=function(l){function S(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory method of "'+u.moduleId+'" has thrown an exception'),console.error(u);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError=="undefined"&&(l.catchError=!1),typeof l.recordStats=="undefined"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=S),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(F.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags=="undefined"&&(l.preferScriptTags=!1),Array.isArray(l.nodeModules)||(l.nodeModules=[]),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){var a=t(new Error("INVALID cached data configuration, 'path' MUST be set"));a.phase="configuration",l.onError(a),l.nodeCachedData=void 0}return l},C.mergeConfigurationOptions=function(l,S){l===void 0&&(l=null),S===void 0&&(S=null);var a=F.Utilities.recursiveClone(S||{});return F.Utilities.forEachProperty(l,function(u,o){u==="ignoreDuplicateModules"&&typeof a.ignoreDuplicateModules!="undefined"?a.ignoreDuplicateModules=a.ignoreDuplicateModules.concat(o):u==="paths"&&typeof a.paths!="undefined"?F.Utilities.forEachProperty(o,function(v,w){return a.paths[v]=w}):u==="config"&&typeof a.config!="undefined"?F.Utilities.forEachProperty(o,function(v,w){return a.config[v]=w}):a[u]=F.Utilities.recursiveClone(o)}),C.validateConfigurationOptions(a)},C}();F.ConfigurationOptionsUtil=P;var R=function(){function C(l,S){if(this._env=l,this.options=P.mergeConfigurationOptions(S),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var a=this.options.nodeRequire.main.filename,u=Math.max(a.lastIndexOf("/"),a.lastIndexOf("\\"));this.options.baseUrl=a.substring(0,u+1)}if(this.options.nodeMain&&this._env.isNode){var a=this.options.nodeMain,u=Math.max(a.lastIndexOf("/"),a.lastIndexOf("\\"));this.options.baseUrl=a.substring(0,u+1)}}}return C.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0},C.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var l=0,S=this.options.nodeModules;l<S.length;l++){var a=S[l];this.nodeModulesMap[a]=!0}},C.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],F.Utilities.forEachProperty(this.options.paths,function(S,a){Array.isArray(a)?l.sortedPathsRules.push({from:S,to:a}):l.sortedPathsRules.push({from:S,to:[a]})}),this.sortedPathsRules.sort(function(S,a){return a.from.length-S.from.length})},C.prototype.cloneAndMerge=function(l){return new C(this._env,P.mergeConfigurationOptions(l,this.options))},C.prototype.getOptionsLiteral=function(){return this.options},C.prototype._applyPaths=function(l){for(var S,a=0,u=this.sortedPathsRules.length;a<u;a++)if(S=this.sortedPathsRules[a],F.Utilities.startsWith(l,S.from)){for(var o=[],v=0,w=S.to.length;v<w;v++)o.push(S.to[v]+l.substr(S.from.length));return o}return[l]},C.prototype._addUrlArgsToUrl=function(l){return F.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},C.prototype._addUrlArgsIfNecessaryToUrl=function(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l},C.prototype._addUrlArgsIfNecessaryToUrls=function(l){if(this.options.urlArgs)for(var S=0,a=l.length;S<a;S++)l[S]=this._addUrlArgsToUrl(l[S]);return l},C.prototype.moduleIdToPaths=function(l){var S=this.nodeModulesMap[l]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l);if(S)return this.isBuild()?["empty:"]:["node|"+l];var a=l,u;if(!F.Utilities.endsWith(a,".js")&&!F.Utilities.isAbsolutePath(a)){u=this._applyPaths(a);for(var o=0,v=u.length;o<v;o++)this.isBuild()&&u[o]==="empty:"||(F.Utilities.isAbsolutePath(u[o])||(u[o]=this.options.baseUrl+u[o]),!F.Utilities.endsWith(u[o],".js")&&!F.Utilities.containsQueryString(u[o])&&(u[o]=u[o]+".js"))}else!F.Utilities.endsWith(a,".js")&&!F.Utilities.containsQueryString(a)&&(a=a+".js"),u=[a];return this._addUrlArgsIfNecessaryToUrls(u)},C.prototype.requireToUrl=function(l){var S=l;return F.Utilities.isAbsolutePath(S)||(S=this._applyPaths(S)[0],F.Utilities.isAbsolutePath(S)||(S=this.options.baseUrl+S)),this._addUrlArgsIfNecessaryToUrl(S)},C.prototype.isBuild=function(){return this.options.isBuild},C.prototype.isDuplicateMessageIgnoredFor=function(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)},C.prototype.getConfigForModule=function(l){if(this.options.config)return this.options.config[l]},C.prototype.shouldCatchError=function(){return this.options.catchError},C.prototype.shouldRecordStats=function(){return this.options.recordStats},C.prototype.onError=function(l){this.options.onError(l)},C}();F.Configuration=R})(ee||(ee={}));var ee;(function(F){var t=function(){function u(o){this._env=o,this._scriptLoader=null,this._callbackMap={}}return u.prototype.load=function(o,v,w,g){var c=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new C;else if(this._env.isElectronRenderer){var _=o.getConfig().getOptionsLiteral().preferScriptTags;_?this._scriptLoader=new P:this._scriptLoader=new l(this._env)}else this._env.isNode?this._scriptLoader=new l(this._env):this._scriptLoader=new P;var b={callback:w,errorback:g};if(this._callbackMap.hasOwnProperty(v)){this._callbackMap[v].push(b);return}this._callbackMap[v]=[b],this._scriptLoader.load(o,v,function(){return c.triggerCallback(v)},function(A){return c.triggerErrorback(v,A)})},u.prototype.triggerCallback=function(o){var v=this._callbackMap[o];delete this._callbackMap[o];for(var w=0;w<v.length;w++)v[w].callback()},u.prototype.triggerErrorback=function(o,v){var w=this._callbackMap[o];delete this._callbackMap[o];for(var g=0;g<w.length;g++)w[g].errorback(v)},u}(),P=function(){function u(){}return u.prototype.attachListeners=function(o,v,w){var g=function(){o.removeEventListener("load",c),o.removeEventListener("error",_)},c=function(b){g(),v()},_=function(b){g(),w(b)};o.addEventListener("load",c),o.addEventListener("error",_)},u.prototype.load=function(o,v,w,g){if(/^node\|/.test(v)){var c=o.getConfig().getOptionsLiteral(),_=S(o.getRecorder(),c.nodeRequire||F.global.nodeRequire),b=v.split("|"),A=null;try{A=_(b[1])}catch(r){g(r);return}o.enqueueDefineAnonymousModule([],function(){return A}),w()}else{var E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript"),this.attachListeners(E,w,g);var n=o.getConfig().getOptionsLiteral().trustedTypesPolicy;n&&(v=n.createScriptURL(v)),E.setAttribute("src",v);var i=o.getConfig().getOptionsLiteral().cspNonce;i&&E.setAttribute("nonce",i),document.getElementsByTagName("head")[0].appendChild(E)}},u}();function R(u){var o=u.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var v=o?self.eval(o.createScript("","true")):new Function("true");return v.call(self),!0}catch(w){return!1}}var C=function(){function u(){this._cachedCanUseEval=null}return u.prototype._canUseEval=function(o){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=R(o)),this._cachedCanUseEval},u.prototype.load=function(o,v,w,g){if(/^node\|/.test(v)){var c=o.getConfig().getOptionsLiteral(),_=S(o.getRecorder(),c.nodeRequire||F.global.nodeRequire),b=v.split("|"),A=null;try{A=_(b[1])}catch(i){g(i);return}o.enqueueDefineAnonymousModule([],function(){return A}),w()}else{var E=o.getConfig().getOptionsLiteral().trustedTypesPolicy,n=/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin;if(!n&&this._canUseEval(o)){fetch(v).then(function(i){if(i.status!==200)throw new Error(i.statusText);return i.text()}).then(function(i){i=i+`
//# sourceURL=`+v;var r=E?self.eval(E.createScript("",i)):new Function(i);r.call(self),w()}).then(void 0,g);return}try{E&&(v=E.createScriptURL(v)),importScripts(v),w()}catch(i){g(i)}}},u}(),l=function(){function u(o){this._env=o,this._didInitialize=!1,this._didPatchNodeRequire=!1}return u.prototype._init=function(o){this._didInitialize||(this._didInitialize=!0,this._fs=o("fs"),this._vm=o("vm"),this._path=o("path"),this._crypto=o("crypto"))},u.prototype._initNodeRequire=function(o,v){var w=v.getConfig().getOptionsLiteral().nodeCachedData;if(!w||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var g=this,c=o("module");function _(b){var A=b.constructor,E=function(i){try{return b.require(i)}finally{}};return E.resolve=function(i,r){return A._resolveFilename(i,b,!1,r)},E.resolve.paths=function(i){return A._resolveLookupPaths(i,b)},E.main=process.mainModule,E.extensions=A._extensions,E.cache=A._cache,E}c.prototype._compile=function(b,A){var E=c.wrap(b.replace(/^#!.*/,"")),n=v.getRecorder(),i=g._getCachedDataPath(w,A),r={filename:A},s;try{var f=g._fs.readFileSync(i);s=f.slice(0,16),r.cachedData=f.slice(16),n.record(60,i)}catch(M){n.record(61,i)}var L=new g._vm.Script(E,r),h=L.runInThisContext(r),d=g._path.dirname(A),m=_(this),p=[this.exports,m,this,A,d,process,Se,Buffer],D=h.apply(this.exports,p);return g._handleCachedData(L,E,i,!r.cachedData,v),g._verifyCachedData(L,E,i,s,v),D}},u.prototype.load=function(o,v,w,g){var c=this,_=o.getConfig().getOptionsLiteral(),b=S(o.getRecorder(),_.nodeRequire||F.global.nodeRequire),A=_.nodeInstrumenter||function(h){return h};this._init(b),this._initNodeRequire(b,o);var E=o.getRecorder();if(/^node\|/.test(v)){var n=v.split("|"),i=null;try{i=b(n[1])}catch(h){g(h);return}o.enqueueDefineAnonymousModule([],function(){return i}),w()}else{v=F.Utilities.fileUriToFilePath(this._env.isWindows,v);var r=this._path.normalize(v),s=this._getElectronRendererScriptPathOrUri(r),f=Boolean(_.nodeCachedData),L=f?this._getCachedDataPath(_.nodeCachedData,v):void 0;this._readSourceAndCachedData(r,L,E,function(h,d,m,p){if(h){g(h);return}var D;d.charCodeAt(0)===u._BOM?D=u._PREFIX+d.substring(1)+u._SUFFIX:D=u._PREFIX+d+u._SUFFIX,D=A(D,r);var M={filename:s,cachedData:m},U=c._createAndEvalScript(o,D,M,w,g);c._handleCachedData(U,D,L,f&&!m,o),c._verifyCachedData(U,D,L,p,o)})}},u.prototype._createAndEvalScript=function(o,v,w,g,c){var _=o.getRecorder();_.record(31,w.filename);var b=new this._vm.Script(v,w),A=b.runInThisContext(w),E=o.getGlobalAMDDefineFunc(),n=!1,i=function(){return n=!0,E.apply(null,arguments)};return i.amd=E.amd,A.call(F.global,o.getGlobalAMDRequireFunc(),i,w.filename,this._path.dirname(w.filename)),_.record(32,w.filename),n?g():c(new Error("Didn't receive define call in "+w.filename+"!")),b},u.prototype._getElectronRendererScriptPathOrUri=function(o){if(!this._env.isElectronRenderer)return o;var v=o.match(/^([a-z])\:(.*)/i);return v?"file:///"+(v[1].toUpperCase()+":"+v[2]).replace(/\\/g,"/"):"file://"+o},u.prototype._getCachedDataPath=function(o,v){var w=this._crypto.createHash("md5").update(v,"utf8").update(o.seed,"utf8").update(process.arch,"").digest("hex"),g=this._path.basename(v).replace(/\.js$/,"");return this._path.join(o.path,g+"-"+w+".code")},u.prototype._handleCachedData=function(o,v,w,g,c){var _=this;o.cachedDataRejected?this._fs.unlink(w,function(b){c.getRecorder().record(62,w),_._createAndWriteCachedData(o,v,w,c),b&&c.getConfig().onError(b)}):g&&this._createAndWriteCachedData(o,v,w,c)},u.prototype._createAndWriteCachedData=function(o,v,w,g){var c=this,_=Math.ceil(g.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),b=-1,A=0,E=void 0,n=function(){setTimeout(function(){E||(E=c._crypto.createHash("md5").update(v,"utf8").digest());var i=o.createCachedData();if(!(i.length===0||i.length===b||A>=5)){if(i.length<b){n();return}b=i.length,c._fs.writeFile(w,Buffer.concat([E,i]),function(r){r&&g.getConfig().onError(r),g.getRecorder().record(63,w),n()})}},_*Math.pow(4,A++))};n()},u.prototype._readSourceAndCachedData=function(o,v,w,g){if(!v)this._fs.readFile(o,{encoding:"utf8"},g);else{var c=void 0,_=void 0,b=void 0,A=2,E=function(n){n?g(n):--A==0&&g(void 0,c,_,b)};this._fs.readFile(o,{encoding:"utf8"},function(n,i){c=i,E(n)}),this._fs.readFile(v,function(n,i){!n&&i&&i.length>0?(b=i.slice(0,16),_=i.slice(16),w.record(60,v)):w.record(61,v),E()})}},u.prototype._verifyCachedData=function(o,v,w,g,c){var _=this;!g||o.cachedDataRejected||setTimeout(function(){var b=_._crypto.createHash("md5").update(v,"utf8").digest();g.equals(b)||(c.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+w+"' now, but a RESTART IS REQUIRED")),_._fs.unlink(w,function(A){A&&c.getConfig().onError(A)}))},Math.ceil(5e3*(1+Math.random())))},u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`,u}();function S(u,o){if(o.__$__isRecorded)return o;var v=function(g){u.record(33,g);try{return o(g)}finally{u.record(34,g)}};return v.__$__isRecorded=!0,v}F.ensureRecordedNodeRequire=S;function a(u){return new t(u)}F.createScriptLoader=a})(ee||(ee={}));var ee;(function(F){var t=function(){function a(u){var o=u.lastIndexOf("/");o!==-1?this.fromModulePath=u.substr(0,o+1):this.fromModulePath=""}return a._normalizeModuleId=function(u){var o=u,v;for(v=/\/\.\//;v.test(o);)o=o.replace(v,"/");for(o=o.replace(/^\.\//g,""),v=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;v.test(o);)o=o.replace(v,"/");return o=o.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),o},a.prototype.resolveModule=function(u){var o=u;return F.Utilities.isAbsolutePath(o)||(F.Utilities.startsWith(o,"./")||F.Utilities.startsWith(o,"../"))&&(o=a._normalizeModuleId(this.fromModulePath+o)),o},a.ROOT=new a(""),a}();F.ModuleIdResolver=t;var P=function(){function a(u,o,v,w,g,c){this.id=u,this.strId=o,this.dependencies=v,this._callback=w,this._errorback=g,this.moduleIdResolver=c,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return a._safeInvokeFunction=function(u,o){try{return{returnedValue:u.apply(F.global,o),producedError:null}}catch(v){return{returnedValue:null,producedError:v}}},a._invokeFactory=function(u,o,v,w){return u.isBuild()&&!F.Utilities.isAnonymousModule(o)?{returnedValue:null,producedError:null}:u.shouldCatchError()?this._safeInvokeFunction(v,w):{returnedValue:v.apply(F.global,w),producedError:null}},a.prototype.complete=function(u,o,v){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);var g=a._invokeFactory(o,this.strId,this._callback,v);w=g.producedError,u.record(22,this.strId),!w&&typeof g.returnedValue!="undefined"&&(!this.exportsPassedIn||F.Utilities.isEmpty(this.exports))&&(this.exports=g.returnedValue)}else this.exports=this._callback;if(w){var c=F.ensureError(w);c.phase="factory",c.moduleId=this.strId,this.error=c,o.onError(c)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},a.prototype.onDependencyError=function(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1},a.prototype.isComplete=function(){return this._isComplete},a}();F.Module=P;var R=function(){function a(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return a.prototype.getMaxModuleId=function(){return this._nextId},a.prototype.getModuleId=function(u){var o=this._strModuleIdToIntModuleId.get(u);return typeof o=="undefined"&&(o=this._nextId++,this._strModuleIdToIntModuleId.set(u,o),this._intModuleIdToStrModuleId[o]=u),o},a.prototype.getStrModuleId=function(u){return this._intModuleIdToStrModuleId[u]},a}(),C=function(){function a(u){this.id=u}return a.EXPORTS=new a(0),a.MODULE=new a(1),a.REQUIRE=new a(2),a}();F.RegularDependency=C;var l=function(){function a(u,o,v){this.id=u,this.pluginId=o,this.pluginParam=v}return a}();F.PluginDependency=l;var S=function(){function a(u,o,v,w,g){g===void 0&&(g=0),this._env=u,this._scriptLoader=o,this._loaderAvailableTimestamp=g,this._defineFunc=v,this._requireFunc=w,this._moduleIdProvider=new R,this._config=new F.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return a.prototype.reset=function(){return new a(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},a.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},a.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},a._findRelevantLocationInStack=function(u,o){for(var v=function(r){return r.replace(/\\/g,"/")},w=v(u),g=o.split(/\n/),c=0;c<g.length;c++){var _=g[c].match(/(.*):(\d+):(\d+)\)?$/);if(_){var b=_[1],A=_[2],E=_[3],n=Math.max(b.lastIndexOf(" ")+1,b.lastIndexOf("(")+1);if(b=b.substr(n),b=v(b),b===w){var i={line:parseInt(A,10),col:parseInt(E,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+u)},a.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var u=[],o=0,v=0,w=this._modules2.length;v<w;v++){var g=this._modules2[v];if(!!g){var c=this._buildInfoPath[g.id]||null,_=this._buildInfoDefineStack[g.id]||null,b=this._buildInfoDependencies[g.id];u[o++]={id:g.strId,path:c,defineLocation:c&&_?a._findRelevantLocationInStack(c,_):null,dependencies:b,shim:null,exports:g.exports}}}return u},a.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new F.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=F.NullLoaderEventRecorder.INSTANCE),this._recorder},a.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},a.prototype.enqueueDefineAnonymousModule=function(u,o){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var v=null;this._config.isBuild()&&(v=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:v,dependencies:u,callback:o}},a.prototype.defineModule=function(u,o,v,w,g,c){var _=this;c===void 0&&(c=new t(u));var b=this._moduleIdProvider.getModuleId(u);if(this._modules2[b]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}var A=new P(b,u,this._normalizeDependencies(o,c),v,w,c);this._modules2[b]=A,this._config.isBuild()&&(this._buildInfoDefineStack[b]=g,this._buildInfoDependencies[b]=(A.dependencies||[]).map(function(E){return _._moduleIdProvider.getStrModuleId(E.id)})),this._resolve(A)},a.prototype._normalizeDependency=function(u,o){if(u==="exports")return C.EXPORTS;if(u==="module")return C.MODULE;if(u==="require")return C.REQUIRE;var v=u.indexOf("!");if(v>=0){var w=o.resolveModule(u.substr(0,v)),g=o.resolveModule(u.substr(v+1)),c=this._moduleIdProvider.getModuleId(w+"!"+g),_=this._moduleIdProvider.getModuleId(w);return new l(c,_,g)}return new C(this._moduleIdProvider.getModuleId(o.resolveModule(u)))},a.prototype._normalizeDependencies=function(u,o){for(var v=[],w=0,g=0,c=u.length;g<c;g++)v[w++]=this._normalizeDependency(u[g],o);return v},a.prototype._relativeRequire=function(u,o,v,w){if(typeof o=="string")return this.synchronousRequire(o,u);this.defineModule(F.Utilities.generateAnonymousModule(),o,v,w,null,u)},a.prototype.synchronousRequire=function(u,o){o===void 0&&(o=new t(u));var v=this._normalizeDependency(u,o),w=this._modules2[v.id];if(!w)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!w.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(w.error)throw w.error;return w.exports},a.prototype.configure=function(u,o){var v=this._config.shouldRecordStats();o?this._config=new F.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!v&&(this._recorder=null)},a.prototype.getConfig=function(){return this._config},a.prototype._onLoad=function(u){if(this._currentAnonymousDefineCall!==null){var o=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),o.dependencies,o.callback,null,o.stack)}},a.prototype._createLoadError=function(u,o){var v=this,w=this._moduleIdProvider.getStrModuleId(u),g=(this._inverseDependencies2[u]||[]).map(function(_){return v._moduleIdProvider.getStrModuleId(_)}),c=F.ensureError(o);return c.phase="loading",c.moduleId=w,c.neededBy=g,c},a.prototype._onLoadError=function(u,o){var v=this._createLoadError(u,o);this._modules2[u]||(this._modules2[u]=new P(u,this._moduleIdProvider.getStrModuleId(u),[],function(){},null,null));for(var w=[],g=0,c=this._moduleIdProvider.getMaxModuleId();g<c;g++)w[g]=!1;var _=!1,b=[];for(b.push(u),w[u]=!0;b.length>0;){var A=b.shift(),E=this._modules2[A];E&&(_=E.onDependencyError(v)||_);var n=this._inverseDependencies2[A];if(n)for(var g=0,c=n.length;g<c;g++){var i=n[g];w[i]||(b.push(i),w[i]=!0)}}_||this._config.onError(v)},a.prototype._hasDependencyPath=function(u,o){var v=this._modules2[u];if(!v)return!1;for(var w=[],g=0,c=this._moduleIdProvider.getMaxModuleId();g<c;g++)w[g]=!1;var _=[];for(_.push(v),w[u]=!0;_.length>0;){var b=_.shift(),A=b.dependencies;if(A)for(var g=0,c=A.length;g<c;g++){var E=A[g];if(E.id===o)return!0;var n=this._modules2[E.id];n&&!w[E.id]&&(w[E.id]=!0,_.push(n))}}return!1},a.prototype._findCyclePath=function(u,o,v){if(u===o||v===50)return[u];var w=this._modules2[u];if(!w)return null;var g=w.dependencies;if(g)for(var c=0,_=g.length;c<_;c++){var b=this._findCyclePath(g[c].id,o,v+1);if(b!==null)return b.push(u),b}return null},a.prototype._createRequire=function(u){var o=this,v=function(w,g,c){return o._relativeRequire(u,w,g,c)};return v.toUrl=function(w){return o._config.requireToUrl(u.resolveModule(w))},v.getStats=function(){return o.getLoaderEvents()},v.hasDependencyCycle=function(){return o._hasDependencyCycle},v.config=function(w,g){g===void 0&&(g=!1),o.configure(w,g)},v.__$__nodeRequire=F.global.nodeRequire,v},a.prototype._loadModule=function(u){var o=this;if(!(this._modules2[u]||this._knownModules2[u])){this._knownModules2[u]=!0;var v=this._moduleIdProvider.getStrModuleId(u),w=this._config.moduleIdToPaths(v),g=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(v.indexOf("/")===-1||g.test(v))&&w.push("node|"+v);var c=-1,_=function(b){if(c++,c>=w.length)o._onLoadError(u,b);else{var A=w[c],E=o.getRecorder();if(o._config.isBuild()&&A==="empty:"){o._buildInfoPath[u]=A,o.defineModule(o._moduleIdProvider.getStrModuleId(u),[],null,null,null),o._onLoad(u);return}E.record(10,A),o._scriptLoader.load(o,A,function(){o._config.isBuild()&&(o._buildInfoPath[u]=A),E.record(11,A),o._onLoad(u)},function(n){E.record(12,A),_(n)})}};_(null)}},a.prototype._loadPluginDependency=function(u,o){var v=this;if(!(this._modules2[o.id]||this._knownModules2[o.id])){this._knownModules2[o.id]=!0;var w=function(g){v.defineModule(v._moduleIdProvider.getStrModuleId(o.id),[],g,null,null)};w.error=function(g){v._config.onError(v._createLoadError(o.id,g))},u.load(o.pluginParam,this._createRequire(t.ROOT),w,this._config.getOptionsLiteral())}},a.prototype._resolve=function(u){var o=this,v=u.dependencies;if(v)for(var w=0,g=v.length;w<g;w++){var c=v[w];if(c===C.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(c===C.MODULE){u.unresolvedDependenciesCount--;continue}if(c===C.REQUIRE){u.unresolvedDependenciesCount--;continue}var _=this._modules2[c.id];if(_&&_.isComplete()){if(_.error){u.onDependencyError(_.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(c.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(c.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");var b=this._findCyclePath(c.id,u.id,0)||[];b.reverse(),b.push(c.id),console.warn(b.map(function(n){return o._moduleIdProvider.getStrModuleId(n)}).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[c.id]=this._inverseDependencies2[c.id]||[],this._inverseDependencies2[c.id].push(u.id),c instanceof l){var A=this._modules2[c.pluginId];if(A&&A.isComplete()){this._loadPluginDependency(A.exports,c);continue}var E=this._inversePluginDependencies2.get(c.pluginId);E||(E=[],this._inversePluginDependencies2.set(c.pluginId,E)),E.push(c),this._loadModule(c.pluginId);continue}this._loadModule(c.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)},a.prototype._onModuleComplete=function(u){var o=this,v=this.getRecorder();if(!u.isComplete()){var w=u.dependencies,g=[];if(w)for(var c=0,_=w.length;c<_;c++){var b=w[c];if(b===C.EXPORTS){g[c]=u.exports;continue}if(b===C.MODULE){g[c]={id:u.strId,config:function(){return o._config.getConfigForModule(u.strId)}};continue}if(b===C.REQUIRE){g[c]=this._createRequire(u.moduleIdResolver);continue}var A=this._modules2[b.id];if(A){g[c]=A.exports;continue}g[c]=null}u.complete(v,this._config,g);var E=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,E)for(var c=0,_=E.length;c<_;c++){var n=E[c],i=this._modules2[n];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var r=this._inversePluginDependencies2.get(u.id);if(r){this._inversePluginDependencies2.delete(u.id);for(var c=0,_=r.length;c<_;c++)this._loadPluginDependency(u.exports,r[c])}}},a}();F.ModuleManager=S})(ee||(ee={}));var z,ee;(function(F){var t=new F.Environment,P=null,R=function(a,u,o){typeof a!="string"&&(o=u,u=a,a=null),(typeof u!="object"||!Array.isArray(u))&&(o=u,u=null),u||(u=["require","exports","module"]),a?P.defineModule(a,u,o,null,null):P.enqueueDefineAnonymousModule(u,o)};R.amd={jQuery:!0};var C=function(a,u){u===void 0&&(u=!1),P.configure(a,u)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){C(arguments[0]);return}if(typeof arguments[0]=="string")return P.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){P.defineModule(F.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=C,l.getConfig=function(){return P.getConfig().getOptionsLiteral()},l.reset=function(){P=P.reset()},l.getBuildInfo=function(){return P.getBuildInfo()},l.getStats=function(){return P.getLoaderEvents()},l.define=R;function S(){if(typeof F.global.require!="undefined"||typeof require!="undefined"){var a=F.global.require||require;if(typeof a=="function"&&typeof a.resolve=="function"){var u=F.ensureRecordedNodeRequire(P.getRecorder(),a);F.global.nodeRequire=u,l.nodeRequire=u,l.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?(module.exports=l,require=l):(t.isElectronRenderer||(F.global.define=R),F.global.require=l)}F.init=S,(typeof F.global.define!="function"||!F.global.define.amd)&&(P=new F.ModuleManager(t,F.createScriptLoader(t),R,l,F.Utilities.getHighPerformanceTimestamp()),typeof F.global.require!="undefined"&&typeof F.global.require!="function"&&l.config(F.global.require),z=function(){return R.apply(null,arguments)},z.amd=R.amd,typeof doNotInitLoader=="undefined"&&S())})(ee||(ee={}));var be=this,ge;(function(F){var t=be||{},P=t.Plugin&&t.Plugin.Resources?t.Plugin.Resources:void 0,R=t&&t.document&&t.document.location&&t.document.location.hash.indexOf("pseudo=true")>=0;function C(o,v){var w;return v.length===0?w=o:w=o.replace(/\{(\d+)\}/g,function(g,c){var _=c[0];return typeof v[_]!="undefined"?v[_]:g}),R&&(w="\uFF3B"+w.replace(/[aouei]/g,"$&$&")+"\uFF3D"),w}function l(o,v){var w=o[v];return w||(w=o["*"],w)?w:null}function S(o,v){for(var w=[],g=0;g<arguments.length-2;g++)w[g]=arguments[g+2];return C(v,w)}function a(o){return function(v,w){var g=Array.prototype.slice.call(arguments,2);return C(o[v],g)}}var u=function(){function o(){this.localize=S}return o.prototype.setPseudoTranslation=function(v){R=v},o.prototype.create=function(v,w){return{localize:a(w[v])}},o.prototype.load=function(v,w,g,c){if(c=c||{},!v||v.length===0)g({localize:S});else{var _=void 0;if(P&&P.getString)_=".nls.keys",w([v+_],function(E){g({localize:function(n,i){if(!E[n])return"NLS error: unknown key "+n;var r=E[n].keys;if(i>=r.length)return"NLS error unknown index "+i;var s=r[i],f=[];f[0]=n+"_"+s;for(var L=0;L<arguments.length-2;L++)f[L+1]=arguments[L+2];return P.getString.apply(P,f)}})});else if(c.isBuild)w([v+".nls",v+".nls.keys"],function(E,n){o.BUILD_MAP[v]=E,o.BUILD_MAP_KEYS[v]=n,g(E)});else{var b=c["vs/nls"]||{},A=b.availableLanguages?l(b.availableLanguages,v):null;_=".nls",A!==null&&A!==o.DEFAULT_TAG&&(_=_+"."+A),w([v+_],function(E){Array.isArray(E)?E.localize=a(E):E.localize=a(E[v]),g(E)})}}},o.prototype._getEntryPointsMap=function(){return t.nlsPluginEntryPoints=t.nlsPluginEntryPoints||{},t.nlsPluginEntryPoints},o.prototype.write=function(v,w,g){var c=g.getEntryPoint(),_=this._getEntryPointsMap();_[c]=_[c]||[],_[c].push(w),w!==c&&g.asModule(v+"!"+w,"define(['vs/nls', 'vs/nls!"+c+`'], function(nls, data) { return nls.create("`+w+'", data); });')},o.prototype.writeFile=function(v,w,g,c,_){var b=this._getEntryPointsMap();if(b.hasOwnProperty(w)){for(var A=g.toUrl(w+".nls.js"),E=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],n=b[w],i={},r=0;r<n.length;r++)i[n[r]]=o.BUILD_MAP[n[r]];E.push('define("'+w+'.nls", '+JSON.stringify(i,null,"	")+");"),c(A,E.join(`\r
`))}},o.prototype.finishBuild=function(v){v("nls.metadata.json",JSON.stringify({keys:o.BUILD_MAP_KEYS,messages:o.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},o.DEFAULT_TAG="i-default",o.BUILD_MAP={},o.BUILD_MAP_KEYS={},o}();F.NLSPlugin=u,function(){z("vs/nls",new u)}()})(ge||(ge={})),z(V[15],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class P{constructor(C,l,S,a){this.originalStart=C,this.originalLength=l,this.modifiedStart=S,this.modifiedLength=a}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=P}),z(V[4],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(f){setTimeout(()=>{throw f.stack?new Error(f.message+`

`+f.stack):f},0)}}addListener(f){return this.listeners.push(f),()=>{this._removeListener(f)}}emit(f){this.listeners.forEach(L=>{L(f)})}_removeListener(f){this.listeners.splice(this.listeners.indexOf(f),1)}setUnexpectedErrorHandler(f){this.unexpectedErrorHandler=f}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(f){this.unexpectedErrorHandler(f),this.emit(f)}onUnexpectedExternalError(f){this.unexpectedErrorHandler(f)}}t.ErrorHandler=P,t.errorHandler=new P;function R(s){t.errorHandler.setUnexpectedErrorHandler(s)}t.setUnexpectedErrorHandler=R;function C(s){u(s)||t.errorHandler.onUnexpectedError(s)}t.onUnexpectedError=C;function l(s){u(s)||t.errorHandler.onUnexpectedExternalError(s)}t.onUnexpectedExternalError=l;function S(s){if(s instanceof Error){let{name:f,message:L}=s;const h=s.stacktrace||s.stack;return{$isError:!0,name:f,message:L,stack:h}}return s}t.transformErrorForSerialization=S;const a="Canceled";function u(s){return s instanceof Error&&s.name===a&&s.message===a}t.isPromiseCanceledError=u;class o extends Error{constructor(){super(a);this.name=this.message}}t.CancellationError=o;function v(){const s=new Error(a);return s.name=s.message,s}t.canceled=v;function w(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}t.illegalArgument=w;function g(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}t.illegalState=g;function c(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=c;function _(s){const f=new Error(`${s} has been disposed`);return f.name="DISPOSED",f}t.disposed=_;function b(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}t.getErrorMessage=b;class A extends Error{constructor(f){super("NotImplemented");f&&(this.message=f)}}t.NotImplementedError=A;class E extends Error{constructor(f){super("NotSupported");f&&(this.message=f)}}t.NotSupportedError=E;class n extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=n;function i(s){const f=s;return f instanceof Error&&Array.isArray(f.actions)}t.isErrorWithActions=i;function r(s,f=Object.create(null)){const L=new Error(s);return f.actions&&(L.actions=f.actions),L}t.createErrorWithActions=r}),z(V[7],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function P(R){const C=this;let l=!1,S;return function(){return l||(l=!0,S=R.apply(C,arguments)),S}}t.once=P}),z(V[16],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var P;(function(R){function C(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}R.is=C;const l=Object.freeze([]);function S(){return l}R.empty=S;function*a(s){yield s}R.single=a;function u(s){return s||l}R.from=u;function o(s){return!s||s[Symbol.iterator]().next().done===!0}R.isEmpty=o;function v(s){return s[Symbol.iterator]().next().value}R.first=v;function w(s,f){for(const L of s)if(f(L))return!0;return!1}R.some=w;function g(s,f){for(const L of s)if(f(L))return L}R.find=g;function*c(s,f){for(const L of s)f(L)&&(yield L)}R.filter=c;function*_(s,f){let L=0;for(const h of s)yield f(h,L++)}R.map=_;function*b(...s){for(const f of s)for(const L of f)yield L}R.concat=b;function*A(s){for(const f of s)for(const L of f)yield L}R.concatNested=A;function E(s,f,L){let h=L;for(const d of s)h=f(h,d);return h}R.reduce=E;function*n(s,f,L=s.length){for(f<0&&(f+=s.length),L<0?L+=s.length:L>s.length&&(L=s.length);f<L;f++)yield s[f]}R.slice=n;function i(s,f=Number.POSITIVE_INFINITY){const L=[];if(f===0)return[L,s];const h=s[Symbol.iterator]();for(let d=0;d<f;d++){const m=h.next();if(m.done)return[L,R.empty()];L.push(m.value)}return[L,{[Symbol.iterator](){return h}}]}R.consume=i;function r(s,f,L=(h,d)=>h===d){const h=s[Symbol.iterator](),d=f[Symbol.iterator]();for(;;){const m=h.next(),p=d.next();if(m.done!==p.done)return!1;if(m.done)return!0;if(!L(m.value,p.value))return!1}}R.equals=r})(P=t.Iterable||(t.Iterable={}))}),z(V[17],G([0,1,4]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.KeyCode=void 0;var R;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.KEY_0=21]="KEY_0",n[n.KEY_1=22]="KEY_1",n[n.KEY_2=23]="KEY_2",n[n.KEY_3=24]="KEY_3",n[n.KEY_4=25]="KEY_4",n[n.KEY_5=26]="KEY_5",n[n.KEY_6=27]="KEY_6",n[n.KEY_7=28]="KEY_7",n[n.KEY_8=29]="KEY_8",n[n.KEY_9=30]="KEY_9",n[n.KEY_A=31]="KEY_A",n[n.KEY_B=32]="KEY_B",n[n.KEY_C=33]="KEY_C",n[n.KEY_D=34]="KEY_D",n[n.KEY_E=35]="KEY_E",n[n.KEY_F=36]="KEY_F",n[n.KEY_G=37]="KEY_G",n[n.KEY_H=38]="KEY_H",n[n.KEY_I=39]="KEY_I",n[n.KEY_J=40]="KEY_J",n[n.KEY_K=41]="KEY_K",n[n.KEY_L=42]="KEY_L",n[n.KEY_M=43]="KEY_M",n[n.KEY_N=44]="KEY_N",n[n.KEY_O=45]="KEY_O",n[n.KEY_P=46]="KEY_P",n[n.KEY_Q=47]="KEY_Q",n[n.KEY_R=48]="KEY_R",n[n.KEY_S=49]="KEY_S",n[n.KEY_T=50]="KEY_T",n[n.KEY_U=51]="KEY_U",n[n.KEY_V=52]="KEY_V",n[n.KEY_W=53]="KEY_W",n[n.KEY_X=54]="KEY_X",n[n.KEY_Y=55]="KEY_Y",n[n.KEY_Z=56]="KEY_Z",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.US_SEMICOLON=80]="US_SEMICOLON",n[n.US_EQUAL=81]="US_EQUAL",n[n.US_COMMA=82]="US_COMMA",n[n.US_MINUS=83]="US_MINUS",n[n.US_DOT=84]="US_DOT",n[n.US_SLASH=85]="US_SLASH",n[n.US_BACKTICK=86]="US_BACKTICK",n[n.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",n[n.US_BACKSLASH=88]="US_BACKSLASH",n[n.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",n[n.US_QUOTE=90]="US_QUOTE",n[n.OEM_8=91]="OEM_8",n[n.OEM_102=92]="OEM_102",n[n.NUMPAD_0=93]="NUMPAD_0",n[n.NUMPAD_1=94]="NUMPAD_1",n[n.NUMPAD_2=95]="NUMPAD_2",n[n.NUMPAD_3=96]="NUMPAD_3",n[n.NUMPAD_4=97]="NUMPAD_4",n[n.NUMPAD_5=98]="NUMPAD_5",n[n.NUMPAD_6=99]="NUMPAD_6",n[n.NUMPAD_7=100]="NUMPAD_7",n[n.NUMPAD_8=101]="NUMPAD_8",n[n.NUMPAD_9=102]="NUMPAD_9",n[n.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",n[n.NUMPAD_ADD=104]="NUMPAD_ADD",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",n[n.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",n[n.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.MAX_VALUE=112]="MAX_VALUE"})(R=t.KeyCode||(t.KeyCode={}));class C{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(i,r){this._keyCodeToStr[i]=r,this._strToKeyCode[r.toLowerCase()]=i}keyCodeToStr(i){return this._keyCodeToStr[i]}strToKeyCode(i){return this._strToKeyCode[i.toLowerCase()]||0}}const l=new C,S=new C,a=new C;(function(){function n(i,r,s=r,f=s){l.define(i,r),S.define(i,s),a.define(i,f)}n(0,"unknown"),n(1,"Backspace"),n(2,"Tab"),n(3,"Enter"),n(4,"Shift"),n(5,"Ctrl"),n(6,"Alt"),n(7,"PauseBreak"),n(8,"CapsLock"),n(9,"Escape"),n(10,"Space"),n(11,"PageUp"),n(12,"PageDown"),n(13,"End"),n(14,"Home"),n(15,"LeftArrow","Left"),n(16,"UpArrow","Up"),n(17,"RightArrow","Right"),n(18,"DownArrow","Down"),n(19,"Insert"),n(20,"Delete"),n(21,"0"),n(22,"1"),n(23,"2"),n(24,"3"),n(25,"4"),n(26,"5"),n(27,"6"),n(28,"7"),n(29,"8"),n(30,"9"),n(31,"A"),n(32,"B"),n(33,"C"),n(34,"D"),n(35,"E"),n(36,"F"),n(37,"G"),n(38,"H"),n(39,"I"),n(40,"J"),n(41,"K"),n(42,"L"),n(43,"M"),n(44,"N"),n(45,"O"),n(46,"P"),n(47,"Q"),n(48,"R"),n(49,"S"),n(50,"T"),n(51,"U"),n(52,"V"),n(53,"W"),n(54,"X"),n(55,"Y"),n(56,"Z"),n(57,"Meta"),n(58,"ContextMenu"),n(59,"F1"),n(60,"F2"),n(61,"F3"),n(62,"F4"),n(63,"F5"),n(64,"F6"),n(65,"F7"),n(66,"F8"),n(67,"F9"),n(68,"F10"),n(69,"F11"),n(70,"F12"),n(71,"F13"),n(72,"F14"),n(73,"F15"),n(74,"F16"),n(75,"F17"),n(76,"F18"),n(77,"F19"),n(78,"NumLock"),n(79,"ScrollLock"),n(80,";",";","OEM_1"),n(81,"=","=","OEM_PLUS"),n(82,",",",","OEM_COMMA"),n(83,"-","-","OEM_MINUS"),n(84,".",".","OEM_PERIOD"),n(85,"/","/","OEM_2"),n(86,"`","`","OEM_3"),n(110,"ABNT_C1"),n(111,"ABNT_C2"),n(87,"[","[","OEM_4"),n(88,"\\","\\","OEM_5"),n(89,"]","]","OEM_6"),n(90,"'","'","OEM_7"),n(91,"OEM_8"),n(92,"OEM_102"),n(93,"NumPad0"),n(94,"NumPad1"),n(95,"NumPad2"),n(96,"NumPad3"),n(97,"NumPad4"),n(98,"NumPad5"),n(99,"NumPad6"),n(100,"NumPad7"),n(101,"NumPad8"),n(102,"NumPad9"),n(103,"NumPad_Multiply"),n(104,"NumPad_Add"),n(105,"NumPad_Separator"),n(106,"NumPad_Subtract"),n(107,"NumPad_Decimal"),n(108,"NumPad_Divide")})();var u;(function(n){function i(d){return l.keyCodeToStr(d)}n.toString=i;function r(d){return l.strToKeyCode(d)}n.fromString=r;function s(d){return S.keyCodeToStr(d)}n.toUserSettingsUS=s;function f(d){return a.keyCodeToStr(d)}n.toUserSettingsGeneral=f;function L(d){return S.strToKeyCode(d)||a.strToKeyCode(d)}n.fromUserSettings=L;function h(d){if(d>=93&&d<=108)return null;switch(d){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return l.keyCodeToStr(d)}n.toElectronAccelerator=h})(u=t.KeyCodeUtils||(t.KeyCodeUtils={}));var o;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl",n[n.KeyCode=255]="KeyCode"})(o||(o={}));var v;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl"})(v=t.KeyMod||(t.KeyMod={}));function w(n,i){const r=(i&65535)<<16>>>0;return(n|r)>>>0}t.KeyChord=w;function g(n,i){if(n===0)return null;const r=(n&65535)>>>0,s=(n&4294901760)>>>16;return s!==0?new b([c(r,i),c(s,i)]):new b([c(r,i)])}t.createKeybinding=g;function c(n,i){const r=!!(n&2048),s=!!(n&256),f=i===2?s:r,L=!!(n&1024),h=!!(n&512),d=i===2?r:s,m=n&255;return new _(f,L,h,d,m)}t.createSimpleKeybinding=c;class _{constructor(i,r,s,f,L){this.ctrlKey=i,this.shiftKey=r,this.altKey=s,this.metaKey=f,this.keyCode=L}equals(i){return this.ctrlKey===i.ctrlKey&&this.shiftKey===i.shiftKey&&this.altKey===i.altKey&&this.metaKey===i.metaKey&&this.keyCode===i.keyCode}getHashCode(){const i=this.ctrlKey?"1":"0",r=this.shiftKey?"1":"0",s=this.altKey?"1":"0",f=this.metaKey?"1":"0";return`${i}${r}${s}${f}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=_;class b{constructor(i){if(i.length===0)throw(0,P.illegalArgument)("parts");this.parts=i}getHashCode(){let i="";for(let r=0,s=this.parts.length;r<s;r++)r!==0&&(i+=";"),i+=this.parts[r].getHashCode();return i}equals(i){if(i===null||this.parts.length!==i.parts.length)return!1;for(let r=0;r<this.parts.length;r++)if(!this.parts[r].equals(i.parts[r]))return!1;return!0}}t.ChordKeybinding=b;class A{constructor(i,r,s,f,L,h){this.ctrlKey=i,this.shiftKey=r,this.altKey=s,this.metaKey=f,this.keyLabel=L,this.keyAriaLabel=h}}t.ResolvedKeybindingPart=A;class E{}t.ResolvedKeybinding=E}),z(V[8],G([0,1,7,16]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const C=!1;let l=null;function S(d){l=d}if(t.setDisposableTracker=S,C){const d="__is_disposable_tracked__";S(new class{trackDisposable(m){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[d]||console.log(p)},3e3)}setParent(m,p){if(m&&m!==n.None)try{m[d]=!0}catch{}}markAsDisposed(m){if(m&&m!==n.None)try{m[d]=!0}catch{}}markAsSingleton(m){}})}function a(d){return l?.trackDisposable(d),d}function u(d){l?.markAsDisposed(d)}function o(d,m){l?.setParent(d,m)}function v(d,m){if(!!l)for(const p of d)l.setParent(p,m)}function w(d){return l?.markAsSingleton(d),d}t.markAsSingleton=w;class g extends Error{constructor(m){super(`Encountered errors while disposing of store. Errors: [${m.join(", ")}]`);this.errors=m}}t.MultiDisposeError=g;function c(d){return typeof d.dispose=="function"&&d.dispose.length===0}t.isDisposable=c;function _(d){if(R.Iterable.is(d)){let m=[];for(const p of d)if(p)try{p.dispose()}catch(D){m.push(D)}if(m.length===1)throw m[0];if(m.length>1)throw new g(m);return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}t.dispose=_;function b(...d){const m=A(()=>_(d));return v(d,m),m}t.combinedDisposable=b;function A(d){const m=a({dispose:(0,P.once)(()=>{u(m),d()})});return m}t.toDisposable=A;class E{constructor(){this._toDispose=new Set,this._isDisposed=!1,a(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}clear(){try{_(this._toDispose.values())}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return o(m,this),this._isDisposed?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}}t.DisposableStore=E,E.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this._store=new E,a(this),o(this._store,this)}dispose(){u(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}t.Disposable=n,n.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,a(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){this._isDisposed||m===this._value||(this._value?.dispose(),m&&o(m,this),this._value=m)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const m=this._value;return this._value=void 0,m&&o(m,null),m}}t.MutableDisposable=i;class r{constructor(m){this._disposable=m,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}t.RefCountedDisposable=r;class s{constructor(){this.references=new Map}acquire(m,...p){let D=this.references.get(m);D||(D={counter:0,object:this.createReferencedObject(m,...p)},this.references.set(m,D));const{object:M}=D,U=(0,P.once)(()=>{--D.counter==0&&(this.destroyReferencedObject(m,D.object),this.references.delete(m))});return D.counter++,{object:M,dispose:U}}}t.ReferenceCollection=s;class f{constructor(m){this.referenceCollection=m}async acquire(m,...p){const D=this.referenceCollection.acquire(m,...p);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(M){throw D.dispose(),M}}}t.AsyncReferenceCollection=f;class L{constructor(m){this.object=m}dispose(){}}t.ImmortalReference=L;function h(d){const m=new E;try{d(m)}finally{m.dispose()}}t.disposeOnReturn=h}),z(V[18],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class P{constructor(l){this.element=l,this.next=P.Undefined,this.prev=P.Undefined}}P.Undefined=new P(void 0);class R{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let l=this._first;for(;l!==P.Undefined;){const S=l.next;l.prev=P.Undefined,l.next=P.Undefined,l=S}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(l){return this._insert(l,!1)}push(l){return this._insert(l,!0)}_insert(l,S){const a=new P(l);if(this._first===P.Undefined)this._first=a,this._last=a;else if(S){const o=this._last;this._last=a,a.prev=o,o.next=a}else{const o=this._first;this._first=a,a.next=o,o.prev=a}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(a))}}shift(){if(this._first!==P.Undefined){const l=this._first.element;return this._remove(this._first),l}}pop(){if(this._last!==P.Undefined){const l=this._last.element;return this._remove(this._last),l}}_remove(l){if(l.prev!==P.Undefined&&l.next!==P.Undefined){const S=l.prev;S.next=l.next,l.next.prev=S}else l.prev===P.Undefined&&l.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):l.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):l.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let l=this._first;for(;l!==P.Undefined;)yield l.element,l=l.next}}t.LinkedList=R}),z(V[2],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.isElectronSandboxed=t.globals=void 0;const P="en";let R=!1,C=!1,l=!1,S=!1,a=!1,u=!1,o=!1,v,w=P,g,c;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let _;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?_=t.globals.vscode.process:typeof process!="undefined"&&(_=process);const b=typeof _?.versions?.electron=="string"&&_.type==="renderer";if(t.isElectronSandboxed=b&&_?.sandboxed,typeof navigator=="object"&&!b)c=navigator.userAgent,R=c.indexOf("Windows")>=0,C=c.indexOf("Macintosh")>=0,o=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,l=c.indexOf("Linux")>=0,u=!0,v=navigator.language,w=v;else if(typeof _=="object"){R=_.platform==="win32",C=_.platform==="darwin",l=_.platform==="linux",S=l&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,v=P,w=P;const h=_.env.VSCODE_NLS_CONFIG;if(h)try{const d=JSON.parse(h),m=d.availableLanguages["*"];v=d.locale,w=m||P,g=d._translationsConfigFile}catch(d){}a=!0}else console.error("Unable to resolve platform.");var A;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(A=t.Platform||(t.Platform={}));function E(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=E;let n=0;C?n=1:R?n=3:l&&(n=2),t.isWindows=R,t.isMacintosh=C,t.isLinux=l,t.isLinuxSnap=S,t.isNative=a,t.isWeb=u,t.isIOS=o,t.platform=n,t.userAgent=c,t.language=w;var i;(function(h){function d(){return t.language}h.value=d;function m(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}h.isDefaultVariant=m;function p(){return t.language==="en"}h.isDefault=p})(i=t.Language||(t.Language={})),t.locale=v,t.translationsConfigFile=g,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let m=[];t.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let M=0,U=m.length;M<U;M++){const k=m[M];if(k.id===D.data.vscodeSetImmediateId){m.splice(M,1),k.callback();return}}});let p=0;return D=>{const M=++p;m.push({id:M,callback:D}),t.globals.postMessage({vscodeSetImmediateId:M},"*")}}if(typeof _?.nextTick=="function")return _.nextTick.bind(_);const d=Promise.resolve();return m=>d.then(m)}();var r;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(r=t.OperatingSystem||(t.OperatingSystem={})),t.OS=C||o?2:R?1:3;let s=!0,f=!1;function L(){if(!f){f=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,s=new Uint16Array(h.buffer)[0]===(2<<8)+1}return s}t.isLittleEndian=L}),z(V[19],G([0,1,2]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.nextTick=t.platform=t.env=t.cwd=void 0;let R;if(typeof P.globals.vscode!="undefined"&&typeof P.globals.vscode.process!="undefined"){const C=P.globals.vscode.process;R={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()},nextTick(l){return(0,P.setImmediate)(l)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:R={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},nextTick(C){return(0,P.setImmediate)(C)},get env(){return{}},cwd(){return"/"}};t.cwd=R.cwd,t.env=R.env,t.platform=R.platform,t.nextTick=R.nextTick,t.arch=R.arch}),z(V[20],G([0,1,19]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const R=65,C=97,l=90,S=122,a=46,u=47,o=92,v=58,w=63;class g extends Error{constructor(r,s,f){let L;typeof s=="string"&&s.indexOf("not ")===0?(L="must not be",s=s.replace(/^not /,"")):L="must be";const h=r.indexOf(".")!==-1?"property":"argument";let d=`The "${r}" ${h} ${L} of type ${s}`;d+=`. Received type ${typeof f}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function c(i,r){if(typeof i!="string")throw new g(r,"string",i)}function _(i){return i===u||i===o}function b(i){return i===u}function A(i){return i>=R&&i<=l||i>=C&&i<=S}function E(i,r,s,f){let L="",h=0,d=-1,m=0,p=0;for(let D=0;D<=i.length;++D){if(D<i.length)p=i.charCodeAt(D);else{if(f(p))break;p=u}if(f(p)){if(!(d===D-1||m===1))if(m===2){if(L.length<2||h!==2||L.charCodeAt(L.length-1)!==a||L.charCodeAt(L.length-2)!==a){if(L.length>2){const M=L.lastIndexOf(s);M===-1?(L="",h=0):(L=L.slice(0,M),h=L.length-1-L.lastIndexOf(s)),d=D,m=0;continue}else if(L.length!==0){L="",h=0,d=D,m=0;continue}}r&&(L+=L.length>0?`${s}..`:"..",h=2)}else L.length>0?L+=`${s}${i.slice(d+1,D)}`:L=i.slice(d+1,D),h=D-d-1;d=D,m=0}else p===a&&m!==-1?++m:m=-1}return L}function n(i,r){if(r===null||typeof r!="object")throw new g("pathObject","Object",r);const s=r.dir||r.root,f=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${f}`:`${s}${i}${f}`:f}t.win32={resolve(...i){let r="",s="",f=!1;for(let L=i.length-1;L>=-1;L--){let h;if(L>=0){if(h=i[L],c(h,"path"),h.length===0)continue}else r.length===0?h=P.cwd():(h=P.env[`=${r}`]||P.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==r.toLowerCase()&&h.charCodeAt(2)===o)&&(h=`${r}\\`));const d=h.length;let m=0,p="",D=!1;const M=h.charCodeAt(0);if(d===1)_(M)&&(m=1,D=!0);else if(_(M))if(D=!0,_(h.charCodeAt(1))){let U=2,k=U;for(;U<d&&!_(h.charCodeAt(U));)U++;if(U<d&&U!==k){const W=h.slice(k,U);for(k=U;U<d&&_(h.charCodeAt(U));)U++;if(U<d&&U!==k){for(k=U;U<d&&!_(h.charCodeAt(U));)U++;(U===d||U!==k)&&(p=`\\\\${W}\\${h.slice(k,U)}`,m=U)}}}else m=1;else A(M)&&h.charCodeAt(1)===v&&(p=h.slice(0,2),m=2,d>2&&_(h.charCodeAt(2))&&(D=!0,m=3));if(p.length>0)if(r.length>0){if(p.toLowerCase()!==r.toLowerCase())continue}else r=p;if(f){if(r.length>0)break}else if(s=`${h.slice(m)}\\${s}`,f=D,D&&r.length>0)break}return s=E(s,!f,"\\",_),f?`${r}\\${s}`:`${r}${s}`||"."},normalize(i){c(i,"path");const r=i.length;if(r===0)return".";let s=0,f,L=!1;const h=i.charCodeAt(0);if(r===1)return b(h)?"\\":i;if(_(h))if(L=!0,_(i.charCodeAt(1))){let m=2,p=m;for(;m<r&&!_(i.charCodeAt(m));)m++;if(m<r&&m!==p){const D=i.slice(p,m);for(p=m;m<r&&_(i.charCodeAt(m));)m++;if(m<r&&m!==p){for(p=m;m<r&&!_(i.charCodeAt(m));)m++;if(m===r)return`\\\\${D}\\${i.slice(p)}\\`;m!==p&&(f=`\\\\${D}\\${i.slice(p,m)}`,s=m)}}}else s=1;else A(h)&&i.charCodeAt(1)===v&&(f=i.slice(0,2),s=2,r>2&&_(i.charCodeAt(2))&&(L=!0,s=3));let d=s<r?E(i.slice(s),!L,"\\",_):"";return d.length===0&&!L&&(d="."),d.length>0&&_(i.charCodeAt(r-1))&&(d+="\\"),f===void 0?L?`\\${d}`:d:L?`${f}\\${d}`:`${f}${d}`},isAbsolute(i){c(i,"path");const r=i.length;if(r===0)return!1;const s=i.charCodeAt(0);return _(s)||r>2&&A(s)&&i.charCodeAt(1)===v&&_(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,s;for(let h=0;h<i.length;++h){const d=i[h];c(d,"path"),d.length>0&&(r===void 0?r=s=d:r+=`\\${d}`)}if(r===void 0)return".";let f=!0,L=0;if(typeof s=="string"&&_(s.charCodeAt(0))){++L;const h=s.length;h>1&&_(s.charCodeAt(1))&&(++L,h>2&&(_(s.charCodeAt(2))?++L:f=!1))}if(f){for(;L<r.length&&_(r.charCodeAt(L));)L++;L>=2&&(r=`\\${r.slice(L)}`)}return t.win32.normalize(r)},relative(i,r){if(c(i,"from"),c(r,"to"),i===r)return"";const s=t.win32.resolve(i),f=t.win32.resolve(r);if(s===f||(i=s.toLowerCase(),r=f.toLowerCase(),i===r))return"";let L=0;for(;L<i.length&&i.charCodeAt(L)===o;)L++;let h=i.length;for(;h-1>L&&i.charCodeAt(h-1)===o;)h--;const d=h-L;let m=0;for(;m<r.length&&r.charCodeAt(m)===o;)m++;let p=r.length;for(;p-1>m&&r.charCodeAt(p-1)===o;)p--;const D=p-m,M=d<D?d:D;let U=-1,k=0;for(;k<M;k++){const H=i.charCodeAt(L+k);if(H!==r.charCodeAt(m+k))break;H===o&&(U=k)}if(k!==M){if(U===-1)return f}else{if(D>M){if(r.charCodeAt(m+k)===o)return f.slice(m+k+1);if(k===2)return f.slice(m+k)}d>M&&(i.charCodeAt(L+k)===o?U=k:k===2&&(U=3)),U===-1&&(U=0)}let W="";for(k=L+U+1;k<=h;++k)(k===h||i.charCodeAt(k)===o)&&(W+=W.length===0?"..":"\\..");return m+=U,W.length>0?`${W}${f.slice(m,p)}`:(f.charCodeAt(m)===o&&++m,f.slice(m,p))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const r=t.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===o){if(r.charCodeAt(1)===o){const s=r.charCodeAt(2);if(s!==w&&s!==a)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(A(r.charCodeAt(0))&&r.charCodeAt(1)===v&&r.charCodeAt(2)===o)return`\\\\?\\${r}`;return i},dirname(i){c(i,"path");const r=i.length;if(r===0)return".";let s=-1,f=0;const L=i.charCodeAt(0);if(r===1)return _(L)?i:".";if(_(L)){if(s=f=1,_(i.charCodeAt(1))){let m=2,p=m;for(;m<r&&!_(i.charCodeAt(m));)m++;if(m<r&&m!==p){for(p=m;m<r&&_(i.charCodeAt(m));)m++;if(m<r&&m!==p){for(p=m;m<r&&!_(i.charCodeAt(m));)m++;if(m===r)return i;m!==p&&(s=f=m+1)}}}}else A(L)&&i.charCodeAt(1)===v&&(s=r>2&&_(i.charCodeAt(2))?3:2,f=s);let h=-1,d=!0;for(let m=r-1;m>=f;--m)if(_(i.charCodeAt(m))){if(!d){h=m;break}}else d=!1;if(h===-1){if(s===-1)return".";h=s}return i.slice(0,h)},basename(i,r){r!==void 0&&c(r,"ext"),c(i,"path");let s=0,f=-1,L=!0,h;if(i.length>=2&&A(i.charCodeAt(0))&&i.charCodeAt(1)===v&&(s=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let d=r.length-1,m=-1;for(h=i.length-1;h>=s;--h){const p=i.charCodeAt(h);if(_(p)){if(!L){s=h+1;break}}else m===-1&&(L=!1,m=h+1),d>=0&&(p===r.charCodeAt(d)?--d==-1&&(f=h):(d=-1,f=m))}return s===f?f=m:f===-1&&(f=i.length),i.slice(s,f)}for(h=i.length-1;h>=s;--h)if(_(i.charCodeAt(h))){if(!L){s=h+1;break}}else f===-1&&(L=!1,f=h+1);return f===-1?"":i.slice(s,f)},extname(i){c(i,"path");let r=0,s=-1,f=0,L=-1,h=!0,d=0;i.length>=2&&i.charCodeAt(1)===v&&A(i.charCodeAt(0))&&(r=f=2);for(let m=i.length-1;m>=r;--m){const p=i.charCodeAt(m);if(_(p)){if(!h){f=m+1;break}continue}L===-1&&(h=!1,L=m+1),p===a?s===-1?s=m:d!==1&&(d=1):s!==-1&&(d=-1)}return s===-1||L===-1||d===0||d===1&&s===L-1&&s===f+1?"":i.slice(s,L)},format:n.bind(null,"\\"),parse(i){c(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const s=i.length;let f=0,L=i.charCodeAt(0);if(s===1)return _(L)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(_(L)){if(f=1,_(i.charCodeAt(1))){let U=2,k=U;for(;U<s&&!_(i.charCodeAt(U));)U++;if(U<s&&U!==k){for(k=U;U<s&&_(i.charCodeAt(U));)U++;if(U<s&&U!==k){for(k=U;U<s&&!_(i.charCodeAt(U));)U++;U===s?f=U:U!==k&&(f=U+1)}}}}else if(A(L)&&i.charCodeAt(1)===v){if(s<=2)return r.root=r.dir=i,r;if(f=2,_(i.charCodeAt(2))){if(s===3)return r.root=r.dir=i,r;f=3}}f>0&&(r.root=i.slice(0,f));let h=-1,d=f,m=-1,p=!0,D=i.length-1,M=0;for(;D>=f;--D){if(L=i.charCodeAt(D),_(L)){if(!p){d=D+1;break}continue}m===-1&&(p=!1,m=D+1),L===a?h===-1?h=D:M!==1&&(M=1):h!==-1&&(M=-1)}return m!==-1&&(h===-1||M===0||M===1&&h===m-1&&h===d+1?r.base=r.name=i.slice(d,m):(r.name=i.slice(d,h),r.base=i.slice(d,m),r.ext=i.slice(h,m))),d>0&&d!==f?r.dir=i.slice(0,d-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...i){let r="",s=!1;for(let f=i.length-1;f>=-1&&!s;f--){const L=f>=0?i[f]:P.cwd();c(L,"path"),L.length!==0&&(r=`${L}/${r}`,s=L.charCodeAt(0)===u)}return r=E(r,!s,"/",b),s?`/${r}`:r.length>0?r:"."},normalize(i){if(c(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===u,s=i.charCodeAt(i.length-1)===u;return i=E(i,!r,"/",b),i.length===0?r?"/":s?"./":".":(s&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return c(i,"path"),i.length>0&&i.charCodeAt(0)===u},join(...i){if(i.length===0)return".";let r;for(let s=0;s<i.length;++s){const f=i[s];c(f,"path"),f.length>0&&(r===void 0?r=f:r+=`/${f}`)}return r===void 0?".":t.posix.normalize(r)},relative(i,r){if(c(i,"from"),c(r,"to"),i===r||(i=t.posix.resolve(i),r=t.posix.resolve(r),i===r))return"";const s=1,f=i.length,L=f-s,h=1,d=r.length-h,m=L<d?L:d;let p=-1,D=0;for(;D<m;D++){const U=i.charCodeAt(s+D);if(U!==r.charCodeAt(h+D))break;U===u&&(p=D)}if(D===m)if(d>m){if(r.charCodeAt(h+D)===u)return r.slice(h+D+1);if(D===0)return r.slice(h+D)}else L>m&&(i.charCodeAt(s+D)===u?p=D:D===0&&(p=0));let M="";for(D=s+p+1;D<=f;++D)(D===f||i.charCodeAt(D)===u)&&(M+=M.length===0?"..":"/..");return`${M}${r.slice(h+p)}`},toNamespacedPath(i){return i},dirname(i){if(c(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===u;let s=-1,f=!0;for(let L=i.length-1;L>=1;--L)if(i.charCodeAt(L)===u){if(!f){s=L;break}}else f=!1;return s===-1?r?"/":".":r&&s===1?"//":i.slice(0,s)},basename(i,r){r!==void 0&&c(r,"ext"),c(i,"path");let s=0,f=-1,L=!0,h;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let d=r.length-1,m=-1;for(h=i.length-1;h>=0;--h){const p=i.charCodeAt(h);if(p===u){if(!L){s=h+1;break}}else m===-1&&(L=!1,m=h+1),d>=0&&(p===r.charCodeAt(d)?--d==-1&&(f=h):(d=-1,f=m))}return s===f?f=m:f===-1&&(f=i.length),i.slice(s,f)}for(h=i.length-1;h>=0;--h)if(i.charCodeAt(h)===u){if(!L){s=h+1;break}}else f===-1&&(L=!1,f=h+1);return f===-1?"":i.slice(s,f)},extname(i){c(i,"path");let r=-1,s=0,f=-1,L=!0,h=0;for(let d=i.length-1;d>=0;--d){const m=i.charCodeAt(d);if(m===u){if(!L){s=d+1;break}continue}f===-1&&(L=!1,f=d+1),m===a?r===-1?r=d:h!==1&&(h=1):r!==-1&&(h=-1)}return r===-1||f===-1||h===0||h===1&&r===f-1&&r===s+1?"":i.slice(r,f)},format:n.bind(null,"/"),parse(i){c(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const s=i.charCodeAt(0)===u;let f;s?(r.root="/",f=1):f=0;let L=-1,h=0,d=-1,m=!0,p=i.length-1,D=0;for(;p>=f;--p){const M=i.charCodeAt(p);if(M===u){if(!m){h=p+1;break}continue}d===-1&&(m=!1,d=p+1),M===a?L===-1?L=p:D!==1&&(D=1):L!==-1&&(D=-1)}if(d!==-1){const M=h===0&&s?1:h;L===-1||D===0||D===1&&L===d-1&&L===h+1?r.base=r.name=i.slice(M,d):(r.name=i.slice(M,L),r.base=i.slice(M,d),r.ext=i.slice(L,d))}return h>0?r.dir=i.slice(0,h-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=P.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=P.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=P.platform==="win32"?t.win32.join:t.posix.join,t.resolve=P.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=P.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=P.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=P.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=P.platform==="win32"?t.win32.extname:t.posix.extname,t.format=P.platform==="win32"?t.win32.format:t.posix.format,t.parse=P.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=P.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=P.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=P.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),z(V[9],G([0,1,2]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const R=P.globals.performance&&typeof P.globals.performance.now=="function";class C{constructor(S){this._highResolution=R&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new C(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?P.globals.performance.now():Date.now()}}t.StopWatch=C}),z(V[10],G([0,1,4,7,8,18,9]),function(F,t,P,R,C,l,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;var a;(function(r){r.None=()=>C.Disposable.None;function s(q){return(y,Y=null,j)=>{let Q=!1,Z;return Z=q(K=>{if(!Q)return Z?Z.dispose():Q=!0,y.call(Y,K)},null,j),Q&&Z.dispose(),Z}}r.once=s;function f(q,y){return D((Y,j=null,Q)=>q(Z=>Y.call(j,y(Z)),null,Q))}r.map=f;function L(q,y){return D((Y,j=null,Q)=>q(Z=>{y(Z),Y.call(j,Z)},null,Q))}r.forEach=L;function h(q,y){return D((Y,j=null,Q)=>q(Z=>y(Z)&&Y.call(j,Z),null,Q))}r.filter=h;function d(q){return q}r.signal=d;function m(...q){return(y,Y=null,j)=>(0,C.combinedDisposable)(...q.map(Q=>Q(Z=>y.call(Y,Z),null,j)))}r.any=m;function p(q,y,Y){let j=Y;return f(q,Q=>(j=y(j,Q),j))}r.reduce=p;function D(q){let y;const Y=new g({onFirstListenerAdd(){y=q(Y.fire,Y)},onLastListenerRemove(){y.dispose()}});return Y.event}function M(q,y,Y=100,j=!1,Q){let Z,K,te,oe=0;const ae=new g({leakWarningThreshold:Q,onFirstListenerAdd(){Z=q(he=>{oe++,K=y(K,he),j&&!te&&(ae.fire(K),K=void 0),clearTimeout(te),te=setTimeout(()=>{const de=K;K=void 0,te=void 0,(!j||oe>1)&&ae.fire(de),oe=0},Y)})},onLastListenerRemove(){Z.dispose()}});return ae.event}r.debounce=M;function U(q,y=(Y,j)=>Y===j){let Y=!0,j;return h(q,Q=>{const Z=Y||!y(Q,j);return Y=!1,j=Q,Z})}r.latch=U;function k(q,y){return[r.filter(q,y),r.filter(q,Y=>!y(Y))]}r.split=k;function W(q,y=!1,Y=[]){let j=Y.slice(),Q=q(te=>{j?j.push(te):K.fire(te)});const Z=()=>{j&&j.forEach(te=>K.fire(te)),j=null},K=new g({onFirstListenerAdd(){Q||(Q=q(te=>K.fire(te)))},onFirstListenerDidAdd(){j&&(y?setTimeout(Z):Z())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return K.event}r.buffer=W;class H{constructor(y){this.event=y}map(y){return new H(f(this.event,y))}forEach(y){return new H(L(this.event,y))}filter(y){return new H(h(this.event,y))}reduce(y,Y){return new H(p(this.event,y,Y))}latch(){return new H(U(this.event))}debounce(y,Y=100,j=!1,Q){return new H(M(this.event,y,Y,j,Q))}on(y,Y,j){return this.event(y,Y,j)}once(y,Y,j){return s(this.event)(y,Y,j)}}function X(q){return new H(q)}r.chain=X;function $(q,y,Y=j=>j){const j=(...te)=>K.fire(Y(...te)),Q=()=>q.on(y,j),Z=()=>q.removeListener(y,j),K=new g({onFirstListenerAdd:Q,onLastListenerRemove:Z});return K.event}r.fromNodeEventEmitter=$;function x(q,y,Y=j=>j){const j=(...te)=>K.fire(Y(...te)),Q=()=>q.addEventListener(y,j),Z=()=>q.removeEventListener(y,j),K=new g({onFirstListenerAdd:Q,onLastListenerRemove:Z});return K.event}r.fromDOMEventEmitter=x;function e(q){return new Promise(y=>s(q)(y))}r.toPromise=e})(a=t.Event||(t.Event={}));class u{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${u._idPool++}`}start(s){this._stopWatch=new S.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}u._idPool=0;let o=-1;function v(r){const s=o;return o=r,{dispose(){o=s}}}t.setGlobalLeakWarningThreshold=v;class w{constructor(s,f=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let f=o;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),f<=0||s<f)return;this._stacks||(this._stacks=new Map);const L=new Error().stack.split(`
`).slice(3).join(`
`),h=this._stacks.get(L)||0;if(this._stacks.set(L,h+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let d,m=0;for(const[p,D]of this._stacks)(!d||m<D)&&(d=p,m=D);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${m}):`),console.warn(d)}return()=>{const d=this._stacks.get(L)||0;this._stacks.set(L,d-1)}}}class g{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=o>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new u(this._options._profName):void 0}get event(){return this._event||(this._event=(s,f,L)=>{this._listeners||(this._listeners=new l.LinkedList);const h=this._listeners.isEmpty();h&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const d=this._listeners.push(f?[s,f]:s);h&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,f);const m=this._leakageMon?.check(this._listeners.size),p=(0,C.toDisposable)(()=>{m&&m(),this._disposed||(d(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return L instanceof C.DisposableStore?L.add(p):Array.isArray(L)&&L.push(p),p}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new l.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,s]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,L]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,L):f[0].call(f[1],L)}catch(h){(0,P.onUnexpectedError)(h)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}t.Emitter=g;class c extends g{async fireAsync(s,f,L){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new l.LinkedList);for(const h of this._listeners)this._asyncDeliveryQueue.push([h,s]);for(;this._asyncDeliveryQueue.size>0&&!f.isCancellationRequested;){const[h,d]=this._asyncDeliveryQueue.shift(),m=[],p={...d,waitUntil:D=>{if(Object.isFrozen(m))throw new Error("waitUntil can NOT be called asynchronous");L&&(D=L(D,typeof h=="function"?h:h[0])),m.push(D)}};try{typeof h=="function"?h.call(void 0,p):h[0].call(h[1],p)}catch(D){(0,P.onUnexpectedError)(D);continue}Object.freeze(m),await Promise.allSettled(m).then(D=>{for(const M of D)M.status==="rejected"&&(0,P.onUnexpectedError)(M.reason)})}}}}t.AsyncEmitter=c;class _ extends g{constructor(s){super(s);this._isPaused=0,this._eventQueue=new l.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}t.PauseableEmitter=_;class b extends _{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}t.DebounceEmitter=b;class A extends g{constructor(s){super(s);this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(f=>super.fire(f)),this._queuedEvents=[]})}}t.MicrotaskEmitter=A;class E{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const f={event:s,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const L=()=>{this.hasListeners&&this.unhook(f);const h=this.events.indexOf(f);this.events.splice(h,1)};return(0,C.toDisposable)((0,R.once)(L))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(f=>this.emitter.fire(f))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=E;class n{constructor(){this.buffers=[]}wrapEvent(s){return(f,L,h)=>s(d=>{const m=this.buffers[this.buffers.length-1];m?m.push(()=>f.call(L,d)):f.call(L,d)},void 0,h)}bufferEvents(s){const f=[];this.buffers.push(f);const L=s();return this.buffers.pop(),f.forEach(h=>h()),L}}t.EventBufferer=n;class i{constructor(){this.listening=!1,this.inputEvent=a.None,this.inputEventListener=C.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=i}),z(V[21],G([0,1,10]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const R=Object.freeze(function(a,u){const o=setTimeout(a.bind(u),0);return{dispose(){clearTimeout(o)}}});var C;(function(a){function u(o){return o===a.None||o===a.Cancelled||o instanceof l?!0:!o||typeof o!="object"?!1:typeof o.isCancellationRequested=="boolean"&&typeof o.onCancellationRequested=="function"}a.isCancellationToken=u,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(C=t.CancellationToken||(t.CancellationToken={}));class l{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new l),this._token}cancel(){this._token?this._token instanceof l&&this._token.cancel():this._token=C.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof l&&this._token.dispose():this._token=C.None}}t.CancellationTokenSource=S}),z(V[5],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLeftDeleteOffset=t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function P(N){return!N||typeof N!="string"?!0:N.trim().length===0}t.isFalsyOrWhitespace=P;const R=/{(\d+)}/g;function C(N,...I){return I.length===0?N:N.replace(R,function(T,O){const B=parseInt(O,10);return isNaN(B)||B<0||B>=I.length?T:I[B]})}t.format=C;const l=/{([^}]+)}/g;function S(N,I){return N.replace(l,(T,O)=>I[O]??T)}t.format2=S;function a(N){return N.replace(/[<>&]/g,function(I){switch(I){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return I}})}t.escape=a;function u(N){return N.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=u;function o(N,I){let T=0;const O=I.charCodeAt(0);for(let B=N.length-1;B>=0;B--)N.charCodeAt(B)===O&&T++;return T}t.count=o;function v(N,I,T="\u2026"){return N.length<=I?N:`${N.substr(0,I)}${T}`}t.truncate=v;function w(N,I=" "){const T=g(N,I);return c(T,I)}t.trim=w;function g(N,I){if(!N||!I)return N;const T=I.length;if(T===0||N.length===0)return N;let O=0;for(;N.indexOf(I,O)===O;)O=O+T;return N.substring(O)}t.ltrim=g;function c(N,I){if(!N||!I)return N;const T=I.length,O=N.length;if(T===0||O===0)return N;let B=O,J=-1;for(;J=N.lastIndexOf(I,B-1),!(J===-1||J+T!==B);){if(J===0)return"";B=J}return N.substring(0,B)}t.rtrim=c;function _(N){return N.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=_;function b(N){return N.replace(/\*/g,"")}t.stripWildcards=b;function A(N,I,T={}){if(!N)throw new Error("Cannot create regex from empty string");I||(N=u(N)),T.wholeWord&&(/\B/.test(N.charAt(0))||(N="\\b"+N),/\B/.test(N.charAt(N.length-1))||(N=N+"\\b"));let O="";return T.global&&(O+="g"),T.matchCase||(O+="i"),T.multiline&&(O+="m"),T.unicode&&(O+="u"),new RegExp(N,O)}t.createRegExp=A;function E(N){return N.source==="^"||N.source==="^$"||N.source==="$"||N.source==="^\\s*$"?!1:!!(N.exec("")&&N.lastIndex===0)}t.regExpLeadsToEndlessLoop=E;function n(N){return!!N.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=n;function i(N){return(N.global?"g":"")+(N.ignoreCase?"i":"")+(N.multiline?"m":"")+(N.unicode?"u":"")}t.regExpFlags=i;function r(N){return N.split(/\r\n|\r|\n/)}t.splitLines=r;function s(N){for(let I=0,T=N.length;I<T;I++){const O=N.charCodeAt(I);if(O!==32&&O!==9)return I}return-1}t.firstNonWhitespaceIndex=s;function f(N,I=0,T=N.length){for(let O=I;O<T;O++){const B=N.charCodeAt(O);if(B!==32&&B!==9)return N.substring(I,O)}return N.substring(I,T)}t.getLeadingWhitespace=f;function L(N,I=N.length-1){for(let T=I;T>=0;T--){const O=N.charCodeAt(T);if(O!==32&&O!==9)return T}return-1}t.lastNonWhitespaceIndex=L;function h(N,I){return N<I?-1:N>I?1:0}t.compare=h;function d(N,I,T=0,O=N.length,B=0,J=I.length){for(;T<O&&B<J;T++,B++){let se=N.charCodeAt(T),re=I.charCodeAt(B);if(se<re)return-1;if(se>re)return 1}const ne=O-T,ie=J-B;return ne<ie?-1:ne>ie?1:0}t.compareSubstring=d;function m(N,I){return p(N,I,0,N.length,0,I.length)}t.compareIgnoreCase=m;function p(N,I,T=0,O=N.length,B=0,J=I.length){for(;T<O&&B<J;T++,B++){let se=N.charCodeAt(T),re=I.charCodeAt(B);if(se===re)continue;if(se>=128||re>=128)return d(N.toLowerCase(),I.toLowerCase(),T,O,B,J);D(se)&&(se-=32),D(re)&&(re-=32);const ue=se-re;if(ue!==0)return ue}const ne=O-T,ie=J-B;return ne<ie?-1:ne>ie?1:0}t.compareSubstringIgnoreCase=p;function D(N){return N>=97&&N<=122}t.isLowerAsciiLetter=D;function M(N){return N>=65&&N<=90}t.isUpperAsciiLetter=M;function U(N,I){return N.length===I.length&&p(N,I)===0}t.equalsIgnoreCase=U;function k(N,I){const T=I.length;return I.length>N.length?!1:p(N,I,0,T)===0}t.startsWithIgnoreCase=k;function W(N,I){let T,O=Math.min(N.length,I.length);for(T=0;T<O;T++)if(N.charCodeAt(T)!==I.charCodeAt(T))return T;return O}t.commonPrefixLength=W;function H(N,I){let T,O=Math.min(N.length,I.length);const B=N.length-1,J=I.length-1;for(T=0;T<O;T++)if(N.charCodeAt(B-T)!==I.charCodeAt(J-T))return T;return O}t.commonSuffixLength=H;function X(N){return 55296<=N&&N<=56319}t.isHighSurrogate=X;function $(N){return 56320<=N&&N<=57343}t.isLowSurrogate=$;function x(N,I){return(N-55296<<10)+(I-56320)+65536}t.computeCodePoint=x;function e(N,I,T){const O=N.charCodeAt(T);if(X(O)&&T+1<I){const B=N.charCodeAt(T+1);if($(B))return x(O,B)}return O}t.getNextCodePoint=e;function q(N,I){const T=N.charCodeAt(I-1);if($(T)&&I>1){const O=N.charCodeAt(I-2);if(X(O))return x(O,T)}return T}function y(N,I){const T=le.getInstance(),O=I,B=N.length,J=e(N,B,I);I+=J>=65536?2:1;let ne=T.getGraphemeBreakType(J);for(;I<B;){const ie=e(N,B,I),se=T.getGraphemeBreakType(ie);if(ce(ne,se))break;I+=ie>=65536?2:1,ne=se}return I-O}t.nextCharLength=y;function Y(N,I){const T=le.getInstance(),O=I,B=q(N,I);I-=B>=65536?2:1;let J=T.getGraphemeBreakType(B);for(;I>0;){const ne=q(N,I),ie=T.getGraphemeBreakType(ne);if(ce(ie,J))break;I-=ne>=65536?2:1,J=ie}return O-I}t.prevCharLength=Y;function j(N,I){const T=le.getInstance(),O=N.length,B=I,J=e(N,O,I),ne=T.getGraphemeBreakType(J);I+=J>=65536?2:1;let ie=ne;for(;I<O;){const re=e(N,O,I),ue=T.getGraphemeBreakType(re);if(ce(ie,ue))break;I+=re>=65536?2:1,ie=ue}const se=I;for(I=B,ie=ne;I>0;){const re=q(N,I),ue=T.getGraphemeBreakType(re);if(ce(ue,ie))break;I-=re>=65536?2:1,ie=ue}return[I,se]}function Q(N,I){return I>0&&$(N.charCodeAt(I))?j(N,I-1):j(N,I)}t.getCharContainingOffset=Q;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(N){return Z.test(N)}t.containsRTL=K;const te=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function oe(N){return te.test(N)}t.containsEmoji=oe;const ae=/^[\t\n\r\x20-\x7E]*$/;function he(N){return ae.test(N)}t.isBasicASCII=he,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(N){return t.UNUSUAL_LINE_TERMINATORS.test(N)}t.containsUnusualLineTerminators=de;function Ae(N){for(let I=0,T=N.length;I<T;I++)if(me(N.charCodeAt(I)))return!0;return!1}t.containsFullWidthCharacter=Ae;function me(N){return N=+N,N>=11904&&N<=55215||N>=63744&&N<=64255||N>=65281&&N<=65374}t.isFullWidthCharacter=me;function _e(N){return N>=127462&&N<=127487||N===8986||N===8987||N===9200||N===9203||N>=9728&&N<=10175||N===11088||N===11093||N>=127744&&N<=128591||N>=128640&&N<=128764||N>=128992&&N<=129003||N>=129280&&N<=129535||N>=129648&&N<=129750}t.isEmojiImprecise=_e;function Ne(N,I){if(N.length<I)return N;const T=/\b/g;let O=0;for(;T.test(N)&&!(N.length-T.lastIndex<I);)O=T.lastIndex,T.lastIndex+=1;return N.substring(O).replace(/^\s/,"")}t.lcut=Ne;const we=/\x1B\x5B[12]?K/g,Ce=/\x1b\[\d+m/g,Pe=/\x1b\[0?m/g;function pe(N){return N&&(N=N.replace(we,""),N=N.replace(Ce,""),N=N.replace(Pe,"")),N}t.removeAnsiEscapeCodes=pe,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ve(N){return!!(N&&N.length>0&&N.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ve;function Me(N){return ve(N)?N.substr(1):N}t.stripUTF8BOM=Me;function De(N,I){if(!N||!I||N.length<I.length)return!1;const T=I.length,O=N.toLowerCase();let B=0,J=-1;for(;B<T;){const ne=O.indexOf(I[B],J+1);if(ne<0)return!1;J=ne,B++}return!0}t.fuzzyContains=De;function Ue(N,I=!1){return N?(I&&(N=N.replace(/\\./g,"")),N.toLowerCase()!==N):!1}t.containsUppercaseCharacter=Ue;function Re(N){return N.charAt(0).toUpperCase()+N.slice(1)}t.uppercaseFirstLetter=Re;function Ie(N,I=1){if(I===0)return"";let T=-1;do T=N.indexOf(`
`,T+1),I--;while(I>0&&T>=0);return T===-1?N:(N[T-1]==="\r"&&T--,N.substr(0,T))}t.getNLines=Ie;function Fe(N){const I=90-65+1;return N=N%(2*I),N<I?String.fromCharCode(97+N):String.fromCharCode(65+N-I)}t.singleLetterHash=Fe;function Te(N){return le.getInstance().getGraphemeBreakType(N)}t.getGraphemeBreakType=Te;function ce(N,I){return N===0?I!==5&&I!==7:N===2&&I===3?!1:N===4||N===2||N===3||I===4||I===2||I===3?!0:!(N===8&&(I===8||I===9||I===11||I===12)||(N===11||N===9)&&(I===9||I===10)||(N===12||N===10)&&I===10||I===5||I===13||I===7||N===1||N===13&&I===14||N===6&&I===6)}t.breakBetweenGraphemeBreakType=ce;var ke;(function(N){N[N.Other=0]="Other",N[N.Prepend=1]="Prepend",N[N.CR=2]="CR",N[N.LF=3]="LF",N[N.Control=4]="Control",N[N.Extend=5]="Extend",N[N.Regional_Indicator=6]="Regional_Indicator",N[N.SpacingMark=7]="SpacingMark",N[N.L=8]="L",N[N.V=9]="V",N[N.T=10]="T",N[N.LV=11]="LV",N[N.LVT=12]="LVT",N[N.ZWJ=13]="ZWJ",N[N.Extended_Pictographic=14]="Extended_Pictographic"})(ke=t.GraphemeBreakType||(t.GraphemeBreakType={}));class le{constructor(){this._data=ye()}static getInstance(){return le._INSTANCE||(le._INSTANCE=new le),le._INSTANCE}getGraphemeBreakType(I){if(I<32)return I===10?3:I===13?2:4;if(I<127)return 0;const T=this._data,O=T.length/3;let B=1;for(;B<=O;)if(I<T[3*B])B=2*B;else if(I>T[3*B+1])B=2*B+1;else return T[3*B+2];return 0}}le._INSTANCE=null;function ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function We(N,I){if(N===0)return 0;const T=Oe(N,I);if(T!==void 0)return T;const O=q(I,N);return N-=fe(O),N}t.getLeftDeleteOffset=We;function Oe(N,I){let T=q(I,N);for(N-=fe(T);qe(T)||T===65039||T===8419;){if(N===0)return;T=q(I,N),N-=fe(T)}if(!!_e(T)){if(N>=0){const O=q(I,N);O===8205&&(N-=fe(O))}return N}}function fe(N){return N>=65536?2:1}function qe(N){return 127995<=N&&N<=127999}var Le;(function(N){N[N.zwj=8205]="zwj",N[N.emojiVariantSelector=65039]="emojiVariantSelector",N[N.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={}))}),z(V[22],G([0,1,5]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function R(E){return C(E,0)}t.hash=R;function C(E,n){switch(typeof E){case"object":return E===null?l(349,n):Array.isArray(E)?u(E,n):o(E,n);case"string":return a(E,n);case"boolean":return S(E,n);case"number":return l(E,n);case"undefined":return l(937,n);default:return l(617,n)}}t.doHash=C;function l(E,n){return(n<<5)-n+E|0}t.numberHash=l;function S(E,n){return l(E?433:863,n)}function a(E,n){n=l(149417,n);for(let i=0,r=E.length;i<r;i++)n=l(E.charCodeAt(i),n);return n}t.stringHash=a;function u(E,n){return n=l(104579,n),E.reduce((i,r)=>C(r,i),n)}function o(E,n){return n=l(181387,n),Object.keys(E).sort().reduce((i,r)=>(i=a(r,i),C(E[r],i)),n)}class v{constructor(){this._value=0}get value(){return this._value}hash(n){return this._value=C(n,this._value),this._value}}t.Hasher=v;var w;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function g(E,n,i=32){const r=i-n,s=~((1<<r)-1);return(E<<n|(s&E)>>>r)>>>0}function c(E,n=0,i=E.byteLength,r=0){for(let s=0;s<i;s++)E[n+s]=r}function _(E,n,i="0"){for(;E.length<n;)E=i+E;return E}function b(E,n=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(i=>i.toString(16).padStart(2,"0")).join(""):_((E>>>0).toString(16),n/4)}t.toHexString=b;class A{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(n){const i=n.length;if(i===0)return;const r=this._buff;let s=this._buffLen,f=this._leftoverHighSurrogate,L,h;for(f!==0?(L=f,h=-1,f=0):(L=n.charCodeAt(0),h=0);;){let d=L;if(P.isHighSurrogate(L))if(h+1<i){const m=n.charCodeAt(h+1);P.isLowSurrogate(m)?(h++,d=P.computeCodePoint(L,m)):d=65533}else{f=L;break}else P.isLowSurrogate(L)&&(d=65533);if(s=this._push(r,s,d),h++,h<i)L=n.charCodeAt(h);else break}this._buffLen=s,this._leftoverHighSurrogate=f}_push(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const n=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(n/4294967296),!1),this._buffDV.setUint32(60,n%4294967296,!1),this._step()}_step(){const n=A._bigBlock32,i=this._buffDV;for(let D=0;D<64;D+=4)n.setUint32(D,i.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)n.setUint32(D,g(n.getUint32(D-12,!1)^n.getUint32(D-32,!1)^n.getUint32(D-56,!1)^n.getUint32(D-64,!1),1),!1);let r=this._h0,s=this._h1,f=this._h2,L=this._h3,h=this._h4,d,m,p;for(let D=0;D<80;D++)D<20?(d=s&f|~s&L,m=1518500249):D<40?(d=s^f^L,m=1859775393):D<60?(d=s&f|s&L|f&L,m=2400959708):(d=s^f^L,m=3395469782),p=g(r,5)+d+h+m+n.getUint32(D*4,!1)&4294967295,h=L,L=f,f=g(s,30),s=r,r=p;this._h0=this._h0+r&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+f&4294967295,this._h3=this._h3+L&4294967295,this._h4=this._h4+h&4294967295}}t.StringSHA1=A,A._bigBlock32=new DataView(new ArrayBuffer(320))}),z(V[11],G([0,1,15,22]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class C{constructor(g){this.source=g}getElements(){const g=this.source,c=new Int32Array(g.length);for(let _=0,b=g.length;_<b;_++)c[_]=g.charCodeAt(_);return c}}t.StringDiffSequence=C;function l(w,g,c){return new v(new C(w),new C(g)).ComputeDiff(c).changes}t.stringDiff=l;class S{static Assert(g,c){if(!g)throw new Error(c)}}t.Debug=S;class a{static Copy(g,c,_,b,A){for(let E=0;E<A;E++)_[b+E]=g[c+E]}static Copy2(g,c,_,b,A){for(let E=0;E<A;E++)_[b+E]=g[c+E]}}t.MyArray=a;var u;(function(w){w[w.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class o{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new P.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(g,c){this.m_originalStart=Math.min(this.m_originalStart,g),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_originalCount++}AddModifiedElement(g,c){this.m_originalStart=Math.min(this.m_originalStart,g),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class v{constructor(g,c,_=null){this.ContinueProcessingPredicate=_,this._originalSequence=g,this._modifiedSequence=c;const[b,A,E]=v._getElements(g),[n,i,r]=v._getElements(c);this._hasStrings=E&&r,this._originalStringElements=b,this._originalElementsOrHash=A,this._modifiedStringElements=n,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(g){return g.length>0&&typeof g[0]=="string"}static _getElements(g){const c=g.getElements();if(v._isStringArray(c)){const _=new Int32Array(c.length);for(let b=0,A=c.length;b<A;b++)_[b]=(0,R.stringHash)(c[b],0);return[c,_,!0]}return c instanceof Int32Array?[[],c,!1]:[[],new Int32Array(c),!1]}ElementsAreEqual(g,c){return this._originalElementsOrHash[g]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[g]===this._modifiedStringElements[c]:!0}ElementsAreStrictEqual(g,c){if(!this.ElementsAreEqual(g,c))return!1;const _=v._getStrictElement(this._originalSequence,g),b=v._getStrictElement(this._modifiedSequence,c);return _===b}static _getStrictElement(g,c){return typeof g.getStrictElement=="function"?g.getStrictElement(c):null}OriginalElementsAreEqual(g,c){return this._originalElementsOrHash[g]!==this._originalElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[g]===this._originalStringElements[c]:!0}ModifiedElementsAreEqual(g,c){return this._modifiedElementsOrHash[g]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._modifiedStringElements[g]===this._modifiedStringElements[c]:!0}ComputeDiff(g){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,g)}_ComputeDiff(g,c,_,b,A){const E=[!1];let n=this.ComputeDiffRecursive(g,c,_,b,E);return A&&(n=this.PrettifyChanges(n)),{quitEarly:E[0],changes:n}}ComputeDiffRecursive(g,c,_,b,A){for(A[0]=!1;g<=c&&_<=b&&this.ElementsAreEqual(g,_);)g++,_++;for(;c>=g&&b>=_&&this.ElementsAreEqual(c,b);)c--,b--;if(g>c||_>b){let f;return _<=b?(S.Assert(g===c+1,"originalStart should only be one more than originalEnd"),f=[new P.DiffChange(g,0,_,b-_+1)]):g<=c?(S.Assert(_===b+1,"modifiedStart should only be one more than modifiedEnd"),f=[new P.DiffChange(g,c-g+1,_,0)]):(S.Assert(g===c+1,"originalStart should only be one more than originalEnd"),S.Assert(_===b+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const E=[0],n=[0],i=this.ComputeRecursionPoint(g,c,_,b,E,n,A),r=E[0],s=n[0];if(i!==null)return i;if(!A[0]){const f=this.ComputeDiffRecursive(g,r,_,s,A);let L=[];return A[0]?L=[new P.DiffChange(r+1,c-(r+1)+1,s+1,b-(s+1)+1)]:L=this.ComputeDiffRecursive(r+1,c,s+1,b,A),this.ConcatenateChanges(f,L)}return[new P.DiffChange(g,c-g+1,_,b-_+1)]}WALKTRACE(g,c,_,b,A,E,n,i,r,s,f,L,h,d,m,p,D,M){let U=null,k=null,W=new o,H=c,X=_,$=h[0]-p[0]-b,x=-1073741824,e=this.m_forwardHistory.length-1;do{const q=$+g;q===H||q<X&&r[q-1]<r[q+1]?(f=r[q+1],d=f-$-b,f<x&&W.MarkNextChange(),x=f,W.AddModifiedElement(f+1,d),$=q+1-g):(f=r[q-1]+1,d=f-$-b,f<x&&W.MarkNextChange(),x=f-1,W.AddOriginalElement(f,d+1),$=q-1-g),e>=0&&(r=this.m_forwardHistory[e],g=r[0],H=1,X=r.length-1)}while(--e>=-1);if(U=W.getReverseChanges(),M[0]){let q=h[0]+1,y=p[0]+1;if(U!==null&&U.length>0){const Y=U[U.length-1];q=Math.max(q,Y.getOriginalEnd()),y=Math.max(y,Y.getModifiedEnd())}k=[new P.DiffChange(q,L-q+1,y,m-y+1)]}else{W=new o,H=E,X=n,$=h[0]-p[0]-i,x=1073741824,e=D?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const q=$+A;q===H||q<X&&s[q-1]>=s[q+1]?(f=s[q+1]-1,d=f-$-i,f>x&&W.MarkNextChange(),x=f+1,W.AddOriginalElement(f+1,d+1),$=q+1-A):(f=s[q-1],d=f-$-i,f>x&&W.MarkNextChange(),x=f,W.AddModifiedElement(f+1,d+1),$=q-1-A),e>=0&&(s=this.m_reverseHistory[e],A=s[0],H=1,X=s.length-1)}while(--e>=-1);k=W.getChanges()}return this.ConcatenateChanges(U,k)}ComputeRecursionPoint(g,c,_,b,A,E,n){let i=0,r=0,s=0,f=0,L=0,h=0;g--,_--,A[0]=0,E[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=c-g+(b-_),m=d+1,p=new Int32Array(m),D=new Int32Array(m),M=b-_,U=c-g,k=g-_,W=c-b,X=(U-M)%2==0;p[M]=g,D[U]=c,n[0]=!1;for(let $=1;$<=d/2+1;$++){let x=0,e=0;s=this.ClipDiagonalBound(M-$,$,M,m),f=this.ClipDiagonalBound(M+$,$,M,m);for(let y=s;y<=f;y+=2){y===s||y<f&&p[y-1]<p[y+1]?i=p[y+1]:i=p[y-1]+1,r=i-(y-M)-k;const Y=i;for(;i<c&&r<b&&this.ElementsAreEqual(i+1,r+1);)i++,r++;if(p[y]=i,i+r>x+e&&(x=i,e=r),!X&&Math.abs(y-U)<=$-1&&i>=D[y])return A[0]=i,E[0]=r,Y<=D[y]&&1447>0&&$<=1447+1?this.WALKTRACE(M,s,f,k,U,L,h,W,p,D,i,c,A,r,b,E,X,n):null}const q=(x-g+(e-_)-$)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(x,q))return n[0]=!0,A[0]=x,E[0]=e,q>0&&1447>0&&$<=1447+1?this.WALKTRACE(M,s,f,k,U,L,h,W,p,D,i,c,A,r,b,E,X,n):(g++,_++,[new P.DiffChange(g,c-g+1,_,b-_+1)]);L=this.ClipDiagonalBound(U-$,$,U,m),h=this.ClipDiagonalBound(U+$,$,U,m);for(let y=L;y<=h;y+=2){y===L||y<h&&D[y-1]>=D[y+1]?i=D[y+1]-1:i=D[y-1],r=i-(y-U)-W;const Y=i;for(;i>g&&r>_&&this.ElementsAreEqual(i,r);)i--,r--;if(D[y]=i,X&&Math.abs(y-M)<=$&&i<=p[y])return A[0]=i,E[0]=r,Y>=p[y]&&1447>0&&$<=1447+1?this.WALKTRACE(M,s,f,k,U,L,h,W,p,D,i,c,A,r,b,E,X,n):null}if($<=1447){let y=new Int32Array(f-s+2);y[0]=M-s+1,a.Copy2(p,s,y,1,f-s+1),this.m_forwardHistory.push(y),y=new Int32Array(h-L+2),y[0]=U-L+1,a.Copy2(D,L,y,1,h-L+1),this.m_reverseHistory.push(y)}}return this.WALKTRACE(M,s,f,k,U,L,h,W,p,D,i,c,A,r,b,E,X,n)}PrettifyChanges(g){for(let c=0;c<g.length;c++){const _=g[c],b=c<g.length-1?g[c+1].originalStart:this._originalElementsOrHash.length,A=c<g.length-1?g[c+1].modifiedStart:this._modifiedElementsOrHash.length,E=_.originalLength>0,n=_.modifiedLength>0;for(;_.originalStart+_.originalLength<b&&_.modifiedStart+_.modifiedLength<A&&(!E||this.OriginalElementsAreEqual(_.originalStart,_.originalStart+_.originalLength))&&(!n||this.ModifiedElementsAreEqual(_.modifiedStart,_.modifiedStart+_.modifiedLength));){const r=this.ElementsAreStrictEqual(_.originalStart,_.modifiedStart);if(this.ElementsAreStrictEqual(_.originalStart+_.originalLength,_.modifiedStart+_.modifiedLength)&&!r)break;_.originalStart++,_.modifiedStart++}let i=[null];if(c<g.length-1&&this.ChangesOverlap(g[c],g[c+1],i)){g[c]=i[0],g.splice(c+1,1),c--;continue}}for(let c=g.length-1;c>=0;c--){const _=g[c];let b=0,A=0;if(c>0){const f=g[c-1];b=f.originalStart+f.originalLength,A=f.modifiedStart+f.modifiedLength}const E=_.originalLength>0,n=_.modifiedLength>0;let i=0,r=this._boundaryScore(_.originalStart,_.originalLength,_.modifiedStart,_.modifiedLength);for(let f=1;;f++){const L=_.originalStart-f,h=_.modifiedStart-f;if(L<b||h<A||E&&!this.OriginalElementsAreEqual(L,L+_.originalLength)||n&&!this.ModifiedElementsAreEqual(h,h+_.modifiedLength))break;const m=(L===b&&h===A?5:0)+this._boundaryScore(L,_.originalLength,h,_.modifiedLength);m>r&&(r=m,i=f)}_.originalStart-=i,_.modifiedStart-=i;const s=[null];if(c>0&&this.ChangesOverlap(g[c-1],g[c],s)){g[c-1]=s[0],g.splice(c,1),c++;continue}}if(this._hasStrings)for(let c=1,_=g.length;c<_;c++){const b=g[c-1],A=g[c],E=A.originalStart-b.originalStart-b.originalLength,n=b.originalStart,i=A.originalStart+A.originalLength,r=i-n,s=b.modifiedStart,f=A.modifiedStart+A.modifiedLength,L=f-s;if(E<5&&r<20&&L<20){const h=this._findBetterContiguousSequence(n,r,s,L,E);if(h){const[d,m]=h;(d!==b.originalStart+b.originalLength||m!==b.modifiedStart+b.modifiedLength)&&(b.originalLength=d-b.originalStart,b.modifiedLength=m-b.modifiedStart,A.originalStart=d+E,A.modifiedStart=m+E,A.originalLength=i-A.originalStart,A.modifiedLength=f-A.modifiedStart)}}}return g}_findBetterContiguousSequence(g,c,_,b,A){if(c<A||b<A)return null;const E=g+c-A+1,n=_+b-A+1;let i=0,r=0,s=0;for(let f=g;f<E;f++)for(let L=_;L<n;L++){const h=this._contiguousSequenceScore(f,L,A);h>0&&h>i&&(i=h,r=f,s=L)}return i>0?[r,s]:null}_contiguousSequenceScore(g,c,_){let b=0;for(let A=0;A<_;A++){if(!this.ElementsAreEqual(g+A,c+A))return 0;b+=this._originalStringElements[g+A].length}return b}_OriginalIsBoundary(g){return g<=0||g>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[g])}_OriginalRegionIsBoundary(g,c){if(this._OriginalIsBoundary(g)||this._OriginalIsBoundary(g-1))return!0;if(c>0){const _=g+c;if(this._OriginalIsBoundary(_-1)||this._OriginalIsBoundary(_))return!0}return!1}_ModifiedIsBoundary(g){return g<=0||g>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[g])}_ModifiedRegionIsBoundary(g,c){if(this._ModifiedIsBoundary(g)||this._ModifiedIsBoundary(g-1))return!0;if(c>0){const _=g+c;if(this._ModifiedIsBoundary(_-1)||this._ModifiedIsBoundary(_))return!0}return!1}_boundaryScore(g,c,_,b){const A=this._OriginalRegionIsBoundary(g,c)?1:0,E=this._ModifiedRegionIsBoundary(_,b)?1:0;return A+E}ConcatenateChanges(g,c){let _=[];if(g.length===0||c.length===0)return c.length>0?c:g;if(this.ChangesOverlap(g[g.length-1],c[0],_)){const b=new Array(g.length+c.length-1);return a.Copy(g,0,b,0,g.length-1),b[g.length-1]=_[0],a.Copy(c,1,b,g.length,c.length-1),b}else{const b=new Array(g.length+c.length);return a.Copy(g,0,b,0,g.length),a.Copy(c,0,b,g.length,c.length),b}}ChangesOverlap(g,c,_){if(S.Assert(g.originalStart<=c.originalStart,"Left change is not less than or equal to right change"),S.Assert(g.modifiedStart<=c.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=c.originalStart||g.modifiedStart+g.modifiedLength>=c.modifiedStart){const b=g.originalStart;let A=g.originalLength;const E=g.modifiedStart;let n=g.modifiedLength;return g.originalStart+g.originalLength>=c.originalStart&&(A=c.originalStart+c.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=c.modifiedStart&&(n=c.modifiedStart+c.modifiedLength-g.modifiedStart),_[0]=new P.DiffChange(b,A,E,n),!0}else return _[0]=null,!1}ClipDiagonalBound(g,c,_,b){if(g>=0&&g<b)return g;const A=_,E=b-_-1,n=c%2==0;if(g<0){const i=A%2==0;return n===i?0:1}else{const i=E%2==0;return n===i?b-1:b-2}}}t.LcsDiff=v}),z(V[12],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isPromise=t.assertNever=t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function P(M){return Array.isArray(M)}t.isArray=P;function R(M){return typeof M=="string"}t.isString=R;function C(M){return Array.isArray(M)&&M.every(U=>R(U))}t.isStringArray=C;function l(M){return typeof M=="object"&&M!==null&&!Array.isArray(M)&&!(M instanceof RegExp)&&!(M instanceof Date)}t.isObject=l;function S(M){return typeof M=="number"&&!isNaN(M)}t.isNumber=S;function a(M){return!!M&&typeof M[Symbol.iterator]=="function"}t.isIterable=a;function u(M){return M===!0||M===!1}t.isBoolean=u;function o(M){return typeof M=="undefined"}t.isUndefined=o;function v(M){return!w(M)}t.isDefined=v;function w(M){return o(M)||M===null}t.isUndefinedOrNull=w;function g(M,U){if(!M)throw new Error(U?`Unexpected type, expected '${U}'`:"Unexpected type")}t.assertType=g;function c(M){if(w(M))throw new Error("Assertion Failed: argument is undefined or null");return M}t.assertIsDefined=c;function _(...M){const U=[];for(let k=0;k<M.length;k++){const W=M[k];if(w(W))throw new Error(`Assertion Failed: argument at index ${k} is undefined or null`);U.push(W)}return U}t.assertAllDefined=_;const b=Object.prototype.hasOwnProperty;function A(M){if(!l(M))return!1;for(let U in M)if(b.call(M,U))return!1;return!0}t.isEmptyObject=A;function E(M){return typeof M=="function"}t.isFunction=E;function n(...M){return M.length>0&&M.every(E)}t.areFunctions=n;function i(M,U){const k=Math.min(M.length,U.length);for(let W=0;W<k;W++)r(M[W],U[W])}t.validateConstraints=i;function r(M,U){if(R(U)){if(typeof M!==U)throw new Error(`argument does not match constraint: typeof ${U}`)}else if(E(U)){try{if(M instanceof U)return}catch{}if(!w(M)&&M.constructor===U||U.length===1&&U.call(void 0,M)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=r;function s(M){let U=[],k=Object.getPrototypeOf(M);for(;Object.prototype!==k;)U=U.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return U}t.getAllPropertyNames=s;function f(M){const U=[];for(const k of s(M))typeof M[k]=="function"&&U.push(k);return U}t.getAllMethodNames=f;function L(M,U){const k=H=>function(){const X=Array.prototype.slice.call(arguments,0);return U(H,X)};let W={};for(const H of M)W[H]=k(H);return W}t.createProxyObject=L;function h(M){return M===null?void 0:M}t.withNullAsUndefined=h;function d(M){return typeof M=="undefined"?null:M}t.withUndefinedAsNull=d;function m(M){return class{constructor(){return new Proxy({},{get(U,k){if(U[k])return U[k];throw new Error(`Not Implemented: ${M}->${String(k)}`)}})}}}t.NotImplementedProxy=m;function p(M,U="Unreachable"){throw new Error(U)}t.assertNever=p;function D(M){return!!M&&typeof M.then=="function"&&typeof M.catch=="function"}t.isPromise=D}),z(V[13],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var P;(function(l){l[l.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",l[l.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",l[l.MAX_UINT_8=255]="MAX_UINT_8",l[l.MAX_UINT_16=65535]="MAX_UINT_16",l[l.MAX_UINT_32=4294967295]="MAX_UINT_32",l[l.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P=t.Constants||(t.Constants={}));function R(l){return l<0?0:l>255?255:l|0}t.toUint8=R;function C(l){return l<0?0:l>4294967295?4294967295:l|0}t.toUint32=C}),z(V[14],G([0,1,20,2]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const C=/^\w[\w\d+.-]*$/,l=/^\//,S=/^\/\//;function a(h,d){if(!h.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!C.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!l.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(h,d){return!h&&!d?"file":h}function o(h,d){switch(h){case"https":case"http":case"file":d?d[0]!==w&&(d=w+d):d=w;break}return d}const v="",w="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{constructor(d,m,p,D,M,U=!1){typeof d=="object"?(this.scheme=d.scheme||v,this.authority=d.authority||v,this.path=d.path||v,this.query=d.query||v,this.fragment=d.fragment||v):(this.scheme=u(d,U),this.authority=m||v,this.path=o(this.scheme,p||v),this.query=D||v,this.fragment=M||v,a(this,U))}static isUri(d){return d instanceof c?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}get fsPath(){return i(this,!1)}with(d){if(!d)return this;let{scheme:m,authority:p,path:D,query:M,fragment:U}=d;return m===void 0?m=this.scheme:m===null&&(m=v),p===void 0?p=this.authority:p===null&&(p=v),D===void 0?D=this.path:D===null&&(D=v),M===void 0?M=this.query:M===null&&(M=v),U===void 0?U=this.fragment:U===null&&(U=v),m===this.scheme&&p===this.authority&&D===this.path&&M===this.query&&U===this.fragment?this:new b(m,p,D,M,U)}static parse(d,m=!1){const p=g.exec(d);return p?new b(p[2]||v,L(p[4]||v),L(p[5]||v),L(p[7]||v),L(p[9]||v),m):new b(v,v,v,v,v)}static file(d){let m=v;if(R.isWindows&&(d=d.replace(/\\/g,w)),d[0]===w&&d[1]===w){const p=d.indexOf(w,2);p===-1?(m=d.substring(2),d=w):(m=d.substring(2,p),d=d.substring(p)||w)}return new b("file",m,d,v,v)}static from(d){const m=new b(d.scheme,d.authority,d.path,d.query,d.fragment);return a(m,!0),m}static joinPath(d,...m){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return R.isWindows&&d.scheme==="file"?p=c.file(P.win32.join(i(d,!0),...m)).path:p=P.posix.join(d.path,...m),d.with({path:p})}toString(d=!1){return r(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof c)return d;{const m=new b(d);return m._formatted=d.external,m._fsPath=d._sep===_?d.fsPath:null,m}}else return d}}t.URI=c;const _=R.isWindows?1:void 0;class b extends c{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(d=!1){return d?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=_),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const A={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(h,d){let m,p=-1;for(let D=0;D<h.length;D++){const M=h.charCodeAt(D);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||d&&M===47)p!==-1&&(m+=encodeURIComponent(h.substring(p,D)),p=-1),m!==void 0&&(m+=h.charAt(D));else{m===void 0&&(m=h.substr(0,D));const U=A[M];U!==void 0?(p!==-1&&(m+=encodeURIComponent(h.substring(p,D)),p=-1),m+=U):p===-1&&(p=D)}}return p!==-1&&(m+=encodeURIComponent(h.substring(p))),m!==void 0?m:h}function n(h){let d;for(let m=0;m<h.length;m++){const p=h.charCodeAt(m);p===35||p===63?(d===void 0&&(d=h.substr(0,m)),d+=A[p]):d!==void 0&&(d+=h[m])}return d!==void 0?d:h}function i(h,d){let m;return h.authority&&h.path.length>1&&h.scheme==="file"?m=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?d?m=h.path.substr(1):m=h.path[1].toLowerCase()+h.path.substr(2):m=h.path,R.isWindows&&(m=m.replace(/\//g,"\\")),m}t.uriToFsPath=i;function r(h,d){const m=d?n:E;let p="",{scheme:D,authority:M,path:U,query:k,fragment:W}=h;if(D&&(p+=D,p+=":"),(M||D==="file")&&(p+=w,p+=w),M){let H=M.indexOf("@");if(H!==-1){const X=M.substr(0,H);M=M.substr(H+1),H=X.indexOf(":"),H===-1?p+=m(X,!1):(p+=m(X.substr(0,H),!1),p+=":",p+=m(X.substr(H+1),!1)),p+="@"}M=M.toLowerCase(),H=M.indexOf(":"),H===-1?p+=m(M,!1):(p+=m(M.substr(0,H),!1),p+=M.substr(H))}if(U){if(U.length>=3&&U.charCodeAt(0)===47&&U.charCodeAt(2)===58){const H=U.charCodeAt(1);H>=65&&H<=90&&(U=`/${String.fromCharCode(H+32)}:${U.substr(3)}`)}else if(U.length>=2&&U.charCodeAt(1)===58){const H=U.charCodeAt(0);H>=65&&H<=90&&(U=`${String.fromCharCode(H+32)}:${U.substr(2)}`)}p+=m(U,!0)}return k&&(p+="?",p+=m(k,!1)),W&&(p+="#",p+=d?W:E(W,!1)),p}function s(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+s(h.substr(3)):h}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(h){return h.match(f)?h.replace(f,d=>s(d)):h}}),z(V[34],G([0,1,4,8,2,12]),function(F,t,P,R,C,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const S="$initialize";let a=!1;function u(c){!C.isWeb||(a||(a=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(c.message))}t.logOnceWebWorkerWarning=u;class o{constructor(_){this._workerId=-1,this._handler=_,this._lastSentReq=0,this._pendingReplies=Object.create(null)}setWorkerId(_){this._workerId=_}sendMessage(_,b){let A=String(++this._lastSentReq);return new Promise((E,n)=>{this._pendingReplies[A]={resolve:E,reject:n},this._send({vsWorker:this._workerId,req:A,method:_,args:b})})}handleMessage(_){!_||!_.vsWorker||this._workerId!==-1&&_.vsWorker!==this._workerId||this._handleMessage(_)}_handleMessage(_){if(_.seq){let n=_;if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let i=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let r=n.err;n.err.$isError&&(r=new Error,r.name=n.err.name,r.message=n.err.message,r.stack=n.err.stack),i.reject(r);return}i.resolve(n.res);return}let b=_,A=b.req;this._handler.handleMessage(b.method,b.args).then(n=>{this._send({vsWorker:this._workerId,seq:A,res:n,err:void 0})},n=>{n.detail instanceof Error&&(n.detail=(0,P.transformErrorForSerialization)(n.detail)),this._send({vsWorker:this._workerId,seq:A,res:void 0,err:(0,P.transformErrorForSerialization)(n)})})}_send(_){let b=[];if(_.req){const A=_;for(let E=0;E<A.args.length;E++)A.args[E]instanceof ArrayBuffer&&b.push(A.args[E])}else{const A=_;A.res instanceof ArrayBuffer&&b.push(A.res)}this._handler.sendMessage(_,b)}}class v extends R.Disposable{constructor(_,b,A){super();let E=null;this._worker=this._register(_.create("vs/base/common/worker/simpleWorker",s=>{this._protocol.handleMessage(s)},s=>{E&&E(s)})),this._protocol=new o({sendMessage:(s,f)=>{this._worker.postMessage(s,f)},handleMessage:(s,f)=>{if(typeof A[s]!="function")return Promise.reject(new Error("Missing method "+s+" on main thread host."));try{return Promise.resolve(A[s].apply(A,f))}catch(L){return Promise.reject(L)}}}),this._protocol.setWorkerId(this._worker.getId());let n=null;typeof self.require!="undefined"&&typeof self.require.getConfig=="function"?n=self.require.getConfig():typeof self.requirejs!="undefined"&&(n=self.requirejs.s.contexts._.config);const i=l.getAllMethodNames(A);this._onModuleLoaded=this._protocol.sendMessage(S,[this._worker.getId(),JSON.parse(JSON.stringify(n)),b,i]);const r=(s,f)=>this._request(s,f);this._lazyProxy=new Promise((s,f)=>{E=f,this._onModuleLoaded.then(L=>{s(l.createProxyObject(L,r))},L=>{f(L),this._onError("Worker failed to load "+b,L)})})}getProxyObject(){return this._lazyProxy}_request(_,b){return new Promise((A,E)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(_,b).then(A,E)},E)})}_onError(_,b){console.error(_),console.info(b)}}t.SimpleWorkerClient=v;class w{constructor(_,b){this._requestHandlerFactory=b,this._requestHandler=null,this._protocol=new o({sendMessage:(A,E)=>{_(A,E)},handleMessage:(A,E)=>this._handleMessage(A,E)})}onmessage(_){this._protocol.handleMessage(_)}_handleMessage(_,b){if(_===S)return this.initialize(b[0],b[1],b[2],b[3]);if(!this._requestHandler||typeof this._requestHandler[_]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+_));try{return Promise.resolve(this._requestHandler[_].apply(this._requestHandler,b))}catch(A){return Promise.reject(A)}}initialize(_,b,A,E){this._protocol.setWorkerId(_);const n=(r,s)=>this._protocol.sendMessage(r,s),i=l.createProxyObject(E,n);return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(i),Promise.resolve(l.getAllMethodNames(this._requestHandler))):(b&&(typeof b.baseUrl!="undefined"&&delete b.baseUrl,typeof b.paths!="undefined"&&typeof b.paths.vs!="undefined"&&delete b.paths.vs,typeof b.trustedTypesPolicy!==void 0&&delete b.trustedTypesPolicy,b.catchError=!0,self.require.config(b)),new Promise((r,s)=>{self.require([A],f=>{if(this._requestHandler=f.create(i),!this._requestHandler){s(new Error("No RequestHandler!"));return}r(l.getAllMethodNames(this._requestHandler))},s)}))}}t.SimpleWorkerServer=w;function g(c){return new w(c,null)}t.create=g}),z(V[23],G([0,1,13]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class R{constructor(a){let u=(0,P.toUint8)(a);this._defaultValue=u,this._asciiMap=R._createAsciiMap(u),this._map=new Map}static _createAsciiMap(a){let u=new Uint8Array(256);for(let o=0;o<256;o++)u[o]=a;return u}set(a,u){let o=(0,P.toUint8)(u);a>=0&&a<256?this._asciiMap[a]=o:this._map.set(a,o)}get(a){return a>=0&&a<256?this._asciiMap[a]:this._map.get(a)||this._defaultValue}}t.CharacterClassifier=R;var C;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(C||(C={}));class l{constructor(){this._actual=new R(0)}add(a){this._actual.set(a,1)}has(a){return this._actual.get(a)===1}}t.CharacterSet=l}),z(V[3],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class P{constructor(C,l){this.lineNumber=C,this.column=l}with(C=this.lineNumber,l=this.column){return C===this.lineNumber&&l===this.column?this:new P(C,l)}delta(C=0,l=0){return this.with(this.lineNumber+C,this.column+l)}equals(C){return P.equals(this,C)}static equals(C,l){return!C&&!l?!0:!!C&&!!l&&C.lineNumber===l.lineNumber&&C.column===l.column}isBefore(C){return P.isBefore(this,C)}static isBefore(C,l){return C.lineNumber<l.lineNumber?!0:l.lineNumber<C.lineNumber?!1:C.column<l.column}isBeforeOrEqual(C){return P.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,l){return C.lineNumber<l.lineNumber?!0:l.lineNumber<C.lineNumber?!1:C.column<=l.column}static compare(C,l){let S=C.lineNumber|0,a=l.lineNumber|0;if(S===a){let u=C.column|0,o=l.column|0;return u-o}return S-a}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new P(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}t.Position=P}),z(V[6],G([0,1,3]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class R{constructor(l,S,a,u){l>a||l===a&&S>u?(this.startLineNumber=a,this.startColumn=u,this.endLineNumber=l,this.endColumn=S):(this.startLineNumber=l,this.startColumn=S,this.endLineNumber=a,this.endColumn=u)}isEmpty(){return R.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return R.containsPosition(this,l)}static containsPosition(l,S){return!(S.lineNumber<l.startLineNumber||S.lineNumber>l.endLineNumber||S.lineNumber===l.startLineNumber&&S.column<l.startColumn||S.lineNumber===l.endLineNumber&&S.column>l.endColumn)}containsRange(l){return R.containsRange(this,l)}static containsRange(l,S){return!(S.startLineNumber<l.startLineNumber||S.endLineNumber<l.startLineNumber||S.startLineNumber>l.endLineNumber||S.endLineNumber>l.endLineNumber||S.startLineNumber===l.startLineNumber&&S.startColumn<l.startColumn||S.endLineNumber===l.endLineNumber&&S.endColumn>l.endColumn)}strictContainsRange(l){return R.strictContainsRange(this,l)}static strictContainsRange(l,S){return!(S.startLineNumber<l.startLineNumber||S.endLineNumber<l.startLineNumber||S.startLineNumber>l.endLineNumber||S.endLineNumber>l.endLineNumber||S.startLineNumber===l.startLineNumber&&S.startColumn<=l.startColumn||S.endLineNumber===l.endLineNumber&&S.endColumn>=l.endColumn)}plusRange(l){return R.plusRange(this,l)}static plusRange(l,S){let a,u,o,v;return S.startLineNumber<l.startLineNumber?(a=S.startLineNumber,u=S.startColumn):S.startLineNumber===l.startLineNumber?(a=S.startLineNumber,u=Math.min(S.startColumn,l.startColumn)):(a=l.startLineNumber,u=l.startColumn),S.endLineNumber>l.endLineNumber?(o=S.endLineNumber,v=S.endColumn):S.endLineNumber===l.endLineNumber?(o=S.endLineNumber,v=Math.max(S.endColumn,l.endColumn)):(o=l.endLineNumber,v=l.endColumn),new R(a,u,o,v)}intersectRanges(l){return R.intersectRanges(this,l)}static intersectRanges(l,S){let a=l.startLineNumber,u=l.startColumn,o=l.endLineNumber,v=l.endColumn,w=S.startLineNumber,g=S.startColumn,c=S.endLineNumber,_=S.endColumn;return a<w?(a=w,u=g):a===w&&(u=Math.max(u,g)),o>c?(o=c,v=_):o===c&&(v=Math.min(v,_)),a>o||a===o&&u>v?null:new R(a,u,o,v)}equalsRange(l){return R.equalsRange(this,l)}static equalsRange(l,S){return!!l&&!!S&&l.startLineNumber===S.startLineNumber&&l.startColumn===S.startColumn&&l.endLineNumber===S.endLineNumber&&l.endColumn===S.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(l){return new P.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(l){return new P.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,S){return new R(this.startLineNumber,this.startColumn,l,S)}setStartPosition(l,S){return new R(l,S,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(l){return new R(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}static fromPositions(l,S=l){return new R(l.lineNumber,l.column,S.lineNumber,S.column)}static lift(l){return l?new R(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,S){return!(l.endLineNumber<S.startLineNumber||l.endLineNumber===S.startLineNumber&&l.endColumn<S.startColumn||S.endLineNumber<l.startLineNumber||S.endLineNumber===l.startLineNumber&&S.endColumn<l.startColumn)}static areIntersecting(l,S){return!(l.endLineNumber<S.startLineNumber||l.endLineNumber===S.startLineNumber&&l.endColumn<=S.startColumn||S.endLineNumber<l.startLineNumber||S.endLineNumber===l.startLineNumber&&S.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,S){if(l&&S){const o=l.startLineNumber|0,v=S.startLineNumber|0;if(o===v){const w=l.startColumn|0,g=S.startColumn|0;if(w===g){const c=l.endLineNumber|0,_=S.endLineNumber|0;if(c===_){const b=l.endColumn|0,A=S.endColumn|0;return b-A}return c-_}return w-g}return o-v}return(l?1:0)-(S?1:0)}static compareRangesUsingEnds(l,S){return l.endLineNumber===S.endLineNumber?l.endColumn===S.endColumn?l.startLineNumber===S.startLineNumber?l.startColumn-S.startColumn:l.startLineNumber-S.startLineNumber:l.endColumn-S.endColumn:l.endLineNumber-S.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}}t.Range=R}),z(V[24],G([0,1,3,6]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var C;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(C=t.SelectionDirection||(t.SelectionDirection={}));class l extends R.Range{constructor(a,u,o,v){super(a,u,o,v);this.selectionStartLineNumber=a,this.selectionStartColumn=u,this.positionLineNumber=o,this.positionColumn=v}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(a){return l.selectionsEqual(this,a)}static selectionsEqual(a,u){return a.selectionStartLineNumber===u.selectionStartLineNumber&&a.selectionStartColumn===u.selectionStartColumn&&a.positionLineNumber===u.positionLineNumber&&a.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(a,u){return this.getDirection()===0?new l(this.startLineNumber,this.startColumn,a,u):new l(a,u,this.startLineNumber,this.startColumn)}getPosition(){return new P.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(a,u){return this.getDirection()===0?new l(a,u,this.endLineNumber,this.endColumn):new l(this.endLineNumber,this.endColumn,a,u)}static fromPositions(a,u=a){return new l(a.lineNumber,a.column,u.lineNumber,u.column)}static liftSelection(a){return new l(a.selectionStartLineNumber,a.selectionStartColumn,a.positionLineNumber,a.positionColumn)}static selectionsArrEqual(a,u){if(a&&!u||!a&&u)return!1;if(!a&&!u)return!0;if(a.length!==u.length)return!1;for(let o=0,v=a.length;o<v;o++)if(!this.selectionsEqual(a[o],u[o]))return!1;return!0}static isISelection(a){return a&&typeof a.selectionStartLineNumber=="number"&&typeof a.selectionStartColumn=="number"&&typeof a.positionLineNumber=="number"&&typeof a.positionColumn=="number"}static createWithDirection(a,u,o,v,w){return w===0?new l(a,u,o,v):new l(o,v,a,u)}}t.Selection=l}),z(V[25],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;class P{constructor(S,a,u){this._tokenBrand=void 0,this.offset=S|0,this.type=a,this.language=u}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=P;class R{constructor(S,a){this._tokenizationResultBrand=void 0,this.tokens=S,this.endState=a}}t.TokenizationResult=R;class C{constructor(S,a){this._tokenizationResult2Brand=void 0,this.tokens=S,this.endState=a}}t.TokenizationResult2=C}),z(V[26],G([0,1,11,5]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const C=3;function l(b,A,E,n){return new P.LcsDiff(b,A,E).ComputeDiff(n)}class S{constructor(A){const E=[],n=[];for(let i=0,r=A.length;i<r;i++)E[i]=g(A[i],1),n[i]=c(A[i],1);this.lines=A,this._startColumns=E,this._endColumns=n}getElements(){const A=[];for(let E=0,n=this.lines.length;E<n;E++)A[E]=this.lines[E].substring(this._startColumns[E]-1,this._endColumns[E]-1);return A}getStrictElement(A){return this.lines[A]}getStartLineNumber(A){return A+1}getEndLineNumber(A){return A+1}createCharSequence(A,E,n){const i=[],r=[],s=[];let f=0;for(let L=E;L<=n;L++){const h=this.lines[L],d=A?this._startColumns[L]:1,m=A?this._endColumns[L]:h.length+1;for(let p=d;p<m;p++)i[f]=h.charCodeAt(p-1),r[f]=L+1,s[f]=p,f++}return new a(i,r,s)}}class a{constructor(A,E,n){this._charCodes=A,this._lineNumbers=E,this._columns=n}getElements(){return this._charCodes}getStartLineNumber(A){return this._lineNumbers[A]}getStartColumn(A){return this._columns[A]}getEndLineNumber(A){return this._lineNumbers[A]}getEndColumn(A){return this._columns[A]+1}}class u{constructor(A,E,n,i,r,s,f,L){this.originalStartLineNumber=A,this.originalStartColumn=E,this.originalEndLineNumber=n,this.originalEndColumn=i,this.modifiedStartLineNumber=r,this.modifiedStartColumn=s,this.modifiedEndLineNumber=f,this.modifiedEndColumn=L}static createFromDiffChange(A,E,n){let i,r,s,f,L,h,d,m;return A.originalLength===0?(i=0,r=0,s=0,f=0):(i=E.getStartLineNumber(A.originalStart),r=E.getStartColumn(A.originalStart),s=E.getEndLineNumber(A.originalStart+A.originalLength-1),f=E.getEndColumn(A.originalStart+A.originalLength-1)),A.modifiedLength===0?(L=0,h=0,d=0,m=0):(L=n.getStartLineNumber(A.modifiedStart),h=n.getStartColumn(A.modifiedStart),d=n.getEndLineNumber(A.modifiedStart+A.modifiedLength-1),m=n.getEndColumn(A.modifiedStart+A.modifiedLength-1)),new u(i,r,s,f,L,h,d,m)}}function o(b){if(b.length<=1)return b;const A=[b[0]];let E=A[0];for(let n=1,i=b.length;n<i;n++){const r=b[n],s=r.originalStart-(E.originalStart+E.originalLength),f=r.modifiedStart-(E.modifiedStart+E.modifiedLength);Math.min(s,f)<C?(E.originalLength=r.originalStart+r.originalLength-E.originalStart,E.modifiedLength=r.modifiedStart+r.modifiedLength-E.modifiedStart):(A.push(r),E=r)}return A}class v{constructor(A,E,n,i,r){this.originalStartLineNumber=A,this.originalEndLineNumber=E,this.modifiedStartLineNumber=n,this.modifiedEndLineNumber=i,this.charChanges=r}static createFromDiffResult(A,E,n,i,r,s,f){let L,h,d,m,p;if(E.originalLength===0?(L=n.getStartLineNumber(E.originalStart)-1,h=0):(L=n.getStartLineNumber(E.originalStart),h=n.getEndLineNumber(E.originalStart+E.originalLength-1)),E.modifiedLength===0?(d=i.getStartLineNumber(E.modifiedStart)-1,m=0):(d=i.getStartLineNumber(E.modifiedStart),m=i.getEndLineNumber(E.modifiedStart+E.modifiedLength-1)),s&&E.originalLength>0&&E.originalLength<20&&E.modifiedLength>0&&E.modifiedLength<20&&r()){const D=n.createCharSequence(A,E.originalStart,E.originalStart+E.originalLength-1),M=i.createCharSequence(A,E.modifiedStart,E.modifiedStart+E.modifiedLength-1);let U=l(D,M,r,!0).changes;f&&(U=o(U)),p=[];for(let k=0,W=U.length;k<W;k++)p.push(u.createFromDiffChange(U[k],D,M))}return new v(L,h,d,m,p)}}class w{constructor(A,E,n){this.shouldComputeCharChanges=n.shouldComputeCharChanges,this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=n.shouldMakePrettyDiff,this.originalLines=A,this.modifiedLines=E,this.original=new S(A),this.modified=new S(E),this.continueLineDiff=_(n.maxComputationTime),this.continueCharDiff=_(n.maxComputationTime===0?0:Math.min(n.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const A=l(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),E=A.changes,n=A.quitEarly;if(this.shouldIgnoreTrimWhitespace){const f=[];for(let L=0,h=E.length;L<h;L++)f.push(v.createFromDiffResult(this.shouldIgnoreTrimWhitespace,E[L],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:n,changes:f}}const i=[];let r=0,s=0;for(let f=-1,L=E.length;f<L;f++){const h=f+1<L?E[f+1]:null,d=h?h.originalStart:this.originalLines.length,m=h?h.modifiedStart:this.modifiedLines.length;for(;r<d&&s<m;){const p=this.originalLines[r],D=this.modifiedLines[s];if(p!==D){{let M=g(p,1),U=g(D,1);for(;M>1&&U>1;){const k=p.charCodeAt(M-2),W=D.charCodeAt(U-2);if(k!==W)break;M--,U--}(M>1||U>1)&&this._pushTrimWhitespaceCharChange(i,r+1,1,M,s+1,1,U)}{let M=c(p,1),U=c(D,1);const k=p.length+1,W=D.length+1;for(;M<k&&U<W;){const H=p.charCodeAt(M-1),X=p.charCodeAt(U-1);if(H!==X)break;M++,U++}(M<k||U<W)&&this._pushTrimWhitespaceCharChange(i,r+1,M,k,s+1,U,W)}}r++,s++}h&&(i.push(v.createFromDiffResult(this.shouldIgnoreTrimWhitespace,h,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),r+=h.originalLength,s+=h.modifiedLength)}return{quitEarly:n,changes:i}}_pushTrimWhitespaceCharChange(A,E,n,i,r,s,f){if(this._mergeTrimWhitespaceCharChange(A,E,n,i,r,s,f))return;let L;this.shouldComputeCharChanges&&(L=[new u(E,n,E,i,r,s,r,f)]),A.push(new v(E,E,r,r,L))}_mergeTrimWhitespaceCharChange(A,E,n,i,r,s,f){const L=A.length;if(L===0)return!1;const h=A[L-1];return h.originalEndLineNumber===0||h.modifiedEndLineNumber===0?!1:h.originalEndLineNumber+1===E&&h.modifiedEndLineNumber+1===r?(h.originalEndLineNumber=E,h.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&h.charChanges&&h.charChanges.push(new u(E,n,E,i,r,s,r,f)),!0):!1}}t.DiffComputer=w;function g(b,A){const E=R.firstNonWhitespaceIndex(b);return E===-1?A:E+1}function c(b,A){const E=R.lastNonWhitespaceIndex(b);return E===-1?A:E+2}function _(b){if(b===0)return()=>!0;const A=Date.now();return()=>Date.now()-A<b}}),z(V[27],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(a=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const o of t.USUAL_WORD_SEPARATORS)a.indexOf(o)>=0||(u+="\\"+o);return u+="\\s]+)",new RegExp(u,"g")}t.DEFAULT_WORD_REGEXP=P();function R(a){let u=t.DEFAULT_WORD_REGEXP;if(a&&a instanceof RegExp)if(a.global)u=a;else{let o="g";a.ignoreCase&&(o+="i"),a.multiline&&(o+="m"),a.unicode&&(o+="u"),u=new RegExp(a.source,o)}return u.lastIndex=0,u}t.ensureValidWordDefinition=R;const C={maxLen:1e3,windowSize:15,timeBudget:150};function l(a,u,o,v,w=C){if(o.length>w.maxLen){let A=a-w.maxLen/2;return A<0?A=0:v+=A,o=o.substring(A,a+w.maxLen/2),l(a,u,o,v,w)}const g=Date.now(),c=a-1-v;let _=-1,b=null;for(let A=1;!(Date.now()-g>=w.timeBudget);A++){const E=c-w.windowSize*A;u.lastIndex=Math.max(0,E);const n=S(u,o,c,_);if(!n&&b||(b=n,E<=0))break;_=E}if(b){let A={word:b[0],startColumn:v+1+b.index,endColumn:v+1+b.index+b[0].length};return u.lastIndex=0,A}return null}t.getWordAtText=l;function S(a,u,o,v){let w;for(;w=a.exec(u);){const g=w.index||0;if(g<=o&&a.lastIndex>=o)return w;if(v>0&&g>v)return null}return null}}),z(V[28],G([0,1,23]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=t.State=void 0;var R;(function(c){c[c.Invalid=0]="Invalid",c[c.Start=1]="Start",c[c.H=2]="H",c[c.HT=3]="HT",c[c.HTT=4]="HTT",c[c.HTTP=5]="HTTP",c[c.F=6]="F",c[c.FI=7]="FI",c[c.FIL=8]="FIL",c[c.BeforeColon=9]="BeforeColon",c[c.AfterColon=10]="AfterColon",c[c.AlmostThere=11]="AlmostThere",c[c.End=12]="End",c[c.Accept=13]="Accept",c[c.LastKnownState=14]="LastKnownState"})(R=t.State||(t.State={}));class C{constructor(_,b,A){const E=new Uint8Array(_*b);for(let n=0,i=_*b;n<i;n++)E[n]=A;this._data=E,this.rows=_,this.cols=b}get(_,b){return this._data[_*this.cols+b]}set(_,b,A){this._data[_*this.cols+b]=A}}t.Uint8Matrix=C;class l{constructor(_){let b=0,A=0;for(let n=0,i=_.length;n<i;n++){let[r,s,f]=_[n];s>b&&(b=s),r>A&&(A=r),f>A&&(A=f)}b++,A++;let E=new C(A,b,0);for(let n=0,i=_.length;n<i;n++){let[r,s,f]=_[n];E.set(r,s,f)}this._states=E,this._maxCharCode=b}nextState(_,b){return b<0||b>=this._maxCharCode?0:this._states.get(_,b)}}t.StateMachine=l;let S=null;function a(){return S===null&&(S=new l([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var u;(function(c){c[c.None=0]="None",c[c.ForceTermination=1]="ForceTermination",c[c.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let o=null;function v(){if(o===null){o=new P.CharacterClassifier(0);const c=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let b=0;b<c.length;b++)o.set(c.charCodeAt(b),1);const _=".,;";for(let b=0;b<_.length;b++)o.set(_.charCodeAt(b),2)}return o}class w{static _createLink(_,b,A,E,n){let i=n-1;do{const r=b.charCodeAt(i);if(_.get(r)!==2)break;i--}while(i>E);if(E>0){const r=b.charCodeAt(E-1),s=b.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:A,startColumn:E+1,endLineNumber:A,endColumn:i+2},url:b.substring(E,i+1)}}static computeLinks(_,b=a()){const A=v();let E=[];for(let n=1,i=_.getLineCount();n<=i;n++){const r=_.getLineContent(n),s=r.length;let f=0,L=0,h=0,d=1,m=!1,p=!1,D=!1,M=!1;for(;f<s;){let U=!1;const k=r.charCodeAt(f);if(d===13){let W;switch(k){case 40:m=!0,W=0;break;case 41:W=m?0:1;break;case 91:D=!0,p=!0,W=0;break;case 93:D=!1,W=p?0:1;break;case 123:M=!0,W=0;break;case 125:W=M?0:1;break;case 39:W=h===34||h===96?0:1;break;case 34:W=h===39||h===96?0:1;break;case 96:W=h===39||h===34?0:1;break;case 42:W=h===42?1:0;break;case 124:W=h===124?1:0;break;case 32:W=D?0:1;break;default:W=A.get(k)}W===1&&(E.push(w._createLink(A,r,n,L,f)),U=!0)}else if(d===12){let W;k===91?(p=!0,W=0):W=A.get(k),W===1?U=!0:d=13}else d=b.nextState(d,k),d===0&&(U=!0);U&&(d=1,m=!1,p=!1,M=!1,L=f+1,h=k),f++}d===13&&E.push(w._createLink(A,r,n,L,s))}return E}}t.LinkComputer=w;function g(c){return!c||typeof c.getLineCount!="function"||typeof c.getLineContent!="function"?[]:w.computeLinks(c)}t.computeLinks=g}),z(V[29],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class P{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(C,l,S,a,u){if(C&&l){let o=this.doNavigateValueSet(l,u);if(o)return{range:C,value:o}}if(S&&a){let o=this.doNavigateValueSet(a,u);if(o)return{range:S,value:o}}return null}doNavigateValueSet(C,l){let S=this.numberReplace(C,l);return S!==null?S:this.textReplace(C,l)}numberReplace(C,l){let S=Math.pow(10,C.length-(C.lastIndexOf(".")+1)),a=Number(C),u=parseFloat(C);return!isNaN(a)&&!isNaN(u)&&a===u?a===0&&!l?null:(a=Math.floor(a*S),a+=l?S:-S,String(a/S)):null}textReplace(C,l){return this.valueSetsReplace(this._defaultValueSet,C,l)}valueSetsReplace(C,l,S){let a=null;for(let u=0,o=C.length;a===null&&u<o;u++)a=this.valueSetReplace(C[u],l,S);return a}valueSetReplace(C,l,S){let a=C.indexOf(l);return a>=0?(a+=S?1:-1,a<0?a=C.length-1:a%=C.length,C[a]):null}}t.BasicInplaceReplace=P,P.INSTANCE=new P}),z(V[30],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var P;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(P=t.AccessibilitySupport||(t.AccessibilitySupport={}));var R;(function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(R=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var C;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(C=t.CompletionItemKind||(t.CompletionItemKind={}));var l;(function(e){e[e.Deprecated=1]="Deprecated"})(l=t.CompletionItemTag||(t.CompletionItemTag={}));var S;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(S=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var a;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(a=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var u;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(u=t.CursorChangeReason||(t.CursorChangeReason={}));var o;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(o=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var v;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(v=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var w;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(w=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var g;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingDelete=6]="autoClosingDelete",e[e.autoClosingOvertype=7]="autoClosingOvertype",e[e.autoClosingQuotes=8]="autoClosingQuotes",e[e.autoIndent=9]="autoIndent",e[e.automaticLayout=10]="automaticLayout",e[e.autoSurround=11]="autoSurround",e[e.bracketPairColorization=12]="bracketPairColorization",e[e.guides=13]="guides",e[e.codeLens=14]="codeLens",e[e.codeLensFontFamily=15]="codeLensFontFamily",e[e.codeLensFontSize=16]="codeLensFontSize",e[e.colorDecorators=17]="colorDecorators",e[e.columnSelection=18]="columnSelection",e[e.comments=19]="comments",e[e.contextmenu=20]="contextmenu",e[e.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",e[e.cursorBlinking=22]="cursorBlinking",e[e.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",e[e.cursorStyle=24]="cursorStyle",e[e.cursorSurroundingLines=25]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",e[e.cursorWidth=27]="cursorWidth",e[e.disableLayerHinting=28]="disableLayerHinting",e[e.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",e[e.domReadOnly=30]="domReadOnly",e[e.dragAndDrop=31]="dragAndDrop",e[e.emptySelectionClipboard=32]="emptySelectionClipboard",e[e.extraEditorClassName=33]="extraEditorClassName",e[e.fastScrollSensitivity=34]="fastScrollSensitivity",e[e.find=35]="find",e[e.fixedOverflowWidgets=36]="fixedOverflowWidgets",e[e.folding=37]="folding",e[e.foldingStrategy=38]="foldingStrategy",e[e.foldingHighlight=39]="foldingHighlight",e[e.foldingImportsByDefault=40]="foldingImportsByDefault",e[e.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=42]="fontFamily",e[e.fontInfo=43]="fontInfo",e[e.fontLigatures=44]="fontLigatures",e[e.fontSize=45]="fontSize",e[e.fontWeight=46]="fontWeight",e[e.formatOnPaste=47]="formatOnPaste",e[e.formatOnType=48]="formatOnType",e[e.glyphMargin=49]="glyphMargin",e[e.gotoLocation=50]="gotoLocation",e[e.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",e[e.hover=52]="hover",e[e.inDiffEditor=53]="inDiffEditor",e[e.inlineSuggest=54]="inlineSuggest",e[e.letterSpacing=55]="letterSpacing",e[e.lightbulb=56]="lightbulb",e[e.lineDecorationsWidth=57]="lineDecorationsWidth",e[e.lineHeight=58]="lineHeight",e[e.lineNumbers=59]="lineNumbers",e[e.lineNumbersMinChars=60]="lineNumbersMinChars",e[e.linkedEditing=61]="linkedEditing",e[e.links=62]="links",e[e.matchBrackets=63]="matchBrackets",e[e.minimap=64]="minimap",e[e.mouseStyle=65]="mouseStyle",e[e.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=67]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",e[e.multiCursorModifier=69]="multiCursorModifier",e[e.multiCursorPaste=70]="multiCursorPaste",e[e.occurrencesHighlight=71]="occurrencesHighlight",e[e.overviewRulerBorder=72]="overviewRulerBorder",e[e.overviewRulerLanes=73]="overviewRulerLanes",e[e.padding=74]="padding",e[e.parameterHints=75]="parameterHints",e[e.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",e[e.quickSuggestions=78]="quickSuggestions",e[e.quickSuggestionsDelay=79]="quickSuggestionsDelay",e[e.readOnly=80]="readOnly",e[e.renameOnType=81]="renameOnType",e[e.renderControlCharacters=82]="renderControlCharacters",e[e.renderFinalNewline=83]="renderFinalNewline",e[e.renderLineHighlight=84]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=86]="renderValidationDecorations",e[e.renderWhitespace=87]="renderWhitespace",e[e.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",e[e.roundedSelection=89]="roundedSelection",e[e.rulers=90]="rulers",e[e.scrollbar=91]="scrollbar",e[e.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=93]="scrollBeyondLastLine",e[e.scrollPredominantAxis=94]="scrollPredominantAxis",e[e.selectionClipboard=95]="selectionClipboard",e[e.selectionHighlight=96]="selectionHighlight",e[e.selectOnLineNumbers=97]="selectOnLineNumbers",e[e.showFoldingControls=98]="showFoldingControls",e[e.showUnused=99]="showUnused",e[e.snippetSuggestions=100]="snippetSuggestions",e[e.smartSelect=101]="smartSelect",e[e.smoothScrolling=102]="smoothScrolling",e[e.stickyTabStops=103]="stickyTabStops",e[e.stopRenderingLineAfter=104]="stopRenderingLineAfter",e[e.suggest=105]="suggest",e[e.suggestFontSize=106]="suggestFontSize",e[e.suggestLineHeight=107]="suggestLineHeight",e[e.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",e[e.suggestSelection=109]="suggestSelection",e[e.tabCompletion=110]="tabCompletion",e[e.tabIndex=111]="tabIndex",e[e.unusualLineTerminators=112]="unusualLineTerminators",e[e.useShadowDOM=113]="useShadowDOM",e[e.useTabStops=114]="useTabStops",e[e.wordSeparators=115]="wordSeparators",e[e.wordWrap=116]="wordWrap",e[e.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=119]="wordWrapColumn",e[e.wordWrapOverride1=120]="wordWrapOverride1",e[e.wordWrapOverride2=121]="wordWrapOverride2",e[e.wrappingIndent=122]="wrappingIndent",e[e.wrappingStrategy=123]="wrappingStrategy",e[e.showDeprecated=124]="showDeprecated",e[e.inlayHints=125]="inlayHints",e[e.editorClassName=126]="editorClassName",e[e.pixelRatio=127]="pixelRatio",e[e.tabFocusMode=128]="tabFocusMode",e[e.layoutInfo=129]="layoutInfo",e[e.wrappingInfo=130]="wrappingInfo"})(g=t.EditorOption||(t.EditorOption={}));var c;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(c=t.EndOfLinePreference||(t.EndOfLinePreference={}));var _;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(_=t.EndOfLineSequence||(t.EndOfLineSequence={}));var b;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(b=t.IndentAction||(t.IndentAction={}));var A;(function(e){e[e.Other=0]="Other",e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"})(A=t.InlayHintKind||(t.InlayHintKind={}));var E;(function(e){e[e.Automatic=0]="Automatic",e[e.Explicit=1]="Explicit"})(E=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"})(n=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(i=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var s;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(s=t.MinimapPosition||(t.MinimapPosition={}));var f;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(f=t.MouseTargetType||(t.MouseTargetType={}));var L;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(L=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var h;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(h=t.OverviewRulerLane||(t.OverviewRulerLane={}));var d;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(d=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var m;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(m=t.RenderMinimap||(t.RenderMinimap={}));var p;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(p=t.ScrollType||(t.ScrollType={}));var D;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(D=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var M;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(M=t.SelectionDirection||(t.SelectionDirection={}));var U;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(U=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var k;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(k=t.SymbolKind||(t.SymbolKind={}));var W;(function(e){e[e.Deprecated=1]="Deprecated"})(W=t.SymbolTag||(t.SymbolTag={}));var H;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})(H=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var X;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})(X=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var $;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var x;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})(x=t.WrappingIndent||(t.WrappingIndent={}))}),z(V[31],G([0,1,21,10,17,14,3,6,24,25,30]),function(F,t,P,R,C,l,S,a,u,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class w{static chord(_,b){return(0,C.KeyChord)(_,b)}}t.KeyMod=w,w.CtrlCmd=2048,w.Shift=1024,w.Alt=512,w.WinCtrl=256;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.CancellationTokenSource,Emitter:R.Emitter,KeyCode:v.KeyCode,KeyMod:w,Position:S.Position,Range:a.Range,Selection:u.Selection,SelectionDirection:v.SelectionDirection,MarkerSeverity:v.MarkerSeverity,MarkerTag:v.MarkerTag,Uri:l.URI,Token:o.Token}}t.createMonacoBaseAPI=g}),z(V[32],G([0,1,13]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;class R{constructor(S,a){this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=a}}t.PrefixSumIndexOfResult=R;class C{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,a){S=(0,P.toUint32)(S);const u=this.values,o=this.prefixSum,v=a.length;return v===0?!1:(this.values=new Uint32Array(u.length+v),this.values.set(u.subarray(0,S),0),this.values.set(u.subarray(S),S+v),this.values.set(a,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(o.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,a){return S=(0,P.toUint32)(S),a=(0,P.toUint32)(a),this.values[S]===a?!1:(this.values[S]=a,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,a){S=(0,P.toUint32)(S),a=(0,P.toUint32)(a);const u=this.values,o=this.prefixSum;if(S>=u.length)return!1;let v=u.length-S;return a>=v&&(a=v),a===0?!1:(this.values=new Uint32Array(u.length-a),this.values.set(u.subarray(0,S),0),this.values.set(u.subarray(S+a),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(o.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,P.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let a=this.prefixSumValidIndex[0]+1;a===0&&(this.prefixSum[0]=this.values[0],a++),S>=this.values.length&&(S=this.values.length-1);for(let u=a;u<=S;u++)this.prefixSum[u]=this.prefixSum[u-1]+this.values[u];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let a=0,u=this.values.length-1,o=0,v=0,w=0;for(;a<=u;)if(o=a+(u-a)/2|0,v=this.prefixSum[o],w=v-this.values[o],S<w)u=o-1;else if(S>=v)a=o+1;else break;return new R(o,S-w)}}t.PrefixSumComputer=C}),z(V[33],G([0,1,5,3,32]),function(F,t,P,R,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class l{constructor(a,u,o,v){this._uri=a,this._lines=u,this._eol=o,this._versionId=v,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(a){a.eol&&a.eol!==this._eol&&(this._eol=a.eol,this._lineStarts=null);const u=a.changes;for(const o of u)this._acceptDeleteRange(o.range),this._acceptInsertText(new R.Position(o.range.startLineNumber,o.range.startColumn),o.text);this._versionId=a.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const a=this._eol.length,u=this._lines.length,o=new Uint32Array(u);for(let v=0;v<u;v++)o[v]=this._lines[v].length+a;this._lineStarts=new C.PrefixSumComputer(o)}}_setLineText(a,u){this._lines[a]=u,this._lineStarts&&this._lineStarts.changeValue(a,this._lines[a].length+this._eol.length)}_acceptDeleteRange(a){if(a.startLineNumber===a.endLineNumber){if(a.startColumn===a.endColumn)return;this._setLineText(a.startLineNumber-1,this._lines[a.startLineNumber-1].substring(0,a.startColumn-1)+this._lines[a.startLineNumber-1].substring(a.endColumn-1));return}this._setLineText(a.startLineNumber-1,this._lines[a.startLineNumber-1].substring(0,a.startColumn-1)+this._lines[a.endLineNumber-1].substring(a.endColumn-1)),this._lines.splice(a.startLineNumber,a.endLineNumber-a.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(a.startLineNumber,a.endLineNumber-a.startLineNumber)}_acceptInsertText(a,u){if(u.length===0)return;let o=(0,P.splitLines)(u);if(o.length===1){this._setLineText(a.lineNumber-1,this._lines[a.lineNumber-1].substring(0,a.column-1)+o[0]+this._lines[a.lineNumber-1].substring(a.column-1));return}o[o.length-1]+=this._lines[a.lineNumber-1].substring(a.column-1),this._setLineText(a.lineNumber-1,this._lines[a.lineNumber-1].substring(0,a.column-1)+o[0]);let v=new Uint32Array(o.length-1);for(let w=1;w<o.length;w++)this._lines.splice(a.lineNumber+w-1,0,o[w]),v[w-1]=o[w].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(a.lineNumber,v)}}t.MirrorTextModel=l}),z(V[35],G([0,1,11,2,14,3,6,26,33,27,28,29,31,12,9]),function(F,t,P,R,C,l,S,a,u,o,v,w,g,c,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=t.MirrorModel=void 0;class b extends u.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,r){let s=(0,o.getWordAtText)(i.column,(0,o.ensureValidWordDefinition)(r),this._lines[i.lineNumber-1],0);return s?new S.Range(i.lineNumber,s.startColumn,i.lineNumber,s.endColumn):null}getWordUntilPosition(i,r){const s=this.getWordAtPosition(i,r);return s?{word:this._lines[i.lineNumber-1].substring(s.startColumn-1,i.column-1),startColumn:s.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const r=this._lines,s=this._wordenize.bind(this);let f=0,L="",h=0,d=[];return{*[Symbol.iterator](){for(;;)if(h<d.length){const m=L.substring(d[h].start,d[h].end);h+=1,yield m}else if(f<r.length)L=r[f],d=s(L,i),h=0,f+=1;else break}}}getLineWords(i,r){let s=this._lines[i-1],f=this._wordenize(s,r),L=[];for(const h of f)L.push({word:s.substring(h.start,h.end),startColumn:h.start+1,endColumn:h.end+1});return L}_wordenize(i,r){const s=[];let f;for(r.lastIndex=0;(f=r.exec(i))&&f[0].length!==0;)s.push({start:f.index,end:f.index+f[0].length});return s}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let r=this._eol,s=i.startLineNumber-1,f=i.endLineNumber-1,L=[];L.push(this._lines[s].substring(i.startColumn-1));for(let h=s+1;h<f;h++)L.push(this._lines[h]);return L.push(this._lines[f].substring(0,i.endColumn-1)),L.join(r)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(i),s=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,s)}}_validateRange(i){const r=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),s=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return r.lineNumber!==i.startLineNumber||r.column!==i.startColumn||s.lineNumber!==i.endLineNumber||s.column!==i.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:s.lineNumber,endColumn:s.column}:i}_validatePosition(i){if(!l.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:r,column:s}=i,f=!1;if(r<1)r=1,s=1,f=!0;else if(r>this._lines.length)r=this._lines.length,s=this._lines[r-1].length+1,f=!0;else{let L=this._lines[r-1].length+1;s<1?(s=1,f=!0):s>L&&(s=L,f=!0)}return f?{lineNumber:r,column:s}:i}}t.MirrorModel=b;class A{constructor(i,r){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(r=>i.push(this._models[r])),i}acceptNewModel(i){this._models[i.url]=new b(C.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,r){if(!this._models[i])return;this._models[i].onEvents(r)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeDiff(i,r,s,f){const L=this._getModel(i),h=this._getModel(r);if(!L||!h)return null;const d=L.getLinesContent(),m=h.getLinesContent(),D=new a.DiffComputer(d,m,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:f}).computeDiff(),M=D.changes.length>0?!1:this._modelsAreIdentical(L,h);return{quitEarly:D.quitEarly,identical:M,changes:D.changes}}_modelsAreIdentical(i,r){const s=i.getLineCount(),f=r.getLineCount();if(s!==f)return!1;for(let L=1;L<=s;L++){const h=i.getLineContent(L),d=r.getLineContent(L);if(h!==d)return!1}return!0}async computeDirtyDiff(i,r,s){let f=this._getModel(i),L=this._getModel(r);if(!f||!L)return null;let h=f.getLinesContent(),d=L.getLinesContent();return new a.DiffComputer(h,d,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,r){const s=this._getModel(i);if(!s)return r;const f=[];let L;r=r.slice(0).sort((h,d)=>{if(h.range&&d.range)return S.Range.compareRangesUsingStarts(h.range,d.range);let m=h.range?0:1,p=d.range?0:1;return m-p});for(let{range:h,text:d,eol:m}of r){if(typeof m=="number"&&(L=m),S.Range.isEmpty(h)&&!d)continue;const p=s.getValueInRange(h);if(d=d.replace(/\r\n|\n|\r/g,s.eol),p===d)continue;if(Math.max(d.length,p.length)>A._diffLimit){f.push({range:h,text:d});continue}const D=(0,P.stringDiff)(p,d,!1),M=s.offsetAt(S.Range.lift(h).getStartPosition());for(const U of D){const k=s.positionAt(M+U.originalStart),W=s.positionAt(M+U.originalStart+U.originalLength),H={text:d.substr(U.modifiedStart,U.modifiedLength),range:{startLineNumber:k.lineNumber,startColumn:k.column,endLineNumber:W.lineNumber,endColumn:W.column}};s.getValueInRange(H.range)!==H.text&&f.push(H)}}return typeof L=="number"&&f.push({eol:L,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),f}async computeLinks(i){let r=this._getModel(i);return r?(0,v.computeLinks)(r):null}async textualSuggest(i,r,s,f){const L=new _.StopWatch(!0),h=new RegExp(s,f),d=new Set;e:for(let m of i){const p=this._getModel(m);if(!!p){for(let D of p.words(h))if(!(D===r||!isNaN(Number(D)))&&(d.add(D),d.size>A._suggestionsLimit))break e}}return{words:Array.from(d),duration:L.elapsed()}}async computeWordRanges(i,r,s,f){let L=this._getModel(i);if(!L)return Object.create(null);const h=new RegExp(s,f),d=Object.create(null);for(let m=r.startLineNumber;m<r.endLineNumber;m++){let p=L.getLineWords(m,h);for(const D of p){if(!isNaN(Number(D.word)))continue;let M=d[D.word];M||(M=[],d[D.word]=M),M.push({startLineNumber:m,startColumn:D.startColumn,endLineNumber:m,endColumn:D.endColumn})}}return d}async navigateValueSet(i,r,s,f,L){let h=this._getModel(i);if(!h)return null;let d=new RegExp(f,L);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let m=h.getValueInRange(r),p=h.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},d);if(!p)return null;let D=h.getValueInRange(p);return w.BasicInplaceReplace.INSTANCE.navigateValueSet(r,m,p,D,s)}loadForeignModule(i,r,s){const f=(d,m)=>this._host.fhr(d,m);let h={host:c.createProxyObject(s,f),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(h,r),Promise.resolve(c.getAllMethodNames(this._foreignModule))):new Promise((d,m)=>{F([i],p=>{this._foreignModule=p.create(h,r),d(c.getAllMethodNames(this._foreignModule))},m)})}fmr(i,r){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,r))}catch(s){return Promise.reject(s)}}}t.EditorSimpleWorker=A,A._diffLimit=1e5,A._suggestionsLimit=1e4;function E(n){return new A(n,null)}t.create=E,typeof importScripts=="function"&&(R.globals.monaco=(0,g.createMonacoBaseAPI)())}),function(){const F=self.MonacoEnvironment,t=F&&F.baseUrl?F.baseUrl:"../../../",P=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:u=>u,createScript:(u,...o)=>{const v=o.slice(0,-1).join(","),w=o.pop().toString();return`(function anonymous(${v}) {
${w}
})`}}):void 0;function R(){try{return(P?self.eval(P.createScript("","true")):new Function("true")).call(self),!0}catch(u){return!1}}function C(){return new Promise((u,o)=>{if(typeof self.define=="function"&&self.define.amd)return u();const v=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin)&&R()){fetch(v).then(g=>{if(g.status!==200)throw new Error(g.statusText);return g.text()}).then(g=>{g=`${g}
//# sourceURL=${v}`,(P?self.eval(P.createScript("",g)):new Function(g)).call(self),u()}).then(void 0,o);return}P?importScripts(P.createScriptURL(v)):importScripts(v),u()})}const l=function(u){C().then(()=>{require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:P,amdModulesPattern:/^vs\//}),require([u],function(o){setTimeout(function(){let v=o.create((w,g)=>{self.postMessage(w,g)},null);for(self.onmessage=w=>v.onmessage(w.data,w.ports);a.length>0;)self.onmessage(a.shift())},0)})})};let S=!0,a=[];self.onmessage=u=>{if(!S){a.push(u);return}S=!1,l(u.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d817eda05fc021eefb82d24e4d95554c043b6ec7/core/vs/base/worker/workerMain.js.map
