/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","os","vs/platform/workspaces/common/workspaces","vs/base/common/strings","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","fs","vs/base/common/process","vs/base/common/extpath","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","child_process","vs/platform/product/common/product","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/files/common/watcher","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/base/common/errorMessage","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/scanCode","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","vs/code/electron-main/main"],J=function(V){for(var e=[],v=0,R=V.length;v<R;v++)e[v]=Q[V[v]];return e};define(Q[102],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,D){if(!R)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=v}),define(Q[47],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(k){return(n,d,w)=>{let t=null,I=null;if(typeof w.value=="function"?(t="value",I=w.value):typeof w.get=="function"&&(t="get",I=w.get),!I)throw new Error("not supported");w[t]=k(I,d)}}e.createDecorator=v;function R(k,n,d){let w=null,t=null;if(typeof d.value=="function"?(w="value",t=d.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(w="get",t=d.get),!t)throw new Error("not supported");const I=`$memoize$${n}`;d[w]=function(...E){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,E)}),this[I]}}e.memoize=R;function D(k,n,d){return v((w,t)=>{const I=`$debounce$${t}`,E=`$debounce$result$${t}`;return function(...S){this[E]||(this[E]=d?d():void 0),clearTimeout(this[I]),n&&(this[E]=n(this[E],...S),S=[this[E]]),this[I]=setTimeout(()=>{w.apply(this,S),this[E]=d?d():void 0},k)}})}e.debounce=D;function M(k,n,d){return v((w,t)=>{const I=`$throttle$timer$${t}`,E=`$throttle$result$${t}`,S=`$throttle$lastRun$${t}`,f=`$throttle$pending$${t}`;return function(...g){if(this[E]||(this[E]=d?d():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),n&&(this[E]=n(this[E],...g)),this[f])return;const b=this[S]+k;b<=Date.now()?(this[S]=Date.now(),w.apply(this,[this[E]]),this[E]=d?d():void 0):(this[f]=!0,this[I]=setTimeout(()=>{this[f]=!1,this[S]=Date.now(),w.apply(this,[this[E]]),this[E]=d?d():void 0},b-Date.now()))}})}e.throttle=M}),define(Q[17],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(a=>{a(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=v,e.errorHandler=new v;function R(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=R;function D(u){d(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=D;function M(u){d(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=M;function k(u){if(u instanceof Error){let{name:i,message:a}=u;const s=u.stacktrace||u.stack;return{$isError:!0,name:i,message:a,stack:s}}return u}e.transformErrorForSerialization=k;const n="Canceled";function d(u){return u instanceof Error&&u.name===n&&u.message===n}e.isPromiseCanceledError=d;class w extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=w;function t(){const u=new Error(n);return u.name=u.message,u}e.canceled=t;function I(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=I;function E(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=E;function S(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function f(u){const i=new Error(`${u} has been disposed`);return i.name="DISPOSED",i}e.disposed=f;function g(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=g;class b extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=b;class y extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=y;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function h(u){const i=u;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=h;function o(u,i=Object.create(null)){const a=new Error(u);return i.actions&&(a.actions=i.actions),a}e.createErrorWithActions=o}),define(Q[30],J([0,1,17]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(O,T=0){return O[O.length-(1+T)]}e.tail=R;function D(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}e.tail2=D;function M(O,T,_=(j,X)=>j===X){if(O===T)return!0;if(!O||!T||O.length!==T.length)return!1;for(let j=0,X=O.length;j<X;j++)if(!_(O[j],T[j]))return!1;return!0}e.equals=M;function k(O,T,_){let j=0,X=O.length-1;for(;j<=X;){const $=(j+X)/2|0,N=_(O[$],T);if(N<0)j=$+1;else if(N>0)X=$-1;else return $}return-(j+1)}e.binarySearch=k;function n(O,T){let _=0,j=O.length;if(j===0)return 0;for(;_<j;){const X=Math.floor((_+j)/2);T(O[X])?j=X:_=X+1}return _}e.findFirstInSorted=n;function d(O,T,_){if(O=O|0,O>=T.length)throw new TypeError("invalid index");let j=T[Math.floor(T.length*Math.random())],X=[],$=[],N=[];for(let Z of T){const ie=_(Z,j);ie<0?X.push(Z):ie>0?$.push(Z):N.push(Z)}return O<X.length?d(O,X,_):O<X.length+N.length?N[0]:d(O-(X.length+N.length),$,_)}e.quickSelect=d;function w(O,T){const _=[];let j;for(const X of O.slice(0).sort(T))!j||T(j[0],X)!==0?(j=[X],_.push(j)):j.push(X);return _}e.groupBy=w;function t(O,T,_){const j=[];function X(Z,ie,oe){if(ie===0&&oe.length===0)return;const le=j[j.length-1];le&&le.start+le.deleteCount===Z?(le.deleteCount+=ie,le.toInsert.push(...oe)):j.push({start:Z,deleteCount:ie,toInsert:oe})}let $=0,N=0;for(;;){if($===O.length){X($,0,T.slice(N));break}if(N===T.length){X($,O.length-$,[]);break}const Z=O[$],ie=T[N],oe=_(Z,ie);oe===0?($+=1,N+=1):oe<0?(X($,1,[]),$+=1):oe>0&&(X($,0,[ie]),N+=1)}return j}e.sortedDiff=t;function I(O,T,_){const j=t(O,T,_),X=[],$=[];for(const N of j)X.push(...O.slice(N.start,N.start+N.deleteCount)),$.push(...N.toInsert);return{removed:X,added:$}}e.delta=I;function E(O,T,_){if(_===0)return[];const j=O.slice(0,_).sort(T);return f(O,T,j,_,O.length),j}e.top=E;function S(O,T,_,j,X){return _===0?Promise.resolve([]):new Promise(($,N)=>{(async()=>{const Z=O.length,ie=O.slice(0,_).sort(T);for(let oe=_,le=Math.min(_+j,Z);oe<Z;oe=le,le=Math.min(le+j,Z)){if(oe>_&&await new Promise(ne=>setTimeout(ne)),X&&X.isCancellationRequested)throw(0,v.canceled)();f(O,T,ie,oe,le)}return ie})().then($,N)})}e.topAsync=S;function f(O,T,_,j,X){for(const $=_.length;j<X;j++){const N=O[j];if(T(N,_[$-1])<0){_.pop();const Z=n(_,ie=>T(N,ie)<0);_.splice(Z,0,N)}}}function g(O){return O.filter(T=>!!T)}e.coalesce=g;function b(O){let T=0;for(let _=0;_<O.length;_++)O[_]&&(O[T]=O[_],T+=1);O.length=T}e.coalesceInPlace=b;function y(O,T,_){O.splice(_,0,O.splice(T,1)[0])}e.move=y;function c(O){return!Array.isArray(O)||O.length===0}e.isFalsyOrEmpty=c;function h(O){return Array.isArray(O)&&O.length>0}e.isNonEmptyArray=h;function o(O,T=_=>_){const _=new Set;return O.filter(j=>{const X=T(j);return _.has(X)?!1:(_.add(X),!0)})}e.distinct=o;function u(O){const T=Object.create(null);return _=>{const j=O(_);return T[j]?!1:(T[j]=!0,!0)}}e.uniqueFilter=u;function i(O,T){const _=a(O,T);if(_!==-1)return O[_]}e.findLast=i;function a(O,T){for(let _=O.length-1;_>=0;_--){const j=O[_];if(T(j))return _}return-1}e.lastIndex=a;function s(O,T){return O.length>0?O[0]:T}e.firstOrDefault=s;function r(O,T,_=(j,X)=>j===X){let j=0;for(let X=0,$=Math.min(O.length,T.length);X<$&&_(O[X],T[X]);X++)j++;return j}e.commonPrefixLength=r;function l(O){return[].concat(...O)}e.flatten=l;function m(O,T){let _=typeof T=="number"?O:0;typeof T=="number"?_=O:(_=0,T=O);const j=[];if(_<=T)for(let X=_;X<T;X++)j.push(X);else for(let X=_;X>T;X--)j.push(X);return j}e.range=m;function p(O,T,_){return O.reduce((j,X)=>(j[T(X)]=_?_(X):X,j),Object.create(null))}e.index=p;function P(O,T){return O.push(T),()=>L(O,T)}e.insert=P;function L(O,T){const _=O.indexOf(T);if(_>-1)return O.splice(_,1),T}e.remove=L;function A(O,T,_){const j=O.slice(0,T),X=O.slice(T);return j.concat(_,X)}e.arrayInsert=A;function W(O,T){let _;if(typeof T=="number"){let j=T;_=()=>{const X=Math.sin(j++)*179426549;return X-Math.floor(X)}}else _=Math.random;for(let j=O.length-1;j>0;j-=1){const X=Math.floor(_()*(j+1)),$=O[j];O[j]=O[X],O[X]=$}}e.shuffle=W;function q(O,T){const _=O.indexOf(T);_>-1&&(O.splice(_,1),O.unshift(T))}e.pushToStart=q;function x(O,T){const _=O.indexOf(T);_>-1&&(O.splice(_,1),O.push(T))}e.pushToEnd=x;function re(O,T){return Array.isArray(O)?O.map(T):T(O)}e.mapArrayOrNot=re;function K(O){return Array.isArray(O)?O:[O]}e.asArray=K;function ee(O){return O[Math.floor(Math.random()*O.length)]}e.getRandomElement=ee;function F(O,T){for(const _ of O){const j=T(_);if(j!==void 0)return j}}e.mapFind=F;function H(O,T,_){const j=B(O,T),X=O.length,$=_.length;O.length=X+$;for(let N=X-1;N>=j;N--)O[N+$]=O[N];for(let N=0;N<$;N++)O[N+j]=_[N]}e.insertInto=H;function z(O,T,_,j){const X=B(O,T),$=O.splice(X,_);return H(O,X,j),$}e.splice=z;function B(O,T){return T<0?Math.max(T+O.length,0):Math.min(T,O.length)}function U(O,T){let _=Number.MAX_SAFE_INTEGER,j=0;return O.forEach((X,$)=>{const N=T(X);N<_&&(_=N,j=$)}),j}e.minIndex=U;function C(O,T){let _=Number.MIN_SAFE_INTEGER,j=0;return O.forEach((X,$)=>{const N=T(X);N>_&&(_=N,j=$)}),j}e.maxIndex=C;class Y{constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let _=this.firstIdx;for(;_<this.items.length&&T(this.items[_]);)_++;const j=_===this.firstIdx?null:this.items.slice(this.firstIdx,_);return this.firstIdx=_,j}takeFromEndWhile(T){let _=this.lastIdx;for(;_>=0&&T(this.items[_]);)_--;const j=_===this.lastIdx?null:this.items.slice(_+1,this.lastIdx+1);return this.lastIdx=_,j}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=Y}),define(Q[42],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const D=this;let M=!1,k;return function(){return M||(M=!0,k=R.apply(D,arguments)),k}}e.once=v}),define(Q[67],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function D(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}R.is=D;const M=Object.freeze([]);function k(){return M}R.empty=k;function*n(u){yield u}R.single=n;function d(u){return u||M}R.from=d;function w(u){return!u||u[Symbol.iterator]().next().done===!0}R.isEmpty=w;function t(u){return u[Symbol.iterator]().next().value}R.first=t;function I(u,i){for(const a of u)if(i(a))return!0;return!1}R.some=I;function E(u,i){for(const a of u)if(i(a))return a}R.find=E;function*S(u,i){for(const a of u)i(a)&&(yield a)}R.filter=S;function*f(u,i){let a=0;for(const s of u)yield i(s,a++)}R.map=f;function*g(...u){for(const i of u)for(const a of i)yield a}R.concat=g;function*b(u){for(const i of u)for(const a of i)yield a}R.concatNested=b;function y(u,i,a){let s=a;for(const r of u)s=i(s,r);return s}R.reduce=y;function*c(u,i,a=u.length){for(i<0&&(i+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);i<a;i++)yield u[i]}R.slice=c;function h(u,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,u];const s=u[Symbol.iterator]();for(let r=0;r<i;r++){const l=s.next();if(l.done)return[a,R.empty()];a.push(l.value)}return[a,{[Symbol.iterator](){return s}}]}R.consume=h;function o(u,i,a=(s,r)=>s===r){const s=u[Symbol.iterator](),r=i[Symbol.iterator]();for(;;){const l=s.next(),m=r.next();if(l.done!==m.done)return!1;if(l.done)return!0;if(!a(l.value,m.value))return!1}}R.equals=o})(v=e.Iterable||(e.Iterable={}))}),define(Q[39],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function k(i,a=!1){let s=0,r=i.length,l="",m=0,p=16,P=0;function L(ee){let F=0,H=0;for(;F<ee;){const z=i.charCodeAt(s);if(z>=48&&z<=57)H=H*16+z-48;else if(z>=65&&z<=70)H=H*16+z-65+10;else if(z>=97&&z<=102)H=H*16+z-97+10;else break;s++,F++}return F<ee&&(H=-1),H}function A(ee){s=ee,l="",m=0,p=16,P=0}function W(){const ee=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&w(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&w(i.charCodeAt(s)))for(s++;s<i.length&&w(i.charCodeAt(s));)s++;else return P=3,i.substring(ee,s);let F=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&w(i.charCodeAt(s))){for(s++;s<i.length&&w(i.charCodeAt(s));)s++;F=s}else P=3;return i.substring(ee,F)}function q(){let ee="",F=s;for(;;){if(s>=r){ee+=i.substring(F,s),P=2;break}const H=i.charCodeAt(s);if(H===34){ee+=i.substring(F,s),s++;break}if(H===92){if(ee+=i.substring(F,s),s++,s>=r){P=2;break}switch(i.charCodeAt(s++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const B=L(4);B>=0?ee+=String.fromCharCode(B):P=4;break;default:P=5}F=s;continue}if(H>=0&&H<=31)if(d(H)){ee+=i.substring(F,s),P=2;break}else P=6;s++}return ee}function x(){if(l="",P=0,m=s,s>=r)return m=r,p=17;let ee=i.charCodeAt(s);if(n(ee)){do s++,l+=String.fromCharCode(ee),ee=i.charCodeAt(s);while(n(ee));return p=15}if(d(ee))return s++,l+=String.fromCharCode(ee),ee===13&&i.charCodeAt(s)===10&&(s++,l+=`
`),p=14;switch(ee){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,l=q(),p=10;case 47:const F=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<r&&!d(i.charCodeAt(s));)s++;return l=i.substring(F,s),p=12}if(i.charCodeAt(s+1)===42){s+=2;const H=r-1;let z=!1;for(;s<H;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,P=1),l=i.substring(F,s),p=13}return l+=String.fromCharCode(ee),s++,p=16;case 45:if(l+=String.fromCharCode(ee),s++,s===r||!w(i.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=W(),p=11;default:for(;s<r&&re(ee);)s++,ee=i.charCodeAt(s);if(m!==s){switch(l=i.substring(m,s),l){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return l+=String.fromCharCode(ee),s++,p=16}}function re(ee){if(n(ee)||d(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let ee;do ee=x();while(ee>=12&&ee<=15);return ee}return{setPosition:A,getPosition:()=>s,scan:a?K:x,getToken:()=>p,getTokenValue:()=>l,getTokenOffset:()=>m,getTokenLength:()=>s-m,getTokenError:()=>P}}e.createScanner=k;function n(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function d(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function I(i,a){const s=[],r=new Object;let l;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function P(L,A,W,q){m.value=L,m.offset=A,m.length=W,m.type=q,m.colonOffset=void 0,l=m}try{h(i,{onObjectBegin:(L,A)=>{if(a<=L)throw r;l=void 0,p=a>L,s.push("")},onObjectProperty:(L,A,W)=>{if(a<A||(P(L,A,W,"property"),s[s.length-1]=L,a<=A+W))throw r},onObjectEnd:(L,A)=>{if(a<=L)throw r;l=void 0,s.pop()},onArrayBegin:(L,A)=>{if(a<=L)throw r;l=void 0,s.push(0)},onArrayEnd:(L,A)=>{if(a<=L)throw r;l=void 0,s.pop()},onLiteralValue:(L,A,W)=>{if(a<A||(P(L,A,W,u(L)),a<=A+W))throw r},onSeparator:(L,A,W)=>{if(a<=A)throw r;if(L===":"&&l&&l.type==="property")l.colonOffset=A,p=!1,l=void 0;else if(L===","){const q=s[s.length-1];typeof q=="number"?s[s.length-1]=q+1:(p=!0,s[s.length-1]=""),l=void 0}}})}catch(L){if(L!==r)throw L}return{path:s,previousNode:l,isAtPropertyKey:p,matches:L=>{let A=0;for(let W=0;A<L.length&&W<s.length;W++)if(L[A]===s[W]||L[A]==="*")A++;else if(L[A]!=="**")return!1;return A===L.length}}}e.getLocation=I;function E(i,a=[],s=M.DEFAULT){let r=null,l=[];const m=[];function p(L){Array.isArray(l)?l.push(L):r!==null&&(l[r]=L)}return h(i,{onObjectBegin:()=>{const L={};p(L),m.push(l),l=L,r=null},onObjectProperty:L=>{r=L},onObjectEnd:()=>{l=m.pop()},onArrayBegin:()=>{const L=[];p(L),m.push(l),l=L,r=null},onArrayEnd:()=>{l=m.pop()},onLiteralValue:p,onError:(L,A,W)=>{a.push({error:L,offset:A,length:W})}},s),l[0]}e.parse=E;function S(i,a=[],s=M.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(L){r.type==="property"&&(r.length=L-r.offset,r=r.parent)}function m(L){return r.children.push(L),L}h(i,{onObjectBegin:L=>{r=m({type:"object",offset:L,length:-1,parent:r,children:[]})},onObjectProperty:(L,A,W)=>{r=m({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:L,offset:A,length:W,parent:r})},onObjectEnd:(L,A)=>{r.length=L+A-r.offset,r=r.parent,l(L+A)},onArrayBegin:(L,A)=>{r=m({type:"array",offset:L,length:-1,parent:r,children:[]})},onArrayEnd:(L,A)=>{r.length=L+A-r.offset,r=r.parent,l(L+A)},onLiteralValue:(L,A,W)=>{m({type:u(L),offset:A,length:W,parent:r,value:L}),l(A+W)},onSeparator:(L,A,W)=>{r.type==="property"&&(L===":"?r.colonOffset=A:L===","&&l(A))},onError:(L,A,W)=>{a.push({error:L,offset:A,length:W})}},s);const P=r.children[0];return P&&delete P.parent,P}e.parseTree=S;function f(i,a){if(!i)return;let s=i;for(let r of a)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const m of s.children)if(Array.isArray(m.children)&&m.children[0].value===r){s=m.children[1],l=!0;break}if(!l)return}else{const l=r;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.findNodeAtLocation=f;function g(i){if(!i.parent||!i.parent.children)return[];const a=g(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;a.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&a.push(s)}return a}e.getNodePath=g;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":const a=Object.create(null);for(let s of i.children){const r=s.children[1];r&&(a[s.children[0].value]=b(r))}return a;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=b;function y(i,a,s=!1){return a>=i.offset&&a<i.offset+i.length||s&&a===i.offset+i.length}e.contains=y;function c(i,a,s=!1){if(y(i,a,s)){const r=i.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=a;l++){const m=c(r[l],a,s);if(m)return m}return i}}e.findNodeAtOffset=c;function h(i,a,s=M.DEFAULT){const r=k(i,!1);function l(_){return _?()=>_(r.getTokenOffset(),r.getTokenLength()):()=>!0}function m(_){return _?j=>_(j,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=l(a.onObjectBegin),P=m(a.onObjectProperty),L=l(a.onObjectEnd),A=l(a.onArrayBegin),W=l(a.onArrayEnd),q=m(a.onLiteralValue),x=m(a.onSeparator),re=l(a.onComment),K=m(a.onError),ee=s&&s.disallowComments,F=s&&s.allowTrailingComma;function H(){for(;;){const _=r.scan();switch(r.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:ee||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(_){case 12:case 13:ee?z(10):re();break;case 16:z(1);break;case 15:case 14:break;default:return _}}}function z(_,j=[],X=[]){if(K(_),j.length+X.length>0){let $=r.getToken();for(;$!==17;){if(j.indexOf($)!==-1){H();break}else if(X.indexOf($)!==-1)break;$=H()}}}function B(_){const j=r.getTokenValue();return _?q(j):P(j),H(),!0}function U(){switch(r.getToken()){case 11:let _=0;try{_=JSON.parse(r.getTokenValue()),typeof _!="number"&&(z(2),_=0)}catch(j){z(2)}q(_);break;case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return H(),!0}function C(){return r.getToken()!==10?(z(3,[],[2,5]),!1):(B(!1),r.getToken()===6?(x(":"),H(),T()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function Y(){p(),H();let _=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(_||z(4,[],[]),x(","),H(),r.getToken()===2&&F)break}else _&&z(6,[],[]);C()||z(4,[],[2,5]),_=!0}return L(),r.getToken()!==2?z(7,[2],[]):H(),!0}function O(){A(),H();let _=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(_||z(4,[],[]),x(","),H(),r.getToken()===4&&F)break}else _&&z(6,[],[]);T()||z(4,[],[4,5]),_=!0}return W(),r.getToken()!==4?z(8,[4],[]):H(),!0}function T(){switch(r.getToken()){case 3:return O();case 1:return Y();case 10:return B(!0);default:return U()}}return H(),r.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):T()?(r.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=h;function o(i,a){let s=k(i),r=[],l,m=0,p;do switch(p=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:m!==p&&r.push(i.substring(m,p)),a!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,a)),m=s.getPosition();break}while(l!==17);return r.join("")}e.stripComments=o;function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Q[103],J([0,1,39]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(d,w,t){let I,E,S,f,g;if(w){for(f=w.offset,g=f+w.length,S=f;S>0&&!n(d,S-1);)S--;let m=g;for(;m<d.length&&!n(d,m);)m++;E=d.substring(S,m),I=M(E,t)}else E=d,I=0,S=0,f=0,g=d.length;const b=k(t,d);let y=!1,c=0,h;t.insertSpaces?h=D(" ",t.tabSize||4):h="	";const o=(0,v.createScanner)(E,!1);let u=!1;function i(){return b+D(h,I+c)}function a(){let m=o.scan();for(y=!1;m===15||m===14;)y=y||m===14,m=o.scan();return u=m===16||o.getTokenError()!==0,m}const s=[];function r(m,p,P){!u&&p<g&&P>f&&d.substring(p,P)!==m&&s.push({offset:p,length:P-p,content:m})}let l=a();if(l!==17){const m=o.getTokenOffset()+S,p=D(h,I);r(p,S,m)}for(;l!==17;){let m=o.getTokenOffset()+o.getTokenLength()+S,p=a(),P="";for(;!y&&(p===12||p===13);){const A=o.getTokenOffset()+S;r(" ",m,A),m=o.getTokenOffset()+o.getTokenLength()+S,P=p===12?i():"",p=a()}if(p===2)l!==1&&(c--,P=i());else if(p===4)l!==3&&(c--,P=i());else{switch(l){case 3:case 1:c++,P=i();break;case 5:case 12:P=i();break;case 13:y?P=i():P=" ";break;case 6:P=" ";break;case 10:if(p===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?P=" ":p!==5&&p!==17&&(u=!0);break;case 16:u=!0;break}y&&(p===12||p===13)&&(P=i())}const L=o.getTokenOffset()+S;r(P,m,L),l=p}return s}e.format=R;function D(d,w){let t="";for(let I=0;I<w;I++)t+=d;return t}function M(d,w){let t=0,I=0;const E=w.tabSize||4;for(;t<d.length;){const S=d.charAt(t);if(S===" ")I++;else if(S==="	")I+=E;else break;t++}return Math.floor(I/E)}function k(d,w){for(let t=0;t<w.length;t++){const I=w.charAt(t);if(I==="\r")return t+1<w.length&&w.charAt(t+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=k;function n(d,w){return`\r
`.indexOf(d.charAt(w))!==-1}e.isEOL=n}),define(Q[80],J([0,1,39,103]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(w,t,I){return M(w,t,void 0,I)}e.removeProperty=D;function M(w,t,I,E,S){const f=t.slice(),g=[],b=(0,v.parseTree)(w,g);let y,c;for(;f.length>0&&(c=f.pop(),y=(0,v.findNodeAtLocation)(b,f),y===void 0&&I!==void 0);)typeof c=="string"?I={[c]:I}:I=[I];if(y)if(y.type==="object"&&typeof c=="string"&&Array.isArray(y.children)){const h=(0,v.findNodeAtLocation)(y,[c]);if(h!==void 0)if(I===void 0){if(!h.parent)throw new Error("Malformed AST");const o=y.children.indexOf(h.parent);let u,i=h.parent.offset+h.parent.length;if(o>0){const a=y.children[o-1];u=a.offset+a.length}else u=y.offset+1,y.children.length>1&&(i=y.children[1].offset);return k(w,{offset:u,length:i-u,content:""},E)}else return k(w,{offset:h.offset,length:h.length,content:JSON.stringify(I)},E);else{if(I===void 0)return[];const o=`${JSON.stringify(c)}: ${JSON.stringify(I)}`,u=S?S(y.children.map(a=>a.children[0].value)):y.children.length;let i;if(u>0){const a=y.children[u-1];i={offset:a.offset+a.length,length:0,content:","+o}}else y.children.length===0?i={offset:y.offset+1,length:0,content:o}:i={offset:y.offset+1,length:0,content:o+","};return k(w,i,E)}}else if(y.type==="array"&&typeof c=="number"&&Array.isArray(y.children))if(I!==void 0){const h=`${JSON.stringify(I)}`;let o;if(y.children.length===0||c===0)o={offset:y.offset+1,length:0,content:y.children.length===0?h:h+","};else{const u=c===-1||c>y.children.length?y.children.length:c,i=y.children[u-1];o={offset:i.offset+i.length,length:0,content:","+h}}return k(w,o,E)}else{const h=c,o=y.children[h];let u;if(y.children.length===1)u={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===h){const i=y.children[h-1],a=i.offset+i.length,s=y.offset+y.length;u={offset:a,length:s-2-a,content:""}}else u={offset:o.offset,length:y.children[h+1].offset-o.offset,content:""};return k(w,u,E)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${y.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return k(w,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(I)},E)}}e.setProperty=M;function k(w,t,I){let E=n(w,t),S=t.offset,f=t.offset+t.content.length;if(t.length===0||t.content.length===0){for(;S>0&&!(0,R.isEOL)(E,S-1);)S--;for(;f<E.length&&!(0,R.isEOL)(E,f);)f++}const g=(0,R.format)(E,{offset:S,length:f-S},I);for(let y=g.length-1;y>=0;y--){const c=g[y];E=n(E,c),S=Math.min(S,c.offset),f=Math.max(f,c.offset+c.length),f+=c.content.length-c.length}const b=w.length-(E.length-f)-S;return[{offset:S,length:b,content:E.substring(S,f)}]}e.withFormatting=k;function n(w,t){return w.substring(0,t.offset)+t.content+w.substring(t.offset+t.length)}e.applyEdit=n;function d(w,t){let I=t.slice(0).sort((S,f)=>{const g=S.offset-f.offset;return g===0?S.length-f.length:g}),E=w.length;for(let S=I.length-1;S>=0;S--){let f=I[S];if(f.offset+f.length<=E)w=n(w,f);else throw new Error("Overlapping edit");E=f.offset}return w}e.applyEdits=d}),define(Q[58],J([0,1,17]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var R;(function(c){c[c.DependsOnKbLayout=-1]="DependsOnKbLayout",c[c.Unknown=0]="Unknown",c[c.Backspace=1]="Backspace",c[c.Tab=2]="Tab",c[c.Enter=3]="Enter",c[c.Shift=4]="Shift",c[c.Ctrl=5]="Ctrl",c[c.Alt=6]="Alt",c[c.PauseBreak=7]="PauseBreak",c[c.CapsLock=8]="CapsLock",c[c.Escape=9]="Escape",c[c.Space=10]="Space",c[c.PageUp=11]="PageUp",c[c.PageDown=12]="PageDown",c[c.End=13]="End",c[c.Home=14]="Home",c[c.LeftArrow=15]="LeftArrow",c[c.UpArrow=16]="UpArrow",c[c.RightArrow=17]="RightArrow",c[c.DownArrow=18]="DownArrow",c[c.Insert=19]="Insert",c[c.Delete=20]="Delete",c[c.KEY_0=21]="KEY_0",c[c.KEY_1=22]="KEY_1",c[c.KEY_2=23]="KEY_2",c[c.KEY_3=24]="KEY_3",c[c.KEY_4=25]="KEY_4",c[c.KEY_5=26]="KEY_5",c[c.KEY_6=27]="KEY_6",c[c.KEY_7=28]="KEY_7",c[c.KEY_8=29]="KEY_8",c[c.KEY_9=30]="KEY_9",c[c.KEY_A=31]="KEY_A",c[c.KEY_B=32]="KEY_B",c[c.KEY_C=33]="KEY_C",c[c.KEY_D=34]="KEY_D",c[c.KEY_E=35]="KEY_E",c[c.KEY_F=36]="KEY_F",c[c.KEY_G=37]="KEY_G",c[c.KEY_H=38]="KEY_H",c[c.KEY_I=39]="KEY_I",c[c.KEY_J=40]="KEY_J",c[c.KEY_K=41]="KEY_K",c[c.KEY_L=42]="KEY_L",c[c.KEY_M=43]="KEY_M",c[c.KEY_N=44]="KEY_N",c[c.KEY_O=45]="KEY_O",c[c.KEY_P=46]="KEY_P",c[c.KEY_Q=47]="KEY_Q",c[c.KEY_R=48]="KEY_R",c[c.KEY_S=49]="KEY_S",c[c.KEY_T=50]="KEY_T",c[c.KEY_U=51]="KEY_U",c[c.KEY_V=52]="KEY_V",c[c.KEY_W=53]="KEY_W",c[c.KEY_X=54]="KEY_X",c[c.KEY_Y=55]="KEY_Y",c[c.KEY_Z=56]="KEY_Z",c[c.Meta=57]="Meta",c[c.ContextMenu=58]="ContextMenu",c[c.F1=59]="F1",c[c.F2=60]="F2",c[c.F3=61]="F3",c[c.F4=62]="F4",c[c.F5=63]="F5",c[c.F6=64]="F6",c[c.F7=65]="F7",c[c.F8=66]="F8",c[c.F9=67]="F9",c[c.F10=68]="F10",c[c.F11=69]="F11",c[c.F12=70]="F12",c[c.F13=71]="F13",c[c.F14=72]="F14",c[c.F15=73]="F15",c[c.F16=74]="F16",c[c.F17=75]="F17",c[c.F18=76]="F18",c[c.F19=77]="F19",c[c.NumLock=78]="NumLock",c[c.ScrollLock=79]="ScrollLock",c[c.US_SEMICOLON=80]="US_SEMICOLON",c[c.US_EQUAL=81]="US_EQUAL",c[c.US_COMMA=82]="US_COMMA",c[c.US_MINUS=83]="US_MINUS",c[c.US_DOT=84]="US_DOT",c[c.US_SLASH=85]="US_SLASH",c[c.US_BACKTICK=86]="US_BACKTICK",c[c.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",c[c.US_BACKSLASH=88]="US_BACKSLASH",c[c.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",c[c.US_QUOTE=90]="US_QUOTE",c[c.OEM_8=91]="OEM_8",c[c.OEM_102=92]="OEM_102",c[c.NUMPAD_0=93]="NUMPAD_0",c[c.NUMPAD_1=94]="NUMPAD_1",c[c.NUMPAD_2=95]="NUMPAD_2",c[c.NUMPAD_3=96]="NUMPAD_3",c[c.NUMPAD_4=97]="NUMPAD_4",c[c.NUMPAD_5=98]="NUMPAD_5",c[c.NUMPAD_6=99]="NUMPAD_6",c[c.NUMPAD_7=100]="NUMPAD_7",c[c.NUMPAD_8=101]="NUMPAD_8",c[c.NUMPAD_9=102]="NUMPAD_9",c[c.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",c[c.NUMPAD_ADD=104]="NUMPAD_ADD",c[c.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",c[c.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",c[c.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",c[c.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",c[c.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",c[c.ABNT_C1=110]="ABNT_C1",c[c.ABNT_C2=111]="ABNT_C2",c[c.MAX_VALUE=112]="MAX_VALUE"})(R=e.KeyCode||(e.KeyCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,o){this._keyCodeToStr[h]=o,this._strToKeyCode[o.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const M=new D,k=new D,n=new D;(function(){function c(h,o,u=o,i=u){M.define(h,o),k.define(h,u),n.define(h,i)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var d;(function(c){function h(r){return M.keyCodeToStr(r)}c.toString=h;function o(r){return M.strToKeyCode(r)}c.fromString=o;function u(r){return k.keyCodeToStr(r)}c.toUserSettingsUS=u;function i(r){return n.keyCodeToStr(r)}c.toUserSettingsGeneral=i;function a(r){return k.strToKeyCode(r)||n.strToKeyCode(r)}c.fromUserSettings=a;function s(r){if(r>=93&&r<=108)return null;switch(r){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(r)}c.toElectronAccelerator=s})(d=e.KeyCodeUtils||(e.KeyCodeUtils={}));var w;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl",c[c.KeyCode=255]="KeyCode"})(w||(w={}));var t;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl"})(t=e.KeyMod||(e.KeyMod={}));function I(c,h){const o=(h&65535)<<16>>>0;return(c|o)>>>0}e.KeyChord=I;function E(c,h){if(c===0)return null;const o=(c&65535)>>>0,u=(c&4294901760)>>>16;return u!==0?new g([S(o,h),S(u,h)]):new g([S(o,h)])}e.createKeybinding=E;function S(c,h){const o=!!(c&2048),u=!!(c&256),i=h===2?u:o,a=!!(c&1024),s=!!(c&512),r=h===2?o:u,l=c&255;return new f(i,a,s,r,l)}e.createSimpleKeybinding=S;class f{constructor(h,o,u,i,a){this.ctrlKey=h,this.shiftKey=o,this.altKey=u,this.metaKey=i,this.keyCode=a}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",u=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`${h}${o}${u}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=f;class g{constructor(h){if(h.length===0)throw(0,v.illegalArgument)("parts");this.parts=h}getHashCode(){let h="";for(let o=0,u=this.parts.length;o<u;o++)o!==0&&(h+=";"),h+=this.parts[o].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(h.parts[o]))return!1;return!0}}e.ChordKeybinding=g;class b{constructor(h,o,u,i,a,s){this.ctrlKey=h,this.shiftKey=o,this.altKey=u,this.metaKey=i,this.keyLabel=a,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=b;class y{}e.ResolvedKeybinding=y}),define(Q[2],J([0,1,42,67]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let M=null;function k(r){M=r}if(e.setDisposableTracker=k,D){const r="__is_disposable_tracked__";k(new class{trackDisposable(l){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[r]||console.log(m)},3e3)}setParent(l,m){if(l&&l!==c.None)try{l[r]=!0}catch{}}markAsDisposed(l){if(l&&l!==c.None)try{l[r]=!0}catch{}}markAsSingleton(l){}})}function n(r){return M?.trackDisposable(r),r}function d(r){M?.markAsDisposed(r)}function w(r,l){M?.setParent(r,l)}function t(r,l){if(!!M)for(const m of r)M.setParent(m,l)}function I(r){return M?.markAsSingleton(r),r}e.markAsSingleton=I;class E extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=E;function S(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=S;function f(r){if(R.Iterable.is(r)){let l=[];for(const m of r)if(m)try{m.dispose()}catch(p){l.push(p)}if(l.length===1)throw l[0];if(l.length>1)throw new E(l);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=f;function g(...r){const l=b(()=>f(r));return t(r,l),l}e.combinedDisposable=g;function b(r){const l=n({dispose:(0,v.once)(()=>{d(l),r()})});return l}e.toDisposable=b;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return w(l,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new y,n(this),w(this._store,this)}dispose(){d(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&w(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&w(l,null),l}}e.MutableDisposable=h;class o{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class u{constructor(){this.references=new Map}acquire(l,...m){let p=this.references.get(l);p||(p={counter:0,object:this.createReferencedObject(l,...m)},this.references.set(l,p));const{object:P}=p,L=(0,v.once)(()=>{--p.counter==0&&(this.destroyReferencedObject(l,p.object),this.references.delete(l))});return p.counter++,{object:P,dispose:L}}}e.ReferenceCollection=u;class i{constructor(l){this.referenceCollection=l}async acquire(l,...m){const p=this.referenceCollection.acquire(l,...m);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(P){throw p.dispose(),P}}}e.AsyncReferenceCollection=i;class a{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=a;function s(r){const l=new y;try{r(l)}finally{l.dispose()}}e.disposeOnReturn=s}),define(Q[104],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(M){this.element=M,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let M=this._first;for(;M!==v.Undefined;){const k=M.next;M.prev=v.Undefined,M.next=v.Undefined,M=k}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,k){const n=new v(M);if(this._first===v.Undefined)this._first=n,this._last=n;else if(k){const w=this._last;this._last=n,n.prev=w,w.next=n}else{const w=this._first;this._first=n,n.next=w,w.prev=n}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(n))}}shift(){if(this._first!==v.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==v.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==v.Undefined&&M.next!==v.Undefined){const k=M.prev;k.next=M.next,M.next.prev=k}else M.prev===v.Undefined&&M.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):M.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):M.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==v.Undefined;)yield M.element,M=M.next}}e.LinkedList=R}),function(){function V(D){const M=[];typeof D=="number"&&M.push("code/timeOrigin",D);function k(d){M.push(d,Date.now())}function n(){const d=[];for(let w=0;w<M.length;w+=2)d.push({name:M[w],startTime:M[w+1]});return d}return{mark:k,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))M.push({name:k.name,startTime:Math.round(D+k.startTime)});return M}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(Q[3],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let R=!1,D=!1,M=!1,k=!1,n=!1,d=!1,w=!1,t,I=v,E,S;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const g=typeof f?.versions?.electron=="string"&&f.type==="renderer";if(e.isElectronSandboxed=g&&f?.sandboxed,typeof navigator=="object"&&!g)S=navigator.userAgent,R=S.indexOf("Windows")>=0,D=S.indexOf("Macintosh")>=0,w=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=S.indexOf("Linux")>=0,d=!0,t=navigator.language,I=t;else if(typeof f=="object"){R=f.platform==="win32",D=f.platform==="darwin",M=f.platform==="linux",k=M&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,t=v,I=v;const s=f.env.VSCODE_NLS_CONFIG;if(s)try{const r=JSON.parse(s),l=r.availableLanguages["*"];t=r.locale,I=l||v,E=r._translationsConfigFile}catch(r){}n=!0}else console.error("Unable to resolve platform.");var b;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function y(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let c=0;D?c=1:R?c=3:M&&(c=2),e.isWindows=R,e.isMacintosh=D,e.isLinux=M,e.isLinuxSnap=k,e.isNative=n,e.isWeb=d,e.isIOS=w,e.platform=c,e.userAgent=S,e.language=I;var h;(function(s){function r(){return e.language}s.value=r;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=l;function m(){return e.language==="en"}s.isDefault=m})(h=e.Language||(e.Language={})),e.locale=t,e.translationsConfigFile=E,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeSetImmediateId)for(let P=0,L=l.length;P<L;P++){const A=l[P];if(A.id===p.data.vscodeSetImmediateId){l.splice(P,1),A.callback();return}}});let m=0;return p=>{const P=++m;l.push({id:P,callback:p}),e.globals.postMessage({vscodeSetImmediateId:P},"*")}}if(typeof f?.nextTick=="function")return f.nextTick.bind(f);const r=Promise.resolve();return l=>r.then(l)}();var o;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||w?2:R?1:3;let u=!0,i=!1;function a(){if(!i){i=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,u=new Uint16Array(s.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=a}),define(Q[32],J([0,1,3]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const D=v.globals.vscode.process;R={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(M){return(0,v.setImmediate)(M)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,v.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick,e.arch=R.arch}),define(Q[8],J([0,1,32]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,D=97,M=90,k=122,n=46,d=47,w=92,t=58,I=63;class E extends Error{constructor(o,u,i){let a;typeof u=="string"&&u.indexOf("not ")===0?(a="must not be",u=u.replace(/^not /,"")):a="must be";const s=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${s} ${a} of type ${u}`;r+=`. Received type ${typeof i}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function S(h,o){if(typeof h!="string")throw new E(o,"string",h)}function f(h){return h===d||h===w}function g(h){return h===d}function b(h){return h>=R&&h<=M||h>=D&&h<=k}function y(h,o,u,i){let a="",s=0,r=-1,l=0,m=0;for(let p=0;p<=h.length;++p){if(p<h.length)m=h.charCodeAt(p);else{if(i(m))break;m=d}if(i(m)){if(!(r===p-1||l===1))if(l===2){if(a.length<2||s!==2||a.charCodeAt(a.length-1)!==n||a.charCodeAt(a.length-2)!==n){if(a.length>2){const P=a.lastIndexOf(u);P===-1?(a="",s=0):(a=a.slice(0,P),s=a.length-1-a.lastIndexOf(u)),r=p,l=0;continue}else if(a.length!==0){a="",s=0,r=p,l=0;continue}}o&&(a+=a.length>0?`${u}..`:"..",s=2)}else a.length>0?a+=`${u}${h.slice(r+1,p)}`:a=h.slice(r+1,p),s=p-r-1;r=p,l=0}else m===n&&l!==-1?++l:l=-1}return a}function c(h,o){if(o===null||typeof o!="object")throw new E("pathObject","Object",o);const u=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return u?u===o.root?`${u}${i}`:`${u}${h}${i}`:i}e.win32={resolve(...h){let o="",u="",i=!1;for(let a=h.length-1;a>=-1;a--){let s;if(a>=0){if(s=h[a],S(s,"path"),s.length===0)continue}else o.length===0?s=v.cwd():(s=v.env[`=${o}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===w)&&(s=`${o}\\`));const r=s.length;let l=0,m="",p=!1;const P=s.charCodeAt(0);if(r===1)f(P)&&(l=1,p=!0);else if(f(P))if(p=!0,f(s.charCodeAt(1))){let L=2,A=L;for(;L<r&&!f(s.charCodeAt(L));)L++;if(L<r&&L!==A){const W=s.slice(A,L);for(A=L;L<r&&f(s.charCodeAt(L));)L++;if(L<r&&L!==A){for(A=L;L<r&&!f(s.charCodeAt(L));)L++;(L===r||L!==A)&&(m=`\\\\${W}\\${s.slice(A,L)}`,l=L)}}}else l=1;else b(P)&&s.charCodeAt(1)===t&&(m=s.slice(0,2),l=2,r>2&&f(s.charCodeAt(2))&&(p=!0,l=3));if(m.length>0)if(o.length>0){if(m.toLowerCase()!==o.toLowerCase())continue}else o=m;if(i){if(o.length>0)break}else if(u=`${s.slice(l)}\\${u}`,i=p,p&&o.length>0)break}return u=y(u,!i,"\\",f),i?`${o}\\${u}`:`${o}${u}`||"."},normalize(h){S(h,"path");const o=h.length;if(o===0)return".";let u=0,i,a=!1;const s=h.charCodeAt(0);if(o===1)return g(s)?"\\":h;if(f(s))if(a=!0,f(h.charCodeAt(1))){let l=2,m=l;for(;l<o&&!f(h.charCodeAt(l));)l++;if(l<o&&l!==m){const p=h.slice(m,l);for(m=l;l<o&&f(h.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&!f(h.charCodeAt(l));)l++;if(l===o)return`\\\\${p}\\${h.slice(m)}\\`;l!==m&&(i=`\\\\${p}\\${h.slice(m,l)}`,u=l)}}}else u=1;else b(s)&&h.charCodeAt(1)===t&&(i=h.slice(0,2),u=2,o>2&&f(h.charCodeAt(2))&&(a=!0,u=3));let r=u<o?y(h.slice(u),!a,"\\",f):"";return r.length===0&&!a&&(r="."),r.length>0&&f(h.charCodeAt(o-1))&&(r+="\\"),i===void 0?a?`\\${r}`:r:a?`${i}\\${r}`:`${i}${r}`},isAbsolute(h){S(h,"path");const o=h.length;if(o===0)return!1;const u=h.charCodeAt(0);return f(u)||o>2&&b(u)&&h.charCodeAt(1)===t&&f(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let o,u;for(let s=0;s<h.length;++s){const r=h[s];S(r,"path"),r.length>0&&(o===void 0?o=u=r:o+=`\\${r}`)}if(o===void 0)return".";let i=!0,a=0;if(typeof u=="string"&&f(u.charCodeAt(0))){++a;const s=u.length;s>1&&f(u.charCodeAt(1))&&(++a,s>2&&(f(u.charCodeAt(2))?++a:i=!1))}if(i){for(;a<o.length&&f(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.win32.normalize(o)},relative(h,o){if(S(h,"from"),S(o,"to"),h===o)return"";const u=e.win32.resolve(h),i=e.win32.resolve(o);if(u===i||(h=u.toLowerCase(),o=i.toLowerCase(),h===o))return"";let a=0;for(;a<h.length&&h.charCodeAt(a)===w;)a++;let s=h.length;for(;s-1>a&&h.charCodeAt(s-1)===w;)s--;const r=s-a;let l=0;for(;l<o.length&&o.charCodeAt(l)===w;)l++;let m=o.length;for(;m-1>l&&o.charCodeAt(m-1)===w;)m--;const p=m-l,P=r<p?r:p;let L=-1,A=0;for(;A<P;A++){const q=h.charCodeAt(a+A);if(q!==o.charCodeAt(l+A))break;q===w&&(L=A)}if(A!==P){if(L===-1)return i}else{if(p>P){if(o.charCodeAt(l+A)===w)return i.slice(l+A+1);if(A===2)return i.slice(l+A)}r>P&&(h.charCodeAt(a+A)===w?L=A:A===2&&(L=3)),L===-1&&(L=0)}let W="";for(A=a+L+1;A<=s;++A)(A===s||h.charCodeAt(A)===w)&&(W+=W.length===0?"..":"\\..");return l+=L,W.length>0?`${W}${i.slice(l,m)}`:(i.charCodeAt(l)===w&&++l,i.slice(l,m))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const o=e.win32.resolve(h);if(o.length<=2)return h;if(o.charCodeAt(0)===w){if(o.charCodeAt(1)===w){const u=o.charCodeAt(2);if(u!==I&&u!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(b(o.charCodeAt(0))&&o.charCodeAt(1)===t&&o.charCodeAt(2)===w)return`\\\\?\\${o}`;return h},dirname(h){S(h,"path");const o=h.length;if(o===0)return".";let u=-1,i=0;const a=h.charCodeAt(0);if(o===1)return f(a)?h:".";if(f(a)){if(u=i=1,f(h.charCodeAt(1))){let l=2,m=l;for(;l<o&&!f(h.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&f(h.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&!f(h.charCodeAt(l));)l++;if(l===o)return h;l!==m&&(u=i=l+1)}}}}else b(a)&&h.charCodeAt(1)===t&&(u=o>2&&f(h.charCodeAt(2))?3:2,i=u);let s=-1,r=!0;for(let l=o-1;l>=i;--l)if(f(h.charCodeAt(l))){if(!r){s=l;break}}else r=!1;if(s===-1){if(u===-1)return".";s=u}return h.slice(0,s)},basename(h,o){o!==void 0&&S(o,"ext"),S(h,"path");let u=0,i=-1,a=!0,s;if(h.length>=2&&b(h.charCodeAt(0))&&h.charCodeAt(1)===t&&(u=2),o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let r=o.length-1,l=-1;for(s=h.length-1;s>=u;--s){const m=h.charCodeAt(s);if(f(m)){if(!a){u=s+1;break}}else l===-1&&(a=!1,l=s+1),r>=0&&(m===o.charCodeAt(r)?--r==-1&&(i=s):(r=-1,i=l))}return u===i?i=l:i===-1&&(i=h.length),h.slice(u,i)}for(s=h.length-1;s>=u;--s)if(f(h.charCodeAt(s))){if(!a){u=s+1;break}}else i===-1&&(a=!1,i=s+1);return i===-1?"":h.slice(u,i)},extname(h){S(h,"path");let o=0,u=-1,i=0,a=-1,s=!0,r=0;h.length>=2&&h.charCodeAt(1)===t&&b(h.charCodeAt(0))&&(o=i=2);for(let l=h.length-1;l>=o;--l){const m=h.charCodeAt(l);if(f(m)){if(!s){i=l+1;break}continue}a===-1&&(s=!1,a=l+1),m===n?u===-1?u=l:r!==1&&(r=1):u!==-1&&(r=-1)}return u===-1||a===-1||r===0||r===1&&u===a-1&&u===i+1?"":h.slice(u,a)},format:c.bind(null,"\\"),parse(h){S(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const u=h.length;let i=0,a=h.charCodeAt(0);if(u===1)return f(a)?(o.root=o.dir=h,o):(o.base=o.name=h,o);if(f(a)){if(i=1,f(h.charCodeAt(1))){let L=2,A=L;for(;L<u&&!f(h.charCodeAt(L));)L++;if(L<u&&L!==A){for(A=L;L<u&&f(h.charCodeAt(L));)L++;if(L<u&&L!==A){for(A=L;L<u&&!f(h.charCodeAt(L));)L++;L===u?i=L:L!==A&&(i=L+1)}}}}else if(b(a)&&h.charCodeAt(1)===t){if(u<=2)return o.root=o.dir=h,o;if(i=2,f(h.charCodeAt(2))){if(u===3)return o.root=o.dir=h,o;i=3}}i>0&&(o.root=h.slice(0,i));let s=-1,r=i,l=-1,m=!0,p=h.length-1,P=0;for(;p>=i;--p){if(a=h.charCodeAt(p),f(a)){if(!m){r=p+1;break}continue}l===-1&&(m=!1,l=p+1),a===n?s===-1?s=p:P!==1&&(P=1):s!==-1&&(P=-1)}return l!==-1&&(s===-1||P===0||P===1&&s===l-1&&s===r+1?o.base=o.name=h.slice(r,l):(o.name=h.slice(r,s),o.base=h.slice(r,l),o.ext=h.slice(s,l))),r>0&&r!==i?o.dir=h.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let o="",u=!1;for(let i=h.length-1;i>=-1&&!u;i--){const a=i>=0?h[i]:v.cwd();S(a,"path"),a.length!==0&&(o=`${a}/${o}`,u=a.charCodeAt(0)===d)}return o=y(o,!u,"/",g),u?`/${o}`:o.length>0?o:"."},normalize(h){if(S(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===d,u=h.charCodeAt(h.length-1)===d;return h=y(h,!o,"/",g),h.length===0?o?"/":u?"./":".":(u&&(h+="/"),o?`/${h}`:h)},isAbsolute(h){return S(h,"path"),h.length>0&&h.charCodeAt(0)===d},join(...h){if(h.length===0)return".";let o;for(let u=0;u<h.length;++u){const i=h[u];S(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(h,o){if(S(h,"from"),S(o,"to"),h===o||(h=e.posix.resolve(h),o=e.posix.resolve(o),h===o))return"";const u=1,i=h.length,a=i-u,s=1,r=o.length-s,l=a<r?a:r;let m=-1,p=0;for(;p<l;p++){const L=h.charCodeAt(u+p);if(L!==o.charCodeAt(s+p))break;L===d&&(m=p)}if(p===l)if(r>l){if(o.charCodeAt(s+p)===d)return o.slice(s+p+1);if(p===0)return o.slice(s+p)}else a>l&&(h.charCodeAt(u+p)===d?m=p:p===0&&(m=0));let P="";for(p=u+m+1;p<=i;++p)(p===i||h.charCodeAt(p)===d)&&(P+=P.length===0?"..":"/..");return`${P}${o.slice(s+m)}`},toNamespacedPath(h){return h},dirname(h){if(S(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===d;let u=-1,i=!0;for(let a=h.length-1;a>=1;--a)if(h.charCodeAt(a)===d){if(!i){u=a;break}}else i=!1;return u===-1?o?"/":".":o&&u===1?"//":h.slice(0,u)},basename(h,o){o!==void 0&&S(o,"ext"),S(h,"path");let u=0,i=-1,a=!0,s;if(o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let r=o.length-1,l=-1;for(s=h.length-1;s>=0;--s){const m=h.charCodeAt(s);if(m===d){if(!a){u=s+1;break}}else l===-1&&(a=!1,l=s+1),r>=0&&(m===o.charCodeAt(r)?--r==-1&&(i=s):(r=-1,i=l))}return u===i?i=l:i===-1&&(i=h.length),h.slice(u,i)}for(s=h.length-1;s>=0;--s)if(h.charCodeAt(s)===d){if(!a){u=s+1;break}}else i===-1&&(a=!1,i=s+1);return i===-1?"":h.slice(u,i)},extname(h){S(h,"path");let o=-1,u=0,i=-1,a=!0,s=0;for(let r=h.length-1;r>=0;--r){const l=h.charCodeAt(r);if(l===d){if(!a){u=r+1;break}continue}i===-1&&(a=!1,i=r+1),l===n?o===-1?o=r:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||i===-1||s===0||s===1&&o===i-1&&o===u+1?"":h.slice(o,i)},format:c.bind(null,"/"),parse(h){S(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const u=h.charCodeAt(0)===d;let i;u?(o.root="/",i=1):i=0;let a=-1,s=0,r=-1,l=!0,m=h.length-1,p=0;for(;m>=i;--m){const P=h.charCodeAt(m);if(P===d){if(!l){s=m+1;break}continue}r===-1&&(l=!1,r=m+1),P===n?a===-1?a=m:p!==1&&(p=1):a!==-1&&(p=-1)}if(r!==-1){const P=s===0&&u?1:s;a===-1||p===0||p===1&&a===r-1&&a===s+1?o.base=o.name=h.slice(P,r):(o.name=h.slice(P,a),o.base=h.slice(P,r),o.ext=h.slice(a,r))}return s>0?o.dir=h.slice(0,s-1):u&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[81],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var R;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(M,...k){const n=k.reduce((t,I)=>(t[I]=!0,t),{}),d=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(t=>!n[t]).forEach(t=>{for(let I=0;I<d.length;I++)if(t.search(d[I])!==-1){delete M[t];break}})}e.sanitizeProcessEnvironment=D}),define(Q[68],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const R=[],D=Object.create(null),M=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>M[n]||0,toEnum:n=>D[n]||0,toString:n=>R[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class k{constructor(d,w,t,I,E){this.ctrlKey=d,this.shiftKey=w,this.altKey=t,this.metaKey=I,this.scanCode=E}equals(d){return this.ctrlKey===d.ctrlKey&&this.shiftKey===d.shiftKey&&this.altKey===d.altKey&&this.metaKey===d.metaKey&&this.scanCode===d.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=k,function(){function n(d,w){R[d]=w,D[w]=d,M[w.toLowerCase()]=d}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let d=0;d<=193;d++)e.IMMUTABLE_CODE_TO_KEY_CODE[d]=-1;for(let d=0;d<=112;d++)e.IMMUTABLE_KEY_CODE_TO_CODE[d]=-1;function n(d,w){e.IMMUTABLE_CODE_TO_KEY_CODE[d]=w,w!==0&&w!==3&&w!==5&&w!==4&&w!==6&&w!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[w]=d)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Q[105],J([0,1,58,68]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(k){k=k.toLowerCase().trim();let n=!1,d=!1,w=!1,t=!1,I;do I=!1,/^ctrl(\+|\-)/.test(k)&&(n=!0,k=k.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(k)&&(d=!0,k=k.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(k)&&(w=!0,k=k.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(k)&&(t=!0,k=k.substr("meta-".length),I=!0),/^win(\+|\-)/.test(k)&&(t=!0,k=k.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(k)&&(t=!0,k=k.substr("cmd-".length),I=!0);while(I);let E;const S=k.indexOf(" ");return S>0?(E=k.substring(0,S),k=k.substring(S)):(E=k,k=""),{remains:k,ctrl:n,shift:d,alt:w,meta:t,key:E}}static parseSimpleKeybinding(k){const n=this._readModifiers(k),d=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,d),n.remains]}static parseKeybinding(k,n){if(!k)return null;const d=[];let w;do[w,k]=this.parseSimpleKeybinding(k),d.push(w);while(k.length>0);return new v.ChordKeybinding(d)}static parseSimpleUserBinding(k){const n=this._readModifiers(k),d=n.key.match(/^\[([^\]]+)\]$/);if(d){const t=d[1],I=R.ScanCodeUtils.lowerCaseToEnum(t);return[new R.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,I),n.remains]}const w=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseUserBinding(k){if(!k)return[];const n=[];let d;for(;k.length>0;)[d,k]=this.parseSimpleUserBinding(k),n.push(d);return n}}e.KeybindingParser=D}),define(Q[106],J([0,1,3]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class D{constructor(k){this._highResolution=R&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Q[4],J([0,1,17,42,2,104,106]),function(V,e,v,R,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(o){o.None=()=>D.Disposable.None;function u(F){return(H,z=null,B)=>{let U=!1,C;return C=F(Y=>{if(!U)return C?C.dispose():U=!0,H.call(z,Y)},null,B),U&&C.dispose(),C}}o.once=u;function i(F,H){return p((z,B=null,U)=>F(C=>z.call(B,H(C)),null,U))}o.map=i;function a(F,H){return p((z,B=null,U)=>F(C=>{H(C),z.call(B,C)},null,U))}o.forEach=a;function s(F,H){return p((z,B=null,U)=>F(C=>H(C)&&z.call(B,C),null,U))}o.filter=s;function r(F){return F}o.signal=r;function l(...F){return(H,z=null,B)=>(0,D.combinedDisposable)(...F.map(U=>U(C=>H.call(z,C),null,B)))}o.any=l;function m(F,H,z){let B=z;return i(F,U=>(B=H(B,U),B))}o.reduce=m;function p(F){let H;const z=new E({onFirstListenerAdd(){H=F(z.fire,z)},onLastListenerRemove(){H.dispose()}});return z.event}function P(F,H,z=100,B=!1,U){let C,Y,O,T=0;const _=new E({leakWarningThreshold:U,onFirstListenerAdd(){C=F(j=>{T++,Y=H(Y,j),B&&!O&&(_.fire(Y),Y=void 0),clearTimeout(O),O=setTimeout(()=>{const X=Y;Y=void 0,O=void 0,(!B||T>1)&&_.fire(X),T=0},z)})},onLastListenerRemove(){C.dispose()}});return _.event}o.debounce=P;function L(F,H=(z,B)=>z===B){let z=!0,B;return s(F,U=>{const C=z||!H(U,B);return z=!1,B=U,C})}o.latch=L;function A(F,H){return[o.filter(F,H),o.filter(F,z=>!H(z))]}o.split=A;function W(F,H=!1,z=[]){let B=z.slice(),U=F(O=>{B?B.push(O):Y.fire(O)});const C=()=>{B&&B.forEach(O=>Y.fire(O)),B=null},Y=new E({onFirstListenerAdd(){U||(U=F(O=>Y.fire(O)))},onFirstListenerDidAdd(){B&&(H?setTimeout(C):C())},onLastListenerRemove(){U&&U.dispose(),U=null}});return Y.event}o.buffer=W;class q{constructor(H){this.event=H}map(H){return new q(i(this.event,H))}forEach(H){return new q(a(this.event,H))}filter(H){return new q(s(this.event,H))}reduce(H,z){return new q(m(this.event,H,z))}latch(){return new q(L(this.event))}debounce(H,z=100,B=!1,U){return new q(P(this.event,H,z,B,U))}on(H,z,B){return this.event(H,z,B)}once(H,z,B){return u(this.event)(H,z,B)}}function x(F){return new q(F)}o.chain=x;function re(F,H,z=B=>B){const B=(...O)=>Y.fire(z(...O)),U=()=>F.on(H,B),C=()=>F.removeListener(H,B),Y=new E({onFirstListenerAdd:U,onLastListenerRemove:C});return Y.event}o.fromNodeEventEmitter=re;function K(F,H,z=B=>B){const B=(...O)=>Y.fire(z(...O)),U=()=>F.addEventListener(H,B),C=()=>F.removeEventListener(H,B),Y=new E({onFirstListenerAdd:U,onLastListenerRemove:C});return Y.event}o.fromDOMEventEmitter=K;function ee(F){return new Promise(H=>u(F)(H))}o.toPromise=ee})(n=e.Event||(e.Event={}));class d{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${d._idPool++}`}start(u){this._stopWatch=new k.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let w=-1;function t(o){const u=w;return w=o,{dispose(){w=u}}}e.setGlobalLeakWarningThreshold=t;class I{constructor(u,i=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let i=w;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),i<=0||u<i)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(a)||0;if(this._stacks.set(a,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let r,l=0;for(const[m,p]of this._stacks)(!r||l<p)&&(r=m,l=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${l}):`),console.warn(r)}return()=>{const r=this._stacks.get(a)||0;this._stacks.set(a,r-1)}}}class E{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=w>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0}get event(){return this._event||(this._event=(u,i,a)=>{this._listeners||(this._listeners=new M.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(i?[u,i]:u);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,i);const l=this._leakageMon?.check(this._listeners.size),m=(0,D.toDisposable)(()=>{l&&l(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof D.DisposableStore?a.add(m):Array.isArray(a)&&a.push(m),m}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,a]=this._deliveryQueue.shift();try{typeof i=="function"?i.call(void 0,a):i[0].call(i[1],a)}catch(s){(0,v.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=E;class S extends E{async fireAsync(u,i,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,u]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),l=[],m={...r,waitUntil:p=>{if(Object.isFrozen(l))throw new Error("waitUntil can NOT be called asynchronous");a&&(p=a(p,typeof s=="function"?s:s[0])),l.push(p)}};try{typeof s=="function"?s.call(void 0,m):s[0].call(s[1],m)}catch(p){(0,v.onUnexpectedError)(p);continue}Object.freeze(l),await Promise.allSettled(l).then(p=>{for(const P of p)P.status==="rejected"&&(0,v.onUnexpectedError)(P.reason)})}}}}e.AsyncEmitter=S;class f extends E{constructor(u){super(u);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=f;class g extends f{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=g;class b extends E{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]})}}e.MicrotaskEmitter=b;class y{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const i={event:u,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const a=()=>{this.hasListeners&&this.unhook(i);const s=this.events.indexOf(i);this.events.splice(s,1)};return(0,D.toDisposable)((0,R.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(i=>this.emitter.fire(i))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=y;class c{constructor(){this.buffers=[]}wrapEvent(u){return(i,a,s)=>u(r=>{const l=this.buffers[this.buffers.length-1];l?l.push(()=>i.call(a,r)):i.call(a,r)},void 0,s)}bufferEvents(u){const i=[];this.buffers.push(i);const a=u();return this.buffers.pop(),i.forEach(s=>s()),a}}e.EventBufferer=c;class h{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=D.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=h}),define(Q[23],J([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(n,d){const w=setTimeout(n.bind(d),0);return{dispose(){clearTimeout(w)}}});var D;(function(n){function d(w){return w===n.None||w===n.Cancelled||w instanceof M?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}n.isCancellationToken=d,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(D=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=D.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(Q[107],J([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(I){const E=this._icons.get(I.id);E?I.description?E.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new R;e.iconRegistry=D;function M(t,I){return new n(t,I)}e.registerCodicon=M;function k(t){return t?t.replace(/\$\((.*?)\)/g,(I,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=k;class n{constructor(I,E,S){this.id=I,this.definition=E,this.description=S,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function d(t,I){const E=["codicon","codicon-"+t];return I&&E.push("codicon-modifier-"+I),E}e.getClassNamesArray=d;var w;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function E(g){if(g instanceof n)return["codicon","codicon-"+g.id];const b=I.exec(g.id);if(!b)return E(n.error);let[,y,c]=b;const h=["codicon","codicon-"+y];return c&&h.push("codicon-modifier-"+c.substr(1)),h}t.asClassNameArray=E;function S(g){return E(g).join(" ")}t.asClassName=S;function f(g){return"."+E(g).join(".")}t.asCSSSelector=f})(w=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"})}(n=e.Codicon||(e.Codicon={}))}),define(Q[69],J([0,1,17,2]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=D;function M(h){const o=h;return o?D(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=M;function k(h,o){return new n(h,o)}e.newWriteableStream=k;class n{constructor(o,u){this.reducer=o,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(u=>u(o))}emitError(o){this.listeners.error.length===0?(0,v.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(u=>u(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,u){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(o,u){if(this.state.destroyed)return;let i;switch(o){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const a=i.indexOf(u);a>=0&&i.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(h,o){const u=[];let i;for(;(i=h.read())!==null;)u.push(i);return o(u)}e.consumeReadable=d;function w(h,o,u){const i=[];let a;for(;(a=h.read())!==null&&i.length<u;)i.push(a);return a===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof a!="undefined"){const s=a;return a=void 0,s}return h.read()}}}e.peekReadable=w;function t(h,o){return new Promise((u,i)=>{const a=[];I(h,{onData:s=>{o&&a.push(s)},onError:s=>{o?i(s):u(void 0)},onEnd:()=>{u(o?o(a):void 0)}})})}e.consumeStream=t;function I(h,o){h.on("error",u=>o.onError(u)),h.on("end",()=>o.onEnd()),h.on("data",u=>o.onData(u))}e.listenStream=I;function E(h,o){return new Promise((u,i)=>{const a=new R.DisposableStore,s=[],r=p=>{if(s.push(p),s.length>o)return a.dispose(),h.pause(),u({stream:h,buffer:s,ended:!1})},l=p=>i(p),m=()=>u({stream:h,buffer:s,ended:!0});a.add((0,R.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),a.add((0,R.toDisposable)(()=>h.removeListener("end",m))),h.on("end",m),a.add((0,R.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}e.peekStream=E;function S(h,o){const u=k(o);return u.end(h),u}e.toStream=S;function f(){const h=k(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=f;function g(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}e.toReadable=g;function b(h,o,u){const i=k(u);return I(h,{onData:a=>i.write(o.data(a)),onError:a=>i.error(o.error?o.error(a):a),onEnd:()=>i.end()}),i}e.transform=b;function y(h,o,u){let i=!1;return{read:()=>{const a=o.read();return i?a:(i=!0,a!==null?u([h,a]):h)}}}e.prefixedReadable=y;function c(h,o,u){let i=!1;const a=k(u);return I(o,{onData:s=>i?a.write(s):(i=!0,a.write(u([h,s]))),onError:s=>a.error(s),onEnd:()=>{i||(i=!0,a.write(h)),a.end()}}),a}e.prefixedStream=c}),define(Q[18],J([0,1,69]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined";let D,M;class k{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return R?new k(Buffer.allocUnsafe(r)):new k(new Uint8Array(r))}static wrap(r){return R&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new k(r)}static fromString(r,l){return!(l?.dontUseNodeBuffer||!1)&&R?new k(Buffer.from(r)):(D||(D=new TextEncoder),new k(D.encode(r)))}static concat(r,l){if(typeof l=="undefined"){l=0;for(let P=0,L=r.length;P<L;P++)l+=r[P].byteLength}const m=k.alloc(l);let p=0;for(let P=0,L=r.length;P<L;P++){const A=r[P];m.set(A,p),p+=A.byteLength}return m}toString(){return R?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(r,l){return new k(this.buffer.subarray(r,l))}set(r,l){r instanceof k?this.buffer.set(r.buffer,l):this.buffer.set(r,l)}readUInt32BE(r){return w(this.buffer,r)}writeUInt32BE(r,l){t(this.buffer,r,l)}readUInt32LE(r){return I(this.buffer,r)}writeUInt32LE(r,l){E(this.buffer,r,l)}readUInt8(r){return S(this.buffer,r)}writeUInt8(r,l){f(this.buffer,r,l)}}e.VSBuffer=k;function n(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0}e.readUInt16LE=n;function d(s,r,l){s[l+0]=r&255,r=r>>>8,s[l+1]=r&255}e.writeUInt16LE=d;function w(s,r){return s[r]*2**24+s[r+1]*2**16+s[r+2]*2**8+s[r+3]}e.readUInt32BE=w;function t(s,r,l){s[l+3]=r,r=r>>>8,s[l+2]=r,r=r>>>8,s[l+1]=r,r=r>>>8,s[l]=r}e.writeUInt32BE=t;function I(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0|s[r+2]<<16>>>0|s[r+3]<<24>>>0}e.readUInt32LE=I;function E(s,r,l){s[l+0]=r&255,r=r>>>8,s[l+1]=r&255,r=r>>>8,s[l+2]=r&255,r=r>>>8,s[l+3]=r&255}e.writeUInt32LE=E;function S(s,r){return s[r]}e.readUInt8=S;function f(s,r,l){s[l]=r}e.writeUInt8=f;function g(s){return v.consumeReadable(s,r=>k.concat(r))}e.readableToBuffer=g;function b(s){return v.toReadable(s)}e.bufferToReadable=b;function y(s){return v.consumeStream(s,r=>k.concat(r))}e.streamToBuffer=y;async function c(s){return s.ended?k.concat(s.buffer):k.concat([...s.buffer,await y(s.stream)])}e.bufferedStreamToBuffer=c;function h(s){return v.toStream(s,r=>k.concat(r))}e.bufferToStream=h;function o(s){return v.transform(s,{data:r=>typeof r=="string"?k.fromString(r):k.wrap(r)},r=>k.concat(r))}e.streamToBufferReadableStream=o;function u(s){return v.newWriteableStream(r=>k.concat(r),s)}e.newWriteableBufferStream=u;function i(s,r){return v.prefixedReadable(s,r,l=>k.concat(l))}e.prefixedBufferReadable=i;function a(s,r){return v.prefixedStream(s,r,l=>k.concat(l))}e.prefixedBufferStream=a}),define(Q[27],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function v(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function D(G,...se){return se.length===0?G:G.replace(R,function(ce,we){const be=parseInt(we,10);return isNaN(be)||be<0||be>=se.length?ce:se[be]})}e.format=D;const M=/{([^}]+)}/g;function k(G,se){return G.replace(M,(ce,we)=>se[we]??ce)}e.format2=k;function n(G){return G.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=n;function d(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=d;function w(G,se){let ce=0;const we=se.charCodeAt(0);for(let be=G.length-1;be>=0;be--)G.charCodeAt(be)===we&&ce++;return ce}e.count=w;function t(G,se,ce="\u2026"){return G.length<=se?G:`${G.substr(0,se)}${ce}`}e.truncate=t;function I(G,se=" "){const ce=E(G,se);return S(ce,se)}e.trim=I;function E(G,se){if(!G||!se)return G;const ce=se.length;if(ce===0||G.length===0)return G;let we=0;for(;G.indexOf(se,we)===we;)we=we+ce;return G.substring(we)}e.ltrim=E;function S(G,se){if(!G||!se)return G;const ce=se.length,we=G.length;if(ce===0||we===0)return G;let be=we,Le=-1;for(;Le=G.lastIndexOf(se,be-1),!(Le===-1||Le+ce!==be);){if(Le===0)return"";be=Le}return G.substring(0,be)}e.rtrim=S;function f(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function g(G){return G.replace(/\*/g,"")}e.stripWildcards=g;function b(G,se,ce={}){if(!G)throw new Error("Cannot create regex from empty string");se||(G=d(G)),ce.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let we="";return ce.global&&(we+="g"),ce.matchCase||(we+="i"),ce.multiline&&(we+="m"),ce.unicode&&(we+="u"),new RegExp(G,we)}e.createRegExp=b;function y(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function h(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=h;function o(G){return G.split(/\r\n|\r|\n/)}e.splitLines=o;function u(G){for(let se=0,ce=G.length;se<ce;se++){const we=G.charCodeAt(se);if(we!==32&&we!==9)return se}return-1}e.firstNonWhitespaceIndex=u;function i(G,se=0,ce=G.length){for(let we=se;we<ce;we++){const be=G.charCodeAt(we);if(be!==32&&be!==9)return G.substring(se,we)}return G.substring(se,ce)}e.getLeadingWhitespace=i;function a(G,se=G.length-1){for(let ce=se;ce>=0;ce--){const we=G.charCodeAt(ce);if(we!==32&&we!==9)return ce}return-1}e.lastNonWhitespaceIndex=a;function s(G,se){return G<se?-1:G>se?1:0}e.compare=s;function r(G,se,ce=0,we=G.length,be=0,Le=se.length){for(;ce<we&&be<Le;ce++,be++){let Ne=G.charCodeAt(ce),Be=se.charCodeAt(be);if(Ne<Be)return-1;if(Ne>Be)return 1}const Ce=we-ce,Fe=Le-be;return Ce<Fe?-1:Ce>Fe?1:0}e.compareSubstring=r;function l(G,se){return m(G,se,0,G.length,0,se.length)}e.compareIgnoreCase=l;function m(G,se,ce=0,we=G.length,be=0,Le=se.length){for(;ce<we&&be<Le;ce++,be++){let Ne=G.charCodeAt(ce),Be=se.charCodeAt(be);if(Ne===Be)continue;if(Ne>=128||Be>=128)return r(G.toLowerCase(),se.toLowerCase(),ce,we,be,Le);p(Ne)&&(Ne-=32),p(Be)&&(Be-=32);const ze=Ne-Be;if(ze!==0)return ze}const Ce=we-ce,Fe=Le-be;return Ce<Fe?-1:Ce>Fe?1:0}e.compareSubstringIgnoreCase=m;function p(G){return G>=97&&G<=122}e.isLowerAsciiLetter=p;function P(G){return G>=65&&G<=90}e.isUpperAsciiLetter=P;function L(G,se){return G.length===se.length&&m(G,se)===0}e.equalsIgnoreCase=L;function A(G,se){const ce=se.length;return se.length>G.length?!1:m(G,se,0,ce)===0}e.startsWithIgnoreCase=A;function W(G,se){let ce,we=Math.min(G.length,se.length);for(ce=0;ce<we;ce++)if(G.charCodeAt(ce)!==se.charCodeAt(ce))return ce;return we}e.commonPrefixLength=W;function q(G,se){let ce,we=Math.min(G.length,se.length);const be=G.length-1,Le=se.length-1;for(ce=0;ce<we;ce++)if(G.charCodeAt(be-ce)!==se.charCodeAt(Le-ce))return ce;return we}e.commonSuffixLength=q;function x(G){return 55296<=G&&G<=56319}e.isHighSurrogate=x;function re(G){return 56320<=G&&G<=57343}e.isLowSurrogate=re;function K(G,se){return(G-55296<<10)+(se-56320)+65536}e.computeCodePoint=K;function ee(G,se,ce){const we=G.charCodeAt(ce);if(x(we)&&ce+1<se){const be=G.charCodeAt(ce+1);if(re(be))return K(we,be)}return we}e.getNextCodePoint=ee;function F(G,se){const ce=G.charCodeAt(se-1);if(re(ce)&&se>1){const we=G.charCodeAt(se-2);if(x(we))return K(we,ce)}return ce}function H(G,se){const ce=Oe.getInstance(),we=se,be=G.length,Le=ee(G,be,se);se+=Le>=65536?2:1;let Ce=ce.getGraphemeBreakType(Le);for(;se<be;){const Fe=ee(G,be,se),Ne=ce.getGraphemeBreakType(Fe);if(Ae(Ce,Ne))break;se+=Fe>=65536?2:1,Ce=Ne}return se-we}e.nextCharLength=H;function z(G,se){const ce=Oe.getInstance(),we=se,be=F(G,se);se-=be>=65536?2:1;let Le=ce.getGraphemeBreakType(be);for(;se>0;){const Ce=F(G,se),Fe=ce.getGraphemeBreakType(Ce);if(Ae(Fe,Le))break;se-=Ce>=65536?2:1,Le=Fe}return we-se}e.prevCharLength=z;function B(G,se){const ce=Oe.getInstance(),we=G.length,be=se,Le=ee(G,we,se),Ce=ce.getGraphemeBreakType(Le);se+=Le>=65536?2:1;let Fe=Ce;for(;se<we;){const Be=ee(G,we,se),ze=ce.getGraphemeBreakType(Be);if(Ae(Fe,ze))break;se+=Be>=65536?2:1,Fe=ze}const Ne=se;for(se=be,Fe=Ce;se>0;){const Be=F(G,se),ze=ce.getGraphemeBreakType(Be);if(Ae(ze,Fe))break;se-=Be>=65536?2:1,Fe=ze}return[se,Ne]}function U(G,se){return se>0&&re(G.charCodeAt(se))?B(G,se-1):B(G,se)}e.getCharContainingOffset=U;const C=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(G){return C.test(G)}e.containsRTL=Y;const O=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function T(G){return O.test(G)}e.containsEmoji=T;const _=/^[\t\n\r\x20-\x7E]*$/;function j(G){return _.test(G)}e.isBasicASCII=j,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=X;function $(G){for(let se=0,ce=G.length;se<ce;se++)if(N(G.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=$;function N(G){return G=+G,G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=N;function Z(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129003||G>=129280&&G<=129535||G>=129648&&G<=129750}e.isEmojiImprecise=Z;function ie(G,se){if(G.length<se)return G;const ce=/\b/g;let we=0;for(;ce.test(G)&&!(G.length-ce.lastIndex<se);)we=ce.lastIndex,ce.lastIndex+=1;return G.substring(we).replace(/^\s/,"")}e.lcut=ie;const oe=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,ne=/\x1b\[0?m/g;function ae(G){return G&&(G=G.replace(oe,""),G=G.replace(le,""),G=G.replace(ne,"")),G}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function de(G){return ue(G)?G.substr(1):G}e.stripUTF8BOM=de;function ve(G,se){if(!G||!se||G.length<se.length)return!1;const ce=se.length,we=G.toLowerCase();let be=0,Le=-1;for(;be<ce;){const Ce=we.indexOf(se[be],Le+1);if(Ce<0)return!1;Le=Ce,be++}return!0}e.fuzzyContains=ve;function Ie(G,se=!1){return G?(se&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Ie;function me(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=me;function ge(G,se=1){if(se===0)return"";let ce=-1;do ce=G.indexOf(`
`,ce+1),se--;while(se>0&&ce>=0);return ce===-1?G:(G[ce-1]==="\r"&&ce--,G.substr(0,ce))}e.getNLines=ge;function Ee(G){const se=90-65+1;return G=G%(2*se),G<se?String.fromCharCode(97+G):String.fromCharCode(65+G-se)}e.singleLetterHash=Ee;function ke(G){return Oe.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=ke;function Ae(G,se){return G===0?se!==5&&se!==7:G===2&&se===3?!1:G===4||G===2||G===3||se===4||se===2||se===3?!0:!(G===8&&(se===8||se===9||se===11||se===12)||(G===11||G===9)&&(se===9||se===10)||(G===12||G===10)&&se===10||se===5||se===13||se===7||G===1||G===13&&se===14||G===6&&se===6)}e.breakBetweenGraphemeBreakType=Ae;var We;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(We=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=Ye()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ce=this._data,we=ce.length/3;let be=1;for(;be<=we;)if(se<ce[3*be])be=2*be;else if(se>ce[3*be+1])be=2*be+1;else return ce[3*be+2];return 0}}Oe._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Xe(G,se){if(G===0)return 0;const ce=ct(G,se);if(ce!==void 0)return ce;const we=F(se,G);return G-=Ke(we),G}e.getLeftDeleteOffset=Xe;function ct(G,se){let ce=F(se,G);for(G-=Ke(ce);xe(ce)||ce===65039||ce===8419;){if(G===0)return;ce=F(se,G),G-=Ke(ce)}if(!!Z(ce)){if(G>=0){const we=F(se,G);we===8205&&(G-=Ke(we))}return G}}function Ke(G){return G>=65536?2:1}function xe(G){return 127995<=G&&G<=127999}var et;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={}))}),define(Q[82],J([0,1,27]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(y){return D(y,0)}e.hash=R;function D(y,c){switch(typeof y){case"object":return y===null?M(349,c):Array.isArray(y)?d(y,c):w(y,c);case"string":return n(y,c);case"boolean":return k(y,c);case"number":return M(y,c);case"undefined":return M(937,c);default:return M(617,c)}}e.doHash=D;function M(y,c){return(c<<5)-c+y|0}e.numberHash=M;function k(y,c){return M(y?433:863,c)}function n(y,c){c=M(149417,c);for(let h=0,o=y.length;h<o;h++)c=M(y.charCodeAt(h),c);return c}e.stringHash=n;function d(y,c){return c=M(104579,c),y.reduce((h,o)=>D(o,h),c)}function w(y,c){return c=M(181387,c),Object.keys(y).sort().reduce((h,o)=>(h=n(o,h),D(y[o],h)),c)}class t{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=D(c,this._value),this._value}}e.Hasher=t;var I;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function E(y,c,h=32){const o=h-c,u=~((1<<o)-1);return(y<<c|(u&y)>>>o)>>>0}function S(y,c=0,h=y.byteLength,o=0){for(let u=0;u<h;u++)y[c+u]=o}function f(y,c,h="0"){for(;y.length<c;)y=h+y;return y}function g(y,c=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(h=>h.toString(16).padStart(2,"0")).join(""):f((y>>>0).toString(16),c/4)}e.toHexString=g;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const h=c.length;if(h===0)return;const o=this._buff;let u=this._buffLen,i=this._leftoverHighSurrogate,a,s;for(i!==0?(a=i,s=-1,i=0):(a=c.charCodeAt(0),s=0);;){let r=a;if(v.isHighSurrogate(a))if(s+1<h){const l=c.charCodeAt(s+1);v.isLowSurrogate(l)?(s++,r=v.computeCodePoint(a,l)):r=65533}else{i=a;break}else v.isLowSurrogate(a)&&(r=65533);if(u=this._push(o,u,r),s++,s<h)a=c.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=i}_push(c,h,o){return o<128?c[h++]=o:o<2048?(c[h++]=192|(o&1984)>>>6,c[h++]=128|(o&63)>>>0):o<65536?(c[h++]=224|(o&61440)>>>12,c[h++]=128|(o&4032)>>>6,c[h++]=128|(o&63)>>>0):(c[h++]=240|(o&1835008)>>>18,c[h++]=128|(o&258048)>>>12,c[h++]=128|(o&4032)>>>6,c[h++]=128|(o&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=b._bigBlock32,h=this._buffDV;for(let p=0;p<64;p+=4)c.setUint32(p,h.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)c.setUint32(p,E(c.getUint32(p-12,!1)^c.getUint32(p-32,!1)^c.getUint32(p-56,!1)^c.getUint32(p-64,!1),1),!1);let o=this._h0,u=this._h1,i=this._h2,a=this._h3,s=this._h4,r,l,m;for(let p=0;p<80;p++)p<20?(r=u&i|~u&a,l=1518500249):p<40?(r=u^i^a,l=1859775393):p<60?(r=u&i|u&a|i&a,l=2400959708):(r=u^i^a,l=3395469782),m=E(o,5)+r+s+l+c.getUint32(p*4,!1)&4294967295,s=a,a=i,i=E(u,30),u=o,o=m;this._h0=this._h0+o&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[13],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(P){return Array.isArray(P)}e.isArray=v;function R(P){return typeof P=="string"}e.isString=R;function D(P){return Array.isArray(P)&&P.every(L=>R(L))}e.isStringArray=D;function M(P){return typeof P=="object"&&P!==null&&!Array.isArray(P)&&!(P instanceof RegExp)&&!(P instanceof Date)}e.isObject=M;function k(P){return typeof P=="number"&&!isNaN(P)}e.isNumber=k;function n(P){return!!P&&typeof P[Symbol.iterator]=="function"}e.isIterable=n;function d(P){return P===!0||P===!1}e.isBoolean=d;function w(P){return typeof P=="undefined"}e.isUndefined=w;function t(P){return!I(P)}e.isDefined=t;function I(P){return w(P)||P===null}e.isUndefinedOrNull=I;function E(P,L){if(!P)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}e.assertType=E;function S(P){if(I(P))throw new Error("Assertion Failed: argument is undefined or null");return P}e.assertIsDefined=S;function f(...P){const L=[];for(let A=0;A<P.length;A++){const W=P[A];if(I(W))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);L.push(W)}return L}e.assertAllDefined=f;const g=Object.prototype.hasOwnProperty;function b(P){if(!M(P))return!1;for(let L in P)if(g.call(P,L))return!1;return!0}e.isEmptyObject=b;function y(P){return typeof P=="function"}e.isFunction=y;function c(...P){return P.length>0&&P.every(y)}e.areFunctions=c;function h(P,L){const A=Math.min(P.length,L.length);for(let W=0;W<A;W++)o(P[W],L[W])}e.validateConstraints=h;function o(P,L){if(R(L)){if(typeof P!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(y(L)){try{if(P instanceof L)return}catch{}if(!I(P)&&P.constructor===L||L.length===1&&L.call(void 0,P)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function u(P){let L=[],A=Object.getPrototypeOf(P);for(;Object.prototype!==A;)L=L.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return L}e.getAllPropertyNames=u;function i(P){const L=[];for(const A of u(P))typeof P[A]=="function"&&L.push(A);return L}e.getAllMethodNames=i;function a(P,L){const A=q=>function(){const x=Array.prototype.slice.call(arguments,0);return L(q,x)};let W={};for(const q of P)W[q]=A(q);return W}e.createProxyObject=a;function s(P){return P===null?void 0:P}e.withNullAsUndefined=s;function r(P){return typeof P=="undefined"?null:P}e.withUndefinedAsNull=r;function l(P){return class{constructor(){return new Proxy({},{get(L,A){if(L[A])return L[A];throw new Error(`Not Implemented: ${P}->${String(A)}`)}})}}}e.NotImplementedProxy=l;function m(P,L="Unreachable"){throw new Error(L)}e.assertNever=m;function p(P){return!!P&&typeof P.then=="function"&&typeof P.catch=="function"}e.isPromise=p}),define(Q[33],J([0,1,8,3,27,13]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function n(s){return s.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=n;function d(s){return s.indexOf("/")===-1&&(s=n(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=d;function w(s,r=v.posix.sep){if(!s)return"";const l=s.length,m=s.charCodeAt(0);if(k(m)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let P=3;const L=P;for(;P<l&&!k(s.charCodeAt(P));P++);if(L!==P&&!k(s.charCodeAt(P+1))){for(P+=1;P<l;P++)if(k(s.charCodeAt(P)))return s.slice(0,P+1).replace(/[\\/]/g,r)}}return r}else if(y(m)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<l;p++)if(k(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=w;function t(s){if(!R.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let l=2;const m=l;for(;l<s.length&&(r=s.charCodeAt(l),r!==92);l++);return!(m===l||(r=s.charCodeAt(l+1),isNaN(r)||r===92))}e.isUNC=t;const I=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,r=R.isWindows){const l=r?I:E;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||r&&S.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function g(s,r,l){const m=s===r;return!l||m?m:!s||!r?!1:(0,D.equalsIgnoreCase)(s,r)}e.isEqual=g;function b(s,r,l,m=v.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(l){if(!(0,D.startsWithIgnoreCase)(s,r))return!1;if(r.length===s.length)return!0;let P=r.length;return r.charAt(r.length-1)===m&&P--,s.charAt(P)===m}return r.charAt(r.length-1)!==m&&(r+=m),s.indexOf(r)===0}e.isEqualOrParent=b;function y(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=y;function c(s,r){return R.isWindows&&s.endsWith(":")&&(s+=v.sep),(0,v.isAbsolute)(s)||(s=(0,v.join)(r,s)),s=(0,v.normalize)(s),R.isWindows?(s=(0,D.rtrim)(s,v.sep),s.endsWith(":")&&(s+=v.sep)):(s=(0,D.rtrim)(s,v.sep),s||(s=v.sep)),s}e.sanitizeFilePath=c;function h(s){const r=(0,v.normalize)(s);return R.isWindows?s.length>3?!1:o(r)&&(s.length===2||r.charCodeAt(2)===92):r===v.posix.sep}e.isRootOrDriveLetter=h;function o(s){return R.isWindows?y(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function u(s){return o(s)?s[0]:void 0}e.getDriveLetter=u;function i(s,r,l){return r.length>s.length?-1:s===r?0:(l&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=i;function a(s){const r=s.split(":");let l,m,p;if(r.forEach(P=>{const L=Number(P);(0,M.isNumber)(L)?m===void 0?m=L:p===void 0&&(p=L):l=l?[l,P].join(":"):P}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:m!==void 0?m:void 0,column:p!==void 0?p:m!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(Q[43],J([0,1,13]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const b=Array.isArray(g)?[]:{};return Object.keys(g).forEach(y=>{g[y]&&typeof g[y]=="object"?b[y]=R(g[y]):b[y]=g[y]}),b}e.deepClone=R;function D(g){if(!g||typeof g!="object")return g;const b=[g];for(;b.length>0;){const y=b.shift();Object.freeze(y);for(const c in y)if(M.call(y,c)){const h=y[c];typeof h=="object"&&!Object.isFrozen(h)&&b.push(h)}}return g}e.deepFreeze=D;const M=Object.prototype.hasOwnProperty;function k(g,b){return n(g,b,new Set)}e.cloneAndChange=k;function n(g,b,y){if((0,v.isUndefinedOrNull)(g))return g;const c=b(g);if(typeof c!="undefined")return c;if((0,v.isArray)(g)){const h=[];for(const o of g)h.push(n(o,b,y));return h}if((0,v.isObject)(g)){if(y.has(g))throw new Error("Cannot clone recursive data-structure");y.add(g);const h={};for(let o in g)M.call(g,o)&&(h[o]=n(g[o],b,y));return y.delete(g),h}return g}function d(g,b,y=!0){return(0,v.isObject)(g)?((0,v.isObject)(b)&&Object.keys(b).forEach(c=>{c in g?y&&((0,v.isObject)(g[c])&&(0,v.isObject)(b[c])?d(g[c],b[c],y):g[c]=b[c]):g[c]=b[c]}),g):b}e.mixin=d;function w(g,b){if(g===b)return!0;if(g==null||b===null||b===void 0||typeof g!=typeof b||typeof g!="object"||Array.isArray(g)!==Array.isArray(b))return!1;let y,c;if(Array.isArray(g)){if(g.length!==b.length)return!1;for(y=0;y<g.length;y++)if(!w(g[y],b[y]))return!1}else{const h=[];for(c in g)h.push(c);h.sort();const o=[];for(c in b)o.push(c);if(o.sort(),!w(h,o))return!1;for(y=0;y<h.length;y++)if(!w(g[h[y]],b[h[y]]))return!1}return!0}e.equals=w;function t(g){const b=new Set;return JSON.stringify(g,(y,c)=>{if((0,v.isObject)(c)||Array.isArray(c)){if(b.has(c))return"[Circular]";b.add(c)}return c})}e.safeStringify=t;function I(g,b,y){const c=b(g);return typeof c=="undefined"?y:c}e.getOrDefault=I;function E(g,b){const y=Object.create(null);return!g||!b||Object.keys(b).forEach(h=>{const o=g[h],u=b[h];w(o,u)||(y[h]=u)}),y}e.distinct=E;function S(g,b){const y=b.toLowerCase(),c=Object.keys(g).find(h=>h.toLowerCase()===y);return c?g[c]:g[b]}e.getCaseInsensitive=S;function f(g,b){const y=Object.create(null);for(const c of Object.keys(g))b(c,g[c])&&(y[c]=g[c]);return y}e.filter=f}),define(Q[7],J([0,1,8,3]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,M=/^\//,k=/^\/\//;function n(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!M.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(s,r){return!s&&!r?"file":s}function w(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const t="",I="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(r,l,m,p,P,L=!1){typeof r=="object"?(this.scheme=r.scheme||t,this.authority=r.authority||t,this.path=r.path||t,this.query=r.query||t,this.fragment=r.fragment||t):(this.scheme=d(r,L),this.authority=l||t,this.path=w(this.scheme,m||t),this.query=p||t,this.fragment=P||t,n(this,L))}static isUri(r){return r instanceof S?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return h(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:m,path:p,query:P,fragment:L}=r;return l===void 0?l=this.scheme:l===null&&(l=t),m===void 0?m=this.authority:m===null&&(m=t),p===void 0?p=this.path:p===null&&(p=t),P===void 0?P=this.query:P===null&&(P=t),L===void 0?L=this.fragment:L===null&&(L=t),l===this.scheme&&m===this.authority&&p===this.path&&P===this.query&&L===this.fragment?this:new g(l,m,p,P,L)}static parse(r,l=!1){const m=E.exec(r);return m?new g(m[2]||t,a(m[4]||t),a(m[5]||t),a(m[7]||t),a(m[9]||t),l):new g(t,t,t,t,t)}static file(r){let l=t;if(R.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const m=r.indexOf(I,2);m===-1?(l=r.substring(2),r=I):(l=r.substring(2,m),r=r.substring(m)||I)}return new g("file",l,r,t,t)}static from(r){const l=new g(r.scheme,r.authority,r.path,r.query,r.fragment);return n(l,!0),l}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return R.isWindows&&r.scheme==="file"?m=S.file(v.win32.join(h(r,!0),...l)).path:m=v.posix.join(r.path,...l),r.with({path:m})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof S)return r;{const l=new g(r);return l._formatted=r.external,l._fsPath=r._sep===f?r.fsPath:null,l}}else return r}}e.URI=S;const f=R.isWindows?1:void 0;class g extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=f),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(s,r){let l,m=-1;for(let p=0;p<s.length;p++){const P=s.charCodeAt(p);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||r&&P===47)m!==-1&&(l+=encodeURIComponent(s.substring(m,p)),m=-1),l!==void 0&&(l+=s.charAt(p));else{l===void 0&&(l=s.substr(0,p));const L=b[P];L!==void 0?(m!==-1&&(l+=encodeURIComponent(s.substring(m,p)),m=-1),l+=L):m===-1&&(m=p)}}return m!==-1&&(l+=encodeURIComponent(s.substring(m))),l!==void 0?l:s}function c(s){let r;for(let l=0;l<s.length;l++){const m=s.charCodeAt(l);m===35||m===63?(r===void 0&&(r=s.substr(0,l)),r+=b[m]):r!==void 0&&(r+=s[l])}return r!==void 0?r:s}function h(s,r){let l;return s.authority&&s.path.length>1&&s.scheme==="file"?l=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?l=s.path.substr(1):l=s.path[1].toLowerCase()+s.path.substr(2):l=s.path,R.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=h;function o(s,r){const l=r?c:y;let m="",{scheme:p,authority:P,path:L,query:A,fragment:W}=s;if(p&&(m+=p,m+=":"),(P||p==="file")&&(m+=I,m+=I),P){let q=P.indexOf("@");if(q!==-1){const x=P.substr(0,q);P=P.substr(q+1),q=x.indexOf(":"),q===-1?m+=l(x,!1):(m+=l(x.substr(0,q),!1),m+=":",m+=l(x.substr(q+1),!1)),m+="@"}P=P.toLowerCase(),q=P.indexOf(":"),q===-1?m+=l(P,!1):(m+=l(P.substr(0,q),!1),m+=P.substr(q))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const q=L.charCodeAt(1);q>=65&&q<=90&&(L=`/${String.fromCharCode(q+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const q=L.charCodeAt(0);q>=65&&q<=90&&(L=`${String.fromCharCode(q+32)}:${L.substr(2)}`)}m+=l(L,!0)}return A&&(m+="?",m+=l(A,!1)),W&&(m+="#",m+=r?W:y(W,!1)),m}function u(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+u(s.substr(3)):s}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(s){return s.match(i)?s.replace(i,r=>u(r)):s}}),define(Q[108],J([0,1,7]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(w){const t=w;return t&&typeof t.type=="string"&&typeof t.severity=="string"}e.isRemoteConsoleLog=R;function D(w){const t=[];let I;try{const E=JSON.parse(w.arguments),S=E[E.length-1];S&&S.__$stack&&(E.pop(),I=S.__$stack),t.push(...E)}catch(E){t.push("Unable to log remote console arguments",w.arguments)}return{args:t,stack:I}}e.parse=D;function M(w){if(typeof w!="string")return M(D(w).stack);const t=w;if(t){const I=k(t),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(E&&E.length===4)return{uri:v.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=M;function k(w){if(!w)return w;const t=w.indexOf(`
`);return t===-1?w:w.substring(0,t)}function n(w,t){const{args:I,stack:E}=D(w),S=typeof I[0]=="string"&&I.length===1;let f=k(E);f&&(f=`(${f.trim()})`);let g=[];if(typeof I[0]=="string"?f&&S?g=[`%c[${t}] %c${I[0]} %c${f}`,d("blue"),d(""),d("grey")]:g=[`%c[${t}] %c${I[0]}`,d("blue"),d(""),...I.slice(1)]:g=[`%c[${t}]%`,d("blue"),...I],f&&!S&&g.push(f),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,g)}e.log=n;function d(w){return`color: ${w}`}});var bt=this&&this.__classPrivateFieldSet||function(V,e,v,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!D:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(V,v):D?D.value=v:e.set(V,v),v},je=this&&this.__classPrivateFieldGet||function(V,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!R:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(V):R?R.value:e.get(V)};define(Q[40],J([0,1,30,27,7]),function(V,e,v,R,D){"use strict";var M,k,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function d(s,r,l){let m=s.get(r);return m===void 0&&(m=l,s.set(r,m)),m}e.getOrSet=d;function w(s){const r=[];return s.forEach((l,m)=>{r.push(`${m} => ${l}`)}),`Map(${s.size}) {${r.join(", ")}}`}e.mapToString=w;function t(s){const r=[];return s.forEach(l=>{r.push(l)}),`Set(${s.size}) {${r.join(", ")}}`}e.setToString=t;class I{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const l=r.charCodeAt(0),m=this._value.charCodeAt(this._pos);return l-m}value(){return this._value[this._pos]}}e.StringIterator=I;class E{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class S{constructor(r=!0,l=!0){this._splitOnBackslash=r,this._caseSensitive=l}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var f;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(f||(f={}));class g{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,R.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(y||(y={}));class c{constructor(r){this._iter=r}static forUris(r=()=>!1){return new c(new g(r))}static forPaths(){return new c(new S)}static forStrings(){return new c(new I)}static forConfigKeys(){return new c(new E)}clear(){this._root=void 0}fill(r,l){if(l){const m=l.slice(0);(0,v.shuffle)(m);for(let p of m)this.set(p,r)}else{const m=r.slice(0);(0,v.shuffle)(m);for(let p of m)this.set(p[0],p[1])}}set(r,l){const m=this._iter.reset(r);let p;this._root||(this._root=new b,this._root.segment=m.value());const P=[];for(p=this._root;;){const A=m.cmp(p.segment);if(A>0)p.left||(p.left=new b,p.left.segment=m.value()),P.push([-1,p]),p=p.left;else if(A<0)p.right||(p.right=new b,p.right.segment=m.value()),P.push([1,p]),p=p.right;else if(m.hasNext())m.next(),p.mid||(p.mid=new b,p.mid.segment=m.value()),P.push([0,p]),p=p.mid;else break}const L=p.value;p.value=l,p.key=r;for(let A=P.length-1;A>=0;A--){const W=P[A][1];W.updateHeight();const q=W.balanceFactor();if(q<-1||q>1){const x=P[A][0],re=P[A+1][0];if(x===1&&re===1)P[A][1]=W.rotateLeft();else if(x===-1&&re===-1)P[A][1]=W.rotateRight();else if(x===1&&re===-1)W.right=P[A+1][1]=P[A+1][1].rotateRight(),P[A][1]=W.rotateLeft();else if(x===-1&&re===1)W.left=P[A+1][1]=P[A+1][1].rotateLeft(),P[A][1]=W.rotateRight();else throw new Error;if(A>0)switch(P[A-1][0]){case-1:P[A-1][1].left=P[A][1];break;case 1:P[A-1][1].right=P[A][1];break;case 0:P[A-1][1].mid=P[A][1];break}else this._root=P[0][1]}}return L}get(r){return this._getNode(r)?.value}_getNode(r){const l=this._iter.reset(r);let m=this._root;for(;m;){const p=l.cmp(m.segment);if(p>0)m=m.left;else if(p<0)m=m.right;else if(l.hasNext())l.next(),m=m.mid;else break}return m}has(r){const l=this._getNode(r);return!(l?.value===void 0&&l?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,l){const m=this._iter.reset(r),p=[];let P=this._root;for(;P;){const L=m.cmp(P.segment);if(L>0)p.push([-1,P]),P=P.left;else if(L<0)p.push([1,P]),P=P.right;else if(m.hasNext())m.next(),p.push([0,P]),P=P.mid;else break}if(!!P){if(l?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const L=this._min(P.right),{key:A,value:W,segment:q}=L;this._delete(L.key,!1),P.key=A,P.value=W,P.segment=q}else{const L=P.left??P.right;if(p.length>0){const[A,W]=p[p.length-1];switch(A){case-1:W.left=L;break;case 0:W.mid=L;break;case 1:W.right=L;break}}else this._root=L}for(let L=p.length-1;L>=0;L--){const A=p[L][1];A.updateHeight();const W=A.balanceFactor();if(W>1?(A.right.balanceFactor()>=0||(A.right=p[L+1][1]=p[L+1][1].rotateRight()),p[L][1]=A.rotateLeft()):W<-1&&(A.left.balanceFactor()<=0||(A.left=p[L+1][1]=p[L+1][1].rotateLeft()),p[L][1]=A.rotateRight()),L>0)switch(p[L-1][0]){case-1:p[L-1][1].left=p[L][1];break;case 1:p[L-1][1].right=p[L][1];break;case 0:p[L-1][1].mid=p[L][1];break}else this._root=p[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const l=this._iter.reset(r);let m=this._root,p;for(;m;){const P=l.cmp(m.segment);if(P>0)m=m.left;else if(P<0)m=m.right;else if(l.hasNext())l.next(),p=m.value||p,m=m.mid;else break}return m&&m.value||p}findSuperstr(r){const l=this._iter.reset(r);let m=this._root;for(;m;){const p=l.cmp(m.segment);if(p>0)m=m.left;else if(p<0)m=m.right;else if(l.hasNext())l.next(),m=m.mid;else return m.mid?this._entries(m.mid):void 0}}forEach(r){for(const[l,m]of this)r(m,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=l=>{if(!l)return!0;const m=l.balanceFactor();return m<-1||m>1?!1:r(l.left)&&r(l.right)};return r(this._root)}}e.TernarySearchTree=c;class h{constructor(r,l){this[M]="ResourceMap",r instanceof h?(this.map=new Map(r.map),this.toKey=l??h.defaultToKey):(this.map=new Map,this.toKey=r??h.defaultToKey)}set(r,l){return this.map.set(this.toKey(r),l),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,l){typeof l!="undefined"&&(r=r.bind(l));for(let[m,p]of this.map)r(p,D.URI.parse(m),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield D.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[D.URI.parse(r[0]),r[1]]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[D.URI.parse(r[0]),r[1]]}}e.ResourceMap=h,h.defaultToKey=s=>s.toString();var o;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class u{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,l=0){const m=this._map.get(r);if(!!m)return l!==0&&this.touch(m,l),m.value}set(r,l,m=0){let p=this._map.get(r);if(p)p.value=l,m!==0&&this.touch(p,m);else{switch(p={key:r,value:l,next:void 0,previous:void 0},m){case 0:this.addItemLast(p);break;case 1:this.addItemFirst(p);break;case 2:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(r,p),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const l=this._map.get(r);if(!!l)return this._map.delete(r),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,l){const m=this._state;let p=this._head;for(;p;){if(l?r.bind(l)(p.value,p.key,this):r(p.value,p.key,this),this._state!==m)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const r=this,l=this._state;let m=this._head;const p={[Symbol.iterator](){return p},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(m){const P={value:m.key,done:!1};return m=m.next,P}else return{value:void 0,done:!0}}};return p}values(){const r=this,l=this._state;let m=this._head;const p={[Symbol.iterator](){return p},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(m){const P={value:m.value,done:!1};return m=m.next,P}else return{value:void 0,done:!0}}};return p}entries(){const r=this,l=this._state;let m=this._head;const p={[Symbol.iterator](){return p},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(m){const P={value:[m.key,m.value],done:!1};return m=m.next,P}else return{value:void 0,done:!0}}};return p}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let l=this._head,m=this.size;for(;l&&m>r;)this._map.delete(l.key),l=l.next,m--;this._head=l,this._size=m,l&&(l.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const l=r.next,m=r.previous;if(!l||!m)throw new Error("Invalid list");l.previous=m,m.next=l}r.next=void 0,r.previous=void 0,this._state++}touch(r,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(r===this._head)return;const m=r.next,p=r.previous;r===this._tail?(p.next=void 0,this._tail=p):(m.previous=p,p.next=m),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(l===2){if(r===this._tail)return;const m=r.next,p=r.previous;r===this._head?(m.previous=void 0,this._head=m):(m.previous=p,p.next=m),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((l,m)=>{r.push([m,l])}),r}fromJSON(r){this.clear();for(const[l,m]of r)this.set(l,m)}}e.LinkedMap=u;class i extends u{constructor(r,l=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,l=2){return super.get(r,l)}peek(r){return super.get(r,0)}set(r,l){return super.set(r,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class a{constructor(r){n.set(this,void 0),bt(this,n,r,"f")}get size(){return je(this,n,"f").size}forEach(r,l){je(this,n,"f").forEach(r,l)}get(r){return je(this,n,"f").get(r)}has(r){return je(this,n,"f").has(r)}entries(){return je(this,n,"f").entries()}keys(){return je(this,n,"f").keys()}values(){return je(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return je(this,n,"f").entries()}}e.ReadonlyMapView=a}),define(Q[109],J([0,1,18,27,7]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(t){return JSON.stringify(t,d)}e.stringify=M;function k(t){let I=JSON.parse(t);return I=w(I),I}e.parse=k;var n;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function d(t,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,R.regExpFlags)(I)}:I}function w(t,I=0){if(!t||I>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return D.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof v.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let E=0;E<t.length;++E)t[E]=w(t[E],I+1);else for(const E in t)Object.hasOwnProperty.call(t,E)&&(t[E]=w(t[E],I+1))}return t}e.revive=w}),define(Q[10],J([0,1,3,7]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}set(d,w,t){this._hosts[d]=w,this._ports[d]=t}setConnectionToken(d,w){this._connectionTokens[d]=w}rewrite(d){if(this._delegate)return this._delegate(d);const w=d.authority;let t=this._hosts[w];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const I=this._ports[w],E=this._connectionTokens[w];let S=`path=${encodeURIComponent(d.path)}`;return typeof E=="string"&&(S+=`&tkn=${encodeURIComponent(E)}`),R.URI.from({scheme:v.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${t}:${I}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new M;class k{asBrowserUri(d,w){const t=this.toUri(d,w);return t.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===D.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${D.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?t.with({scheme:D.vscodeFileResource,authority:t.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(d,w){const t=this.toUri(d,w);return t.scheme===D.vscodeFileResource?t.with({scheme:D.file,authority:t.authority!==k.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(d,w){return R.URI.isUri(d)?d:R.URI.parse(w.toUrl(d))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(Q[70],J([0,1,40]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new v.LRUCache(1e4);function D(w){return d(w,"NFC",R)}e.normalizeNFC=D;const M=new v.LRUCache(1e4);function k(w){return d(w,"NFD",M)}e.normalizeNFD=k;const n=/[^\u0000-\u0080]/;function d(w,t,I){if(!w)return w;const E=I.get(w);if(E)return E;let S;return n.test(w)?S=w.normalize(t):S=w,I.set(w,S),S}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(t){return k(t).replace(w,"")}}()}),define(Q[15],J([0,1,33,10,8,3,27,7]),function(V,e,v,R,D,M,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(S){return(0,n.uriToFsPath)(S,!0)}e.originalFSPath=d;class w{constructor(f){this._ignorePathCasing=f}compare(f,g,b=!1){return f===g?0:(0,k.compare)(this.getComparisonKey(f,b),this.getComparisonKey(g,b))}isEqual(f,g,b=!1){return f===g?!0:!f||!g?!1:this.getComparisonKey(f,b)===this.getComparisonKey(g,b)}getComparisonKey(f,g=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,g,b=!1){if(f.scheme===g.scheme){if(f.scheme===R.Schemas.file)return v.isEqualOrParent(d(f),d(g),this._ignorePathCasing(f))&&f.query===g.query&&(b||f.fragment===g.fragment);if((0,e.isEqualAuthority)(f.authority,g.authority))return v.isEqualOrParent(f.path,g.path,this._ignorePathCasing(f),"/")&&f.query===g.query&&(b||f.fragment===g.fragment)}return!1}joinPath(f,...g){return n.URI.joinPath(f,...g)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return D.posix.basename(f.path)}extname(f){return D.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let g;return f.scheme===R.Schemas.file?g=n.URI.file(D.dirname(d(f))).path:(g=D.posix.dirname(f.path),f.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),g="/")),f.with({path:g})}normalizePath(f){if(!f.path.length)return f;let g;return f.scheme===R.Schemas.file?g=n.URI.file(D.normalize(d(f))).path:g=D.posix.normalize(f.path),f.with({path:g})}relativePath(f,g){if(f.scheme!==g.scheme||!(0,e.isEqualAuthority)(f.authority,g.authority))return;if(f.scheme===R.Schemas.file){const c=D.relative(d(f),d(g));return M.isWindows?v.toSlashes(c):c}let b=f.path||"/",y=g.path||"/";if(this._ignorePathCasing(f)){let c=0;for(const h=Math.min(b.length,y.length);c<h&&!(b.charCodeAt(c)!==y.charCodeAt(c)&&b.charAt(c).toLowerCase()!==y.charAt(c).toLowerCase());c++);b=y.substr(0,c)+b.substr(c)}return D.posix.relative(b,y)}resolvePath(f,g){if(f.scheme===R.Schemas.file){const b=n.URI.file(D.resolve(d(f),g));return f.with({authority:b.authority,path:b.path})}return g=v.toPosixPath(g),f.with({path:D.posix.resolve(f.path,g)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,g){return f===g||(0,k.equalsIgnoreCase)(f,g)}hasTrailingPathSeparator(f,g=D.sep){if(f.scheme===R.Schemas.file){const b=d(f);return b.length>v.getRoot(b).length&&b[b.length-1]===g}else{const b=f.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,g=D.sep){return(0,e.hasTrailingPathSeparator)(f,g)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,g=D.sep){let b=!1;if(f.scheme===R.Schemas.file){const y=d(f);b=y!==void 0&&y.length===v.getRoot(y).length&&y[y.length-1]===g}else{g="/";const y=f.path;b=y.length===1&&y.charCodeAt(y.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(f,g)?f.with({path:f.path+"/"}):f}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(S=>S.scheme===R.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new w(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(S,f){const g=[];for(let b=0;b<S.length;b++){const y=f(S[b]);S.some((c,h)=>h===b?!1:(0,e.isEqualOrParent)(y,f(c)))||g.push(S[b])}return g}e.distinctParents=t;var I;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function f(g){const b=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(h=>{const[o,u]=h.split(":");o&&u&&b.set(o,u)});const c=g.path.substring(0,g.path.indexOf(";"));return c&&b.set(S.META_DATA_MIME,c),b}S.parseMetaData=f})(I=e.DataUri||(e.DataUri={}));function E(S,f,g){if(f){let b=S.path;return b&&b[0]!==D.posix.sep&&(b=D.posix.sep+b),S.with({scheme:g,authority:f,path:b})}return S.with({scheme:g})}e.toLocalResource=E}),define(Q[9],J([0,1,23,17,4,2,15]),function(V,e,v,R,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n(z){return!!z&&typeof z.then=="function"}e.isThenable=n;function d(z){const B=new v.CancellationTokenSource,U=z(B.token),C=new Promise((Y,O)=>{const T=B.token.onCancellationRequested(()=>{T.dispose(),B.dispose(),O((0,R.canceled)())});Promise.resolve(U).then(_=>{T.dispose(),B.dispose(),Y(_)},_=>{T.dispose(),B.dispose(),O(_)})});return new class{cancel(){B.cancel()}then(Y,O){return C.then(Y,O)}catch(Y){return this.then(void 0,Y)}finally(Y){return C.finally(Y)}}}e.createCancelablePromise=d;function w(z,B,U){return Promise.race([z,new Promise(C=>B.onCancellationRequested(()=>C(U)))])}e.raceCancellation=w;async function t(z){let B=-1;const U=z.map((Y,O)=>Y.then(T=>(B=O,T))),C=await Promise.race(U);return z.forEach((Y,O)=>{O!==B&&Y.cancel()}),C}e.raceCancellablePromises=t;function I(z,B,U){let C;const Y=setTimeout(()=>{C?.(void 0),U?.()},B);return Promise.race([z.finally(()=>clearTimeout(Y)),new Promise(O=>C=O)])}e.raceTimeout=I;function E(z){return new Promise((B,U)=>{const C=z();n(C)?C.then(B,U):B(C)})}e.asPromise=E;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const C=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,C};this.queuedPromise=new Promise(C=>{this.activePromise.then(U,U).then(C)})}return new Promise((U,C)=>{this.queuedPromise.then(U,C)})}return this.activePromise=B(),new Promise((U,C)=>{this.activePromise.then(Y=>{this.activePromise=null,U(Y)},Y=>{this.activePromise=null,C(Y)})})}}e.Throttler=S;class f{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=f;class g{constructor(){this.promiseMap=new Map}queue(B,U){const Y=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(B)===Y&&this.promiseMap.delete(B)});return this.promiseMap.set(B,Y),Y}}e.SequencerByKey=g;class b{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,U=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((C,Y)=>{this.doResolve=C,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const C=this.task;return this.task=null,C()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class y{constructor(B){this.delayer=new b(B),this.throttler=new S}trigger(B,U){return this.delayer.trigger(()=>this.throttler.queue(B),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=y;class c{constructor(){this._isOpen=!1,this._promise=new Promise((B,U)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class h extends c{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function o(z,B){return B?new Promise((U,C)=>{const Y=setTimeout(()=>{O.dispose(),U()},z),O=B.onCancellationRequested(()=>{clearTimeout(Y),O.dispose(),C((0,R.canceled)())})}):d(U=>o(z,U))}e.timeout=o;function u(z,B=0){const U=setTimeout(z,B);return(0,M.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=u;function i(z){const B=[];let U=0;const C=z.length;function Y(){return U<C?z[U++]():null}function O(T){T!=null&&B.push(T);const _=Y();return _?_.then(O):Promise.resolve(B)}return Promise.resolve(null).then(O)}e.sequence=i;function a(z,B=C=>!!C,U=null){let C=0;const Y=z.length,O=()=>{if(C>=Y)return Promise.resolve(U);const T=z[C++];return Promise.resolve(T()).then(j=>B(j)?Promise.resolve(j):O())};return O()}e.first=a;function s(z,B=C=>!!C,U=null){if(z.length===0)return Promise.resolve(U);let C=z.length;const Y=()=>{C=-1;for(const O of z)O.cancel?.()};return new Promise((O,T)=>{for(const _ of z)_.then(j=>{--C>=0&&B(j)?(Y(),O(j)):C===0&&O(U)}).catch(j=>{--C>=0&&(Y(),T(j))})})}e.firstParallel=s;class r{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((U,C)=>{this.outstandingPromises.push({factory:B,c:U,e:C}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const U=B.factory();U.then(B.c,B.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class l extends r{constructor(){super(1)}}e.Queue=l;class m{constructor(){this.queues=new Map}queueFor(B,U=k.extUri){const C=U.getComparisonKey(B);let Y=this.queues.get(C);return Y||(Y=new l,D.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(C)}),this.queues.set(C,Y)),Y}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=m;class p{constructor(B,U){this._token=-1,typeof B=="function"&&typeof U=="number"&&this.setIfNotSet(B,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},U)}setIfNotSet(B,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},U))}}e.TimeoutTimer=p;class P{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,U){this.cancel(),this._token=setInterval(()=>{B()},U)}}e.IntervalTimer=P;class L{constructor(B,U){this.timeoutToken=-1,this.runner=B,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class A{constructor(B,U){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class W extends L{constructor(B,U){super(B,U);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=W;class q extends M.Disposable{constructor(B,U,C,Y){super();this.maxWorkChunkSize=B,this.maxPendingWork=U,this.throttleDelay=C,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=z=>{const B=setTimeout(()=>{const C=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0,clearTimeout(B))}}}:e.runWhenIdle=(z,B)=>{const U=requestIdleCallback(z,typeof B=="number"?{timeout:B}:void 0);let C=!1;return{dispose(){C||(C=!0,cancelIdleCallback(U))}}}}();class x{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function re(z,B,U){let C;for(let Y=0;Y<U;Y++)try{return await z()}catch(O){C=O,await o(B)}throw C}e.retry=re;class K{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,U,C){return this._pending={taskId:B,cancel:()=>C?.(),promise:U},U.then(()=>this.donePending(B),()=>this.donePending(B)),U}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let U,C;const Y=new Promise((O,T)=>{U=O,C=T});this._next={run:B,promise:Y,promiseResolve:U,promiseReject:C}}return this._next.promise}}e.TaskSequentializer=K;class ee{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,U)=>{this.completeCallback=B,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(U=>{this.completeCallback(B),this.resolved=!0,U()})}error(B){return new Promise(U=>{this.errorCallback(B),this.rejected=!0,U()})}cancel(){new Promise(B=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=F;var H;(function(z){async function B(C){let Y;const O=await Promise.all(C.map(T=>T.then(_=>_,_=>{Y||(Y=_)})));if(typeof Y!="undefined")throw Y;return O}z.settled=B;function U(C){return new Promise(async(Y,O)=>{try{await C(Y,O)}catch(T){O(T)}})}z.withAsyncBody=U})(H=e.Promises||(e.Promises={}))}),define(Q[34],J([0,1,33,10,8,3,15,27,7]),function(V,e,v,R,D,M,k,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(r,l,m){if(typeof r=="string"&&(r=d.URI.file(r)),m){const P=m.getWorkspaceFolder(r);if(P){const L=m.getWorkspace().folders.length>1;let A;if((0,k.isEqual)(P.uri,r)?A="":A=(0,k.relativePath)(P.uri,r),L){const W=P.name?P.name:(0,k.basename)(P.uri);A=A?W+" \u2022 "+A:W}return A}}if(r.scheme!==R.Schemas.file&&r.scheme!==R.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(r.fsPath))return(0,D.normalize)(I(r.fsPath));let p=(0,D.normalize)(r.fsPath);return!M.isWindows&&l?.userHome&&(p=S(p,l.userHome.fsPath)),p}e.getPathLabel=w;function t(r){if(!r)return;typeof r=="string"&&(r=d.URI.file(r));const l=(0,k.basename)(r)||(r.scheme===R.Schemas.file?r.fsPath:r.path);return M.isWindows&&(0,v.isRootOrDriveLetter)(l)?I(l):l}e.getBaseLabel=t;function I(r){return(0,v.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=I;let E=Object.create(null);function S(r,l){if(M.isWindows||!r||!l)return r;let m=E.original===l?E.normalized:void 0;return m||(m=`${(0,n.rtrim)(l,D.posix.sep)}${D.posix.sep}`,E={original:l,normalized:m}),(M.isLinux?r.startsWith(m):(0,n.startsWithIgnoreCase)(r,m))&&(r=`~/${r.substr(m.length)}`),r}e.tildify=S;function f(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=f;const g="\u2026",b="\\\\",y="~";function c(r,l=D.sep){const m=new Array(r.length);let p=!1;for(let P=0;P<r.length;P++){let L=r[P];if(L===""){m[P]=`.${l}`;continue}if(!L){m[P]=L;continue}p=!0;let A="";L.indexOf(b)===0?(A=L.substr(0,L.indexOf(b)+b.length),L=L.substr(L.indexOf(b)+b.length)):L.indexOf(l)===0?(A=L.substr(0,L.indexOf(l)+l.length),L=L.substr(L.indexOf(l)+l.length)):L.indexOf(y)===0&&(A=L.substr(0,L.indexOf(y)+y.length),L=L.substr(L.indexOf(y)+y.length));const W=L.split(l);for(let q=1;p&&q<=W.length;q++)for(let x=W.length-q;p&&x>=0;x--){p=!1;let re=W.slice(x,x+q).join(l);for(let K=0;!p&&K<r.length;K++)if(K!==P&&r[K]&&r[K].indexOf(re)>-1){const ee=x+q===W.length,F=x>0&&r[K].indexOf(l)>-1?l+re:re,H=r[K].endsWith(F);p=!ee||H}if(!p){let K="";(W[0].endsWith(":")||A!=="")&&(x===1&&(x=0,q++,re=W[0]+l+re),x>0&&(K=W[0]+l),K=A+K),x>0&&(K=K+g+l),K=K+re,x+q<W.length&&(K=K+l+g),m[P]=K}}p&&(m[P]=L)}return m}e.shorten=c;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(r,l=Object.create(null)){const m=[];let p=!1,P="";for(const L of r)if(L==="$"||p&&L==="{")P&&m.push({value:P,type:h.TEXT}),P="",p=!0;else if(L==="}"&&p){const A=l[P];if(typeof A=="string")A.length&&m.push({value:A,type:h.VARIABLE});else if(A){const W=m[m.length-1];(!W||W.type!==h.SEPARATOR)&&m.push({value:A.label,type:h.SEPARATOR})}P="",p=!1}else P+=L;return P&&!p&&m.push({value:P,type:h.TEXT}),m.filter((L,A)=>{if(L.type===h.SEPARATOR){const W=m[A-1],q=m[A+1];return[W,q].every(x=>x&&(x.type===h.VARIABLE||x.type===h.TEXT)&&x.value.length>0)}return!0}).map(L=>L.value).join("")}e.template=o;function u(r,l){return M.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function i(r,l){return M.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,m=>m==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function a(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=a;function s(r){const l=r.indexOf("/")!==-1?D.posix:D.win32,m=l.basename(r),p=l.dirname(r);return m.length?{name:m,parentPath:p}:{name:p,parentPath:""}}e.splitName=s}),define(Q[28],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(d){return v.test(d)}e.isUUID=R;const D=new Uint8Array(16),M=[];for(let d=0;d<256;d++)M.push(d.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(d){for(let w=0;w<d.length;w++)d[w]=Math.floor(Math.random()*256);return d};function n(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let d=0,w="";return w+=M[D[d++]],w+=M[D[d++]],w+=M[D[d++]],w+=M[D[d++]],w+="-",w+=M[D[d++]],w+=M[D[d++]],w+="-",w+=M[D[d++]],w+=M[D[d++]],w+="-",w+=M[D[d++]],w+=M[D[d++]],w+="-",w+=M[D[d++]],w+=M[D[d++]],w+=M[D[d++]],w+=M[D[d++]],w+=M[D[d++]],w+=M[D[d++]],w}e.generateUuid=n}),define(Q[110],J([0,1,59,31,42]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(k,n){if(await new Promise((t,I)=>{const E=R.createReadStream(k),S=v.createHash("sha1");E.pipe(S);const f=(0,D.once)((g,b)=>{E.removeAllListeners(),S.removeAllListeners(),g?I(g):t(b)});E.once("error",f),E.once("end",f),S.once("error",f),S.once("data",g=>f(void 0,g.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=M}),define(Q[111],J([0,1,238]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(M="utf8"){this.stringDecoder=new v.StringDecoder(M),this.remaining=null}write(M){const k=[],n=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(n.length<1)return k;let d=0,w,t=d;for(;t<n.length;)if(w=n.charCodeAt(t),w===13||w===10){if(k.push(n.substring(d,t)),t++,t<n.length){const I=w;w=n.charCodeAt(t),(I===13&&w===10||I===10&&w===13)&&t++}d=t}else t++;return this.remaining=d<n.length?n.substr(d):null,k}end(){return this.remaining}}e.LineDecoder=R}),define(Q[112],J([0,1,25]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(n){const d=n.replace(/\-/g,":").toLowerCase();return!R.has(d)}function M(){return new Promise(async(n,d)=>{const w=setTimeout(()=>d("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await k())}catch(t){d(t)}finally{clearTimeout(w)}})}e.getMac=M;function k(){return new Promise((n,d)=>{try{const w=(0,v.networkInterfaces)();for(let t in w){const I=w[t];if(I){for(const{mac:E}of I)if(D(E))return n(E)}}d("Unable to retrieve mac address (unexpected format)")}catch(w){d(w)}})}}),define(Q[71],J([0,1,25,17,40,28,112]),function(V,e,v,R,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(t){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(t)}value(){if(this._value===void 0){let t=0,I=0;const E=(0,v.networkInterfaces)();for(let S in E){const f=E[S];if(f)for(const{mac:g,internal:b}of f)b||(I+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(t+=1))}this._value=I>0?t/I:0}return this._value}};let n;async function d(){return n||(n=(async()=>await w()||M.generateUuid())()),n}e.getMachineId=d;async function w(){try{const t=await new Promise((E,S)=>{V(["crypto"],E,S)}),I=await(0,k.getMac)();return t.createHash("sha256").update(I,"utf8").digest("hex")}catch(t){R.onUnexpectedError(t);return}}}),define(Q[19],J([0,1,31,25,113,9,33,70,8,3,15,7,28]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function f(F,H=S.UNLINK){if((0,k.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return H===S.UNLINK?b(F):g(F)}async function g(F){try{const H=(0,d.join)((0,R.tmpdir)(),(0,E.generateUuid)());try{await e.Promises.rename(F,H)}catch(z){return b(F)}b(H).catch(z=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function b(F){return e.Promises.rmdir(F,{recursive:!0,maxRetries:3})}function y(F){if((0,k.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(F,{recursive:!0})}e.rimrafSync=y;async function c(F,H){return u(await(H?h(F):(0,D.promisify)(v.readdir)(F)))}async function h(F){try{return await(0,D.promisify)(v.readdir)(F,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const H=[],z=await c(F);for(const B of z){let U=!1,C=!1,Y=!1;try{const O=await e.Promises.lstat((0,d.join)(F,B));U=O.isFile(),C=O.isDirectory(),Y=O.isSymbolicLink()}catch(O){console.warn("[node.js fs] unexpected error from lstat after readdir: ",O)}H.push({name:B,isFile:()=>U,isDirectory:()=>C,isSymbolicLink:()=>Y})}return H}function o(F){return u(v.readdirSync(F))}e.readdirSync=o;function u(F){return F.map(H=>typeof H=="string"?w.isMacintosh?(0,n.normalizeNFC)(H):H:(H.name=w.isMacintosh?(0,n.normalizeNFC)(H.name):H.name,H))}async function i(F){const H=await c(F),z=[];for(const B of H)await s.existsDirectory((0,d.join)(F,B))&&z.push(B);return z}function a(F,H=1e3){return new Promise(z=>{let B=!1;const U=setInterval(()=>{B||(B=!0,v.access(F,C=>{B=!1,C&&(clearInterval(U),z(void 0))}))},H)})}e.whenDeleted=a;var s;(function(F){async function H(U){let C;try{if(C=await e.Promises.lstat(U),!C.isSymbolicLink())return{stat:C}}catch(Y){}try{return{stat:await e.Promises.stat(U),symbolicLink:C?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&C)return{stat:C,symbolicLink:{dangling:!0}};if(w.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(O){if(O.code==="ENOENT"&&C)return{stat:C,symbolicLink:{dangling:!0}};throw O}throw Y}}F.stat=H;async function z(U){try{const{stat:C,symbolicLink:Y}=await F.stat(U);return C.isFile()&&Y?.dangling!==!0}catch(C){}return!1}F.existsFile=z;async function B(U){try{const{stat:C,symbolicLink:Y}=await F.stat(U);return C.isDirectory()&&Y?.dangling!==!0}catch(C){}return!1}F.existsDirectory=B})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new M.ResourceQueue;function l(F,H,z){return r.queueFor(I.URI.file(F),t.extUriBiasedIgnorePathCase).queue(()=>{const B=L(z);return new Promise((U,C)=>p(F,H,B,Y=>Y?C(Y):U()))})}let m=!0;function p(F,H,z,B){if(!m)return v.writeFile(F,H,{mode:z.mode,flag:z.flag},B);v.open(F,z.flag,z.mode,(U,C)=>{if(U)return B(U);v.writeFile(C,H,Y=>{if(Y)return v.close(C,()=>B(Y));v.fdatasync(C,O=>(O&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",O),m=!1),v.close(C,T=>B(T))))})})}function P(F,H,z){const B=L(z);if(!m)return v.writeFileSync(F,H,{mode:B.mode,flag:B.flag});const U=v.openSync(F,B.flag,B.mode);try{v.writeFileSync(U,H);try{v.fdatasyncSync(U)}catch(C){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",C),m=!1}}finally{v.closeSync(U)}}e.writeFileSync=P;function L(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function A(F,H){if(F===H)return;async function z(B){try{const U=await e.Promises.lstat(B);if(U.isDirectory()||U.isSymbolicLink())return;await e.Promises.utimes(B,U.atime,new Date)}catch(U){}}try{await e.Promises.rename(F,H),await z(H)}catch(B){if(F.toLowerCase()!==H.toLowerCase()&&B.code==="EXDEV"||F.endsWith("."))await W(F,H,{preserveSymlinks:!1}),await f(F,S.MOVE),await z(H);else throw B}}async function W(F,H,z){return x(F,H,{root:{source:F,target:H},options:z,handledSourcePaths:new Set})}const q=511;async function x(F,H,z){if(z.handledSourcePaths.has(F))return;z.handledSourcePaths.add(F);const{stat:B,symbolicLink:U}=await s.stat(F);if(U){if(z.options.preserveSymlinks)try{return await ee(F,H,z)}catch(C){console.warn("[node.js fs] copy of symlink failed: ",C)}if(U.dangling)return}return B.isDirectory()?re(F,H,B.mode&q,z):K(F,H,B.mode&q)}async function re(F,H,z,B){await e.Promises.mkdir(H,{recursive:!0,mode:z});const U=await c(F);for(const C of U)await x((0,d.join)(F,C),(0,d.join)(H,C),B)}async function K(F,H,z){await e.Promises.copyFile(F,H),await e.Promises.chmod(H,z)}async function ee(F,H,z){let B=await e.Promises.readlink(F);(0,k.isEqualOrParent)(B,z.root.source,!w.isLinux)&&(B=(0,d.join)(z.root.target,B.substr(z.root.source.length+1))),await e.Promises.symlink(B,H)}e.Promises=new class{get access(){return(0,D.promisify)(v.access)}get stat(){return(0,D.promisify)(v.stat)}get lstat(){return(0,D.promisify)(v.lstat)}get utimes(){return(0,D.promisify)(v.utimes)}get read(){return(0,D.promisify)(v.read)}get readFile(){return(0,D.promisify)(v.readFile)}get write(){return(0,D.promisify)(v.write)}get appendFile(){return(0,D.promisify)(v.appendFile)}get fdatasync(){return(0,D.promisify)(v.fdatasync)}get truncate(){return(0,D.promisify)(v.truncate)}get rename(){return(0,D.promisify)(v.rename)}get copyFile(){return(0,D.promisify)(v.copyFile)}get open(){return(0,D.promisify)(v.open)}get close(){return(0,D.promisify)(v.close)}get symlink(){return(0,D.promisify)(v.symlink)}get readlink(){return(0,D.promisify)(v.readlink)}get chmod(){return(0,D.promisify)(v.chmod)}get mkdir(){return(0,D.promisify)(v.mkdir)}get unlink(){return(0,D.promisify)(v.unlink)}get rmdir(){return(0,D.promisify)(v.rmdir)}get realpath(){return(0,D.promisify)(v.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return i}get writeFile(){return l}get rm(){return f}get move(){return A}get copy(){return W}}}),define(Q[83],J([0,1,31,8,27,19]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(t){const I=(0,R.dirname)(t);if(t===I)return t;const E=((0,R.basename)(t)||t).toLowerCase();try{const f=(0,M.readdirSync)(I).filter(g=>g.toLowerCase()===E);if(f.length===1){const g=k(I);if(g)return(0,R.join)(g,f[0])}else if(f.length>1){const g=f.indexOf(E);if(g>=0){const b=k(I);if(b)return(0,R.join)(b,f[g])}}}catch(S){}return null}e.realcaseSync=k;async function n(t){try{return await M.Promises.realpath(t)}catch(I){const E=w(t);return await M.Promises.access(E,v.constants.R_OK),E}}e.realpath=n;function d(t){try{return v.realpathSync(t)}catch(I){const E=w(t);return v.accessSync(E,v.constants.R_OK),E}}e.realpathSync=d;function w(t){return(0,D.rtrim)((0,R.normalize)(t),R.sep)}}),define(Q[114],J([0,1,60]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function R(n,d,w,t=1){let I=!1;return new Promise(E=>{const S=setTimeout(()=>{if(!I)return I=!0,E(0)},w);D(n,d,t,f=>{if(!I)return I=!0,clearTimeout(S),E(f)})})}e.findFreePort=R;function D(n,d,w,t){if(d===0)return t(0);const I=new v.Socket;I.once("connect",()=>(k(I),D(n+w,d-1,w,t))),I.once("data",()=>{}),I.once("error",E=>(k(I),E.code!=="ECONNREFUSED"?D(n+w,d-1,w,t):t(n))),I.connect(n,"127.0.0.1")}function M(n,d,w){let t=!1,I,E=1;const S=v.createServer({pauseOnConnect:!0});function f(g,b){t||(t=!0,S.removeAllListeners(),S.close(),I&&clearTimeout(I),b(g))}return new Promise(g=>{I=setTimeout(()=>{f(0,g)},w),S.on("listening",()=>{f(n,g)}),S.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&E<d?(n++,E++,S.listen(n,"127.0.0.1")):f(0,g)}),S.on("close",()=>{f(0,g)}),S.listen(n,"127.0.0.1")})}e.findFreePortFaster=M;function k(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(d){console.error(d)}}}),define(Q[115],J([0,1,25,8,19]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,k=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var d;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(d||(d={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let t;process.env.PROCESSOR_ARCHITEW6432?t=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?t=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?t=1:t=0;class I{constructor(u,i,a){this.exePath=u,this.displayName=i,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:o=!1}={}){return o?w===0?process.env["ProgramFiles(x86)"]||null:t===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:o=!1,findPreview:u=!1}={}){const i=E({useAlternateBitness:o});if(!i)return null;const a=R.join(i,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(a))return null;let s=-1,r=null;for(const p of await D.Promises.readdir(a)){let P=-1;if(u){const A=p.indexOf("-");if(A<0)continue;const W=p.substring(0,A);if(!M.test(W)||p.substring(A+1)!=="preview")continue;P=parseInt(W,10)}else{if(!M.test(p))continue;P=parseInt(p,10)}if(P<=s)continue;const L=R.join(a,p,"pwsh.exe");!await D.SymlinkSupport.existsFile(L)||(r=L,s=P)}if(!r)return null;const l=i.includes("x86")?" (x86)":"",m=u?" Preview":"";return new I(r,`PowerShell${m}${l}`,!0)}async function f({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const u=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:i,pwshMsixName:a}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const s of await D.Promises.readdir(u))if(i.test(s)){const r=R.join(u,s,"pwsh.exe");return new I(r,a)}return null}function g(){const o=R.join(v.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function b(){const o=R.join(process.env.windir,w===1&&t!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}async function*y(){let o=await S();o&&(yield o),o=await S({useAlternateBitness:!0}),o&&(yield o),o=await f(),o&&(yield o),o=g(),o&&(yield o),o=await S({findPreview:!0}),o&&(yield o),o=await f({findPreview:!0}),o&&(yield o),o=await S({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=b(),o&&(yield o)}async function*c(){for await(const o of y())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=c;async function h(){for await(const o of c())return o;return null}e.getFirstAvailablePowerShellInstallation=h}),define(Q[84],J([0,1,44,10]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((n,d)=>{let w;const t=new Map;function I(S,f,g,b,y){const c=t.get(f);if(S===k||c){const h={name:E(g),cmd:g,pid:S,ppid:f,load:b,mem:y};t.set(S,h),S===k&&(w=h),c&&(c.children||(c.children=[]),c.children.push(h),c.children.length>1&&(c.children=c.children.sort((o,u)=>o.pid-u.pid)))}}function E(S){const f=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,b=/--crashes-directory/,y=/\\pipe\\winpty-control/,c=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(g.exec(S))return"watcherService ";if(b.exec(S))return"electron-crash-reporter";if(y.exec(S))return"winpty-process";if(c.exec(S))return"console-window-host (Windows internal process)";let o=h.exec(S);if(o&&o.length===2)return o[1]==="renderer"?f.exec(S)?"shared-process":"window":o[1];const u=/[a-zA-Z-]+\.js/g;let i="";do o=u.exec(S),o&&(i+=o+" ");while(o);return i&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${i}`:S}if(process.platform==="win32"){const S=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,g)=>{V(["windows-process-tree"],f,g)}).then(f=>{f.getProcessList(k,g=>{f.getProcessCpuUsage(g,b=>{const y=new Map;b.forEach(c=>{const h=S(c.commandLine||"");y.set(c.pid,{name:E(h),cmd:h,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),w=y.get(k),w?(y.forEach(c=>{const h=y.get(c.ppid);h&&(h.children||(h.children=[]),h.children.push(c))}),y.forEach(c=>{c.children&&(c.children=c.children.sort((h,o)=>h.pid-o.pid))}),n(w)):d(new Error(`Root process ${k} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let S=function(){let f=[w];const g=[];for(;f.length;){const y=f.shift();y&&(g.push(y.pid),y.children&&(f=f.concat(y.children)))}let b=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);b+=" "+g.join(" "),(0,v.exec)(b,{},(y,c,h)=>{if(y||h)d(y||new Error(h.toString()));else{const o=c.toString().split(`
`);for(let u=0;u<g.length;u++){const i=t.get(g[u]);i.load=parseFloat(o[u])}if(!w){d(new Error(`Root process ${k} not found`));return}n(w)}})};(0,v.exec)("which ps",{},(f,g,b)=>{if(f||b)if(process.platform!=="linux")d(f||new Error(b.toString()));else{const y=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,v.exec)(y,{},(c,h,o)=>{c||o?d(c||new Error(o.toString())):(M(h,I),S())})}else{const y=g.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${y} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,o,u)=>{h||u&&!u.includes("screen size is bogus")?d(h||new Error(u.toString())):(M(o,I),process.platform==="linux"?S():w?n(w):d(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function M(k,n){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=k.toString().split(`
`);for(const t of w){const I=d.exec(t.trim());I&&I.length===6&&n(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(Q[116],J([0,1,31,23,33,2,70,8,3,19]),function(V,e,v,R,D,M,k,n,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function t(f,g,b){return E({path:f,isDirectory:!1},g,b)}e.watchFile=t;function I(f,g,b){return E({path:f,isDirectory:!0},g,b)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function E(f,g,b){if(d.isMacintosh&&(0,D.isEqualOrParent)(f.path,"/Volumes/"))return b(`Refusing to watch ${f.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const y=(0,n.basename)(f.path),c=new Map;let h=!1,o=[(0,M.toDisposable)(()=>{c.forEach(u=>(0,M.dispose)(u)),c.clear()})];try{const u=(0,v.watch)(f.path);o.push((0,M.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const i=new Set;f.isDirectory&&w.Promises.readdir(f.path).then(a=>a.forEach(s=>i.add(s))),u.on("error",(a,s)=>{h||b(`Failed to watch ${f.path} for changes using fs.watch() (${a}, ${s})`)}),u.on("change",(a,s)=>{if(h)return;let r="";if(s&&(r=s.toString(),d.isMacintosh&&(r=(0,k.normalizeNFC)(r))),!r||a!=="change"&&a!=="rename")return;const l=f.isDirectory?(0,n.join)(f.path,r):f.path;if(f.isDirectory)if(a==="rename"){const m=c.get(l);m&&(0,M.dispose)(m);const p=setTimeout(async()=>{c.delete(l);const P=await w.Promises.exists(l);if(h)return;let L;P?i.has(r)?L="changed":(L="added",i.add(r)):(i.delete(r),L="deleted"),g(L,l)},e.CHANGE_BUFFER_DELAY);c.set(l,(0,M.toDisposable)(()=>clearTimeout(p)))}else{let m;i.has(r)?m="changed":(m="added",i.add(r)),g(m,l)}else if(a==="rename"||r!==y){const m=setTimeout(async()=>{const p=await w.Promises.exists(l);h||(p?(g("changed",l),o=[E(f,g,b)]):g("deleted",l))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(o),o=[(0,M.toDisposable)(()=>clearTimeout(m))]}else g("changed",l)})}catch(u){w.Promises.exists(f.path).then(i=>{i&&!h&&b(`Failed to watch ${f.path} for changes using fs.watch() (${u.toString()})`)})}return(0,M.toDisposable)(()=>{h=!0,o=(0,M.dispose)(o)})}async function S(f,g,b,y=512){const c=await w.Promises.open(f,"r"),h=Buffer.allocUnsafe(y),o=new R.CancellationTokenSource(b);let u,i=!1;const a=t(f,async s=>{if(s==="changed"){if(i)return;i=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:r}=await w.Promises.read(c,h,0,y,null);if(!r||o.token.isCancellationRequested)break;g(h.slice(0,r))}}catch(r){u=new Error(r),o.dispose(!0)}finally{i=!1}}},s=>{u=new Error(s),o.dispose(!0)});return new Promise((s,r)=>{o.token.onCancellationRequested(async()=>{a.dispose(),await w.Promises.close(c),u?r(u):s()})})}e.watchFileContents=S}),define(Q[117],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[118],J([0,1,14,13,117]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){v.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(n,d,w,t,I)=>{const E=k(n,t,w);E.popup({window:(0,R.withNullAsUndefined)(v.BrowserWindow.fromWebContents(n.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{E&&n.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=M;function k(n,d,w){const t=new v.Menu;return w.forEach(I=>{let E;I.type==="separator"?E=new v.MenuItem({type:I.type}):Array.isArray(I.submenu)?E=new v.MenuItem({submenu:k(n,d,I.submenu),label:I.label}):E=new v.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(S,f,g)=>n.sender.send(d,I.id,g)}),t.append(E)}),t}});var he=this&&this.__decorate||function(V,e,v,R){var D=arguments.length,M=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(V,e,v,R);else for(var n=V.length-1;n>=0;n--)(k=V[n])&&(M=(D<3?k(M):D>3?k(e,v,M):k(e,v))||M);return D>3&&M&&Object.defineProperty(e,v,M),M};define(Q[35],J([0,1,30,9,18,23,47,17,4,2,109,27,13]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function f(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function b(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(y||(y={}));class c{constructor(C){this.buffer=C,this.pos=0}read(C){const Y=this.buffer.slice(this.pos,this.pos+C);return this.pos+=Y.byteLength,Y}}class h{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(C){this.buffers.push(C)}}var o;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(o||(o={}));function u(U){const C=D.VSBuffer.alloc(4);return C.writeUInt32BE(U,0),C}function i(U){return U.read(4).readUInt32BE(0)}function a(U){const C=D.VSBuffer.alloc(1);return C.writeUInt8(U,0),C}const s={Undefined:a(o.Undefined),String:a(o.String),Buffer:a(o.Buffer),VSBuffer:a(o.VSBuffer),Array:a(o.Array),Object:a(o.Object)},r=typeof Buffer!="undefined";function l(U,C){if(typeof C=="undefined")U.write(s.Undefined);else if(typeof C=="string"){const Y=D.VSBuffer.fromString(C);U.write(s.String),U.write(u(Y.byteLength)),U.write(Y)}else if(r&&Buffer.isBuffer(C)){const Y=D.VSBuffer.wrap(C);U.write(s.Buffer),U.write(u(Y.byteLength)),U.write(Y)}else if(C instanceof D.VSBuffer)U.write(s.VSBuffer),U.write(u(C.byteLength)),U.write(C);else if(Array.isArray(C)){U.write(s.Array),U.write(u(C.length));for(const Y of C)l(U,Y)}else{const Y=D.VSBuffer.fromString(JSON.stringify(C));U.write(s.Object),U.write(u(Y.byteLength)),U.write(Y)}}function m(U){switch(U.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return U.read(i(U)).toString();case o.Buffer:return U.read(i(U)).buffer;case o.VSBuffer:return U.read(i(U));case o.Array:{const Y=i(U),O=[];for(let T=0;T<Y;T++)O.push(m(U));return O}case o.Object:return JSON.parse(U.read(i(U)).toString())}}class p{constructor(C,Y,O=null,T=1e3){this.protocol=C,this.ctx=Y,this.logger=O,this.timeoutDelay=T,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(C,Y){this.channels.set(C,Y),setTimeout(()=>this.flushPendingRequests(C),0)}sendResponse(C){switch(C.type){case 200:{const Y=this.send([C.type]);this.logger&&this.logger.logOutgoing(Y,0,1,b(C.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([C.type,C.id],C.data);this.logger&&this.logger.logOutgoing(Y,C.id,1,b(C.type),C.data);return}}}send(C,Y=void 0){const O=new h;return l(O,C),l(O,Y),this.sendBuffer(O.buffer)}sendBuffer(C){try{return this.protocol.send(C),C.byteLength}catch(Y){return 0}}onRawMessage(C){const Y=new c(C),O=m(Y),T=m(Y),_=O[0];switch(_){case 100:return this.logger&&this.logger.logIncoming(C.byteLength,O[1],1,`${f(_)}: ${O[2]}.${O[3]}`,T),this.onPromise({type:_,id:O[1],channelName:O[2],name:O[3],arg:T});case 102:return this.logger&&this.logger.logIncoming(C.byteLength,O[1],1,`${f(_)}: ${O[2]}.${O[3]}`,T),this.onEventListen({type:_,id:O[1],channelName:O[2],name:O[3],arg:T});case 101:return this.logger&&this.logger.logIncoming(C.byteLength,O[1],1,`${f(_)}`),this.disposeActiveRequest({type:_,id:O[1]});case 103:return this.logger&&this.logger.logIncoming(C.byteLength,O[1],1,`${f(_)}`),this.disposeActiveRequest({type:_,id:O[1]})}}onPromise(C){const Y=this.channels.get(C.channelName);if(!Y){this.collectPendingRequest(C);return}const O=new M.CancellationTokenSource;let T;try{T=Y.call(this.ctx,C.name,C.arg,O.token)}catch(X){T=Promise.reject(X)}const _=C.id;T.then(X=>{this.sendResponse({id:_,data:X,type:201}),this.activeRequests.delete(C.id)},X=>{X instanceof Error?this.sendResponse({id:_,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:_,data:X,type:203}),this.activeRequests.delete(C.id)});const j=(0,w.toDisposable)(()=>O.cancel());this.activeRequests.set(C.id,j)}onEventListen(C){const Y=this.channels.get(C.channelName);if(!Y){this.collectPendingRequest(C);return}const O=C.id,_=Y.listen(this.ctx,C.name,C.arg)(j=>this.sendResponse({id:O,data:j,type:204}));this.activeRequests.set(C.id,_)}disposeActiveRequest(C){const Y=this.activeRequests.get(C.id);Y&&(Y.dispose(),this.activeRequests.delete(C.id))}collectPendingRequest(C){let Y=this.pendingRequests.get(C.channelName);Y||(Y=[],this.pendingRequests.set(C.channelName,Y));const O=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.sendResponse({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:C,timeoutTimer:O})}flushPendingRequests(C){const Y=this.pendingRequests.get(C);if(Y){for(const O of Y)switch(clearTimeout(O.timeoutTimer),O.request.type){case 100:this.onPromise(O.request);break;case 102:this.onEventListen(O.request);break}this.pendingRequests.delete(C)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(C=>C.dispose()),this.activeRequests.clear()}}e.ChannelServer=p;var P;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(C,Y=null){this.protocol=C,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(O=>this.onBuffer(O)),this.logger=Y}getChannel(C){const Y=this;return{call(O,T,_){return Y.isDisposed?Promise.reject(n.canceled()):Y.requestPromise(C,O,T,_)},listen(O,T){return Y.isDisposed?Promise.reject(n.canceled()):Y.requestEvent(C,O,T)}}}requestPromise(C,Y,O,T=M.CancellationToken.None){const _=this.lastRequestId++,X={id:_,type:100,channelName:C,name:Y,arg:O};if(T.isCancellationRequested)return Promise.reject(n.canceled());let $;return new Promise((Z,ie)=>{if(T.isCancellationRequested)return ie(n.canceled());const oe=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(_),Z(de.data);break;case 202:this.handlers.delete(_);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,ie(ve);break;case 203:this.handlers.delete(_),ie(de.data);break}};this.handlers.set(_,ue),this.sendRequest(X)};let le=null;this.state===y.Idle?oe():(le=(0,R.createCancelablePromise)(ue=>this.whenInitialized()),le.then(()=>{le=null,oe()}));const ne=()=>{le?(le.cancel(),le=null):this.sendRequest({id:_,type:101}),ie(n.canceled())},ae=T.onCancellationRequested(ne);$=(0,w.combinedDisposable)((0,w.toDisposable)(ne),ae),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(C,Y,O){const T=this.lastRequestId++,j={id:T,type:102,channelName:C,name:Y,arg:O};let X=null;const $=new d.Emitter({onFirstListenerAdd:()=>{X=(0,R.createCancelablePromise)(Z=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add($),this.sendRequest(j)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete($),this.sendRequest({id:T,type:103}))}}),N=Z=>$.fire(Z.data);return this.handlers.set(T,N),$.event}sendRequest(C){switch(C.type){case 100:case 102:{const Y=this.send([C.type,C.id,C.channelName,C.name],C.arg);this.logger&&this.logger.logOutgoing(Y,C.id,0,`${f(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const Y=this.send([C.type,C.id]);this.logger&&this.logger.logOutgoing(Y,C.id,0,f(C.type));return}}}send(C,Y=void 0){const O=new h;return l(O,C),l(O,Y),this.sendBuffer(O.buffer)}sendBuffer(C){try{return this.protocol.send(C),C.byteLength}catch(Y){return 0}}onBuffer(C){const Y=new c(C),O=m(Y),T=m(Y),_=O[0];switch(_){case 200:return this.logger&&this.logger.logIncoming(C.byteLength,0,0,b(_)),this.onResponse({type:O[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(C.byteLength,O[1],0,b(_),T),this.onResponse({type:O[0],id:O[1],data:T})}}onResponse(C){if(C.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(C.id);Y&&Y(C)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(C=>C.dispose()),this.activeRequests.clear()}}he([k.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class A{constructor(C){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,C(({protocol:Y,onDidClientDisconnect:O})=>{d.Event.once(Y.onMessage)(_=>{const j=new c(_),X=m(j),$=new p(Y,X),N=new L(Y);this.channels.forEach((ie,oe)=>$.registerChannel(oe,ie));const Z={channelServer:$,channelClient:N,ctx:X};this._connections.add(Z),this._onDidAddConnection.fire(Z),O(()=>{$.dispose(),N.dispose(),this._connections.delete(Z),this._onDidRemoveConnection.fire(Z)})})})}get connections(){const C=[];return this._connections.forEach(Y=>C.push(Y)),C}getChannel(C,Y){const O=this;return{call(T,_,j){let X;if((0,E.isFunction)(Y)){let N=(0,v.getRandomElement)(O.connections.filter(Y));X=N?Promise.resolve(N):d.Event.toPromise(d.Event.filter(O.onDidAddConnection,Y))}else X=Y.routeCall(O,T,_);const $=X.then(N=>N.channelClient.getChannel(C));return q($).call(T,_,j)},listen(T,_){if((0,E.isFunction)(Y))return O.getMulticastEvent(C,Y,T,_);const j=Y.routeEvent(O,T,_).then(X=>X.channelClient.getChannel(C));return q(j).listen(T,_)}}}getMulticastEvent(C,Y,O,T){const _=this;let j=new w.DisposableStore;const X=new d.Emitter({onFirstListenerAdd:()=>{j=new w.DisposableStore;const $=new d.EventMultiplexer,N=new Map,Z=oe=>{const ne=oe.channelClient.getChannel(C).listen(O,T),ae=$.add(ne);N.set(oe,ae)},ie=oe=>{const le=N.get(oe);!le||(le.dispose(),N.delete(oe))};_.connections.filter(Y).forEach(Z),d.Event.filter(_.onDidAddConnection,Y)(Z,void 0,j),_.onDidRemoveConnection(ie,void 0,j),$.event(X.fire,X,j),j.add($)},onLastListenerRemove:()=>{j.dispose()}});return X.event}registerChannel(C,Y){this.channels.set(C,Y),this._connections.forEach(O=>{O.channelServer.registerChannel(C,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class W{constructor(C,Y,O=null){const T=new h;l(T,Y),C.send(T.buffer),this.channelClient=new L(C,O),this.channelServer=new p(C,Y,O)}getChannel(C){return this.channelClient.getChannel(C)}registerChannel(C,Y){this.channelServer.registerChannel(C,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function q(U){return{call(C,Y,O){return U.then(T=>T.call(C,Y,O))},listen(C,Y){const O=new d.Relay;return U.then(T=>O.input=T.listen(C,Y)),O.event}}}e.getDelayedChannel=q;function x(U){let C=!1;return{call(Y,O,T){return C?U.call(Y,O,T):(0,R.timeout)(0).then(()=>C=!0).then(()=>U.call(Y,O,T))},listen(Y,O){if(C)return U.listen(Y,O);const T=new d.Relay;return(0,R.timeout)(0).then(()=>C=!0).then(()=>T.input=U.listen(Y,O)),T.event}}}e.getNextTickChannel=x;class re{constructor(C){this.fn=C}routeCall(C){return this.route(C)}routeEvent(C){return this.route(C)}async route(C){for(const Y of C.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await d.Event.toPromise(C.onDidAddConnection),await this.route(C)}}e.StaticRouter=re;var K;(function(U){function C(_,j){const X=_,$=j&&j.disableMarshalling,N=new Map;for(const Z in X)O(Z)&&N.set(Z,d.Event.buffer(X[Z],!0));return new class{listen(Z,ie,oe){const le=N.get(ie);if(le)return le;if(T(ie)){const ne=X[ie];if(typeof ne=="function")return ne.call(X,oe)}throw new Error(`Event not found: ${ie}`)}call(Z,ie,oe){const le=X[ie];if(typeof le=="function"){if(!$&&Array.isArray(oe))for(let ne=0;ne<oe.length;ne++)oe[ne]=(0,t.revive)(oe[ne]);return le.apply(X,oe)}throw new Error(`Method not found: ${ie}`)}}}U.fromService=C;function Y(_,j){const X=j&&j.disableMarshalling;return new Proxy({},{get($,N){if(typeof N=="string")return j?.properties?.has(N)?j.properties.get(N):T(N)?function(Z){return _.listen(N,Z)}:O(N)?_.listen(N):async function(...Z){let ie;j&&!(0,E.isUndefinedOrNull)(j.context)?ie=[j.context,...Z]:ie=Z;const oe=await _.call(N,ie);return X?oe:(0,t.revive)(oe)};throw new Error(`Property not found: ${String(N)}`)}})}U.toService=Y;function O(_){return _[0]==="o"&&_[1]==="n"&&I.isUpperAsciiLetter(_.charCodeAt(2))}function T(_){return/^onDynamic/.test(_)&&I.isUpperAsciiLetter(_.charCodeAt(9))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let C=U.toString();if(C!=="[object Object]")return C}return U}function H(U){return Array.isArray(U)?U.map(F):F(U)}function z(U,C,Y,O,T,_,j){j=H(j);const X=ee[T],$=X[O%X.length];let N=[`%c[${U}]%c[${String(C).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(O).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(_)?(N=N.concat(j),N.push(")")):N.push(j),console.log.apply(console,N)}e.logWithColors=z;class B{constructor(C,Y){this._outgoingPrefix=C,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(C,Y,O,T,_){this._totalOutgoing+=C,z(this._outgoingPrefix,this._totalOutgoing,C,Y,O,T,_)}logIncoming(C,Y,O,T,_){this._totalIncoming+=C,z(this._incomingPrefix,this._totalIncoming,C,Y,O,T,_)}}e.IPCLogger=B}),define(Q[119],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(D,M){this.sender=D,this.onMessage=M}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Q[120],J([0,1,18,4,35]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(d){this.port=d,this.onMessage=R.Event.fromDOMEventEmitter(this.port,"message",w=>v.VSBuffer.wrap(w.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class k extends D.IPCClient{constructor(d,w){const t=new M(d);super(t,w);this.protocol=t}dispose(){this.protocol.disconnect()}}e.Client=k}),define(Q[85],J([0,1,18,4,2,3,32,35]),function(V,e,v,R,D,M,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var d;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function t(){return w||(w=v.VSBuffer.alloc(0)),w}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,l){if(r===0)return t();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const L=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=r),L}if(this._chunks[0].byteLength>r){const L=this._chunks[0].slice(0,r);return l&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),L}let m=v.VSBuffer.alloc(r),p=0,P=0;for(;r>0;){const L=this._chunks[P];if(L.byteLength>r){const A=L.slice(0,r);m.set(A,p),p+=r,l&&(this._chunks[P]=L.slice(r),this._totalLength-=r),r-=r}else m.set(L,p),p+=L.byteLength,l?(this._chunks.shift(),this._totalLength-=L.byteLength):P++,r-=L.byteLength}return m}}e.ChunkStream=I;var E;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(E||(E={}));var S;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(S=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(r,l,m,p){this.type=r,this.id=l,this.ack=m,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends D.Disposable{constructor(r){super();this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const m=this._state.messageType,p=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new f(m,p,P,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class b{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=v.VSBuffer.alloc(13);l.writeUInt8(r.type,0),l.writeUInt32BE(r.id,1),l.writeUInt32BE(r.ack,5),l.writeUInt32BE(r.data.byteLength,9),this._writeSoon(l,r.data)}_bufferAdd(r,l){const m=this._totalLength===0;return this._data.push(r,l),this._totalLength+=r.byteLength+l.byteLength,m}_bufferTake(){const r=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,l){this._bufferAdd(r,l)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class y extends D.Disposable{constructor(r){super();this._onMessage=new R.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new b(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new f(1,0,0,r))}}e.Protocol=y;class c extends n.IPCClient{constructor(r,l,m=null){super(r,l,m);this.protocol=r}static fromSocket(r,l){return new c(new y(r),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=c;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new R.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class o{constructor(r){this.data=r,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],l=0,m=this._first;for(;m;)r[l++]=m.data,m=m.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const l=new o(r);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class i{constructor(){this.lastRuns=[];const r=Date.now();for(let l=0;l<i._HISTORY_LENGTH;l++)this.lastRuns[l]=r-1e3*l;setInterval(()=>{for(let l=i._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const r=Date.now(),l=(1+i._HISTORY_LENGTH)*1e3;let m=0;for(let p=0;p<i._HISTORY_LENGTH;p++)r-this.lastRuns[p]<=l&&m++;return 1-m/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class a{constructor(r,l=null,m=i.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=m,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new f(5,0,0,t());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const l=new f(4,0,0,t());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,l){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let l=0,m=r.length;l<m;l++)this._socketWriter.write(r[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new f(6,0,0,t())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const l=this._outgoingUnackMsg.toArray();for(let m=0,p=l.length;m<p;m++)this._socketWriter.write(l[m]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const m=new f(1,l,this._incomingAckId,r);this._outgoingUnackMsg.push(m),this._isReconnecting||(this._socketWriter.write(m),this._recvAckCheck())}sendControl(r){const l=new f(2,0,0,r);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),l=Date.now()-r.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new f(3,0,this._incomingAckId,t());this._socketWriter.write(r)}}e.PersistentProtocol=a}),define(Q[121],J([0,1,14,18,4,2,35,119]),function(V,e,v,R,D,M,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(t,I){const E=D.Event.fromNodeEventEmitter(v.ipcMain,I,(f,g)=>({event:f,message:g})),S=D.Event.filter(E,({event:f})=>f.sender.id===t);return D.Event.map(S,({message:f})=>f&&R.VSBuffer.wrap(f))}class w extends k.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const I=D.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:E})=>E);return D.Event.map(I,E=>{const S=E.id,f=w.Clients.get(S);f&&f.dispose();const g=new D.Emitter;w.Clients.set(S,(0,M.toDisposable)(()=>g.fire()));const b=d(S,"vscode:message"),y=D.Event.any(D.Event.signal(d(S,"vscode:disconnect")),g.event);return{protocol:new n.Protocol(E,b),onDidClientDisconnect:y}})}}e.Server=w,w.Clients=new Map}),define(Q[86],J([0,1,14,4,28,120]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class k extends M.Client{constructor(w,t){super({addEventListener:(I,E)=>w.addListener(I,E),removeEventListener:(I,E)=>w.removeListener(I,E),postMessage:I=>w.postMessage(I),start:()=>w.start(),close:()=>w.close()},t)}}e.Client=k;async function n(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,D.generateUuid)();d.webContents.send("vscode:createMessageChannel",w);const t=R.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(E,S)=>({nonce:S,port:E.ports[0]})),{port:I}=await R.Event.toPromise(R.Event.once(R.Event.filter(t,E=>E.nonce===w)));return I}e.connect=n}),define(Q[87],J([0,1,9,4,2,13]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function n(I){const E=I;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=n;var d;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(d||(d={}));class w extends D.Disposable{constructor(E,S=Object.create(null)){super();this.database=E,this.options=S,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((S,f)=>this.accept(f,S)),E.deleted?.forEach(S=>this.accept(S,void 0))}accept(E,S){if(this.state===d.Closed)return;let f=!1;(0,M.isUndefinedOrNull)(S)?f=this.cache.delete(E):this.cache.get(E)!==S&&(this.cache.set(E,S),f=!0),f&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,S){const f=this.cache.get(E);return(0,M.isUndefinedOrNull)(f)?S:f}getBoolean(E,S){const f=this.get(E);return(0,M.isUndefinedOrNull)(f)?S:f==="true"}getNumber(E,S){const f=this.get(E);return(0,M.isUndefinedOrNull)(f)?S:parseInt(f,10)}async set(E,S){if(this.state===d.Closed)return;if((0,M.isUndefinedOrNull)(S))return this.delete(E);const f=String(S);if(this.cache.get(E)!==f)return this.cache.set(E,f),this.pendingInserts.set(E,f),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async delete(E){if(!(this.state===d.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(E){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class t{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert&&E.insert.forEach((S,f)=>this.items.set(f,S)),E.delete&&E.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=t}),define(Q[122],J([0,1,9,4,40,8,19]),function(V,e,v,R,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(t,I=Object.create(null)){this.path=t,this.options=I,this.name=(0,M.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return R.Event.None}async getItems(){const t=await this.whenConnected,I=new Map;return(await this.all(t,"SELECT * FROM ItemTable")).forEach(S=>I.set(S.key,S.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(t){const I=await this.whenConnected;return this.doUpdateItems(I,t)}doUpdateItems(t,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,D.mapToString)(I.insert):"0"}), delete(${I.delete?(0,D.setToString)(I.delete):"0"})`),this.transaction(t,()=>{const E=I.insert,S=I.delete;if(E&&E.size>0){const f=[];f.push([]);let g=0;E.forEach((b,y)=>{let c=f[g];c.length>n.MAX_HOST_PARAMETERS&&(g++,c=[],f.push(c)),c.push(y,b)}),f.forEach(b=>{this.prepare(t,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,y=>y.run(b),()=>{const y=[];let c=0;return E.forEach((h,o)=>{y.push(o),c+=h.length}),`Keys: ${y.join(", ")} Length: ${c}`})})}if(S&&S.size){const f=[];f.push([]);let g=0;S.forEach(b=>{let y=f[g];y.length>n.MAX_HOST_PARAMETERS&&(g++,y=[],f.push(y)),y.push(b)}),f.forEach(b=>{this.prepare(t,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,y=>y.run(b),()=>{const y=[];return S.forEach(c=>{y.push(c)}),`Keys: ${y.join(", ")}`})})}})}async close(t){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,t)}doClose(t,I){return new Promise((E,S)=>{t.db.close(f=>(f&&this.handleSQLiteError(t,`[storage ${this.name}] close(): ${f}`),this.path===n.IN_MEMORY_PATH?E():!t.isErroneous&&!t.isInMemory?this.backup().then(E,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),E())):typeof I=="function"?k.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const b=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:I()}).then(()=>b(),y=>(b(),Promise.reject(y)))})).then(E,S):S(f||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const t=this.toBackupPath(this.path);return k.Promises.copy(this.path,t,{preserveSymlinks:!1})}toBackupPath(t){return`${t}.backup`}async checkIntegrity(t){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${t})`);const I=await this.whenConnected,E=await this.get(I,t?"PRAGMA integrity_check":"PRAGMA quick_check"),S=t?E.integrity_check:E.quick_check;return I.isErroneous?`${S} (last error: ${I.lastError})`:I.isInMemory?`${S} (in-memory!)`:S}async connect(t,I=!0){this.logger.trace(`[storage ${this.name}] open(${t}, retryOnBusy: ${I})`);try{return await this.doConnect(t)}catch(E){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&I)return await(0,v.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(t,!1);try{await k.Promises.unlink(t);try{await k.Promises.rename(this.toBackupPath(t),t)}catch(S){}return await this.doConnect(t)}catch(S){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${S}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(t,I){t.isErroneous=!0,t.lastError=I,this.logger.error(I)}doConnect(t){return new Promise((I,E)=>{new Promise((S,f)=>{V(["@vscode/sqlite3"],S,f)}).then(S=>{const f={db:new(this.logger.isTracing?S.verbose().Database:S.Database)(t,g=>g?f.db?f.db.close(()=>E(g)):E(g):this.exec(f,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(f),b=>f.db.close(()=>E(b)))),isInMemory:t===n.IN_MEMORY_PATH};f.db.on("error",g=>this.handleSQLiteError(f,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&f.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},E)})}exec(t,I){return new Promise((E,S)=>{t.db.exec(I,f=>f?(this.handleSQLiteError(t,`[storage ${this.name}] exec(): ${f}`),S(f)):E())})}get(t,I){return new Promise((E,S)=>{t.db.get(I,(f,g)=>f?(this.handleSQLiteError(t,`[storage ${this.name}] get(): ${f}`),S(f)):E(g))})}all(t,I){return new Promise((E,S)=>{t.db.all(I,(f,g)=>f?(this.handleSQLiteError(t,`[storage ${this.name}] all(): ${f}`),S(f)):E(g))})}transaction(t,I){return new Promise((E,S)=>{t.db.serialize(()=>{t.db.run("BEGIN TRANSACTION"),I(),t.db.run("END TRANSACTION",f=>f?(this.handleSQLiteError(t,`[storage ${this.name}] transaction(): ${f}`),S(f)):E())})})}prepare(t,I,E,S){const f=t.db.prepare(I),g=b=>{this.handleSQLiteError(t,`[storage ${this.name}] prepare(): ${b} (${I}). Details: ${S()}`)};f.on("error",g),E(f),f.finalize(b=>{b&&g(b),f.removeListener("error",g)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class d{constructor(t){t&&typeof t.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=t.logTrace),t&&typeof t.logError=="function"&&(this.logError=t.logError)}get isTracing(){return!!this.logTrace}trace(t){this.logTrace&&this.logTrace(t)}error(t){this.logError&&this.logError(t)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[123],J([12,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(Q[124],J([0,1,123]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,D=R*60,M=D*24,k=M*7,n=M*30,d=M*365;function w(I,E){typeof I!="number"&&(I=I.getTime());const S=Math.round((new Date().getTime()-I)/1e3);if(S<-30)return(0,v.localize)(0,null,w(new Date().getTime()+S*1e3,!1));if(S<30)return(0,v.localize)(1,null);let f;return S<R?(f=S,E?f===1?(0,v.localize)(2,null,f):(0,v.localize)(3,null,f):f===1?(0,v.localize)(4,null,f):(0,v.localize)(5,null,f)):S<D?(f=Math.floor(S/R),E?f===1?(0,v.localize)(6,null,f):(0,v.localize)(7,null,f):f===1?(0,v.localize)(8,null,f):(0,v.localize)(9,null,f)):S<M?(f=Math.floor(S/D),E?f===1?(0,v.localize)(10,null,f):(0,v.localize)(11,null,f):f===1?(0,v.localize)(12,null,f):(0,v.localize)(13,null,f)):S<k?(f=Math.floor(S/M),E?f===1?(0,v.localize)(14,null,f):(0,v.localize)(15,null,f):f===1?(0,v.localize)(16,null,f):(0,v.localize)(17,null,f)):S<n?(f=Math.floor(S/k),E?f===1?(0,v.localize)(18,null,f):(0,v.localize)(19,null,f):f===1?(0,v.localize)(20,null,f):(0,v.localize)(21,null,f)):S<d?(f=Math.floor(S/n),E?f===1?(0,v.localize)(22,null,f):(0,v.localize)(23,null,f):f===1?(0,v.localize)(24,null,f):(0,v.localize)(25,null,f)):(f=Math.floor(S/d),E?f===1?(0,v.localize)(26,null,f):(0,v.localize)(27,null,f):f===1?(0,v.localize)(28,null,f):(0,v.localize)(29,null,f))}e.fromNow=w;function t(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(Q[125],J([12,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(Q[61],J([0,1,30,13,125]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(w,t){return t&&(w.stack||w.stacktrace)?D.localize(0,null,n(w),k(w.stack)||k(w.stacktrace)):n(w)}function k(w){return Array.isArray(w)?w.join(`
`):w}function n(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?D.localize(1,null,w.message):w.message||D.localize(2,null)}function d(w=null,t=!1){if(!w)return D.localize(3,null);if(Array.isArray(w)){const I=v.coalesce(w),E=d(I[0],t);return I.length>1?D.localize(4,null,E,I.length):E}if(R.isString(w))return w;if(w.detail){const I=w.detail;if(I.error)return M(I.error,t);if(I.exception)return M(I.exception,t)}return w.stack?M(w,t):w.message?w.message:D.localize(5,null)}e.toErrorMessage=d}),define(Q[126],J([12,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(Q[127],J([0,1,126]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class R{constructor(k,n,d=n){this.modifierLabels=[null],this.modifierLabels[2]=k,this.modifierLabels[1]=n,this.modifierLabels[3]=d}toLabel(k,n,d){if(n.length===0)return null;const w=[];for(let t=0,I=n.length;t<I;t++){const E=n[t],S=d(E);if(S===null)return null;w[t]=D(E,S,this.modifierLabels[k])}return w.join(" ")}}e.ModifierLabelProvider=R,e.UILabelProvider=new R({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new R({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new R({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new R({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(M,k,n){if(k===null)return"";const d=[];return M.ctrlKey&&d.push(n.ctrlKey),M.shiftKey&&d.push(n.shiftKey),M.altKey&&d.push(n.altKey),M.metaKey&&d.push(n.metaKey),k!==""&&d.push(k),d.join(n.separator)}}),define(Q[128],J([12,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(Q[72],J([0,1,44,33,10,43,8,3,32,81,13,111,19,128]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return w.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return w.TerminateResponseCode}});function f(i){switch(i){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(i,a){if(n.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};a&&(s.cwd=a);const r=v.execFile("taskkill",["/T","/F","/PID",i.pid.toString()],s);return new Promise(l=>{r.once("error",m=>{l({success:!1,error:m})}),r.once("exit",(m,p)=>{l(m===0?{success:!0}:{success:!1,code:m!==null?m:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?f(s.status):1})}else if(n.isLinux||n.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(r=>{v.execFile(s,[i.pid.toString()],{encoding:"utf8",shell:!0},(l,m,p)=>{r(l?{success:!1,error:l}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else i.kill("SIGKILL");return Promise.resolve({success:!0})}function b(i){!i||(delete i.DEBUG,n.isMacintosh&&delete i.DYLD_LIBRARY_PATH,n.isLinux&&delete i.LD_PRELOAD)}e.removeDangerousEnvVariables=b;function y(i=d.env){return i.comspec||"cmd.exe"}e.getWindowsShell=y;class c{constructor(a,s,r,l){if(s!==void 0&&r!==void 0&&l!==void 0)this.cmd=a,this.args=s,this.shell=r,this.options=l;else{const m=a;this.cmd=m.command,this.shell=m.isShellCommand,this.args=m.args.slice(0),this.options=m.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const m=Object.create(null);Object.keys(d.env).forEach(p=>{m[p]=d.env[p]}),Object.keys(this.options.env).forEach(p=>{m[p]=this.options.env[p]}),this.options.env=m}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const s=a.lastIndexOf(k.sep);return s!==-1&&(a=a.substring(s+1)),c.WellKnowCommands[a]?a:"other"}start(a){return n.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(d.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(s=>{let r,l;const m=new Promise((p,P)=>{r=p,l=P});if(s){let p=this.cmd;this.args&&(p=p+" "+this.args.join(" ")),this.childProcess=v.exec(p,this.options,(P,L,A)=>{this.childProcess=null;const W=P;W&&W.killed?l({killed:this.terminateRequested,stdout:L.toString(),stderr:A.toString()}):this.handleExec(r,a,P,L,A)})}else{let p=null;const P=L=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(L,r,a,l);const A={terminated:this.terminateRequested};t.isNumber(L)&&(A.cmdCode=L),r(A)};if(this.shell&&n.isWindows){const L=M.deepClone(this.options);L.windowsVerbatimArguments=!0,L.detached=!1;let A=!1,W=!1;const q=[];let x=this.ensureQuotes(this.cmd);q.push(x.value),A=x.quoted,this.args&&this.args.forEach(K=>{x=this.ensureQuotes(K),q.push(x.value),W=W&&x.quoted});const re=["/s","/c"];A?W?re.push('"'+q.join(" ")+'"'):q.length>1?re.push('"'+q[0]+'" '+q.slice(1).join(" ")):re.push('"'+q[0]+'"'):re.push(q.join(" ")),p=v.spawn(y(),re,L)}else this.cmd&&(p=v.spawn(this.cmd,this.args,this.options));p&&(this.childProcess=p,this.childProcessPromise=Promise.resolve(p),this.pidResolve&&(this.pidResolve(t.isNumber(p.pid)?p.pid:-1),this.pidResolve=void 0),p.on("error",L=>{this.childProcess=null,l({terminated:this.terminateRequested,error:L})}),p.pid&&(this.childProcess.on("close",P),this.handleSpawn(p,r,a,l,!0)))}return m})}handleClose(a,s,r,l){}ensureQuotes(a){return c.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,g(a,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!n.isWindows)return a(!1);const s=v.spawn(y(),["/s","/c"]);s.on("error",r=>a(!0)),s.on("exit",r=>a(!1))})}}e.AbstractProcess=c,c.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},c.regexp=/^[^"].* .*[^"]/;class h extends c{constructor(a,s,r,l){super(a,s,r,l);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,s,r,l,m){[l,m].forEach((p,P)=>{const L=new I.LineDecoder;L.write(p).forEach(q=>{s({line:q,source:P===0?0:1})});const W=L.end();W&&s({line:W,source:P===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,s,r,l,m){const p=new I.LineDecoder,P=new I.LineDecoder;a.stdout.on("data",L=>{p.write(L).forEach(W=>r({line:W,source:0}))}),a.stderr.on("data",L=>{P.write(L).forEach(W=>r({line:W,source:1}))}),this.stdoutLineDecoder=p,this.stderrLineDecoder=P}handleClose(a,s,r,l){const m=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;m&&r({line:m,source:0});const p=this.stderrLineDecoder?this.stderrLineDecoder.end():null;p&&r({line:p,source:1})}}e.LineProcess=h;function o(i){let a=[],s=!1;const r=function(l){if(s){a.push(l);return}(!i.send(l,p=>{if(p&&console.error(p),s=!1,a.length>0){const P=a.slice(0);a=[],P.forEach(L=>r(L))}})||n.isWindows)&&(s=!0)};return{send:r}}e.createQueuedSender=o;var u;(function(i){async function a(s,r,l){if(k.isAbsolute(s))return s;if(r===void 0&&(r=d.cwd()),k.dirname(s)!=="."||(l===void 0&&t.isString(d.env.PATH)&&(l=d.env.PATH.split(k.delimiter)),l===void 0||l.length===0))return k.join(r,s);async function p(P){if(await E.Promises.exists(P)){let L;try{L=await E.Promises.stat(P)}catch(A){A.message.startsWith("EACCES")&&(L=await E.Promises.lstat(P))}return L?!L.isDirectory():!1}return!1}for(let P of l){let L;if(k.isAbsolute(P)?L=k.join(P,s):L=k.join(r,P,s),await p(L))return L;let A=L+".com";if(await p(A)||(A=L+".exe",await p(A)))return A}return k.join(r,s)}i.findExecutable=a})(u=e.win32||(e.win32={}))}),define(Q[129],J([0,1,25,3,115,72]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(S,f){return S===1?R.isWindows?I():M.getWindowsShell(f):w(S,f)}e.getSystemShell=k;function n(S,f){return S===1?R.isWindows?E(f):M.getWindowsShell(f):w(S,f)}e.getSystemShellSync=n;let d=null;function w(S,f){if(R.isLinux&&S===2||R.isMacintosh&&S===3)return"/bin/bash";if(!d){let g;if(R.isWindows)g="/bin/bash";else{if(g=f.SHELL,!g)try{g=(0,v.userInfo)().shell}catch(b){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}d=g}return d}let t=null;async function I(){return t||(t=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),t}function E(S){if(t)return t;const f=R.isWindows&&parseFloat((0,v.release)())>=10,g=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${S.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?b:M.getWindowsShell(S)}}),define(Q[73],J([0,1,44,9,18,23,108,17,4,2,43,72,35]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends E.ChannelServer{constructor(b){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch(c){}},onMessage:d.Event.fromNodeEventEmitter(process,"message",y=>D.VSBuffer.wrap(Buffer.from(y,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=S;class f{constructor(b,y){this.modulePath=b,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new R.Delayer(c),this.child=null,this._client=null}getChannel(b){const y=this;return{call(c,h,o){return y.requestPromise(b,c,h,o)},listen(c,h){return y.requestEvent(b,c,h)}}}requestPromise(b,y,c,h=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(n.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(b),u=(0,R.createCancelablePromise)(s=>o.call(y,c,s)),i=h.onCancellationRequested(()=>u.cancel()),a=(0,w.toDisposable)(()=>u.cancel());return this.activeRequests.add(a),u.finally(()=>{i.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(b,y,c){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let h;const o=new d.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(b).listen(y,c)(o.fire,o),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,t.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,I.removeDangerousEnvVariables)(y.env),this.child=(0,v.fork)(this.modulePath,b,y);const c=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,k.isRemoteConsoleLog)(r)){(0,k.log)(r,`IPC Library: ${this.options.serverName}`);return}c.fire(D.VSBuffer.wrap(Buffer.from(r,"base64")))});const o=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,u=r=>this.child&&this.child.connected&&o.send(r.buffer.toString("base64")),i=c.event,a={send:u,onMessage:i};this._client=new E.ChannelClient(a);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,l)=>{process.removeListener("exit",s),this.activeRequests.forEach(m=>(0,w.dispose)(m)),this.activeRequests.clear(),r!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:l})})}return this._client}getCachedChannel(b){let y=this.channels.get(b);return y||(y=this.client.getChannel(b),this.channels.set(b,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=f}),define(Q[130],J([12,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(Q[131],J([12,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[132],J([12,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[133],J([12,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(Q[134],J([12,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(Q[135],J([12,11]),function(V,e){return V.create("vs/platform/environment/node/shellEnv",e)}),define(Q[136],J([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[137],J([12,11]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[138],J([12,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Q[139],J([12,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(Q[140],J([12,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(Q[141],J([12,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(Q[142],J([12,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[143],J([12,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[144],J([12,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[145],J([12,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Q[146],J([12,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(Q[147],J([12,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[148],J([12,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[149],J([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(Q[150],J([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[151],J([12,11]),function(V,e){return V.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[152],J([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[153],J([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[154],J([0,1,4,2]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(n,d,w){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(n,d,w){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class M extends R.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,d,w){this.channel.call("attach",[n,d,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,d){this.channel.call("terminate",[n,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,d){return this.channel.call("openExtensionDevelopmentHostWindow",[n,d])}}e.ExtensionHostDebugChannelClient=M}),define(Q[155],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(k){this.driver=k}listen(k,n){throw new Error(`No event found: ${n}`)}call(k,n,d){switch(n){case"click":return this.driver.click(d[0],d[1],d[2]);case"doubleClick":return this.driver.doubleClick(d);case"setValue":return this.driver.setValue(d[0],d[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(d);case"getElements":return this.driver.getElements(d[0],d[1]);case"getElementXY":return this.driver.getElementXY(d[0],d[1],d[2]);case"typeInEditor":return this.driver.typeInEditor(d[0],d[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(d);case"writeInTerminal":return this.driver.writeInTerminal(d[0],d[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=v;class R{constructor(k){this.channel=k}click(k,n,d){return this.channel.call("click",[k,n,d])}doubleClick(k){return this.channel.call("doubleClick",k)}setValue(k,n){return this.channel.call("setValue",[k,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(k){return this.channel.call("isActiveElement",k)}getElements(k,n){return this.channel.call("getElements",[k,n])}getElementXY(k,n,d){return this.channel.call("getElementXY",[k,n,d])}typeInEditor(k,n){return this.channel.call("typeInEditor",[k,n])}getTerminalBuffer(k){return this.channel.call("getTerminalBuffer",k)}writeInTerminal(k,n){return this.channel.call("writeInTerminal",[k,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=R;class D{constructor(k){this.channel=k}registerWindowDriver(k){return this.channel.call("registerWindowDriver",k)}reloadWindowDriver(k){return this.channel.call("reloadWindowDriver",k)}}e.WindowDriverRegistryChannelClient=D}),define(Q[156],J([0,1,124,47,10,8,32,15,7]),function(V,e,v,R,D,M,k,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(g,b,y){this._args=g,this.paths=b,this.productService=y}get appRoot(){return(0,M.dirname)(D.FileAccess.asFileUri("",V).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,n.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,n.joinPath)(d.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return d.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return d.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=k.env.VSCODE_PORTABLE;return g?d.URI.file((0,M.join)(g,"argv.json")):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,n.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,M.resolve)(g):(0,M.normalize)((0,M.join)(D.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,M.resolve)(g):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,M.resolve)(g);const b=k.env.VSCODE_EXTENSIONS;if(b)return b;const y=k.env.VSCODE_PORTABLE;return y?(0,M.join)(y,"extensions"):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(b=>/^[^:/?#]+?:\/\//.test(b)?d.URI.parse(b):d.URI.file((0,M.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?d.URI.parse(g):d.URI.file((0,M.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return t(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,n.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return d.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([R.memoize],w.prototype,"appRoot",null),he([R.memoize],w.prototype,"userHome",null),he([R.memoize],w.prototype,"userDataPath",null),he([R.memoize],w.prototype,"appSettingsHome",null),he([R.memoize],w.prototype,"tmpDir",null),he([R.memoize],w.prototype,"userRoamingDataHome",null),he([R.memoize],w.prototype,"settingsResource",null),he([R.memoize],w.prototype,"userDataSyncHome",null),he([R.memoize],w.prototype,"userDataSyncLogResource",null),he([R.memoize],w.prototype,"sync",null),he([R.memoize],w.prototype,"machineSettingsResource",null),he([R.memoize],w.prototype,"globalStorageHome",null),he([R.memoize],w.prototype,"workspaceStorageHome",null),he([R.memoize],w.prototype,"keybindingsResource",null),he([R.memoize],w.prototype,"keyboardLayoutResource",null),he([R.memoize],w.prototype,"argvResource",null),he([R.memoize],w.prototype,"snippetsHome",null),he([R.memoize],w.prototype,"isExtensionDevelopment",null),he([R.memoize],w.prototype,"untitledWorkspacesHome",null),he([R.memoize],w.prototype,"installSourcePath",null),he([R.memoize],w.prototype,"builtinExtensionsPath",null),he([R.memoize],w.prototype,"extensionsPath",null),he([R.memoize],w.prototype,"extensionDevelopmentLocationURI",null),he([R.memoize],w.prototype,"extensionDevelopmentKind",null),he([R.memoize],w.prototype,"extensionTestsLocationURI",null),he([R.memoize],w.prototype,"debugExtensionHost",null),he([R.memoize],w.prototype,"serviceMachineIdResource",null),he([R.memoize],w.prototype,"telemetryLogResource",null),he([R.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function t(f,g){return S(f["inspect-extensions"],f["inspect-brk-extensions"],5870,g,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=t;function I(f,g){return S(f["inspect-search"],f["inspect-brk-search"],5876,g,f.extensionEnvironment)}e.parseSearchPort=I;function E(f,g){return S(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,g,f.extensionEnvironment)}e.parsePtyHostPort=E;function S(f,g,b,y,c,h){const u=Number(g||f)||(y?null:b),i=u?Boolean(!!g):!1;let a;if(h)try{a=JSON.parse(h)}catch{}return{port:u,break:i,debugId:c,env:a}}}),define(Q[88],J([0,1,239,3,133]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(f,g,b=k){const y={},c=[],h=[];for(let a in g){const s=g[a];s.alias&&(y[a]=s.alias),s.type==="string"||s.type==="string[]"?(c.push(a),s.deprecates&&c.push(s.deprecates)):s.type==="boolean"&&(h.push(a),s.deprecates&&h.push(s.deprecates))}const o=v(f,{string:c,boolean:h,alias:y}),u={},i=o;u._=o._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(let a in g){const s=g[a];s.alias&&delete i[s.alias];let r=i[a];s.deprecates&&i.hasOwnProperty(s.deprecates)&&(r||(r=i[s.deprecates]),delete i[s.deprecates]),typeof r!="undefined"&&(s.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):s.type==="string"&&Array.isArray(r)&&(r=r.pop(),b.onMultipleValues(a,r)),u[a]=r),delete i[a]}for(let a in i)b.onUnknownOption(a);return u}e.parseArgs=n;function d(f,g){let b="";return g.args&&(Array.isArray(g.args)?b=` <${g.args.join("> <")}>`:b=` <${g.args}>`),g.alias?`-${g.alias} --${f}${b}`:`--${f}${b}`}function w(f,g){let b=0,y=[];for(const u in f){const i=f[u],a=d(u,i);b=Math.max(b,a.length),y.push([a,i.description])}let c=b+2+1;if(g-c<25)return y.reduce((u,i)=>u.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let h=g-c-1,o=[];for(const u of y){let i=u[0],a=I(u[1],h),s=t(c-i.length-2);o.push("  "+i+s+a[0]);for(let r=1;r<a.length;r++)o.push(t(c)+a[r])}return o}e.formatOptions=w;function t(f){return" ".repeat(f)}function I(f,g){let b=[];for(;f.length;){let y=f.length<g?f.length:f.lastIndexOf(" ",g),c=f.slice(0,y).trim();f=f.slice(y),b.push(c)}return b}function E(f,g,b,y,c=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${f} ${b}`];o.push(""),o.push(`${(0,D.localize)(32,null)}: ${g} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),o.push(""),c&&(R.isWindows?o.push((0,D.localize)(35,null,g)):o.push((0,D.localize)(36,null,g)),o.push(""));const u={};for(const i in y){const a=y[i];if(a.description&&a.cat){let s=u[a.cat];s||(u[a.cat]=s={}),s[i]=a}}for(let i in u){const a=i;let s=u[a];s&&(o.push(M[a]),o.push(...w(s,h)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=E;function S(f,g){return`${f||(0,D.localize)(37,null)}
${g||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=S}),define(Q[157],J([0,1,60,154,88]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends R.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,d,w){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1]):super.call(n,d,w)}async openExtensionDevelopmentHostWindow(n,d){const w=(0,D.parseArgs)(n,D.OPTIONS);w.debugRenderer=d;const t=w.extensionDevelopmentPath;if(!t)return{success:!1};const[I]=this.windowsMainService.openExtensionDevelopmentHostWindow(t,{context:5,cli:w});if(!d)return{success:!0};const E=I.win;if(!E)return{success:!0};const S=E.webContents.debugger;let f=S.isAttached()?Infinity:0;const g=(0,v.createServer)(b=>{f++==0&&S.attach();let y=!1;const c=u=>{y||b.write(JSON.stringify(u)+"\0")},h=(u,i,a,s)=>c({method:i,params:a,sessionId:s});E.on("close",()=>{S.removeListener("message",h),b.end(),y=!0}),S.addListener("message",h);let o=Buffer.alloc(0);b.on("data",u=>{o=Buffer.concat([o,u]);for(let i=o.indexOf(0);i!==-1;i=o.indexOf(0)){let a;try{const s=o.slice(0,i).toString("utf8");o=o.slice(i+1),a=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}S.sendCommand(a.method,a.params,a.sessionId).then(s=>c({id:a.id,sessionId:a.sessionId,result:s})).catch(s=>c({id:a.id,sessionId:a.sessionId,error:{code:0,message:s.message}}))}}),b.on("error",u=>{console.error("error on cdp pipe:",u)}),b.on("close",()=>{y=!0,--f==0&&S.detach()})});return await new Promise(b=>g.listen(0,b)),E.on("close",()=>g.close()),{rendererDebugPort:g.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function V(e,v,R,D){function M(n){const d=k(n),w=[d];return e.isAbsolute(d)||w.unshift(D),e.resolve(...w)}function k(n){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,R);const t=n["user-data-dir"];if(t)return t;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(I,"AppData","Roaming")}break;case"darwin":w=e.join(v.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,R)}return{getUserDataPath:M}}if(typeof define=="function")define(Q[158],J([0,240,25,10,15,32]),function(e,v,R,D,M,k){const n=M.dirname(D.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(M.joinPath(n,"package.json").fsPath);return V(v,R,d.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),R=require("os");module.exports=V(v,R,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[159],J([0,1,25,156,158]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends R.AbstractNativeEnvironmentService{constructor(n,d){super(n,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,D.getUserDataPath)(n)},d)}}e.NativeEnvironmentService=M}),define(Q[160],J([0,1,31,25,8]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(k){const n=(0,D.join)((0,R.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(n,""),k&&console.log(`Marker file for --wait created: ${n}`),n}catch(d){k&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFile=M}),define(Q[161],J([0,1,137]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function M(E){return E=E.trim(),E==="*"||R.test(E)}e.isValidVersionStr=M;function k(E){if(!M(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=E.match(R);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=k;function n(E){if(!E)return null;let S=E.majorBase,f=E.majorMustEqual,g=E.minorBase,b=E.minorMustEqual,y=E.patchBase,c=E.patchMustEqual;E.hasCaret&&(S===0||(b=!1),c=!1);let h=0;if(E.preRelease){const o=D.exec(E.preRelease);if(o){const[,u,i,a]=o;h=Date.UTC(Number(u),Number(i)-1,Number(a))}}return{majorBase:S,majorMustEqual:f,minorBase:g,minorMustEqual:b,patchBase:y,patchMustEqual:c,isMinimum:E.hasGreaterEquals,notBefore:h}}e.normalizeVersion=n;function d(E,S,f){let g;typeof E=="string"?g=n(k(E)):g=E;let b;S instanceof Date?b=S.getTime():typeof S=="string"&&(b=new Date(S).getTime());let y;if(typeof f=="string"?y=n(k(f)):y=f,!g||!y)return!1;let c=g.majorBase,h=g.minorBase,o=g.patchBase,u=y.majorBase,i=y.minorBase,a=y.patchBase,s=y.notBefore,r=y.majorMustEqual,l=y.minorMustEqual,m=y.patchMustEqual;return y.isMinimum?c>u?!0:c<u?!1:h>i?!0:h<i||b&&b<s?!1:o>=a:(c===1&&u===0&&(!r||!l||!m)&&(u=1,i=0,a=0,r=!0,l=!1,m=!1),c<u?!1:c>u?!r:h<i?!1:h>i?!l:o<a?!1:o>a?!m:!(b&&b<s))}e.isValidVersion=d;function w(E,S,f,g){return f.isBuiltin||typeof f.main=="undefined"?!0:I(E,S,f.engines.vscode,g)}e.isValidExtensionVersion=w;function t(E,S,f){return E==="*"||I(S,f,E)}e.isEngineValid=t;function I(E,S,f,g=[]){let b=n(k(f));if(!b)return g.push(v.localize(0,null,f)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return g.push(v.localize(1,null,f)),!1}else if(!b.majorMustEqual)return g.push(v.localize(2,null,f)),!1;return d(E,S,b)?!0:(g.push(v.localize(3,null,E,f)),!1)}}),define(Q[74],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(D,M=[],k=!1){this.ctor=D,this.staticArguments=M,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=v}),define(Q[162],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=v;class R{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let k of this._nodes.values())k.outgoing.size===0&&M.push(k);return M}insertEdge(M,k){const n=this.lookupOrInsertNode(M),d=this.lookupOrInsertNode(k);n.outgoing.set(this._hashFn(k),d),d.incoming.set(this._hashFn(M),n)}removeNode(M){const k=this._hashFn(M);this._nodes.delete(k);for(let n of this._nodes.values())n.outgoing.delete(k),n.incoming.delete(k)}lookupOrInsertNode(M){const k=this._hashFn(M);let n=this._nodes.get(k);return n||(n=new v(M),this._nodes.set(k,n)),n}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[k,n]of this._nodes)M.push(`${k}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,k]of this._nodes){const n=new Set([M]),d=this._findCycle(k,n);if(d)return d}}_findCycle(M,k){for(let[n,d]of M.outgoing){if(k.has(n))return[...k,n].join(" -> ");k.add(n);const w=this._findCycle(d,k);if(w)return w;k.delete(n)}}}e.Graph=R}),define(Q[5],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function d(w){return w[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=d})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function R(n,d,w,t){d[v.DI_TARGET]===d?d[v.DI_DEPENDENCIES].push({id:n,index:w,optional:t}):(d[v.DI_DEPENDENCIES]=[{id:n,index:w,optional:t}],d[v.DI_TARGET]=d)}function D(n){if(v.serviceIds.has(n))return v.serviceIds.get(n);const d=function(w,t,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(d,w,I,!1)};return d.toString=()=>n,v.serviceIds.set(n,d),d}e.createDecorator=D;function M(n){return n}e.refineServiceDecorator=M;function k(n){return function(d,w,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(n,d,t,!0)}}e.optional=k}),define(Q[75],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function R(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=R}),define(Q[89],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class R{constructor(M){this.machineId=M}encryption(){return new Promise((M,k)=>V(["vscode-encrypt"],M,k))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(k){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(k){return M}}}e.EncryptionMainService=R}),define(Q[48],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[163],J([0,1,10,136,5]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var M;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(M=e.TargetPlatform||(e.TargetPlatform={}));function k(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function n(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=n;function d(c,h){switch(c){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=d;function w(c,h){return h==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function t(c,h,o){return w(h,o)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===o?!0:I(o).includes(c)}e.isTargetPlatformCompatible=t;function I(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function E(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=E;var S;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var f;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var b;(function(c){c[c.None=0]="None",c[c.Install=1]="Install",c[c.Update=2]="Update"})(b=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class y extends Error{constructor(h,o){super(h);this.code=o,this.name=o}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",V).toString(!0),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(Q[164],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Q[90],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Q[165],J([0,1,44,10,8,3,81,19,72,138,90]),function(V,e,v,R,D,M,k,n,d,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=w.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends E{openTerminal(o,u){return this.spawnTerminal(v,o,d.getWindowsShell(),u)}spawnTerminal(o,u,i,a){const s=u.windowsExec||S.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const r=D.basename(s).toLowerCase();if(r==="cmder"||r==="cmder.exe")return o.spawn(s,a?[a]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push('""'),l.push(s),(r==="wt"||r==="wt.exe")&&l.push("-d ."),new Promise((m,p)=>{const P=b(process),L=o.spawn(i,l,{cwd:a,env:P});L.on("error",p),L.on("exit",()=>m())})}runInTerminal(o,u,i,a,s){const r="windowsExec"in s&&s.windowsExec?s.windowsExec:S.getDefaultTerminalWindows();return new Promise((l,m)=>{const p=`"${u} - ${I}"`,P=`""${i.join('" "')}" & pause"`,L=["/c","start",p,"/wait",r,"/c",P],A=Object.assign({},b(process),a);Object.keys(A).filter(x=>A[x]===null).forEach(x=>delete A[x]);const W={cwd:u,env:A,windowsVerbatimArguments:!0};v.spawn(S.CMD,L,W).on("error",x=>{m(y(x))}),l(void 0)})}static getDefaultTerminalWindows(){if(!S._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return S._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=S,S.CMD="cmd.exe";class f extends E{openTerminal(o,u){return this.spawnTerminal(v,o,u)}runInTerminal(o,u,i,a,s){const r=s.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((l,m)=>{if(r===t.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const p=r===t.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[R.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${p}.scpt`,V).fsPath,"-t",o||I,"-w",u];for(let q of i)L.push("-a"),L.push(q);if(a){const q=Object.assign({},b(process),a);for(let x in q){const re=q[x];re===null?(L.push("-u"),L.push(x)):(L.push("-e"),L.push(`${x}=${re}`))}}let A="";const W=v.spawn(f.OSASCRIPT,L);W.on("error",q=>{m(y(q))}),W.stderr.on("data",q=>{A+=q.toString()}),W.on("exit",q=>{if(q===0)l(void 0);else if(A){const x=A.split(`
`,1);m(new Error(x[0]))}else m(new Error(w.localize(1,null,p,q)))})}else m(new Error(w.localize(2,null,r)))})}spawnTerminal(o,u,i){const a=u.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((s,r)=>{const l=["-a",a];i&&l.push(i);const m=b(process),p=o.spawn("/usr/bin/open",l,{cwd:i,env:m});p.on("error",r),p.on("exit",()=>s())})}}e.MacExternalTerminalService=f,f.OSASCRIPT="/usr/bin/osascript";class g extends E{openTerminal(o,u){return this.spawnTerminal(v,o,u)}runInTerminal(o,u,i,a,s){const r=s.linuxExec?Promise.resolve(s.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,m)=>{let p=[];r.then(P=>{P.indexOf("gnome-terminal")>=0?p.push("-x"):p.push("-e"),p.push("bash"),p.push("-c");const L=`${c(i)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;p.push(`''${L}''`);const A=Object.assign({},b(process),a);Object.keys(A).filter(re=>A[re]===null).forEach(re=>delete A[re]);const W={cwd:u,env:A};let q="";const x=v.spawn(P,p,W);x.on("error",re=>{m(y(re))}),x.stderr.on("data",re=>{q+=re.toString()}),x.on("exit",re=>{if(re===0)l(void 0);else if(q){const K=q.split(`
`,1);m(new Error(K[0]))}else m(new Error(w.localize(4,null,P,re)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!M.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await n.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{o?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,u,i){const a=u.linuxExec?Promise.resolve(u.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,r)=>{a.then(l=>{const m=b(process),p=o.spawn(l,[],{cwd:i,env:m});p.on("error",r),p.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=w.localize(3,null);function b(h){const o={...h.env};return(0,k.sanitizeProcessEnvironment)(o),o}function y(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(w.localize(5,null,h.path)):h}function c(h){let o="";for(let u of h)u.indexOf(" ")>=0?o+='"'+u+'"':o+=u,o+=" ";return o}}),define(Q[20],J([0,1,40,8,27,13,7,140,5]),function(V,e,v,R,D,M,k,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function w(F){return F.create===!0}e.isFileOpenForWriteOptions=w;var t;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var I;(function(F){F[F.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var E;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=S;function f(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=f;function g(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function b(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=b;var y;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(H,z){super(H);this.code=z}}e.FileSystemProviderError=c;function h(F,H){const z=new c(F.toString(),H);return u(z,H),z}e.createFileSystemProviderError=h;function o(F){return F||h((0,n.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=o;function u(F,H){return F.name=H?`${H} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=u;function i(F){if(!F)return y.Unknown;if(F instanceof c)return F.code;const H=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!H)return y.Unknown;switch(H[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=i;function a(F){if(F instanceof P)return F.fileOperationResult;switch(i(F)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var s;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(H,z,B){this.resource=H,this.operation=z,this.target=B}isOperation(H){return this.operation===H}}e.FileOperationEvent=r;var l;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class m{constructor(H,z){this.added=void 0,this.updated=void 0,this.deleted=void 0;const B=new Map;for(const U of H){const C=B.get(U.type);C?C.push([U.resource,U]):B.set(U.type,[[U.resource,U]])}for(const[U,C]of B)switch(U){case 1:this.added=v.TernarySearchTree.forUris(()=>z),this.added.fill(C);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>z),this.updated.fill(C);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>z),this.deleted.fill(C);break}}contains(H,...z){return this.doContains(H,{includeChildren:!1},...z)}affects(H,...z){return this.doContains(H,{includeChildren:!0},...z)}doContains(H,z,...B){if(!H)return!1;const U=B.length>0;return!!((!U||B.includes(1))&&(this.added?.get(H)||z.includeChildren&&this.added?.findSuperstr(H))||(!U||B.includes(0))&&(this.updated?.get(H)||z.includeChildren&&this.updated?.findSuperstr(H))||(!U||B.includes(2))&&(this.deleted?.findSubstr(H)||z.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function p(F,H,z){return!F||!H||F===H||H.length>F.length?!1:(H.charAt(H.length-1)!==R.sep&&(H+=R.sep),z?(0,D.startsWithIgnoreCase)(F,H):F.indexOf(H)===0)}e.isParent=p;class P extends Error{constructor(H,z,B){super(H);this.fileOperationResult=z,this.options=B}}e.FileOperationError=P;class L extends P{constructor(H,z,B){super(H,2,B);this.stat=z}}e.NotModifiedSinceFileOperationError=L;var A;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var W;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(W=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function q(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=q;async function x(F,H){if(!H.hasProvider(k.URI.from({scheme:F.scheme})))return new Promise(z=>{const B=H.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===F.scheme&&U.added&&(B.dispose(),z())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(H){return(0,M.isNumber)(H)||(H=0),H<re.KB?(0,n.localize)(1,null,H.toFixed(0)):H<re.MB?(0,n.localize)(2,null,(H/re.KB).toFixed(2)):H<re.GB?(0,n.localize)(3,null,(H/re.MB).toFixed(2)):H<re.TB?(0,n.localize)(4,null,(H/re.GB).toFixed(2)):(0,n.localize)(5,null,(H/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var K;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function ee(F){return{maxFileSize:F===0?300*re.MB:16*re.GB,maxHeapSize:F===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=ee}),define(Q[54],J([0,1,241,134,88,20]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(E,S){const f={onUnknownOption:b=>{console.warn((0,R.localize)(0,null,b))},onMultipleValues:(b,y)=>{console.warn((0,R.localize)(1,null,b,y))}},g=(0,D.parseArgs)(E,D.OPTIONS,S?f:void 0);return g.goto&&g._.forEach(b=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,R.localize)(2,null))),g["max-memory"]&&v(parseInt(g["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function n(E){const S=E.findIndex(f=>!/^-/.test(f));if(S>-1)return[...E.slice(0,S),...E.slice(S+1)]}function d(E){let[,...S]=E;process.env.VSCODE_DEV&&(S=n(S)||[]);const f=!I(process.env);return k(S,f)}e.parseMainProcessArgv=d;function w(E){const[,,...S]=E;return k(S,!0)}e.parseCLIProcessArgv=w;function t(E,...S){const f=E.indexOf("--");return f===-1?E.push(...S):E.splice(f,0,...S),E}e.addArg=t;function I(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(Q[91],J([0,1,44,8,135,23,61,17,3,28,129,54,9]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const S=1e4;let f;async function g(y,c,h){return c["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(h)&&!c["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(h)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=E.Promises.withAsyncBody(async(o,u)=>{const i=new M.CancellationTokenSource,a=setTimeout(()=>{i.dispose(!0),u(new Error((0,D.localize)(0,null)))},S);try{o(await b(y,i.token))}catch(s){!(0,n.isPromiseCanceledError)(s)&&!i.token.isCancellationRequested?u(new Error((0,D.localize)(1,null,(0,k.toErrorMessage)(s)))):o({})}finally{clearTimeout(a),i.dispose()}})),f)}e.resolveShellEnv=g;async function b(y,c){const h=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",o);const u=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(u+"(.*)"+u),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};y.trace("getUnixShellEnvironment#env",a);const s=await(0,t.getSystemShell)(d.OS,a);return y.trace("getUnixShellEnvironment#shell",s),new Promise((r,l)=>{if(c.isCancellationRequested)return l((0,n.canceled)());const m=(0,R.basename)(s);let p,P;/^pwsh(-preview)?$/.test(m)?(p=`& '${process.execPath}' -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,P=["-Login","-Command"]):(p=`'${process.execPath}' -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,P=["-ilc"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),p);const L=(0,v.spawn)(s,[...P,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});c.onCancellationRequested(()=>(L.kill(),l((0,n.canceled)()))),L.on("error",q=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(q)),l(q)});const A=[];L.stdout.on("data",q=>A.push(q));const W=[];L.stderr.on("data",q=>W.push(q)),L.on("close",(q,x)=>{const re=Buffer.concat(A).toString("utf8");y.trace("getUnixShellEnvironment#raw",re);const K=Buffer.concat(W).toString("utf8");if(K.trim()&&y.trace("getUnixShellEnvironment#stderr",K),q||x)return l(new Error((0,D.localize)(2,null,q,x)));const ee=i.exec(re),F=ee?ee[1]:"{}";try{const H=JSON.parse(F);h?H.ELECTRON_RUN_AS_NODE=h:delete H.ELECTRON_RUN_AS_NODE,o?H.ELECTRON_NO_ATTACH_CONSOLE=o:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",H),r(H)}catch(H){y.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(H)),l(H)}})})}}),define(Q[55],J([0,1,2,3,7,20]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=e.WatcherService=void 0;class k extends v.Disposable{}e.WatcherService=k;function n(t){return t.map(I=>({type:I.type,resource:D.URI.file(I.path)}))}e.toFileChanges=n;function d(t){const I=new w;for(const E of t)I.processEvent(E);return I.normalize()}e.normalizeFileChanges=d;class w{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(I){return R.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const E=this.mapPathToChange.get(this.toKey(I));let S=!1;if(E){const f=E.type,g=I.type;E.path!==I.path&&I.type===2?S=!0:f===1&&g===2?(this.mapPathToChange.delete(this.toKey(I)),this.normalized.delete(E)):f===2&&g===1?E.type=0:f===1&&g===0||(E.type=g)}else S=!0;S&&(this.normalized.add(I),this.mapPathToChange.set(this.toKey(I),I))}normalize(){const I=[],E=[];return Array.from(this.normalized).filter(S=>S.type!==2?(I.push(S),!1):!0).sort((S,f)=>S.path.length-f.path.length).filter(S=>E.some(f=>(0,M.isParent)(S.path,f,!R.isLinux))?!1:(E.push(S.path),!0)).concat(I)}}}),define(Q[166],J([0,1,9,2,8,83,19,116,55]),function(V,e,v,R,D,M,k,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends R.Disposable{constructor(I,E,S,f){super();this.path=I,this.onDidFilesChange=E,this.onLogMessage=S,this.verboseLogging=f,this.fileChangesDelayer=this._register(new v.ThrottledDelayer(n.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:E}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let S=this.path;if(E)try{S=await(0,M.realpath)(S)}catch(f){if(this.onError(f),E.dangling)return}I.isDirectory()?this._register((0,n.watchFolder)(S,(f,g)=>{this.onFileChange({type:f==="changed"?0:f==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(g))})},f=>this.onError(f))):this._register((0,n.watchFile)(S,f=>{this.onFileChange({type:f==="changed"?0:2,path:this.path})},f=>this.onError(f)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,d.normalizeFileChanges)(E);if(this.verboseLogging)for(const f of S)this.onVerbose(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);S.length>0&&this.onDidFilesChange(S)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(Q[167],J([0,1,10,35,73,55]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends M.WatcherService{constructor(d,w,t,I){super();this.requests=d,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(d.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.watch(this.requests)}async setVerboseLogging(d){this.verboseLogging=d,this.isDisposed||await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${d}`})}async watch(d){this.requests=d,await this.service?.watch(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Q[168],J([0,1,10,35,73,55]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends M.WatcherService{constructor(d,w,t,I){super();this.requests=d,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(d.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.watch(this.requests)}async setVerboseLogging(d){this.verboseLogging=d,this.isDisposed||await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${d}`})}async watch(d){this.requests=d,await this.service?.watch(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Q[169],J([0,1,10,35,73,55]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends M.WatcherService{constructor(d,w,t,I,E={}){super();this.requests=d,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=I,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherServiceChokidar"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(d.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.watch(this.requests)}async setVerboseLogging(d){this.verboseLogging=d,this.isDisposed||await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${d}`})}async watch(d){this.requests=d,await this.service?.watch(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Q[76],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(let[M,k]of D)this.set(M,k)}set(D,M){const k=this._entries.get(D);return this._entries.set(D,M),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(Q[170],J([0,1,9,17,74,162,5,76]),function(V,e,v,R,D,M,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const d=!1;class w extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class t{constructor(f=new n.ServiceCollection,g=!1,b){this._activeInstantiations=new Set,this._services=f,this._strict=g,this._parent=b,this._services.set(k.IInstantiationService,this)}createChild(f){return new t(f,this._strict,this)}invokeFunction(f,...g){let b=E.traceInvocation(f),y=!1;try{return f({get:(h,o)=>{if(y)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(h,b);if(!u&&o!==k.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return u}},...g)}finally{y=!0,b.stop()}}createInstance(f,...g){let b,y;return f instanceof D.SyncDescriptor?(b=E.traceCreation(f.ctor),y=this._createInstance(f.ctor,f.staticArguments.concat(g),b)):(b=E.traceCreation(f),y=this._createInstance(f,g,b)),b.stop(),y}_createInstance(f,g=[],b){let y=k._util.getServiceDependencies(f).sort((o,u)=>o.index-u.index),c=[];for(const o of y){let u=this._getOrCreateServiceInstance(o.id,b);if(!u&&this._strict&&!o.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${o.id}.`);c.push(u)}let h=y.length>0?y[0].index:g.length;if(g.length!==h){console.warn(`[createInstance] First service dependency of ${f.name} at position ${h+1} conflicts with ${g.length} static arguments`);let o=h-g.length;o>0?g=g.concat(new Array(o)):g=g.slice(0,h)}return new f(...[...g,...c])}_setServiceInstance(f,g){if(this._services.get(f)instanceof D.SyncDescriptor)this._services.set(f,g);else if(this._parent)this._parent._setServiceInstance(f,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let g=this._services.get(f);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):g}_getOrCreateServiceInstance(f,g){let b=this._getServiceInstanceOrDescriptor(f);return b instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,b,g.branch(f,!0)):(g.branch(f,!1),b)}_safeCreateAndCacheServiceInstance(f,g,b){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,g,b)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,g,b){const y=new M.Graph(o=>o.id.toString());let c=0;const h=[{id:f,desc:g,_trace:b}];for(;h.length;){const o=h.pop();if(y.lookupOrInsertNode(o),c++>1e3)throw new w(y);for(let u of k._util.getServiceDependencies(o.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(u.id);if(!i&&!u.optional&&console.warn(`[createInstance] ${f} depends on ${u.id} which is NOT registered.`),i instanceof D.SyncDescriptor){const a={id:u.id,desc:i,_trace:o._trace.branch(u.id,!0)};y.insertEdge(o,a),h.push(a)}}}for(;;){const o=y.roots();if(o.length===0){if(!y.isEmpty())throw new w(y);break}for(const{data:u}of o){if(this._getServiceInstanceOrDescriptor(u.id)instanceof D.SyncDescriptor){const a=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,a)}y.removeNode(u)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,g,b=[],y,c){if(this._services.get(f)instanceof D.SyncDescriptor)return this._createServiceInstance(g,b,y,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,g,b,y,c);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(f,g=[],b,y){if(b){const c=new v.IdleValue(()=>this._createInstance(f,g,y));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let u=c.value,i=u[o];return typeof i!="function"||(i=i.bind(u),h[o]=i),i},set(h,o,u){return c.value[o]=u,!0}})}else return this._createInstance(f,g,y)}}e.InstantiationService=t;var I;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(I||(I={}));class E{constructor(f,g){this.type=f,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return d?new E(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(f){return d?new E(0,f.name):E._None}branch(f,g){let b=new E(2,f.toString());return this._dep.push([f,g,b]),b}stop(){let f=Date.now()-this._start;E._totals+=f;let g=!1;function b(c,h){let o=[],u=new Array(c+1).join("	");for(const[i,a,s]of h._dep)if(a&&s){g=!0,o.push(`${u}CREATES -> ${i}`);let r=b(c+1,s);r&&o.push(r)}else o.push(`${u}uses -> ${i}`);return o.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(f>2||g)&&console.log(y.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(Q[171],J([0,1,17,127,58]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends D.ResolvedKeybinding{constructor(n,d){super();if(d.length===0)throw(0,v.illegalArgument)("parts");this._os=n,this._parts=d}getLabel(){return R.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return R.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:R.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return R.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new D.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=M}),define(Q[172],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class v{constructor(M,k,n,d,w,t,I){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=M,this.keypressParts=M?R(M.getDispatchParts()):[],M&&this.keypressParts.length===0&&(this.keypressParts=R(M.getSingleModifierDispatchParts())),this.bubble=k?k.charCodeAt(0)===94:!1,this.command=this.bubble?k.substr(1):k,this.commandArgs=n,this.when=d,this.isDefault=w,this.extensionId=t,this.isBuiltinExtension=I}}e.ResolvedKeybindingItem=v;function R(D){let M=[];for(let k=0,n=D.length;k<n;k++){const d=D[k];if(!d)return M;M.push(d)}return M}e.removeElementsAfterNulls=R}),define(Q[173],J([0,1,58,68,171,172]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends D.BaseResolvedKeybinding{constructor(d,w){super(w,d.parts)}_keyCodeToUILabel(d){if(this._os===2)switch(d){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(d)}_getLabel(d){return d.isDuplicateModifierCase()?"":this._keyCodeToUILabel(d.keyCode)}_getAriaLabel(d){return d.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(d.keyCode)}_getElectronAccelerator(d){return v.KeyCodeUtils.toElectronAccelerator(d.keyCode)}_getUserSettingsLabel(d){if(d.isDuplicateModifierCase())return"";const w=v.KeyCodeUtils.toUserSettingsUS(d.keyCode);return w&&w.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(d){return k.getDispatchStr(d)}static getDispatchStr(d){if(d.isModifierKey())return null;let w="";return d.ctrlKey&&(w+="ctrl+"),d.shiftKey&&(w+="shift+"),d.altKey&&(w+="alt+"),d.metaKey&&(w+="meta+"),w+=v.KeyCodeUtils.toString(d.keyCode),w}_getSingleModifierDispatchPart(d){return d.keyCode===5&&!d.shiftKey&&!d.altKey&&!d.metaKey?"ctrl":d.keyCode===4&&!d.ctrlKey&&!d.altKey&&!d.metaKey?"shift":d.keyCode===6&&!d.ctrlKey&&!d.shiftKey&&!d.metaKey?"alt":d.keyCode===57&&!d.ctrlKey&&!d.shiftKey&&!d.altKey?"meta":null}static _scanCodeToKeyCode(d){const w=R.IMMUTABLE_CODE_TO_KEY_CODE[d];if(w!==-1)return w;switch(d){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(d){if(!d)return null;if(d instanceof v.SimpleKeybinding)return d;const w=this._scanCodeToKeyCode(d.scanCode);return w===0?null:new v.SimpleKeybinding(d.ctrlKey,d.shiftKey,d.altKey,d.metaKey,w)}static resolveUserBinding(d,w){const t=(0,M.removeElementsAfterNulls)(d.map(I=>this._resolveSimpleUserBinding(I)));return t.length>0?[new k(new v.ChordKeybinding(t),w)]:[]}}e.USLayoutResolvedKeybinding=k}),define(Q[174],J([0,1,9]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function R(D,M){if(D.length===0)return Promise.resolve(!1);const k=[];let n=!1;for(let d of D){if(d===!0)return Promise.resolve(!0);(0,v.isThenable)(d)&&k.push(d.then(w=>{w&&(n=!0)},w=>{M(w),n=!0}))}return v.Promises.settled(k).then(()=>n)}e.handleVetos=R}),define(Q[6],J([0,1,61,4,2,3,5]),function(V,e,v,R,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function n(){return new Date().toISOString()}var d;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;class w extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class t extends w{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...a){this.checkLogLevel(d.Trace)&&this.log(d.Trace,this.format([i,...a]))}debug(i,...a){this.checkLogLevel(d.Debug)&&this.log(d.Debug,this.format([i,...a]))}info(i,...a){this.checkLogLevel(d.Info)&&this.log(d.Info,this.format([i,...a]))}warn(i,...a){this.checkLogLevel(d.Warning)&&this.log(d.Warning,this.format([i,...a]))}error(i,...a){if(this.checkLogLevel(d.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(d.Error,this.format(s))}else this.log(d.Error,this.format([i,...a]))}critical(i,...a){this.checkLogLevel(d.Critical)&&this.log(d.Critical,this.format([i,...a]))}flush(){}format(i){let a="";for(let s=0;s<i.length;s++){let r=i[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}a+=(s>0?" ":"")+r}return a}}e.AbstractMessageLogger=t;class I extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!M.isWindows}trace(i,...a){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...a):console.log(`[main ${n()}]`,i,...a))}debug(i,...a){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...a):console.log(`[main ${n()}]`,i,...a))}info(i,...a){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...a):console.log(`[main ${n()}]`,i,...a))}warn(i,...a){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,i,...a):console.warn(`[main ${n()}]`,i,...a))}error(i,...a){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,i,...a):console.error(`[main ${n()}]`,i,...a))}critical(i,...a){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,i,...a):console.error(`[main ${n()}]`,i,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class E extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...a){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",i,...a)}debug(i,...a){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...a)}info(i,...a){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",i,...a)}warn(i,...a){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",i,...a)}error(i,...a){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",i,...a)}critical(i,...a){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...a)}dispose(){}flush(){}}e.ConsoleLogger=E;class S extends w{constructor(i,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(a)}trace(i,...a){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(i),...a])}debug(i,...a){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(i),...a])}info(i,...a){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(i),...a])}warn(i,...a){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(i),...a])}error(i,...a){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(i),...a])}critical(i,...a){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(i),...a])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class f extends w{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const a of this.logServices)a.setLevel(i);super.setLevel(i)}trace(i,...a){for(const s of this.logServices)s.trace(i,...a)}debug(i,...a){for(const s of this.logServices)s.debug(i,...a)}info(i,...a){for(const s of this.logServices)s.info(i,...a)}warn(i,...a){for(const s of this.logServices)s.warn(i,...a)}error(i,...a){for(const s of this.logServices)s.error(i,...a)}critical(i,...a){for(const s of this.logServices)s.critical(i,...a)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=f;class g extends D.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...a){this.logger.trace(i,...a)}debug(i,...a){this.logger.debug(i,...a)}info(i,...a){this.logger.info(i,...a)}warn(i,...a){this.logger.warn(i,...a)}error(i,...a){this.logger.error(i,...a)}critical(i,...a){this.logger.critical(i,...a)}flush(){this.logger.flush()}}e.LogService=g;class b extends D.Disposable{constructor(i,a){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,a){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,a?.always?d.Trace:this.logLevel,a),this.loggers.set(i.toString(),s),a?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class y{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(i){}getLevel(){return d.Info}trace(i,...a){}debug(i,...a){}info(i,...a){}warn(i,...a){}error(i,...a){}critical(i,...a){}dispose(){}flush(){}}e.NullLogService=y;function c(u){if(u.verbose)return d.Trace;if(typeof u.logLevel=="string"){const i=h(u.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function h(u){switch(u){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=h;function o(u){switch(u){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=o});var te=this&&this.__param||function(V,e){return function(v,R){e(v,R,V)}};define(Q[175],J([0,1,9,18,39,80,48,20,5,6]),function(V,e,v,R,D,M,k,n,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var t;(function(E){E.ERROR_INVALID_FILE="ERROR_INVALID_FILE",E.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(t=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,d.createDecorator)(e.UserConfigurationFileServiceId);let I=class{constructor(S,f,g){this.environmentService=S,this.fileService=f,this.logService=g,this.queue=new v.Queue}async updateSettings(S,f){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,S,f))}async doWrite(S,f,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,S.toString(),f);const{value:b,mtime:y,etag:c}=await this.fileService.readFile(S,{atomic:!0});let h=b.toString();const o=[];if((0,D.parse)(h,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const u=this.getEdits(f,h,g)[0];if(u){h=h.substring(0,u.offset)+u.content+h.substring(u.offset+u.length);try{await this.fileService.writeFile(S,R.VSBuffer.fromString(h),{etag:c,mtime:y})}catch(i){if(i.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:S,path:f},g,b){return f.length?(0,M.setProperty)(g,f,S,b):[{content:JSON.stringify(S,null,b.insertSpaces&&b.tabSize?" ".repeat(b.tabSize):"	"),length:g.length,offset:0}]}};I=he([te(0,k.IEnvironmentService),te(1,n.IFileService),te(2,w.ILogService)],I),e.UserConfigurationFileService=I}),define(Q[92],J([0,1,6]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function R(M,k){switch(k){case v.LogLevel.Trace:return M.trace;case v.LogLevel.Debug:return M.debug;case v.LogLevel.Info:return M.info;case v.LogLevel.Warning:return M.warn;case v.LogLevel.Error:return M.error;case v.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class D extends v.AbstractLogger{constructor(k=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(k){this._logger=k;for(const{level:n,args:d}of this.buffer)R(k,n).apply(k,d);this.buffer=[]}_log(k,...n){this._logger?R(this._logger,k).apply(this._logger,n):this.getLevel()<=k&&this.buffer.push({level:k,args:n})}trace(k,...n){this._log(v.LogLevel.Trace,k,...n)}debug(k,...n){this._log(v.LogLevel.Debug,k,...n)}info(k,...n){this._log(v.LogLevel.Info,k,...n)}warn(k,...n){this._log(v.LogLevel.Warning,k,...n)}error(k,...n){this._log(v.LogLevel.Error,k,...n)}critical(k,...n){this._log(v.LogLevel.Critical,k,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(Q[176],J([0,1,9,18,15,20,5,92,6]),function(V,e,v,R,D,M,k,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*M.ByteSize.MB;let t=class extends d.AbstractLogger{constructor(S,f,g,b,y){super();this.name=S,this.resource=f,this.donotUseFormatters=b,this.fileService=y,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=d.LogLevel.Trace&&this._log(d.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=d.LogLevel.Debug&&this._log(d.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=d.LogLevel.Info&&this._log(d.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=d.LogLevel.Warning&&this._log(d.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=d.LogLevel.Error){const S=arguments[0];if(S instanceof Error){const f=Array.prototype.slice.call(arguments);f[0]=S.stack,this._log(d.LogLevel.Error,this.format(f))}else this._log(d.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=d.LogLevel.Critical&&this._log(d.LogLevel.Critical,this.format(arguments))}flush(){}log(S,f){this._log(S,this.format(f))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(S){if(S.fileOperationResult!==3)throw S}}_log(S,f){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>w&&(await this.fileService.writeFile(this.getBackupResource(),R.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=f:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(S)}] ${f}
`,await this.fileService.writeFile(this.resource,R.VSBuffer.fromString(g))})}getCurrentTimestamp(){const S=b=>b<10?`0${b}`:b,f=b=>b<10?`00${b}`:b<100?`0${b}`:b,g=new Date;return`${g.getFullYear()}-${S(g.getMonth()+1)}-${S(g.getDate())} ${S(g.getHours())}:${S(g.getMinutes())}:${S(g.getSeconds())}.${f(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(S){return""}}stringifyLogLevel(S){switch(S){case d.LogLevel.Critical:return"critical";case d.LogLevel.Debug:return"debug";case d.LogLevel.Error:return"error";case d.LogLevel.Info:return"info";case d.LogLevel.Trace:return"trace";case d.LogLevel.Warning:return"warning"}return""}format(S){let f="";for(let g=0;g<S.length;g++){let b=S[g];if(typeof b=="object")try{b=JSON.stringify(b)}catch(y){}f+=(g>0?" ":"")+b}return f}};t=he([te(4,M.IFileService)],t),e.FileLogger=t;let I=class extends d.AbstractLoggerService{constructor(S,f,g){super(S.getLevel(),S.onDidChangeLogLevel);this.instantiationService=f,this.fileService=g}doCreateLogger(S,f,g){const b=new n.BufferLogService(f);return(0,M.whenProviderRegistered)(S,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(t,(0,D.basename)(S),S,b.getLevel(),!!g?.donotUseFormatters)),b}};I=he([te(0,d.ILogService),te(1,k.IInstantiationService),te(2,M.IFileService)],I),e.FileLoggerService=I}),define(Q[177],J([0,1,4,7,6]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(E){this.service=E,this.onDidChangeLogLevel=v.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(E,S,f){switch(S){case"setLevel":return this.service.setLevel(f)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=M;class k{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){k.setLevel(this.channel,E)}static setLevel(E,S){return E.call("setLevel",S)}}e.LogLevelChannelClient=k;class n{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,S){throw new Error(`Event not found: ${S}`)}async call(E,S,f){switch(S){case"createLogger":this.createLogger(R.URI.revive(f[0]),f[1]);return;case"log":return this.log(R.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${S}`)}createLogger(E,S){this.loggers.set(E.toString(),this.loggerService.createLogger(E,S))}consoleLog(E,S){let f=console.log;switch(E){case D.LogLevel.Error:f=console.error;break;case D.LogLevel.Warning:f=console.warn;break;case D.LogLevel.Info:f=console.info;break}f.call(console,...S)}log(E,S){const f=this.loggers.get(E.toString());if(!f)throw new Error("Create the logger before logging");for(const[g,b]of S)switch(g){case D.LogLevel.Trace:f.trace(b);break;case D.LogLevel.Debug:f.debug(b);break;case D.LogLevel.Info:f.info(b);break;case D.LogLevel.Warning:f.warn(b);break;case D.LogLevel.Error:f.error(b);break;case D.LogLevel.Critical:f.critical(b);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class d extends D.AbstractLoggerService{constructor(E,S,f){super(E,S);this.channel=f}createConsoleMainLogger(){return new D.AdapterLogger({log:(E,S)=>{this.channel.call("consoleLog",[E,S])}})}doCreateLogger(E,S,f){return new w(this.channel,E,S,f)}}e.LoggerChannelClient=d;class w extends D.AbstractMessageLogger{constructor(E,S,f,g){super(g?.always);this.channel=E,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[S,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,S){const f=[[E,S]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(E){this.channel.call("log",[this.file,E])}}class t extends D.LogService{constructor(E,S){super(S);this.parent=E,this._register(E.onDidChangeLogLevel(f=>S.setLevel(f)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=t}),define(Q[93],J([0,1,20,6]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(d,w,t,I){try{const E=await new Promise((S,f)=>{V(["spdlog"],S,f)});return E.setFlushOn(R.LogLevel.Trace),E.createAsyncRotatingLogger(d,w,t,I)}catch(E){console.error(E)}return null}function M(d,w,t,I){const E=V.__$__nodeRequire("spdlog");return E.setFlushOn(R.LogLevel.Trace),E.createRotatingLogger(d,w,t,I)}e.createRotatingLogger=M;function k(d,w,t){switch(w){case R.LogLevel.Trace:d.trace(t);break;case R.LogLevel.Debug:d.debug(t);break;case R.LogLevel.Info:d.info(t);break;case R.LogLevel.Warning:d.warn(t);break;case R.LogLevel.Error:d.error(t);break;case R.LogLevel.Critical:d.critical(t);break;default:throw new Error("Invalid log level")}}class n extends R.AbstractMessageLogger{constructor(w,t,I,E){super();this.name=w,this.filepath=t,this.rotating=I,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}_createSpdLogLogger(){const w=this.rotating?6:1,t=30/w*v.ByteSize.MB;return D(this.name,this.filepath,t,w).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:E,message:S}of this.buffer)k(this._logger,E,S);this.buffer=[]}})}log(w,t){this._logger?k(this._logger,w,t):this.getLevel()<=w&&this.buffer.push({level:w,message:t})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Q[178],J([0,1,10,15,28,20,176,6,93]),function(V,e,v,R,D,M,k,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends n.AbstractLoggerService{constructor(I,E){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=E}doCreateLogger(I,E,S){if(I.scheme===v.Schemas.file){const f=new d.SpdLogLogger(S?.name||(0,D.generateUuid)(),I.fsPath,!S?.donotRotate,E);return S?.donotUseFormatters&&f.clearFormatters(),f}else return new k.FileLogger(S?.name??(0,R.basename)(I),I,E,!!S?.donotUseFormatters,this.fileService)}};w=he([te(0,n.ILogService),te(1,M.IFileService)],w),e.LoggerService=w}),define(Q[179],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(k){return k.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function R(k){return k.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=R;function D(k){return k.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function M(k){return!v(k)&&!R(k)&&!D(k)}e.isMenubarMenuItemAction=M}),define(Q[45],J([0,1,10,3,32,15]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const n=R.globals.vscode.context.configuration();if(n)k=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const n=(0,M.dirname)(v.FileAccess.asFileUri("",V));k=V.__$__nodeRequire((0,M.joinPath)(n,"product.json").fsPath);const d=V.__$__nodeRequire((0,M.joinPath)(n,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:d.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(Q[94],J([0,1,18,17,141,20,45]),function(V,e,v,R,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(I,E,S,f,g,b){let y;try{await d(I,E,S,f,g,b)}catch(c){y=c}finally{y&&g.errorTransformer&&(y=g.errorTransformer(y)),typeof y!="undefined"&&S.error(y),S.end()}}e.readFileIntoStream=n;async function d(I,E,S,f,g,b){w(b);const y=await I.open(E,{create:!1});try{w(b);let c=0,h=0,o=g&&typeof g.length=="number"?g.length:void 0,u=v.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),i=g&&typeof g.position=="number"?g.position:0,a=0;do h=await I.read(y,i,u.buffer,a,u.byteLength-a),i+=h,a+=h,c+=h,typeof o=="number"&&(o-=h),a===u.byteLength&&(await S.write(f(u)),u=v.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),a=0);while(h>0&&(typeof o!="number"||o>0)&&w(b)&&t(c,g));if(a>0){let s=a;typeof o=="number"&&(s=Math.min(a,o)),S.write(f(u.slice(0,s)))}}catch(c){throw(0,M.ensureFileSystemProviderError)(c)}finally{await I.close(y)}}function w(I){if(I.isCancellationRequested)throw(0,R.canceled)();return!0}function t(I,E){if(E?.limits){if(typeof E.limits.memory=="number"&&I>E.limits.memory)throw(0,M.createFileSystemProviderError)((0,D.localize)(0,null,k.default.nameShort),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&I>E.limits.size)throw(0,M.createFileSystemProviderError)((0,D.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[180],J([0,1,30,9,18,23,4,67,2,40,10,77,15,69,139,20,94,6]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class Ve extends d.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new R.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new R.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!0)))),this.watchedResources=w.TernarySearchTree.forUris(u=>{const i=this.getProvider(u.scheme);return i?!this.isPathCaseSensitive(i):!1}),this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(o,u){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:u});const i=new d.DisposableStore;return i.add(u.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(u)))),i.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:o}))),typeof u.onDidErrorOccur=="function"&&i.add(u.onDidErrorOccur(a=>this._onError.fire(new Error(a)))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:u}),this.provider.delete(o),(0,d.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){u.push(i)}}),!this.provider.has(o)&&await R.Promises.settled(u)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,u){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&u)}listCapabilities(){return n.Iterable.map(this.provider,([o,u])=>({scheme:o,capabilities:u.capabilities}))}async withProvider(o){if(!(0,E.isAbsolutePath)(o))throw new g.FileOperationError((0,f.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const u=this.provider.get(o.scheme);if(!u){const i=new Error;throw i.name="ENOPRO",i.message=(0,f.localize)(1,null,o.toString()),i}return u}async withReadProvider(o){const u=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u)||(0,g.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const u=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,u){try{return await this.doResolveFile(o,u)}catch(i){throw(0,g.toFileSystemProviderErrorCode)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,f.localize)(2,null,this.resourceForError(o)),1):(0,g.ensureFileSystemProviderError)(i)}}async doResolveFile(o,u){const i=await this.withProvider(o),a=this.isPathCaseSensitive(i),s=u?.resolveTo,r=u?.resolveSingleChildDescendants,l=u?.resolveMetadata,m=await i.stat(o);let p;return this.toFileStat(i,o,m,void 0,!!l,(P,L)=>(p||(p=w.TernarySearchTree.forUris(()=>!a),p.set(o,!0),s&&p.fill(!0,s)),p.get(P.resource)||p.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&r?L===1:!1))}async toFileStat(o,u,i,a,s,r){const{providerExtUri:l}=this.getExtUri(o),m={resource:u,name:l.basename(u),isFile:(i.type&g.FileType.File)!=0,isDirectory:(i.type&g.FileType.Directory)!=0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!=0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&g.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,g.etag)({mtime:i.mtime,size:i.size})};if(m.isDirectory&&r(m,a)){try{const p=await o.readdir(u),P=await R.Promises.settled(p.map(async([L,A])=>{try{const W=l.joinPath(u,L),q=s?await o.stat(W):{type:A};return await this.toFileStat(o,W,q,p.length,s,r)}catch(W){return this.logService.trace(W),null}}));m.children=(0,v.coalesce)(P)}catch(p){this.logService.trace(p),m.children=[]}return m}return m}async resolveAll(o){return R.Promises.settled(o.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async exists(o){const u=await this.withProvider(o);try{return!!await u.stat(o)}catch(i){return!1}}async canCreateFile(o,u){try{await this.doValidateCreateFile(o,u)}catch(i){return i}return!0}async doValidateCreateFile(o,u){if(!u?.overwrite&&await this.exists(o))throw new g.FileOperationError((0,f.localize)(3,null,this.resourceForError(o)),3,u)}async createFile(o,u=D.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const a=await this.writeFile(o,u);return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,a)),a}async writeFile(o,u,i){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(a);try{await this.validateWriteFile(a,o,i)||await this.mkdirp(a,s.dirname(o));let l;if((0,g.hasReadWriteCapability)(a)&&!(u instanceof D.VSBuffer))if((0,S.isReadableStream)(u)){const m=await(0,S.peekStream)(u,3);m.ended?l=D.VSBuffer.concat(m.buffer):l=m}else l=(0,S.peekReadable)(u,m=>D.VSBuffer.concat(m),3);else l=u;!(0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a)&&l instanceof D.VSBuffer?await this.doWriteUnbuffered(a,o,i,l):await this.doWriteBuffered(a,o,i,l instanceof D.VSBuffer?(0,D.bufferToReadable)(l):l)}catch(r){throw new g.FileOperationError((0,f.localize)(4,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),i)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,u,i){if(!!i?.unlock&&!(o.capabilities&8192))throw new Error((0,f.localize)(5,null,this.resourceForError(u)));let s;try{s=await o.stat(u)}catch(r){return}if((s.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,f.localize)(6,null,this.resourceForError(u)),0,i);if(this.throwIfFileIsReadonly(u,s),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&i.mtime<s.mtime&&i.etag!==(0,g.etag)({mtime:i.mtime,size:s.size}))throw new g.FileOperationError((0,f.localize)(7,null),3,i);return s}async readFile(o,u){const i=await this.withReadProvider(o);return u?.atomic?this.doReadFileAtomic(i,o,u):this.doReadFile(i,o,u)}async doReadFileAtomic(o,u,i){return new Promise((a,s)=>{this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,u,i);a(r)}catch(r){s(r)}})})}async doReadFile(o,u,i){const a=await this.doReadFileStream(o,u,{...i,preferUnbuffered:!0});return{...a,value:await(0,D.streamToBuffer)(a.value)}}async readFileStream(o,u){const i=await this.withReadProvider(o);return this.doReadFileStream(i,o,u)}async doReadFileStream(o,u,i){const a=new M.CancellationTokenSource,s=this.validateReadFile(u,i).then(l=>l,l=>{throw a.cancel(),l});let r;try{return typeof i?.etag=="string"&&i.etag!==g.ETAG_DISABLED&&await s,!((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasFileReadStreamCapability)(o))||(0,g.hasReadWriteCapability)(o)&&i?.preferUnbuffered?r=this.readFileUnbuffered(o,u,i):(0,g.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,u,a.token,i):r=this.readFileBuffered(o,u,a.token,i),{...await s,value:r}}catch(l){r&&await(0,S.consumeStream)(r);const m=(0,f.localize)(8,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(l).toString());throw l instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(m,l.stat,i):new g.FileOperationError(m,(0,g.toFileOperationResult)(l),i)}}readFileStreamed(o,u,i,a=Object.create(null)){const s=o.readFileStream(u,a,i);return(0,S.transform)(s,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new g.FileOperationError((0,f.localize)(9,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),a)},r=>D.VSBuffer.concat(r))}readFileBuffered(o,u,i,a=Object.create(null)){const s=(0,D.newWriteableBufferStream)();return(0,b.readFileIntoStream)(o,u,s,r=>r,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new g.FileOperationError((0,f.localize)(10,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),a)},i),s}readFileUnbuffered(o,u,i){const a=(0,S.newWriteableStream)(s=>D.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(u);typeof i?.position=="number"&&(s=s.slice(i.position)),typeof i?.length=="number"&&(s=s.slice(0,i.length)),this.validateReadFileLimits(u,s.byteLength,i),a.end(D.VSBuffer.wrap(s))}catch(s){a.error(s),a.end()}})(),a}async validateReadFile(o,u){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new g.FileOperationError((0,f.localize)(11,null,this.resourceForError(o)),0,u);if(typeof u?.etag=="string"&&u.etag!==g.ETAG_DISABLED&&u.etag===i.etag)throw new g.NotModifiedSinceFileOperationError((0,f.localize)(12,null),i,u);return this.validateReadFileLimits(o,i.size,u),i}validateReadFileLimits(o,u,i){if(i?.limits){let a;if(typeof i.limits.memory=="number"&&u>i.limits.memory&&(a=9),typeof i.limits.size=="number"&&u>i.limits.size&&(a=7),typeof a=="number")throw new g.FileOperationError((0,f.localize)(13,null,this.resourceForError(o)),a)}}async canMove(o,u,i){return this.doCanMoveCopy(o,u,"move",i)}async canCopy(o,u,i){return this.doCanMoveCopy(o,u,"copy",i)}async doCanMoveCopy(o,u,i,a){if(o.toString()!==u.toString())try{const s=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(s,o,r,u,i,a)}catch(s){return s}return!0}async move(o,u,i){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(a,o,s,u,"move",!!i),l=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,r==="move"?2:3,l)),l}async copy(o,u,i){const a=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(a,o,s,u,"copy",!!i),l=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,r==="copy"?3:2,l)),l}async doMoveCopy(o,u,i,a,s,r){if(u.toString()===a.toString())return s;const{exists:l,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(o,u,i,a,s,r);if(l&&!m&&r&&await this.del(a,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(a)),s==="copy"){if(o===i&&(0,g.hasFileFolderCopyCapability)(o))await o.copy(u,a,{overwrite:r});else{const p=await this.resolve(u);p.isDirectory?await this.doCopyFolder(o,p,i,a):await this.doCopyFile(o,u,i,a)}return s}else return o===i?(await o.rename(u,a,{overwrite:r}),s):(await this.doMoveCopy(o,u,i,a,"copy",r),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(o,u,i,a){if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,u,i,a);if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,u,i,a);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,u,i,a);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,u,i,a)}async doCopyFolder(o,u,i,a){await i.mkdir(a),Array.isArray(u.children)&&await R.Promises.settled(u.children.map(async s=>{const r=this.getExtUri(i).providerExtUri.joinPath(a,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),i,r):this.doCopyFile(o,s.resource,i,r)}))}async doValidateMoveCopy(o,u,i,a,s,r){let l=!1;if(o===i){const{providerExtUri:p,isPathCaseSensitive:P}=this.getExtUri(o);if(P||(l=p.isEqual(u,a)),l&&s==="copy")throw new Error((0,f.localize)(14,null,this.resourceForError(u),this.resourceForError(a)));if(!l&&p.isEqualOrParent(a,u))throw new Error((0,f.localize)(15,null,this.resourceForError(u),this.resourceForError(a)))}const m=await this.exists(a);if(m&&!l){if(!r)throw new g.FileOperationError((0,f.localize)(16,null,this.resourceForError(u),this.resourceForError(a)),4);if(o===i){const{providerExtUri:p}=this.getExtUri(o);if(p.isEqualOrParent(u,a))throw new Error((0,f.localize)(17,null,this.resourceForError(u),this.resourceForError(a)))}}return{exists:m,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const u=this.isPathCaseSensitive(o);return{providerExtUri:u?E.extUri:E.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(u,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,i)),i}async mkdirp(o,u){const i=[],{providerExtUri:a}=this.getExtUri(o);for(;!a.isEqual(u,a.dirname(u));)try{if(((await o.stat(u)).type&g.FileType.Directory)==0)throw new Error((0,f.localize)(18,null,this.resourceForError(u)));break}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(a.basename(u)),u=a.dirname(u)}for(let s=i.length-1;s>=0;s--){u=a.joinPath(u,i[s]);try{await o.mkdir(u)}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,u){try{await this.doValidateDelete(o,u)}catch(i){return i}return!0}async doValidateDelete(o,u){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!u?.useTrash&&!(i.capabilities&4096))throw new Error((0,f.localize)(19,null,this.resourceForError(o)));let s;try{s=await i.stat(o)}catch(l){}if(s)this.throwIfFileIsReadonly(o,s);else throw new g.FileOperationError((0,f.localize)(20,null,this.resourceForError(o)),1);if(!!!u?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,f.localize)(21,null,this.resourceForError(o)))}return i}async del(o,u){const i=await this.doValidateDelete(o,u),a=!!u?.useTrash,s=!!u?.recursive;await i.delete(o,{recursive:s,useTrash:a}),this._onDidRunOperation.fire(new g.FileOperationEvent(o,1))}onDidChangeFile(o,u){this._onDidChangeFilesRaw.fire({changes:o});let i,a;{for(const s of o)this.watchedResources.has(s.resource)?(i||(i=[]),i.push(s)):(a||(a=[]),a.push(s));i&&this._onDidFilesChange.fire(new g.FileChangesEvent(i,!u))}if(a){const s=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!s.work(a)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),s.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${s.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,u={recursive:!1,excludes:[]}){const i=new d.DisposableStore;{let a=!1,s=()=>{a=!0};i.add((0,d.toDisposable)(()=>s())),this.doWatch(o,u).then(r=>{a?(0,d.dispose)(r):s=()=>(0,d.dispose)(r)},r=>this.logService.error(r))}return u.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),i.add((0,d.toDisposable)(()=>{const a=this.watchedResources.get(o);typeof a=="number"&&(a<=1?this.watchedResources.delete(o):this.watchedResources.set(o,a-1))}))),i}async doWatch(o,u){const i=await this.withProvider(o),a=this.toWatchKey(i,o,u),s=this.activeWatchers.get(a)||{count:0,disposable:i.watch(o,u)};return this.activeWatchers.has(a)||this.activeWatchers.set(a,s),s.count+=1,(0,d.toDisposable)(()=>{s.count--,s.count===0&&((0,d.dispose)(s.disposable),this.activeWatchers.delete(a))})}toWatchKey(o,u,i){const{providerExtUri:a}=this.getExtUri(o);return[a.getComparisonKey(u),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,d.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,u,i,a){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{const s=await o.open(u,{create:!0,unlock:i?.unlock??!1});try{(0,S.isReadableStream)(a)||(0,S.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(o,s,a):await this.doWriteReadableBufferedQueued(o,s,a)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await o.close(s)}})}async doWriteStreamBufferedQueued(o,u,i){let a=0,s;if((0,S.isReadableBufferedStream)(i)){if(i.buffer.length>0){const r=D.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,u,r,r.byteLength,a,0),a+=r.byteLength}if(i.ended)return;s=i.stream}else s=i;return new Promise((r,l)=>{(0,S.listenStream)(s,{onData:async m=>{s.pause();try{await this.doWriteBuffer(o,u,m,m.byteLength,a,0)}catch(p){return l(p)}a+=m.byteLength,setTimeout(()=>s.resume())},onError:m=>l(m),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,u,i){let a=0,s;for(;(s=i.read())!==null;)await this.doWriteBuffer(o,u,s,s.byteLength,a,0),a+=s.byteLength}async doWriteBuffer(o,u,i,a,s,r){let l=0;for(;l<a;)l+=await o.write(u,s+l,i.buffer,r+l,a-l)}async doWriteUnbuffered(o,u,i,a){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,u,i,a))}async doWriteUnbufferedQueued(o,u,i,a){let s;a instanceof D.VSBuffer?s=a:(0,S.isReadableStream)(a)?s=await(0,D.streamToBuffer)(a):(0,S.isReadableBufferedStream)(a)?s=await(0,D.bufferedStreamToBuffer)(a):s=(0,D.readableToBuffer)(a),await o.writeFile(u,s.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(o,u,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,u,i,a))}async doPipeBufferedQueued(o,u,i,a){let s,r;try{s=await o.open(u,{create:!1}),r=await i.open(a,{create:!0,unlock:!1});const l=D.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,p=0,P=0;do P=await o.read(s,m,l.buffer,p,l.byteLength-p),await this.doWriteBuffer(i,r,l,P,m,p),m+=P,p+=P,p===l.byteLength&&(p=0);while(P>0)}catch(l){throw(0,g.ensureFileSystemProviderError)(l)}finally{await R.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof r=="number"?i.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,u,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,u,i,a))}async doPipeUnbufferedQueued(o,u,i,a){return i.writeFile(a,await o.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,u,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,u,i,a))}async doPipeUnbufferedToBufferedQueued(o,u,i,a){const s=await i.open(a,{create:!0,unlock:!1});try{const r=await o.readFile(u);await this.doWriteBuffer(i,s,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await i.close(s)}}async doPipeBufferedToUnbuffered(o,u,i,a){const s=await(0,D.streamToBuffer)(this.readFileBuffered(o,u,M.CancellationToken.None));await this.doWriteUnbuffered(i,a,void 0,s)}throwIfFileSystemIsReadonly(o,u){if(o.capabilities&2048)throw new g.FileOperationError((0,f.localize)(22,null,this.resourceForError(u)),6);return o}throwIfFileIsReadonly(o,u){if((u.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,f.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===t.Schemas.file?o.fsPath:o.toString(!0)}};c.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},c=he([te(0,y.ILogService)],c),e.FileService=c}),define(Q[181],J([0,1,30,9,18,4,33,2,8,3,15,69,19,142,20,94,166,167,168,169,55,6,45]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y,c,h,o,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class a extends n.Disposable{constructor(r,l){super();this.logService=r,this.options=l,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:l,symbolicLink:m}=await E.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(l,m),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(r){try{const l=await E.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),m=[];return await Promise.all(l.map(async p=>{try{let P;p.isSymbolicLink()?P=(await this.stat((0,t.joinPath)(r,p.name))).type:P=this.toType(p),m.push([p.name,P])}catch(P){this.logService.trace(P)}})),m}catch(l){throw this.toFileSystemProviderError(l)}}toType(r,l){let m;return l?.dangling?m=f.FileType.Unknown:r.isFile()?m=f.FileType.File:r.isDirectory()?m=f.FileType.Directory:m=f.FileType.Unknown,l&&(m|=f.FileType.SymbolicLink),m}async readFile(r){try{const l=this.toFilePath(r);return await E.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(r,l,m){const p=(0,I.newWriteableStream)(P=>D.VSBuffer.concat(P.map(L=>D.VSBuffer.wrap(L))).buffer);return(0,g.readFileIntoStream)(this,r,p,P=>P.buffer,{...l,bufferSize:this.BUFFER_SIZE},m),p}async writeFile(r,l,m){let p;try{const P=this.toFilePath(r);if(!m.create||!m.overwrite){if(await E.Promises.exists(P)){if(!m.overwrite)throw(0,f.createFileSystemProviderError)((0,S.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!m.create)throw(0,f.createFileSystemProviderError)((0,S.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:m.unlock}),await this.write(p,0,l,0,l.byteLength)}catch(P){throw await this.toFileSystemProviderWriteError(r,P)}finally{typeof p=="number"&&await this.close(p)}}async open(r,l){try{const m=this.toFilePath(r);if((0,f.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:L}=await E.SymlinkSupport.stat(m);L.mode&128||await E.Promises.chmod(m,L.mode|128)}catch(L){this.logService.trace(L)}let p;if((0,f.isFileOpenForWriteOptions)(l)){if(w.isWindows)try{await E.Promises.truncate(m,0),p="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}p||(p="w")}else p="r";const P=await E.Promises.open(m,p);return this.mapHandleToPos.set(P,0),(0,f.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(P,r),P}catch(m){throw(0,f.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(r,m):this.toFileSystemProviderError(m)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await E.Promises.fdatasync(r)}catch(l){this.canFlush=!1,this.logService.error(l)}return await E.Promises.close(r)}catch(l){throw this.toFileSystemProviderError(l)}}async read(r,l,m,p,P){const L=this.normalizePos(r,l);let A=null;try{const W=await E.Promises.read(r,m,p,P,L);return typeof W=="number"?A=W:A=W.bytesRead,A}catch(W){throw this.toFileSystemProviderError(W)}finally{this.updatePos(r,L,A)}}normalizePos(r,l){return l===this.mapHandleToPos.get(r)?null:l}updatePos(r,l,m){const p=this.mapHandleToPos.get(r);typeof p=="number"&&(typeof l=="number"||(typeof m=="number"?this.mapHandleToPos.set(r,p+m):this.mapHandleToPos.delete(r)))}async write(r,l,m,p,P){return(0,R.retry)(()=>this.doWrite(r,l,m,p,P),100,3)}async doWrite(r,l,m,p,P){const L=this.normalizePos(r,l);let A=null;try{const W=await E.Promises.write(r,m,p,P,L);return typeof W=="number"?A=W:A=W.bytesWritten,A}catch(W){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),W)}finally{this.updatePos(r,L,A)}}async mkdir(r){try{await E.Promises.mkdir(this.toFilePath(r))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(r,l){try{const m=this.toFilePath(r);await this.doDelete(m,l)}catch(m){throw this.toFileSystemProviderError(m)}}async doDelete(r,l){l.recursive?await E.Promises.rm(r,E.RimRafMode.MOVE):await E.Promises.unlink(r)}async rename(r,l,m){const p=this.toFilePath(r),P=this.toFilePath(l);if(p!==P)try{await this.validateTargetDeleted(r,l,"move",m.overwrite),await E.Promises.move(p,P)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,S.localize)(2,null,(0,d.basename)(p),(0,d.basename)((0,d.dirname)(P)),L.toString()))),this.toFileSystemProviderError(L)}}async copy(r,l,m){const p=this.toFilePath(r),P=this.toFilePath(l);if(p!==P)try{await this.validateTargetDeleted(r,l,"copy",m.overwrite),await E.Promises.copy(p,P,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,S.localize)(3,null,(0,d.basename)(p),(0,d.basename)((0,d.dirname)(P)),L.toString()))),this.toFileSystemProviderError(L)}}async validateTargetDeleted(r,l,m,p){const P=this.toFilePath(r),L=this.toFilePath(l);let A=!1;if(!!(this.capabilities&1024)||(A=(0,k.isEqual)(P,L,!0)),A&&m==="copy")throw(0,f.createFileSystemProviderError)((0,S.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!A&&await E.Promises.exists(L)){if(!p)throw(0,f.createFileSystemProviderError)((0,S.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(r,l){return l.recursive?this.watchRecursive(r,l):this.watchNonRecursive(r)}watchRecursive(r,l){const m={path:this.toFilePath(r),excludes:l.excludes},p=(0,v.insert)(this.recursiveFoldersToWatch,m);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{p(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){this.recursiveWatcher?this.recursiveWatcher.watch(this.recursiveFoldersToWatch):this.recursiveFoldersToWatch.length>0&&(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch,r=>this._onDidChangeFile.fire((0,o.toFileChanges)(r)),r=>{r.type==="error"&&this._onDidWatchErrorOccur.fire(r.message),this.logService[r.type](r.message)},this.logService.getLevel()===u.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)})))}createRecursiveWatcher(r,l,m,p){let P,L;if(this.options?.watcher?.usePolling)P=h.FileWatcher,L=this.options?.watcher;else{let A=!1;this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?A=this.options.legacyWatcher==="on":i.default.quality==="stable"&&(A=this.recursiveFoldersToWatch.length===1),A?w.isLinux?P=h.FileWatcher:P=y.FileWatcher:P=c.FileWatcher}return new P(r,A=>l(A),A=>m(A),p,L)}watchNonRecursive(r){const l=new b.FileWatcher(this.toFilePath(r),p=>this._onDidChangeFile.fire((0,o.toFileChanges)(p)),p=>{p.type==="error"&&this._onDidWatchErrorOccur.fire(p.message),this.logService[p.type](p.message)},this.logService.getLevel()===u.LogLevel.Trace),m=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)});return(0,n.combinedDisposable)(l,m)}toFilePath(r){return(0,d.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof f.FileSystemProviderError)return r;let l;switch(r.code){case"ENOENT":l=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=f.FileSystemProviderErrorCode.NoPermissions;break;default:l=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(r,l)}async toFileSystemProviderWriteError(r,l){let m=this.toFileSystemProviderError(l);if(r&&m.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await E.SymlinkSupport.stat(this.toFilePath(r));p.mode&128||(m=(0,f.createFileSystemProviderError)(l,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return m}}e.DiskFileSystemProvider=a}),define(Q[21],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(Q[182],J([0,1,59,6,21]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(n,d){this.productService=n,this.logService=d,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,d){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(d);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,t,I]=w;let E=this.trustedExtensionUrlPublicKeys.get(n);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[n],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...E])}const S=Buffer.from(decodeURIComponent(I),"base64");if(S.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const f=S.slice(0,6),g=S.readUIntBE(0,6),b=Date.now()-g;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const y=S.slice(6),c=v.createVerify("SHA256");c.write(f),c.write(Buffer.from(t)),c.end();for(let h=0;h<E.length;h++){let o=E[h];if(o!==null){if(typeof o=="string")try{o=v.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),E[h]=o}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${n}:`,u),E[h]=null;continue}if(c.verify(o,y))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};M=he([te(0,D.IProductService),te(1,R.ILogService)],M),e.ExtensionUrlTrustService=M}),define(Q[56],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Q[183],J([0,1,14,2,40,10,3,15,7,28,48,6]),function(V,e,v,R,D,M,k,n,d,w,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends R.Disposable{constructor(f,g){super();this.logService=g,this.validRoots=D.TernarySearchTree.forUris(()=>!k.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(d.URI.file(f.appRoot)),this.addValidFileRoot(d.URI.file(f.extensionsPath)),this.addValidFileRoot(f.globalStorageHome),this.addValidFileRoot(f.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:f}=v.session;f.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(g,b)=>this.handleResourceRequest(g,b)),f.protocol.interceptFileProtocol(M.Schemas.file,(g,b)=>this.handleFileRequest(g,b)),this._register((0,R.toDisposable)(()=>{f.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),f.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(f){return this.validRoots.get(f)?R.Disposable.None:(this.validRoots.set(f,!0),(0,R.toDisposable)(()=>this.validRoots.delete(f)))}handleFileRequest(f,g){const b=d.URI.parse(f.url);return this.logService.error(`Refused to load resource ${b.fsPath} from ${M.Schemas.file}: protocol (original URL: ${f.url})`),g({error:-3})}handleResourceRequest(f,g){const b=d.URI.parse(f.url),y=M.FileAccess.asFileUri(b);return this.validRoots.findSubstr(y)?g({path:y.fsPath}):this.validExtensions.has((0,n.extname)(y))?g({path:y.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${y.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${f.url})`),g({error:-3}))}createIPCObjectUrl(){let f;const g=d.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),b=g.toString(),y=async()=>f;return v.ipcMain.handle(b,y),this.logService.trace(`IPC Object URL: Registered new channel ${b}.`),{resource:g,update:c=>f=c,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${b}.`),v.ipcMain.removeHandler(b)}}}};E=he([te(0,t.INativeEnvironmentService),te(1,I.ILogService)],E),e.ProtocolMainService=E}),define(Q[37],J([0,1,102,13]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,n){v.ok(R.isString(k)),v.ok(R.isObject(n)),v.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,n)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(Q[184],J([0,1,4,37]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class M{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,w){this.schemasById[D(d)]=w,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new M;R.Registry.add(e.Extensions.JSONContribution,k)}),define(Q[49],J([0,1,30,4,13,131,184,37]),function(V,e,v,R,D,M,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=n.Registry.as(k.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,o=!0){this.registerConfigurations([h],o)}registerConfigurations(h,o=!0){const u=this.doRegisterConfigurations(h,o);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(h){const o=this.doDeregisterConfigurations(h);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:h,remove:o}){const u=[];u.push(...this.doDeregisterConfigurations(o)),u.push(...this.doRegisterConfigurations(h,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,v.distinct)(u))}registerDefaultConfigurations(h){const o=[],u=[];for(const i of h)for(const a in i)if(o.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]={...this.defaultValues[a]||{},...i[a]};const s={type:"object",default:this.defaultValues[a],description:M.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};u.push(S(a)),this.configurationProperties[a]=s,this.defaultLanguageConfigurationOverridesNode.properties[a]=s}else{this.defaultValues[a]=i[a];const s=this.configurationProperties[a];s&&(this.updatePropertyDefaultValue(a,s),this.updateSchema(a,s))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(h){const o=[];for(const u of h)for(const i in u)if(o.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const a=this.configurationProperties[i];a&&(this.updatePropertyDefaultValue(i,a),this.updateSchema(i,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const o of h)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,o){const u=[];return h.forEach(i=>{u.push(...this.validateAndRegisterProperties(i,o,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),u}doDeregisterConfigurations(h){const o=[],u=i=>{if(i.properties)for(const a in i.properties)o.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,i.properties[a]);i.allOf&&i.allOf.forEach(a=>u(a))};for(const i of h){u(i);const a=this.configurationContributors.indexOf(i);a!==-1&&this.configurationContributors.splice(a,1)}return o}validateAndRegisterProperties(h,o=!0,u,i=3){i=D.isUndefinedOrNull(h.scope)?i:h.scope;let a=[],s=h.properties;if(s)for(let l in s){if(o&&b(l)){delete s[l];continue}const m=s[l];if(this.updatePropertyDefaultValue(l,m),e.OVERRIDE_PROPERTY_PATTERN.test(l)?m.scope=void 0:(m.scope=D.isUndefinedOrNull(m.scope)?i:m.scope,m.restricted=D.isUndefinedOrNull(m.restricted)?!!u?.restrictedConfigurations?.includes(l):m.restricted),s[l].hasOwnProperty("included")&&!s[l].included){this.excludedConfigurationProperties[l]=s[l],delete s[l];continue}else this.configurationProperties[l]=s[l];!s[l].deprecationMessage&&s[l].markdownDeprecationMessage&&(s[l].deprecationMessage=s[l].markdownDeprecationMessage),a.push(l)}let r=h.allOf;if(r)for(let l of r)a.push(...this.validateAndRegisterProperties(l,o,u,i));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const o=u=>{let i=u.properties;if(i)for(const s in i)this.updateSchema(s,i[s]);let a=u.allOf;a&&a.forEach(o)};o(h)}updateSchema(h,o){switch(e.allSettings.properties[h]=o,o.scope){case 1:e.applicationSettings.properties[h]=o;break;case 2:e.machineSettings.properties[h]=o;break;case 6:e.machineOverridableSettings.properties[h]=o;break;case 3:e.windowSettings.properties[h]=o;break;case 4:e.resourceSettings.properties[h]=o;break;case 5:e.resourceSettings.properties[h]=o,this.resourceLanguageSettingsSchema.properties[h]=o;break}}removeFromSchema(h,o){switch(delete e.allSettings.properties[h],o.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const o=`[${h}]`,u={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,u),e.allSettings.properties[o]=u,e.applicationSettings.properties[o]=u,e.machineSettings.properties[o]=u,e.machineOverridableSettings.properties[o]=u,e.windowSettings.properties[o]=u,e.resourceSettings.properties[o]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,o){let u=this.defaultValues[h];D.isUndefined(u)&&(u=o.default),D.isUndefined(u)&&(u=f(o.type)),o.default=u}}const E="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(E);function S(c){return c.substring(1,c.length-1)}e.overrideIdentifierFromKey=S;function f(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const g=new I;n.Registry.add(e.Extensions.Configuration,g);function b(c){return c.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(c)?M.localize(5,null,c):g.getConfigurationProperties()[c]!==void 0?M.localize(6,null,c):null:M.localize(4,null)}e.validateProperty=b;function y(){const c=[],h=g.getConfigurationProperties();for(const o of Object.keys(h))c.push([o,h[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=y}),define(Q[16],J([0,1,43,13,7,49,5,37]),function(V,e,v,R,D,M,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function d(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof D.URI)}e.isConfigurationOverrides=d;var w;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function I(a,s){const r=s?a?s.keys.filter(W=>a.keys.indexOf(W)===-1):[...s.keys]:[],l=a?s?a.keys.filter(W=>s.keys.indexOf(W)===-1):[...a.keys]:[],m=[];if(s&&a){for(const W of a.keys)if(s.keys.indexOf(W)!==-1){const q=y(a.contents,W),x=y(s.contents,W);v.equals(q,x)||m.push(W)}}const p=[],P=W=>{const q={};for(const x of W)for(const re of x.identifiers)q[u(re)]=x;return q},L=s?P(s.overrides):{},A=a?P(a.overrides):{};if(Object.keys(L).length)for(const W of r){const q=L[W];q&&p.push([(0,M.overrideIdentifierFromKey)(W),q.keys])}if(Object.keys(A).length)for(const W of l){const q=A[W];q&&p.push([(0,M.overrideIdentifierFromKey)(W),q.keys])}if(Object.keys(L).length&&Object.keys(A).length)for(const W of m){const q=A[W],x=L[W];if(q&&x){const re=I({contents:q.contents,keys:q.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});p.push([(0,M.overrideIdentifierFromKey)(W),[...re.added,...re.removed,...re.updated]])}}return{added:r,removed:l,updated:m,overrides:p}}e.compare=I;function E(a,s){const r=[];for(const l of Object.keys(a))if(M.OVERRIDE_PROPERTY_PATTERN.test(l)){const m={};for(const p in a[l])m[p]=a[l][p];r.push({identifiers:[(0,M.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(m),contents:S(m,s)})}return r}e.toOverrides=E;function S(a,s){const r=Object.create(null);for(let l in a)f(r,l,a[l],s);return r}e.toValuesTree=S;function f(a,s,r,l){const m=s.split("."),p=m.pop();let P=a;for(let L=0;L<m.length;L++){let A=m[L],W=P[A];switch(typeof W){case"undefined":W=P[A]=Object.create(null);break;case"object":break;default:l(`Ignoring ${s} as ${m.slice(0,L+1).join(".")} is ${JSON.stringify(W)}`);return}P=W}if(typeof P=="object"&&P!==null)try{P[p]=r}catch(L){l(`Ignoring ${s} as ${m.join(".")} is ${JSON.stringify(P)}`)}else l(`Ignoring ${s} as ${m.join(".")} is ${JSON.stringify(P)}`)}e.addToValueTree=f;function g(a,s){const r=s.split(".");b(a,r)}e.removeFromValueTree=g;function b(a,s){const r=s.shift();if(s.length===0){delete a[r];return}if(Object.keys(a).indexOf(r)!==-1){const l=a[r];typeof l=="object"&&!Array.isArray(l)&&(b(l,s),Object.keys(l).length===0&&delete a[r])}}function y(a,s,r){function l(P,L){let A=P;for(const W of L){if(typeof A!="object"||A===null)return;A=A[W]}return A}const m=s.split("."),p=l(a,m);return typeof p=="undefined"?r:p}e.getConfigurationValue=y;function c(a,s,r){Object.keys(s).forEach(l=>{l!=="__proto__"&&(l in a?R.isObject(a[l])&&R.isObject(s[l])?c(a[l],s[l],r):r&&(a[l]=s[l]):a[l]=s[l])})}e.merge=c;function h(){const a=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=h;function o(){const a=Object.create(null),s=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let r in s){let l=s[r].default;f(a,r,l,m=>console.error(`Conflict in default settings: ${m}`))}return a}e.getDefaultValues=o;function u(a){return`[${a}]`}e.keyFromOverrideIdentifier=u;function i(a,s,r){const l=a.inspect(s),m=a.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:l.defaultValue}e.getMigratedSettingValue=i}),define(Q[185],J([0,1,30,4,39,2,40,43,13,7,16,49,37]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(i={},a=[],s=[]){this._contents=i,this._keys=a,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,a){const s=this.getContentsForOverrideIdentifer(a);return s?i?(0,t.getConfigurationValue)(s,i):s:void 0}getKeysForOverrideIdentifier(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.keys;return[]}override(i){let a=this.overrideConfigurations.get(i);return a||(a=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,a)),a}merge(...i){const a=n.deepClone(this.contents),s=n.deepClone(this.overrides),r=[...this.keys];for(const l of i){this.mergeContents(a,l.contents);for(const m of l.overrides){const[p]=s.filter(P=>v.equals(P.identifiers,m.identifiers));p?this.mergeContents(p.contents,m.contents):s.push(n.deepClone(m))}for(const m of l.keys)r.indexOf(m)===-1&&r.push(m)}return new S(a,r,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const a=this.getContentsForOverrideIdentifer(i);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let s={};for(const r of v.distinct([...Object.keys(this.contents),...Object.keys(a)])){let l=this.contents[r],m=a[r];m&&(typeof l=="object"&&typeof m=="object"?(l=n.deepClone(l),this.mergeContents(l,m)):l=m),s[r]=l}return new S(s,this.keys,this.overrides)}mergeContents(i,a){for(const s of Object.keys(a)){if(s in i&&d.isObject(i[s])&&d.isObject(a[s])){this.mergeContents(i[s],a[s]);continue}i[s]=n.deepClone(a[s])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?n.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,a){this.addKey(i),(0,t.addToValueTree)(this.contents,i,a,s=>{throw new Error(s)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let a=this.keys.length;for(let s=0;s<a;s++)i.indexOf(this.keys[s])===0&&(a=s);this.keys.splice(a,1,i)}removeKey(i){let a=this.keys.indexOf(i);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=S;class f extends S{constructor(){const i=(0,t.getDefaultValues)(),a=(0,t.getConfigurationKeys)(),s=[];for(const r of Object.keys(i))I.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,I.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(i[r]),contents:(0,t.toValuesTree)(i[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(i,a,s)}}e.DefaultConfigurationModel=f;class g{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,a){if(!d.isUndefinedOrNull(i)){const s=this.doParseContent(i);this.parseRaw(s,a)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,a){this._raw=i;const{contents:s,keys:r,overrides:l,restricted:m}=this.doParseRaw(i,a);this._configurationModel=new S(s,r,l),this._restrictedConfigurations=m||[]}doParseContent(i){let a={},s=null,r=[],l=[],m=[];function p(L){Array.isArray(r)?r.push(L):s!==null&&(r[s]=L)}let P={onObjectBegin:()=>{let L={};p(L),l.push(r),r=L,s=null},onObjectProperty:L=>{s=L},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let L=[];p(L),l.push(r),r=L,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:p,onError:(L,A,W)=>{m.push({error:L,offset:A,length:W})}};if(i)try{D.visit(i,P),a=r[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return a}doParseRaw(i,a){const s=E.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,s,!0,a);i=r.raw;const l=(0,t.toValuesTree)(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),m=Object.keys(i),p=(0,t.toOverrides)(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:l,keys:m,overrides:p,restricted:r.restricted}}filter(i,a,s,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const l={},m=[];for(let p in i)if(I.OVERRIDE_PROPERTY_PATTERN.test(p)&&s){const P=this.filter(i[p],a,!1,r);l[p]=P.raw,m.push(...P.restricted)}else{const P=a[p],L=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&m.push(p),(L===void 0||r.scopes===void 0||r.scopes.includes(L))&&(r.skipRestricted&&P?.restricted||(l[p]=i[p]))}return{raw:l,restricted:m}}}e.ConfigurationModelParser=g;class b extends M.Disposable{constructor(i,a,s,r){super();this.userSettingsResource=i,this.scopes=a,this.fileService=r,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class y{constructor(i,a,s=new S,r=new S,l=new k.ResourceMap,m=new S,p=new k.ResourceMap,P=!0){this._defaultConfiguration=i,this._localUserConfiguration=a,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=m,this._memoryConfigurationByResource=p,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(i,a,s){return this.getConsolidateConfigurationModel(a,s).getValue(i)}updateValue(i,a,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new S,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,a===void 0?r.removeValue(i):r.setValue(i,a),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,a,s){const r=this.getConsolidateConfigurationModel(a,s),l=this.getFolderConfigurationModelForResource(a.resource,s),m=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,p=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),P=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),L=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),A=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),W=s?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,q=l?a.overrideIdentifier?l.freeze().override(a.overrideIdentifier).getValue(i):l.freeze().getValue(i):void 0,x=a.overrideIdentifier?m.override(a.overrideIdentifier).getValue(i):m.getValue(i),re=r.getValue(i),K=v.distinct(v.flatten(r.overrides.map(ee=>ee.identifiers))).filter(ee=>r.getOverrideValue(i,ee)!==void 0);return{defaultValue:p,userValue:P,userLocalValue:L,userRemoteValue:A,workspaceValue:W,workspaceFolderValue:q,memoryValue:x,value:re,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userLocal:L!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspace:W!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspaceFolder:q!==void 0?{value:l?.freeze().getValue(i),override:a.overrideIdentifier?l?.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:m.getValue(i),override:a.overrideIdentifier?m.getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(i){const a=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,a){this._folderConfigurations.set(i,a),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,a){const s=a.filter(r=>I.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,I.overrideIdentifierFromKey)(r),m=this._defaultConfiguration.getKeysForOverrideIdentifier(l),p=i.getKeysForOverrideIdentifier(l),P=[...p.filter(L=>m.indexOf(L)===-1),...m.filter(L=>p.indexOf(L)===-1),...m.filter(L=>!n.equals(this._defaultConfiguration.override(l).getValue(L),i.override(l).getValue(L)))];return[l,P]});return this.updateDefaultConfiguration(i),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:a,updated:s,removed:r,overrides:l}=(0,t.compare)(this.localUserConfiguration,i),m=[...a,...s,...r];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:a,updated:s,removed:r,overrides:l}=(0,t.compare)(this.remoteUserConfiguration,i);let m=[...a,...s,...r];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:a,updated:s,removed:r,overrides:l}=(0,t.compare)(this.workspaceConfiguration,i);let m=[...a,...s,...r];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:l}}compareAndUpdateFolderConfiguration(i,a){const s=this.folderConfigurations.get(i),{added:r,updated:l,removed:m,overrides:p}=(0,t.compare)(s,a);let P=[...r,...l,...m];return(P.length||!s)&&this.updateFolderConfiguration(i,a),{keys:P,overrides:p}}compareAndDeleteFolderConfiguration(i){const a=this.folderConfigurations.get(i);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:r,removed:l,overrides:m}=(0,t.compare)(a,void 0);return{keys:[...s,...r,...l],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,a){let s=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier?s.override(i.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:i},a){let s=this.getWorkspaceConsolidatedConfiguration();if(a&&i){const r=a.getFolder(i);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const l=this._memoryConfigurationByResource.get(i);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let a=this._foldersConsolidatedConfigurations.get(i);if(!a){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(a=s.merge(r),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(i,a)):a=s}return a}getFolderConfigurationModelForResource(i,a){if(a&&i){const s=a.getFolder(i);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,a)=>{const{contents:s,overrides:r,keys:l}=this._folderConfigurations.get(a);return i.push([a,{contents:s,overrides:r,keys:l}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>i.add(a)),this.userConfiguration.freeze().keys.forEach(a=>i.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(s=>i.add(s))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>a.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>a.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>a.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r))),[...a.values()]}static parse(i){const a=this.parseConfigurationModel(i.defaults),s=this.parseConfigurationModel(i.user),r=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((m,p)=>(m.set(w.URI.revive(p[0]),this.parseConfigurationModel(p[1])),m),new k.ResourceMap);return new y(a,s,new S,r,l,new S,new k.ResourceMap,!1)}static parseConfigurationModel(i){return new S(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=y;function c(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const i=new Set,a=new Map;for(const r of u)r.keys.forEach(l=>i.add(l)),r.overrides.forEach(([l,m])=>{const p=(0,k.getOrSet)(a,l,new Set);m.forEach(P=>p.add(P))});const s=[];return a.forEach((r,l)=>s.push([l,[...r.values()]])),{keys:[...i.values()],overrides:s}}e.mergeChanges=c;class h{constructor(i,a,s,r){this.change=i,this.previous=a,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;i.keys.forEach(p=>l.add(p)),i.overrides.forEach(([,p])=>p.forEach(P=>l.add(P))),this.affectedKeys=[...l.values()];const m=new S;this.affectedKeys.forEach(p=>m.setValue(p,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(a){const s=this.previousConfiguration?this.previousConfiguration.getValue(i,a,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,a,this.currentWorkspace);return!n.equals(s,r)}return!0}return!1}doesAffectedKeysTreeContains(i,a){let s=(0,t.toValuesTree)({[a]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(i=i[r],!i)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=h;class o extends h{constructor(i,a,s,r){super({keys:i.allKeys(),overrides:[]},void 0,i,a);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=o}),define(Q[186],J([0,1,9,4,2,15,16,185,49,37]),function(V,e,v,R,D,M,k,n,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class t extends D.Disposable{constructor(E,S){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new n.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,S)),this.configuration=new n.Configuration(new n.DefaultConfigurationModel,new n.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(f=>this.onDidDefaultConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new n.Configuration(new n.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,S){const f=typeof E=="string"?E:void 0,g=(0,k.isConfigurationOverrides)(E)?E:(0,k.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(f,g,void 0)}updateValue(E,S,f,g){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const S=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(f,S,1)}onDidDefaultConfigurationChange(E){const S=this.configuration.toData(),f=this.configuration.compareAndUpdateDefaultConfiguration(new n.DefaultConfigurationModel,E);this.trigger(f,S,6)}trigger(E,S,f){const g=new n.ConfigurationChangeEvent(E,{data:S},this.configuration);g.source=f,g.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=t}),define(Q[187],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var R;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,n=R.Unknown,d){super(k);this._message=k,this._code=n,this._detail=d,this.isHandled=n===R.NotAvailable&&d===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===R.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===R.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(Q[188],J([0,1,9,18,23,17,4,2,28,85,187]),function(V,e,v,R,D,M,k,n,d,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var E;(function(O){O[O.Management=1]="Management",O[O.ExtensionHost=2]="ExtensionHost",O[O.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function S(O){switch(O){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(O){const T=new D.CancellationTokenSource;return setTimeout(()=>T.cancel(),O),T.token}function g(O,T){if(O.isCancellationRequested||T.isCancellationRequested)return D.CancellationToken.Cancelled;const _=new D.CancellationTokenSource;return O.onCancellationRequested(()=>_.cancel()),T.onCancellationRequested(()=>_.cancel()),_.token}class b{constructor(T){this._state="pending",this._disposables=new n.DisposableStore,this.promise=new Promise((_,j)=>{this._resolvePromise=_,this._rejectPromise=j}),T.isCancellationRequested?this._timeout():this._disposables.add(T.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(T){this._state==="pending"?this._disposables.add(T):T.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const T=new Error("Time limit reached");return T.code="ETIMEDOUT",T.syscall="connect",T}resolve(T){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(T))}reject(T){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(T))}}function y(O,T){const _=new b(T);return _.registerDisposable(O.onControlMessage(j=>{const X=JSON.parse(j.toString()),$=z(X);$?_.reject($):_.resolve(X)})),_.promise}function c(O,T,_,j,X,$){const N=new b($);return T.connect(_,j,X,(Z,ie)=>{N.didTimeout?(Z&&O.error(Z),ie?.dispose()):Z||!ie?N.reject(Z):N.resolve(ie)}),N.promise}function h(O,T){const _=new b(T);return O.then(j=>{_.didTimeout||_.resolve(j)},j=>{_.didTimeout||_.reject(j)}),_.promise}async function o(O,T,_,j){const X=C(O,T);O.logService.trace(`${X} 1/6. invoking socketFactory.connect().`);let $;try{$=await c(O.logService,O.socketFactory,O.host,O.port,`reconnectionToken=${O.reconnectionToken}&reconnection=${O.reconnectionProtocol?"true":"false"}`,j)}catch(oe){throw O.logService.error(`${X} socketFactory.connect() failed or timed out. Error:`),O.logService.error(oe),oe}O.logService.trace(`${X} 2/6. socketFactory.connect() was successful.`);let N,Z;O.reconnectionProtocol?(O.reconnectionProtocol.beginAcceptReconnection($,null),N=O.reconnectionProtocol,Z=!1):(N=new w.PersistentProtocol($,null),Z=!0),O.logService.trace(`${X} 3/6. sending AuthRequest control message.`);const ie={type:"auth",auth:O.connectionToken||"00000000000000000000"};N.sendControl(R.VSBuffer.fromString(JSON.stringify(ie)));try{const oe=await y(N,g(j,f(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const ae=new Error("Unexpected handshake message");throw ae.code="VSCODE_CONNECTION_ERROR",ae}O.logService.trace(`${X} 4/6. received SignRequest control message.`);const le=await h(O.signService.sign(oe.data),j),ne={type:"connectionType",commit:O.commit,signedData:le,desiredConnectionType:T};return _&&(ne.args=_),O.logService.trace(`${X} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(R.VSBuffer.fromString(JSON.stringify(ne))),{protocol:N,ownsProtocol:Z}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(O.logService.error(`${X} the handshake timed out. Error:`),O.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(O.logService.error(`${X} received error control message when negotiating connection. Error:`),O.logService.error(oe)),Z&&H(N),oe}}async function u(O,T,_,j){const X=Date.now(),$=C(O,T),{protocol:N,ownsProtocol:Z}=await o(O,T,_,j),ie=new b(j);return ie.registerDisposable(N.onControlMessage(oe=>{const le=JSON.parse(oe.toString()),ne=z(le);ne?(O.logService.error(`${$} received error control message when negotiating connection. Error:`),O.logService.error(ne),Z&&H(N),ie.reject(ne)):(O.reconnectionProtocol&&O.reconnectionProtocol.endAcceptReconnection(),O.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${Y(X)}!`),ie.resolve({protocol:N,firstMessage:le}))})),ie.promise}async function i(O,T){const{protocol:_}=await u(O,1,void 0,T);return{protocol:_}}async function a(O,T,_){const{protocol:j,firstMessage:X}=await u(O,2,T,_),$=X&&X.debugPort;return{protocol:j,debugPort:$}}async function s(O,T,_){const j=Date.now(),X=C(O,3),{protocol:$}=await o(O,3,T,_);return O.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${Y(j)}!`),$}async function r(O,T,_){const{host:j,port:X,connectionToken:$}=await O.addressProvider.getAddress();return{commit:O.commit,host:j,port:X,connectionToken:$,reconnectionToken:T,reconnectionProtocol:_,socketFactory:O.socketFactory,signService:O.signService,logService:O.logService}}async function l(O,T,_){try{const j=(0,d.generateUuid)(),X=await r(O,j,null),{protocol:$}=await i(X,D.CancellationToken.None);return new ee(O,T,_,j,$)}catch(j){throw O.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),O.logService.error(j),K.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(j)),j}}e.connectRemoteAgentManagement=l;async function m(O,T){try{const _=(0,d.generateUuid)(),j=await r(O,_,null),{protocol:X,debugPort:$}=await a(j,T,D.CancellationToken.None);return new F(O,T,_,X,$)}catch(_){throw O.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),O.logService.error(_),K.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentExtensionHost=m;async function p(O,T,_){const j=await r(O,(0,d.generateUuid)(),null);return await s(j,{host:T,port:_},D.CancellationToken.None)}e.connectRemoteAgentTunnel=p;function P(O){return(0,v.createCancelablePromise)(T=>new Promise((_,j)=>{const X=setTimeout(_,O*1e3);T.onCancellationRequested(()=>{clearTimeout(X),_()})}))}var L;(function(O){O[O.ConnectionLost=0]="ConnectionLost",O[O.ReconnectionWait=1]="ReconnectionWait",O[O.ReconnectionRunning=2]="ReconnectionRunning",O[O.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",O[O.ConnectionGain=4]="ConnectionGain"})(L=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(T,_){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=A;class W{constructor(T,_,j,X){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.durationSeconds=j,this.cancellableTimer=X,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class q{constructor(T,_,j){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=j,this.type=2}}e.ReconnectionRunningEvent=q;class x{constructor(T,_,j){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=j,this.type=4}}e.ConnectionGainEvent=x;class re{constructor(T,_,j,X){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=j,this.handled=X,this.type=3}}e.ReconnectionPermanentFailureEvent=re;class K extends n.Disposable{constructor(T,_,j,X){super();this._connectionType=T,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=_,this.reconnectionToken=j,this.protocol=X,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(X.onSocketClose($=>{const N=U(this._connectionType,this.reconnectionToken,!0);$?$.type===0?(this._options.logService.info(`${N} received socket close event (hadError: ${$.hadError}).`),$.error&&this._options.logService.error($.error)):(this._options.logService.info(`${N} received socket close event (wasClean: ${$.wasClean}, code: ${$.code}, reason: ${$.reason}).`),$.event&&this._options.logService.error($.event)):this._options.logService.info(`${N} received socket close event.`),this._beginReconnecting()})),this._register(X.onSocketTimeout(()=>{const $=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${$} received socket timeout event.`),this._beginReconnecting()})),K._instances.push(this),K._permanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}static triggerPermanentFailure(T,_,j){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=T,this._permanentFailureAttempt=_,this._permanentFailureHandled=j,this._instances.forEach(X=>X._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(K._permanentFailure)return;const T=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${T} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let j=-1;do{j++;const X=j<_.length?_[j]:_[_.length-1];try{if(X>0){const N=P(X);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X,N)),this._options.logService.info(`${T} waiting for ${X} seconds before reconnecting...`);try{await N}catch{}}if(K._permanentFailure){this._options.logService.error(`${T} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1)),this._options.logService.info(`${T} resolving connection...`);const $=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${T} connecting to ${$.host}:${$.port}...`),await this._reconnect($,f(I)),this._options.logService.info(`${T} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${T} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error($),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(j>360){this._options.logService.error(`${T} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error($),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(t.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this._options.logService.info(`${T} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this._options.logService.info(`${T} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if((0,M.isPromiseCanceledError)($)){this._options.logService.info(`${T} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if($ instanceof t.RemoteAuthorityResolverError){this._options.logService.error(`${T} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error($),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,t.RemoteAuthorityResolverError.isHandled($));break}this._options.logService.error(`${T} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error($),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}}while(!K._permanentFailure)}_gotoPermanentFailure(T,_,j){this._onDidStateChange.fire(new re(this.reconnectionToken,T,_,j)),H(this.protocol)}}K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[];class ee extends K{constructor(T,_,j,X,$){super(1,T,X,$);this.client=this._register(new w.Client($,{remoteAuthority:_,clientId:j},T.ipcLogger))}async _reconnect(T,_){await i(T,_)}}e.ManagementPersistentConnection=ee;class F extends K{constructor(T,_,j,X,$){super(2,T,j,X);this._startArguments=_,this.debugPort=$}async _reconnect(T,_){await a(T,this._startArguments,_)}}e.ExtensionHostPersistentConnection=F;function H(O){try{O.acceptDisconnect();const T=O.getSocket();O.dispose(),T.dispose()}catch(T){(0,M.onUnexpectedError)(T)}}function z(O){if(O&&O.type==="error"){const T=new Error(`Connection error: ${O.reason}`);return T.code="VSCODE_CONNECTION_ERROR",T}return null}function B(O,T){for(;O.length<T;)O+=" ";return O}function U(O,T,_){return`[remote-connection][${B(S(O),13)}][${T.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function C(O,T){return`${U(T,O.reconnectionToken,!!O.reconnectionProtocol)}[${O.host}:${O.port}]`}function Y(O){return`${Date.now()-O} ms`}}),define(Q[62],J([0,1,10]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(w){return w.scheme===v.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=R;function D(w){if(!w)return;const t=w.indexOf("+");return t<0?w:w.substr(0,t)}e.getRemoteName=D;function M(w){return w.scheme!==v.Schemas.file&&w.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=M;function k(w){if(w.folders.length)return w.folders.every(t=>M(t.uri))?w.folders[0].uri:void 0;if(w.configuration&&M(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=k;function n(w){return k(w)?.scheme}e.getVirtualWorkspaceScheme=n;function d(w){return k(w)!==void 0}e.isVirtualWorkspace=d}),define(Q[189],J([0,1,27,5,62]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=M;function k(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var n;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(n=e.ExtensionType||(e.ExtensionType={}));class d{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,f){if(typeof S=="undefined"||S===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof S=="string"||typeof f=="string"){let g=typeof S=="string"?S:S.value,b=typeof f=="string"?f:f.value;return v.equalsIgnoreCase(g,b)}return S._lower===f._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=d;function w(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function t(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=t;function I(E,S){if(S&&E.enableProposedApi){const f=`onResolveRemoteAuthority:${(0,D.getRemoteName)(S)}`;return E.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[190],J([0,1,27,189]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(f,g){return f.uuid&&g.uuid?f.uuid===g.uuid:f.id===g.id?!0:(0,v.compareIgnoreCase)(f.id,g.id)===0}e.areSameExtensions=D;class M{constructor(g,b){this.version=b,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof M?D(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=M;function k(f,g){return`${f}.${g}`}e.getExtensionId=k;function n(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function d(f,g){return n(k(f,g))}e.getGalleryExtensionId=d;function w(f,g){const b=[],y=c=>{for(const h of b)if(h.some(o=>D(g(o),g(c))))return h;return null};for(const c of f){const h=y(c);h?h.push(c):b.push([c])}return b}e.groupByExtension=w;function t(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function I(f){return{id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),...f.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function E(f){const g=new Set;for(const b of f)b.malicious&&g.add(b.id.id);return g}e.getMaliciousExtensionsSet=E;function S(f,g){const b=[],y=g.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const c=y.shift();if(c&&b.every(h=>!D(h.identifier,{id:c}))){const h=f.filter(o=>D(o.identifier,{id:c}));h.length===1&&(b.push(h[0]),y.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=S}),define(Q[95],J([0,1,4,3,5,6]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var k;(function(f){f.Http="http",f.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(n=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=I;function E(f,g){return g?g!==1&&f<1024:!R.isWindows&&f<1024}e.isPortPrivileged=E;let S=class{constructor(g){this.logService=g,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g,b){return this._tunnelProvider=g,g?(this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],b=Array.from(this._tunnels.values());for(let y of b){const c=Array.from(y.values());for(let h of c){const o=await h.value;o&&g.push(o)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:b}of g.values())await b.then(y=>y?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,b,y,c,h=!1,o=n.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${b}:${y} on local port ${c}.`),!g)return;b||(b="localhost");const i=this.retainOrCreateTunnel(g,b,y,c,h,o,u);return i?i.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(b,y);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(a);return(a.tunnelRemoteHost!==b||a.tunnelRemotePort!==y)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const b=this._tunnels.get(g.tunnelRemoteHost);if(b){const y=b.get(g.tunnelRemotePort);y&&(y.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,y))}}}}async tryDisposeTunnel(g,b,y){if(y.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${b}.`);const c=y.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(b),c}}async closeTunnel(g,b){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${b} `);const y=this._tunnels.get(g);if(y&&y.has(b)){const c=y.get(b);c.refcount=0,await this.tryDisposeTunnel(g,b,c)}}addTunnelToMap(g,b,y){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(b,{refcount:1,value:y})}async removeEmptyTunnelFromMap(g,b){const y=this._tunnels.get(g);y&&(await y.get(b)||y.delete(b),y.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,b){let y=[g];t(g)?(y.push(...e.LOCALHOST_ADDRESSES),y.push(...e.ALL_INTERFACES_ADDRESSES)):I(g)&&y.push(...e.ALL_INTERFACES_ADDRESSES);const c=y.map(h=>this._tunnels.get(h));for(const h of c){const o=h?.get(b);if(o)return o}}canTunnel(g){return!!w(g)}createWithProvider(g,b,y,c,h,o,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${b}:${y} on local port ${c}.`);const a={elevationRequired:h?E(c===void 0?y:c):!1},s={remoteAddress:{host:b,port:y},localAddressPort:c,privacy:o,public:o!==n.Private,protocol:u},r=g.forwardPort(s,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(b,y,r),r}};S=he([te(0,M.ILogService)],S),e.AbstractTunnelService=S}),define(Q[50],J([0,1,18,146,49,5,37]),function(V,e,v,R,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function n(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=n;function d(f){return f.res.statusCode===204}async function w(f){if(!n(f))throw new Error("Server returned "+f.res.statusCode);return d(f)?null:(await(0,v.streamToBuffer)(f.stream)).toString()}e.asText=w;async function t(f){if(!n(f))throw new Error("Server returned "+f.res.statusCode);if(d(f))return null;const b=(await(0,v.streamToBuffer)(f.stream)).toString();try{return JSON.parse(b)}catch(y){throw y.message+=`:
`+b,y}}e.asJson=t;function I(f){S(f)}e.updateProxyConfigurationsScope=I;let E;function S(f){const g=k.Registry.as(D.Extensions.Configuration),b=E;E={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[E],remove:b?[b]:[]})}S(2)}),define(Q[191],J([0,1,192,13]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(k,n){return k.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:k.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function M(k,n,d={}){const w=(0,v.parse)(k),t=d.proxyUrl||D(w,n);if(!t)return null;const I=(0,v.parse)(t);if(!/^https?:$/.test(I.protocol||""))return null;const E={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,R.isBoolean)(d.strictSSL)?d.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((S,f)=>{V(["http-proxy-agent"],S,f)}))(E):new(await new Promise((S,f)=>{V(["https-proxy-agent"],S,f)}))(E)}e.getProxyAgent=M}),define(Q[193],J([0,1,18,28]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(M,k,n){let d=n&&n.get("storage.serviceMachineId",0)||null;if(d)return d;try{const t=(await k.readFile(M.serviceMachineIdResource)).value.toString();d=(0,R.isUUID)(t)?t:null}catch(w){d=null}if(!d){d=(0,R.generateUuid)();try{await k.writeFile(M.serviceMachineIdResource,v.VSBuffer.fromString(d))}catch(w){}}return n&&n.store("storage.serviceMachineId",d,0,1),d}e.getServiceMachineId=D}),define(Q[78],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Q[194],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((D,M)=>V(["vsda"],D,M))}async sign(D){try{const M=await this.vsda(),k=new M.signer;if(k)return k.sign(D)}catch(M){}return D}}e.SignService=v}),define(Q[38],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Q[22],J([0,1,14,9,4,2,3,32,13,5,174,6,38]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var S;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(S=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let f=class at extends M.Disposable{constructor(b,y){super();this.logService=b,this.stateMainService=y,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(at.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(at.QUIT_AND_RESTART_KEY)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),k.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",b);const y=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!k.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",y),v.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",b),v.app.removeListener("window-all-closed",y),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(y){b.push(y)}}),this.pendingWillShutdownPromise=(async()=>{try{await R.Promises.settled(b)}catch(y){this.logService.error(y)}try{await this.stateMainService.close()}catch(y){this.logService.error(y)}})(),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===b)return;this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const y=this.phaseWhen.get(this._phase);y&&(y.open(),this.phaseWhen.delete(this._phase))}async when(b){if(b<=this._phase)return;let y=this.phaseWhen.get(b);y||(y=new R.Barrier,this.phaseWhen.set(b,y)),await y.wait()}registerWindow(b){const y=new M.DisposableStore;this.windowCounter++,y.add(b.onWillLoad(h=>this._onWillLoadWindow.fire({window:b,workspace:h.workspace,reason:h.reason})));const c=(0,d.assertIsDefined)(b.win);c.on("close",h=>{const o=b.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),h.preventDefault(),this.unload(b,1).then(u=>{if(u){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(b),b.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,y.dispose(),this.windowCounter===0&&(!k.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(b,y){await this.unload(b,3)||b.reload(y)}async unload(b,y){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const c=this._quitRequested?2:y;let h=await this.onBeforeUnloadWindowInRenderer(b,c);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(h)):(h=await this.onBeforeUnloadWindowInMain(b,c),h?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(h)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,c),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(b,y){return new Promise(c=>{const h=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${h}`,u=`vscode:cancel${h}`;v.ipcMain.once(o,()=>{c(!1)}),v.ipcMain.once(u,()=>{c(!0)}),b.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:u,reason:y})})}onBeforeUnloadWindowInMain(b,y){const c=[];return this._onBeforeUnloadWindow.fire({reason:y,window:b,veto(h){c.push(h)}}),(0,t.handleVetos)(c,h=>this.logService.error(h))}onWillUnloadWindowInRenderer(b,y){return new Promise(c=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(o,()=>c()),b.send("vscode:onWillUnload",{replyChannel:o,reason:y})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${b}`),b&&this.stateMainService.setItem(at.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(y=>{this.pendingQuitPromiseResolve=y,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(b){this.logService.trace("Lifecycle#relaunch()");const y=process.argv.slice(1);if(b?.addArgs&&y.push(...b.addArgs),b?.removeArgs)for(const o of b.removeArgs){const u=y.indexOf(o);u>=0&&y.splice(u,1)}const c=()=>{try{if(k.isWindows){const o=(0,n.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:y})};v.app.once("quit",c),await this.quit(!0)&&v.app.removeListener("quit",c)}async kill(b){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,R.timeout)(1e3),(async()=>{for(const y of v.BrowserWindow.getAllWindows())if(y&&!y.isDestroyed()){let c;y.webContents&&!y.webContents.isDestroyed()?c=new Promise(h=>y.once("closed",h)):c=Promise.resolve(),y.destroy(),await c}})()]),v.app.exit(b)}};f.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",f=he([te(0,I.ILogService),te(1,E.IStateMainService)],f),e.LifecycleMainService=f}),define(Q[195],J([0,1,4,2,5,22]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let k=class extends R.Disposable{constructor(w){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((t,I)=>{V(["native-keymap"],t,I)});this._keyboardLayoutData=n(w),w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};k=he([te(0,M.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function n(d){const w=d.getKeyMap(),t=d.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:t}}}),define(Q[96],J([0,1,9,4,2,13,87,5]),function(V,e,v,R,D,M,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";e.IStorageService=(0,n.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var t;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(t=e.StorageScope||(e.StorageScope={}));var I;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class E extends D.Disposable{constructor(b={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,y){y===d?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:y,target:this.getKeyTargets(b)[y]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,y,c){return this.getStorage(y)?.get(b,c)}getBoolean(b,y,c){return this.getStorage(y)?.getBoolean(b,c)}getNumber(b,y,c){return this.getStorage(y)?.getNumber(b,c)}store(b,y,c,h){if((0,M.isUndefinedOrNull)(y)){this.remove(b,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,c,h),this.getStorage(c)?.set(b,y)})}remove(b,y){this.withPausedEmitters(()=>{this.updateKeyTarget(b,y,void 0),this.getStorage(y)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,y){const c=[],h=this.getKeyTargets(b);for(const o of Object.keys(h))h[o]===y&&c.push(o);return c}updateKeyTarget(b,y,c){const h=this.getKeyTargets(y);typeof c=="number"?h[b]!==c&&(h[b]=c,this.getStorage(y)?.set(d,JSON.stringify(h))):typeof h[b]=="number"&&(delete h[b],this.getStorage(y)?.set(d,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const y=this.get(d,b);if(y)try{return JSON.parse(y)}catch(c){}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=w.NONE){this._onWillSaveState.fire({reason:b}),await v.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const b=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return f(b,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class S extends E{constructor(){super();this.globalStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=S;async function f(g,b,y,c){const h=l=>{try{return JSON.parse(l)}catch(m){return l}},o=new Map,u=new Map;g.forEach((l,m)=>{o.set(m,l),u.set(m,h(l))});const i=new Map,a=new Map;b.forEach((l,m)=>{i.set(m,l),a.set(m,h(l))}),console.group(`Storage: Global (path: ${y})`);let s=[];o.forEach((l,m)=>{s.push({key:m,value:l})}),console.table(s),console.groupEnd(),console.log(u),console.group(`Storage: Workspace (path: ${c})`);let r=[];i.forEach((l,m)=>{r.push({key:m,value:l})}),console.table(r),console.groupEnd(),console.log(a)}e.logStorage=f}),define(Q[196],J([0,1,3,32,7,28]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(w){if(v.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function n(w,t,I,E,S,f,g,b,y,c){const h=Object.create(null);h["common.machineId"]=g,h.sessionID=(0,M.generateUuid)()+Date.now(),h.commitHash=S,h.version=f,h["common.platformVersion"]=(t||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,v.PlatformToString)(v.platform),h["common.nodePlatform"]=R.platform,h["common.nodeArch"]=E,h["common.product"]=c||"desktop";const o=d(b||[]);o&&(h["common.msftInternal"]=o);let u=0;const i=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),v.isLinuxSnap&&(h["common.snap"]="true");const a=k(I);a&&(h["common.platformDetail"]=a);try{const s=await w.readFile(D.URI.file(y));h["common.source"]=s.value.toString().slice(0,30)}catch(s){}return h}e.resolveCommonProperties=n;function d(w){const t=R.env.USERDNSDOMAIN;if(!t)return!1;const I=t.toLowerCase();return w.some(E=>I===E)}e.verifyMicrosoftInternalDomain=d}),define(Q[29],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[197],J([0,1,25,67,9,39,10,8,3,7,71,19,84,75,20,21,29]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function y(i,a){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,l=new Map,m=2e4;function p(A,W,q,x){const re=W.substring(A.length+1);return D.Promises.withAsyncBody(async K=>{let ee;try{ee=await I.Promises.readdir(W,{withFileTypes:!0})}catch(z){K();return}if(x.count>=m){x.count+=ee.length,x.maxReached=!0,K();return}let F=ee.length;if(F===0){K();return}let H=ee;x.count+ee.length>m&&(x.maxReached=!0,F=m-x.count,H=ee.slice(0,F)),x.count+=ee.length;for(const z of H)if(z.isDirectory()){if(q.includes(z.name)||await p(A,(0,n.join)(W,z.name),q,x),--F==0){K();return}}else{const B=z.name.lastIndexOf(".");if(B>=0){const U=z.name.substring(B+1);U&&r.set(U,(r.get(U)??0)+1)}for(const U of s)U.relativePathPattern?.test(re)!==!1&&U.filePattern.test(z.name)&&l.set(U.tag,(l.get(U.tag)??0)+1);if(--F==0){K();return}}})}const P={count:0,maxReached:!1};await p(i,i,a,P);const L=await o(i);return{configFiles:c(l),fileTypes:c(r),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:L}}e.collectWorkspaceStats=y;function c(i){return[...R.Iterable.map(i.entries(),([a,s])=>({name:a,count:s}))].sort((a,s)=>s.count-a.count)}function h(){const i={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(t.virtualMachineHint.value()*100)}%`},a=v.cpus();return a&&a.length>0&&(i.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),i}e.getMachineInfo=h;async function o(i){try{const a=new Map,s=(0,n.join)(i,".vscode","launch.json"),r=await I.Promises.readFile(s),l=[],m=(0,M.parse)(r.toString(),l);if(l.length)return console.log(`Unable to parse ${s}`),[];if((0,M.getNodeType)(m)==="object"&&m.configurations)for(const p of m.configurations){const P=p.type;P&&(a.has(P)?a.set(P,a.get(P)+1):a.set(P,1))}return c(a)}catch(a){return[]}}e.collectLaunchConfigs=o;let u=class{constructor(a,s){this.telemetryService=a,this.productService=s}formatMachineInfo(a){const s=[];return s.push(`OS Version:       ${a.os}`),s.push(`CPUs:             ${a.cpus}`),s.push(`Memory (System):  ${a.memory}`),s.push(`VM:               ${a.vmHint}`),s.join(`
`)}formatEnvironment(a){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const r=v.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(v.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),d.isWindows||s.push(`Load (avg):       ${v.loadavg().map(l=>Math.round(l)).join(", ")}`),s.push(`VM:               ${Math.round(t.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${a.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(a,s){return Promise.all([(0,E.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async r=>{let[l,m]=r,p=this.formatProcessList(a,l);return s.forEach(P=>{if((0,S.isRemoteDiagnosticError)(P))p+=`
${P.errorMessage}`,m+=`
${P.errorMessage}`;else if(p+=`

Remote: ${P.hostName}`,P.processes&&(p+=`
${this.formatProcessList(a,P.processes)}`),P.workspaceMetadata){m+=`
|  Remote: ${P.hostName}`;for(const L of Object.keys(P.workspaceMetadata)){const A=P.workspaceMetadata[L];let W=`${A.fileCount} files`;A.maxFilesReached&&(W=`more than ${W}`),m+=`|    Folder (${L}): ${W}`,m+=this.formatWorkspaceStats(A)}}}),{processInfo:p,workspaceInfo:m}})}async getSystemInfo(a,s){const{memory:r,vmHint:l,os:m,cpus:p}=h(),P={os:m,memory:r,cpus:p,vmHint:l,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:s};return d.isWindows||(P.load=`${v.loadavg().map(L=>Math.round(L)).join(", ")}`),d.isLinux&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(a,s){const r=[];return(0,E.listProcesses)(a.mainPID).then(async l=>(r.push(""),r.push(this.formatEnvironment(a)),r.push(""),r.push(this.formatProcessList(a,l)),a.windows.some(m=>m.folderURIs&&m.folderURIs.length>0&&!m.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(a))),s.forEach(m=>{if((0,S.isRemoteDiagnosticError)(m))r.push(`
${m.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${m.hostName}`),r.push(this.formatMachineInfo(m.machineInfo)),m.processes&&r.push(this.formatProcessList(a,m.processes)),m.workspaceMetadata)for(const p of Object.keys(m.workspaceMetadata)){const P=m.workspaceMetadata[p];let L=`${P.fileCount} files`;P.maxFilesReached&&(L=`more than ${L}`),r.push(`Folder (${p}): ${L}`),r.push(this.formatWorkspaceStats(P))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(a){const s=[],r=60;let l=0;const m=(A,W)=>{const q=` ${A}(${W})`;l+q.length>r?(s.push(p),p="|                 ",l=p.length):l+=q.length,p+=q};let p="|      File types:";const P=10;let L=a.fileTypes.length>P?P:a.fileTypes.length;for(let A=0;A<L;A++){const W=a.fileTypes[A];m(W.name,W.count)}if(s.push(p),a.configFiles.length>=0&&(p="|      Conf files:",l=0,a.configFiles.forEach(A=>{m(A.name,A.count)}),s.push(p)),a.launchConfigFiles.length>0){let A="|      Launch Configs:";a.launchConfigFiles.forEach(W=>{A+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(A)}return s.join(`
`)}expandGPUFeatures(a){const s=Math.max(...Object.keys(a).map(r=>r.length));return Object.keys(a).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${a[r]}`).join(`
                  `)}formatWorkspaceMetadata(a){const s=[],r=[];return a.windows.forEach(l=>{l.folderURIs.length===0||!!l.remoteAuthority||(s.push(`|  Window (${l.title})`),l.folderURIs.forEach(m=>{const p=w.URI.revive(m);if(p.scheme===k.Schemas.file){const P=p.fsPath;r.push(y(P,["node_modules",".git"]).then(L=>{let A=`${L.fileCount} files`;L.maxFilesReached&&(A=`more than ${A}`),s.push(`|    Folder (${(0,n.basename)(P)}): ${A}`),s.push(this.formatWorkspaceStats(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${P} (${L.toString()})`)}))}else s.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(l=>s.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}formatProcessList(a,s){const r=new Map;a.windows.forEach(m=>r.set(m.pid,m.title));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(a.mainPID,r,l,s,0),l.join(`
`)}formatProcessItem(a,s,r,l,m){const p=m===0;let P;p?P=l.pid===a?`${this.productService.applicationName} main`:"remote agent":(P=`${"  ".repeat(m)} ${l.name}`,l.name==="window"&&(P=`${P} (${s.get(l.pid)})`));const L=process.platform==="win32"?l.mem:v.totalmem()*(l.mem/100);r.push(`${l.load.toFixed(0).padStart(5," ")}	${(L/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(l.children)&&l.children.forEach(A=>this.formatProcessItem(a,s,r,A,m+1))}async reportWorkspaceStats(a){for(const{uri:s}of a.folders){const r=w.URI.revive(s);if(r.scheme!==k.Schemas.file)continue;const l=r.fsPath;try{const m=await y(l,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),m.fileTypes.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:p.name,count:p.count})}),m.launchConfigFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:p.name,count:p.count})}),m.configFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};u=he([te(0,b.ITelemetryService),te(1,g.IProductService)],u),e.DiagnosticsService=u}),define(Q[198],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(M){this.appenders=M}listen(M,k){throw new Error(`Event not found: ${k}`)}call(M,k,{eventName:n,data:d}){return this.appenders.forEach(w=>w.log(n,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class R{constructor(M){this.channel=M}log(M,k){return this.channel.call("log",{eventName:M,data:k}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(Q[63],J([0,1,43,13,16,29]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(y,c){return Promise.resolve(void 0)}publicLog2(y,c){return this.publicLog(y,c)}publicLogError(y,c){return Promise.resolve(void 0)}publicLogError2(y,c){return this.publicLogError(y,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class n{async publicLog(y,c,h){}async publicLogError(y,c,h){}}e.NullEndpointTelemetryService=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(b,y){return y.onDidChangeConfiguration(c=>{c.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(c.source),configurationKeys:f(c.sourceConfig)})})}e.configurationTelemetry=d;function w(b,y){return!(y.disableTelemetry||!b.enableTelemetry)}e.supportsTelemetry=w;function t(b){const y=b.getValue(M.TELEMETRY_SETTING_ID),c=b.getValue("telemetry.enableCrashReporter");if(b.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=t;function I(b){const y=Object.create(null),c=Object.create(null),h=Object.create(null);S(b,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const u=h[o];typeof u=="number"?c[o]=u:typeof u=="boolean"?c[o]=u?1:0:typeof u=="string"?y[o]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(y[o]=u)}return{properties:y,measurements:c}}e.validateTelemetryData=I;function E(b){if(!b)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{b.indexOf(`${h}+`)===0&&(y=h)}),y}e.cleanRemoteAuthority=E;function S(b,y,c=0,h){if(!!b)for(let o of Object.getOwnPropertyNames(b)){const u=b[o],i=h?h+o:o;Array.isArray(u)?y[i]=(0,v.safeStringify)(u):u instanceof Date?y[i]=u.toISOString():(0,R.isObject)(u)?c<2?S(u,y,c+1,i+"."):y[i]=(0,v.safeStringify)(u):y[i]=u}}function f(b){if(!b)return[];const y=[];return g(y,"",b),y}function g(b,y,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(h=>g(b,y?`${y}.${h}`:h,c[h])):b.push(y)}}),define(Q[199],J([0,1,30,23,17,43,3,32,7,16,48,163,190,161,20,6,21,50,193,96,29,63]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y,c,h,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=k.isWeb?"web":(0,I.getTargetPlatform)(k.platform,n.arch);var a;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished"})(a||(a={}));function s(...$){return String($.reduce((N,Z)=>N|Z,0))}var r;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},P={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class L{constructor(N=P){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,Z=this.state.pageSize){return new L({...this.state,pageNumber:N,pageSize:Z})}withFilter(N,...Z){const ie=[...this.state.criteria,...Z.length?Z.map(oe=>({filterType:N,value:oe})):[{filterType:N}]];return new L({...this.state,criteria:ie})}withSortBy(N){return new L({...this.state,sortBy:N})}withSortOrder(N){return new L({...this.state,sortOrder:N})}withFlags(...N){return new L({...this.state,flags:N.reduce((Z,ie)=>Z|ie,0)})}withAssetTypes(...N){return new L({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:Z,pageSize:ie,sortBy:oe,sortOrder:le,flags:ne,assetTypes:ae}=this.state;return{filters:[{criteria:N,pageNumber:Z,pageSize:ie,sortBy:oe,sortOrder:le}],assetTypes:ae,flags:ne}}get searchText(){const N=this.state.criteria.filter(Z=>Z.filterType===r.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A($,N){const Z=($||[]).filter(ie=>ie.statisticName===N)[0];return Z?Z.value:0}function W($){const N="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(ie=>ie.assetType.indexOf(N)===0).reduce((ie,oe)=>{const le=K($,oe.assetType);return le&&ie.push([oe.assetType.substring(N.length),le]),ie},[])}function q($){if($.properties){const N=$.properties.filter(oe=>oe.key===l.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=N.filter(oe=>Z.test(oe.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return K($,l.Repository)}function x($){return{uri:`${$.fallbackAssetUri}/${l.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${l.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function re($){const N=K($,l.Icon);if(N)return N;const Z=I.DefaultIconPath;return{uri:Z,fallbackUri:Z}}function K($,N){return $.files.filter(ie=>ie.assetType===N)[0]?{uri:`${$.assetUri}/${N}`,fallbackUri:`${$.fallbackAssetUri}/${N}`}:null}function ee($,N){const Z=$.properties?$.properties.filter(oe=>oe.key===N):[],ie=Z.length>0&&Z[0].value;return ie?ie.split(",").map(oe=>(0,E.adoptToGalleryExtensionId)(oe)):[]}function F($){const N=$.properties?$.properties.filter(Z=>Z.key===m.Engine):[];return N.length>0&&N[0].value||""}function H($){const N=$.properties?$.properties.filter(ie=>ie.key===m.LocalizedLanguages):[],Z=N.length>0&&N[0].value||"";return Z?Z.split(","):[]}function z($){return $.indexOf("preview")!==-1}function B($){return $.targetPlatform?(0,I.toTargetPlatform)($.targetPlatform):"undefined"}function U($){const N=(0,v.distinct)($.versions.map(B)),Z=!!$.tags?.includes(I.WEB_EXTENSION_TAG),ie=N.indexOf("web");return Z?ie===-1&&N.push("web"):ie!==-1&&N.splice(ie,1),N}function C($,N){const Z=(0,I.getFallbackTargetPlarforms)(N);for(let ie=0;ie<$.length;ie++){const oe=$[ie];if(oe.version===$[ie-1]?.version){let le=ie;const ne=B(oe);if(ne===N)for(;le>0&&$[le-1].version===oe.version;)le--;else if(Z.includes(ne))for(;le>0&&$[le-1].version===oe.version&&B($[le-1])!==N;)le--;le!==ie&&($.splice(ie,1),$.splice(le,0,oe))}}return $}e.sortExtensionVersions=C;function Y($,N,Z,ie,oe){const le=U($);let ne=$.versions[0];return ne=$.versions.find(ae=>ae.version===ne.version&&(0,I.isTargetPlatformCompatible)(B(ae),le,oe))||ne,O($,ne,le,N,Z,ie)}function O($,N,Z,ie,oe,le){const ne={manifest:K(N,l.Manifest),readme:K(N,l.Details),changelog:K(N,l.Changelog),license:K(N,l.License),repository:q(N),download:x(N),icon:re(N),coreTranslations:W(N)};return{identifier:{id:(0,E.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:N.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,description:$.shortDescription||"",installCount:A($.statistics,"install"),rating:A($.statistics,"averagerating"),ratingCount:A($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:Z,assets:ne,properties:{dependencies:ee(N,m.Dependency),extensionPack:ee(N,m.ExtensionPack),engine:F(N),localizedLanguages:H(N),targetPlatform:B(N)},preview:z($.flags),telemetryData:{index:(oe.pageNumber-1)*oe.pageSize+ie,querySource:le}}}let T=class{constructor(N,Z,ie,oe,le,ne,ae,ue){this.requestService=Z,this.logService=ie,this.environmentService=oe,this.telemetryService=le,this.fileService=ne,this.productService=ae,this.configurationService=ue;const de=ae.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=X(ae.version,ae,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,Z){const ie=[];let oe=new L().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,N.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...N.map(({id:ne})=>ne.toLowerCase()));N.every(ne=>!ne.version)&&(oe=oe.withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties,a.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(oe,i,R.CancellationToken.None);for(let ne=0;ne<le.length;ne++){const ae=le[ne];if(!ae.versions.length)continue;const ue=(0,E.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),de=N.find(ve=>(0,E.areSameExtensions)(ve,{id:ue}))?.version;if(de){const ve=ae.versions.find(Ie=>Ie.version===de);ve&&ie.push(O(ae,ve,U(ae),ne,oe))}else ie.push(Y(ae,ne,oe,void 0,i))}return ie}async getCompatibleExtension(N,Z){const ie=(0,I.isIExtensionIdentifier)(N)?null:N;if(ie){if((0,I.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(ie,Z))return ie}const{id:oe,uuid:le}=ie?ie.identifier:N;let ne=new L().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");le?ne=ne.withFilter(r.ExtensionId,le):ne=ne.withFilter(r.ExtensionName,oe);const{galleryExtensions:ae}=await this.queryGallery(ne,Z,R.CancellationToken.None),[ue]=ae;if(!ue||!ue.versions.length)return null;const de=U(ue);if((0,I.isNotWebExtensionInWebTargetPlatform)(de,Z))return null;for(let ve of ue.versions){if(!F(ve)){const Ie=await this.getEngine(ve);ve={...ve,properties:[...ve.properties||[],{key:m.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(ve,de,Z))return O(ue,ve,de,0,ne)}return null}async isExtensionCompatible(N,Z){if(!(0,I.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,Z))return!1;let ie=N.properties.engine;if(!ie){const oe=await this.getManifest(N,R.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");ie=oe.engines.vscode}return(0,S.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,Z,ie){if(!(0,I.isTargetPlatformCompatible)(B(N),Z,ie))return!1;const oe=await this.getEngine(N);return(0,S.isEngineValid)(oe,this.productService.version,this.productService.date)}async query(N,Z){const ie=R.CancellationToken.isCancellationToken(N)?{}:N,oe=R.CancellationToken.isCancellationToken(N)?N:Z;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=ie.text||"";const ne=(0,M.getOrDefault)(ie,me=>me.pageSize,50);let ae=new L().withFlags(a.IncludeLatestVersionOnly,a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,ne).withFilter(r.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ge,Ee)=>(ae=ae.withFilter(r.Category,Ee||ge),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ge,Ee)=>(ae=ae.withFilter(r.Tag,Ee||ge),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(r.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),ae=ae.withFilter(r.SearchText,le)),ae=ae.withSortBy(0)):ie.ids?ae=ae.withFilter(r.ExtensionId,...ie.ids):ie.names?ae=ae.withFilter(r.ExtensionName,...ie.names):ae=ae.withSortBy(4),typeof ie.sortBy=="number"&&(ae=ae.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(ae=ae.withSortOrder(ie.sortOrder));const{galleryExtensions:ue,total:de}=await this.queryGallery(ae,i,oe),ve=ue.map((me,ge)=>Y(me,ge,ae,ie.source,i)),Ie=async(me,ge)=>{if(ge.isCancellationRequested)throw(0,D.canceled)();const Ee=ae.withPage(me+1),{galleryExtensions:ke}=await this.queryGallery(Ee,i,ge);return ke.map((Ae,We)=>Y(Ae,We,Ee,ie.source,i))};return{firstPage:ve,total:de,pageSize:ae.pageSize,getPage:Ie}}async queryGallery(N,Z,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,a.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(a.Unpublished));const oe=await this.commonHeadersPromise,le=JSON.stringify(N.raw),ne={...oe,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},ae=new Date().getTime();let ue,de,ve=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:ne},ie),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ve};const Ie=await(0,y.asJson)(ue);if(Ie){const me=Ie.results[0],ge=me.extensions;ge.forEach(ke=>C(ke.versions,Z));const Ee=me.resultMetadata&&me.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return ve=Ee&&Ee.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ve}}return{galleryExtensions:[],total:ve}}catch(Ie){throw de=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-ae,success:!!ue&&(0,y.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:de?(0,D.isPromiseCanceledError)(de)?"canceled":(0,D.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(N,Z,ie,oe){if(!this.isEnabled())return;const le=k.isWeb?this.api(`/itemName/${N}.${Z}/version/${ie}/statType/${oe==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${Z}/${ie}/stats?statType=${oe}`),ne=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ne};try{await this.requestService.request({type:"POST",url:le,headers:ue},R.CancellationToken.None)}catch(de){}}async download(N,Z,ie){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const oe=(0,E.getGalleryExtensionTelemetryData)(N),le=new Date().getTime(),ne=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...oe,duration:ve}),ae=ie===1?"install":ie===2?"update":"",ue=ae?{uri:`${N.assets.download.uri}${d.URI.parse(N.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${N.assets.download.fallbackUri}${d.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:N.assets.download,de=await this.getAsset(ue);await this.fileService.writeFile(Z,de.stream),ne(new Date().getTime()-le)}async getReadme(N,Z){if(N.assets.readme){const ie=await this.getAsset(N.assets.readme,{},Z);return await(0,y.asText)(ie)||""}return""}async getManifest(N,Z){if(N.assets.manifest){const ie=await this.getAsset(N.assets.manifest,{},Z),oe=await(0,y.asText)(ie);return oe?JSON.parse(oe):null}return null}async getManifestFromRawExtensionVersion(N,Z){const ie=K(N,l.Manifest);if(!ie)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},le=await this.getAsset(ie,{headers:oe});return await(0,y.asJson)(le)}async getCoreTranslation(N,Z){const ie=N.assets.coreTranslations.filter(oe=>oe[0]===Z.toUpperCase())[0];if(ie){const oe=await this.getAsset(ie[1]),le=await(0,y.asText)(oe);return le?JSON.parse(le):null}return null}async getChangelog(N,Z){if(N.assets.changelog){const ie=await this.getAsset(N.assets.changelog,{},Z);return await(0,y.asText)(ie)||""}return""}async getAllCompatibleVersions(N,Z){let ie=new L().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?ie=ie.withFilter(r.ExtensionId,N.identifier.uuid):ie=ie.withFilter(r.ExtensionName,N.identifier.id);const{galleryExtensions:oe}=await this.queryGallery(ie,Z,R.CancellationToken.None);if(!oe.length)return[];const le=U(oe[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(le,Z))return[];const ne=[];for(const ae of oe[0].versions)try{ne[ne.length-1]?.version!==ae.version&&await this.isRawExtensionVersionCompatible(ae,le,Z)&&ne.push({version:ae.version,date:ae.lastUpdated})}catch(ue){}return ne}async getAsset(N,Z={},ie=R.CancellationToken.None){const oe=await this.commonHeadersPromise,le={type:"GET"},ne={...oe,...Z.headers||{}};Z={...Z,...le,headers:ne};const ae=N.uri,ue=N.fallbackUri,de={...Z,url:ae};try{const ve=await this.requestService.request(de,ie);if(ve.res.statusCode===200)return ve;const Ie=await(0,y.asText)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${Ie}`)}catch(ve){if((0,D.isPromiseCanceledError)(ve))throw ve;const Ie=(0,D.getErrorMessage)(ve);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:Ie});const me={...Z,url:ue};return this.requestService.request(me,ie)}}async getEngine(N){let Z=F(N);if(!Z){const ie=await this.getManifestFromRawExtensionVersion(N,R.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");Z=ie.engines.vscode}return Z}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,y.asJson)(N),ie=new Map;if(Z)for(const oe of Z.malicious){const le=ie.get(oe)||{id:{id:oe},malicious:!0,slow:!1};le.malicious=!0,ie.set(oe,le)}return[...ie.values()]}};T=he([te(1,y.IRequestService),te(2,g.ILogService),te(3,t.IEnvironmentService),te(4,o.ITelemetryService),te(5,f.IFileService),te(6,b.IProductService),te(7,w.IConfigurationService)],T);let _=class extends T{constructor(N,Z,ie,oe,le,ne,ae,ue){super(N,Z,ie,oe,le,ne,ae,ue)}};_=he([te(0,h.IStorageService),te(1,y.IRequestService),te(2,g.ILogService),te(3,t.IEnvironmentService),te(4,o.ITelemetryService),te(5,f.IFileService),te(6,b.IProductService),te(7,w.IConfigurationService)],_),e.ExtensionGalleryService=_;let j=class extends T{constructor(N,Z,ie,oe,le,ne,ae){super(void 0,N,Z,ie,oe,le,ne,ae)}};j=he([te(0,y.IRequestService),te(1,g.ILogService),te(2,t.IEnvironmentService),te(3,o.ITelemetryService),te(4,f.IFileService),te(5,b.IProductService),te(6,w.IConfigurationService)],j),e.ExtensionGalleryServiceWithNoStorageService=j;async function X($,N,Z,ie,oe,le){const ne={"X-Market-Client-Id":`VSCode ${$}`,"User-Agent":`VSCode ${$}`},ae=await(0,c.getServiceMachineId)(Z,oe,le);return(0,u.supportsTelemetry)(N,Z)&&(0,u.getTelemetryLevel)(ie)===3&&(ne["X-Market-User-Id"]=ae),ne}e.resolveMarketplaceHeaders=X}),define(Q[200],J([0,1,2,43,3,27,147,16,49,45,37,29,63]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(b,y){this._configurationService=y,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=b.appenders,this._commonProperties=b.commonProperties||Promise.resolve({}),this._piiPaths=b.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!b.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(c=>{const h=/^[a-f0-9]+$/i.test(c["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!h})})}setExperimentProperty(b,y){this._experimentProperties[b]=y}_updateTelemetryLevel(){this._telemetryLevel=(0,E.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const b=await this._commonProperties;let y=b.sessionID,c=b["common.instanceId"],h=b["common.machineId"],o=b["common.firstSessionDate"],u=b["common.msftInternal"];return{sessionId:y,instanceId:c,machineId:h,firstSessionDate:o,msftInternal:u}}dispose(){this._disposables.dispose()}_log(b,y,c,h){return this.telemetryLevel<y?Promise.resolve(void 0):this._commonProperties.then(o=>{c=(0,R.mixin)(c,o),c=(0,R.mixin)(c,this._experimentProperties),c=(0,R.cloneAndChange)(c,u=>{if(typeof u=="string")return this._cleanupInfo(u,h)}),this._appenders.forEach(u=>u.log(b,c))},o=>{console.error(o)})}publicLog(b,y,c){return this._log(b,3,y,c)}publicLog2(b,y,c){return this.publicLog(b,y,c)}publicLogError(b,y){return this.sendErrorTelemetry?this._log(b,2,y,!0):Promise.resolve(void 0)}publicLogError2(b,y){return this.publicLogError(b,y)}_anonymizeFilePaths(b){let y=b;const c=[];for(let i of this._cleanupPatterns)for(;;){const a=i.exec(b);if(!a)break;c.push([a.index,i.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(y="";;){const i=o.exec(b);if(!i)break;!h.test(i[0])&&c.every(([a,s])=>i.index<a||i.index>=s)&&(y+=b.substring(u,i.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<b.length&&(y+=b.substr(u)),y}_removePropertiesWithPossibleUserInfo(b){if(!b)return b;const y=b.toLowerCase(),c=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(y)?"<REDACTED: secret>":c.test(y)?"<REDACTED: email>":b}_cleanupInfo(b,y){let c=b;y&&(c=this._anonymizeFilePaths(c));for(let h of this._cleanupPatterns)c=c.replace(h,"");return c=this._removePropertiesWithPossibleUserInfo(c),c}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=he([te(1,n.IConfigurationService)],S),e.TelemetryService=S;function f(){const g=(0,k.localize)(0,null,w.default.nameLong),b=w.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=D.isWeb?"":(0,k.localize)(3,null),c=(0,k.localize)(4,null),h=(0,k.localize)(5,null),o=(0,k.localize)(6,null),u=(0,k.localize)(7,null),i=`
|       | ${c} | ${h} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,k.localize)(8,null);return`
${g} ${b} ${y}

&nbsp;

${u}
${i}

&nbsp;

${a}
`}t.Registry.as(d.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:f(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),t.Registry.as(d.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,k.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,k.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[201],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(Q[202],J([0,1,107,4,2,5,37,201]),function(V,e,v,R,D,M,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var d;(function(b){function y(c){return c&&typeof c=="object"&&typeof c.id=="string"}b.isThemeColor=y})(d=e.ThemeColor||(e.ThemeColor={}));function w(b){return{id:b}}e.themeColorFromId=w;var t;(function(b){function y(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||d.isThemeColor(a.color))}b.isThemeIcon=y;const c=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function h(a){const s=c.exec(a);if(!s)return;let[,r]=s;return{id:r}}b.fromString=h;function o(a,s){let r=a.id;const l=r.lastIndexOf("~");return l!==-1&&(r=r.substring(0,l)),s&&(r=`${r}~${s}`),{id:r}}b.modify=o;function u(a,s){return a.id===s.id&&a.color?.id===s.color?.id}b.isEqual=u;function i(a,s){return{id:a.id,color:s?w(s):void 0}}b.asThemeIcon=i,b.asClassNameArray=v.CSSIcon.asClassNameArray,b.asClassName=v.CSSIcon.asClassName,b.asCSSSelector=v.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function I(b){switch(b){case n.ColorScheme.DARK:return"vs-dark";case n.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new R.Emitter}onColorThemeChange(y){return this.themingParticipants.push(y),this.onThemingParticipantAddedEmitter.fire(y),(0,D.toDisposable)(()=>{const c=this.themingParticipants.indexOf(y);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new E;k.Registry.add(e.Extensions.ThemingContribution,S);function f(b){return S.onColorThemeChange(b)}e.registerThemingParticipant=f;class g extends D.Disposable{constructor(y){super();this.themeService=y,this.theme=y.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(y){this.theme=y,this.updateStyles()}updateStyles(){}getColor(y,c){let h=this.theme.getColor(y);return h&&c&&(h=c(h,this.theme)),h?h.toString():null}}e.Themable=g}),define(Q[64],J([0,1,14,3,5,38]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const k="#FFFFFF",n="#1E1E1E",d="#000000",w="theme",t="themeBackground",I="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let E=class{constructor(f){this.stateMainService=f}getBackgroundColor(){if((R.isWindows||R.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return d;let f=this.stateMainService.getItem(t,null);if(!f){let g;(R.isWindows||R.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(w,"vs-dark").split(" ")[0],f=g==="hc-black"?d:g==="vs"?k:n}return R.isMacintosh&&f.toUpperCase()===n&&(f="#171717"),f}saveWindowSplash(f,g){this.stateMainService.setItems([{key:w,data:g.baseTheme},{key:t,data:g.colorInfo.background},{key:I,data:g}]),typeof f=="number"&&this.updateBackgroundColor(f,g)}updateBackgroundColor(f,g){for(const b of v.BrowserWindow.getAllWindows())if(b.id===f){b.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};E=he([te(0,M.IStateMainService)],E),e.ThemeMainService=E}),define(Q[41],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var R;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(R=e.StateType||(e.StateType={}));var D;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,k)=>({type:"idle",updateType:M,error:k}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Q[203],J([0,1,3,148,49,37]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Q[204],J([0,1,4,41]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(n){this.service=n}listen(n,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(n,d,w){switch(d){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=D;class M{constructor(n){this.channel=n,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=R.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(Q[97],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Q[205],J([0,1,7]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(n){this.handler=n}listen(n,d){throw new Error(`Event not found: ${d}`)}call(n,d,w){switch(d){case"handleURL":return this.handler.handleURL(v.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=R;class D{constructor(n){this.channel=n}handleURL(n,d){return this.channel.call("handleURL",[n.toJSON(),d])}}e.URLHandlerChannelClient=D;class M{constructor(n){this.next=n}async routeCall(n,d,w,t){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(w){const I=v.URI.revive(w);if(I&&I.query){const E=/\bwindowId=(\d+)/.exec(I.query);if(E){const S=E[1],f=new RegExp(`window:${S}`),g=n.connections.find(b=>f.test(b.ctx));if(g)return g}}}return this.next.routeCall(n,d,w,t)}routeEvent(n,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=M}),define(Q[206],J([0,1,9,2,7,21]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class k extends R.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,t){const I=[...this.handlers.values()];return(0,v.first)(I.map(E=>()=>E.handleURL(w,t)),void 0,!1).then(E=>E||!1)}registerHandler(w){return this.handlers.add(w),(0,R.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=k;let n=class extends k{constructor(w){super();this.productService=w}create(w){let{authority:t,path:I,query:E,fragment:S}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return t&&I&&I.indexOf("/")!==0&&(I=`/${I}`),D.URI.from({scheme:this.productService.urlProtocol,authority:t,path:I,query:E,fragment:S})}};n=he([te(0,M.IProductService)],n),e.NativeURLService=n}),define(Q[207],J([0,1,14,9,4,2,3,7]),function(V,e,v,R,D,M,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function d(t){try{return n.URI.parse(t)}catch(I){return null}}class w{constructor(I,E,S,f,g){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=I,k.isWindows){const c=f.isBuilt?[]:[`"${f.appRoot}"`];c.push("--open-url","--"),v.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,c)}const b=D.Event.map(D.Event.fromNodeEventEmitter(v.app,"open-url",(c,h)=>({event:c,url:h})),({event:c,url:h})=>(c.preventDefault(),h));this.disposables.add(b(c=>{const h=d(c);!h||this.urlService.open(h,{originalUrl:c})})),S.getWindows().filter(c=>c.isReady).length>0?this.flush():D.Event.once(S.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||I.push(E);I.length!==0&&(this.uris=I,this.flushDisposable=(0,R.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(Q[208],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Q[209],J([0,1,14,2,10,7]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class k extends R.Disposable{constructor(){super();const d=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(D.Schemas.vscodeWebview,d)}handleWebviewRequest(d,w){try{const t=M.URI.parse(d.url),I=k.validWebviewFilePaths.get(t.path);if(typeof I=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${I}`,S=D.FileAccess.asFileUri(E,V);return w(decodeURIComponent(S.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=k,k.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Q[65],J([0,1,3]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(w){return!!w.workspaceUri}e.isWorkspaceToOpen=R;function D(w){return!!w.folderUri}e.isFolderToOpen=D;function M(w){return!!w.fileUri}e.isFileToOpen=M;function k(w){const t=n(w),I=w.getValue("window.menuBarVisibility");return I==="default"||t==="native"&&I==="compact"||v.isMacintosh&&v.isNative?"classic":I}e.getMenuBarVisibility=k;function n(w){if(v.isWeb)return"custom";const t=w.getValue("window");if(t){if(v.isMacintosh&&t.nativeTabs===!0||v.isMacintosh&&t.nativeFullScreen===!1)return"native";const S=t.titleBarStyle;if(S==="native"||S==="custom")return S}return v.isLinux?"native":"custom"}e.getTitleBarStyle=n;function d(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=d}),define(Q[36],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var R;(function(w){w[w.INITIAL=1]="INITIAL",w[w.LOAD=2]="LOAD",w[w.RELOAD=3]="RELOAD"})(R=e.LoadReason||(e.LoadReason={}));var D;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var M;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const k=function(w=1){return{width:1024,height:768,mode:w}};e.defaultWindowState=k;var n;(function(w){w[w.Maximized=0]="Maximized",w[w.Normal=1]="Normal",w[w.Minimized=2]="Minimized",w[w.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var d;(function(w){w[w.UNRESPONSIVE=1]="UNRESPONSIVE",w[w.CRASHED=2]="CRASHED",w[w.LOAD=3]="LOAD"})(d=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(Q[210],J([0,1,14,4,2,209,36]),function(V,e,v,R,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends D.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new R.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,t){let I;if(typeof w.windowId=="number"){const{windowId:E}=w,S=this.windowsMainService.getWindowById(E);if(!S?.win)throw new Error(`Invalid windowId: ${E}`);I=S.win.webContents}else{const{webContentsId:E}=w;if(I=v.webContents.fromId(E),!I)throw new Error(`Invalid webContentsId: ${E}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(t)}async findInFrame(w,t,I,E){const S=this.getFrameByName(w,t),f=S;if(typeof f.findInFrame=="function"){f.findInFrame(I,{findNext:E.findNext,forward:E.forward});const g=(b,y)=>{y.finalUpdate&&(this._onFoundInFrame.fire(y),S.removeListener("found-in-frame",g))};S.on("found-in-frame",g)}}async stopFindInFrame(w,t,I){const S=this.getFrameByName(w,t);typeof S.stopFindInFrame=="function"&&S.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,t){const I=this.windowsMainService.getWindowById(w.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${w}`);const E=I.win.webContents.mainFrame.framesInSubtree.find(S=>S.name===t);if(!E)throw new Error(`Unknown frame: ${t}`);return E}};n=he([te(0,k.IWindowsMainService)],n),e.WebviewMainService=n}),define(Q[211],J([0,1,9,4,2]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends D.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:d,getActiveWindowId:w}){super();this.disposables=this._register(new D.DisposableStore),R.Event.latch(R.Event.any(n,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>w()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(Q[212],J([0,1,40,15,7,5]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var k;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function n(E){const S=E;return!!(S&&typeof S=="object"&&typeof S.id=="string"&&Array.isArray(S.folders))}e.isWorkspace=n;function d(E){const S=E;return!!(S&&typeof S=="object"&&D.URI.isUri(S.uri)&&typeof S.name=="string"&&typeof S.toResource=="function")}e.isWorkspaceFolder=d;class w{constructor(S,f,g,b,y){this._id=S,this._transient=g,this._configuration=b,this._ignorePathCasing=y,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=f}update(S){this._id=S.id,this._configuration=S.configuration,this._transient=S.transient,this._ignorePathCasing=S._ignorePathCasing,this.folders=S.folders}get folders(){return this._folders}set folders(S){this._folders=S,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(S){this._configuration=S}getFolder(S){return S&&this._foldersMap.findSubstr(S.with({scheme:S.scheme,authority:S.authority,path:S.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const S of this.folders)this._foldersMap.set(S.uri,S)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class t{constructor(S,f){this.raw=f,this.uri=S.uri,this.index=S.index,this.name=S.name}toResource(S){return(0,R.joinPath)(this.uri,S)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function I(E){return new t({uri:E,index:0,name:(0,R.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=I}),define(Q[26],J([0,1,33,39,80,34,10,8,3,15,7,151,5,62,212]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(F){return(typeof F=="string"?(0,n.extname)(F):(0,w.extname)(F))===g}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function y(F){return F.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function c(F){return F.hasOwnProperty("folderUri")}e.isRecentFolder=c;function h(F){return F.hasOwnProperty("fileUri")}e.isRecentFile=h;function o(F){const H=F;return typeof H?.id=="string"&&t.URI.isUri(H.uri)}e.isSingleFolderWorkspaceIdentifier=o;function u(F){if(F.configuration)return{id:F.id,configPath:F.configuration};if(F.folders.length===1)return{id:F.id,uri:F.folders[0].uri}}e.toWorkspaceIdentifier=u;function i(F){const H=F;return typeof H?.id=="string"&&t.URI.isUri(H.configPath)}e.isWorkspaceIdentifier=i;function a(F){const H=F;if(H?.uri)return{id:H.id,uri:t.URI.revive(H.uri)};const z=F;if(z?.configPath)return{id:z.id,configPath:t.URI.revive(z.configPath)};if(F?.id)return{id:F.id}}e.reviveIdentifier=a;function s(F,H){return w.extUriBiasedIgnorePathCase.isEqualOrParent(F,H.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(F){return l(F)||m(F)}e.isStoredWorkspaceFolder=r;function l(F){const H=F;return typeof H?.path=="string"&&(!H.name||typeof H.name=="string")}e.isRawFileWorkspaceFolder=l;function m(F){const H=F;return typeof H?.uri=="string"&&(!H.name||typeof H.name=="string")}e.isRawUriWorkspaceFolder=m;function p(F,H,z,B,U=!d.isWindows,C){if(F.scheme!==B.scheme)return{name:z,uri:F.toString(!0)};let Y=H?void 0:C.relativePath(B,F);if(Y!==void 0)Y.length===0?Y=".":d.isWindows&&F.scheme===k.Schemas.file&&!U&&(Y=Y.replace(/\//g,"\\"));else if(F.scheme===k.Schemas.file)Y=F.fsPath,d.isWindows&&(Y=(0,M.normalizeDriveLetter)(Y),U&&(Y=(0,v.toSlashes)(Y)));else{if(!C.isEqualAuthority(F.authority,B.authority))return{name:z,uri:F.toString(!0)};Y=F.path}return{name:z,path:Y}}e.getStoredWorkspaceFolder=p;function P(F,H,z){let B=[],U=new Set;const C=z.dirname(H);for(let Y of F){let O;if(l(Y))Y.path&&(O=z.resolvePath(C,Y.path));else if(m(Y))try{O=t.URI.parse(Y.uri),O.path[0]!=="/"&&(O=O.with({path:"/"+O.path}))}catch(T){console.warn(T)}if(O){let T=z.getComparisonKey(O);if(!U.has(T)){U.add(T);const _=Y.name||z.basenameOrAuthority(O);B.push(new f.WorkspaceFolder({uri:O,name:_,index:B.length},Y))}}}return B}e.toWorkspaceFolders=P;function L(F,H,z,B,U){let C=A(H,F);const Y=U.dirname(H),O=U.dirname(B),T=[],_=W(C.folders);for(const N of C.folders){const Z=l(N)?U.resolvePath(Y,N.path):t.URI.parse(N.uri);let ie;z?ie=!1:ie=!l(N)||(0,n.isAbsolute)(N.path),T.push(p(Z,ie,N.name,O,_,U))}const j={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},X=D.setProperty(F,["folders"],T,j);let $=D.applyEdits(F,X);return C.remoteAuthority===(0,S.getRemoteAuthority)(B)&&($=D.applyEdits($,D.removeProperty($,["remoteAuthority"],j))),$}e.rewriteWorkspaceFileForNewLocation=L;function A(F,H){let z=R.parse(H);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter(B=>r(B));else throw new Error(`${F} looks like an invalid workspace file.`);return z}function W(F){return d.isWindows?F.some(H=>l(H)&&H.path.indexOf("/")>=0):!0}e.useSlashForPath=W;function q(F){return F.workspace&&typeof F.workspace=="object"&&typeof F.workspace.id=="string"&&typeof F.workspace.configPath=="string"}function x(F){return typeof F.folderUri=="string"}function re(F){return typeof F.fileUri=="string"}function K(F,H){const z={workspaces:[],files:[]};if(F){const B=function(C,Y){for(let O=0;O<C.length;O++)try{Y(C[O],O)}catch(T){H.warn(`Error restoring recent entry ${JSON.stringify(C[O])}: ${T.toString()}. Skip entry.`)}},U=F;if(Array.isArray(U.entries))B(U.entries,C=>{const Y=C.label,O=C.remoteAuthority;q(C)?z.workspaces.push({label:Y,remoteAuthority:O,workspace:{id:C.workspace.id,configPath:t.URI.parse(C.workspace.configPath)}}):x(C)?z.workspaces.push({label:Y,remoteAuthority:O,folderUri:t.URI.parse(C.folderUri)}):re(C)&&z.files.push({label:Y,remoteAuthority:O,fileUri:t.URI.parse(C.fileUri)})});else{const C=F;Array.isArray(C.workspaces3)&&B(C.workspaces3,(Y,O)=>{const T=Array.isArray(C.workspaceLabels)&&C.workspaceLabels[O]||void 0;typeof Y=="object"&&typeof Y.id=="string"&&typeof Y.configURIPath=="string"?z.workspaces.push({label:T,workspace:{id:Y.id,configPath:t.URI.parse(Y.configURIPath)}}):typeof Y=="string"&&z.workspaces.push({label:T,folderUri:t.URI.parse(Y)})}),Array.isArray(C.files2)&&B(C.files2,(Y,O)=>{const T=Array.isArray(C.fileLabels)&&C.fileLabels[O]||void 0;typeof Y=="string"&&z.files.push({label:T,fileUri:t.URI.parse(Y)})})}}return z}e.restoreRecentlyOpened=K;function ee(F){const H={entries:[]};for(const z of F.workspaces)c(z)?H.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):H.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of F.files)H.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return H}e.toStoreData=ee}),define(Q[51],J([0,1,5,26]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function D(M){const k=M;return k&&(0,R.isWorkspaceIdentifier)(k.workspace)}e.isWorkspaceBackupInfo=D}),define(Q[52],J([0,1,14,9,82,34,2,70,8,3,13,19,132,5,6,38,26]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let y=class gt{constructor(h,o){this.stateMainService=h,this.logService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new R.Queue}pickFileFolder(h,o){return this.doPick({...h,pickFolders:!0,pickFiles:!0,title:(0,E.localize)(0,null)},o)}pickFolder(h,o){return this.doPick({...h,pickFolders:!0,title:(0,E.localize)(1,null)},o)}pickFile(h,o){return this.doPick({...h,pickFiles:!0,title:(0,E.localize)(2,null)},o)}pickWorkspace(h,o){const u=(0,E.localize)(3,null),i=(0,M.mnemonicButtonLabel)((0,E.localize)(4,null)),a=b.WORKSPACE_FILTER;return this.doPick({...h,pickFiles:!0,title:u,filters:a,buttonLabel:i},o)}async doPick(h,o){const u={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters};u.defaultPath=h.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(u.properties=void 0,h.pickFiles&&h.pickFolders&&(u.properties=["multiSelections","openDirectory","openFile","createDirectory"])),u.properties||(u.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&u.properties.push("treatPackageAsDirectory");const i=o||v.BrowserWindow.getFocusedWindow(),a=await this.showOpenDialog(u,(0,t.withNullAsUndefined)(i));if(a&&a.filePaths&&a.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,d.dirname)(a.filePaths[0])),a.filePaths}getWindowDialogQueue(h){if(h){let o=this.windowDialogQueues.get(h.id);return o||(o=new R.Queue,this.windowDialogQueues.set(h.id,o)),o}else return this.noWindowDialogueQueue}showMessageBox(h,o){return this.getWindowDialogQueue(o).queue(async()=>o?v.dialog.showMessageBox(o,h):v.dialog.showMessageBox(h))}async showSaveDialog(h,o){const u=this.acquireFileDialogLock(h,o);if(!u)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(o).queue(async()=>{let i;return o?i=await v.dialog.showSaveDialog(o,h):i=await v.dialog.showSaveDialog(h),i.filePath=this.normalizePath(i.filePath),i})}finally{(0,k.dispose)(u)}}normalizePath(h){return h&&w.isMacintosh&&(h=(0,n.normalizeNFC)(h)),h}normalizePaths(h){return h.map(o=>this.normalizePath(o))}async showOpenDialog(h,o){h.defaultPath&&(await I.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const u=this.acquireFileDialogLock(h,o);if(!u)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(o).queue(async()=>{let i;return o?i=await v.dialog.showOpenDialog(o,h):i=await v.dialog.showOpenDialog(h),i.filePaths=this.normalizePaths(i.filePaths),i})}finally{(0,k.dispose)(u)}}acquireFileDialogLock(h,o){if(!o)return k.Disposable.None;let u=this.windowFileDialogLocks.get(o.id);u||(u=new Set,this.windowFileDialogLocks.set(o.id,u));const i=(0,D.hash)(h);if(!u.has(i))return u.add(i),(0,k.toDisposable)(()=>{u?.delete(i),u?.size===0&&this.windowFileDialogLocks.delete(o.id)})}};y.workingDirPickerStorageKey="pickerWorkingDir",y=he([te(0,g.IStateMainService),te(1,f.ILogService)],y),e.DialogMainService=y}),define(Q[213],J([0,1,4,2,26]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends R.Disposable{constructor(n,d){super();this.logService=n,this.storageMainService=d,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,d)=>(n?n.push(d):n=[d],n),M.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const d=new Map,w=new Set;return n.forEach(t=>{const I=this.storageMainService.globalStorage.get(t.key);typeof I=="string"?d.set(t.key,I):w.add(t.key)}),{changed:Array.from(d.entries()),deleted:Array.from(w.values())}}listen(n,d){switch(d){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${d}`)}async call(n,d,w){const t=(0,D.reviveIdentifier)(w.workspace),I=await this.withStorageInitialized(t);switch(d){case"getItems":return Array.from(I.items.entries());case"updateItems":{const E=w;if(E.insert)for(const[S,f]of E.insert)I.set(S,f);E.delete&&E.delete.forEach(S=>I.delete(S));break}case"close":{if(t)return I.close();break}default:throw new Error(`Call not found: ${d}`)}}async withStorageInitialized(n){const d=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await d.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${w}`)}return d}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[214],J([0,1,4,2,8,28,19,87,122,6,96,29,26]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class S extends R.Disposable{constructor(y){super();this.logService=y,this._onDidChangeStorage=this._register(new v.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new v.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const y=await this.doCreate();this.storage.dispose(),this.storage=y,this._register(y.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(y);const c=y.getBoolean(t.IS_NEW_KEY);c===void 0?y.set(t.IS_NEW_KEY,!0):c&&y.set(t.IS_NEW_KEY,!1)}catch(y){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${y}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?y=>this.logService.trace(y):void 0,logError:y=>this.logService.error(y)}}doInit(y){return y.init()}get items(){return this.storage.items}get(y,c){return this.storage.get(y,c)}set(y,c){return this.storage.set(y,c)}delete(y){return this.storage.delete(y)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class f extends S{constructor(y,c,h){super(c);this.options=y,this.environmentService=h}async doCreate(){let y;return this.options.useInMemoryStorage?y=d.SQLiteStorageDatabase.IN_MEMORY_PATH:y=(0,D.join)(this.environmentService.globalStorageHome.fsPath,f.STORAGE_NAME),new n.Storage(new d.SQLiteStorageDatabase(y,{logging:this.createLoggingOptions()}))}async doInit(y){await super.doInit(y),this.updateTelemetryState(y)}updateTelemetryState(y){y.get(I.instanceStorageKey,void 0)===void 0&&y.set(I.instanceStorageKey,(0,M.generateUuid)()),y.get(I.firstSessionDateStorageKey,void 0)===void 0&&y.set(I.firstSessionDateStorageKey,new Date().toUTCString());const o=y.get(I.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();y.set(I.lastSessionDateStorageKey,typeof o=="undefined"?null:o),y.set(I.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=f,f.STORAGE_NAME="state.vscdb";class g extends S{constructor(y,c,h,o){super(h);this.workspace=y,this.options=c,this.environmentService=o}async doCreate(){const{storageFilePath:y,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new d.SQLiteStorageDatabase(y,{logging:this.createLoggingOptions()}),{hint:c?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:d.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const y=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,D.join)(y,g.WORKSPACE_STORAGE_NAME);return await k.Promises.exists(y)?{storageFilePath:c,wasCreated:!1}:(await k.Promises.mkdir(y,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(y),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(y){let c;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const h=(0,D.join)(y,g.WORKSPACE_META_NAME);await k.Promises.exists(h)||await k.Promises.writeFile(h,JSON.stringify(c,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Q[98],J([0,1,42,2,48,5,22,6,214]),function(V,e,v,R,D,M,k,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let w=class extends R.Disposable{constructor(I,E,S){super();this.logService=I,this.environmentService=E,this.lifecycleMainService=S,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async I=>{I.workspace&&this.workspaceStorage(I.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(I=>{I.join(this.globalStorage.close());for(const[,E]of this.mapWorkspaceToStorage)I.join(E.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const I=new d.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(I.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),I}createWorkspaceStorage(I){return new d.WorkspaceStorageMain(I,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(I){let E=this.mapWorkspaceToStorage.get(I.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${I.id})`),E=this.createWorkspaceStorage(I),this.mapWorkspaceToStorage.set(I.id,E),(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${I.id})`),this.mapWorkspaceToStorage.delete(I.id)})),E}};w=he([te(0,n.ILogService),te(1,D.IEnvironmentService),te(2,k.ILifecycleMainService)],w),e.StorageMainService=w}),define(Q[99],J([0,1,15,7,26]),function(V,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(d,w,t){for(const E of d){const S=E.openedWorkspace;if((0,D.isWorkspaceIdentifier)(S)){const f=t(S);if(f){if(f.folders.some(g=>v.extUriBiasedIgnorePathCase.isEqualOrParent(w,g.uri)))return E}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(w,S.configPath))return E}}const I=d.filter(E=>(0,D.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(w,E.openedWorkspace.uri));if(I.length)return I.sort((E,S)=>-(E.openedWorkspace.uri.path.length-S.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function k(d,w){for(const t of d)if((0,D.isWorkspaceIdentifier)(t.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.configPath,w)||(0,D.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.uri,w))return t}e.findWindowOnWorkspaceOrFolder=k;function n(d,w){const t=I=>w.some(E=>v.extUriBiasedIgnorePathCase.isEqual(R.URI.file(E),R.URI.file(I)));for(const I of d)if(I.config?.extensionDevelopmentPath?.some(E=>t(E)))return I}e.findWindowOnExtensionDevelopmentPath=n}),define(Q[215],J([0,1,14,2,3,15,7,16,22,6,38,36,26]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let S=class mt extends R.Disposable{constructor(h,o,u,i,a){super();this.windowsMainService=h,this.stateMainService=o,this.lifecycleMainService=u,this.logService=i,this.configurationService=a,this._state=f(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(a=>!a.isExtensionDevelopmentHost)),i&&(h.lastActiveWindow=this.toWindowState(i))}const o=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>this.toWindowState(i)));const u=b(h);this.stateMainService.setItem(mt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(u=>{const i=(0,E.isWorkspaceIdentifier)(h.openedWorkspace)&&u.workspace?.id===h.openedWorkspace.id,a=(0,E.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&u.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(u.folderUri,h.openedWorkspace.uri);(i||a)&&(u.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(h){return{workspace:(0,E.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,E.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const o=this.doGetNewWindowState(h),u=this.configurationService.getValue("window");let i;return o.hasDefaultState?i=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(i=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),i&&D.isMacintosh&&this.windowsMainService.getWindows().some(a=>a.isFullScreen)&&(i=!1)),o.mode===3&&!i&&(o.mode=1),o}doGetNewWindowState(h){const o=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=h.workspace;if((0,E.isWorkspaceIdentifier)(l)){const p=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===l.id).map(P=>P.uiState);if(p.length)return p[0]}if((0,E.isSingleFolderWorkspaceIdentifier)(l)){const p=this.state.openedWindows.filter(P=>P.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(P.folderUri,l.uri)).map(P=>P.uiState);if(p.length)return p[0]}else if(h.backupPath){const p=this.state.openedWindows.filter(P=>P.backupPath===h.backupPath).map(P=>P.uiState);if(p.length)return p[0]}const m=this.lastClosedState||this.state.lastActiveWindow;if(!o&&m)return m.uiState}let u;const i=v.screen.getAllDisplays();if(i.length===1)u=i[0];else{if(D.isMacintosh){const l=v.screen.getCursorScreenPoint();u=v.screen.getDisplayNearestPoint(l)}!u&&o&&(u=v.screen.getDisplayMatching(o.getBounds())),u||(u=v.screen.getPrimaryDisplay()||i[0])}let a=(0,I.defaultWindowState)();a.x=Math.round(u.bounds.x+u.bounds.width/2-a.width/2),a.y=Math.round(u.bounds.y+u.bounds.height/2-a.height/2);const s=this.configurationService.getValue("window");let r=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")a.mode=0,r=!1;else if(s.newWindowDimensions==="fullscreen")a.mode=3,r=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&o){const l=o.serializeWindowState();l.mode===3?a.mode=3:a=l,r=a.mode!==3&&s.newWindowDimensions==="offset"}}return r&&(a=this.ensureNoOverlap(a)),a.hasDefaultState=!0,a}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const o=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;o.some(u=>u.x===h.x||u.y===h.y);)h.x+=30,h.y+=30;return h}};S.windowsStateStorageKey="windowsState",S=he([te(0,I.IWindowsMainService),te(1,t.IStateMainService),te(2,d.ILifecycleMainService),te(3,w.ILogService),te(4,n.IConfigurationService)],S),e.WindowsStateHandler=S;function f(c){const h={openedWindows:[]},o=c||{openedWindows:[]};return o.lastActiveWindow&&(h.lastActiveWindow=g(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=g(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(h.openedWindows=o.openedWindows.map(u=>g(u))),h}e.restoreWindowsState=f;function g(c){const h={uiState:c.uiState};return c.backupPath&&(h.backupPath=c.backupPath),c.remoteAuthority&&(h.remoteAuthority=c.remoteAuthority),c.folder&&(h.folderUri=k.URI.parse(c.folder)),c.workspaceIdentifier&&(h.workspace={id:c.workspaceIdentifier.id,configPath:k.URI.parse(c.workspaceIdentifier.configURIPath)}),h}function b(c){return{lastActiveWindow:c.lastActiveWindow&&y(c.lastActiveWindow),lastPluginDevelopmentHostWindow:c.lastPluginDevelopmentHostWindow&&y(c.lastPluginDevelopmentHostWindow),openedWindows:c.openedWindows.map(h=>y(h))}}e.getWindowsStateStoreData=b;function y(c){return{workspaceIdentifier:c.workspace&&{id:c.workspace.id,configURIPath:c.workspace.configPath.toString()},folder:c.folderUri&&c.folderUri.toString(),backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.uiState}}}),define(Q[100],J([0,1,59,31,10,3,15]),function(V,e,v,R,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(w){function t(){let I=w.scheme===D.Schemas.file?(0,k.originalFSPath)(w):w.toString();return M.isLinux||(I=I.toLowerCase()),(0,v.createHash)("md5").update(I).digest("hex")}return{id:t(),configPath:w}}e.getWorkspaceIdentifier=n;function d(w,t){function I(){if(w.scheme!==D.Schemas.file)return(0,v.createHash)("md5").update(w.toString()).digest("hex");if(!t)try{t=(0,R.statSync)(w.fsPath)}catch(f){return}let S;return M.isLinux?S=t.ino:M.isMacintosh?S=t.birthtime.getTime():M.isWindows&&(typeof t.birthtimeMs=="number"?S=Math.floor(t.birthtimeMs):S=t.birthtime.getTime()),(0,v.createHash)("md5").update(w.fsPath).update(S?String(S):"").digest("hex")}const E=I();if(typeof E=="string")return{id:E,uri:w}}e.getSingleFolderWorkspaceIdentifier=d}),define(Q[57],J([0,1,59,60,25,18,17,4,2,8,3,28,35,85,216]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(p){this.socket=p,this._errorListener=P=>{if(P){if(P.code==="EPIPE")return;(0,k.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(p){const P=L=>p(M.VSBuffer.wrap(L));return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(p){const P=L=>{p({type:0,hadError:L,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(p){return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(p){if(!this.socket.destroyed)try{this.socket.write(p.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,k.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,k.onUnexpectedError)(P)}}end(){this.socket.end()}drain(){return new Promise((p,P)=>{if(this.socket.bufferSize===0){p();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),p()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=g;var b;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var y;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(y||(y={}));class c extends d.Disposable{constructor(p,P,L,A){super();this._onDidZlibFlush=this._register(new n.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=p,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=P,this._recordInflateBytes=A,P?(this._zlibInflate=f.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",W=>{console.error(W),(0,k.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})}),this._zlibInflate.on("data",W=>{this._pendingInflateData.push(W)}),L&&(this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=f.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",W=>{console.error(W),(0,k.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})}),this._zlibDeflate.on("data",W=>{this._pendingDeflateData.push(W)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new S.ChunkStream,this._register(this.socket.onData(W=>this._acceptChunk(W))),this._register(this.socket.onClose(W=>this._onClose.fire(W)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this._onData.event(p)}onClose(p){return this._onClose.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){this._totalOutgoingDataBytes+=p.byteLength,this._zlibDeflate?(this._zlibDeflate.write(p.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let P=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.length-4),this._isEnded||this._write(M.VSBuffer.wrap(P),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(p,!1)}_write(p,P){let L=2;p.byteLength<126?L+=0:p.byteLength<2**16?L+=2:L+=8;const A=M.VSBuffer.alloc(L);if(P?A.writeUInt8(194,0):A.writeUInt8(130,0),p.byteLength<126)A.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){A.writeUInt8(126,1);let W=1;A.writeUInt8(p.byteLength>>>8&255,++W),A.writeUInt8(p.byteLength>>>0&255,++W)}else{A.writeUInt8(127,1);let W=1;A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(p.byteLength>>>24&255,++W),A.writeUInt8(p.byteLength>>>16&255,++W),A.writeUInt8(p.byteLength>>>8&255,++W),A.writeUInt8(p.byteLength>>>0&255,++W)}this._totalOutgoingWireBytes+=A.byteLength+p.byteLength,this.socket.write(M.VSBuffer.concat([A,p]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(p){if(p.byteLength!==0){for(this._totalIncomingWireBytes+=p.byteLength,this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),L=P.readUInt8(0),A=(L&128)>>>7,W=(L&64)>>>6,q=P.readUInt8(1),x=(q&128)>>>7,re=q&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(W)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),L=P.readUInt8(1),A=(L&128)>>>7;let W=L&127,q=1;W===126?W=P.readUInt8(++q)*2**8+P.readUInt8(++q):W===127&&(W=P.readUInt8(++q)*0+P.readUInt8(++q)*0+P.readUInt8(++q)*0+P.readUInt8(++q)*0+P.readUInt8(++q)*2**24+P.readUInt8(++q)*2**16+P.readUInt8(++q)*2**8+P.readUInt8(++q));let x=0;A&&(x=P.readUInt8(++q)*2**24+P.readUInt8(++q)*2**16+P.readUInt8(++q)*2**8+P.readUInt8(++q)),this._state.state=3,this._state.readLen=W,this._state.mask=x}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);h(P,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(P.buffer)),this._zlibInflate.write(P.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const L=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=L.length,this._onData.fire(M.VSBuffer.wrap(L))})):(this._totalIncomingDataBytes+=P.byteLength,this._onData.fire(P))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await n.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=c;function h(m,p){if(p===0)return;let P=m.byteLength>>>2;for(let re=0;re<P;re++){const K=m.readUInt32BE(re*4);m.writeUInt32BE(K^p,re*4)}let L=P*4,A=m.byteLength-L;const W=p>>>24&255,q=p>>>16&255,x=p>>>8&255;A>=1&&m.writeUInt8(m.readUInt8(L)^W,L),A>=2&&m.writeUInt8(m.readUInt8(L+1)^q,L+1),A>=3&&m.writeUInt8(m.readUInt8(L+2)^x,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function u(){const m=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let p;return e.XDG_RUNTIME_DIR?p=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):p=(0,w.join)((0,D.tmpdir)(),`vscode-ipc-${m}.sock`),a(p),p}e.createRandomIPCHandle=u;function i(m,p,P){const L=(0,v.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${P}-${p}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${P}-${p}.sock`):A=(0,w.join)(m,`${P}-${p}.sock`),a(A),A}e.createStaticIPCHandle=i;function a(m){const p=o[t.platform];typeof p=="number"&&m.length>=p&&console.warn(`WARNING: IPC handle "${m}" is longer than ${p} chars, try a shorter --user-data-dir`)}class s extends E.IPCServer{constructor(p){super(s.toClientConnectionEvent(p));this.server=p}static toClientConnectionEvent(p){const P=n.Event.fromNodeEventEmitter(p,"connection");return n.Event.map(P,L=>({protocol:new S.Protocol(new g(L)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(m){return new Promise((p,P)=>{const L=(0,R.createServer)();L.on("error",P),L.listen(m,()=>{L.removeListener("error",P),p(new s(L))})})}e.serve=r;function l(m,p){return new Promise((P,L)=>{const A=(0,R.createConnection)(m,()=>{A.removeListener("error",L),P(S.Client.fromSocket(new g(A),p))});A.once("error",L)})}e.connect=l}),define(Q[217],J([0,1,57]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class R{constructor(d){this.driver=d}listen(d,w){throw new Error("No event found")}call(d,w,t){switch(w){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(t);case"reloadWindow":return this.driver.reloadWindow(t);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(t[0],t[1]);case"click":return this.driver.click(t[0],t[1],t[2],t[3]);case"doubleClick":return this.driver.doubleClick(t[0],t[1]);case"setValue":return this.driver.setValue(t[0],t[1],t[2]);case"getTitle":return this.driver.getTitle(t[0]);case"isActiveElement":return this.driver.isActiveElement(t[0],t[1]);case"getElements":return this.driver.getElements(t[0],t[1],t[2]);case"getElementXY":return this.driver.getElementXY(t[0],t[1],t[2]);case"typeInEditor":return this.driver.typeInEditor(t[0],t[1],t[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(t[0],t[1]);case"writeInTerminal":return this.driver.writeInTerminal(t[0],t[1],t[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(t);case"getLocalizedStrings":return this.driver.getLocalizedStrings(t)}throw new Error(`Call not found: ${w}`)}}e.DriverChannel=R;class D{constructor(d){this.channel=d}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(d){return this.channel.call("capturePage",d)}reloadWindow(d){return this.channel.call("reloadWindow",d)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(d,w){return this.channel.call("dispatchKeybinding",[d,w])}click(d,w,t,I){return this.channel.call("click",[d,w,t,I])}doubleClick(d,w){return this.channel.call("doubleClick",[d,w])}setValue(d,w,t){return this.channel.call("setValue",[d,w,t])}getTitle(d){return this.channel.call("getTitle",[d])}isActiveElement(d,w){return this.channel.call("isActiveElement",[d,w])}getElements(d,w,t){return this.channel.call("getElements",[d,w,t])}getElementXY(d,w,t,I){return this.channel.call("getElementXY",[d,w,t,I])}typeInEditor(d,w,t){return this.channel.call("typeInEditor",[d,w,t])}getTerminalBuffer(d,w){return this.channel.call("getTerminalBuffer",[d,w])}writeInTerminal(d,w,t){return this.channel.call("writeInTerminal",[d,w,t])}getLocaleInfo(d){return this.channel.call("getLocaleInfo",d)}getLocalizedStrings(d){return this.channel.call("getLocalizedStrings",d)}}e.DriverChannelClient=D;class M{constructor(d){this.registry=d}listen(d,w){throw new Error(`Event not found: ${w}`)}call(d,w,t){switch(w){case"registerWindowDriver":return this.registry.registerWindowDriver(t);case"reloadWindowDriver":return this.registry.reloadWindowDriver(t)}throw new Error(`Call not found: ${w}`)}}e.WindowDriverRegistryChannel=M;async function k(n){const d=await(0,v.connect)(n,"driverClient"),w=d.getChannel("driver"),t=new D(w);return{client:d,driver:t}}e.connect=k}),define(Q[218],J([0,1,9,4,105,58,2,3,68,35,57,155,217,173,22,36]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function b(h){return h<21}let y=class{constructor(o,u,i,a){this.windowServer=o,this.options=u,this.windowsMainService=i,this.lifecycleMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new R.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const u=this.windowsMainService.getWindowById(o);if(!u?.win)throw new Error("Invalid window");return(await u.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const u=this.windowsMainService.getWindowById(o);if(!u)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(u)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(o,u){await this.whenUnfrozen(o);const i=D.KeybindingParser.parseUserBinding(u);for(let a of i)await this._dispatchKeybinding(o,a)}async _dispatchKeybinding(o,u){if(u instanceof d.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(o);if(!i?.win)throw new Error("Invalid window");const a=i.win.webContents,s=new M.SimpleKeybinding(!1,!1,!1,!1,u.keyCode),l=new S.USLayoutResolvedKeybinding(s.toChord(),n.OS).getElectronAccelerator(),m=[];u.ctrlKey&&m.push("ctrl"),u.metaKey&&m.push("meta"),u.shiftKey&&m.push("shift"),u.altKey&&m.push("alt"),a.sendInputEvent({type:"keyDown",keyCode:l,modifiers:m}),b(u.keyCode)||a.sendInputEvent({type:"char",keyCode:l,modifiers:m}),a.sendInputEvent({type:"keyUp",keyCode:l,modifiers:m}),await(0,v.timeout)(100)}async click(o,u,i,a){await(await this.getWindowDriver(o)).click(u,i,a)}async doubleClick(o,u){await(await this.getWindowDriver(o)).doubleClick(u)}async setValue(o,u,i){await(await this.getWindowDriver(o)).setValue(u,i)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,u){return await(await this.getWindowDriver(o)).isActiveElement(u)}async getElements(o,u,i){return await(await this.getWindowDriver(o)).getElements(u,i)}async getElementXY(o,u,i,a){return await(await this.getWindowDriver(o)).getElementXY(u,i,a)}async typeInEditor(o,u,i){await(await this.getWindowDriver(o)).typeInEditor(u,i)}async getTerminalBuffer(o,u){return await(await this.getWindowDriver(o)).getTerminalBuffer(u)}async writeInTerminal(o,u,i){await(await this.getWindowDriver(o)).writeInTerminal(u,i)}async getLocaleInfo(o){return await(await this.getWindowDriver(o)).getLocaleInfo()}async getLocalizedStrings(o){return await(await this.getWindowDriver(o)).getLocalizedStrings()}async getWindowDriver(o){await this.whenUnfrozen(o);const u=`window:${o}`,i=new w.StaticRouter(s=>s===u),a=this.windowServer.getChannel("windowDriver",i);return new I.WindowDriverChannelClient(a)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await R.Event.toPromise(this.onDidReloadingChange.event)}};y=he([te(2,g.IWindowsMainService),te(3,f.ILifecycleMainService)],y),e.Driver=y;async function c(h,o,u,i){const a=u.driverVerbose,s=i.createInstance(y,h,{verbose:a}),r=new E.WindowDriverRegistryChannel(s);h.registerChannel("windowDriverRegistry",r);const l=await(0,t.serve)(o),m=new E.DriverChannel(s);return l.registerChannel("driver",m),(0,k.combinedDisposable)(l,h)}e.serve=c}),define(Q[24],J([0,1,47,8,57,48,159,5]),function(V,e,v,R,D,M,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,n.refineServiceDecorator)(M.IEnvironmentService);class d extends k.NativeEnvironmentService{get cachedLanguagesPath(){return(0,R.join)(this.userDataPath,"clp")}get backupHome(){return(0,R.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,R.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,R.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([v.memoize],d.prototype,"cachedLanguagesPath",null),he([v.memoize],d.prototype,"backupHome",null),he([v.memoize],d.prototype,"backupWorkspacesPath",null),he([v.memoize],d.prototype,"mainIPCHandle",null),he([v.memoize],d.prototype,"mainLockfile",null),he([v.memoize],d.prototype,"sandbox",null),he([v.memoize],d.prototype,"driverVerbose",null),he([v.memoize],d.prototype,"disableUpdates",null),he([v.memoize],d.prototype,"disableKeytar",null),he([v.memoize],d.prototype,"codeCachePath",null),he([v.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(Q[219],J([0,1,59,31,33,10,8,3,15,7,19,51,16,24,20,6,26]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let y=class{constructor(h,o,u){this.configurationService=o,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=d.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,a)=>(0,D.isEqual)(i,a,!n.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await t.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(i){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let o=[];try{Array.isArray(h.rootURIWorkspaces)&&(o=h.rootURIWorkspaces.map(i=>({workspace:{id:i.id,configPath:w.URI.parse(i.configURIPath)},remoteAuthority:i.remoteAuthority})))}catch(i){}this.workspaces=await this.validateWorkspaces(o);let u=[];try{Array.isArray(h.folderURIWorkspaces)&&(u=h.folderURIWorkspaces.map(i=>w.URI.parse(i)))}catch(i){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==f.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,o){this.workspaces.some(i=>h.workspace.id===i.workspace.id)||(this.workspaces.push(h),this.saveSync());const u=this.getBackupPath(h.workspace.id);return o&&this.moveBackupFolderSync(u,o),u}moveBackupFolderSync(h,o){if(R.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),R.existsSync(o))try{R.renameSync(o,h)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(h){const o=h.id,u=this.workspaces.findIndex(i=>i.workspace.id===o);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(o=>this.backupUriComparer.isEqual(h,o))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const o=this.folders.findIndex(u=>this.backupUriComparer.isEqual(h,u));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(h,o){const u=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:o}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(h){const o=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,h));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(h){return(0,k.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const o=new Set,u=[];for(let i of h){const a=i.workspace;if(!(0,b.isWorkspaceIdentifier)(a))return[];if(!o.has(a.id)){o.add(a.id);const s=this.getBackupPath(a.id);await this.doHasBackups(s)?a.configPath.scheme!==M.Schemas.file||await t.Promises.exists(a.configPath.fsPath)?u.push(i):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return u}async validateFolders(h){if(!Array.isArray(h))return[];const o=[],u=new Set;for(let i of h){const a=this.backupUriComparer.getComparisonKey(i);if(!u.has(a)){u.add(a);const s=this.getBackupPath(this.getFolderHash(i));await this.doHasBackups(s)?i.scheme!==M.Schemas.file||await t.Promises.exists(i.fsPath)?o.push(i):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const o=[],u=new Set;for(let i of h){const a=i.backupFolder;if(typeof a!="string")return[];if(!u.has(a)){u.add(a);const s=this.getBackupPath(a);await this.doHasBackups(s)?o.push(i):await this.deleteStaleBackup(s)}}return o}async deleteStaleBackup(h){try{await t.Promises.exists(h)&&await t.Promises.rm(h,t.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{await t.Promises.rename(h,u)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{R.renameSync(h,u)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const h=[];for(const o of this.workspaces)await this.hasBackups(o)&&h.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&h.push(o);return h}hasBackups(h){let o;return w.URI.isUri(h)?o=this.getBackupPath(this.getFolderHash(h)):(0,I.isWorkspaceBackupInfo)(h)?o=this.getBackupPath(h.workspace.id):o=h.backupFolder,this.doHasBackups(o)}async doHasBackups(h){try{const o=await t.Promises.readdir(h);for(const u of o)try{if((await t.Promises.readdir((0,k.join)(h,u))).length>0)return!0}catch(i){}}catch(o){}return!1}saveSync(){try{(0,t.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await t.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let o;return h.scheme===M.Schemas.file?o=n.isLinux?h.fsPath:h.fsPath.toLowerCase():o=h.toString().toLowerCase(),(0,v.createHash)("md5").update(o).digest("hex")}};y=he([te(0,S.IEnvironmentMainService),te(1,E.IConfigurationService),te(2,g.ILogService)],y),e.BackupMainService=y}),define(Q[220],J([0,1,60,57]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,M,k,n){const d=t=>n(t,void 0),w=v.createConnection({host:D,port:M},()=>{w.removeListener("error",d);const t=Buffer.alloc(16);for(let f=0;f<16;f++)t[f]=Math.round(Math.random()*256);const I=t.toString("base64");let E=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${M}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];w.write(E.join(`\r
`)+`\r
\r
`);const S=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",S),n(void 0,new R.NodeSocket(w)))};w.on("data",S)});w.once("error",d)}}}),define(Q[221],J([0,1,60,114,220,9,2,16,6,21,188,95,78]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function S(y,c,h,o,u){return new f(y,c,h,o,u).waitForReady()}class f extends k.Disposable{constructor(c,h,o,u,i){super();this.defaultTunnelHost=h,this.suggestedLocalPort=i,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=v.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let c=await(0,R.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(c){c.pause();const h=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,t.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),u=o.getSocket().socket,i=o.readEntireBuffer();o.dispose(),i.byteLength>0&&c.write(i.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),u.end()}),c.on("close",()=>u.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),u.destroy()}),u.on("end",()=>c.end()),u.on("close",()=>c.end()),u.on("error",()=>{c.destroy()}),c.pipe(u),u.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),u.end()})}}let g=class extends I.AbstractTunnelService{constructor(c,h,o,u,i){super(h);this.socketFactory=c,this.signService=o,this.productService=u,this.configurationService=i}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,h,o,u,i,a,s){const r=this.getTunnelFromMap(h,o);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,o,u,i,a,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${o} on local port ${u}.`);const l={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},m=S(l,this.defaultTunnelHost,h,o,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,o,m),m}}};g=he([te(1,d.ILogService),te(2,E.ISignService),te(3,w.IProductService),te(4,n.IConfigurationService)],g),e.BaseTunnelService=g;let b=class extends g{constructor(c,h,o,u){super(D.nodeSocketFactory,c,h,o,u)}};b=he([te(0,d.ILogService),te(1,E.ISignService),te(2,w.IProductService),te(3,n.IConfigurationService)],b),e.TunnelService=b}),define(Q[222],J([0,1,192,18,17,2,13,16,48,91,6,191,216]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let S=class extends M.Disposable{constructor(g,b,y){super();this.environmentService=b,this.logService=y,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,b){this.logService.trace("RequestService#request",g.url);const{proxyUrl:y,strictSSL:c}=this;let h;try{h=await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(i){this.logService.error("RequestService#request resolving shell environment failed",i)}const o={...process.env,...h},u=g.agent?g.agent:await(0,I.getProxyAgent)(g.url||"",o,{proxyUrl:y,strictSSL:c});return g.agent=u,g.strictSSL=c,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,b)}async getNodeRequest(g){return((0,v.parse)(g.url).protocol==="https:"?await new Promise((c,h)=>{V(["https"],c,h)}):await new Promise((c,h)=>{V(["http"],c,h)})).request}_request(g,b){return new Promise(async(y,c)=>{let h;const o=(0,v.parse)(g.url),u=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),i={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,k.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(i.auth=g.user+":"+g.password),h=u(i,a=>{const s=(0,k.isNumber)(g.followRedirects)?g.followRedirects:3;if(a.statusCode&&a.statusCode>=300&&a.statusCode<400&&s>0&&a.headers.location)this._request({...g,url:a.headers.location,followRedirects:s-1},b).then(y,c);else{let r=a;a.headers["content-encoding"]==="gzip"&&(r=a.pipe((0,E.createGunzip)())),y({res:a,stream:(0,R.streamToBufferReadableStream)(r)})}}),h.on("error",c),g.timeout&&h.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&h.write(g.data),h.end(),b.onCancellationRequested(()=>{h.abort(),c((0,D.canceled)())})})}async resolveProxy(g){}};S=he([te(0,n.IConfigurationService),te(1,d.INativeEnvironmentService),te(2,t.ILogService)],S),e.RequestService=S}),define(Q[223],J([0,1,14,222]),function(V,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(k){return v.net.request}class M extends R.RequestService{request(n,d){return super.request({...n||{},getRawRequest:D},d)}}e.RequestMainService=M}),define(Q[224],J([0,1,14,9,4,2,10,13,86,24,22,6,45,56,64]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(y,c,h,o,u,i,a){super();this.machineId=y,this.userEnv=c,this.environmentMainService=h,this.lifecycleMainService=o,this.logService=u,this.themeMainService=i,this.protocolMainService=a,this.firstWindowConnectionBarrier=new R.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),v.ipcMain.on("vscode:createSharedProcessMessageChannel",(y,c)=>this.onWindowConnection(y,c)),v.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(y,c)=>this.onWorkerConnection(y,c))}async onWindowConnection(y,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const h=await this.connect();if(y.sender.isDestroyed())return h.close();y.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[h])}onWorkerConnection(y,c){this.logService.trace("SharedProcess: onWorkerConnection",c);const h=new M.DisposableStore,o=i=>{this.logService.trace(`SharedProcess: disposing worker (reason: '${i}')`,c),h.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",c)},u=v.BrowserWindow.fromId(c.reply.windowId);if(!u||u.isDestroyed()||u.webContents.isDestroyed()||!c.reply.channel){o("unavailable");return}h.add(D.Event.fromNodeEventEmitter(u,"closed")(()=>o("closed")));for(const i of["destroyed","render-process-gone","did-start-loading"])h.add(D.Event.fromNodeEventEmitter(u.webContents,i)(()=>o(i)));u.webContents.postMessage(c.reply.channel,c.reply.nonce,y.ports)}onWillShutdown(){const y=this.window;!y||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(y.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{y.close()}catch(c){}this.window=void 0},0))}send(y,...c){const h=this.window;if(!h||h.isDestroyed()||h.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${y}' for shared process window that is destroyed`);return}h.webContents.send(y,...c)}whenReady(){return this._whenReady||(this._whenReady=new Promise(y=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),y()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(y=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),y()}))})()),this._whenIpcReady}createWindow(){const y=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${y.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),y.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:E.default}),this.window.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=y=>{this.logService.trace("SharedProcess#close prevented"),y.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(y,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(y,c,h)=>this._onDidError.fire({type:3,details:{reason:h,exitCode:c}})))}async connect(){await this.whenIpcReady;const y=(0,n.assertIsDefined)(this.window);return(0,d.connect)(y)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};g=he([te(2,w.IEnvironmentMainService),te(3,t.ILifecycleMainService),te(4,I.ILogService),te(5,f.IThemeMainService),te(6,S.IProtocolMainService)],g),e.SharedProcess=g}),define(Q[225],J([0,1,9,18,8,13,7,24,20,6]),function(V,e,v,R,D,M,k,n,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class t{constructor(S,f,g){this.storagePath=S,this.logService=f,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}}getItem(S,f){const g=this.storage[S];return(0,M.isUndefinedOrNull)(g)?f:g}setItem(S,f){this.setItems([{key:S,data:f}])}setItems(S){let f=!1;for(const{key:g,data:b}of S)this.storage[g]!==b&&((0,M.isUndefinedOrNull)(b)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,f=!0):(this.storage[g]=b,f=!0));f&&this.save()}removeItem(S){(0,M.isUndefined)(this.storage[S])||(this.storage[S]=void 0,this.save())}async save(S){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),S)}async doSave(){if(!this.initializing)return;await this.initializing;const S=JSON.stringify(this.storage,null,4);if(S!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,R.VSBuffer.fromString(S)),this.lastSavedStorageContents=S}catch(f){this.logService.error(f)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=t;let I=class yt{constructor(S,f,g){this.fileStorage=new t(k.URI.file((0,D.join)(S.userDataPath,yt.STATE_FILE)),f,g)}async init(){return this.fileStorage.init()}getItem(S,f){return this.fileStorage.getItem(S,f)}setItem(S,f){this.fileStorage.setItem(S,f)}setItems(S){this.fileStorage.setItems(S)}removeItem(S){this.fileStorage.removeItem(S)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=he([te(0,n.IEnvironmentMainService),te(1,w.ILogService),te(2,d.IFileService)],I),e.StateMainService=I}),define(Q[79],J([0,1,9,23,4,16,24,22,6,21,50,41]),function(V,e,v,R,D,M,k,n,d,w,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(f,g,b){return`${b.updateUrl}/api/update/${f}/${g}/${b.commit}`}e.createUpdateURL=E;let S=class{constructor(g,b,y,c,h,o){this.lifecycleMainService=g,this.configurationService=b,this.environmentMainService=y,this.requestService=c,this.logService=h,this.productService=o,this._state=I.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.getUpdateMode(),b=this.getProductQuality(g);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,y=>this.logService.error(y))}getUpdateMode(){return(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,v.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},R.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};S=he([te(0,n.ILifecycleMainService),te(1,M.IConfigurationService),te(2,k.IEnvironmentMainService),te(3,t.IRequestService),te(4,d.ILogService),te(5,w.IProductService)],S),e.AbstractUpdateService=S}),define(Q[226],J([0,1,14,47,4,2,16,24,22,6,21,50,29,41,79]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends f.AbstractUpdateService{constructor(y,c,h,o,u,i,a){super(y,c,o,u,i,a);this.telemetryService=h,this.disposables=new M.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"error",(y,c)=>c)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(y,c,h)=>({url:c,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(y,c,h,o)=>({releaseNotes:c,version:h,productVersion:h,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(y){this.logService.error("UpdateService error:",y);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?y:void 0;this.setState(S.State.Idle(1,h))}buildUpdateFeedUrl(y){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,f.createUpdateURL)(c,y,this.productService);try{v.autoUpdater.setFeedURL({url:h})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return h}doCheckForUpdates(y){this.setState(S.State.CheckingForUpdates(y)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(y){this.state.type==="checking for updates"&&this.setState(S.State.Downloading(y))}onUpdateDownloaded(y){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:y.version}),this.setState(S.State.Ready(y)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(S.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([R.memoize],g.prototype,"onRawError",null),he([R.memoize],g.prototype,"onRawUpdateNotAvailable",null),he([R.memoize],g.prototype,"onRawUpdateAvailable",null),he([R.memoize],g.prototype,"onRawUpdateDownloaded",null),g=he([te(0,d.ILifecycleMainService),te(1,k.IConfigurationService),te(2,E.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,I.IRequestService),te(5,w.ILogService),te(6,t.IProductService)],g),e.DarwinUpdateService=g}),define(Q[227],J([0,1,44,31,9,4,8,24,22,6,29,41]),function(V,e,v,R,D,M,k,n,d,w,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(g,b,y){if(this.lifecycleMainService=g,this.logService=y,this._state=I.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,D.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=he([te(0,d.ILifecycleMainService),te(1,n.IEnvironmentMainService),te(2,w.ILogService)],E);let S=class extends E{constructor(g,b,y,c,h,o){super(y,c,h);this.snap=g,this.snapRevision=b,this.telemetryService=o;const u=(0,R.watch)(k.dirname(this.snap)),i=M.Event.fromNodeEventEmitter(u,"change",(l,m)=>m),a=M.Event.filter(i,l=>l==="current"),r=M.Event.debounce(a,(l,m)=>m,2e3)(()=>this.checkForUpdates(!1));y.onWillShutdown(()=>{r.dispose(),u.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+k.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((y,c)=>(0,R.realpath)(`${k.dirname(this.snap)}/current`,(h,o)=>h?c(h):y(o))),b=k.basename(g);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};S=he([te(2,d.ILifecycleMainService),te(3,n.IEnvironmentMainService),te(4,w.ILogService),te(5,t.ITelemetryService)],S),e.SnapUpdateService=S}),define(Q[46],J([0,1,14,31,4,39,34,2,10,8,3,15,13,19,153,51,52,24,5,6,21,99,26,100]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y,c,h,o,u,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,c.createDecorator)("workspacesManagementMainService");let s=class extends n.Disposable{constructor(l,m,p,P,L){super();this.environmentMainService=l,this.logService=m,this.backupMainService=p,this.dialogMainService=P,this.productService=L,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,m=>(0,R.readFileSync)(m,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,m=>S.Promises.readFile(m,"utf8"))}doResolveLocalWorkspace(l,m){if(!!this.isWorkspacePath(l)&&l.scheme===d.Schemas.file)try{const p=m(l.fsPath);return p instanceof Promise?p.then(P=>this.doResolveWorkspace(l,P),P=>{}):this.doResolveWorkspace(l,p)}catch{return}}isWorkspacePath(l){return(0,i.isUntitledWorkspace)(l,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,m){try{const p=this.doParseStoredWorkspace(l,m),P=(0,a.getWorkspaceIdentifier)(l);return{id:P.id,configPath:P.configPath,folders:(0,i.toWorkspaceFolders)(p.folders,P.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:p.remoteAuthority,transient:p.transient}}catch(p){this.logService.warn(p.toString())}}doParseStoredWorkspace(l,m){const p=(0,M.parse)(m);if(p&&Array.isArray(p.folders))p.folders=p.folders.filter(P=>(0,i.isStoredWorkspaceFolder)(P));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return p}async createUntitledWorkspace(l,m){const{workspace:p,storedWorkspace:P}=this.newUntitledWorkspace(l,m),L=p.configPath.fsPath;return await S.Promises.mkdir((0,w.dirname)(L),{recursive:!0}),await S.Promises.writeFile(L,JSON.stringify(P,null,"	")),p}createUntitledWorkspaceSync(l,m){const{workspace:p,storedWorkspace:P}=this.newUntitledWorkspace(l,m),L=p.configPath.fsPath;return(0,R.mkdirSync)((0,w.dirname)(L),{recursive:!0}),(0,S.writeFileSync)(L,JSON.stringify(P,null,"	")),p}newUntitledWorkspace(l=[],m){const p=(Date.now()+Math.round(Math.random()*1e3)).toString(),P=(0,I.joinPath)(this.untitledWorkspacesHome,p),L=(0,I.joinPath)(P,i.UNTITLED_WORKSPACE_NAME),A=[];for(const W of l)A.push((0,i.getStoredWorkspaceFolder)(W.uri,!0,W.name,P,!t.isWindows,I.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(L),storedWorkspace:{folders:A,remoteAuthority:m}}}async getWorkspaceIdentifier(l){return(0,a.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,i.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const m=(0,I.originalFSPath)(l.configPath);try{(0,S.rimrafSync)((0,w.dirname)(m));const p=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,R.existsSync)(p)&&(0,S.writeFileSync)((0,w.join)(p,"obsolete"),"")}catch(p){this.logService.warn(`Unable to delete untitled workspace ${m} (${p}).`)}}getUntitledWorkspacesSync(){const l=[];try{const m=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(p=>(0,I.joinPath)(this.untitledWorkspacesHome,p,i.UNTITLED_WORKSPACE_NAME));for(const p of m){const P=(0,a.getWorkspaceIdentifier)(p),L=this.resolveLocalWorkspaceSync(p);L?l.push({workspace:P,remoteAuthority:L.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(P)}}catch(m){m.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${m}).`)}return l}async enterWorkspace(l,m,p){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,m,p))return;const L=this.doEnterWorkspace(l,(0,a.getWorkspaceIdentifier)(p));if(!!L)return this._onDidEnterWorkspace.fire({window:l,workspace:L.workspace}),L}async isValidTargetWorkspacePath(l,m,p){if(!p)return!0;if((0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,p))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(m,p)){const P={title:this.productService.nameLong,type:"info",buttons:[(0,k.mnemonicButtonLabel)((0,f.localize)(0,null))],message:(0,f.localize)(1,null,(0,I.basename)(p)),detail:(0,f.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(P,(0,E.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,m){if(!l.config)return;l.focus();let p;return l.config.extensionDevelopmentPath||(p=this.backupMainService.registerWorkspaceBackupSync({workspace:m,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=m,l.config.backupPath=p,{workspace:m,backupPath:p}}};s=he([te(0,y.IEnvironmentMainService),te(1,h.ILogService),te(2,g.IBackupMainService),te(3,b.IDialogMainService),te(4,o.IProductService)],s),e.WorkspacesManagementMainService=s}),define(Q[101],J([0,1,14,30,23,3,13,7,19,16,54,5,6,97,36,26,46]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,I.createDecorator)(e.ID);let y=class{constructor(h,o,u,i,a){this.logService=h,this.windowsMainService=o,this.urlService=u,this.workspacesManagementMainService=i,this.configurationService=a}async start(h,o){this.logService.trace("Received data from other instance: ",h,o),M.isMacintosh&&v.app.focus({steal:!0});const u=this.parseOpenUrl(h);if(u.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:a,url:s}of u)this.urlService.open(a,{originalUrl:s})})}else return this.startOpenWindow(h,o)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,R.coalesce)(h._urls.map(o=>{try{return{uri:n.URI.parse(o),url:o}}catch(u){return null}})):[]}async startOpenWindow(h,o){const u=(0,t.isLaunchedFromCli)(o)?0:4;let i=[];const a=h.wait&&h.waitMarkerFilePath?n.URI.file(h.waitMarkerFilePath):void 0,s=h.remote||void 0,r={context:u,cli:h,userEnv:o,waitMarkerFileURI:a,remoteAuthority:s};if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,r);else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let l=!1;if(h["new-window"]||h["unity-launch"])l=!0;else if(h["reuse-window"])l=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":l=!0;break;case"off":l=!1;break;default:l=!M.isMacintosh}if(l)i=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const m=this.windowsMainService.getLastActiveWindow();m?(this.windowsMainService.openExistingWindow(m,r),i=[m]):i=this.windowsMainService.open({...r,forceEmpty:!0})}}else i=this.windowsMainService.open({...r,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],gotoLineMode:h.goto});if(a&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,d.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return v.BrowserWindow.getAllWindows().forEach(o=>{const u=this.windowsMainService.getWindowById(o.id);u?h.push(this.codeWindowToInfo(u)):h.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(i=>new Promise(a=>{const s=i.remoteAuthority;if(s){const r=`vscode:getDiagnosticInfoResponse${i.id}`,l={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(i):void 0};i.sendWhenReady("vscode:getDiagnosticInfo",D.CancellationToken.None,{replyChannel:r,args:l}),v.ipcMain.once(r,(m,p)=>{p||a({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),a(p)}),setTimeout(()=>{a({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else a(void 0)})))).filter(i=>!!i)}getFolderURIs(h){const o=[],u=h.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(u))o.push(u.uri);else if((0,g.isWorkspaceIdentifier)(u)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);i&&i.folders.forEach(s=>{o.push(s.uri)})}return o}codeWindowToInfo(h){const o=this.getFolderURIs(h),u=(0,k.assertIsDefined)(h.win);return this.browserWindowToInfo(u,o,h.remoteAuthority)}browserWindowToInfo(h,o=[],u){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:o,remoteAuthority:u}}};y=he([te(0,E.ILogService),te(1,f.IWindowsMainService),te(2,S.IURLService),te(3,b.IWorkspacesManagementMainService),te(4,w.IConfigurationService)],y),e.LaunchMainService=y}),define(Q[53],J([0,1,44,14,25,113,47,4,34,2,10,8,3,7,83,71,19,145,52,24,5,22,6,21,29,64,36,26,46]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y,c,h,o,u,i,a,s,r,l,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,o.createDecorator)("nativeHostMainService");let P=class lt extends w.Disposable{constructor(A,W,q,x,re,K,ee,F,H,z){super();this.sharedProcess=A,this.windowsMainService=W,this.dialogMainService=q,this.lifecycleMainService=x,this.environmentMainService=re,this.telemetryService=K,this.logService=ee,this.productService=F,this.themeMainService=H,this.workspacesManagementMainService=z,this.onDidOpenWindow=n.Event.map(this.windowsMainService.onDidOpenWindow,B=>B.id),this.onDidMaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(R.app,"browser-window-maximize",(B,U)=>U.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidUnmaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(R.app,"browser-window-unmaximize",(B,U)=>U.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidBlurWindow=n.Event.filter(n.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(B,U)=>U.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidFocusWindow=n.Event.any(n.Event.map(n.Event.filter(n.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),B=>!!B),B=>B.id),n.Event.filter(n.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(B,U)=>U.id),B=>!!this.windowsMainService.getWindowById(B))),this.onDidResumeOS=n.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=n.Event.debounce(n.Event.any(n.Event.filter(n.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(B,U,C)=>C),B=>!(Array.isArray(B)&&B.length===1&&B[0]==="workArea")),n.Event.fromNodeEventEmitter(R.screen,"display-added"),n.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){R.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(A){return this.windowsMainService.getWindowCount()}async getActiveWindowId(A){const W=R.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(A,W,q){return Array.isArray(W)?this.doOpenWindow(A,W,q):this.doOpenEmptyWindow(A,W)}async doOpenWindow(A,W,q=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:A,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0})}async doOpenEmptyWindow(A,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:A},W)}async toggleFullScreen(A){const W=this.windowById(A);W&&W.toggleFullScreen()}async handleTitleDoubleClick(A){const W=this.windowById(A);W&&W.handleTitleDoubleClick()}async isMaximized(A){const W=this.windowById(A);return W?.win?W.win.isMaximized():!1}async maximizeWindow(A){const W=this.windowById(A);W?.win&&W.win.maximize()}async unmaximizeWindow(A){const W=this.windowById(A);W?.win&&W.win.unmaximize()}async minimizeWindow(A){const W=this.windowById(A);W?.win&&W.win.minimize()}async focusWindow(A,W){W&&typeof W.windowId=="number"&&(A=W.windowId);const q=this.windowById(A);q&&q.focus({force:W?.force??!1})}async setMinimumSize(A,W,q){const x=this.windowById(A);if(x?.win){const[re,K]=x.win.getSize(),[ee,F]=x.win.getMinimumSize(),[H,z]=[W??ee,q??F],[B,U]=[Math.max(re,H),Math.max(K,z)];(ee!==H||F!==z)&&x.win.setMinimumSize(H,z),(re!==B||K!==U)&&x.win.setSize(B,U)}}async saveWindowSplash(A,W){this.themeMainService.saveWindowSplash(A,W)}async installShellCommand(A){const{source:W,target:q}=await this.getShellCommandLink();try{const{symbolicLink:x}=await b.SymlinkSupport.stat(W);if(x&&!x.dangling){const re=await(0,f.realpath)(W);if(q===re)return}await b.Promises.unlink(W)}catch(x){if(x.code!=="ENOENT")throw x}try{await b.Promises.symlink(q,W)}catch(x){if(x.code!=="EACCES"&&x.code!=="ENOENT")throw x;const{response:re}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(0,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,y.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const K=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${W}'\\" with administrator privileges"`;await(0,M.promisify)(v.exec)(K)}catch(K){throw new Error((0,y.localize)(3,null,W))}}}async uninstallShellCommand(A){const{source:W}=await this.getShellCommandLink();try{await b.Promises.unlink(W)}catch(q){switch(q.code){case"EACCES":const{response:x}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(4,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,y.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(x===0)try{const re=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,M.promisify)(v.exec)(re)}catch(re){throw new Error((0,y.localize)(7,null,W))}break;case"ENOENT":break;default:throw q}}}async getShellCommandLink(){const A=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(A))throw new Error((0,y.localize)(8,null,A));return{source:W,target:A}}async showMessageBox(A,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(A))}async showSaveDialog(A,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(A))}async showOpenDialog(A,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(A))}toBrowserWindow(A){const W=this.windowById(A);if(W?.win)return W.win}async pickFileFolderAndOpen(A,W){const q=await this.dialogMainService.pickFileFolder(W);q&&(this.sendPickerTelemetry(q,W.telemetryEventName||"openFileFolder",W.telemetryExtraData),this.doOpenPicked(await Promise.all(q.map(async x=>await b.SymlinkSupport.existsDirectory(x)?{folderUri:S.URI.file(x)}:{fileUri:S.URI.file(x)})),W,A))}async pickFolderAndOpen(A,W){const q=await this.dialogMainService.pickFolder(W);q&&(this.sendPickerTelemetry(q,W.telemetryEventName||"openFolder",W.telemetryExtraData),this.doOpenPicked(q.map(x=>({folderUri:S.URI.file(x)})),W,A))}async pickFileAndOpen(A,W){const q=await this.dialogMainService.pickFile(W);q&&(this.sendPickerTelemetry(q,W.telemetryEventName||"openFile",W.telemetryExtraData),this.doOpenPicked(q.map(x=>({fileUri:S.URI.file(x)})),W,A))}async pickWorkspaceAndOpen(A,W){const q=await this.dialogMainService.pickWorkspace(W);q&&(this.sendPickerTelemetry(q,W.telemetryEventName||"openWorkspace",W.telemetryExtraData),this.doOpenPicked(q.map(x=>({workspaceUri:S.URI.file(x)})),W,A))}doOpenPicked(A,W,q){this.windowsMainService.open({context:3,contextWindowId:q,cli:this.environmentMainService.args,urisToOpen:A,forceNewWindow:W.forceNewWindow})}sendPickerTelemetry(A,W,q){const x=A?A.length:0;this.telemetryService.publicLog(W,{...q,outcome:x?"success":"canceled",numberOfPaths:x})}async showItemInFolder(A,W){R.shell.showItemInFolder(W)}async setRepresentedFilename(A,W){const q=this.windowById(A);q&&q.setRepresentedFilename(W)}async setDocumentEdited(A,W){const q=this.windowById(A);q&&q.setDocumentEdited(W)}async openExternal(A,W){return E.isLinuxSnap?this.safeSnapOpenExternal(W):R.shell.openExternal(W),!0}safeSnapOpenExternal(A){const W=process.env.GDK_PIXBUF_MODULE_FILE,q=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,R.shell.openExternal(A),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=q}moveItemToTrash(A,W){return R.shell.trashItem(W)}async isAdmin(){let A;return E.isWindows?A=(await new Promise((W,q)=>{V(["native-is-elevated"],W,q)}))():A=process.getuid()===0,A}async writeElevated(A,W,q,x){const re=await new Promise((K,ee)=>{V(["sudo-prompt"],K,ee)});return new Promise((K,ee)=>{const F=[`"${this.cliPath}"`];x?.unlock&&F.push("--file-chmod"),F.push("--file-write",`"${W.fsPath}"`,`"${q.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:E.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};re.exec(F.join(" "),H,(z,B,U)=>{B&&this.logService.trace(`[sudo-prompt] received stdout: ${B}`),U&&this.logService.trace(`[sudo-prompt] received stderr: ${U}`),z?ee(z):K(void 0)})})}get cliPath(){return E.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):E.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}get osColorScheme(){return{highContrast:R.nativeTheme.shouldUseInvertedColorScheme||R.nativeTheme.shouldUseHighContrastColors,dark:R.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(A,W,q){process.kill(W,q)}async readClipboardText(A,W){return R.clipboard.readText(W)}async writeClipboardText(A,W,q){return R.clipboard.writeText(W,q)}async readClipboardFindText(A){return R.clipboard.readFindText()}async writeClipboardFindText(A,W){return R.clipboard.writeFindText(W)}async writeClipboardBuffer(A,W,q,x){return R.clipboard.writeBuffer(W,Buffer.from(q),x)}async readClipboardBuffer(A,W){return R.clipboard.readBuffer(W)}async hasClipboard(A,W,q){return R.clipboard.has(W,q)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(A,W){const q=this.windowById(A);q&&q.updateTouchBar(W)}async notifyReady(A){const W=this.windowById(A);W&&W.setReady()}async relaunch(A,W){return this.lifecycleMainService.relaunch(W)}async reload(A,W){const q=this.windowById(A);if(q){if((0,m.isWorkspaceIdentifier)(q.openedWorkspace)){const x=q.openedWorkspace.configPath;if(x.scheme===t.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(x))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(q,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(A){this.closeWindowById(A,A)}async closeWindowById(A,W){const q=this.windowById(W);if(q?.win)return q.win.close()}async quit(A){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(A,W){await this.lifecycleMainService.kill(W)}async resolveProxy(A,W){const x=this.windowById(A)?.win?.webContents?.session;if(x)return x.resolveProxy(W)}async openDevTools(A,W){const q=this.windowById(A);q?.win&&q.win.webContents.openDevTools(W)}async toggleDevTools(A){const W=this.windowById(A);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(A,W){const q=this.windowById(A);q?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&q.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(A,W,q,x){if(!E.isWindows)return;const re=await new Promise((K,ee)=>{V(["vscode-windows-registry"],K,ee)});try{return re.GetStringRegKey(W,q,x)}catch{return}}async getPassword(A,W,q){const x=await this.withKeytar(),re=await x.getPassword(W,q);if(re)try{let{content:K,hasNextChunk:ee}=JSON.parse(re);if(!K||!ee)return re;let F=1;for(;ee;){const H=await x.getPassword(W,`${q}-${F}`),z=JSON.parse(H);K+=z.content,ee=z.hasNextChunk,F++}return K}catch{return re}return re}async setPassword(A,W,q,x){const re=await this.withKeytar(),K=3,ee=async(F,H,z)=>{let B=0,U;for(;B<K;)try{await re.setPassword(F,H,z);return}catch(C){U=C,this.logService.warn("Error attempting to set a password: ",C),B++,await new Promise(Y=>setTimeout(Y,200))}throw U};if(E.isWindows&&x.length>lt.MAX_PASSWORD_LENGTH){let F=0,H=0,z=!0;for(;z;){const B=x.substring(F,F+lt.PASSWORD_CHUNK_SIZE);F+=lt.PASSWORD_CHUNK_SIZE,z=x.length-F>0;const U={content:B,hasNextChunk:z};await ee(W,H?`${q}-${H}`:q,JSON.stringify(U)),H++}}else await ee(W,q,x);this._onDidChangePassword.fire({service:W,account:q})}async deletePassword(A,W,q){const re=await(await this.withKeytar()).deletePassword(W,q);return re&&this._onDidChangePassword.fire({service:W,account:q}),re}async findPassword(A,W){return(await this.withKeytar()).findPassword(W)}async findCredentials(A,W){return(await this.withKeytar()).findCredentials(W)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((A,W)=>{V(["keytar"],A,W)})}windowById(A){if(typeof A=="number")return this.windowsMainService.getWindowById(A)}};P.MAX_PASSWORD_LENGTH=2500,P.PASSWORD_CHUNK_SIZE=P.MAX_PASSWORD_LENGTH-100,he([k.memoize],P.prototype,"cliPath",null),P=he([te(1,l.IWindowsMainService),te(2,c.IDialogMainService),te(3,u.ILifecycleMainService),te(4,h.IEnvironmentMainService),te(5,s.ITelemetryService),te(6,i.ILogService),te(7,a.IProductService),te(8,r.IThemeMainService),te(9,p.IWorkspacesManagementMainService)],P),e.NativeHostMainService=P}),define(Q[228],J([0,1,14,23,4,82,2,28,89,6,53,21,36]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var S;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(S||(S={}));let f=class extends k.Disposable{constructor(b,y,c,h,o){super();this.logService=b,this.windowsMainService=y,this.nativeHostMainService=c,this.encryptionMainService=h,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=S.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=D.Event.fromNodeEventEmitter(v.app,"login",(y,c,h,o,u)=>({event:y,webContents:c,req:h,authInfo:o,callback:u}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:y,req:c,callback:h}){if(!y.isProxy)return;if(!this.pendingProxyResolve&&this.state===S.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(y);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(o?.username,o?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const y=await this.doResolveProxyCredentials(b);if(y)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),y;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const y=String((0,M.hash)({scheme:b.scheme,host:b.host,port:b.port}));let c,h;try{const a=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y);if(a){const s=JSON.parse(await this.encryptionMainService.decrypt(a));c=s.username,h=s.password}}catch(a){this.logService.error(a)}if(this.state!==S.StoredCredentialsUsed&&typeof c=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=S.StoredCredentialsUsed,{username:c,password:h};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const u={authInfo:b,username:this.sessionCredentials?.username??c,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,u),this.state=S.LoginDialogShown;const i=await new Promise(a=>{const s=async(r,l,m)=>{if(l===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",s),m){const p={username:m.username,password:m.password};try{if(m.remember){const P=await this.encryptionMainService.encrypt(JSON.stringify(p));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y,P)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y)}catch(P){this.logService.error(P)}a({username:p.username,password:p.password})}else a(void 0)};o.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=i,i}};f=he([te(0,w.ILogService),te(1,E.IWindowsMainService),te(2,t.INativeHostMainService),te(3,d.IEncryptionMainService),te(4,I.IProductService)],f),e.ProxyAuthHandler=f}),define(Q[229],J([0,1,14,25,34,2,10,3,84,143,75,52,24,5,101,6,53,45,21,56,65]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y,c,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,S.createDecorator)("issueMainService");let u=class St{constructor(a,s,r,l,m,p,P,L,A){this.userEnv=a,this.environmentMainService=s,this.launchMainService=r,this.logService=l,this.diagnosticsService=m,this.dialogMainService=p,this.nativeHostMainService=P,this.protocolMainService=L,this.productService=A,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async a=>{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(s,r);this.safeSend(a,"vscode:issueSystemInfoResponse",l)}),v.ipcMain.on("vscode:listProcesses",async a=>{const s=[];try{const r=await this.launchMainService.getMainProcessId();s.push({name:(0,w.localize)(0,null),rootProcess:await(0,d.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(m=>{(0,t.isRemoteDiagnosticError)(m)?s.push({name:m.hostName,rootProcess:m}):m.processes&&s.push({name:m.hostName,rootProcess:m.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(a,"vscode:listProcessesResponse",s)}),v.ipcMain.on("vscode:issueReporterClipboard",async a=>{const s={title:this.productService.nameLong,message:(0,w.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,w.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,w.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(a,"vscode:issueReporterClipboardResponse",r.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const s=await this.getPerformanceInfo();this.safeSend(a,"vscode:issuePerformanceInfoResponse",s)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const a={title:this.productService.nameLong,message:(0,w.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,w.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(a,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(a,s)=>{const{id:r,from:l,args:m}=s;let p;switch(l){case"issueReporter":p=this.issueReporterParentWindow;break;case"processExplorer":p=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}p&&p.webContents.send("vscode:runAction",{id:r,from:l,args:m})}),v.ipcMain.on("vscode:openExternal",(a,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),v.ipcMain.on("vscode:closeIssueReporter",a=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",a=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async a=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(a,"vscode:windowsInfoResponse",s.windows)})}safeSend(a,s,...r){a.sender.isDestroyed()||a.sender.send(s,...r)}async openReporter(a){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new M.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,r,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:a,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:y.default}),this.issueReporterWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(a){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new M.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,r,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:a,product:y.default}),this.processExplorerWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(a,s,r){const l=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:r.title,backgroundColor:r.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,o.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[a,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(a,s)}getWindowPosition(a,s,r){let l;const m=v.screen.getAllDisplays();if(m.length===1)l=m[0];else{if(n.isMacintosh){const L=v.screen.getCursorScreenPoint();l=v.screen.getDisplayNearestPoint(L)}!l&&a&&(l=v.screen.getDisplayMatching(a.getBounds())),l||(l=v.screen.getPrimaryDisplay()||m[0])}const p={width:s,height:r},P=l.bounds;return p.x=P.x+P.width/2-p.width/2,p.y=P.y+P.height/2-p.height/2,P.width>0&&P.height>0&&(p.x<P.x&&(p.x=P.x),p.y<P.y&&(p.y=P.y),p.x>P.x+P.width&&(p.x=P.x),p.y>P.y+P.height&&(p.y=P.y),p.width>P.width&&(p.width=P.width),p.height>P.height&&(p.height=P.height)),p}async getPerformanceInfo(){try{const[a,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(a,s)}catch(a){throw this.logService.warn("issueService#getPerformanceInfo ",a.message),a}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([te(1,E.IEnvironmentMainService),te(2,f.ILaunchMainService),te(3,g.ILogService),te(4,t.IDiagnosticsService),te(5,I.IDialogMainService),te(6,b.INativeHostMainService),te(7,h.IProtocolMainService),te(8,c.IProductService)],u),e.IssueMainService=u}),define(Q[230],J([0,1,23,16,24,22,6,53,21,50,29,41,79]),function(V,e,v,R,D,M,k,n,d,w,t,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let S=class extends E.AbstractUpdateService{constructor(g,b,y,c,h,o,u,i){super(g,b,c,h,o,i);this.telemetryService=y,this.nativeHostMainService=u}buildUpdateFeedUrl(g){return(0,E.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(I.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},v.CancellationToken.None).then(w.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const y=g?b.message||b:void 0;this.setState(I.State.Idle(1,y))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(I.State.Idle(1))}};S=he([te(0,M.ILifecycleMainService),te(1,R.IConfigurationService),te(2,t.ITelemetryService),te(3,D.IEnvironmentMainService),te(4,w.IRequestService),te(5,k.ILogService),te(6,n.INativeHostMainService),te(7,d.IProductService)],S),e.LinuxUpdateService=S}),define(Q[231],J([0,1,44,31,25,9,23,47,8,7,110,19,16,24,20,22,6,53,21,50,29,41,79]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y,c,h,o,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(m,p=1e3){for(;!m();)await(0,M.timeout)(p)}let s;function r(){return typeof s=="undefined"&&(s=R.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),s}let l=class extends i.AbstractUpdateService{constructor(p,P,L,A,W,q,x,re,K){super(p,P,A,W,q,K);this.telemetryService=L,this.fileService=x,this.nativeHostMainService=re}get cachePath(){const p=d.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(p,{recursive:!0}).then(()=>p)}initialize(){super.initialize(),r()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(p){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),r()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,i.createUpdateURL)(P,p,this.productService)}doCheckForUpdates(p){!this.url||(this.setState(u.State.CheckingForUpdates(p)),this.requestService.request({url:this.url},k.CancellationToken.None).then(h.asJson).then(P=>{const L=r();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p}),this.setState(u.State.Idle(L)),Promise.resolve(null)):L===1?(this.setState(u.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(u.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(A=>I.Promises.exists(A).then(W=>{if(W)return Promise.resolve(A);const q=P.url,x=P.hash,re=`${A}.tmp`;return this.requestService.request({url:q},k.CancellationToken.None).then(K=>this.fileService.writeFile(w.URI.file(re),K.stream)).then(x?()=>(0,t.checksum)(re,P.hash):()=>{}).then(()=>I.Promises.rename(re,A)).then(()=>A)})).then(A=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},W&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(P)):this.setState(u.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p});const L=p?P.message||P:void 0;this.setState(u.State.Idle(r(),L))}))}async doDownloadUpdate(p){p.update.url&&this.nativeHostMainService.openExternal(void 0,p.update.url),this.setState(u.State.Idle(r()))}async getUpdatePackagePath(p){const P=await this.cachePath;return d.join(P,`CodeSetup-${this.productService.quality}-${p}.exe`)}async cleanup(p=null){const P=p?q=>!new RegExp(`${this.productService.quality}-${p}\\.exe$`).test(q):()=>!0,L=await this.cachePath,W=(await I.Promises.readdir(L)).filter(P).map(async q=>{try{await I.Promises.unlink(d.join(L,q))}catch(x){}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const p=this.state.update;this.setState(u.State.Updating(p));const P=await this.cachePath;this.availableUpdate.updateFilePath=d.join(P,`CodeSetup-${this.productService.quality}-${p.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(r()))});const A=`${this.productService.win32MutexName}-ready`,W=await new Promise((q,x)=>{V(["windows-mutex"],q,x)});a(()=>W.isActive(A)).then(()=>this.setState(u.State.Ready(p)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?R.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}};he([n.memoize],l.prototype,"cachePath",null),l=he([te(0,g.ILifecycleMainService),te(1,E.IConfigurationService),te(2,o.ITelemetryService),te(3,S.IEnvironmentMainService),te(4,h.IRequestService),te(5,b.ILogService),te(6,f.IFileService),te(7,y.INativeHostMainService),te(8,c.IProductService)],l),e.Win32UpdateService=l}),define(Q[232],J([0,1,14,9,23,4,34,2,10,8,77,3,7,149,51,16,52,24,54,199,20,22,6,21,56,98,29,202,64,65,36,26,46]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y,c,h,o,u,i,a,s,r,l,m,p,P,L,A,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var q;(function(re){re[re.NONE=0]="NONE",re[re.LOADING=1]="LOADING",re[re.NAVIGATING=2]="NAVIGATING",re[re.READY=3]="READY"})(q||(q={}));let x=class extends n.Disposable{constructor(K,ee,F,H,z,B,U,C,Y,O,T,_,j,X){super();this.logService=ee,this.environmentMainService=F,this.fileService=H,this.configurationService=B,this.themeMainService=U,this.workspacesManagementMainService=C,this.backupMainService=Y,this.telemetryService=O,this.dialogMainService=T,this.lifecycleMainService=_,this.productService=j,this.protocolMainService=X,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[$,N]=this.restoreWindowState(K.state);this.windowState=$,this.logService.trace("window#ctor: using window state",$);const Z=this.windowState.mode===0||this.windowState.mode===3,ie=this.configurationService.getValue("window"),oe={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:P.WindowMinimumSize.WIDTH,minHeight:P.WindowMinimumSize.HEIGHT,show:!Z,title:this.productService.nameLong,webPreferences:{preload:d.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,P.zoomLevelToZoomFactor)(ie?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};I.isLinux?oe.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(oe.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(oe.fullscreenable=!1),I.isMacintosh&&(oe.acceptFirstMouse=!0,ie?.clickThroughInactive===!1&&(oe.acceptFirstMouse=!1));const le=I.isMacintosh&&ie?.nativeTabs===!0;le&&(oe.tabbingIdentifier=this.productService.nameShort);const ne=(0,P.getTitleBarStyle)(this.configurationService)==="custom";if(ne&&(oe.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,I.isMacintosh||(oe.frame=!1)),(0,t.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(oe),(0,t.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),I.isMacintosh&&ne&&this._win.setSheetOffset(22),I.isMacintosh&&N&&(!le||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ae=>typeof ae=="number")){const ae=this.windowState;this._win.setBounds({width:ae.width,height:ae.height,x:ae.x,y:ae.y})}Z&&((0,t.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,t.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,h.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:$=>z.globalStorage.get($),store:($,N)=>z.globalStorage.set($,N)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(K){I.isMacintosh?this._win.setRepresentedFilename(K):this.representedFilename=K}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(K){I.isMacintosh&&this._win.setDocumentEdited(K),this.documentEdited=K}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(K){I.isMacintosh&&K?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(K=>{if(this.isReady)return K(this);this.whenReadyCallbacks.push(K)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(K=>{function ee(){F.dispose(),H.dispose(),K()}const F=this.onDidClose(()=>ee()),H=this.onWillLoad(()=>ee())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(z,B)=>this.onWindowError(2,B)),this._win.webContents.on("did-fail-load",(z,B,U)=>this.onWindowError(3,{reason:U,exitCode:B})),this._win.webContents.on("will-prevent-unload",z=>{z.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const K=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),ee=z=>{for(let B=z;B;B=B.parent)if(B.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},F=z=>z.resourceType==="xhr"||ee(z.frame);this._win.webContents.session.webRequest.onBeforeRequest((z,B)=>{const U=E.URI.parse(z.url);return U.path.endsWith(".svg")&&!K.has(U.scheme)?B({cancel:!F(z)}):B({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((z,B)=>{const U=z.responseHeaders,C=U["content-type"]||U["Content-Type"];if(C&&Array.isArray(C)){const Y=E.URI.parse(z.url);if(Y.path.endsWith(".svg")&&K.has(Y.scheme))return U["Content-Type"]=["image/svg+xml"],B({cancel:!1,responseHeaders:U});if(!Y.path.includes(d.Schemas.vscodeRemoteResource)&&C.some(O=>O.toLowerCase().includes("image/svg")))return B({cancel:!F(z)})}return B({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",z,this._win)}),this._win.on("unmaximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",z,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(z=>this.onDidDeleteUntitledWorkspace(z)));const H=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:H},async(z,B)=>{const U=await this.marketplaceHeadersPromise;B({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,U)})})}async onWindowError(K,ee){switch(K){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:K,reason:ee?.reason,code:ee?.exitCode}),K){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(K===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const F=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,S.localize)(0,null)),(0,k.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,k.mnemonicButtonLabel)((0,S.localize)(2,null))],message:(0,S.localize)(3,null),detail:(0,S.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;F.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):F.response===2&&this.destroyWindow()}else if(K===2){let F;ee?F=(0,S.localize)(6,null,ee.reason,ee.exitCode??"<unknown>"):F=(0,S.localize)(5,null);const H=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,S.localize)(7,null)),(0,k.mnemonicButtonLabel)((0,S.localize)(8,null))],message:F,detail:(0,S.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;H.response===0?this.reload():H.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(K){this.openedWorkspace?.id===K.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const K=this.getMenuBarVisibility();K!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=K,this.setMenuBarVisibility(K));let ee=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;ee?.endsWith("/")&&(ee=ee.substr(0,ee.length-1));const F=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((ee||"").indexOf("@")===-1&&(ee!==this.currentHttpProxy||F!==this.currentNoProxy)){this.currentHttpProxy=ee,this.currentNoProxy=F;const H=ee||"",z=F?`${F},<local>`:"<local>";this.logService.trace(`Setting proxy to '${H}', bypassing '${z}'`),this._win.webContents.session.setProxy({proxyRules:H,proxyBypassRules:z,pacScript:""})}}addTabbedWindow(K){I.isMacintosh&&K.win&&this._win.addTabbedWindow(K.win)}load(K,ee=Object.create(null)){this.isDocumentEdited()&&(!ee.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),ee.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(K,ee),this.readyState===0?this.currentConfig=K:(this.pendingLoadConfig=K,this.readyState=2),this._win.loadURL(d.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const F=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new R.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:K.workspace,reason:ee.isReload?3:F?2:1})}updateConfiguration(K,ee){const F=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(F){const H=(0,c.isLaunchedFromCli)(F)&&!(0,c.isLaunchedFromCli)(K.userEnv),z=this.isExtensionDevelopmentHost;(H||z)&&(K.userEnv={...F,...K.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(K.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),ee.disableExtensions!==void 0&&(K["disable-extensions"]=ee.disableExtensions),K.fullscreen=this.isFullScreen,K.maximized=this._win.isMaximized(),K.partsSplash=this.themeMainService.getWindowSplash(),(0,t.mark)("code/willOpenNewWindow"),K.perfMarks=(0,t.getMarks)(),this.configObjectUrl.update(K)}async reload(K){const ee=Object.assign({},this.currentConfig);ee.workspace=await this.validateWorkspaceBeforeReload(ee),delete ee.filesToOpenOrCreate,delete ee.filesToDiff,delete ee.filesToWait,this.isExtensionDevelopmentHost&&K&&(ee.verbose=K.verbose,ee.debugId=K.debugId,ee.extensionEnvironment=K.extensionEnvironment,ee["inspect-extensions"]=K["inspect-extensions"],ee["inspect-brk-extensions"]=K["inspect-brk-extensions"],ee["extensions-dir"]=K["extensions-dir"]),ee.isInitialStartup=!1,this.load(ee,{isReload:!0,disableExtensions:K?.["disable-extensions"]})}async validateWorkspaceBeforeReload(K){if((0,A.isWorkspaceIdentifier)(K.workspace)){const ee=K.workspace.configPath;if(ee.scheme===d.Schemas.file&&!await this.fileService.exists(ee))return}else if((0,A.isSingleFolderWorkspaceIdentifier)(K.workspace)){const ee=K.workspace.uri;if(ee.scheme===d.Schemas.file&&!await this.fileService.exists(ee))return}return K.workspace}serializeWindowState(){if(!this._win)return(0,L.defaultWindowState)();if(this.isFullScreen){let F;try{F=v.screen.getDisplayMatching(this.getBounds())}catch(B){}const H=(0,L.defaultWindowState)();return{mode:3,display:F?F.id:void 0,width:this.windowState.width||H.width,height:this.windowState.height||H.height,x:this.windowState.x||0,y:this.windowState.y||0}}const K=Object.create(null);let ee;if(!I.isMacintosh&&this._win.isMaximized()?ee=0:ee=1,ee===0?K.mode=0:K.mode=1,ee===1||ee===0){let F;ee===1?F=this.getBounds():F=this._win.getNormalBounds(),K.x=F.x,K.y=F.y,K.width=F.width,K.height=F.height}return K}restoreWindowState(K){(0,t.mark)("code/willRestoreCodeWindowState");let ee=!1;if(K)try{const F=v.screen.getAllDisplays();ee=F.length>1,K=this.validateWindowState(K,F)}catch(F){this.logService.warn(`Unexpected error validating window state: ${F}
${F.stack}`)}return(0,t.mark)("code/didRestoreCodeWindowState"),[K||(0,L.defaultWindowState)(),ee]}validateWindowState(K,ee){if(this.logService.trace(`window#validateWindowState: validating window state on ${ee.length} display(s)`,K),typeof K.x!="number"||typeof K.y!="number"||typeof K.width!="number"||typeof K.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(K.width<=0||K.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(ee.length===1){const z=this.getWorkingArea(ee[0]);if(z){let B=function(){!K||typeof K.x!="number"||typeof K.y!="number"||!z||(K.x<z.x&&(K.x=z.x),K.y<z.y&&(K.y=z.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",z),B(),K.width>z.width&&(K.width=z.width),K.height>z.height&&(K.height=z.height),K.x>z.x+z.width-128&&(K.x=z.x+z.width-K.width),K.y>z.y+z.height-128&&(K.y=z.y+z.height-K.height),B()}return K}if(K.display&&K.mode===3){const z=ee.find(B=>B.id===K.display);if(z&&typeof z.bounds?.x=="number"&&typeof z.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const B=(0,L.defaultWindowState)(3);return B.x=z.bounds.x,B.y=z.bounds.y,B}}let F,H;try{F=v.screen.getDisplayMatching({x:K.x,y:K.y,width:K.width,height:K.height}),H=this.getWorkingArea(F)}catch(z){}if(F&&H&&K.x+K.width>H.x&&K.y+K.height>H.y&&K.x<H.x+H.width&&K.y<H.y+H.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",H),K}getWorkingArea(K){if(K.workArea.width>0&&K.workArea.height>0)return K.workArea;if(K.bounds.width>0&&K.bounds.height>0)return K.bounds}getBounds(){const[K,ee]=this._win.getPosition(),[F,H]=this._win.getSize();return{x:K,y:ee,width:F,height:H}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(K){this.useNativeFullScreen()?this.setNativeFullScreen(K):this.setSimpleFullScreen(K),this.sendWhenReady(K?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(K){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(K)}setSimpleFullScreen(K){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(K),this._win.webContents.focus()}useNativeFullScreen(){const K=this.configurationService.getValue("window");return!K||typeof K.nativeFullScreen!="boolean"||K.nativeTabs?!0:K.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let K=(0,P.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(K)<0&&(K="classic"),K}setMenuBarVisibility(K,ee=!0){I.isMacintosh||(K==="toggle"&&ee&&this.send("vscode:showInfoMessage",(0,S.localize)(10,null)),K==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(K)}):this.doSetMenuBarVisibility(K))}doSetMenuBarVisibility(K){const ee=this.isFullScreen;switch(K){case"classic":this._win.setMenuBarVisibility(!ee),this._win.autoHideMenuBar=ee;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(K,ee,...F){this.isReady?this.send(K,...F):this.ready().then(()=>{ee.isCancellationRequested||this.send(K,...F)})}send(K,...ee){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${K}' for window that is destroyed`);return}this._win.webContents.send(K,...ee)}}updateTouchBar(K){!I.isMacintosh||this.touchBarGroups.forEach((ee,F)=>{const H=K[F];ee.segments=this.createTouchBarGroupSegments(H)})}createTouchBar(){if(!!I.isMacintosh){for(let K=0;K<10;K++){const ee=this.createTouchBarGroup();this.touchBarGroups.push(ee)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(K=[]){const ee=this.createTouchBarGroupSegments(K),F=new v.TouchBar.TouchBarSegmentedControl({segments:ee,mode:"buttons",segmentStyle:"automatic",change:H=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:F.segments[H].id,from:"touchbar"})}});return F}createTouchBarGroupSegments(K=[]){return K.map(F=>{let H;F.icon&&!m.ThemeIcon.isThemeIcon(F.icon)&&F.icon?.dark?.scheme===d.Schemas.file&&(H=v.nativeImage.createFromPath(E.URI.revive(F.icon.dark).fsPath),H.isEmpty()&&(H=void 0));let z;return typeof F.title=="string"?z=F.title:z=F.title.value,{id:F.id,label:H?void 0:z,icon:H}})}dispose(){super.dispose(),this._win=null}};x=he([te(1,i.ILogService),te(2,y.IEnvironmentMainService),te(3,o.IFileService),te(4,r.IStorageMainService),te(5,g.IConfigurationService),te(6,p.IThemeMainService),te(7,W.IWorkspacesManagementMainService),te(8,f.IBackupMainService),te(9,l.ITelemetryService),te(10,b.IDialogMainService),te(11,u.ILifecycleMainService),te(12,a.IProductService),te(13,s.IProtocolMainService)],x),e.CodeWindow=x}),define(Q[66],J([0,1,14,30,9,4,34,2,10,3,15,7,19,152,5,22,6,38,26,46]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,f.createDecorator)("workspacesHistoryMainService");let o=class He extends n.Disposable{constructor(m,p,P,L){super();this.stateMainService=m,this.logService=p,this.workspacesManagementMainService=P,this.lifecycleMainService=L,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(m=>this.addRecentlyOpened([{workspace:m.workspace}])))}handleWindowsJumpList(){!w.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(m){const p=[],P=[];for(let L of m)if((0,c.isRecentWorkspace)(L))!this.workspacesManagementMainService.isUntitledWorkspace(L.workspace)&&a(p,L.workspace)===-1&&p.push(L);else if((0,c.isRecentFolder)(L))s(p,L.folderUri)===-1&&p.push(L);else{const A=r(P,L.fileUri)>=0,W=L.fileUri.scheme===d.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,t.basename)(L.fileUri))>=0;!A&&!W&&(P.push(L),w.isWindows&&L.fileUri.scheme===d.Schemas.file&&v.app.addRecentDocument(L.fileUri.fsPath))}this.addEntriesFromStorage(p,P),p.length>He.MAX_TOTAL_RECENT_ENTRIES&&(p.length=He.MAX_TOTAL_RECENT_ENTRIES),P.length>He.MAX_TOTAL_RECENT_ENTRIES&&(P.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:p,files:P}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(m){const p=W=>{const q=i(W);for(const x of m)if(t.extUriBiasedIgnorePathCase.isEqual(x,q))return!1;return!0},P=this.getRecentlyOpened(),L=P.workspaces.filter(p),A=P.files.filter(p);(L.length!==P.workspaces.length||A.length!==P.files.length)&&(this.saveRecentlyOpened({files:A,workspaces:L}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;v.app.clearRecentDocuments();const m=this.getRecentlyOpened(),p=[];let P=0;for(let A=0;A<m.workspaces.length&&P<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;A++){const W=i(m.workspaces[A]);if(W.scheme===d.Schemas.file){const q=(0,t.originalFSPath)(W);await E.Promises.exists(q)&&(p.push(q),P++)}}const L=[];for(let A=0;A<m.files.length&&P<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;A++){const W=i(m.files[A]);if(W.scheme===d.Schemas.file){const q=(0,t.originalFSPath)(W);if(He.COMMON_FILES_FILTER.includes((0,t.basename)(W))||p.includes(q))continue;await E.Promises.exists(q)&&(L.push(q),P++)}}L.reverse().forEach(A=>v.app.addRecentDocument(A)),p.reverse().forEach(A=>v.app.addRecentDocument(A))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(m){const p=[],P=[],L=m?.config?.workspace;(0,c.isWorkspaceIdentifier)(L)&&!this.workspacesManagementMainService.isUntitledWorkspace(L)?p.push({workspace:L}):(0,c.isSingleFolderWorkspaceIdentifier)(L)&&p.push({folderUri:L.uri});const A=m?.config?.filesToOpenOrCreate;if(A)for(let W of A){const q=W.fileUri;q&&r(P,q)===-1&&P.push({fileUri:q})}return this.addEntriesFromStorage(p,P),{workspaces:p,files:P}}addEntriesFromStorage(m,p){let P=this.getRecentlyOpenedFromStorage();for(let L of P.workspaces){let A=(0,c.isRecentFolder)(L)?s(m,L.folderUri):a(m,L.workspace);A>=0?m[A].label=m[A].label||L.label:m.push(L)}for(let L of P.files){let A=r(p,L.fileUri);A>=0?p[A].label=p[A].label||L.label:p.push(L)}}getRecentlyOpenedFromStorage(){const m=this.stateMainService.getItem(He.recentlyOpenedStorageKey);return(0,c.restoreRecentlyOpened)(m,this.logService)}saveRecentlyOpened(m){const p=(0,c.toStoreData)(m);this.stateMainService.setItem(He.recentlyOpenedStorageKey,p)}updateWindowsJumpList(){if(!w.isWindows)return;const m=[];if(m.push({type:"tasks",items:[{type:"task",title:(0,S.localize)(0,null),description:(0,S.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let p=[];for(let A of v.app.getJumpListSettings().removedItems){const W=A.args;if(W){const q=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(W);q&&p.push(I.URI.parse(q[2]))}}this.removeRecentlyOpened(p);let P=!1;const L=(0,R.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(A=>{const W=(0,c.isRecentWorkspace)(A)?A.workspace:A.folderUri,{title:q,description:x}=this.getWindowsJumpListLabel(W,A.label);let re;return I.URI.isUri(W)?re=`--folder-uri "${W.toString()}"`:(P=!0,re=`--file-uri "${W.configPath.toString()}"`),{type:"task",title:q.substr(0,255),description:x.substr(0,255),program:process.execPath,args:re,iconPath:"explorer.exe",iconIndex:0}}));L.length>0&&m.push({type:"custom",name:P?(0,S.localize)(2,null):(0,S.localize)(3,null),items:L})}m.push({type:"recent"});try{v.app.setJumpList(m)}catch(p){this.logService.warn("updateWindowsJumpList#setJumpList",p)}}getWindowsJumpListLabel(m,p){if(p)return{title:(0,k.splitName)(p).name,description:p};if(I.URI.isUri(m))return{title:(0,t.basename)(m),description:u(m)};if(this.workspacesManagementMainService.isUntitledWorkspace(m))return{title:(0,S.localize)(4,null),description:""};let P=(0,t.basename)(m.configPath);return P.endsWith(c.WORKSPACE_EXTENSION)&&(P=P.substr(0,P.length-c.WORKSPACE_EXTENSION.length-1)),{title:(0,S.localize)(5,null,P),description:u(m.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([te(0,y.IStateMainService),te(1,b.ILogService),te(2,h.IWorkspacesManagementMainService),te(3,g.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function u(l){return l.scheme==="file"?(0,k.normalizeDriveLetter)(l.fsPath):l.toString()}function i(l){return(0,c.isRecentFolder)(l)?l.folderUri:(0,c.isRecentFile)(l)?l.fileUri:l.workspace.configPath}function a(l,m){return l.findIndex(p=>(0,c.isRecentWorkspace)(p)&&p.workspace.id===m.id)}function s(l,m){return l.findIndex(p=>(0,c.isRecentFolder)(p)&&t.extUriBiasedIgnorePathCase.isEqual(p.folderUri,m))}function r(l,m){return l.findIndex(p=>t.extUriBiasedIgnorePathCase.isEqual(p.fileUri,m))}}),define(Q[233],J([0,1,14,9,23,34,3,7,144,16,24,22,6,179,53,21,38,29,41,65,36,66]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y,c,h,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let a=class wt{constructor(l,m,p,P,L,A,W,q,x,re,K){this.updateService=l,this.configurationService=m,this.windowsMainService=p,this.environmentMainService=P,this.telemetryService=L,this.workspacesHistoryMainService=A,this.stateMainService=W,this.lifecycleMainService=q,this.logService=x,this.nativeHostMainService=re,this.productService=K,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new R.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new R.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(k.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(A,W,q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(A,W,q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(A,W,q)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(q),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(A,W,q)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(q),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const m=this.productService.requestFeatureUrl;m&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(m,"openUserVoiceUrl"));const p=this.productService.reportIssueUrl;p&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(p,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(k.language){const A=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${A}lang=${k.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!k.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,m){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!k.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!k.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=v.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(k.isMacintosh?new v.Menu:null);return}const m=new v.Menu;let p;if(k.isMacintosh){const L=new v.Menu;p=new v.MenuItem({label:this.productService.nameShort,submenu:L}),this.setMacApplicationMenu(L),m.append(p)}if(k.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const L=new v.Menu;L.append(new v.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(L)}if(this.shouldDrawMenu("File")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:L});this.setMenuById(L,"File"),m.append(A)}if(this.shouldDrawMenu("Edit")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:L});this.setMenuById(L,"Edit"),m.append(A)}if(this.shouldDrawMenu("Selection")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:L});this.setMenuById(L,"Selection"),m.append(A)}if(this.shouldDrawMenu("View")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:L});this.setMenuById(L,"View"),m.append(A)}if(this.shouldDrawMenu("Go")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:L});this.setMenuById(L,"Go"),m.append(A)}if(this.shouldDrawMenu("Run")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:L});this.setMenuById(L,"Run"),m.append(A)}if(this.shouldDrawMenu("Terminal")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:L});this.setMenuById(L,"Terminal"),m.append(A)}let P;if(this.shouldDrawMenu("Window")){const L=new v.Menu;P=new v.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:L,role:"window"}),this.setMacWindowMenu(L)}if(P&&m.append(P),this.shouldDrawMenu("Help")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),m.append(A)}m.items&&m.items.length>0?v.Menu.setApplicationMenu(m):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const m=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),p=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const ee=new v.Menu;this.setMenuById(ee,"Preferences"),P=new v.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:ee})}const L=new v.Menu,A=new v.MenuItem({label:d.localize(12,null),role:"services",submenu:L}),W=new v.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),q=new v.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new v.MenuItem({label:d.localize(15,null),role:"unhide"}),re=new v.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:()=>{const ee=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||ee?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),K=[m];K.push(...p),P&&K.push(s(),P),K.push(s(),A,s(),W,q,x,s(),re),K.forEach(ee=>l.append(ee))}shouldDrawMenu(l){if(!k.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,m){m.forEach(p=>{if((0,S.isMenubarMenuItemSeparator)(p))l.append(s());else if((0,S.isMenubarMenuItemSubmenu)(p)){const P=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(p.label),submenu:P});this.setMenu(P,p.submenu.items),l.append(L)}else(0,S.isMenubarMenuItemRecentAction)(p)?l.append(this.createOpenRecentMenuItem(p)):(0,S.isMenubarMenuItemAction)(p)&&(p.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),k.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[p.id]?l.append(new v.MenuItem(this.likeAction(p.id,{label:this.mnemonicLabel(p.label),click:this.fallbackMenuHandlers[p.id]}))):l.append(this.createMenuItem(p.label,p.id,!1,p.checked)):l.append(this.createMenuItem(p.label,p.id,p.enabled!==!1,!!p.checked)):l.append(this.createMenuItem(p.label,p.id,p.enabled!==!1,!!p.checked)))})}setMenuById(l,m){this.menubarMenus&&this.menubarMenus[m]&&this.setMenu(l,this.menubarMenus[m].items)}insertCheckForUpdatesItems(l){const m=this.getUpdateMenuItems();m.length&&(m.forEach(p=>l.append(p)),l.append(s()))}createOpenRecentMenuItem(l){const m=n.URI.revive(l.uri),p=l.id,P=p==="openRecentFile"?{fileUri:m}:p==="openRecentWorkspace"?{workspaceUri:m}:{folderUri:m};return new v.MenuItem(this.likeAction(p,{label:l.label,click:(L,A,W)=>{const q=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:q,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([m])}},!1))}isOptionClick(l){return!!(l&&(!k.isMacintosh&&(l.ctrlKey||l.shiftKey)||k.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,m,p){const P={label:this.mnemonicLabel(l),role:p,enabled:!0};return new v.MenuItem(this.withKeybinding(m,P))}setMacWindowMenu(l){const m=new v.MenuItem({label:d.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),p=new v.MenuItem({label:d.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new v.MenuItem({label:d.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(d.localize(20,null),"workbench.action.switchWindow"),A=[];this.currentEnableNativeTabs&&(A.push(s()),A.push(this.createMenuItem(d.localize(21,null),"workbench.action.newWindowTab")),A.push(this.createRoleMenuItem(d.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.createRoleMenuItem(d.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.createRoleMenuItem(d.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[m,p,s(),L,...A,s(),P].forEach(W=>l.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:d.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:d.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:d.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,m,p,P){const L=this.mnemonicLabel(l),A=typeof m=="function"?m:(K,ee,F)=>{const H=K?K.userSettingsLabel:null;let z=m;Array.isArray(m)&&(z=this.isOptionClick(F)?m[1]:m[0]),H&&F.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:H}):this.runActionInRenderer({type:"commandId",commandId:z})},W=typeof p=="boolean"?p:this.windowsMainService.getWindowCount()>0,q=typeof P=="boolean"?P:!1,x={label:L,click:A,enabled:W};q&&(x.type="checkbox",x.checked=q);let re;return typeof m=="string"?re=m:Array.isArray(m)&&(re=m[0]),k.isMacintosh&&(re==="editor.action.clipboardCutAction"?x.role="cut":re==="editor.action.clipboardCopyAction"?x.role="copy":re==="editor.action.clipboardPasteAction"&&(x.role="paste"),re==="undo"?x.click=this.makeContextAwareClickHandler(A,{inDevTools:K=>K.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?x.click=this.makeContextAwareClickHandler(A,{inDevTools:K=>K.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(A,{inDevTools:K=>K.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(re,x))}makeContextAwareClickHandler(l,m){return(p,P,L)=>{const A=v.BrowserWindow.getFocusedWindow();if(!A)return m.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return m.inDevTools(A.webContents.devToolsWebContents);l(p,P||A,L)}}runActionInRenderer(l){let m=v.BrowserWindow.getFocusedWindow();if(!m){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(m=P.win)}const p=m?this.windowsMainService.getWindowById(m.id):void 0;if(p){if(this.logService.trace("menubar#runActionInRenderer",l),k.isMacintosh&&!this.environmentMainService.isBuilt&&!p.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const P={id:l.commandId,from:"menu"};p.sendWhenReady("vscode:runAction",D.CancellationToken.None,P)}else{const P={userSettingsLabel:l.userSettingsLabel};p.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,m){const p=typeof l=="string"?this.keybindings[l]:void 0;if(p?.label){if(p.isNative!==!1)m.accelerator=p.label,m.userSettingsLabel=p.userSettingsLabel;else if(typeof m.label=="string"){const P=m.label.indexOf("[");P>=0?m.label=`${m.label.substr(0,P)} [${p.label}]`:m.label=`${m.label} [${p.label}]`}}else m.accelerator=void 0;return m}likeAction(l,m,p=!m.accelerator){p&&(m=this.withKeybinding(l,m));const P=m.click;return m.click=(L,A,W)=>{this.reportMenuActionTelemetry(l),P&&P(L,A,W)},m}openUrl(l,m){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(m)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:i})}mnemonicLabel(l){return(0,M.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",a=he([te(0,c.IUpdateService),te(1,w.IConfigurationService),te(2,o.IWindowsMainService),te(3,t.IEnvironmentMainService),te(4,y.ITelemetryService),te(5,u.IWorkspacesHistoryMainService),te(6,b.IStateMainService),te(7,I.ILifecycleMainService),te(8,E.ILogService),te(9,f.INativeHostMainService),te(10,g.IProductService)],a),e.Menubar=a;function s(){return new v.MenuItem({type:"separator"})}}),define(Q[234],J([0,1,5,22,6,233]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let k=class{constructor(d,w,t){this.instantiationService=d,this.lifecycleMainService=w,this.logService=t,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(d,w){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(w,d)}};k=he([te(0,v.IInstantiationService),te(1,R.ILifecycleMainService),te(2,D.ILogService)],k),e.MenubarMainService=k}),define(Q[235],J([0,1,14,31,25,30,23,4,33,42,34,2,10,8,77,3,32,15,13,7,150,51,16,52,24,20,5,22,6,45,21,56,62,38,65,232,99,215,26,100,66,46]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y,c,h,o,u,i,a,s,r,l,m,p,P,L,A,W,q,x,re,K,ee,F,H,z,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function U(O){return(0,F.isWorkspaceIdentifier)(O?.workspace)}function C(O){return(0,F.isSingleFolderWorkspaceIdentifier)(O?.workspace)}let Y=class Ze extends I.Disposable{constructor(T,_,j,X,$,N,Z,ie,oe,le,ne,ae,ue,de,ve){super();this.machineId=T,this.initialUserEnv=_,this.logService=j,this.stateMainService=X,this.environmentMainService=$,this.lifecycleMainService=N,this.backupMainService=Z,this.configurationService=ie,this.workspacesHistoryMainService=oe,this.workspacesManagementMainService=le,this.instantiationService=ne,this.dialogMainService=ae,this.fileService=ue,this.productService=de,this.protocolMainService=ve,this._onDidOpenWindow=this._register(new n.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new n.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new n.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new n.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new ee.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(T=>this._onDidSignalReadyWindow.fire(T.window))),this._register(this.onDidSignalReadyWindow(T=>{if(T.config?.extensionDevelopmentPath||T.config?.extensionTestsPath){const _=new I.DisposableStore;if(_.add(n.Event.any(T.onDidClose,T.onDidDestroy)(()=>_.dispose())),T.config.extensionDevelopmentPath)for(const j of T.config.extensionDevelopmentPath)_.add(this.protocolMainService.addValidFileRoot(h.URI.file(j)));T.config.extensionTestsPath&&_.add(this.protocolMainService.addValidFileRoot(h.URI.file(T.config.extensionTestsPath)))}}))}openEmptyWindow(T,_){let j=this.environmentMainService.args;const X=_?.remoteAuthority||void 0,$=!0,N=_?.forceReuseWindow,Z=!N;return this.open({...T,cli:j,forceEmpty:$,forceNewWindow:Z,forceReuseWindow:N,remoteAuthority:X})}openExistingWindow(T,_){T.focus(),this.handleWaitMarkerFile(_,[T])}open(T){this.logService.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const _=[],j=[],X=[],$=[],N=[];let Z,ie=0;const oe=this.getPathsToOpen(T);this.logService.trace("windowsManager#open pathsToOpen",oe);for(const ue of oe)C(ue)?T.addMode?_.push(ue):j.push(ue):U(ue)?X.push(ue):ue.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ue.remoteAuthority}),Z.filesToOpenOrCreate.push(ue)):ue.backupPath?N.push({backupFolder:(0,S.basename)(ue.backupPath),remoteAuthority:ue.remoteAuthority}):ie++;T.diffMode&&Z&&Z.filesToOpenOrCreate.length>=2&&(Z.filesToDiff=Z.filesToOpenOrCreate.slice(0,2),Z.filesToOpenOrCreate=[]),Z&&T.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?($.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),X.push(...$),N.push(...this.backupMainService.getEmptyWindowBackupPaths())):N.length=0;const{windows:le,filesOpenedInWindow:ne}=this.doOpen(T,X,j,N,ie,Z,_);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${X.length}, foldersToOpen: ${j.length}, emptyToRestore: ${N.length}, emptyToOpen: ${ie})`),le.length>1)if(ne)ne.focus();else{const ue=this.windowsStateHandler.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let de=!0,ve=!0;if(ue){const Ie=le.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),de=!1,ve=!1)}if(de)for(let Ie=le.length-1;Ie>=0;Ie--){const me=le[Ie];if(!(me.openedWorkspace&&$.some(ge=>me.openedWorkspace&&ge.workspace.id===me.openedWorkspace.id)||me.backupPath&&N.some(ge=>me.backupPath&&ge.backupFolder===(0,S.basename)(me.backupPath)))){me.focus(),ve=!1;break}}ve&&le[le.length-1].focus()}const ae=Z&&Z.filesToDiff.length>0;if(!le.some(ue=>ue.isExtensionDevelopmentHost)&&!ae&&!T.noRecentEntry){const ue=[];for(const de of oe)U(de)&&!de.transient?ue.push({label:de.label,workspace:de.workspace,remoteAuthority:de.remoteAuthority}):C(de)?ue.push({label:de.label,folderUri:de.workspace.uri,remoteAuthority:de.remoteAuthority}):de.fileUri&&ue.push({label:de.label,fileUri:de.fileUri,remoteAuthority:de.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ue)}return this.handleWaitMarkerFile(T,le),le}handleWaitMarkerFile(T,_){const j=T.waitMarkerFileURI;T.context===0&&j&&_.length===1&&_[0]&&(async()=>{await _[0].whenClosedOrLoaded;try{await this.fileService.del(j)}catch(X){}})()}doOpen(T,_,j,X,$,N,Z){const ie=[];let oe;function le(me,ge){ie.push(me),ge&&(oe=me,N=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:ae}=this.shouldOpenNewWindow(T);if(!T.initialStartup&&Z.length>0){const me=Z[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(me);ge&&le(this.doAddFoldersToExistingWindow(ge,Z.map(Ee=>Ee.workspace.uri)))}const ue=j.length+_.length+X.length;if(N&&ue===0){const me=N.filesToOpenOrCreate[0]||N.filesToDiff[0],ge=this.getWindows().filter(ke=>N&&ke.remoteAuthority===N.remoteAuthority);let Ee;me?.fileUri&&!ae&&((T.context===4||T.context===0||T.context===1)&&(Ee=(0,K.findWindowOnFile)(ge,me.fileUri,ke=>ke.configPath.scheme===E.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(ge))),Ee?(0,F.isWorkspaceIdentifier)(Ee.openedWorkspace)?_.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,F.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?j.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):le(this.doOpenFilesInExistingWindow(T,Ee,N),!0):le(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow}),!0)}const de=(0,M.distinct)(_,me=>me.workspace.id);if(de.length>0){const me=(0,M.coalesce)(de.map(ge=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(me.length>0){const ge=me[0],Ee=N?.remoteAuthority===ge.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(T,ge,Ee),!!Ee),ne=!0}de.forEach(ge=>{if(me.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===ge.workspace.id))return;const Ee=ge.remoteAuthority,ke=N?.remoteAuthority===Ee?N:void 0;le(this.doOpenFolderOrWorkspace(T,ge,ne,ke),!!ke),ne=!0})}const ve=(0,M.distinct)(j,me=>y.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(ve.length>0){const me=(0,M.coalesce)(ve.map(ge=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(me.length>0){const ge=me[0],Ee=N?.remoteAuthority===ge.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(T,ge,Ee),!!Ee),ne=!0}ve.forEach(ge=>{if(me.some(Ae=>(0,F.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,ge.workspace.uri)))return;const Ee=ge.remoteAuthority,ke=N?.remoteAuthority===Ee?N:void 0;le(this.doOpenFolderOrWorkspace(T,ge,ne,ke),!!ke),ne=!0})}const Ie=(0,M.distinct)(X,me=>me.backupFolder);if(Ie.length>0&&Ie.forEach(me=>{const ge=me.remoteAuthority,Ee=N?.remoteAuthority===ge?N:void 0;le(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:Ee,remoteAuthority:ge,forceNewWindow:!0,forceNewTabbedWindow:T.forceNewTabbedWindow,emptyWindowBackupInfo:me}),!!Ee),ne=!0}),ie.length===0||N){N&&!$&&$++;const me=N?N.remoteAuthority:T.remoteAuthority;for(let ge=0;ge<$;ge++)le(this.doOpenEmpty(T,ne,me,N),!!N),ne=!0}return{windows:(0,M.distinct)(ie),filesOpenedInWindow:oe}}doOpenFilesInExistingWindow(T,_,j){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),_.focus();const X={filesToOpenOrCreate:j?.filesToOpenOrCreate,filesToDiff:j?.filesToDiff,filesToWait:j?.filesToWait,termProgram:T?.userEnv?.TERM_PROGRAM};return _.sendWhenReady("vscode:openFiles",k.CancellationToken.None,X),_}doAddFoldersToExistingWindow(T,_){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),T.focus();const j={foldersToAdd:_};return T.sendWhenReady("vscode:addFolders",k.CancellationToken.None,j),T}doOpenEmpty(T,_,j,X,$){return!_&&!$&&typeof T.contextWindowId=="number"&&($=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:j,forceNewWindow:_,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:X,windowToUse:$})}doOpenFolderOrWorkspace(T,_,j,X,$){return!j&&!$&&typeof T.contextWindowId=="number"&&($=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({workspace:_.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:_.remoteAuthority,forceNewWindow:j,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:X,windowToUse:$})}getPathsToOpen(T){let _,j=!1,X=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(_=this.doExtractPathsFromAPI(T),j=!0):T.forceEmpty?_=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(_=this.doExtractPathsFromCLI(T.cli),_.length===0&&_.push(Object.create(null)),j=!0):(_=this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),X=!0),!T.addMode&&j){const $=_.filter(N=>C(N));if($.length>1){const N=$[0].remoteAuthority;if($.every(Z=>Z.remoteAuthority===N)){const Z=this.workspacesManagementMainService.createUntitledWorkspaceSync($.map(ie=>({uri:ie.workspace.uri})));_.push({workspace:Z,remoteAuthority:N}),_=_.filter(ie=>!C(ie))}}}return T.initialStartup&&!X&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&_.unshift(...this.doGetPathsFromLastSession().filter($=>U($)||C($)||$.backupPath)),_}doExtractPathsFromAPI(T){const _=[],j={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority};for(const X of(0,M.coalesce)(T.urisToOpen||[])){const $=this.resolveOpenable(X,j);if($)$.label=X.label,_.push($);else{const N=this.resourceFromOpenable(X),Z={title:this.productService.nameLong,type:"info",buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(0,null))],defaultId:0,message:N.scheme===E.Schemas.file?(0,o.localize)(1,null):(0,o.localize)(2,null),detail:N.scheme===E.Schemas.file?(0,o.localize)(3,null,(0,t.getPathLabel)(N.fsPath,this.environmentMainService)):(0,o.localize)(4,null,N.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,(0,c.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return _}doExtractPathsFromCLI(T){const _=[],j={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:!1},X=T["folder-uri"];if(X)for(const Z of X){const ie=this.cliArgToUri(Z);if(ie){const oe=this.resolveOpenable({folderUri:ie},j);oe&&_.push(oe)}}const $=T["file-uri"];if($)for(const Z of $){const ie=this.cliArgToUri(Z);if(ie){const oe=this.resolveOpenable((0,F.hasWorkspaceFileExtension)(Z)?{workspaceUri:ie}:{fileUri:ie},j);oe&&_.push(oe)}}const N=T._;for(const Z of N){const ie=j.remoteAuthority?this.doResolvePathRemote(Z,j):this.doResolveFilePath(Z,j);ie&&_.push(ie)}return _}cliArgToUri(T){try{const _=h.URI.parse(T);if(!_.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${T}`);return}return _}catch(_){this.logService.error(`Invalid URI input string: ${T}, ${_.message}`)}}doGetPathsFromLastSession(){const T=this.getRestoreWindowsSetting();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":const _=[];T!=="one"&&_.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&_.push(this.windowsStateHandler.state.lastActiveWindow);const j=[];for(const X of _)if(X.workspace){const $=this.resolveOpenable({workspaceUri:X.workspace.configPath},{remoteAuthority:X.remoteAuthority,rejectTransientWorkspaces:!0});U($)&&j.push($)}else if(X.folderUri){const $=this.resolveOpenable({folderUri:X.folderUri},{remoteAuthority:X.remoteAuthority});C($)&&j.push($)}else T!=="folders"&&X.backupPath&&j.push({backupPath:X.backupPath,remoteAuthority:X.remoteAuthority});return j}}getRestoreWindowsSetting(){let T;return this.lifecycleMainService.wasRestarted?T="all":(T=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")),T}resolveOpenable(T,_=Object.create(null)){let j=this.resourceFromOpenable(T);return j.scheme===E.Schemas.file?((0,x.isFileToOpen)(T)&&(_={..._,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(j.fsPath,_)):this.doResolveRemoteOpenable(T,_)}doResolveRemoteOpenable(T,_){let j=this.resourceFromOpenable(T);const X=(0,W.getRemoteAuthority)(j)||_.remoteAuthority;if(j=(0,y.removeTrailingPathSeparator)((0,y.normalizePath)(j)),(0,x.isFileToOpen)(T)){if(_.gotoLineMode){const{path:$,line:N,column:Z}=(0,d.parseLineAndColumnAware)(j.path);return{fileUri:j.with({path:$}),selection:N?{startLineNumber:N,startColumn:Z||1}:void 0,remoteAuthority:X}}return{fileUri:j,remoteAuthority:X}}else if((0,x.isWorkspaceToOpen)(T))return{workspace:(0,H.getWorkspaceIdentifier)(j),remoteAuthority:X};return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:X}}resourceFromOpenable(T){return(0,x.isWorkspaceToOpen)(T)?T.workspaceUri:(0,x.isFolderToOpen)(T)?T.folderUri:T.fileUri}doResolveFilePath(T,_){let j,X;_.gotoLineMode&&({path:T,line:j,column:X}=(0,d.parseLineAndColumnAware)(T)),T=(0,d.sanitizeFilePath)((0,S.normalize)(T),(0,b.cwd)());try{const $=(0,R.statSync)(T);if($.isFile()){if(!_.forceOpenWorkspaceAsFile){const N=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(T));if(N)return N.transient&&_.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},remoteAuthority:N.remoteAuthority,exists:!0,transient:N.transient}}return{fileUri:h.URI.file(T),selection:j?{startLineNumber:j,startColumn:X||1}:void 0,exists:!0}}else if($.isDirectory())return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(h.URI.file(T),$),exists:!0}}catch($){const N=h.URI.file(T);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),_.ignoreFileNotFound)return{fileUri:N,exists:!1}}}doResolvePathRemote(T,_){const j=T.charCodeAt(0),X=_.remoteAuthority;let $,N;_.gotoLineMode&&({path:T,line:$,column:N}=(0,d.parseLineAndColumnAware)(T)),j!==47&&((0,d.isWindowsDriveLetter)(j)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=(0,d.toSlashes)(T)),T=`/${T}`);const Z=h.URI.from({scheme:E.Schemas.vscodeRemote,authority:X,path:T});if(T.charCodeAt(T.length-1)!==47){if((0,F.hasWorkspaceFileExtension)(T))return _.forceOpenWorkspaceAsFile?{fileUri:Z,selection:$?{startLineNumber:$,startColumn:N||1}:void 0,remoteAuthority:_.remoteAuthority}:{workspace:(0,H.getWorkspaceIdentifier)(Z),remoteAuthority:X};if(_.gotoLineMode||S.posix.basename(T).indexOf(".")!==-1)return{fileUri:Z,selection:$?{startLineNumber:$,startColumn:N||1}:void 0,remoteAuthority:X}}return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:X}}shouldOpenNewWindow(T){const _=this.configurationService.getValue("window"),j=_?.openFoldersInNewWindow||"default",X=_?.openFilesInNewWindow||"off";let $=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(j==="on"||j==="off")&&($=j==="on");let N=!1;return T.forceNewWindow||T.forceReuseWindow?N=!!T.forceNewWindow&&!T.forceReuseWindow:(g.isMacintosh?T.context===1&&(N=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!T.cli.extensionDevelopmentPath&&(X==="on"||X==="off")&&(N=X==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:N}}openExtensionDevelopmentHostWindow(T,_){const j=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),T);if(j)return this.lifecycleMainService.reload(j,_.cli),j.focus(),[j];let X=_.cli["folder-uri"]||[],$=_.cli["file-uri"]||[],N=_.cli._;if(!N.length&&!X.length&&!$.length&&!_.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=le&&(le.workspace||le.folderUri);ne&&(h.URI.isUri(ne)?ne.scheme===E.Schemas.file?N=[ne.fsPath]:X=[ne.toString()]:ne.configPath.scheme===E.Schemas.file?N=[(0,y.originalFSPath)(ne.configPath)]:$=[ne.configPath.toString()])}let Z=_.remoteAuthority;for(const le of T)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=h.URI.parse(le),ae=(0,W.getRemoteAuthority)(ne);ae&&(Z?ae!==Z&&this.logService.error("more than one extension development path authority"):Z=ae)}N=N.filter(le=>{const ne=h.URI.file(le);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,W.getRemoteAuthority)(ne)===Z}),X=X.filter(le=>{const ne=this.cliArgToUri(le);return ne&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,W.getRemoteAuthority)(ne)===Z:!1}),$=$.filter(le=>{const ne=this.cliArgToUri(le);return ne&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,W.getRemoteAuthority)(ne)===Z:!1}),_.cli._=N,_.cli["folder-uri"]=X,_.cli["file-uri"]=$;const ie=!N.length&&!X.length&&!$.length,oe={context:_.context,cli:_.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:_.userEnv,noRecentEntry:!0,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:Z};return this.open(oe)}openInBrowserWindow(T){const _=this.configurationService.getValue("window"),j={...this.environmentMainService.args,...T.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:T.emptyWindowBackupInfo?(0,S.join)(this.environmentMainService.backupHome,T.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:T.remoteAuthority,workspace:T.workspace,userEnv:{...this.initialUserEnv,...T.userEnv},filesToOpenOrCreate:T.filesToOpen?.filesToOpenOrCreate,filesToDiff:T.filesToOpen?.filesToDiff,filesToWait:T.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:P.default,isInitialStartup:T.initialStartup,perfMarks:(0,f.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof _?.zoomLevel=="number"?_.zoomLevel:void 0,legacyWatcher:this.configurationService.getValue("files.legacyWatcher"),experimentalSandboxedFileService:this.configurationService.getValue("files.experimentalSandboxedFileService"),autoDetectHighContrast:_?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let X;if(!T.forceNewWindow&&!T.forceNewTabbedWindow&&(X=T.windowToUse||this.getLastActiveWindow(),X&&X.focus()),X){const $=X.config;!j.extensionDevelopmentPath&&$&&!!$.extensionDevelopmentPath&&(j.extensionDevelopmentPath=$.extensionDevelopmentPath,j.verbose=$.verbose,j["inspect-brk-extensions"]=$["inspect-brk-extensions"],j.debugId=$.debugId,j.extensionEnvironment=$.extensionEnvironment,j["inspect-extensions"]=$["inspect-extensions"],j["extensions-dir"]=$["extensions-dir"])}else{const $=this.windowsStateHandler.getNewWindowState(j);(0,f.mark)("code/willCreateCodeWindow");const N=X=this.instantiationService.createInstance(re.CodeWindow,{state:$,extensionDevelopmentPath:j.extensionDevelopmentPath,isExtensionTestHost:!!j.extensionTestsPath});if((0,f.mark)("code/didCreateCodeWindow"),T.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(N)}Ze.WINDOWS.push(N),this._onDidOpenWindow.fire(N),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(N.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(N)),(0,w.once)(N.onDidClose)(()=>this.onWindowClosed(N)),(0,w.once)(N.onDidDestroy)(()=>this._onDidDestroyWindow.fire(N));const Z=(0,c.assertIsDefined)(N.win?.webContents);Z.removeAllListeners("devtools-reload-page"),Z.on("devtools-reload-page",()=>this.lifecycleMainService.reload(N)),this.lifecycleMainService.registerWindow(N)}return j.windowId=X.id,X.isReady?this.lifecycleMainService.unload(X,4).then($=>{$||this.doOpenInBrowserWindow(X,j,T)}):this.doOpenInBrowserWindow(X,j,T),X}doOpenInBrowserWindow(T,_,j){if(!_.extensionDevelopmentPath)if((0,F.isWorkspaceIdentifier)(_.workspace))_.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:_.workspace,remoteAuthority:_.remoteAuthority});else if((0,F.isSingleFolderWorkspaceIdentifier)(_.workspace))_.backupPath=this.backupMainService.registerFolderBackupSync(_.workspace.uri);else{const X=j.emptyWindowBackupInfo&&j.emptyWindowBackupInfo.backupFolder;_.backupPath=this.backupMainService.registerEmptyWindowBackupSync(X,_.remoteAuthority)}T.load(_)}onWindowClosed(T){const _=Ze.WINDOWS.indexOf(T);Ze.WINDOWS.splice(_,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const T=v.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(T){return this.doGetLastActiveWindow(this.getWindows().filter(_=>_.remoteAuthority===T))}doGetLastActiveWindow(T){const _=Math.max.apply(Math,T.map(j=>j.lastFocusTime));return T.find(j=>j.lastFocusTime===_)}sendToFocused(T,..._){const j=this.getFocusedWindow()||this.getLastActiveWindow();j&&j.sendWhenReady(T,k.CancellationToken.None,..._)}sendToAll(T,_,j){for(const X of this.getWindows())j&&j.indexOf(X.id)>=0||X.sendWhenReady(T,k.CancellationToken.None,_)}getWindows(){return Ze.WINDOWS}getWindowCount(){return Ze.WINDOWS.length}getWindowById(T){const _=this.getWindows().filter(j=>j.id===T);return(0,M.firstOrDefault)(_)}getWindowByWebContents(T){const _=v.BrowserWindow.fromWebContents(T);if(!!_)return this.getWindowById(_.id)}};Y.WINDOWS=[],Y=he([te(2,p.ILogService),te(3,q.IStateMainService),te(4,s.IEnvironmentMainService),te(5,m.ILifecycleMainService),te(6,u.IBackupMainService),te(7,i.IConfigurationService),te(8,z.IWorkspacesHistoryMainService),te(9,B.IWorkspacesManagementMainService),te(10,l.IInstantiationService),te(11,a.IDialogMainService),te(12,r.IFileService),te(13,L.IProductService),te(14,A.IProtocolMainService)],Y),e.WindowsMainService=Y}),define(Q[236],J([0,1,51,36,66,46]),function(V,e,v,R,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let k=class{constructor(d,w,t,I){this.workspacesManagementMainService=d,this.windowsMainService=w,this.workspacesHistoryMainService=t,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,w){const t=this.windowsMainService.getWindowById(d);if(t)return this.workspacesManagementMainService.enterWorkspace(t,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(d,w,t){return this.workspacesManagementMainService.createUntitledWorkspace(w,t)}deleteUntitledWorkspace(d,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(d,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}async getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(d))}async addRecentlyOpened(d,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}async removeRecentlyOpened(d,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}async clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};k=he([te(0,M.IWorkspacesManagementMainService),te(1,R.IWindowsMainService),te(2,D.IWorkspacesHistoryMainService),te(3,v.IBackupMainService)],k),e.WorkspacesMainService=k}),define(Q[237],J([0,1,14,31,25,18,61,17,33,42,39,34,2,10,8,3,15,13,7,28,71,118,35,121,86,228,130,51,219,16,175,157,75,52,218,89,24,54,91,164,182,90,165,20,74,5,76,229,195,101,22,6,177,234,53,21,62,224,78,38,213,98,196,29,198,200,63,41,204,226,230,227,231,97,205,206,207,208,210,36,235,211,26,66,236,46]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y,c,h,o,u,i,a,s,r,l,m,p,P,L,A,W,q,x,re,K,ee,F,H,z,B,U,C,Y,O,T,_,j,X,$,N,Z,ie,oe,le,ne,ae,ue,de,ve,Ie,me,ge,Ee,ke,Ae,We,Oe,Ye,Xe,ct,Ke,xe,et,G,se,ce,we,be,Le,Ce,Fe,Ne,Be,ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ut=class extends E.Disposable{constructor(fe,ye,Se,pe,Pe,De,Me,Re,Te,qe){super();this.mainProcessNodeIpcServer=fe,this.userEnv=ye,this.mainInstantiationService=Se,this.logService=pe,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Re,this.fileService=Te,this.productService=qe,this.configureSession(),this.registerListeners()}configureSession(){const fe=pe=>pe?.startsWith(`${S.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((pe,Pe,De,Me)=>fe(Me.requestingUrl)?De(ye.has(Pe)):De(!1)),v.session.defaultSession.setPermissionCheckHandler((pe,Pe,De,Me)=>fe(Me.requestingUrl)?ye.has(Pe):!1);const Se=v.session.defaultSession;typeof Se.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Se.setCodeCachePath((0,f.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,n.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>(0,n.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,n.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Se,pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",pe)}),v.app.on("activate",(Se,pe)=>{this.logService.trace("app#activate"),pe||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Se,pe)=>{pe.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),pe.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let fe=[],ye;v.app.on("open-file",(Se,pe)=>{this.logService.trace("app#open-file: ",pe),Se.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(pe)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],ye=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",Se=>{const pe=this.windowsMainService?.getWindowByWebContents(Se.sender);let Pe,De;return pe?.config?(Pe=pe.config,De={...process.env,...pe.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De)}),v.ipcMain.handle("vscode:writeNlsFile",(Se,pe,Pe)=>{const De=this.validateNlsPath([pe]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,M.VSBuffer.fromString(Pe))}),v.ipcMain.handle("vscode:readNlsFile",async(Se,...pe)=>{const Pe=this.validateNlsPath(pe);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(fe){let ye;for(const Se of fe)typeof Se=="string"&&(typeof ye!="string"?ye=Se:ye=(0,f.join)(ye,Se));if(!(typeof ye!="string"||!(0,f.isAbsolute)(ye)||!(0,d.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!g.isLinux)))return c.URI.file(ye)}onUnexpectedError(fe){if(fe){const ye={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=this.productService.win32AppUserModelId;g.isWindows&&fe&&v.app.setAppUserModelId(fe);try{g.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.logService.error(Te)}const ye=new a.Server;this.logService.trace("Resolving machine identifier...");const Se=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:pe,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(Se),Me=await this.initServices(Se,pe,Pe);if(this.environmentMainService.driverHandle){const Te=await(0,x.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Te)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(Te=>this.initChannels(Te,ye,De));const Re=Me.invokeFunction(Te=>this.openFirstWindow(Te,ye));Me.invokeFunction(Te=>this.afterWindowOpen(Te,pe)),this.environmentMainService.args.trace&&Me.invokeFunction(Te=>this.stopTracingEventually(Te,Re))}async resolveMachineId(){let fe=this.stateMainService.getItem(ge.machineIdKey);return(!fe||g.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,o.getMachineId)(),this.stateMainService.setItem(ge.machineIdKey,fe)),fe}setupSharedProcess(fe){const ye=this._register(this.mainInstantiationService.createInstance(ae.SharedProcess,fe,this.userEnv)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(Pe,"main")})(),pe=(async()=>(await ye.whenReady(),Se))();return{sharedProcess:ye,sharedProcessReady:pe,sharedProcessClient:Se}}async initServices(fe,ye,Se){const pe=new T.ServiceCollection;switch(process.platform){case"win32":pe.set(We.IUpdateService,new Y.SyncDescriptor(Ke.Win32UpdateService));break;case"linux":g.isLinuxSnap?pe.set(We.IUpdateService,new Y.SyncDescriptor(ct.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(We.IUpdateService,new Y.SyncDescriptor(Xe.LinuxUpdateService));break;case"darwin":pe.set(We.IUpdateService,new Y.SyncDescriptor(Ye.DarwinUpdateService));break}pe.set(be.IWindowsMainService,new Y.SyncDescriptor(Le.WindowsMainService,[fe,this.userEnv])),pe.set(q.IDialogMainService,new Y.SyncDescriptor(q.DialogMainService)),pe.set(X.ILaunchMainService,new Y.SyncDescriptor(X.LaunchMainService)),pe.set(W.IDiagnosticsService,i.ProxyChannel.toService((0,i.getDelayedChannel)(Se.then(De=>De.getChannel("diagnostics"))))),pe.set(_.IIssueMainService,new Y.SyncDescriptor(_.IssueMainService,[this.userEnv])),pe.set(re.IEncryptionMainService,new Y.SyncDescriptor(re.EncryptionMainService,[fe])),pe.set(j.IKeyboardLayoutMainService,new Y.SyncDescriptor(j.KeyboardLayoutMainService)),pe.set(oe.INativeHostMainService,new Y.SyncDescriptor(oe.NativeHostMainService,[ye])),pe.set(ce.IWebviewManagerService,new Y.SyncDescriptor(we.WebviewMainService)),pe.set(Fe.IWorkspacesService,new Y.SyncDescriptor(Be.WorkspacesMainService)),pe.set(ze.IWorkspacesManagementMainService,new Y.SyncDescriptor(ze.WorkspacesManagementMainService)),pe.set(Ne.IWorkspacesHistoryMainService,new Y.SyncDescriptor(Ne.WorkspacesHistoryMainService)),pe.set(ie.IMenubarMainService,new Y.SyncDescriptor(ie.MenubarMainService)),pe.set(H.IExtensionUrlTrustService,new Y.SyncDescriptor(z.ExtensionUrlTrustService)),pe.set(Ie.IStorageMainService,new Y.SyncDescriptor(Ie.StorageMainService)),g.isWindows?pe.set(B.IExternalTerminalMainService,new Y.SyncDescriptor(U.WindowsExternalTerminalService)):g.isMacintosh?pe.set(B.IExternalTerminalMainService,new Y.SyncDescriptor(U.MacExternalTerminalService)):g.isLinux&&pe.set(B.IExternalTerminalMainService,new Y.SyncDescriptor(U.LinuxExternalTerminalService));const Pe=new p.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(pe.set(m.IBackupMainService,Pe),pe.set(xe.IURLService,new Y.SyncDescriptor(G.NativeURLService)),(0,Ae.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,i.getDelayedChannel)(Se.then(Ge=>Ge.getChannel("telemetryAppender"))),Me=new Ee.TelemetryAppenderClient(De),Re=(0,me.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Te=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],qe={appenders:[Me],commonProperties:Re,piiPaths:Te,sendErrorTelemetry:!0};pe.set(ge.ITelemetryService,new Y.SyncDescriptor(ke.TelemetryService,[qe]))}else pe.set(ge.ITelemetryService,Ae.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(pe)}initChannels(fe,ye,Se){const pe=i.ProxyChannel.fromService(fe.get(X.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",pe),ye.registerChannel(L.UserConfigurationFileServiceId,i.ProxyChannel.fromService(new L.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Pe=new Oe.UpdateChannel(fe.get(We.IUpdateService));ye.registerChannel("update",Pe);const De=i.ProxyChannel.fromService(fe.get(_.IIssueMainService));ye.registerChannel("issue",De);const Me=i.ProxyChannel.fromService(fe.get(re.IEncryptionMainService));ye.registerChannel("encryption",Me);const Re=i.ProxyChannel.fromService(fe.get(ue.ISignService));ye.registerChannel("sign",Re);const Te=i.ProxyChannel.fromService(fe.get(j.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",Te),this.nativeHostMainService=fe.get(oe.INativeHostMainService);const qe=i.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",qe),Se.then($e=>$e.registerChannel("nativeHost",qe));const Ge=i.ProxyChannel.fromService(fe.get(Fe.IWorkspacesService));ye.registerChannel("workspaces",Ge);const tt=i.ProxyChannel.fromService(fe.get(ie.IMenubarMainService));ye.registerChannel("menubar",tt);const it=i.ProxyChannel.fromService(fe.get(xe.IURLService));ye.registerChannel("url",it);const ht=i.ProxyChannel.fromService(fe.get(H.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",ht);const Ue=i.ProxyChannel.fromService(fe.get(ce.IWebviewManagerService));ye.registerChannel("webview",Ue);const nt=this._register(new ve.StorageDatabaseChannel(this.logService,fe.get(Ie.IStorageMainService)));ye.registerChannel("storage",nt),Se.then($e=>$e.registerChannel("storage",nt));const rt=i.ProxyChannel.fromService(fe.get(B.IExternalTerminalMainService));ye.registerChannel("externalTerminal",rt);const Qe=new Z.LogLevelChannel(fe.get(N.ILogService));ye.registerChannel("logLevel",Qe),Se.then($e=>$e.registerChannel("logLevel",Qe));const st=new Z.LoggerChannel(fe.get(N.ILoggerService));ye.registerChannel("logger",st),Se.then($e=>$e.registerChannel("logger",st));const ot=new A.ElectronExtensionHostDebugBroadcastChannel(fe.get(be.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",ot)}openFirstWindow(fe,ye){const Se=this.windowsMainService=fe.get(be.IWindowsMainService),pe=fe.get(xe.IURLService),Pe=fe.get(oe.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(_e=>{try{return{uri:c.URI.parse(_e),url:_e}}catch{return}}).filter(_e=>{if(!_e||this.shouldBlockURI(_e.uri))return!1;const Je=this.getWindowOpenableFromProtocolLink(_e.uri);return Je?(De.push(Je),!1):!0}),Re=this,Te=this.environmentMainService,qe=this.productService;pe.registerHandler({async handleURL(_e,Je){if(_e.scheme===qe.urlProtocol&&_e.path==="workspace"&&(_e=_e.with({authority:"file",path:c.URI.parse(_e.query).path,query:""})),Re.shouldBlockURI(_e))return!0;const vt=Re.getWindowOpenableFromProtocolLink(_e);if(vt){const[ft]=Se.open({context:5,cli:{...Te.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(g.isMacintosh&&Se.getWindowCount()===0){const[ft]=Se.open({context:5,cli:{...Te.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ne.getRemoteAuthority)(_e)});return await ft.ready(),pe.open(_e,Je)}return!1}});const Ge=this._register(new Ce.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),tt=new i.StaticRouter(_e=>Ge.getActiveClientId().then(Je=>_e===Je)),it=new et.URLHandlerRouter(tt),ht=ye.getChannel("urlHandler",it);pe.registerHandler(new et.URLHandlerChannelClient(ht)),this._register(new se.ElectronURLListener(Me,pe,Se,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,nt=global.macOpenFiles,rt=(0,ee.isLaunchedFromCli)(process.env)?0:4,Qe=Ue._.length,st=!!Ue["folder-uri"],ot=!!Ue["file-uri"],$e=Ue["skip-add-to-recently-opened"]===!0,dt=Ue.wait&&Ue.waitMarkerFilePath?c.URI.file(Ue.waitMarkerFilePath):void 0,pt=Ue.remote||void 0;return De.length>0?Se.open({context:rt,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!Qe&&!st&&!ot?Se.open({context:rt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:$e,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):nt.length&&!Qe&&!st&&!ot?Se.open({context:1,cli:Ue,urisToOpen:nt.map(_e=>this.getWindowOpenableFromPathSync(_e)),noRecentEntry:$e,waitMarkerFileURI:dt,initialStartup:!0}):Se.open({context:rt,cli:Ue,forceNewWindow:Ue["new-window"]||!Qe&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:$e,waitMarkerFileURI:dt,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(fe){return!!(fe.authority===S.Schemas.file&&g.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,I.mnemonicButtonLabel)((0,l.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,l.localize)(1,null))],defaultId:0,cancelId:1,message:(0,l.localize)(2,null,(0,I.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,l.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===S.Schemas.file){const ye=c.URI.file(fe.fsPath);return(0,Fe.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(fe.authority===S.Schemas.vscodeRemote){const ye=fe.path.indexOf(f.posix.sep,1);if(ye!==-1){const Se=fe.path.substring(1,ye),pe=fe.path.substring(ye),Pe=c.URI.from({scheme:S.Schemas.vscodeRemote,authority:Se,path:pe,query:fe.query,fragment:fe.fragment});return(0,Fe.hasWorkspaceFileExtension)(pe)?{workspaceUri:Pe}:/:[\d]+$/.test(pe)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(fe){try{if((0,R.statSync)(fe).isDirectory())return{folderUri:c.URI.file(fe)};if((0,Fe.hasWorkspaceFileExtension)(fe))return{workspaceUri:c.URI.file(fe)}}catch(ye){}return{fileUri:c.URI.file(fe)}}async afterWindowOpen(fe,ye){this.lifecycleMainService.phase=3;let Se=!1;(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>Se=!0);const pe=fe.get(ge.ITelemetryService);this._register(ye.onDidError(({type:Me,details:Re})=>{let Te;switch(Me){case 1:Te="SharedProcess: detected unresponsive window";break;case 2:Te=`SharedProcess: crashed (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break;case 3:Te=`SharedProcess: failed to load (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break}(0,n.onUnexpectedError)(new Error(Te)),pe.publicLog2("sharedprocesserror",{type:Me,reason:Re?.reason,code:Re?.exitCode,visible:ye.isVisible(),shuttingdown:Se})}));const Pe=this.productService.win32MutexName;if(g.isWindows&&Pe)try{const Me=V.__$__nodeRequire("windows-mutex").Mutex,Re=new Me(Pe);(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(Me){this.logService.error(Me)}v.protocol.registerHttpProtocol(S.Schemas.vscodeRemoteResource,(Me,Re)=>{Re({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=fe.get(We.IUpdateService);(De instanceof Ke.Win32UpdateService||De instanceof Xe.LinuxUpdateService||De instanceof Ye.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env);try{const Re=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,t.stripComments)(Re))["enable-crash-reporter"]===void 0){const Ge=(0,Ae.getTelemetryLevel)(this.configurationService)>=1,tt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ge},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.generateUuid)()}"`,"}"],it=Re.substring(0,Re.length-2).concat(`,
`,tt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(it))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(fe,ye){try{return await(0,F.resolveShellEnv)(this.logService,fe,ye)}catch(Se){this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",(0,k.toErrorMessage)(Se))}return{}}stopTracingEventually(fe,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Se=fe.get(q.IDialogMainService);let pe=!1;const Pe=async Me=>{if(pe)return;pe=!0;const Re=await v.contentTracing.stopRecording((0,b.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):Se.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,l.localize)(4,null),detail:(0,l.localize)(5,null,Re),buttons:[(0,I.mnemonicButtonLabel)((0,l.localize)(6,null))],defaultId:0,noLink:!0},(0,y.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(ye.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};ut=he([te(2,O.IInstantiationService),te(3,N.ILogService),te(4,K.IEnvironmentMainService),te(5,$.ILifecycleMainService),te(6,P.IConfigurationService),te(7,de.IStateMainService),te(8,C.IFileService),te(9,le.IProductService)],ut),e.CodeApplication=ut}),define(Q[242],J([0,1,14,31,30,9,61,17,33,42,34,10,8,77,3,32,27,19,35,57,237,11,16,186,197,24,54,160,20,180,181,74,170,76,22,92,6,178,93,45,21,56,183,95,221,50,223,78,194,38,225,63,64,203]),function(V,e,v,R,D,M,k,n,d,w,t,I,E,S,f,g,b,y,c,h,o,u,i,a,s,r,l,m,p,P,L,A,W,q,x,re,K,ee,F,H,z,B,U,C,Y,O,T,_,j,X,$,N,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(ne){console.error(ne.message),v.app.exit(1)}}async startup(){(0,n.setUnexpectedErrorHandler)(ge=>console.error(ge));const[ne,ae,ue,de,ve,Ie,me]=this.createServices();try{try{await this.initServices(ue,de,ve)}catch(ge){throw this.handleStartupDataDirError(ue,me.nameLong,ge),ge}await ne.invokeFunction(async ge=>{const Ee=ge.get(K.ILogService),ke=ge.get(x.ILifecycleMainService),Ae=ge.get(p.IFileService),We=await this.claimInstance(Ee,ue,ke,ne,me,!0);return y.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Oe=>{Ee.warn(`Error writing main lockfile: ${Oe.stack}`)}),Ie.logger=new F.SpdLogLogger("main",(0,E.join)(ue.logsPath,"main.log"),!0,Ie.getLevel()),(0,w.once)(ke.onWillShutdown)(Oe=>{Ae.dispose(),de.dispose(),Oe.join(y.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),ne.createInstance(o.CodeApplication,We,ae).startup()})}catch(ge){ne.invokeFunction(this.quit,ge)}}createServices(){const ne=new q.ServiceCollection,ae={_serviceBrand:void 0,...H.default};ne.set(z.IProductService,ae);const ue=new r.EnvironmentMainService(this.resolveArgs(),ae),de=this.patchEnvironment(ue);ne.set(r.IEnvironmentMainService,ue);const ve=new re.BufferLogService,Ie=new K.MultiplexLogService([new K.ConsoleMainLogger((0,K.getLogLevel)(ue)),ve]);process.once("exit",()=>Ie.dispose()),ne.set(K.ILogService,Ie);const me=new P.FileService(Ie);ne.set(p.IFileService,me);const ge=new L.DiskFileSystemProvider(Ie);me.registerProvider(I.Schemas.file,ge),ne.set(K.ILoggerService,new ee.LoggerService(Ie,me));const Ee=new a.ConfigurationService(ue.settingsResource,me);ne.set(i.IConfigurationService,Ee),ne.set(x.ILifecycleMainService,new A.SyncDescriptor(x.LifecycleMainService));const ke=new $.StateMainService(ue,Ie,me);return ne.set(X.IStateMainService,ke),ne.set(O.IRequestService,new A.SyncDescriptor(T.RequestMainService)),ne.set(Z.IThemeMainService,new A.SyncDescriptor(Z.ThemeMainService)),ne.set(_.ISignService,new A.SyncDescriptor(j.SignService)),ne.set(C.ITunnelService,new A.SyncDescriptor(Y.TunnelService)),ne.set(B.IProtocolMainService,new A.SyncDescriptor(U.ProtocolMainService)),[new W.InstantiationService(ne,!0),de,ue,Ee,ke,ve,ae]}patchEnvironment(ne){const ae={VSCODE_IPC_HOOK:ne.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const de=process.env[ue];typeof de=="string"&&(ae[ue]=de)}),Object.assign(process.env,ae),ae}initServices(ne,ae,ue){return M.Promises.settled([Promise.all([ne.extensionsPath,ne.codeCachePath,ne.logsPath,ne.globalStorageHome.fsPath,ne.workspaceStorageHome.fsPath,ne.backupHome].map(de=>de?y.Promises.mkdir(de,{recursive:!0}):void 0)),ae.initialize(),ue.init()])}async claimInstance(ne,ae,ue,de,ve,Ie){let me;try{(0,S.mark)("code/willStartMainServer"),me=await(0,h.serve)(ae.mainIPCHandle),(0,S.mark)("code/didStartMainServer"),(0,w.once)(ue.onWillShutdown)(()=>me.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ae,ve.nameLong,ge),ge;let Ee;try{Ee=await(0,h.connect)(ae.mainIPCHandle,"main")}catch(We){if(!Ie||f.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,ve.nameShort),(0,u.localize)(1,null),ve.nameLong),We;try{(0,R.unlinkSync)(ae.mainIPCHandle)}catch(Oe){throw ne.warn("Could not delete obsolete instance handle",Oe),Oe}return this.claimInstance(ne,ae,ue,de,ve,!1)}if(ae.extensionTestsLocationURI&&!ae.debugExtensionHost.break){const We="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ne.error(We),Ee.dispose(),new Error(We)}let ke;!ae.args.wait&&!ae.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,ve.nameShort),(0,u.localize)(3,null),ve.nameLong)},1e4));const Ae=c.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0});if(ae.args.status)return de.invokeFunction(async()=>{const We=new s.DiagnosticsService(N.NullTelemetryService,ve),Oe=await Ae.getMainProcessInfo(),Ye=await Ae.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Xe=await We.getDiagnostics(Oe,Ye);throw console.log(Xe),new n.ExpectedError});throw f.isWindows&&await this.windowsAllowSetForegroundWindow(Ae,ne),ne.trace("Sending env to running instance..."),await Ae.start(ae.args,process.env),Ee.dispose(),ke&&clearTimeout(ke),new n.ExpectedError("Sent env to running instance. Terminating...")}if(ae.args.status)throw ne.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new n.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),me}handleStartupDataDirError(ne,ae,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const de=(0,D.coalesce)([ne.userDataPath,ne.extensionsPath,h.XDG_RUNTIME_DIR]).map(ve=>(0,t.getPathLabel)(ve,ne));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,k.toErrorMessage)(ue),de.join(`
`)),ae)}}showStartupWarningDialog(ne,ae,ue){v.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,t.mnemonicButtonLabel)((0,u.localize)(6,null))],message:ne,detail:ae,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ne,ae){if(f.isWindows){const ue=await ne.getMainProcessId();ae.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((de,ve)=>{V(["windows-foreground-love"],de,ve)})).allowSetForegroundWindow(ue)}catch(de){ae.error(de)}}}quit(ne,ae){const ue=ne.get(K.ILogService),de=ne.get(x.ILifecycleMainService);let ve=0;ae&&(ae.isExpected?ae.message&&ue.trace(ae.message):(ve=1,ae.stack?ue.error(ae.stack):ue.error(`Startup error: ${ae.toString()}`))),de.kill(ve)}resolveArgs(){const ne=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(ne.wait&&!ne.waitMarkerFilePath){const ae=(0,m.createWaitMarkerFile)(ne.verbose);ae&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",ae),ne.waitMarkerFilePath=ae)}return ne}validatePaths(ne){if(ne["open-url"]&&(ne._urls=ne._,ne._=[]),!ne.remote){const ae=this.doValidatePaths(ne._,ne.goto);ne._=ae}return ne}doValidatePaths(ne,ae){const ue=(0,g.cwd)(),de=ne.map(me=>{let ge=String(me),Ee;ae&&(Ee=(0,d.parseLineAndColumnAware)(ge),ge=Ee.path),ge&&(ge=this.preparePath(ue,ge));const ke=(0,d.sanitizeFilePath)(ge,ue),Ae=(0,E.basename)(ke);return Ae&&!(0,d.isValidBasename)(Ae)?null:ae&&Ee?(Ee.path=ke,this.toPath(Ee)):ke}),ve=f.isWindows||f.isMacintosh,Ie=(0,D.distinct)(de,me=>me&&ve?me.toLowerCase():me||"");return(0,D.coalesce)(Ie)}preparePath(ne,ae){return f.isWindows&&(ae=(0,b.rtrim)(ae,'"')),ae=(0,b.trim)((0,b.trim)(ae," "),"	"),f.isWindows&&(ae=(0,E.resolve)(ne,ae),ae=(0,b.rtrim)(ae,".")),ae}toPath(ne){const ae=[ne.path];return typeof ne.line=="number"&&ae.push(String(ne.line)),typeof ne.column=="number"&&ae.push(String(ne.column)),ae.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d817eda05fc021eefb82d24e4d95554c043b6ec7/core/vs/code/electron-main/main.js.map
