/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/network","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/base/node/pfs","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","os","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/base/common/map","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","vs/base/common/performance","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Y=function(V){for(var t=[],C=0,I=V.length;C<I;C++)t[C]=J[V[C]];return t};define(J[56],Y([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function C(I,S){if(!I)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}t.ok=C}),define(J[46],Y([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function C(R){return(L,l,g)=>{let E=null,D=null;if(typeof g.value=="function"?(E="value",D=g.value):typeof g.get=="function"&&(E="get",D=g.get),!D)throw new Error("not supported");g[E]=R(D,l)}}t.createDecorator=C;function I(R,L,l){let g=null,E=null;if(typeof l.value=="function"?(g="value",E=l.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(g="get",E=l.get),!E)throw new Error("not supported");const D=`$memoize$${L}`;l[g]=function(...d){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,d)}),this[D]}}t.memoize=I;function S(R,L,l){return C((g,E)=>{const D=`$debounce$${E}`,d=`$debounce$result$${E}`;return function(...b){this[d]||(this[d]=l?l():void 0),clearTimeout(this[D]),L&&(this[d]=L(this[d],...b),b=[this[d]]),this[D]=setTimeout(()=>{g.apply(this,b),this[d]=l?l():void 0},R)}})}t.debounce=S;function P(R,L,l){return C((g,E)=>{const D=`$throttle$timer$${E}`,d=`$throttle$result$${E}`,b=`$throttle$lastRun$${E}`,u=`$throttle$pending$${E}`;return function(...c){if(this[d]||(this[d]=l?l():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),L&&(this[d]=L(this[d],...c)),this[u])return;const v=this[b]+R;v<=Date.now()?(this[b]=Date.now(),g.apply(this,[this[d]]),this[d]=l?l():void 0):(this[u]=!0,this[D]=setTimeout(()=>{this[u]=!1,this[b]=Date.now(),g.apply(this,[this[d]]),this[d]=l?l():void 0},v-Date.now()))}})}t.throttle=P}),define(J[57],Y([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var C;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(C=t.ScanError||(t.ScanError={}));var I;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(I=t.SyntaxKind||(t.SyntaxKind={}));var S;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(S=t.ParseErrorCode||(t.ParseErrorCode={}));var P;(function(e){e.DEFAULT={allowTrailingComma:!0}})(P=t.ParseOptions||(t.ParseOptions={}));function R(e,i=!1){let n=0,r=e.length,a="",y=0,w=16,O=0;function m(te){let ue=0,ae=0;for(;ue<te;){const B=e.charCodeAt(n);if(B>=48&&B<=57)ae=ae*16+B-48;else if(B>=65&&B<=70)ae=ae*16+B-65+10;else if(B>=97&&B<=102)ae=ae*16+B-97+10;else break;n++,ue++}return ue<te&&(ae=-1),ae}function T(te){n=te,a="",y=0,w=16,O=0}function F(){const te=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&g(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&g(e.charCodeAt(n)))for(n++;n<e.length&&g(e.charCodeAt(n));)n++;else return O=3,e.substring(te,n);let ue=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&g(e.charCodeAt(n))){for(n++;n<e.length&&g(e.charCodeAt(n));)n++;ue=n}else O=3;return e.substring(te,ue)}function z(){let te="",ue=n;for(;;){if(n>=r){te+=e.substring(ue,n),O=2;break}const ae=e.charCodeAt(n);if(ae===34){te+=e.substring(ue,n),n++;break}if(ae===92){if(te+=e.substring(ue,n),n++,n>=r){O=2;break}switch(e.charCodeAt(n++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const ne=m(4);ne>=0?te+=String.fromCharCode(ne):O=4;break;default:O=5}ue=n;continue}if(ae>=0&&ae<=31)if(l(ae)){te+=e.substring(ue,n),O=2;break}else O=6;n++}return te}function K(){if(a="",O=0,y=n,n>=r)return y=r,w=17;let te=e.charCodeAt(n);if(L(te)){do n++,a+=String.fromCharCode(te),te=e.charCodeAt(n);while(L(te));return w=15}if(l(te))return n++,a+=String.fromCharCode(te),te===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),w=14;switch(te){case 123:return n++,w=1;case 125:return n++,w=2;case 91:return n++,w=3;case 93:return n++,w=4;case 58:return n++,w=6;case 44:return n++,w=5;case 34:return n++,a=z(),w=10;case 47:const ue=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<r&&!l(e.charCodeAt(n));)n++;return a=e.substring(ue,n),w=12}if(e.charCodeAt(n+1)===42){n+=2;const ae=r-1;let B=!1;for(;n<ae;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,B=!0;break}n++}return B||(n++,O=1),a=e.substring(ue,n),w=13}return a+=String.fromCharCode(te),n++,w=16;case 45:if(a+=String.fromCharCode(te),n++,n===r||!g(e.charCodeAt(n)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=F(),w=11;default:for(;n<r&&Z(te);)n++,te=e.charCodeAt(n);if(y!==n){switch(a=e.substring(y,n),a){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return a+=String.fromCharCode(te),n++,w=16}}function Z(te){if(L(te)||l(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let te;do te=K();while(te>=12&&te<=15);return te}return{setPosition:T,getPosition:()=>n,scan:i?oe:K,getToken:()=>w,getTokenValue:()=>a,getTokenOffset:()=>y,getTokenLength:()=>n-y,getTokenError:()=>O}}t.createScanner=R;function L(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function g(e){return e>=48&&e<=57}var E;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(E||(E={}));function D(e,i){const n=[],r=new Object;let a;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function O(m,T,F,z){y.value=m,y.offset=T,y.length=F,y.type=z,y.colonOffset=void 0,a=y}try{f(e,{onObjectBegin:(m,T)=>{if(i<=m)throw r;a=void 0,w=i>m,n.push("")},onObjectProperty:(m,T,F)=>{if(i<T||(O(m,T,F,"property"),n[n.length-1]=m,i<=T+F))throw r},onObjectEnd:(m,T)=>{if(i<=m)throw r;a=void 0,n.pop()},onArrayBegin:(m,T)=>{if(i<=m)throw r;a=void 0,n.push(0)},onArrayEnd:(m,T)=>{if(i<=m)throw r;a=void 0,n.pop()},onLiteralValue:(m,T,F)=>{if(i<T||(O(m,T,F,s(m)),i<=T+F))throw r},onSeparator:(m,T,F)=>{if(i<=T)throw r;if(m===":"&&a&&a.type==="property")a.colonOffset=T,w=!1,a=void 0;else if(m===","){const z=n[n.length-1];typeof z=="number"?n[n.length-1]=z+1:(w=!0,n[n.length-1]=""),a=void 0}}})}catch(m){if(m!==r)throw m}return{path:n,previousNode:a,isAtPropertyKey:w,matches:m=>{let T=0;for(let F=0;T<m.length&&F<n.length;F++)if(m[T]===n[F]||m[T]==="*")T++;else if(m[T]!=="**")return!1;return T===m.length}}}t.getLocation=D;function d(e,i=[],n=P.DEFAULT){let r=null,a=[];const y=[];function w(m){Array.isArray(a)?a.push(m):r!==null&&(a[r]=m)}return f(e,{onObjectBegin:()=>{const m={};w(m),y.push(a),a=m,r=null},onObjectProperty:m=>{r=m},onObjectEnd:()=>{a=y.pop()},onArrayBegin:()=>{const m=[];w(m),y.push(a),a=m,r=null},onArrayEnd:()=>{a=y.pop()},onLiteralValue:w,onError:(m,T,F)=>{i.push({error:m,offset:T,length:F})}},n),a[0]}t.parse=d;function b(e,i=[],n=P.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(m){r.type==="property"&&(r.length=m-r.offset,r=r.parent)}function y(m){return r.children.push(m),m}f(e,{onObjectBegin:m=>{r=y({type:"object",offset:m,length:-1,parent:r,children:[]})},onObjectProperty:(m,T,F)=>{r=y({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:m,offset:T,length:F,parent:r})},onObjectEnd:(m,T)=>{r.length=m+T-r.offset,r=r.parent,a(m+T)},onArrayBegin:(m,T)=>{r=y({type:"array",offset:m,length:-1,parent:r,children:[]})},onArrayEnd:(m,T)=>{r.length=m+T-r.offset,r=r.parent,a(m+T)},onLiteralValue:(m,T,F)=>{y({type:s(m),offset:T,length:F,parent:r,value:m}),a(T+F)},onSeparator:(m,T,F)=>{r.type==="property"&&(m===":"?r.colonOffset=T:m===","&&a(T))},onError:(m,T,F)=>{i.push({error:m,offset:T,length:F})}},n);const O=r.children[0];return O&&delete O.parent,O}t.parseTree=b;function u(e,i){if(!e)return;let n=e;for(let r of i)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const y of n.children)if(Array.isArray(y.children)&&y.children[0].value===r){n=y.children[1],a=!0;break}if(!a)return}else{const a=r;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=u;function c(e){if(!e.parent||!e.parent.children)return[];const i=c(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=c;function v(e){switch(e.type){case"array":return e.children.map(v);case"object":const i=Object.create(null);for(let n of e.children){const r=n.children[1];r&&(i[n.children[0].value]=v(r))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=v;function p(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=p;function h(e,i,n=!1){if(p(e,i,n)){const r=e.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=i;a++){const y=h(r[a],i,n);if(y)return y}return e}}t.findNodeAtOffset=h;function f(e,i,n=P.DEFAULT){const r=R(e,!1);function a(H){return H?()=>H(r.getTokenOffset(),r.getTokenLength()):()=>!0}function y(H){return H?ee=>H(ee,r.getTokenOffset(),r.getTokenLength()):()=>!0}const w=a(i.onObjectBegin),O=y(i.onObjectProperty),m=a(i.onObjectEnd),T=a(i.onArrayBegin),F=a(i.onArrayEnd),z=y(i.onLiteralValue),K=y(i.onSeparator),Z=a(i.onComment),oe=y(i.onError),te=n&&n.disallowComments,ue=n&&n.allowTrailingComma;function ae(){for(;;){const H=r.scan();switch(r.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:te||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(H){case 12:case 13:te?B(10):Z();break;case 16:B(1);break;case 15:case 14:break;default:return H}}}function B(H,ee=[],_=[]){if(oe(H),ee.length+_.length>0){let U=r.getToken();for(;U!==17;){if(ee.indexOf(U)!==-1){ae();break}else if(_.indexOf(U)!==-1)break;U=ae()}}}function ne(H){const ee=r.getTokenValue();return H?z(ee):O(ee),ae(),!0}function M(){switch(r.getToken()){case 11:let H=0;try{H=JSON.parse(r.getTokenValue()),typeof H!="number"&&(B(2),H=0)}catch(ee){B(2)}z(H);break;case 7:z(null);break;case 8:z(!0);break;case 9:z(!1);break;default:return!1}return ae(),!0}function A(){return r.getToken()!==10?(B(3,[],[2,5]),!1):(ne(!1),r.getToken()===6?(K(":"),ae(),ie()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function x(){w(),ae();let H=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(H||B(4,[],[]),K(","),ae(),r.getToken()===2&&ue)break}else H&&B(6,[],[]);A()||B(4,[],[2,5]),H=!0}return m(),r.getToken()!==2?B(7,[2],[]):ae(),!0}function G(){T(),ae();let H=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(H||B(4,[],[]),K(","),ae(),r.getToken()===4&&ue)break}else H&&B(6,[],[]);ie()||B(4,[],[4,5]),H=!0}return F(),r.getToken()!==4?B(8,[4],[]):ae(),!0}function ie(){switch(r.getToken()){case 3:return G();case 1:return x();case 10:return ne(!0);default:return M()}}return ae(),r.getToken()===17?n.allowEmptyContent?!0:(B(4,[],[]),!1):ie()?(r.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}t.visit=f;function o(e,i){let n=R(e),r=[],a,y=0,w;do switch(w=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:y!==w&&r.push(e.substring(y,w)),i!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,i)),y=n.getPosition();break}while(a!==17);return r.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function V(S){const P=[];typeof S=="number"&&P.push("code/timeOrigin",S);function R(l){P.push(l,Date.now())}function L(){const l=[];for(let g=0;g<P.length;g+=2)l.push({name:P[g],startTime:P[g+1]});return l}return{mark:R,getMarks:L}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const R of performance.getEntriesByType("mark"))P.push({name:R.name,startTime:Math.round(S+R.startTime)});return P}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function C(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=t()),S.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=C(I))}(),define(J[58],Y([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var C;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(C=t.Source||(t.Source={}));var I;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(I=t.TerminateResponseCode||(t.TerminateResponseCode={}));function S(P,...R){const L=R.reduce((E,D)=>(E[D]=!0,E),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(E=>!L[E]).forEach(E=>{for(let D=0;D<l.length;D++)if(E.search(l[D])!==-1){delete P[E];break}})}t.sanitizeProcessEnvironment=S}),function(V,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var C=t();for(var I in C)(typeof exports=="object"?exports:V)[I]=C[I]}}(typeof self!="undefined"?self:this,function(){return function(V){var t={};function C(I){if(t[I])return t[I].exports;var S=t[I]={i:I,l:!1,exports:{}};return V[I].call(S.exports,S,S.exports,C),S.l=!0,S.exports}return C.m=V,C.c=t,C.d=function(I,S,P){C.o(I,S)||Object.defineProperty(I,S,{enumerable:!0,get:P})},C.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},C.t=function(I,S){if(1&S&&(I=C(I)),8&S||4&S&&typeof I=="object"&&I&&I.__esModule)return I;var P=Object.create(null);if(C.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:I}),2&S&&typeof I!="string")for(var R in I)C.d(P,R,function(L){return I[L]}.bind(null,R));return P},C.n=function(I){var S=I&&I.__esModule?function(){return I.default}:function(){return I};return C.d(S,"a",S),S},C.o=function(I,S){return Object.prototype.hasOwnProperty.call(I,S)},C.p="",C(C.s=0)}([function(V,t,C){(function(I){var S;t=V.exports=_,S=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var k=Array.prototype.slice.call(arguments,0);k.unshift("SEMVER"),console.log.apply(console,k)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var P=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,L=t.re=[],l=t.src=[],g=0,E=g++;l[E]="0|[1-9]\\d*";var D=g++;l[D]="[0-9]+";var d=g++;l[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=g++;l[b]="("+l[E]+")\\.("+l[E]+")\\.("+l[E]+")";var u=g++;l[u]="("+l[D]+")\\.("+l[D]+")\\.("+l[D]+")";var c=g++;l[c]="(?:"+l[E]+"|"+l[d]+")";var v=g++;l[v]="(?:"+l[D]+"|"+l[d]+")";var p=g++;l[p]="(?:-("+l[c]+"(?:\\."+l[c]+")*))";var h=g++;l[h]="(?:-?("+l[v]+"(?:\\."+l[v]+")*))";var f=g++;l[f]="[0-9A-Za-z-]+";var o=g++;l[o]="(?:\\+("+l[f]+"(?:\\."+l[f]+")*))";var s=g++,e="v?"+l[b]+l[p]+"?"+l[o]+"?";l[s]="^"+e+"$";var i="[v=\\s]*"+l[u]+l[h]+"?"+l[o]+"?",n=g++;l[n]="^"+i+"$";var r=g++;l[r]="((?:<|>)?=?)";var a=g++;l[a]=l[D]+"|x|X|\\*";var y=g++;l[y]=l[E]+"|x|X|\\*";var w=g++;l[w]="[v=\\s]*("+l[y]+")(?:\\.("+l[y]+")(?:\\.("+l[y]+")(?:"+l[p]+")?"+l[o]+"?)?)?";var O=g++;l[O]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[h]+")?"+l[o]+"?)?)?";var m=g++;l[m]="^"+l[r]+"\\s*"+l[w]+"$";var T=g++;l[T]="^"+l[r]+"\\s*"+l[O]+"$";var F=g++;l[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var z=g++;l[z]="(?:~>?)";var K=g++;l[K]="(\\s*)"+l[z]+"\\s+",L[K]=new RegExp(l[K],"g");var Z=g++;l[Z]="^"+l[z]+l[w]+"$";var oe=g++;l[oe]="^"+l[z]+l[O]+"$";var te=g++;l[te]="(?:\\^)";var ue=g++;l[ue]="(\\s*)"+l[te]+"\\s+",L[ue]=new RegExp(l[ue],"g");var ae=g++;l[ae]="^"+l[te]+l[w]+"$";var B=g++;l[B]="^"+l[te]+l[O]+"$";var ne=g++;l[ne]="^"+l[r]+"\\s*("+i+")$|^$";var M=g++;l[M]="^"+l[r]+"\\s*("+e+")$|^$";var A=g++;l[A]="(\\s*)"+l[r]+"\\s*("+i+"|"+l[w]+")",L[A]=new RegExp(l[A],"g");var x=g++;l[x]="^\\s*("+l[w]+")\\s+-\\s+("+l[w]+")\\s*$";var G=g++;l[G]="^\\s*("+l[O]+")\\s+-\\s+("+l[O]+")\\s*$";var ie=g++;l[ie]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)S(H,l[H]),L[H]||(L[H]=new RegExp(l[H]));function ee(k,j){if(k instanceof _)return k;if(typeof k!="string"||k.length>P||!(j?L[n]:L[s]).test(k))return null;try{return new _(k,j)}catch($){return null}}function _(k,j){if(k instanceof _){if(k.loose===j)return k;k=k.version}else if(typeof k!="string")throw new TypeError("Invalid Version: "+k);if(k.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof _))return new _(k,j);S("SemVer",k,j),this.loose=j;var $=k.trim().match(j?L[n]:L[s]);if(!$)throw new TypeError("Invalid Version: "+k);if(this.raw=k,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var he=+le;if(he>=0&&he<R)return he}return le}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}t.parse=ee,t.valid=function(k,j){var $=ee(k,j);return $?$.version:null},t.clean=function(k,j){var $=ee(k.trim().replace(/^[=v]+/,""),j);return $?$.version:null},t.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(k){return S("SemVer.compare",this.version,this.loose,k),k instanceof _||(k=new _(k,this.loose)),this.compareMain(k)||this.comparePre(k)},_.prototype.compareMain=function(k){return k instanceof _||(k=new _(k,this.loose)),N(this.major,k.major)||N(this.minor,k.minor)||N(this.patch,k.patch)},_.prototype.comparePre=function(k){if(k instanceof _||(k=new _(k,this.loose)),this.prerelease.length&&!k.prerelease.length)return-1;if(!this.prerelease.length&&k.prerelease.length)return 1;if(!this.prerelease.length&&!k.prerelease.length)return 0;var j=0;do{var $=this.prerelease[j],le=k.prerelease[j];if(S("prerelease compare",j,$,le),$===void 0&&le===void 0)return 0;if(le===void 0)return 1;if($===void 0)return-1;if($!==le)return N($,le)}while(++j)},_.prototype.inc=function(k,j){switch(k){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",j);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",j);break;case"prepatch":this.prerelease.length=0,this.inc("patch",j),this.inc("pre",j);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",j),this.inc("pre",j);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}j&&(this.prerelease[0]===j?isNaN(this.prerelease[1])&&(this.prerelease=[j,0]):this.prerelease=[j,0]);break;default:throw new Error("invalid increment argument: "+k)}return this.format(),this.raw=this.version,this},t.inc=function(k,j,$,le){typeof $=="string"&&(le=$,$=void 0);try{return new _(k,$).inc(j,le).version}catch(he){return null}},t.diff=function(k,j){if(Q(k,j))return null;var $=ee(k),le=ee(j);if($.prerelease.length||le.prerelease.length){for(var he in $)if((he==="major"||he==="minor"||he==="patch")&&$[he]!==le[he])return"pre"+he;return"prerelease"}for(var he in $)if((he==="major"||he==="minor"||he==="patch")&&$[he]!==le[he])return he},t.compareIdentifiers=N;var U=/^[0-9]+$/;function N(k,j){var $=U.test(k),le=U.test(j);return $&&le&&(k=+k,j=+j),$&&!le?-1:le&&!$?1:k<j?-1:k>j?1:0}function q(k,j,$){return new _(k,$).compare(new _(j,$))}function W(k,j,$){return q(k,j,$)>0}function X(k,j,$){return q(k,j,$)<0}function Q(k,j,$){return q(k,j,$)===0}function se(k,j,$){return q(k,j,$)!==0}function re(k,j,$){return q(k,j,$)>=0}function me(k,j,$){return q(k,j,$)<=0}function ye(k,j,$,le){var he;switch(j){case"===":typeof k=="object"&&(k=k.version),typeof $=="object"&&($=$.version),he=k===$;break;case"!==":typeof k=="object"&&(k=k.version),typeof $=="object"&&($=$.version),he=k!==$;break;case"":case"=":case"==":he=Q(k,$,le);break;case"!=":he=se(k,$,le);break;case">":he=W(k,$,le);break;case">=":he=re(k,$,le);break;case"<":he=X(k,$,le);break;case"<=":he=me(k,$,le);break;default:throw new TypeError("Invalid operator: "+j)}return he}function fe(k,j){if(k instanceof fe){if(k.loose===j)return k;k=k.value}if(!(this instanceof fe))return new fe(k,j);S("comparator",k,j),this.loose=j,this.parse(k),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}t.rcompareIdentifiers=function(k,j){return N(j,k)},t.major=function(k,j){return new _(k,j).major},t.minor=function(k,j){return new _(k,j).minor},t.patch=function(k,j){return new _(k,j).patch},t.compare=q,t.compareLoose=function(k,j){return q(k,j,!0)},t.rcompare=function(k,j,$){return q(j,k,$)},t.sort=function(k,j){return k.sort(function($,le){return t.compare($,le,j)})},t.rsort=function(k,j){return k.sort(function($,le){return t.rcompare($,le,j)})},t.gt=W,t.lt=X,t.eq=Q,t.neq=se,t.gte=re,t.lte=me,t.cmp=ye,t.Comparator=fe;var Ie={};function pe(k,j){if(k instanceof pe)return k.loose===j?k:new pe(k.raw,j);if(k instanceof fe)return new pe(k.value,j);if(!(this instanceof pe))return new pe(k,j);if(this.loose=j,this.raw=k,this.set=k.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+k);this.format()}function Ee(k){return!k||k.toLowerCase()==="x"||k==="*"}function Fe(k,j,$,le,he,De,we,Oe,Pe,Ce,Ne,Re,Le){return((j=Ee($)?"":Ee(le)?">="+$+".0.0":Ee(he)?">="+$+"."+le+".0":">="+j)+" "+(Oe=Ee(Pe)?"":Ee(Ce)?"<"+(+Pe+1)+".0.0":Ee(Ne)?"<"+Pe+"."+(+Ce+1)+".0":Re?"<="+Pe+"."+Ce+"."+Ne+"-"+Re:"<="+Oe)).trim()}function Me(k,j){for(var $=0;$<k.length;$++)if(!k[$].test(j))return!1;if(j.prerelease.length){for($=0;$<k.length;$++)if(S(k[$].semver),k[$].semver!==Ie&&k[$].semver.prerelease.length>0){var le=k[$].semver;if(le.major===j.major&&le.minor===j.minor&&le.patch===j.patch)return!0}return!1}return!0}function ze(k,j,$){try{j=new pe(j,$)}catch(le){return!1}return j.test(k)}function xe(k,j,$,le){var he,De,we,Oe,Pe;switch(k=new _(k,le),j=new pe(j,le),$){case">":he=W,De=me,we=X,Oe=">",Pe=">=";break;case"<":he=X,De=re,we=W,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(k,j,le))return!1;for(var Ce=0;Ce<j.set.length;++Ce){var Ne=j.set[Ce],Re=null,Le=null;if(Ne.forEach(function(Ae){Ae.semver===Ie&&(Ae=new fe(">=0.0.0")),Re=Re||Ae,Le=Le||Ae,he(Ae.semver,Re.semver,le)?Re=Ae:we(Ae.semver,Le.semver,le)&&(Le=Ae)}),Re.operator===Oe||Re.operator===Pe||(!Le.operator||Le.operator===Oe)&&De(k,Le.semver)||Le.operator===Pe&&we(k,Le.semver))return!1}return!0}fe.prototype.parse=function(k){var j=this.loose?L[ne]:L[M],$=k.match(j);if(!$)throw new TypeError("Invalid comparator: "+k);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new _($[2],this.loose):this.semver=Ie},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(k){return S("Comparator.test",k,this.loose),this.semver===Ie||(typeof k=="string"&&(k=new _(k,this.loose)),ye(k,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(k,j){if(!(k instanceof fe))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new pe(k.value,j),ze(this.value,$,j);if(k.operator==="")return $=new pe(this.value,j),ze(k.semver,$,j);var le=!(this.operator!==">="&&this.operator!==">"||k.operator!==">="&&k.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||k.operator!=="<="&&k.operator!=="<"),De=this.semver.version===k.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||k.operator!==">="&&k.operator!=="<="),Oe=ye(this.semver,"<",k.semver,j)&&(this.operator===">="||this.operator===">")&&(k.operator==="<="||k.operator==="<"),Pe=ye(this.semver,">",k.semver,j)&&(this.operator==="<="||this.operator==="<")&&(k.operator===">="||k.operator===">");return le||he||De&&we||Oe||Pe},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(k){return k.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(k){var j=this.loose;k=k.trim(),S("range",k,j);var $=j?L[G]:L[x];k=k.replace($,Fe),S("hyphen replace",k),k=k.replace(L[A],"$1$2$3"),S("comparator trim",k,L[A]),k=(k=(k=k.replace(L[K],"$1~")).replace(L[ue],"$1^")).split(/\s+/).join(" ");var le=j?L[ne]:L[M],he=k.split(" ").map(function(De){return function(we,Oe){return S("comp",we),we=function(Pe,Ce){return Pe.trim().split(/\s+/).map(function(Ne){return function(Re,Le){S("caret",Re,Le);var Ae=Le?L[B]:L[ae];return Re.replace(Ae,function(ke,ge,ve,Se,be){var Te;return S("caret",Re,ke,ge,ve,Se,be),Ee(ge)?Te="":Ee(ve)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Te=ge==="0"?">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+".0 <"+(+ge+1)+".0.0":be?(S("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),Te=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+be+" <"+(+ge+1)+".0.0"):(S("no pr"),Te=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+" <"+(+ge+1)+".0.0"),S("caret return",Te),Te})}(Ne,Ce)}).join(" ")}(we,Oe),S("caret",we),we=function(Pe,Ce){return Pe.trim().split(/\s+/).map(function(Ne){return function(Re,Le){var Ae=Le?L[oe]:L[Z];return Re.replace(Ae,function(ke,ge,ve,Se,be){var Te;return S("tilde",Re,ke,ge,ve,Se,be),Ee(ge)?Te="":Ee(ve)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Te=">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":be?(S("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),Te=">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+(+ve+1)+".0"):Te=">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0",S("tilde return",Te),Te})}(Ne,Ce)}).join(" ")}(we,Oe),S("tildes",we),we=function(Pe,Ce){return S("replaceXRanges",Pe,Ce),Pe.split(/\s+/).map(function(Ne){return function(Re,Le){Re=Re.trim();var Ae=Le?L[T]:L[m];return Re.replace(Ae,function(ke,ge,ve,Se,be,Te){S("xRange",Re,ke,ge,ve,Se,be,Te);var je=Ee(ve),Ve=je||Ee(Se),We=Ve||Ee(be);return ge==="="&&We&&(ge=""),je?ke=ge===">"||ge==="<"?"<0.0.0":"*":ge&&We?(Ve&&(Se=0),We&&(be=0),ge===">"?(ge=">=",Ve?(ve=+ve+1,Se=0,be=0):We&&(Se=+Se+1,be=0)):ge==="<="&&(ge="<",Ve?ve=+ve+1:Se=+Se+1),ke=ge+ve+"."+Se+"."+be):Ve?ke=">="+ve+".0.0 <"+(+ve+1)+".0.0":We&&(ke=">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0"),S("xRange return",ke),ke})}(Ne,Ce)}).join(" ")}(we,Oe),S("xrange",we),we=function(Pe,Ce){return S("replaceStars",Pe,Ce),Pe.trim().replace(L[ie],"")}(we,Oe),S("stars",we),we}(De,j)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(De){return!!De.match(le)})),he=he.map(function(De){return new fe(De,j)})},pe.prototype.intersects=function(k,j){if(!(k instanceof pe))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(le){return k.set.some(function(he){return he.every(function(De){return le.intersects(De,j)})})})})},t.toComparators=function(k,j){return new pe(k,j).set.map(function($){return $.map(function(le){return le.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(k){if(!k)return!1;typeof k=="string"&&(k=new _(k,this.loose));for(var j=0;j<this.set.length;j++)if(Me(this.set[j],k))return!0;return!1},t.satisfies=ze,t.maxSatisfying=function(k,j,$){var le=null,he=null;try{var De=new pe(j,$)}catch(we){return null}return k.forEach(function(we){De.test(we)&&(le&&he.compare(we)!==-1||(he=new _(le=we,$)))}),le},t.minSatisfying=function(k,j,$){var le=null,he=null;try{var De=new pe(j,$)}catch(we){return null}return k.forEach(function(we){De.test(we)&&(le&&he.compare(we)!==1||(he=new _(le=we,$)))}),le},t.validRange=function(k,j){try{return new pe(k,j).range||"*"}catch($){return null}},t.ltr=function(k,j,$){return xe(k,j,"<",$)},t.gtr=function(k,j,$){return xe(k,j,">",$)},t.outside=xe,t.prerelease=function(k,j){var $=ee(k,j);return $&&$.prerelease.length?$.prerelease:null},t.intersects=function(k,j,$){return k=new pe(k,$),j=new pe(j,$),k.intersects(j)},t.coerce=function(k){if(k instanceof _)return k;if(typeof k!="string")return null;var j=k.match(L[F]);return j==null?null:ee((j[1]||"0")+"."+(j[2]||"0")+"."+(j[3]||"0"))}}).call(this,C(1))},function(V,t){var C,I,S=V.exports={};function P(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function L(v){if(C===setTimeout)return setTimeout(v,0);if((C===P||!C)&&setTimeout)return C=setTimeout,setTimeout(v,0);try{return C(v,0)}catch(p){try{return C.call(null,v,0)}catch(h){return C.call(this,v,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:P}catch(v){C=P}try{I=typeof clearTimeout=="function"?clearTimeout:R}catch(v){I=R}})();var l,g=[],E=!1,D=-1;function d(){E&&l&&(E=!1,l.length?g=l.concat(g):D=-1,g.length&&b())}function b(){if(!E){var v=L(d);E=!0;for(var p=g.length;p;){for(l=g,g=[];++D<p;)l&&l[D].run();D=-1,p=g.length}l=null,E=!1,function(h){if(I===clearTimeout)return clearTimeout(h);if((I===R||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(h);try{I(h)}catch(f){try{return I.call(null,h)}catch(o){return I.call(this,h)}}}(v)}}function u(v,p){this.fun=v,this.array=p}function c(){}S.nextTick=function(v){var p=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)p[h-1]=arguments[h];g.push(new u(v,p)),g.length!==1||E||L(b)},u.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=c,S.addListener=c,S.once=c,S.off=c,S.removeListener=c,S.removeAllListeners=c,S.emit=c,S.prependListener=c,S.prependOnceListener=c,S.listeners=function(v){return[]},S.binding=function(v){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(v){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(J[38],Y([0,1,9,2]),function(V,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function S(f){const o=f;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=S;function P(f){const o=f;return o?S(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=P;function R(f,o){return new L(f,o)}t.newWriteableStream=R;class L{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,C.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(f,o){const s=[];let e;for(;(e=f.read())!==null;)s.push(e);return o(s)}t.consumeReadable=l;function g(f,o,s){const e=[];let i;for(;(i=f.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return f.read()}}}t.peekReadable=g;function E(f,o){return new Promise((s,e)=>{const i=[];D(f,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):s(void 0)},onEnd:()=>{s(o?o(i):void 0)}})})}t.consumeStream=E;function D(f,o){f.on("error",s=>o.onError(s)),f.on("end",()=>o.onEnd()),f.on("data",s=>o.onData(s))}t.listenStream=D;function d(f,o){return new Promise((s,e)=>{const i=new I.DisposableStore,n=[],r=w=>{if(n.push(w),n.length>o)return i.dispose(),f.pause(),s({stream:f,buffer:n,ended:!1})},a=w=>e(w),y=()=>s({stream:f,buffer:n,ended:!0});i.add((0,I.toDisposable)(()=>f.removeListener("error",a))),f.on("error",a),i.add((0,I.toDisposable)(()=>f.removeListener("end",y))),f.on("end",y),i.add((0,I.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}t.peekStream=d;function b(f,o){const s=R(o);return s.end(f),s}t.toStream=b;function u(){const f=R(()=>{throw new Error("not supported")});return f.end(),f}t.emptyStream=u;function c(f){let o=!1;return{read:()=>o?null:(o=!0,f)}}t.toReadable=c;function v(f,o,s){const e=R(s);return D(f,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=v;function p(f,o,s){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?s([f,i]):f)}}}t.prefixedReadable=p;function h(f,o,s){let e=!1;const i=R(s);return D(o,{onData:n=>e?i.write(n):(e=!0,i.write(s([f,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(f)),i.end()}}),i}t.prefixedStream=h}),define(J[17],Y([0,1,38]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const I=typeof Buffer!="undefined";let S,P;class R{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return I?new R(Buffer.allocUnsafe(r)):new R(new Uint8Array(r))}static wrap(r){return I&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new R(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&I?new R(Buffer.from(r)):(S||(S=new TextEncoder),new R(S.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let O=0,m=r.length;O<m;O++)a+=r[O].byteLength}const y=R.alloc(a);let w=0;for(let O=0,m=r.length;O<m;O++){const T=r[O];y.set(T,w),w+=T.byteLength}return y}toString(){return I?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(r,a){return new R(this.buffer.subarray(r,a))}set(r,a){r instanceof R?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return g(this.buffer,r)}writeUInt32BE(r,a){E(this.buffer,r,a)}readUInt32LE(r){return D(this.buffer,r)}writeUInt32LE(r,a){d(this.buffer,r,a)}readUInt8(r){return b(this.buffer,r)}writeUInt8(r,a){u(this.buffer,r,a)}}t.VSBuffer=R;function L(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}t.readUInt16LE=L;function l(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255}t.writeUInt16LE=l;function g(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}t.readUInt32BE=g;function E(n,r,a){n[a+3]=r,r=r>>>8,n[a+2]=r,r=r>>>8,n[a+1]=r,r=r>>>8,n[a]=r}t.writeUInt32BE=E;function D(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}t.readUInt32LE=D;function d(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255,r=r>>>8,n[a+2]=r&255,r=r>>>8,n[a+3]=r&255}t.writeUInt32LE=d;function b(n,r){return n[r]}t.readUInt8=b;function u(n,r,a){n[a]=r}t.writeUInt8=u;function c(n){return C.consumeReadable(n,r=>R.concat(r))}t.readableToBuffer=c;function v(n){return C.toReadable(n)}t.bufferToReadable=v;function p(n){return C.consumeStream(n,r=>R.concat(r))}t.streamToBuffer=p;async function h(n){return n.ended?R.concat(n.buffer):R.concat([...n.buffer,await p(n.stream)])}t.bufferedStreamToBuffer=h;function f(n){return C.toStream(n,r=>R.concat(r))}t.bufferToStream=f;function o(n){return C.transform(n,{data:r=>typeof r=="string"?R.fromString(r):R.wrap(r)},r=>R.concat(r))}t.streamToBufferReadableStream=o;function s(n){return C.newWriteableStream(r=>R.concat(r),n)}t.newWriteableBufferStream=s;function e(n,r){return C.prefixedReadable(n,r,a=>R.concat(a))}t.prefixedBufferReadable=e;function i(n,r){return C.prefixedStream(n,r,a=>R.concat(a))}t.prefixedBufferStream=i}),define(J[18],Y([0,1,10]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function I(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const v=Array.isArray(c)?[]:{};return Object.keys(c).forEach(p=>{c[p]&&typeof c[p]=="object"?v[p]=I(c[p]):v[p]=c[p]}),v}t.deepClone=I;function S(c){if(!c||typeof c!="object")return c;const v=[c];for(;v.length>0;){const p=v.shift();Object.freeze(p);for(const h in p)if(P.call(p,h)){const f=p[h];typeof f=="object"&&!Object.isFrozen(f)&&v.push(f)}}return c}t.deepFreeze=S;const P=Object.prototype.hasOwnProperty;function R(c,v){return L(c,v,new Set)}t.cloneAndChange=R;function L(c,v,p){if((0,C.isUndefinedOrNull)(c))return c;const h=v(c);if(typeof h!="undefined")return h;if((0,C.isArray)(c)){const f=[];for(const o of c)f.push(L(o,v,p));return f}if((0,C.isObject)(c)){if(p.has(c))throw new Error("Cannot clone recursive data-structure");p.add(c);const f={};for(let o in c)P.call(c,o)&&(f[o]=L(c[o],v,p));return p.delete(c),f}return c}function l(c,v,p=!0){return(0,C.isObject)(c)?((0,C.isObject)(v)&&Object.keys(v).forEach(h=>{h in c?p&&((0,C.isObject)(c[h])&&(0,C.isObject)(v[h])?l(c[h],v[h],p):c[h]=v[h]):c[h]=v[h]}),c):v}t.mixin=l;function g(c,v){if(c===v)return!0;if(c==null||v===null||v===void 0||typeof c!=typeof v||typeof c!="object"||Array.isArray(c)!==Array.isArray(v))return!1;let p,h;if(Array.isArray(c)){if(c.length!==v.length)return!1;for(p=0;p<c.length;p++)if(!g(c[p],v[p]))return!1}else{const f=[];for(h in c)f.push(h);f.sort();const o=[];for(h in v)o.push(h);if(o.sort(),!g(f,o))return!1;for(p=0;p<f.length;p++)if(!g(c[f[p]],v[f[p]]))return!1}return!0}t.equals=g;function E(c){const v=new Set;return JSON.stringify(c,(p,h)=>{if((0,C.isObject)(h)||Array.isArray(h)){if(v.has(h))return"[Circular]";v.add(h)}return h})}t.safeStringify=E;function D(c,v,p){const h=v(c);return typeof h=="undefined"?p:h}t.getOrDefault=D;function d(c,v){const p=Object.create(null);return!c||!v||Object.keys(v).forEach(f=>{const o=c[f],s=v[f];g(o,s)||(p[f]=s)}),p}t.distinct=d;function b(c,v){const p=v.toLowerCase(),h=Object.keys(c).find(f=>f.toLowerCase()===p);return h?c[h]:c[v]}t.getCaseInsensitive=b;function u(c,v){const p=Object.create(null);for(const h of Object.keys(c))v(h,c[h])&&(p[h]=c[h]);return p}t.filter=u}),define(J[59],Y([0,1,7]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function I(g){const E=g;return E&&typeof E.type=="string"&&typeof E.severity=="string"}t.isRemoteConsoleLog=I;function S(g){const E=[];let D;try{const d=JSON.parse(g.arguments),b=d[d.length-1];b&&b.__$stack&&(d.pop(),D=b.__$stack),E.push(...d)}catch(d){E.push("Unable to log remote console arguments",g.arguments)}return{args:E,stack:D}}t.parse=S;function P(g){if(typeof g!="string")return P(S(g).stack);const E=g;if(E){const D=R(E),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(D||"");if(d&&d.length===4)return{uri:C.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}t.getFirstFrame=P;function R(g){if(!g)return g;const E=g.indexOf(`
`);return E===-1?g:g.substring(0,E)}function L(g,E){const{args:D,stack:d}=S(g),b=typeof D[0]=="string"&&D.length===1;let u=R(d);u&&(u=`(${u.trim()})`);let c=[];if(typeof D[0]=="string"?u&&b?c=[`%c[${E}] %c${D[0]} %c${u}`,l("blue"),l(""),l("grey")]:c=[`%c[${E}] %c${D[0]}`,l("blue"),l(""),...D.slice(1)]:c=[`%c[${E}]%`,l("blue"),...D],u&&!b&&c.push(u),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,c)}t.log=L;function l(g){return`color: ${g}`}}),define(J[60],Y([0,1,17,27,7]),function(V,t,C,I,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function P(E){return JSON.stringify(E,l)}t.stringify=P;function R(E){let D=JSON.parse(E);return D=g(D),D}t.parse=R;var L;(function(E){E[E.Uri=1]="Uri",E[E.Regexp=2]="Regexp",E[E.ScmResource=3]="ScmResource",E[E.ScmResourceGroup=4]="ScmResourceGroup",E[E.ScmProvider=5]="ScmProvider",E[E.CommentController=6]="CommentController",E[E.CommentThread=7]="CommentThread",E[E.CommentThreadReply=8]="CommentThreadReply",E[E.CommentNode=9]="CommentNode",E[E.CommentThreadNode=10]="CommentThreadNode",E[E.TimelineActionContext=11]="TimelineActionContext",E[E.NotebookCellActionContext=12]="NotebookCellActionContext",E[E.TestItemContext=13]="TestItemContext"})(L=t.MarshalledId||(t.MarshalledId={}));function l(E,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,I.regExpFlags)(D)}:D}function g(E,D=0){if(!E||D>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return S.URI.revive(E);case 2:return new RegExp(E.source,E.flags)}if(E instanceof C.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let d=0;d<E.length;++d)E[d]=g(E[d],D+1);else for(const d in E)Object.hasOwnProperty.call(E,d)&&(E[d]=g(E[d],D+1))}return E}t.revive=g}),define(J[61],Y([0,1,47,5,8,11,19,27,7]),function(V,t,C,I,S,P,R,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(r,a,y){if(typeof r=="string"&&(r=l.URI.file(r)),y){const O=y.getWorkspaceFolder(r);if(O){const m=y.getWorkspace().folders.length>1;let T;if((0,R.isEqual)(O.uri,r)?T="":T=(0,R.relativePath)(O.uri,r),m){const F=O.name?O.name:(0,R.basename)(O.uri);T=T?F+" \u2022 "+T:F}return T}}if(r.scheme!==I.Schemas.file&&r.scheme!==I.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,C.hasDriveLetter)(r.fsPath))return(0,S.normalize)(D(r.fsPath));let w=(0,S.normalize)(r.fsPath);return!P.isWindows&&a?.userHome&&(w=b(w,a.userHome.fsPath)),w}t.getPathLabel=g;function E(r){if(!r)return;typeof r=="string"&&(r=l.URI.file(r));const a=(0,R.basename)(r)||(r.scheme===I.Schemas.file?r.fsPath:r.path);return P.isWindows&&(0,C.isRootOrDriveLetter)(a)?D(a):a}t.getBaseLabel=E;function D(r){return(0,C.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=D;let d=Object.create(null);function b(r,a){if(P.isWindows||!r||!a)return r;let y=d.original===a?d.normalized:void 0;return y||(y=`${(0,L.rtrim)(a,S.posix.sep)}${S.posix.sep}`,d={original:a,normalized:y}),(P.isLinux?r.startsWith(y):(0,L.startsWithIgnoreCase)(r,y))&&(r=`~/${r.substr(y.length)}`),r}t.tildify=b;function u(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=u;const c="\u2026",v="\\\\",p="~";function h(r,a=S.sep){const y=new Array(r.length);let w=!1;for(let O=0;O<r.length;O++){let m=r[O];if(m===""){y[O]=`.${a}`;continue}if(!m){y[O]=m;continue}w=!0;let T="";m.indexOf(v)===0?(T=m.substr(0,m.indexOf(v)+v.length),m=m.substr(m.indexOf(v)+v.length)):m.indexOf(a)===0?(T=m.substr(0,m.indexOf(a)+a.length),m=m.substr(m.indexOf(a)+a.length)):m.indexOf(p)===0&&(T=m.substr(0,m.indexOf(p)+p.length),m=m.substr(m.indexOf(p)+p.length));const F=m.split(a);for(let z=1;w&&z<=F.length;z++)for(let K=F.length-z;w&&K>=0;K--){w=!1;let Z=F.slice(K,K+z).join(a);for(let oe=0;!w&&oe<r.length;oe++)if(oe!==O&&r[oe]&&r[oe].indexOf(Z)>-1){const te=K+z===F.length,ue=K>0&&r[oe].indexOf(a)>-1?a+Z:Z,ae=r[oe].endsWith(ue);w=!te||ae}if(!w){let oe="";(F[0].endsWith(":")||T!=="")&&(K===1&&(K=0,z++,Z=F[0]+a+Z),K>0&&(oe=F[0]+a),oe=T+oe),K>0&&(oe=oe+c+a),oe=oe+Z,K+z<F.length&&(oe=oe+a+c),y[O]=oe}}w&&(y[O]=m)}return y}t.shorten=h;var f;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function o(r,a=Object.create(null)){const y=[];let w=!1,O="";for(const m of r)if(m==="$"||w&&m==="{")O&&y.push({value:O,type:f.TEXT}),O="",w=!0;else if(m==="}"&&w){const T=a[O];if(typeof T=="string")T.length&&y.push({value:T,type:f.VARIABLE});else if(T){const F=y[y.length-1];(!F||F.type!==f.SEPARATOR)&&y.push({value:T.label,type:f.SEPARATOR})}O="",w=!1}else O+=m;return O&&!w&&y.push({value:O,type:f.TEXT}),y.filter((m,T)=>{if(m.type===f.SEPARATOR){const F=y[T-1],z=y[T+1];return[F,z].every(K=>K&&(K.type===f.VARIABLE||K.type===f.TEXT)&&K.value.length>0)}return!0}).map(m=>m.value).join("")}t.template=o;function s(r,a){return P.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):r.replace(/&&|&/g,y=>y==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(r,a){return P.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):P.isWindows?r.replace(/&&|&/g,y=>y==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(r){const a=r.indexOf("/")!==-1?S.posix:S.win32,y=a.basename(r),w=a.dirname(r);return y.length?{name:y,parentPath:w}:{name:w,parentPath:""}}t.splitName=n}),define(J[62],Y([0,1,126]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class I{constructor(P="utf8"){this.stringDecoder=new C.StringDecoder(P),this.remaining=null}write(P){const R=[],L=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(L.length<1)return R;let l=0,g,E=l;for(;E<L.length;)if(g=L.charCodeAt(E),g===13||g===10){if(R.push(L.substring(l,E)),E++,E<L.length){const D=g;g=L.charCodeAt(E),(D===13&&g===10||D===10&&g===13)&&E++}l=E}else E++;return this.remaining=l<L.length?L.substr(l):null,R}end(){return this.remaining}}t.LineDecoder=I}),define(J[63],Y([0,1,48,8,27,12]),function(V,t,C,I,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function R(E){const D=(0,I.dirname)(E);if(E===D)return E;const d=((0,I.basename)(E)||E).toLowerCase();try{const u=(0,P.readdirSync)(D).filter(c=>c.toLowerCase()===d);if(u.length===1){const c=R(D);if(c)return(0,I.join)(c,u[0])}else if(u.length>1){const c=u.indexOf(d);if(c>=0){const v=R(D);if(v)return(0,I.join)(v,u[c])}}}catch(b){}return null}t.realcaseSync=R;async function L(E){try{return await P.Promises.realpath(E)}catch(D){const d=g(E);return await P.Promises.access(d,C.constants.R_OK),d}}t.realpath=L;function l(E){try{return C.realpathSync(E)}catch(D){const d=g(E);return C.accessSync(d,C.constants.R_OK),d}}t.realpathSync=l;function g(E){return(0,S.rtrim)((0,I.normalize)(E),I.sep)}}),define(J[64],Y([0,1,35,8,12]),function(V,t,C,I,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,R=/^Microsoft.PowerShell_.*/,L=/^Microsoft.PowerShellPreview_.*/;var l;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(l||(l={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class D{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:o=!1}={}){return o?g===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=d({useAlternateBitness:o});if(!e)return null;const i=I.join(e,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(i))return null;let n=-1,r=null;for(const w of await S.Promises.readdir(i)){let O=-1;if(s){const T=w.indexOf("-");if(T<0)continue;const F=w.substring(0,T);if(!P.test(F)||w.substring(T+1)!=="preview")continue;O=parseInt(F,10)}else{if(!P.test(w))continue;O=parseInt(w,10)}if(O<=n)continue;const m=I.join(i,w,"pwsh.exe");!await S.SymlinkSupport.existsFile(m)||(r=m,n=O)}if(!r)return null;const a=e.includes("x86")?" (x86)":"",y=s?" Preview":"";return new D(r,`PowerShell${y}${a}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:L,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const n of await S.Promises.readdir(s))if(e.test(n)){const r=I.join(s,n,"pwsh.exe");return new D(r,i)}return null}function c(){const o=I.join(C.homedir(),".dotnet","tools","pwsh.exe");return new D(o,".NET Core PowerShell Global Tool")}function v(){const o=I.join(process.env.windir,g===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new D(o,"Windows PowerShell",!0)}async function*p(){let o=await b();o&&(yield o),o=await b({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=c(),o&&(yield o),o=await b({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await b({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=v(),o&&(yield o)}async function*h(){for await(const o of p())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=h;async function f(){for await(const o of h())return o;return null}t.getFirstAvailablePowerShellInstallation=f});var de=this&&this.__decorate||function(V,t,C,I){var S=arguments.length,P=S<3?t:I===null?I=Object.getOwnPropertyDescriptor(t,C):I,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(V,t,C,I);else for(var L=V.length-1;L>=0;L--)(R=V[L])&&(P=(S<3?R(P):S>3?R(t,C,P):R(t,C))||P);return S>3&&P&&Object.defineProperty(t,C,P),P};define(J[36],Y([0,1,20,6,17,24,46,9,13,2,60,27,10]),function(V,t,C,I,S,P,R,L,l,g,E,D,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var b;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(b=t.RequestType||(t.RequestType={}));function u(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(c=t.ResponseType||(t.ResponseType={}));function v(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(p||(p={}));class h{constructor(A){this.buffer=A,this.pos=0}read(A){const x=this.buffer.slice(this.pos,this.pos+A);return this.pos+=x.byteLength,x}}class f{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(o||(o={}));function s(M){const A=S.VSBuffer.alloc(4);return A.writeUInt32BE(M,0),A}function e(M){return M.read(4).readUInt32BE(0)}function i(M){const A=S.VSBuffer.alloc(1);return A.writeUInt8(M,0),A}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},r=typeof Buffer!="undefined";function a(M,A){if(typeof A=="undefined")M.write(n.Undefined);else if(typeof A=="string"){const x=S.VSBuffer.fromString(A);M.write(n.String),M.write(s(x.byteLength)),M.write(x)}else if(r&&Buffer.isBuffer(A)){const x=S.VSBuffer.wrap(A);M.write(n.Buffer),M.write(s(x.byteLength)),M.write(x)}else if(A instanceof S.VSBuffer)M.write(n.VSBuffer),M.write(s(A.byteLength)),M.write(A);else if(Array.isArray(A)){M.write(n.Array),M.write(s(A.length));for(const x of A)a(M,x)}else{const x=S.VSBuffer.fromString(JSON.stringify(A));M.write(n.Object),M.write(s(x.byteLength)),M.write(x)}}function y(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read(e(M)).toString();case o.Buffer:return M.read(e(M)).buffer;case o.VSBuffer:return M.read(e(M));case o.Array:{const x=e(M),G=[];for(let ie=0;ie<x;ie++)G.push(y(M));return G}case o.Object:return JSON.parse(M.read(e(M)).toString())}}class w{constructor(A,x,G=null,ie=1e3){this.protocol=A,this.ctx=x,this.logger=G,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:200})}registerChannel(A,x){this.channels.set(A,x),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const x=this.send([A.type]);this.logger&&this.logger.logOutgoing(x,0,1,v(A.type));return}case 201:case 202:case 204:case 203:{const x=this.send([A.type,A.id],A.data);this.logger&&this.logger.logOutgoing(x,A.id,1,v(A.type),A.data);return}}}send(A,x=void 0){const G=new f;return a(G,A),a(G,x),this.sendBuffer(G.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(x){return 0}}onRawMessage(A){const x=new h(A),G=y(x),ie=y(x),H=G[0];switch(H){case 100:return this.logger&&this.logger.logIncoming(A.byteLength,G[1],1,`${u(H)}: ${G[2]}.${G[3]}`,ie),this.onPromise({type:H,id:G[1],channelName:G[2],name:G[3],arg:ie});case 102:return this.logger&&this.logger.logIncoming(A.byteLength,G[1],1,`${u(H)}: ${G[2]}.${G[3]}`,ie),this.onEventListen({type:H,id:G[1],channelName:G[2],name:G[3],arg:ie});case 101:return this.logger&&this.logger.logIncoming(A.byteLength,G[1],1,`${u(H)}`),this.disposeActiveRequest({type:H,id:G[1]});case 103:return this.logger&&this.logger.logIncoming(A.byteLength,G[1],1,`${u(H)}`),this.disposeActiveRequest({type:H,id:G[1]})}}onPromise(A){const x=this.channels.get(A.channelName);if(!x){this.collectPendingRequest(A);return}const G=new P.CancellationTokenSource;let ie;try{ie=x.call(this.ctx,A.name,A.arg,G.token)}catch(_){ie=Promise.reject(_)}const H=A.id;ie.then(_=>{this.sendResponse({id:H,data:_,type:201}),this.activeRequests.delete(A.id)},_=>{_ instanceof Error?this.sendResponse({id:H,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:H,data:_,type:203}),this.activeRequests.delete(A.id)});const ee=(0,g.toDisposable)(()=>G.cancel());this.activeRequests.set(A.id,ee)}onEventListen(A){const x=this.channels.get(A.channelName);if(!x){this.collectPendingRequest(A);return}const G=A.id,H=x.listen(this.ctx,A.name,A.arg)(ee=>this.sendResponse({id:G,data:ee,type:204}));this.activeRequests.set(A.id,H)}disposeActiveRequest(A){const x=this.activeRequests.get(A.id);x&&(x.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let x=this.pendingRequests.get(A.channelName);x||(x=[],this.pendingRequests.set(A.channelName,x));const G=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:A,timeoutTimer:G})}flushPendingRequests(A){const x=this.pendingRequests.get(A);if(x){for(const G of x)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}t.ChannelServer=w;var O;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(O=t.RequestInitiator||(t.RequestInitiator={}));class m{constructor(A,x=null){this.protocol=A,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=x}getChannel(A){const x=this;return{call(G,ie,H){return x.isDisposed?Promise.reject(L.canceled()):x.requestPromise(A,G,ie,H)},listen(G,ie){return x.isDisposed?Promise.reject(L.canceled()):x.requestEvent(A,G,ie)}}}requestPromise(A,x,G,ie=P.CancellationToken.None){const H=this.lastRequestId++,_={id:H,type:100,channelName:A,name:x,arg:G};if(ie.isCancellationRequested)return Promise.reject(L.canceled());let U;return new Promise((q,W)=>{if(ie.isCancellationRequested)return W(L.canceled());const X=()=>{const me=ye=>{switch(ye.type){case 201:this.handlers.delete(H),q(ye.data);break;case 202:this.handlers.delete(H);const fe=new Error(ye.data.message);fe.stack=ye.data.stack,fe.name=ye.data.name,W(fe);break;case 203:this.handlers.delete(H),W(ye.data);break}};this.handlers.set(H,me),this.sendRequest(_)};let Q=null;this.state===p.Idle?X():(Q=(0,I.createCancelablePromise)(me=>this.whenInitialized()),Q.then(()=>{Q=null,X()}));const se=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:H,type:101}),W(L.canceled())},re=ie.onCancellationRequested(se);U=(0,g.combinedDisposable)((0,g.toDisposable)(se),re),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(A,x,G){const ie=this.lastRequestId++,ee={id:ie,type:102,channelName:A,name:x,arg:G};let _=null;const U=new l.Emitter({onFirstListenerAdd:()=>{_=(0,I.createCancelablePromise)(q=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(U),this.sendRequest(ee)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(U),this.sendRequest({id:ie,type:103}))}}),N=q=>U.fire(q.data);return this.handlers.set(ie,N),U.event}sendRequest(A){switch(A.type){case 100:case 102:{const x=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger&&this.logger.logOutgoing(x,A.id,0,`${u(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const x=this.send([A.type,A.id]);this.logger&&this.logger.logOutgoing(x,A.id,0,u(A.type));return}}}send(A,x=void 0){const G=new f;return a(G,A),a(G,x),this.sendBuffer(G.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(x){return 0}}onBuffer(A){const x=new h(A),G=y(x),ie=y(x),H=G[0];switch(H){case 200:return this.logger&&this.logger.logIncoming(A.byteLength,0,0,v(H)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(A.byteLength,G[1],0,v(H),ie),this.onResponse({type:G[0],id:G[1],data:ie})}}onResponse(A){if(A.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const x=this.handlers.get(A.id);x&&x(A)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}de([R.memoize],m.prototype,"onDidInitializePromise",null),t.ChannelClient=m;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:x,onDidClientDisconnect:G})=>{l.Event.once(x.onMessage)(H=>{const ee=new h(H),_=y(ee),U=new w(x,_),N=new m(x);this.channels.forEach((W,X)=>U.registerChannel(X,W));const q={channelServer:U,channelClient:N,ctx:_};this._connections.add(q),this._onDidAddConnection.fire(q),G(()=>{U.dispose(),N.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)})})})}get connections(){const A=[];return this._connections.forEach(x=>A.push(x)),A}getChannel(A,x){const G=this;return{call(ie,H,ee){let _;if((0,d.isFunction)(x)){let N=(0,C.getRandomElement)(G.connections.filter(x));_=N?Promise.resolve(N):l.Event.toPromise(l.Event.filter(G.onDidAddConnection,x))}else _=x.routeCall(G,ie,H);const U=_.then(N=>N.channelClient.getChannel(A));return z(U).call(ie,H,ee)},listen(ie,H){if((0,d.isFunction)(x))return G.getMulticastEvent(A,x,ie,H);const ee=x.routeEvent(G,ie,H).then(_=>_.channelClient.getChannel(A));return z(ee).listen(ie,H)}}}getMulticastEvent(A,x,G,ie){const H=this;let ee=new g.DisposableStore;const _=new l.Emitter({onFirstListenerAdd:()=>{ee=new g.DisposableStore;const U=new l.EventMultiplexer,N=new Map,q=X=>{const se=X.channelClient.getChannel(A).listen(G,ie),re=U.add(se);N.set(X,re)},W=X=>{const Q=N.get(X);!Q||(Q.dispose(),N.delete(X))};H.connections.filter(x).forEach(q),l.Event.filter(H.onDidAddConnection,x)(q,void 0,ee),H.onDidRemoveConnection(W,void 0,ee),U.event(_.fire,_,ee),ee.add(U)},onLastListenerRemove:()=>{ee.dispose()}});return _.event}registerChannel(A,x){this.channels.set(A,x),this._connections.forEach(G=>{G.channelServer.registerChannel(A,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=T;class F{constructor(A,x,G=null){const ie=new f;a(ie,x),A.send(ie.buffer),this.channelClient=new m(A,G),this.channelServer=new w(A,x,G)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,x){this.channelServer.registerChannel(A,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=F;function z(M){return{call(A,x,G){return M.then(ie=>ie.call(A,x,G))},listen(A,x){const G=new l.Relay;return M.then(ie=>G.input=ie.listen(A,x)),G.event}}}t.getDelayedChannel=z;function K(M){let A=!1;return{call(x,G,ie){return A?M.call(x,G,ie):(0,I.timeout)(0).then(()=>A=!0).then(()=>M.call(x,G,ie))},listen(x,G){if(A)return M.listen(x,G);const ie=new l.Relay;return(0,I.timeout)(0).then(()=>A=!0).then(()=>ie.input=M.listen(x,G)),ie.event}}}t.getNextTickChannel=K;class Z{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const x of A.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await l.Event.toPromise(A.onDidAddConnection),await this.route(A)}}t.StaticRouter=Z;var oe;(function(M){function A(H,ee){const _=H,U=ee&&ee.disableMarshalling,N=new Map;for(const q in _)G(q)&&N.set(q,l.Event.buffer(_[q],!0));return new class{listen(q,W,X){const Q=N.get(W);if(Q)return Q;if(ie(W)){const se=_[W];if(typeof se=="function")return se.call(_,X)}throw new Error(`Event not found: ${W}`)}call(q,W,X){const Q=_[W];if(typeof Q=="function"){if(!U&&Array.isArray(X))for(let se=0;se<X.length;se++)X[se]=(0,E.revive)(X[se]);return Q.apply(_,X)}throw new Error(`Method not found: ${W}`)}}}M.fromService=A;function x(H,ee){const _=ee&&ee.disableMarshalling;return new Proxy({},{get(U,N){if(typeof N=="string")return ee?.properties?.has(N)?ee.properties.get(N):ie(N)?function(q){return H.listen(N,q)}:G(N)?H.listen(N):async function(...q){let W;ee&&!(0,d.isUndefinedOrNull)(ee.context)?W=[ee.context,...q]:W=q;const X=await H.call(N,W);return _?X:(0,E.revive)(X)};throw new Error(`Property not found: ${String(N)}`)}})}M.toService=x;function G(H){return H[0]==="o"&&H[1]==="n"&&D.isUpperAsciiLetter(H.charCodeAt(2))}function ie(H){return/^onDynamic/.test(H)&&D.isUpperAsciiLetter(H.charCodeAt(9))}})(oe=t.ProxyChannel||(t.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let A=M.toString();if(A!=="[object Object]")return A}return M}function ae(M){return Array.isArray(M)?M.map(ue):ue(M)}function B(M,A,x,G,ie,H,ee){ee=ae(ee);const _=te[ie],U=_[G%_.length];let N=[`%c[${M}]%c[${String(A).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(H)?(N=N.concat(ee),N.push(")")):N.push(ee),console.log.apply(console,N)}t.logWithColors=B;class ne{constructor(A,x){this._outgoingPrefix=A,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,x,G,ie,H){this._totalOutgoing+=A,B(this._outgoingPrefix,this._totalOutgoing,A,x,G,ie,H)}logIncoming(A,x,G,ie,H){this._totalIncoming+=A,B(this._incomingPrefix,this._totalIncoming,A,x,G,ie,H)}}t.IPCLogger=ne}),define(J[65],Y([0,1,6,13,2,10]),function(V,t,C,I,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var R;(function(D){D[D.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(R=t.StorageHint||(t.StorageHint={}));function L(D){const d=D;return d?.changed instanceof Map||d?.deleted instanceof Set}t.isStorageItemsChangeEvent=L;var l;(function(D){D[D.None=0]="None",D[D.Initialized=1]="Initialized",D[D.Closed=2]="Closed"})(l||(l={}));class g extends S.Disposable{constructor(d,b=Object.create(null)){super();this.database=d,this.options=b,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((b,u)=>this.accept(u,b)),d.deleted?.forEach(b=>this.accept(b,void 0))}accept(d,b){if(this.state===l.Closed)return;let u=!1;(0,P.isUndefinedOrNull)(b)?u=this.cache.delete(d):this.cache.get(d)!==b&&(this.cache.set(d,b),u=!0),u&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,b){const u=this.cache.get(d);return(0,P.isUndefinedOrNull)(u)?b:u}getBoolean(d,b){const u=this.get(d);return(0,P.isUndefinedOrNull)(u)?b:u==="true"}getNumber(d,b){const u=this.get(d);return(0,P.isUndefinedOrNull)(u)?b:parseInt(u,10)}async set(d,b){if(this.state===l.Closed)return;if((0,P.isUndefinedOrNull)(b))return this.delete(d);const u=String(b);if(this.cache.get(d)!==u)return this.cache.set(d,u),this.pendingInserts.set(d,u),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async delete(d){if(!(this.state===l.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((b,u)=>this.items.set(u,b)),d.delete&&d.delete.forEach(b=>this.items.delete(b))}async close(){}}t.InMemoryStorageDatabase=E}),define(J[66],Y([3,4]),function(V,t){return V.create("vs/base/common/date",t)}),define(J[67],Y([0,1,66]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const I=60,S=I*60,P=S*24,R=P*7,L=P*30,l=P*365;function g(D,d){typeof D!="number"&&(D=D.getTime());const b=Math.round((new Date().getTime()-D)/1e3);if(b<-30)return(0,C.localize)(0,null,g(new Date().getTime()+b*1e3,!1));if(b<30)return(0,C.localize)(1,null);let u;return b<I?(u=b,d?u===1?(0,C.localize)(2,null,u):(0,C.localize)(3,null,u):u===1?(0,C.localize)(4,null,u):(0,C.localize)(5,null,u)):b<S?(u=Math.floor(b/I),d?u===1?(0,C.localize)(6,null,u):(0,C.localize)(7,null,u):u===1?(0,C.localize)(8,null,u):(0,C.localize)(9,null,u)):b<P?(u=Math.floor(b/S),d?u===1?(0,C.localize)(10,null,u):(0,C.localize)(11,null,u):u===1?(0,C.localize)(12,null,u):(0,C.localize)(13,null,u)):b<R?(u=Math.floor(b/P),d?u===1?(0,C.localize)(14,null,u):(0,C.localize)(15,null,u):u===1?(0,C.localize)(16,null,u):(0,C.localize)(17,null,u)):b<L?(u=Math.floor(b/R),d?u===1?(0,C.localize)(18,null,u):(0,C.localize)(19,null,u):u===1?(0,C.localize)(20,null,u):(0,C.localize)(21,null,u)):b<l?(u=Math.floor(b/L),d?u===1?(0,C.localize)(22,null,u):(0,C.localize)(23,null,u):u===1?(0,C.localize)(24,null,u):(0,C.localize)(25,null,u)):(u=Math.floor(b/l),d?u===1?(0,C.localize)(26,null,u):(0,C.localize)(27,null,u):u===1?(0,C.localize)(28,null,u):(0,C.localize)(29,null,u))}t.fromNow=g;function E(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=E}),define(J[68],Y([3,4]),function(V,t){return V.create("vs/base/common/errorMessage",t)}),define(J[30],Y([0,1,20,10,68]),function(V,t,C,I,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function P(g,E){return E&&(g.stack||g.stacktrace)?S.localize(0,null,L(g),R(g.stack)||R(g.stacktrace)):L(g)}function R(g){return Array.isArray(g)?g.join(`
`):g}function L(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?S.localize(1,null,g.message):g.message||S.localize(2,null)}function l(g=null,E=!1){if(!g)return S.localize(3,null);if(Array.isArray(g)){const D=C.coalesce(g),d=l(D[0],E);return D.length>1?S.localize(4,null,d,D.length):d}if(I.isString(g))return g;if(g.detail){const D=g.detail;if(D.error)return P(D.error,E);if(D.exception)return P(D.exception,E)}return g.stack?P(g,E):g.message?g.message:S.localize(5,null)}t.toErrorMessage=l}),define(J[69],Y([3,4]),function(V,t){return V.create("vs/base/node/processes",t)}),define(J[49],Y([0,1,39,47,5,18,8,11,28,58,10,62,12,69]),function(V,t,C,I,S,P,R,L,l,g,E,D,d,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return g.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return g.TerminateResponseCode}});function u(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(e,i){if(L.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};i&&(n.cwd=i);const r=C.execFile("taskkill",["/T","/F","/PID",e.pid.toString()],n);return new Promise(a=>{r.once("error",y=>{a({success:!1,error:y})}),r.once("exit",(y,w)=>{a(y===0?{success:!0}:{success:!1,code:y!==null?y:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?u(n.status):1})}else if(L.isLinux||L.isMacintosh)try{const n=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(r=>{C.execFile(n,[e.pid.toString()],{encoding:"utf8",shell:!0},(a,y,w)=>{r(a?{success:!1,error:a}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else e.kill("SIGKILL");return Promise.resolve({success:!0})}function v(e){!e||(delete e.DEBUG,L.isMacintosh&&delete e.DYLD_LIBRARY_PATH,L.isLinux&&delete e.LD_PRELOAD)}t.removeDangerousEnvVariables=v;function p(e=l.env){return e.comspec||"cmd.exe"}t.getWindowsShell=p;class h{constructor(i,n,r,a){if(n!==void 0&&r!==void 0&&a!==void 0)this.cmd=i,this.args=n,this.shell=r,this.options=a;else{const y=i;this.cmd=y.command,this.shell=y.isShellCommand,this.args=y.args.slice(0),this.options=y.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const y=Object.create(null);Object.keys(l.env).forEach(w=>{y[w]=l.env[w]}),Object.keys(this.options.env).forEach(w=>{y[w]=this.options.env[w]}),this.options.env=y}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const n=i.lastIndexOf(R.sep);return n!==-1&&(i=i.substring(n+1)),h.WellKnowCommands[i]?i:"other"}start(i){return L.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(l.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(n=>{let r,a;const y=new Promise((w,O)=>{r=w,a=O});if(n){let w=this.cmd;this.args&&(w=w+" "+this.args.join(" ")),this.childProcess=C.exec(w,this.options,(O,m,T)=>{this.childProcess=null;const F=O;F&&F.killed?a({killed:this.terminateRequested,stdout:m.toString(),stderr:T.toString()}):this.handleExec(r,i,O,m,T)})}else{let w=null;const O=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,r,i,a);const T={terminated:this.terminateRequested};E.isNumber(m)&&(T.cmdCode=m),r(T)};if(this.shell&&L.isWindows){const m=P.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let T=!1,F=!1;const z=[];let K=this.ensureQuotes(this.cmd);z.push(K.value),T=K.quoted,this.args&&this.args.forEach(oe=>{K=this.ensureQuotes(oe),z.push(K.value),F=F&&K.quoted});const Z=["/s","/c"];T?F?Z.push('"'+z.join(" ")+'"'):z.length>1?Z.push('"'+z[0]+'" '+z.slice(1).join(" ")):Z.push('"'+z[0]+'"'):Z.push(z.join(" ")),w=C.spawn(p(),Z,m)}else this.cmd&&(w=C.spawn(this.cmd,this.args,this.options));w&&(this.childProcess=w,this.childProcessPromise=Promise.resolve(w),this.pidResolve&&(this.pidResolve(E.isNumber(w.pid)?w.pid:-1),this.pidResolve=void 0),w.on("error",m=>{this.childProcess=null,a({terminated:this.terminateRequested,error:m})}),w.pid&&(this.childProcess.on("close",O),this.handleSpawn(w,r,i,a,!0)))}return y})}handleClose(i,n,r,a){}ensureQuotes(i){return h.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,c(i,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!L.isWindows)return i(!1);const n=C.spawn(p(),["/s","/c"]);n.on("error",r=>i(!0)),n.on("exit",r=>i(!1))})}}t.AbstractProcess=h,h.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},h.regexp=/^[^"].* .*[^"]/;class f extends h{constructor(i,n,r,a){super(i,n,r,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,n,r,a,y){[a,y].forEach((w,O)=>{const m=new D.LineDecoder;m.write(w).forEach(z=>{n({line:z,source:O===0?0:1})});const F=m.end();F&&n({line:F,source:O===0?0:1})}),i({terminated:this.terminateRequested,error:r})}handleSpawn(i,n,r,a,y){const w=new D.LineDecoder,O=new D.LineDecoder;i.stdout.on("data",m=>{w.write(m).forEach(F=>r({line:F,source:0}))}),i.stderr.on("data",m=>{O.write(m).forEach(F=>r({line:F,source:1}))}),this.stdoutLineDecoder=w,this.stderrLineDecoder=O}handleClose(i,n,r,a){const y=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;y&&r({line:y,source:0});const w=this.stderrLineDecoder?this.stderrLineDecoder.end():null;w&&r({line:w,source:1})}}t.LineProcess=f;function o(e){let i=[],n=!1;const r=function(a){if(n){i.push(a);return}(!e.send(a,w=>{if(w&&console.error(w),n=!1,i.length>0){const O=i.slice(0);i=[],O.forEach(m=>r(m))}})||L.isWindows)&&(n=!0)};return{send:r}}t.createQueuedSender=o;var s;(function(e){async function i(n,r,a){if(R.isAbsolute(n))return n;if(r===void 0&&(r=l.cwd()),R.dirname(n)!=="."||(a===void 0&&E.isString(l.env.PATH)&&(a=l.env.PATH.split(R.delimiter)),a===void 0||a.length===0))return R.join(r,n);async function w(O){if(await d.Promises.exists(O)){let m;try{m=await d.Promises.stat(O)}catch(T){T.message.startsWith("EACCES")&&(m=await d.Promises.lstat(O))}return m?!m.isDirectory():!1}return!1}for(let O of a){let m;if(R.isAbsolute(O)?m=R.join(O,n):m=R.join(r,O,n),await w(m))return m;let T=m+".com";if(await w(T)||(T=m+".exe",await w(T)))return T}return R.join(r,n)}e.findExecutable=i})(s=t.win32||(t.win32={}))}),define(J[70],Y([0,1,35,11,64,49]),function(V,t,C,I,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function R(b,u){return b===1?I.isWindows?D():P.getWindowsShell(u):g(b,u)}t.getSystemShell=R;function L(b,u){return b===1?I.isWindows?d(u):P.getWindowsShell(u):g(b,u)}t.getSystemShellSync=L;let l=null;function g(b,u){if(I.isLinux&&b===2||I.isMacintosh&&b===3)return"/bin/bash";if(!l){let c;if(I.isWindows)c="/bin/bash";else{if(c=u.SHELL,!c)try{c=(0,C.userInfo)().shell}catch(v){}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}l=c}return l}let E=null;async function D(){return E||(E=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),E}function d(b){if(E)return E;const u=I.isWindows&&parseFloat((0,C.release)())>=10,c=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${b.windir}\\${c?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?v:P.getWindowsShell(b)}}),define(J[40],Y([0,1,39,6,17,24,59,9,13,2,18,49,36]),function(V,t,C,I,S,P,R,L,l,g,E,D,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class b extends d.ChannelServer{constructor(v){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch(h){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",p=>S.VSBuffer.wrap(Buffer.from(p,"base64")))},v);process.once("disconnect",()=>this.dispose())}}t.Server=b;class u{constructor(v,p){this.modulePath=v,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new I.Delayer(h),this.child=null,this._client=null}getChannel(v){const p=this;return{call(h,f,o){return p.requestPromise(v,h,f,o)},listen(h,f){return p.requestEvent(v,h,f)}}}requestPromise(v,p,h,f=P.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(L.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(v),s=(0,I.createCancelablePromise)(n=>o.call(p,h,n)),e=f.onCancellationRequested(()=>s.cancel()),i=(0,g.toDisposable)(()=>s.cancel());return this.activeRequests.add(i),s.finally(()=>{e.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(v,p,h){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let f;const o=new l.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(v).listen(p,h)(o.fire,o),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,D.removeDangerousEnvVariables)(p.env),this.child=(0,C.fork)(this.modulePath,v,p);const h=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,R.isRemoteConsoleLog)(r)){(0,R.log)(r,`IPC Library: ${this.options.serverName}`);return}h.fire(S.VSBuffer.wrap(Buffer.from(r,"base64")))});const o=this.options.useQueue?(0,D.createQueuedSender)(this.child):this.child,s=r=>this.child&&this.child.connected&&o.send(r.buffer.toString("base64")),e=h.event,i={send:s,onMessage:e};this._client=new d.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,a)=>{process.removeListener("exit",n),this.activeRequests.forEach(y=>(0,g.dispose)(y)),this.activeRequests.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:a})})}return this._client}getCachedChannel(v){let p=this.channels.get(v);return p||(p=this.client.getChannel(v),this.channels.set(v,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=u}),define(J[71],Y([3,4]),function(V,t){return V.create("vs/base/node/zip",t)}),define(J[72],Y([3,4]),function(V,t){return V.create("vs/platform/configuration/common/configurationRegistry",t)}),define(J[73],Y([3,4]),function(V,t){return V.create("vs/platform/environment/node/shellEnv",t)}),define(J[74],Y([3,4]),function(V,t){return V.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(J[75],Y([3,4]),function(V,t){return V.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(J[76],Y([3,4]),function(V,t){return V.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(J[77],Y([3,4]),function(V,t){return V.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(J[78],Y([3,4]),function(V,t){return V.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(J[79],Y([3,4]),function(V,t){return V.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(J[80],Y([3,4]),function(V,t){return V.create("vs/platform/extensions/common/extensionValidator",t)}),define(J[81],Y([3,4]),function(V,t){return V.create("vs/platform/files/common/fileService",t)}),define(J[82],Y([3,4]),function(V,t){return V.create("vs/platform/files/common/io",t)}),define(J[83],Y([3,4]),function(V,t){return V.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(J[84],Y([3,4]),function(V,t){return V.create("vs/platform/request/common/request",t)}),define(J[85],Y([3,4]),function(V,t){return V.create("vs/platform/telemetry/common/telemetryService",t)}),define(J[86],Y([0,1,67,46,5,8,28,19,7]),function(V,t,C,I,S,P,R,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class g{constructor(c,v,p){this._args=c,this.paths=v,this.productService=p}get appRoot(){return(0,P.dirname)(S.FileAccess.asFileUri("",V).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,P.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,P.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(l.URI.file((0,P.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=R.env.VSCODE_PORTABLE;return c?l.URI.file((0,P.join)(c,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,P.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,P.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,P.resolve)(c):(0,P.normalize)((0,P.join)(S.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,P.resolve)(c):(0,P.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,P.resolve)(c);const v=R.env.VSCODE_EXTENSIONS;if(v)return v;const p=R.env.VSCODE_PORTABLE;return p?(0,P.join)(p,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(v=>/^[^:/?#]+?:\/\//.test(v)?l.URI.parse(v):l.URI.file((0,P.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?l.URI.parse(c):l.URI.file((0,P.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,P.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([I.memoize],g.prototype,"appRoot",null),de([I.memoize],g.prototype,"userHome",null),de([I.memoize],g.prototype,"userDataPath",null),de([I.memoize],g.prototype,"appSettingsHome",null),de([I.memoize],g.prototype,"tmpDir",null),de([I.memoize],g.prototype,"userRoamingDataHome",null),de([I.memoize],g.prototype,"settingsResource",null),de([I.memoize],g.prototype,"userDataSyncHome",null),de([I.memoize],g.prototype,"userDataSyncLogResource",null),de([I.memoize],g.prototype,"sync",null),de([I.memoize],g.prototype,"machineSettingsResource",null),de([I.memoize],g.prototype,"globalStorageHome",null),de([I.memoize],g.prototype,"workspaceStorageHome",null),de([I.memoize],g.prototype,"keybindingsResource",null),de([I.memoize],g.prototype,"keyboardLayoutResource",null),de([I.memoize],g.prototype,"argvResource",null),de([I.memoize],g.prototype,"snippetsHome",null),de([I.memoize],g.prototype,"isExtensionDevelopment",null),de([I.memoize],g.prototype,"untitledWorkspacesHome",null),de([I.memoize],g.prototype,"installSourcePath",null),de([I.memoize],g.prototype,"builtinExtensionsPath",null),de([I.memoize],g.prototype,"extensionsPath",null),de([I.memoize],g.prototype,"extensionDevelopmentLocationURI",null),de([I.memoize],g.prototype,"extensionDevelopmentKind",null),de([I.memoize],g.prototype,"extensionTestsLocationURI",null),de([I.memoize],g.prototype,"debugExtensionHost",null),de([I.memoize],g.prototype,"serviceMachineIdResource",null),de([I.memoize],g.prototype,"telemetryLogResource",null),de([I.memoize],g.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=g;function E(u,c){return b(u["inspect-extensions"],u["inspect-brk-extensions"],5870,c,u.debugId,u.extensionEnvironment)}t.parseExtensionHostPort=E;function D(u,c){return b(u["inspect-search"],u["inspect-brk-search"],5876,c,u.extensionEnvironment)}t.parseSearchPort=D;function d(u,c){return b(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}t.parsePtyHostPort=d;function b(u,c,v,p,h,f){const s=Number(c||u)||(p?null:v),e=s?Boolean(!!c):!1;let i;if(f)try{i=JSON.parse(f)}catch{}return{port:s,break:e,debugId:h,env:i}}}),function(){"use strict";function V(t,C,I,S){function P(L){const l=R(L),g=[l];return t.isAbsolute(l)||g.unshift(S),t.resolve(...g)}function R(L){const l=process.env.VSCODE_PORTABLE;if(l)return t.join(l,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return t.join(g,I);const E=L["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const D=process.env.USERPROFILE;if(typeof D!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=t.join(D,"AppData","Roaming")}break;case"darwin":g=t.join(C.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||t.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(g,I)}return{getUserDataPath:P}}if(typeof define=="function")define(J[87],Y([0,127,35,5,19,28]),function(t,C,I,S,P,R){const L=P.dirname(S.FileAccess.asFileUri("",t)),l=t.__$__nodeRequire(P.joinPath(L,"package.json").fsPath);return V(C,I,l.name,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),C=require("path"),I=require("os");module.exports=V(C,I,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[88],Y([0,1,35,86,87]),function(V,t,C,I,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class P extends I.AbstractNativeEnvironmentService{constructor(L,l){super(L,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,S.getUserDataPath)(L)},l)}}t.NativeEnvironmentService=P}),define(J[89],Y([0,1,18]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const I=/^%([\w\d.-]+)%$/i;function S(P,R){const L=l=>{if(typeof l!="string")return;const g=I.exec(l);if(!g)return;const E=R[g[1]]??l;return typeof E=="string"?E:typeof E.message=="string"?E.message:l};return(0,C.cloneAndChange)(P,L)}t.localizeManifest=S}),define(J[50],Y([0,1,80]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function P(d){return d=d.trim(),d==="*"||I.test(d)}t.isValidVersionStr=P;function R(d){if(!P(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=d.match(I);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}t.parseVersion=R;function L(d){if(!d)return null;let b=d.majorBase,u=d.majorMustEqual,c=d.minorBase,v=d.minorMustEqual,p=d.patchBase,h=d.patchMustEqual;d.hasCaret&&(b===0||(v=!1),h=!1);let f=0;if(d.preRelease){const o=S.exec(d.preRelease);if(o){const[,s,e,i]=o;f=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:b,majorMustEqual:u,minorBase:c,minorMustEqual:v,patchBase:p,patchMustEqual:h,isMinimum:d.hasGreaterEquals,notBefore:f}}t.normalizeVersion=L;function l(d,b,u){let c;typeof d=="string"?c=L(R(d)):c=d;let v;b instanceof Date?v=b.getTime():typeof b=="string"&&(v=new Date(b).getTime());let p;if(typeof u=="string"?p=L(R(u)):p=u,!c||!p)return!1;let h=c.majorBase,f=c.minorBase,o=c.patchBase,s=p.majorBase,e=p.minorBase,i=p.patchBase,n=p.notBefore,r=p.majorMustEqual,a=p.minorMustEqual,y=p.patchMustEqual;return p.isMinimum?h>s?!0:h<s?!1:f>e?!0:f<e||v&&v<n?!1:o>=i:(h===1&&s===0&&(!r||!a||!y)&&(s=1,e=0,i=0,r=!0,a=!1,y=!1),h<s?!1:h>s?!r:f<e?!1:f>e?!a:o<i?!1:o>i?!y:!(v&&v<n))}t.isValidVersion=l;function g(d,b,u,c){return u.isBuiltin||typeof u.main=="undefined"?!0:D(d,b,u.engines.vscode,c)}t.isValidExtensionVersion=g;function E(d,b,u){return d==="*"||D(b,u,d)}t.isEngineValid=E;function D(d,b,u,c=[]){let v=L(R(u));if(!v)return c.push(C.localize(0,null,u)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return c.push(C.localize(1,null,u)),!1}else if(!v.majorMustEqual)return c.push(C.localize(2,null,u)),!1;return l(d,b,v)?!0:(c.push(C.localize(3,null,d,u)),!1)}}),define(J[51],Y([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class C{constructor(S,P=[],R=!1){this.ctor=S,this.staticArguments=P,this.supportsDelayedInstantiation=R}}t.SyncDescriptor=C}),define(J[90],Y([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class C{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}t.Node=C;class I{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let R of this._nodes.values())R.outgoing.size===0&&P.push(R);return P}insertEdge(P,R){const L=this.lookupOrInsertNode(P),l=this.lookupOrInsertNode(R);L.outgoing.set(this._hashFn(R),l),l.incoming.set(this._hashFn(P),L)}removeNode(P){const R=this._hashFn(P);this._nodes.delete(R);for(let L of this._nodes.values())L.outgoing.delete(R),L.incoming.delete(R)}lookupOrInsertNode(P){const R=this._hashFn(P);let L=this._nodes.get(R);return L||(L=new C(P),this._nodes.set(R,L)),L}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[R,L]of this._nodes)P.push(`${R}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,R]of this._nodes){const L=new Set([P]),l=this._findCycle(R,L);if(l)return l}}_findCycle(P,R){for(let[L,l]of P.outgoing){if(R.has(L))return[...R,L].join(" -> ");R.add(L);const g=this._findCycle(l,R);if(g)return g;R.delete(L)}}}t.Graph=I}),define(J[52],Y([0,1,15]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,C.createDecorator)("downloadService")}),define(J[21],Y([0,1,15]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,C.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,C.refineServiceDecorator)(t.IEnvironmentService)}),define(J[22],Y([0,1,5,75,15]),function(V,t,C,I,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var P;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(P=t.TargetPlatform||(t.TargetPlatform={}));function R(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=R;function L(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=L;function l(h,f){switch(h){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=l;function g(h,f){return f==="web"&&!h.includes("web")}t.isNotWebExtensionInWebTargetPlatform=g;function E(h,f,o){return g(f,o)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===o?!0:D(o).includes(h)}t.isTargetPlatformCompatible=E;function D(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=D;function d(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}t.isIExtensionIdentifier=d;var b;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(b=t.SortBy||(t.SortBy={}));var u;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(u=t.SortOrder||(t.SortOrder={}));var c;(function(h){h.Install="install",h.Uninstall="uninstall"})(c=t.StatisticType||(t.StatisticType={}));var v;(function(h){h[h.None=0]="None",h[h.Install=1]="Install",h[h.Update=2]="Update"})(v=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,S.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class p extends Error{constructor(f,o){super(f);this.code=o,this.name=o}}t.ExtensionManagementError=p,t.IExtensionManagementService=(0,S.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,S.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,S.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",V).toString(!0),t.ExtensionsLabel=(0,I.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,I.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,S.createDecorator)("IExtensionManagementCLIService")}),define(J[91],Y([0,1,39,8,73,24,30,9,11,31,70,128,6]),function(V,t,C,I,S,P,R,L,l,g,E,D,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;const b=1e4;let u;async function c(p,h,f){return h["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,D.isLaunchedFromCli)(f)&&!h["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,D.isLaunchedFromCli)(f)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=d.Promises.withAsyncBody(async(o,s)=>{const e=new P.CancellationTokenSource,i=setTimeout(()=>{e.dispose(!0),s(new Error((0,S.localize)(0,null)))},b);try{o(await v(p,e.token))}catch(n){!(0,L.isPromiseCanceledError)(n)&&!e.token.isCancellationRequested?s(new Error((0,S.localize)(1,null,(0,R.toErrorMessage)(n)))):o({})}finally{clearTimeout(i),e.dispose()}})),u)}t.resolveShellEnv=c;async function v(p,h){const f=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",f);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",o);const s=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",i);const n=await(0,E.getSystemShell)(l.OS,i);return p.trace("getUnixShellEnvironment#shell",n),new Promise((r,a)=>{if(h.isCancellationRequested)return a((0,L.canceled)());const y=(0,I.basename)(n);let w,O;/^pwsh(-preview)?$/.test(y)?(w=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,O=["-Login","-Command"]):(w=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,O=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(O),w);const m=(0,C.spawn)(n,[...O,w],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});h.onCancellationRequested(()=>(m.kill(),a((0,L.canceled)()))),m.on("error",z=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(z)),a(z)});const T=[];m.stdout.on("data",z=>T.push(z));const F=[];m.stderr.on("data",z=>F.push(z)),m.on("close",(z,K)=>{const Z=Buffer.concat(T).toString("utf8");p.trace("getUnixShellEnvironment#raw",Z);const oe=Buffer.concat(F).toString("utf8");if(oe.trim()&&p.trace("getUnixShellEnvironment#stderr",oe),z||K)return a(new Error((0,S.localize)(2,null,z,K)));const te=e.exec(Z),ue=te?te[1]:"{}";try{const ae=JSON.parse(ue);f?ae.ELECTRON_RUN_AS_NODE=f:delete ae.ELECTRON_RUN_AS_NODE,o?ae.ELECTRON_NO_ATTACH_CONSOLE=o:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",ae),r(ae)}catch(ae){p.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(ae)),a(ae)}})})}}),define(J[32],Y([0,1,2,11,7,16]),function(V,t,C,I,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=t.WatcherService=void 0;class R extends C.Disposable{}t.WatcherService=R;function L(E){return E.map(D=>({type:D.type,resource:S.URI.file(D.path)}))}t.toFileChanges=L;function l(E){const D=new g;for(const d of E)D.processEvent(d);return D.normalize()}t.normalizeFileChanges=l;class g{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(D){return I.isLinux?D.path:D.path.toLowerCase()}processEvent(D){const d=this.mapPathToChange.get(this.toKey(D));let b=!1;if(d){const u=d.type,c=D.type;d.path!==D.path&&D.type===2?b=!0:u===1&&c===2?(this.mapPathToChange.delete(this.toKey(D)),this.normalized.delete(d)):u===2&&c===1?d.type=0:u===1&&c===0||(d.type=c)}else b=!0;b&&(this.normalized.add(D),this.mapPathToChange.set(this.toKey(D),D))}normalize(){const D=[],d=[];return Array.from(this.normalized).filter(b=>b.type!==2?(D.push(b),!1):!0).sort((b,u)=>b.path.length-u.path.length).filter(b=>d.some(u=>(0,P.isParent)(b.path,u,!I.isLinux))?!1:(d.push(b.path),!0)).concat(D)}}}),define(J[92],Y([0,1,6,2,8,63,12,129,32]),function(V,t,C,I,S,P,R,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class g extends I.Disposable{constructor(D,d,b,u){super();this.path=D,this.onDidFilesChange=d,this.onLogMessage=b,this.verboseLogging=u,this.fileChangesDelayer=this._register(new C.ThrottledDelayer(L.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(D){this.verboseLogging=D}async startWatching(){try{const{stat:D,symbolicLink:d}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(d)try{b=await(0,P.realpath)(b)}catch(u){if(this.onError(u),d.dangling)return}D.isDirectory()?this._register((0,L.watchFolder)(b,(u,c)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(c))})},u=>this.onError(u))):this._register((0,L.watchFile)(b,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(D){D.code!=="ENOENT"&&this.onError(D)}}onFileChange(D){this.fileChangesBuffer.push(D),this.verboseLogging&&this.onVerbose(`${D.type===1?"[ADDED]":D.type===2?"[DELETED]":"[CHANGED]"} ${D.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,l.normalizeFileChanges)(d);if(this.verboseLogging)for(const u of b)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);b.length>0&&this.onDidFilesChange(b)})}onError(D){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${D}`})}onVerbose(D){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${D}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=g}),define(J[93],Y([0,1,5,36,40,32]),function(V,t,C,I,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R extends P.WatcherService{constructor(l,g,E,D){super();this.requests=l,this.onDidFilesChange=g,this.onLogMessage=E,this.verboseLogging=D,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new S.Client(C.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=R.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=I.ProxyChannel.toService((0,I.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.watch(this.requests)}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}async watch(l){this.requests=l,await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=R,R.MAX_RESTARTS=5}),define(J[94],Y([0,1,5,36,40,32]),function(V,t,C,I,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R extends P.WatcherService{constructor(l,g,E,D){super();this.requests=l,this.onDidFilesChange=g,this.onLogMessage=E,this.verboseLogging=D,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new S.Client(C.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=R.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=I.ProxyChannel.toService((0,I.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.watch(this.requests)}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${l}`})}async watch(l){this.requests=l,await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=R,R.MAX_RESTARTS=5}),define(J[95],Y([0,1,5,36,40,32]),function(V,t,C,I,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R extends P.WatcherService{constructor(l,g,E,D,d={}){super();this.requests=l,this.onDidFilesChange=g,this.onLogMessage=E,this.verboseLogging=D,this.watcherOptions=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new S.Client(C.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherServiceChokidar"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=R.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=I.ProxyChannel.toService((0,I.getNextTickChannel)(l.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.watch(this.requests)}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${l}`})}async watch(l){this.requests=l,await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=R,R.MAX_RESTARTS=5}),define(J[53],Y([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class C{constructor(...S){this._entries=new Map;for(let[P,R]of S)this.set(P,R)}set(S,P){const R=this._entries.get(S);return this._entries.set(S,P),R}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}t.ServiceCollection=C}),define(J[96],Y([0,1,6,9,51,90,15,53]),function(V,t,C,I,S,P,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const l=!1;class g extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class E{constructor(u=new L.ServiceCollection,c=!1,v){this._activeInstantiations=new Set,this._services=u,this._strict=c,this._parent=v,this._services.set(R.IInstantiationService,this)}createChild(u){return new E(u,this._strict,this)}invokeFunction(u,...c){let v=d.traceInvocation(u),p=!1;try{return u({get:(f,o)=>{if(p)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(f,v);if(!s&&o!==R.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return s}},...c)}finally{p=!0,v.stop()}}createInstance(u,...c){let v,p;return u instanceof S.SyncDescriptor?(v=d.traceCreation(u.ctor),p=this._createInstance(u.ctor,u.staticArguments.concat(c),v)):(v=d.traceCreation(u),p=this._createInstance(u,c,v)),v.stop(),p}_createInstance(u,c=[],v){let p=R._util.getServiceDependencies(u).sort((o,s)=>o.index-s.index),h=[];for(const o of p){let s=this._getOrCreateServiceInstance(o.id,v);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);h.push(s)}let f=p.length>0?p[0].index:c.length;if(c.length!==f){console.warn(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${c.length} static arguments`);let o=f-c.length;o>0?c=c.concat(new Array(o)):c=c.slice(0,f)}return new u(...[...c,...h])}_setServiceInstance(u,c){if(this._services.get(u)instanceof S.SyncDescriptor)this._services.set(u,c);else if(this._parent)this._parent._setServiceInstance(u,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let c=this._services.get(u);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):c}_getOrCreateServiceInstance(u,c){let v=this._getServiceInstanceOrDescriptor(u);return v instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,v,c.branch(u,!0)):(c.branch(u,!1),v)}_safeCreateAndCacheServiceInstance(u,c,v){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,c,v)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,c,v){const p=new P.Graph(o=>o.id.toString());let h=0;const f=[{id:u,desc:c,_trace:v}];for(;f.length;){const o=f.pop();if(p.lookupOrInsertNode(o),h++>1e3)throw new g(p);for(let s of R._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`),e instanceof S.SyncDescriptor){const i={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};p.insertEdge(o,i),f.push(i)}}}for(;;){const o=p.roots();if(o.length===0){if(!p.isEmpty())throw new g(p);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof S.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}p.removeNode(s)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,c,v=[],p,h){if(this._services.get(u)instanceof S.SyncDescriptor)return this._createServiceInstance(c,v,p,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,c,v,p,h);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(u,c=[],v,p){if(v){const h=new C.IdleValue(()=>this._createInstance(u,c,p));return new Proxy(Object.create(null),{get(f,o){if(o in f)return f[o];let s=h.value,e=s[o];return typeof e!="function"||(e=e.bind(s),f[o]=e),e},set(f,o,s){return h.value[o]=s,!0}})}else return this._createInstance(u,c,p)}}t.InstantiationService=E;var D;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(D||(D={}));class d{constructor(u,c){this.type=u,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return l?new d(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(u){return l?new d(0,u.name):d._None}branch(u,c){let v=new d(2,u.toString());return this._dep.push([u,c,v]),v}stop(){let u=Date.now()-this._start;d._totals+=u;let c=!1;function v(h,f){let o=[],s=new Array(h+1).join("	");for(const[e,i,n]of f._dep)if(i&&n){c=!0,o.push(`${s}CREATES -> ${e}`);let r=v(h+1,n);r&&o.push(r)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(u>2||c)&&console.log(p.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(J[54],Y([0,1,15]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,C.createDecorator)("localizationsService");function I(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const P of S.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}t.isValidLocalization=I}),define(J[14],Y([0,1,30,13,2,11,15]),function(V,t,C,I,S,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,R.createDecorator)("logService"),t.ILoggerService=(0,R.createDecorator)("loggerService");function L(){return new Date().toISOString()}var l;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;class g extends S.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=g;class E extends g{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(l.Trace)&&this.log(l.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(l.Debug)&&this.log(l.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(l.Info)&&this.log(l.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(l.Warning)&&this.log(l.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(l.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(l.Error,this.format(n))}else this.log(l.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(l.Critical)&&this.log(l.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let r=e[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}i+=(n>0?" ":"")+r}return i}}t.AbstractMessageLogger=E;class D extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!P.isWindows}trace(e,...i){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}debug(e,...i){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}info(e,...i){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}warn(e,...i){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,e,...i):console.warn(`[main ${L()}]`,e,...i))}error(e,...i){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}critical(e,...i){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=D;class d extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=d;class b extends g{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,C.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.AdapterLogger=b;class u extends g{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=u;class c extends S.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=c;class v extends S.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?l.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=v;class p{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=p;function h(s){if(s.verbose)return l.Trace;if(typeof s.logLevel=="string"){const e=f(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=h;function f(s){switch(s){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}t.parseLogLevel=f;function o(s){switch(s){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}t.LogLevelToString=o});var ce=this&&this.__param||function(V,t){return function(C,I){t(C,I,V)}};define(J[97],Y([0,1,39,6,30,13,2,5,8,12,21,14]),function(V,t,C,I,S,P,R,L,l,g,E,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let d=class extends R.Disposable{constructor(u,c){super();this.environmentService=u,this.logService=c,this.processesLimiter=new I.Limiter(5)}async postUninstall(u){const c=this.parseScript(u,"uninstall");return c&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(c.script,"uninstall",c.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${v}`)))),g.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(u,c){const v=`vscode:${c}`;if(u.location.scheme===L.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[v]=="string"){const p=u.manifest.scripts[v].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${v} should be a node script`),null):{script:(0,l.join)(u.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(u,c,v,p,h){return new Promise((f,o)=>{const s=this.start(u,c,v,h);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):f(void 0)};s.on("error",n=>{i((0,S.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,r)=>{i(n?`post-${c} process exited with code ${n}`:void 0)}),p&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(u,c,v,p){const h={silent:!0,execArgv:void 0},f=(0,C.fork)(u,[`--type=extension-post-${c}`,...v],h);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const o=P.Event.fromNodeEventEmitter(f.stdout,"data"),s=P.Event.fromNodeEventEmitter(f.stderr,"data");o(n=>this.logService.info(p.identifier.id,p.manifest.version,`post-${c}`,n)),s(n=>this.logService.error(p.identifier.id,p.manifest.version,`post-${c}`,n));const e=P.Event.any(P.Event.map(o,n=>({data:`%c${n}`,format:[""]})),P.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return P.Event.debounce(e,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(p.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(u){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};d=de([ce(0,E.IEnvironmentService),ce(1,D.ILogService)],d),t.ExtensionsLifecycle=d}),define(J[98],Y([0,1,16,14]),function(V,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function S(l,g,E,D){try{const d=await new Promise((b,u)=>{V(["spdlog"],b,u)});return d.setFlushOn(I.LogLevel.Trace),d.createAsyncRotatingLogger(l,g,E,D)}catch(d){console.error(d)}return null}function P(l,g,E,D){const d=V.__$__nodeRequire("spdlog");return d.setFlushOn(I.LogLevel.Trace),d.createRotatingLogger(l,g,E,D)}t.createRotatingLogger=P;function R(l,g,E){switch(g){case I.LogLevel.Trace:l.trace(E);break;case I.LogLevel.Debug:l.debug(E);break;case I.LogLevel.Info:l.info(E);break;case I.LogLevel.Warning:l.warn(E);break;case I.LogLevel.Error:l.error(E);break;case I.LogLevel.Critical:l.critical(E);break;default:throw new Error("Invalid log level")}}class L extends I.AbstractMessageLogger{constructor(g,E,D,d){super();this.name=g,this.filepath=E,this.rotating=D,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}_createSpdLogLogger(){const g=this.rotating?6:1,E=30/g*C.ByteSize.MB;return S(this.name,this.filepath,E,g).then(D=>{if(D){this._logger=D,this._logger.setLevel(this.getLevel());for(const{level:d,message:b}of this.buffer)R(this._logger,d,b);this.buffer=[]}})}log(g,E){this._logger?R(this._logger,g,E):this.getLevel()<=g&&this.buffer.push({level:g,message:E})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(J[55],Y([0,1,17,9,82,16,33]),function(V,t,C,I,S,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(D,d,b,u,c,v){let p;try{await l(D,d,b,u,c,v)}catch(h){p=h}finally{p&&c.errorTransformer&&(p=c.errorTransformer(p)),typeof p!="undefined"&&b.error(p),b.end()}}t.readFileIntoStream=L;async function l(D,d,b,u,c,v){g(v);const p=await D.open(d,{create:!1});try{g(v);let h=0,f=0,o=c&&typeof c.length=="number"?c.length:void 0,s=C.VSBuffer.alloc(Math.min(c.bufferSize,typeof o=="number"?o:c.bufferSize)),e=c&&typeof c.position=="number"?c.position:0,i=0;do f=await D.read(p,e,s.buffer,i,s.byteLength-i),e+=f,i+=f,h+=f,typeof o=="number"&&(o-=f),i===s.byteLength&&(await b.write(u(s)),s=C.VSBuffer.alloc(Math.min(c.bufferSize,typeof o=="number"?o:c.bufferSize)),i=0);while(f>0&&(typeof o!="number"||o>0)&&g(v)&&E(h,c));if(i>0){let n=i;typeof o=="number"&&(n=Math.min(i,o)),b.write(u(s.slice(0,n)))}}catch(h){throw(0,P.ensureFileSystemProviderError)(h)}finally{await D.close(p)}}function g(D){if(D.isCancellationRequested)throw(0,I.canceled)();return!0}function E(D,d){if(d?.limits){if(typeof d.limits.memory=="number"&&D>d.limits.memory)throw(0,P.createFileSystemProviderError)((0,S.localize)(0,null,R.default.nameShort),P.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&D>d.limits.size)throw(0,P.createFileSystemProviderError)((0,S.localize)(1,null),P.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[99],Y([0,1,20,6,17,24,13,130,2,100,5,131,19,38,81,16,55,14]),function(V,t,C,I,S,P,R,L,l,g,E,D,d,b,u,c,v,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let h=class Ue extends l.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new R.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new I.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new I.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!0)))),this.watchedResources=g.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,D.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new l.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,l.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await I.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return L.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,d.isAbsolutePath)(o))throw new c.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,u.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s)||(0,c.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,c.toFileSystemProviderErrorCode)(e)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,c.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=s?.resolveTo,r=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,y=await e.stat(o);let w;return this.toFileStat(e,o,y,void 0,!!a,(O,m)=>(w||(w=g.TernarySearchTree.forUris(()=>!i),w.set(o,!0),n&&w.fill(!0,n)),w.get(O.resource)||w.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&r?m===1:!1))}async toFileStat(o,s,e,i,n,r){const{providerExtUri:a}=this.getExtUri(o),y={resource:s,name:a.basename(s),isFile:(e.type&c.FileType.File)!=0,isDirectory:(e.type&c.FileType.Directory)!=0,isSymbolicLink:(e.type&c.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&c.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,c.etag)({mtime:e.mtime,size:e.size})};if(y.isDirectory&&r(y,i)){try{const w=await o.readdir(s),O=await I.Promises.settled(w.map(async([m,T])=>{try{const F=a.joinPath(s,m),z=n?await o.stat(F):{type:T};return await this.toFileStat(o,F,z,w.length,n,r)}catch(F){return this.logService.trace(F),null}}));y.children=(0,C.coalesce)(O)}catch(w){this.logService.trace(w),y.children=[]}return y}return y}async resolveAll(o){return I.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new c.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=S.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,s);return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,i)),i}async writeFile(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let a;if((0,c.hasReadWriteCapability)(i)&&!(s instanceof S.VSBuffer))if((0,b.isReadableStream)(s)){const y=await(0,b.peekStream)(s,3);y.ended?a=S.VSBuffer.concat(y.buffer):a=y}else a=(0,b.peekReadable)(s,y=>S.VSBuffer.concat(y),3);else a=s;!(0,c.hasOpenReadWriteCloseCapability)(i)||(0,c.hasReadWriteCapability)(i)&&a instanceof S.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof S.VSBuffer?(0,S.bufferToReadable)(a):a)}catch(r){throw new c.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(s)));let n;try{n=await o.stat(s)}catch(r){return}if((n.type&c.FileType.Directory)!=0)throw new c.FileOperationError((0,u.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,n),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==c.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,c.etag)({mtime:e.mtime,size:n.size}))throw new c.FileOperationError((0,u.localize)(7,null),3,e);return n}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,e);i(r)}catch(r){n(r)}})})}async doReadFile(o,s,e){const i=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,S.streamToBuffer)(i.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const i=new P.CancellationTokenSource,n=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let r;try{return typeof e?.etag=="string"&&e.etag!==c.ETAG_DISABLED&&await n,!((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasFileReadStreamCapability)(o))||(0,c.hasReadWriteCapability)(o)&&e?.preferUnbuffered?r=this.readFileUnbuffered(o,s,e):(0,c.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,i.token,e):r=this.readFileBuffered(o,s,i.token,e),{...await n,value:r}}catch(a){r&&await(0,b.consumeStream)(r);const y=(0,u.localize)(8,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(a).toString());throw a instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(y,a.stat,e):new c.FileOperationError(y,(0,c.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,i=Object.create(null)){const n=o.readFileStream(s,i,e);return(0,b.transform)(n,{data:r=>r instanceof S.VSBuffer?r:S.VSBuffer.wrap(r),error:r=>new c.FileOperationError((0,u.localize)(9,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),i)},r=>S.VSBuffer.concat(r))}readFileBuffered(o,s,e,i=Object.create(null)){const n=(0,S.newWriteableBufferStream)();return(0,v.readFileIntoStream)(o,s,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new c.FileOperationError((0,u.localize)(10,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),i)},e),n}readFileUnbuffered(o,s,e){const i=(0,b.newWriteableStream)(n=>S.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(s);typeof e?.position=="number"&&(n=n.slice(e.position)),typeof e?.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(s,n.byteLength,e),i.end(S.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new c.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==c.ETAG_DISABLED&&s.etag===e.etag)throw new c.NotModifiedSinceFileOperationError((0,u.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new c.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,i){if(o.toString()!==s.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,o,r,s,e,i)}catch(n){return n}return!0}async move(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,s,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,i,n,r){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(o,s,e,i,n,r);if(a&&!y&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&(0,c.hasFileFolderCopyCapability)(o))await o.copy(s,i,{overwrite:r});else{const w=await this.resolve(s);w.isDirectory?await this.doCopyFolder(o,w,e,i):await this.doCopyFile(o,s,e,i)}return n}else return o===e?(await o.rename(s,i,{overwrite:r}),n):(await this.doMoveCopy(o,s,e,i,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,i){if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,i);if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,i);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,i);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,i)}async doCopyFolder(o,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await I.Promises.settled(s.children.map(async n=>{const r=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,r):this.doCopyFile(o,n.resource,e,r)}))}async doValidateMoveCopy(o,s,e,i,n,r){let a=!1;if(o===e){const{providerExtUri:w,isPathCaseSensitive:O}=this.getExtUri(o);if(O||(a=w.isEqual(s,i)),a&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&w.isEqualOrParent(i,s))throw new Error((0,u.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const y=await this.exists(i);if(y&&!a){if(!r)throw new c.FileOperationError((0,u.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(o===e){const{providerExtUri:w}=this.getExtUri(o);if(w.isEqualOrParent(s,i))throw new Error((0,u.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:y,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(s,i.dirname(s));)try{if(((await o.stat(s)).type&c.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,c.toFileSystemProviderErrorCode)(n)!==c.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(s)),s=i.dirname(s)}for(let n=e.length-1;n>=0;n--){s=i.joinPath(s,e[n]);try{await o.mkdir(s)}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(a){}if(n)this.throwIfFileIsReadonly(o,n);else throw new c.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),i=!!s?.useTrash,n=!!s?.recursive;await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new c.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const n of o)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new c.FileChangesEvent(e,!s))}if(i){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ue.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new l.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,l.toDisposable)(()=>n())),this.doWatch(o,s).then(r=>{i?(0,l.dispose)(r):n=()=>(0,l.dispose)(r)},r=>this.logService.error(r))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,l.toDisposable)(()=>{const i=this.watchedResources.get(o);typeof i=="number"&&(i<=1?this.watchedResources.delete(o):this.watchedResources.set(o,i-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),i=this.toWatchKey(e,o,s),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,l.toDisposable)(()=>{n.count--,n.count===0&&((0,l.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,s,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,b.isReadableStream)(i)||(0,b.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,n,i):await this.doWriteReadableBufferedQueued(o,n,i)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,s,e){let i=0,n;if((0,b.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=S.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,i,0),i+=r.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise((r,a)=>{(0,b.listenStream)(n,{onData:async y=>{n.pause();try{await this.doWriteBuffer(o,s,y,y.byteLength,i,0)}catch(w){return a(w)}i+=y.byteLength,setTimeout(()=>n.resume())},onError:y=>a(y),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,s,e,i,n,r){let a=0;for(;a<i;)a+=await o.write(s,n+a,e.buffer,r+a,i-a)}async doWriteUnbuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,i))}async doWriteUnbufferedQueued(o,s,e,i){let n;i instanceof S.VSBuffer?n=i:(0,b.isReadableStream)(i)?n=await(0,S.streamToBuffer)(i):(0,b.isReadableBufferedStream)(i)?n=await(0,S.bufferedStreamToBuffer)(i):n=(0,S.readableToBuffer)(i),await o.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,i))}async doPipeBufferedQueued(o,s,e,i){let n,r;try{n=await o.open(s,{create:!1}),r=await e.open(i,{create:!0,unlock:!1});const a=S.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,w=0,O=0;do O=await o.read(n,y,a.buffer,w,a.byteLength-w),await this.doWriteBuffer(e,r,a,O,y,w),y+=O,w+=O,w===a.byteLength&&(w=0);while(O>0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await I.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,i))}async doPipeUnbufferedQueued(o,s,e,i){return e.writeFile(i,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,i))}async doPipeUnbufferedToBufferedQueued(o,s,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(e,n,S.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,s,e,i){const n=await(0,S.streamToBuffer)(this.readFileBuffered(o,s,P.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new c.FileOperationError((0,u.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===E.Schemas.file?o.fsPath:o.toString(!0)}};h.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},h=de([ce(0,p.ILogService)],h),t.FileService=h}),define(J[101],Y([0,1,20,6,17,13,47,2,8,11,19,38,12,83,16,55,92,93,94,95,32,14,33]),function(V,t,C,I,S,P,R,L,l,g,E,D,d,b,u,c,v,p,h,f,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class i extends L.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new P.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:y}=await d.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,y),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await d.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),y=[];return await Promise.all(a.map(async w=>{try{let O;w.isSymbolicLink()?O=(await this.stat((0,E.joinPath)(r,w.name))).type:O=this.toType(w),y.push([w.name,O])}catch(O){this.logService.trace(O)}})),y}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let y;return a?.dangling?y=u.FileType.Unknown:r.isFile()?y=u.FileType.File:r.isDirectory()?y=u.FileType.Directory:y=u.FileType.Unknown,a&&(y|=u.FileType.SymbolicLink),y}async readFile(r){try{const a=this.toFilePath(r);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,y){const w=(0,D.newWriteableStream)(O=>S.VSBuffer.concat(O.map(m=>S.VSBuffer.wrap(m))).buffer);return(0,c.readFileIntoStream)(this,r,w,O=>O.buffer,{...a,bufferSize:this.BUFFER_SIZE},y),w}async writeFile(r,a,y){let w;try{const O=this.toFilePath(r);if(!y.create||!y.overwrite){if(await d.Promises.exists(O)){if(!y.overwrite)throw(0,u.createFileSystemProviderError)((0,b.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!y.create)throw(0,u.createFileSystemProviderError)((0,b.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:y.unlock}),await this.write(w,0,a,0,a.byteLength)}catch(O){throw await this.toFileSystemProviderWriteError(r,O)}finally{typeof w=="number"&&await this.close(w)}}async open(r,a){try{const y=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:m}=await d.SymlinkSupport.stat(y);m.mode&128||await d.Promises.chmod(y,m.mode|128)}catch(m){this.logService.trace(m)}let w;if((0,u.isFileOpenForWriteOptions)(a)){if(g.isWindows)try{await d.Promises.truncate(y,0),w="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}w||(w="w")}else w="r";const O=await d.Promises.open(y,w);return this.mapHandleToPos.set(O,0),(0,u.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(O,r),O}catch(y){throw(0,u.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,y):this.toFileSystemProviderError(y)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await d.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await d.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,y,w,O){const m=this.normalizePos(r,a);let T=null;try{const F=await d.Promises.read(r,y,w,O,m);return typeof F=="number"?T=F:T=F.bytesRead,T}catch(F){throw this.toFileSystemProviderError(F)}finally{this.updatePos(r,m,T)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,y){const w=this.mapHandleToPos.get(r);typeof w=="number"&&(typeof a=="number"||(typeof y=="number"?this.mapHandleToPos.set(r,w+y):this.mapHandleToPos.delete(r)))}async write(r,a,y,w,O){return(0,I.retry)(()=>this.doWrite(r,a,y,w,O),100,3)}async doWrite(r,a,y,w,O){const m=this.normalizePos(r,a);let T=null;try{const F=await d.Promises.write(r,y,w,O,m);return typeof F=="number"?T=F:T=F.bytesWritten,T}catch(F){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),F)}finally{this.updatePos(r,m,T)}}async mkdir(r){try{await d.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const y=this.toFilePath(r);await this.doDelete(y,a)}catch(y){throw this.toFileSystemProviderError(y)}}async doDelete(r,a){a.recursive?await d.Promises.rm(r,d.RimRafMode.MOVE):await d.Promises.unlink(r)}async rename(r,a,y){const w=this.toFilePath(r),O=this.toFilePath(a);if(w!==O)try{await this.validateTargetDeleted(r,a,"move",y.overwrite),await d.Promises.move(w,O)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,b.localize)(2,null,(0,l.basename)(w),(0,l.basename)((0,l.dirname)(O)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(r,a,y){const w=this.toFilePath(r),O=this.toFilePath(a);if(w!==O)try{await this.validateTargetDeleted(r,a,"copy",y.overwrite),await d.Promises.copy(w,O,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,b.localize)(3,null,(0,l.basename)(w),(0,l.basename)((0,l.dirname)(O)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(r,a,y,w){const O=this.toFilePath(r),m=this.toFilePath(a);let T=!1;if(!!(this.capabilities&1024)||(T=(0,R.isEqual)(O,m,!0)),T&&y==="copy")throw(0,u.createFileSystemProviderError)((0,b.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!T&&await d.Promises.exists(m)){if(!w)throw(0,u.createFileSystemProviderError)((0,b.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a):this.watchNonRecursive(r)}watchRecursive(r,a){const y={path:this.toFilePath(r),excludes:a.excludes},w=(0,C.insert)(this.recursiveFoldersToWatch,y);return this.refreshRecursiveWatchers(),(0,L.toDisposable)(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){this.recursiveWatcher?this.recursiveWatcher.watch(this.recursiveFoldersToWatch):this.recursiveFoldersToWatch.length>0&&(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch,r=>this._onDidChangeFile.fire((0,o.toFileChanges)(r)),r=>{r.type==="error"&&this._onDidWatchErrorOccur.fire(r.message),this.logService[r.type](r.message)},this.logService.getLevel()===s.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)})))}createRecursiveWatcher(r,a,y,w){let O,m;if(this.options?.watcher?.usePolling)O=f.FileWatcher,m=this.options?.watcher;else{let T=!1;this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?T=this.options.legacyWatcher==="on":e.default.quality==="stable"&&(T=this.recursiveFoldersToWatch.length===1),T?g.isLinux?O=f.FileWatcher:O=p.FileWatcher:O=h.FileWatcher}return new O(r,T=>a(T),T=>y(T),w,m)}watchNonRecursive(r){const a=new v.FileWatcher(this.toFilePath(r),w=>this._onDidChangeFile.fire((0,o.toFileChanges)(w)),w=>{w.type==="error"&&this._onDidWatchErrorOccur.fire(w.message),this.logService[w.type](w.message)},this.logService.getLevel()===s.LogLevel.Trace),y=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,L.combinedDisposable)(a,y)}toFilePath(r){return(0,l.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=u.FileSystemProviderErrorCode.NoPermissions;break;default:a=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let y=this.toFileSystemProviderError(a);if(r&&y.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:w}=await d.SymlinkSupport.stat(this.toFilePath(r));w.mode&128||(y=(0,u.createFileSystemProviderError)(a,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(w){this.logService.trace(w)}return y}}t.DiskFileSystemProvider=i}),define(J[41],Y([0,1,15]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,C.createDecorator)("productService")}),define(J[25],Y([0,1,56,10]),function(V,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class S{constructor(){this.data=new Map}add(R,L){C.ok(I.isString(R)),C.ok(I.isObject(L)),C.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,L)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}t.Registry=new S}),define(J[102],Y([0,1,13,25]),function(V,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function S(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class P{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,g){this.schemasById[S(l)]=g,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new P;I.Registry.add(t.Extensions.JSONContribution,R)}),define(J[34],Y([0,1,20,13,10,72,102,25]),function(V,t,C,I,S,P,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var l;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(l=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var g;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=L.Registry.as(R.Extensions.JSONContribution);class D{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(f,o=!0){this.registerConfigurations([f],o)}registerConfigurations(f,o=!0){const s=this.doRegisterConfigurations(f,o);E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(f){const o=this.doDeregisterConfigurations(f);E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:f,remove:o}){const s=[];s.push(...this.doDeregisterConfigurations(o)),s.push(...this.doRegisterConfigurations(f,!1)),E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,C.distinct)(s))}registerDefaultConfigurations(f){const o=[],s=[];for(const e of f)for(const i in e)if(o.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...e[i]};const n={type:"object",default:this.defaultValues[i],description:P.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};s.push(b(i)),this.configurationProperties[i]=n,this.defaultLanguageConfigurationOverridesNode.properties[i]=n}else{this.defaultValues[i]=e[i];const n=this.configurationProperties[i];n&&(this.updatePropertyDefaultValue(i,n),this.updateSchema(i,n))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(f){const o=[];for(const s of f)for(const e in s)if(o.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...f){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(f){for(const o of f)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(f,o){const s=[];return f.forEach(e=>{s.push(...this.validateAndRegisterProperties(e,o,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),s}doDeregisterConfigurations(f){const o=[],s=e=>{if(e.properties)for(const i in e.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,e.properties[i]);e.allOf&&e.allOf.forEach(i=>s(i))};for(const e of f){s(e);const i=this.configurationContributors.indexOf(e);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(f,o=!0,s,e=3){e=S.isUndefinedOrNull(f.scope)?e:f.scope;let i=[],n=f.properties;if(n)for(let a in n){if(o&&v(a)){delete n[a];continue}const y=n[a];if(this.updatePropertyDefaultValue(a,y),t.OVERRIDE_PROPERTY_PATTERN.test(a)?y.scope=void 0:(y.scope=S.isUndefinedOrNull(y.scope)?e:y.scope,y.restricted=S.isUndefinedOrNull(y.restricted)?!!s?.restrictedConfigurations?.includes(a):y.restricted),n[a].hasOwnProperty("included")&&!n[a].included){this.excludedConfigurationProperties[a]=n[a],delete n[a];continue}else this.configurationProperties[a]=n[a];!n[a].deprecationMessage&&n[a].markdownDeprecationMessage&&(n[a].deprecationMessage=n[a].markdownDeprecationMessage),i.push(a)}let r=f.allOf;if(r)for(let a of r)i.push(...this.validateAndRegisterProperties(a,o,s,e));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(f){const o=s=>{let e=s.properties;if(e)for(const n in e)this.updateSchema(n,e[n]);let i=s.allOf;i&&i.forEach(o)};o(f)}updateSchema(f,o){switch(t.allSettings.properties[f]=o,o.scope){case 1:t.applicationSettings.properties[f]=o;break;case 2:t.machineSettings.properties[f]=o;break;case 6:t.machineOverridableSettings.properties[f]=o;break;case 3:t.windowSettings.properties[f]=o;break;case 4:t.resourceSettings.properties[f]=o;break;case 5:t.resourceSettings.properties[f]=o,this.resourceLanguageSettingsSchema.properties[f]=o;break}}removeFromSchema(f,o){switch(delete t.allSettings.properties[f],o.scope){case 1:delete t.applicationSettings.properties[f];break;case 2:delete t.machineSettings.properties[f];break;case 6:delete t.machineOverridableSettings.properties[f];break;case 3:delete t.windowSettings.properties[f];break;case 4:case 5:delete t.resourceSettings.properties[f];break}}updateOverridePropertyPatternKey(){for(const f of this.overrideIdentifiers.values()){const o=`[${f}]`,s={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),t.allSettings.properties[o]=s,t.applicationSettings.properties[o]=s,t.machineSettings.properties[o]=s,t.machineOverridableSettings.properties[o]=s,t.windowSettings.properties[o]=s,t.resourceSettings.properties[o]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(f,o){let s=this.defaultValues[f];S.isUndefined(s)&&(s=o.default),S.isUndefined(s)&&(s=u(o.type)),o.default=s}}const d="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(d);function b(h){return h.substring(1,h.length-1)}t.overrideIdentifierFromKey=b;function u(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=u;const c=new D;L.Registry.add(t.Extensions.Configuration,c);function v(h){return h.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(h)?P.localize(5,null,h):c.getConfigurationProperties()[h]!==void 0?P.localize(6,null,h):null:P.localize(4,null)}t.validateProperty=v;function p(){const h=[],f=c.getConfigurationProperties();for(const o of Object.keys(f))h.push([o,f[o].scope]);return h.push(["launch",4]),h.push(["task",4]),h}t.getScopes=p}),define(J[26],Y([0,1,18,10,7,34,15,25]),function(V,t,C,I,S,P,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,R.createDecorator)("configurationService");function l(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof S.URI)}t.isConfigurationOverrides=l;var g;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(g=t.ConfigurationTarget||(t.ConfigurationTarget={}));function E(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=E;function D(i,n){const r=n?i?n.keys.filter(F=>i.keys.indexOf(F)===-1):[...n.keys]:[],a=i?n?i.keys.filter(F=>n.keys.indexOf(F)===-1):[...i.keys]:[],y=[];if(n&&i){for(const F of i.keys)if(n.keys.indexOf(F)!==-1){const z=p(i.contents,F),K=p(n.contents,F);C.equals(z,K)||y.push(F)}}const w=[],O=F=>{const z={};for(const K of F)for(const Z of K.identifiers)z[s(Z)]=K;return z},m=n?O(n.overrides):{},T=i?O(i.overrides):{};if(Object.keys(m).length)for(const F of r){const z=m[F];z&&w.push([(0,P.overrideIdentifierFromKey)(F),z.keys])}if(Object.keys(T).length)for(const F of a){const z=T[F];z&&w.push([(0,P.overrideIdentifierFromKey)(F),z.keys])}if(Object.keys(m).length&&Object.keys(T).length)for(const F of y){const z=T[F],K=m[F];if(z&&K){const Z=D({contents:z.contents,keys:z.keys,overrides:[]},{contents:K.contents,keys:K.keys,overrides:[]});w.push([(0,P.overrideIdentifierFromKey)(F),[...Z.added,...Z.removed,...Z.updated]])}}return{added:r,removed:a,updated:y,overrides:w}}t.compare=D;function d(i,n){const r=[];for(const a of Object.keys(i))if(P.OVERRIDE_PROPERTY_PATTERN.test(a)){const y={};for(const w in i[a])y[w]=i[a][w];r.push({identifiers:[(0,P.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(y),contents:b(y,n)})}return r}t.toOverrides=d;function b(i,n){const r=Object.create(null);for(let a in i)u(r,a,i[a],n);return r}t.toValuesTree=b;function u(i,n,r,a){const y=n.split("."),w=y.pop();let O=i;for(let m=0;m<y.length;m++){let T=y[m],F=O[T];switch(typeof F){case"undefined":F=O[T]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${y.slice(0,m+1).join(".")} is ${JSON.stringify(F)}`);return}O=F}if(typeof O=="object"&&O!==null)try{O[w]=r}catch(m){a(`Ignoring ${n} as ${y.join(".")} is ${JSON.stringify(O)}`)}else a(`Ignoring ${n} as ${y.join(".")} is ${JSON.stringify(O)}`)}t.addToValueTree=u;function c(i,n){const r=n.split(".");v(i,r)}t.removeFromValueTree=c;function v(i,n){const r=n.shift();if(n.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const a=i[r];typeof a=="object"&&!Array.isArray(a)&&(v(a,n),Object.keys(a).length===0&&delete i[r])}}function p(i,n,r){function a(O,m){let T=O;for(const F of m){if(typeof T!="object"||T===null)return;T=T[F]}return T}const y=n.split("."),w=a(i,y);return typeof w=="undefined"?r:w}t.getConfigurationValue=p;function h(i,n,r){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?I.isObject(i[a])&&I.isObject(n[a])?h(i[a],n[a],r):r&&(i[a]=n[a]):i[a]=n[a])})}t.merge=h;function f(){const i=L.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=f;function o(){const i=Object.create(null),n=L.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let r in n){let a=n[r].default;u(i,r,a,y=>console.error(`Conflict in default settings: ${y}`))}return i}t.getDefaultValues=o;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,n,r){const a=i.inspect(n),y=i.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:a.defaultValue}t.getMigratedSettingValue=e}),define(J[103],Y([0,1,20,13,57,2,100,18,10,7,26,34,25]),function(V,t,C,I,S,P,R,L,l,g,E,D,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class b{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,E.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,E.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){let i=this.overrideConfigurations.get(e);return i||(i=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,i)),i}merge(...e){const i=L.deepClone(this.contents),n=L.deepClone(this.overrides),r=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const y of a.overrides){const[w]=n.filter(O=>C.equals(O.identifiers,y.identifiers));w?this.mergeContents(w.contents,y.contents):n.push(L.deepClone(y))}for(const y of a.keys)r.indexOf(y)===-1&&r.push(y)}return new b(i,r,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const r of C.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r],y=i[r];y&&(typeof a=="object"&&typeof y=="object"?(a=L.deepClone(a),this.mergeContents(a,y)):a=y),n[r]=a}return new b(n,this.keys,this.overrides)}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&l.isObject(e[n])&&l.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=L.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?L.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,E.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,E.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=b;class u extends b{constructor(){const e=(0,E.getDefaultValues)(),i=(0,E.getConfigurationKeys)(),n=[];for(const r of Object.keys(e))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,D.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,E.toValuesTree)(e[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=u;class c{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!l.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:r,overrides:a,restricted:y}=this.doParseRaw(e,i);this._configurationModel=new b(n,r,a),this._restrictedConfigurations=y||[]}doParseContent(e){let i={},n=null,r=[],a=[],y=[];function w(m){Array.isArray(r)?r.push(m):n!==null&&(r[n]=m)}let O={onObjectBegin:()=>{let m={};w(m),a.push(r),r=m,n=null},onObjectProperty:m=>{n=m},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let m=[];w(m),a.push(r),r=m,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:w,onError:(m,T,F)=>{y.push({error:m,offset:T,length:F})}};if(e)try{S.visit(e,O),i=r[0]||{}}catch(m){console.error(`Error while parsing settings file ${this._name}: ${m}`),this._parseErrors=[m]}return i}doParseRaw(e,i){const n=d.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,n,!0,i);e=r.raw;const a=(0,E.toValuesTree)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),y=Object.keys(e),w=(0,E.toOverrides)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:a,keys:y,overrides:w,restricted:r.restricted}}filter(e,i,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const a={},y=[];for(let w in e)if(D.OVERRIDE_PROPERTY_PATTERN.test(w)&&n){const O=this.filter(e[w],i,!1,r);a[w]=O.raw,y.push(...O.restricted)}else{const O=i[w],m=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&y.push(w),(m===void 0||r.scopes===void 0||r.scopes.includes(m))&&(r.skipRestricted&&O?.restricted||(a[w]=e[w]))}return{raw:a,restricted:y}}}t.ConfigurationModelParser=c;class v extends P.Disposable{constructor(e,i,n,r){super();this.userSettingsResource=e,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=v;class p{constructor(e,i,n=new b,r=new b,a=new R.ResourceMap,y=new b,w=new R.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=y,this._memoryConfigurationByResource=w,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new b,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(e):r.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const r=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,w=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),m=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),T=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),F=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,z=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,K=i.overrideIdentifier?y.override(i.overrideIdentifier).getValue(e):y.getValue(e),Z=r.getValue(e),oe=C.distinct(C.flatten(r.overrides.map(te=>te.identifiers))).filter(te=>r.getOverrideValue(e,te)!==void 0);return{defaultValue:w,userValue:O,userLocalValue:m,userRemoteValue:T,workspaceValue:F,workspaceFolderValue:z,memoryValue:K,value:Z,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:m!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:z!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:K!==void 0?{value:y.getValue(e),override:i.overrideIdentifier?y.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,D.overrideIdentifierFromKey)(r),y=this._defaultConfiguration.getKeysForOverrideIdentifier(a),w=e.getKeysForOverrideIdentifier(a),O=[...w.filter(m=>y.indexOf(m)===-1),...y.filter(m=>w.indexOf(m)===-1),...y.filter(m=>!L.equals(this._defaultConfiguration.override(a).getValue(m),e.override(a).getValue(m)))];return[a,O]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,E.compare)(this.localUserConfiguration,e),y=[...i,...n,...r];return y.length&&this.updateLocalUserConfiguration(e),{keys:y,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,E.compare)(this.remoteUserConfiguration,e);let y=[...i,...n,...r];return y.length&&this.updateRemoteUserConfiguration(e),{keys:y,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,E.compare)(this.workspaceConfiguration,e);let y=[...i,...n,...r];return y.length&&this.updateWorkspaceConfiguration(e),{keys:y,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:r,updated:a,removed:y,overrides:w}=(0,E.compare)(n,i);let O=[...r,...a,...y];return(O.length||!n)&&this.updateFolderConfiguration(e,i),{keys:O,overrides:w}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:r,removed:a,overrides:y}=(0,E.compare)(i,void 0);return{keys:[...n,...r,...a],overrides:y}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const r=i.getFolder(e);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(i=n.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:r,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:r,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((y,w)=>(y.set(g.URI.revive(w[0]),this.parseConfigurationModel(w[1])),y),new R.ResourceMap);return new p(i,n,new b,r,a,new b,new R.ResourceMap,!1)}static parseConfigurationModel(e){return new b(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=p;function h(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const r of s)r.keys.forEach(a=>e.add(a)),r.overrides.forEach(([a,y])=>{const w=(0,R.getOrSet)(i,a,new Set);y.forEach(O=>w.add(O))});const n=[];return i.forEach((r,a)=>n.push([a,[...r.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=h;class f{constructor(e,i,n,r){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(w=>a.add(w)),e.overrides.forEach(([,w])=>w.forEach(O=>a.add(O))),this.affectedKeys=[...a.values()];const y=new b;this.affectedKeys.forEach(w=>y.setValue(w,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!L.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,E.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(e=e[r],!e)return!1;n=n[r]}return!0}}t.ConfigurationChangeEvent=f;class o extends f{constructor(e,i,n,r){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=o}),define(J[104],Y([0,1,6,13,2,19,26,103,34,25]),function(V,t,C,I,S,P,R,L,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class E extends S.Disposable{constructor(d,b){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new L.UserSettings(this.settingsResource,void 0,P.extUriBiasedIgnorePathCase,b)),this.configuration=new L.Configuration(new L.DefaultConfigurationModel,new L.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new L.Configuration(new L.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,b){const u=typeof d=="string"?d:void 0,c=(0,R.isConfigurationOverrides)(d)?d:(0,R.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(u,c,void 0)}updateValue(d,b,u,c){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const b=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(u,b,1)}onDidDefaultConfigurationChange(d){const b=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new L.DefaultConfigurationModel,d);this.trigger(u,b,6)}trigger(d,b,u){const c=new L.ConfigurationChangeEvent(d,{data:b},this.configuration);c.source=u,c.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(c)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=E}),define(J[105],Y([0,1,5]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVirtualWorkspace=t.getVirtualWorkspaceScheme=t.getVirtualWorkspaceLocation=t.isVirtualResource=t.getRemoteName=t.getRemoteAuthority=void 0;function I(g){return g.scheme===C.Schemas.vscodeRemote?g.authority:void 0}t.getRemoteAuthority=I;function S(g){if(!g)return;const E=g.indexOf("+");return E<0?g:g.substr(0,E)}t.getRemoteName=S;function P(g){return g.scheme!==C.Schemas.file&&g.scheme!==C.Schemas.vscodeRemote}t.isVirtualResource=P;function R(g){if(g.folders.length)return g.folders.every(E=>P(E.uri))?g.folders[0].uri:void 0;if(g.configuration&&P(g.configuration))return g.configuration}t.getVirtualWorkspaceLocation=R;function L(g){return R(g)?.scheme}t.getVirtualWorkspaceScheme=L;function l(g){return R(g)!==void 0}t.isVirtualWorkspace=l}),define(J[42],Y([0,1,27,15,105]),function(V,t,C,I,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}t.getWorkspaceSupportTypeMessage=P;function R(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}t.isIExtensionIdentifier=R,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(L=t.ExtensionType||(t.ExtensionType={}));class l{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,u){if(typeof b=="undefined"||b===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof b=="string"||typeof u=="string"){let c=typeof b=="string"?b:b.value,v=typeof u=="string"?u:u.value;return C.equalsIgnoreCase(c,v)}return b._lower===u._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}t.ExtensionIdentifier=l;function g(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}t.isLanguagePackExtension=g;function E(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=E;function D(d,b){if(b&&d.enableProposedApi){const u=`onResolveRemoteAuthority:${(0,S.getRemoteName)(b)}`;return d.activationEvents?.indexOf(u)!==-1}return!1}t.isResolverExtension=D,t.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[23],Y([0,1,27,42]),function(V,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function S(u,c){return u.uuid&&c.uuid?u.uuid===c.uuid:u.id===c.id?!0:(0,C.compareIgnoreCase)(u.id,c.id)===0}t.areSameExtensions=S;class P{constructor(c,v){this.version=v,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof P?S(this,c)&&this.version===c.version:!1}}t.ExtensionIdentifierWithVersion=P;function R(u,c){return`${u}.${c}`}t.getExtensionId=R;function L(u){return u.toLocaleLowerCase()}t.adoptToGalleryExtensionId=L;function l(u,c){return L(R(u,c))}t.getGalleryExtensionId=l;function g(u,c){const v=[],p=h=>{for(const f of v)if(f.some(o=>S(c(o),c(h))))return f;return null};for(const h of u){const f=p(h);f?f.push(h):v.push([h])}return v}t.groupByExtension=g;function E(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=E;function D(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}t.getGalleryExtensionTelemetryData=D,t.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function d(u){const c=new Set;for(const v of u)v.malicious&&c.add(v.id.id);return c}t.getMaliciousExtensionsSet=d;function b(u,c){const v=[],p=c.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const h=p.shift();if(h&&v.every(f=>!S(f.identifier,{id:h}))){const f=u.filter(o=>S(o.identifier,{id:h}));f.length===1&&(v.push(f[0]),p.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}t.getExtensionDependencies=b}),define(J[106],Y([0,1,24,9,61,5,43,7,76,22,23,42]),function(V,t,C,I,S,P,R,L,l,g,E,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const d=h=>(0,l.localize)(0,null,h),b=(0,l.localize)(1,null,"ms-dotnettools.csharp");function u(h,f){return f?`${h.publisher}.${h.name}@${h.version}`:`${h.publisher}.${h.name}`}const c=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function v(h){const f=c.exec(h);return f&&f[1]?[(0,E.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,E.adoptToGalleryExtensionId)(h),void 0]}t.getIdAndVersion=v;let p=class{constructor(f,o){this.extensionManagementService=f,this.extensionGalleryService=o}get location(){}async listExtensions(f,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=D.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(y=>y.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),i.forEach(r=>{s.log(r)});return}this.location&&s.log((0,l.localize)(2,null,this.location)),e=e.sort((r,a)=>r.identifier.id.localeCompare(a.identifier.id));let n;for(let r of e)n!==r.identifier.id&&(n=r.identifier.id,s.log(u(r.manifest,f)))}async installExtensions(f,o,s,e,i=console){const n=[],r=[];f.length&&i.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),y=(m,T)=>{const F=a.find(z=>(0,E.areSameExtensions)(z.identifier,{id:m}));if(F){if(!T&&!e)return i.log((0,l.localize)(5,null,m,F.manifest.version,m)),!1;if(T&&F.manifest.version===T)return i.log((0,l.localize)(6,null,`${m}@${T}`)),!1}return!0},w=[],O=[];for(const m of f)if(m instanceof L.URI)w.push(m);else{const[T,F]=v(m);y(T,F)&&O.push({id:T,version:F,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const m of o){const[T,F]=v(m);y(T,F)&&O.push({id:T,version:F,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(w.length&&await Promise.all(w.map(async m=>{try{const T=await this.installVSIX(m,{isBuiltin:!1,isMachineScoped:s},e,i);T&&r.push(T)}catch(T){i.error(T.message||T.stack||T),n.push(m.toString())}})),O.length){const m=await this.getGalleryExtensions(O);await Promise.all(O.map(async T=>{const F=m.get(T.id.toLowerCase());if(F)try{const z=await this.installFromGallery(T,F,a,e,i);z&&r.push(z)}catch(z){i.error(z.message||z.stack||z),n.push(T.id)}else i.error(`${d(T.version?`${T.id}@${T.version}`:T.id)}
${b}`),n.push(T.id)}))}if(n.length)throw new Error((0,l.localize)(7,null,n.join(", ")))}async installVSIX(f,o,s,e){const i=await this.extensionManagementService.getManifest(f);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(f,o),e.log((0,l.localize)(8,null,(0,S.getBaseLabel)(f))),i}catch(r){if((0,I.isPromiseCanceledError)(r))return e.log((0,l.localize)(9,null,(0,S.getBaseLabel)(f))),null;throw r}return null}async getGalleryExtensions(f){const o=new Map,s=await this.extensionGalleryService.getExtensions(f,C.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:f,version:o,installOptions:s},e,i,n,r){const a=await this.extensionGalleryService.getManifest(e,C.CancellationToken.None);if(a&&!this.validateExtensionKind(a,r))return null;const y=i.find(w=>(0,E.areSameExtensions)(w.identifier,e.identifier));if(y){if(e.version===y.manifest.version)return r.log((0,l.localize)(10,null,o?`${f}@${o}`:f)),null;r.log((0,l.localize)(11,null,f,e.version))}try{return s.isBuiltin?r.log(o?(0,l.localize)(12,null,f,o):(0,l.localize)(13,null,f)):r.log(o?(0,l.localize)(14,null,f,o):(0,l.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),r.log((0,l.localize)(16,null,f,e.version)),a}catch(w){if((0,I.isPromiseCanceledError)(w))return r.log((0,l.localize)(17,null,f)),null;throw w}}validateExtensionKind(f,o){return!0}async validateVSIX(f,o,s){const e={id:(0,E.getGalleryExtensionId)(f.publisher,f.name)},n=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,E.areSameExtensions)(e,r.identifier)&&(0,R.gt)(r.manifest.version,f.version));return n&&!o?(s.log((0,l.localize)(18,null,n.identifier.id,n.manifest.version,f.version)),!1):this.validateExtensionKind(f,s)}async uninstallExtensions(f,o,s=console){const e=async n=>{if(n instanceof L.URI){const r=await this.extensionManagementService.getManifest(n);return u(r)}return n},i=[];for(const n of f){const r=await e(n),y=(await this.extensionManagementService.getInstalled()).filter(w=>(0,E.areSameExtensions)(w.identifier,{id:r}));if(!y.length)throw new Error(`${this.notInstalled(r)}
${b}`);if(y.some(w=>w.type===0)){s.log((0,l.localize)(19,null,r));return}if(!o&&y.some(w=>w.isBuiltin)){s.log((0,l.localize)(20,null,r));return}s.log((0,l.localize)(21,null,r));for(const w of y)await this.extensionManagementService.uninstall(w),i.push(w);this.location?s.log((0,l.localize)(22,null,r,this.location)):s.log((0,l.localize)(23,null,r))}}async locateExtension(f,o=console){const s=await this.extensionManagementService.getInstalled();f.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===P.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(f){return this.location?(0,l.localize)(24,null,f,this.location):(0,l.localize)(25,null,f)}};p=de([ce(0,g.IExtensionManagementService),ce(1,g.IExtensionGalleryService)],p),t.ExtensionManagementCLIService=p}),define(J[107],Y([0,1,6,9,2,11,19,43,7,31,12,21,22,23,16,14]),function(V,t,C,I,S,P,R,L,l,g,E,D,d,b,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends S.Disposable{constructor(f,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=l.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,o){await this.cleanUpPromise;const s=this.getName(f),e=(0,R.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,o,s){try{await E.Promises.rename(f.fsPath,o.fsPath)}catch(e){if(P.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${f} to ${o} with 'EPERM' error. Trying again...`),this.rename(f,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const o=[],s=[];for(const n of f.children){const r=this.parse(n.name);r&&s.push([r,n])}const e=(0,b.groupByExtension)(s,([n])=>n),i=[];for(const n of e)n.sort((r,a)=>L.rcompare(r[0].version,a[0].version)),o.push(...n.slice(1).map(r=>r[1].resource)),i.push(n[0][1]);i.sort((n,r)=>n.mtime-r.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await C.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new b.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,g.generateUuid)()}parse(f){const o=v.exec(f);return o&&o[1]&&o[2]?new b.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};p=de([ce(0,D.INativeEnvironmentService),ce(1,u.IFileService),ce(2,d.IExtensionGalleryService),ce(3,c.ILogService)],p),t.ExtensionsDownloader=p}),define(J[108],Y([0,1,2,8,12,42]),function(V,t,C,I,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class R extends C.Disposable{constructor(l,g){super();this.environmentService=l,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,P.MANIFEST_CACHE_FOLDER,P.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(g.onDidUninstallExtension(E=>this.onDidUnInstallExtension(E)))}onDidInstallExtensions(l){l.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){S.Promises.rm(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=R}),define(J[109],Y([0,1,13,2,19,7,21,23,16,14]),function(V,t,C,I,S,P,R,L,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let E=class extends I.Disposable{constructor(d,b,u,c){super();this.extensionsManagementService=d,this.logService=c,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(h=>{this.installedExtensions=h.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(h=>this.onInstallExtension(h))),this._register(d.onDidInstallExtensions(h=>this.onDidInstallExtensions(h))),this._register(d.onDidUninstallExtension(h=>this.onDidUninstallExtension(h)));const v=P.URI.file(u.extensionsPath),p=new S.ExtUri(h=>!b.hasCapability(h,1024));this._register(b.watch(v)),this._register(C.Event.filter(b.onDidChangeFilesRaw,h=>h.changes.some(f=>this.doesChangeAffects(f,v,p)))(()=>this.onDidChange()))}doesChangeAffects(d,b,u){return u.isEqual(u.dirname(d.resource),b)?u.isEqual(d.resource,u.joinPath(b,".obsolete"))?!0:!(d.type!==1&&d.type!==2||u.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const b of d)this.removeInstallingExtension(b.identifier),b.local&&this.addInstalledExtension(b.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(b=>!(0,L.areSameExtensions)(b,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,L.areSameExtensions)(b,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),b=d.filter(c=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,L.areSameExtensions)(v,c.identifier))?!1:c.installedTimestamp&&c.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",c.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",c.identifier.id),!1)),u=this.installedExtensions.filter(c=>this.installingExtensions.some(v=>(0,L.areSameExtensions)(v,c))?!1:d.every(v=>!(0,L.areSameExtensions)(v.identifier,c))?(this.logService.info("Detected extension removed from another source",c.id),!0):!1);this.installedExtensions=d.map(c=>c.identifier),(b.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:u})}}};E=de([ce(1,l.IFileService),ce(2,R.INativeEnvironmentService),ce(3,g.ILogService)],E),t.ExtensionsWatcher=E}),define(J[110],Y([0,1,132,20,6,2,5,8,12,21,22,23,54,14]),function(V,t,C,I,S,P,R,L,l,g,E,D,d,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let u=class extends P.Disposable{constructor(p,h,f){super();this.extensionManagementService=p,this.logService=f,this.cache=this._register(new c(h,f)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const p=await this.cache.getLanguagePacks(),h=["en",...Object.keys(p)];return(0,I.distinct)(h)}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const h=await this.cache.getLanguagePacks();Object.keys(h).some(f=>h[f]&&h[f].extensions.some(o=>(0,D.areSameExtensions)(o.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,h]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(h);return!(0,I.equals)(Object.keys(p),Object.keys(f))}};u=de([ce(0,E.IExtensionManagementService),ce(1,g.INativeEnvironmentService),ce(2,b.ILogService)],u),t.LocalizationsService=u;let c=class extends P.Disposable{constructor(p,h){super();this.logService=h,this.languagePacks={},this.languagePacksFilePath=(0,L.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new S.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(h=>{Object.keys(h).forEach(f=>delete h[f]),this.createLanguagePacksFromExtensions(h,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...h){for(const f of h)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,f);Object.keys(p).forEach(f=>this.updateHash(p[f]))}createLanguagePacksFromExtension(p,h){const f=h.identifier,o=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const s of o)if(h.location.scheme===R.Schemas.file&&(0,d.isValidLocalization)(s)){let e=p[s.languageId];e||(e={hash:"",extensions:[],translations:{}},p[s.languageId]=e);let i=e.extensions.filter(n=>(0,D.areSameExtensions)(n.extensionIdentifier,f))[0];i?i.version=h.manifest.version:e.extensions.push({extensionIdentifier:f,version:h.manifest.version});for(const n of s.translations)e.translations[n.id]=(0,L.join)(h.location.fsPath,n.path)}}updateHash(p){if(p){const h=(0,C.createHash)("md5");for(const f of p.extensions)h.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);p.hash=h.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let h=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(o){return{}}}).then(f=>(h=p(f),f)).then(f=>{for(const s of Object.keys(f))f[s]||delete f[s];this.languagePacks=f,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),l.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>h,f=>this.logService.error(f))})}};c=de([ce(0,g.INativeEnvironmentService),ce(1,b.ILogService)],c)}),define(J[44],Y([0,1,17,84,34,15,25]),function(V,t,C,I,S,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,P.createDecorator)("requestService");function L(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=L;function l(u){return u.res.statusCode===204}async function g(u){if(!L(u))throw new Error("Server returned "+u.res.statusCode);return l(u)?null:(await(0,C.streamToBuffer)(u.stream)).toString()}t.asText=g;async function E(u){if(!L(u))throw new Error("Server returned "+u.res.statusCode);if(l(u))return null;const v=(await(0,C.streamToBuffer)(u.stream)).toString();try{return JSON.parse(v)}catch(p){throw p.message+=`:
`+v,p}}t.asJson=E;function D(u){b(u)}t.updateProxyConfigurationsScope=D;let d;function b(u){const c=R.Registry.as(S.Extensions.Configuration),v=d;d={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},c.updateConfigurations({add:[d],remove:v?[v]:[]})}b(2)}),define(J[111],Y([0,1,24,5,16,44]),function(V,t,C,I,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let R=class{constructor(l,g){this.requestService=l,this.fileService=g}async download(l,g,E=C.CancellationToken.None){if(l.scheme===I.Schemas.file||l.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(l,g);return}const D={type:"GET",url:l.toString()},d=await this.requestService.request(D,E);if(d.res.statusCode===200)await this.fileService.writeFile(g,d.stream);else{const b=await(0,P.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${b}`)}}};R=de([ce(0,P.IRequestService),ce(1,S.IFileService)],R),t.DownloadService=R}),define(J[112],Y([0,1,113,10]),function(V,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function S(R,L){return R.protocol==="http:"?L.HTTP_PROXY||L.http_proxy||null:R.protocol==="https:"&&(L.HTTPS_PROXY||L.https_proxy||L.HTTP_PROXY||L.http_proxy)||null}async function P(R,L,l={}){const g=(0,C.parse)(R),E=l.proxyUrl||S(g,L);if(!E)return null;const D=(0,C.parse)(E);if(!/^https?:$/.test(D.protocol||""))return null;const d={host:D.hostname||"",port:D.port||(D.protocol==="https"?"443":"80"),auth:D.auth,rejectUnauthorized:(0,I.isBoolean)(l.strictSSL)?l.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((b,u)=>{V(["http-proxy-agent"],b,u)}))(d):new(await new Promise((b,u)=>{V(["https-proxy-agent"],b,u)}))(d)}t.getProxyAgent=P}),define(J[114],Y([0,1,17,31]),function(V,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function S(P,R,L){let l=L&&L.get("storage.serviceMachineId",0)||null;if(l)return l;try{const E=(await R.readFile(P.serviceMachineIdResource)).value.toString();l=(0,I.isUUID)(E)?E:null}catch(g){l=null}if(!l){l=(0,I.generateUuid)();try{await R.writeFile(P.serviceMachineIdResource,C.VSBuffer.fromString(l))}catch(g){}}return L&&L.store("storage.serviceMachineId",l,0,1),l}t.getServiceMachineId=S}),define(J[115],Y([0,1,6,13,2,10,65,15]),function(V,t,C,I,S,P,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const l="__$__targetStorageMarker";t.IStorageService=(0,L.createDecorator)("storageService");var g;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(g=t.WillSaveStateReason||(t.WillSaveStateReason={}));var E;(function(c){c[c.GLOBAL=0]="GLOBAL",c[c.WORKSPACE=1]="WORKSPACE"})(E=t.StorageScope||(t.StorageScope={}));var D;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(D=t.StorageTarget||(t.StorageTarget={}));class d extends S.Disposable{constructor(v={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,p){p===l?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:p,target:this.getKeyTargets(v)[p]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,p,h){return this.getStorage(p)?.get(v,h)}getBoolean(v,p,h){return this.getStorage(p)?.getBoolean(v,h)}getNumber(v,p,h){return this.getStorage(p)?.getNumber(v,h)}store(v,p,h,f){if((0,P.isUndefinedOrNull)(p)){this.remove(v,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,h,f),this.getStorage(h)?.set(v,p)})}remove(v,p){this.withPausedEmitters(()=>{this.updateKeyTarget(v,p,void 0),this.getStorage(p)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,p){const h=[],f=this.getKeyTargets(v);for(const o of Object.keys(f))f[o]===p&&h.push(o);return h}updateKeyTarget(v,p,h){const f=this.getKeyTargets(p);typeof h=="number"?f[v]!==h&&(f[v]=h,this.getStorage(p)?.set(l,JSON.stringify(f))):typeof f[v]=="number"&&(delete f[v],this.getStorage(p)?.set(l,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const p=this.get(l,v);if(p)try{return JSON.parse(p)}catch(h){}return Object.create(null)}isNew(v){return this.getBoolean(t.IS_NEW_KEY,v)===!0}async flush(v=g.NONE){this._onWillSaveState.fire({reason:v}),await C.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const v=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return u(v,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends d{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}t.InMemoryStorageService=b;async function u(c,v,p,h){const f=a=>{try{return JSON.parse(a)}catch(y){return a}},o=new Map,s=new Map;c.forEach((a,y)=>{o.set(y,a),s.set(y,f(a))});const e=new Map,i=new Map;v.forEach((a,y)=>{e.set(y,a),i.set(y,f(a))}),console.group(`Storage: Global (path: ${p})`);let n=[];o.forEach((a,y)=>{n.push({key:y,value:a})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${h})`);let r=[];e.forEach((a,y)=>{r.push({key:y,value:a})}),console.table(r),console.groupEnd(),console.log(i)}t.logStorage=u}),define(J[116],Y([0,1,11,28,7,31]),function(V,t,C,I,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function R(g){if(C.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function L(g,E,D,d,b,u,c,v,p,h){const f=Object.create(null);f["common.machineId"]=c,f.sessionID=(0,P.generateUuid)()+Date.now(),f.commitHash=b,f.version=u,f["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,C.PlatformToString)(C.platform),f["common.nodePlatform"]=I.platform,f["common.nodeArch"]=d,f["common.product"]=h||"desktop";const o=l(v||[]);o&&(f["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),C.isLinuxSnap&&(f["common.snap"]="true");const i=R(D);i&&(f["common.platformDetail"]=i);try{const n=await g.readFile(S.URI.file(p));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}t.resolveCommonProperties=L;function l(g){const E=I.env.USERDNSDOMAIN;if(!E)return!1;const D=E.toLowerCase();return g.some(d=>D===d)}t.verifyMicrosoftInternalDomain=l}),define(J[29],Y([0,1,15]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,C.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(I=t.TelemetryLevel||(t.TelemetryLevel={}));var S;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(S=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(J[117],Y([0,1,20,6,24,9,13,2,11,7,74,22,23,14,33,29]),function(V,t,C,I,S,P,R,L,l,g,E,D,d,b,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let v=class extends L.Disposable{constructor(s,e,i){super();this.galleryService=s,this.telemetryService=e,this.logService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const e=await this.getTargetPlatform();return s.allTargetPlatforms.some(i=>(0,D.isTargetPlatformCompatible)(i,s.allTargetPlatforms,e))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(E.localize(0,null));if(!await this.canInstall(s)){const n=await this.getTargetPlatform(),r=new D.ExtensionManagementError(E.localize(1,null,s.identifier.id,u.default.nameLong,(0,D.TargetPlatformToString)(n)),t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",s.identifier.id,r.message),h(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,r),r}try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(n){throw this.logService.error((0,P.getErrorMessage)(n)),h(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,n),n}const i=await this.galleryService.getManifest(s,S.CancellationToken.None);if(i===null){const n=new D.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,n.message),h(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,n),n}if(i.version!==s.version){const n=new D.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),h(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,n),n}return this.installExtension(i,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(2,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(E.localize(3,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,i){if(!g.URI.isUri(e)){let w=this.installingExtensions.get(new d.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(w)return this.logService.info("Extensions is already requested to install",e.identifier.id),w.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],a=this.createInstallExtensionTask(s,e,i);g.URI.isUri(e)||this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),n.push({task:a,manifest:s});let y=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:m,manifest:T}of O)if(y=y||!!T.extensionDependencies?.some(F=>(0,d.areSameExtensions)({id:F},a.identifier)),this.installingExtensions.has(new d.ExtensionIdentifierWithVersion(m.identifier,m.version).key()))this.logService.info("Extension is already requested to install",m.identifier.id);else{const F=this.createInstallExtensionTask(T,m,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(F.identifier,T.version).key(),F),this._onInstallExtension.fire({identifier:F.identifier,source:m}),this.logService.info("Installing extension:",F.identifier.id),n.push({task:F,manifest:T})}}catch(O){if(g.URI.isUri(a.source))(0,C.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,O.message),(0,C.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(O),O}const w=n.reduce((O,{task:m,manifest:T})=>(O.set(m.identifier.id.toLowerCase(),{task:m,manifest:T}),O),new Map);for(;w.size;){let O;const m=[...w.values()].filter(({manifest:T})=>!T.extensionDependencies?.some(F=>w.has(F.toLowerCase())));m.length?O=w.size===1?m:m.filter(({task:T})=>!(T===a&&!y)):(this.logService.info("Found extensions with circular dependencies",m.map(({task:T})=>T.identifier.id)),O=[...w.values()]),await this.joinAllSettled(O.map(async({task:T})=>{const F=new Date().getTime();try{const z=await T.run();if(await this.joinAllSettled(this.participants.map(K=>K.postInstall(z,T.source,i,S.CancellationToken.None))),!g.URI.isUri(T.source)&&(h(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-F,void 0),l.isWeb&&T.operation===1))try{await this.galleryService.reportStatistic(z.manifest.publisher,z.manifest.name,z.manifest.version,"install")}catch(K){}r.push({local:z,identifier:T.identifier,operation:T.operation,source:T.source})}catch(z){throw g.URI.isUri(T.source)||h(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-F,z),this.logService.error("Error while installing the extension:",T.identifier.id),this.logService.error(z),z}finally{w.delete(T.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:O})=>(0,d.areSameExtensions)(O,a.identifier))[0].local}catch(w){if(n.forEach(({task:O})=>O.cancel()),r.length)try{const O=await Promise.allSettled(r.map(({local:m})=>this.createUninstallExtensionTask(m,{versionOnly:!0}).run()));for(let m=0;m<O.length;m++){const T=O[m],{identifier:F}=r[m];T.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",F.id):this.logService.warn("Rollback: Error while uninstalling extension",F.id,(0,P.getErrorMessage)(T.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,P.getErrorMessage)(O),r.map(({identifier:m})=>m.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,P.getErrorMessage)(w)),this._onDidInstallExtensions.fire(n.map(({task:O})=>({identifier:O.identifier,operation:1,source:O.source}))),w instanceof Error&&(w.name=w&&w.code?w.code:t.ERROR_UNKNOWN),w}finally{for(const{task:w,manifest:O}of n)if(!g.URI.isUri(w.source)){const m=new d.ExtensionIdentifierWithVersion(w.identifier,O.version).key();this.installingExtensions.delete(m)||this.logService.warn("Installation task is not found in the cache",m)}}}async joinAllSettled(s){const e=[],i=[],n=await Promise.allSettled(s);for(const r of n)r.status==="fulfilled"?e.push(r.value):i.push(r.reason);if(i.length)throw p(i);return e}async getAllDepsAndPackExtensionsToInstall(s,e,i){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[s,...n.map(w=>w.identifier)],a=[],y=async(w,O)=>{const m=O.extensionDependencies||[],T=[...m];if(O.extensionPack){const F=i?n.find(z=>(0,d.areSameExtensions)(z.identifier,w)):void 0;for(const z of O.extensionPack)F&&F.manifest.extensionPack&&F.manifest.extensionPack.some(K=>(0,d.areSameExtensions)({id:K},{id:z}))||T.every(K=>!(0,d.areSameExtensions)({id:K},{id:z}))&&T.push(z)}if(T.length){const F=[...r,...a.map(K=>K.gallery.identifier)],z=T.filter(K=>F.every(Z=>!(0,d.areSameExtensions)(Z,{id:K})));if(z.length){const K=await this.galleryService.query({names:z,pageSize:T.length},S.CancellationToken.None);for(const Z of K.firstPage){if(F.find(ae=>(0,d.areSameExtensions)(ae,Z.identifier)))continue;if(!m.some(ae=>(0,d.areSameExtensions)({id:ae},Z.identifier))&&!await this.canInstall(Z)){this.logService.info("Skipping the packed extension as it cannot be installed",Z.identifier.id);continue}const te=await this.checkAndGetCompatibleVersion(Z,!0),ue=await this.galleryService.getManifest(te,S.CancellationToken.None);if(ue===null)throw new D.ExtensionManagementError(`Missing manifest for extension ${te.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:te,manifest:ue}),await y(te.identifier,ue)}}}};return await y(s,e),n=await this.getInstalled(),a.filter(w=>!n.some(O=>(0,d.areSameExtensions)(O.identifier,w.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new D.ExtensionManagementError(E.localize(4,null,s.identifier.id),D.INSTALL_ERROR_MALICIOUS);const i=await this.getCompatibleVersion(s,e);if(!i)throw new D.ExtensionManagementError(E.localize(5,null,s.identifier.id,u.default.version),D.INSTALL_ERROR_INCOMPATIBLE);return i}async getCompatibleVersion(s,e){const i=await this.getTargetPlatform();let n=null;return await this.galleryService.isExtensionCompatible(s,i)&&(n=s),!n&&e&&(n=await this.galleryService.getCompatibleExtension(s,i)),n}async isMalicious(s){const e=await this.getExtensionsReport();return(0,d.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const i=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),i.waitUntilTaskIsFinished();const n=(w,O)=>{const m=this.createUninstallExtensionTask(w,O);return this.uninstallingExtensions.set(m.extension.identifier.id.toLowerCase(),m),this.logService.info("Uninstalling extension:",w.identifier.id),this._onUninstallExtension.fire(w.identifier),m},r=(w,O)=>{O?this.logService.error("Failed to uninstall extension:",w.identifier.id,O.message):this.logService.info("Successfully uninstalled extension:",w.identifier.id),h(this.telemetryService,"extensionGallery:uninstall",(0,d.getLocalExtensionTelemetryData)(w),void 0,O),this._onDidUninstallExtension.fire({identifier:w.identifier,error:O?.code})},a=[],y=[];try{a.push(n(s,{}));const w=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const O=this.getAllPackExtensionsToUninstall(s,w);for(const m of O)this.uninstallingExtensions.has(m.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",m.identifier.id):a.push(n(m,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(O=>O.extension),w,s),await this.joinAllSettled(a.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(m=>m.postUninstall(O.extension,e,S.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch(m){}r(O.extension)}catch(m){const T=m instanceof D.ExtensionManagementError?m:new D.ExtensionManagementError((0,P.getErrorMessage)(m),t.ERROR_UNKNOWN);throw r(O.extension,T),T}finally{y.push(O)}}))}catch(w){const O=w instanceof D.ExtensionManagementError?w:new D.ExtensionManagementError((0,P.getErrorMessage)(w),t.ERROR_UNKNOWN);for(const m of a){try{m.cancel()}catch(T){}y.includes(m)||r(m.extension,O)}throw O}finally{for(const w of a)this.uninstallingExtensions.delete(w.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",w.extension.identifier.id)}}checkForDependents(s,e,i){for(const n of s){const r=this.getDependents(n,e);if(r.length){const a=r.filter(y=>!s.some(w=>(0,d.areSameExtensions)(w.identifier,y.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(n,a,i))}}}getDependentsErrorMessage(s,e,i){return i===s?e.length===1?E.localize(6,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?E.localize(7,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):E.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?E.localize(9,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?E.localize(10,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):E.localize(11,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,i=[]){if(i.indexOf(s)!==-1)return[];i.push(s);const n=s.manifest.extensionPack?s.manifest.extensionPack:[];if(n.length){const r=e.filter(y=>!y.isBuiltin&&n.some(w=>(0,d.areSameExtensions)({id:w},y.identifier))),a=[];for(const y of r)a.push(...this.getAllPackExtensionsToUninstall(y,e,i));return[...r,...a]}return[]}getDependents(s,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(n=>(0,d.areSameExtensions)({id:n},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},S.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},S.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};v=de([ce(0,D.IExtensionGalleryService),ce(1,c.ITelemetryService),ce(2,b.ILogService)],v),t.AbstractExtensionManagementService=v;function p(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=p;function h(o,s,e,i,n){const r=n?n instanceof D.ExtensionManagementError?n.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!n,duration:i,errorcode:r})}t.reportTelemetry=h;class f{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(s=>new Promise((e,i)=>{const n=s.onCancellationRequested(()=>{n.dispose(),i((0,P.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=f}),define(J[37],Y([0,1,18,10,26,29]),function(V,t,C,I,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class R{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,h){return Promise.resolve(void 0)}publicLog2(p,h){return this.publicLog(p,h)}publicLogError(p,h){return Promise.resolve(void 0)}publicLogError2(p,h){return this.publicLogError(p,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=R,t.NullTelemetryService=new R;class L{async publicLog(p,h,f){}async publicLogError(p,h,f){}}t.NullEndpointTelemetryService=L,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(v,p){return p.onDidChangeConfiguration(h=>{h.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,S.ConfigurationTargetToString)(h.source),configurationKeys:u(h.sourceConfig)})})}t.configurationTelemetry=l;function g(v,p){return!(p.disableTelemetry||!v.enableTelemetry)}t.supportsTelemetry=g;function E(v){const p=v.getValue(P.TELEMETRY_SETTING_ID),h=v.getValue("telemetry.enableCrashReporter");if(v.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=E;function D(v){const p=Object.create(null),h=Object.create(null),f=Object.create(null);b(v,f);for(let o in f){o=o.length>150?o.substr(o.length-149):o;const s=f[o];typeof s=="number"?h[o]=s:typeof s=="boolean"?h[o]=s?1:0:typeof s=="string"?p[o]=s.substring(0,1023):typeof s!="undefined"&&s!==null&&(p[o]=s)}return{properties:p,measurements:h}}t.validateTelemetryData=D;function d(v){if(!v)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{v.indexOf(`${f}+`)===0&&(p=f)}),p}t.cleanRemoteAuthority=d;function b(v,p,h=0,f){if(!!v)for(let o of Object.getOwnPropertyNames(v)){const s=v[o],e=f?f+o:o;Array.isArray(s)?p[e]=(0,C.safeStringify)(s):s instanceof Date?p[e]=s.toISOString():(0,I.isObject)(s)?h<2?b(s,p,h+1,e+"."):p[e]=(0,C.safeStringify)(s):p[e]=s}}function u(v){if(!v)return[];const p=[];return c(p,"",v),p}function c(v,p,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(f=>c(v,p?`${p}.${f}`:f,h[f])):v.push(p)}}),define(J[118],Y([0,1,20,24,9,18,11,28,7,26,21,22,23,50,16,14,41,44,114,115,29,37]),function(V,t,C,I,S,P,R,L,l,g,E,D,d,b,u,c,v,p,h,f,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=R.isWeb?"web":(0,D.getTargetPlatform)(R.platform,L.arch);var i;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(i||(i={}));function n(...U){return String(U.reduce((N,q)=>N|q,0))}var r;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},y={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},O={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class m{constructor(N=O){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,q=this.state.pageSize){return new m({...this.state,pageNumber:N,pageSize:q})}withFilter(N,...q){const W=[...this.state.criteria,...q.length?q.map(X=>({filterType:N,value:X})):[{filterType:N}]];return new m({...this.state,criteria:W})}withSortBy(N){return new m({...this.state,sortBy:N})}withSortOrder(N){return new m({...this.state,sortOrder:N})}withFlags(...N){return new m({...this.state,flags:N.reduce((q,W)=>q|W,0)})}withAssetTypes(...N){return new m({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:q,pageSize:W,sortBy:X,sortOrder:Q,flags:se,assetTypes:re}=this.state;return{filters:[{criteria:N,pageNumber:q,pageSize:W,sortBy:X,sortOrder:Q}],assetTypes:re,flags:se}}get searchText(){const N=this.state.criteria.filter(q=>q.filterType===r.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(U,N){const q=(U||[]).filter(W=>W.statisticName===N)[0];return q?q.value:0}function F(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(W=>W.assetType.indexOf(N)===0).reduce((W,X)=>{const Q=oe(U,X.assetType);return Q&&W.push([X.assetType.substring(N.length),Q]),W},[])}function z(U){if(U.properties){const N=U.properties.filter(X=>X.key===a.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=N.filter(X=>q.test(X.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return oe(U,a.Repository)}function K(U){return{uri:`${U.fallbackAssetUri}/${a.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${a.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function Z(U){const N=oe(U,a.Icon);if(N)return N;const q=D.DefaultIconPath;return{uri:q,fallbackUri:q}}function oe(U,N){return U.files.filter(W=>W.assetType===N)[0]?{uri:`${U.assetUri}/${N}`,fallbackUri:`${U.fallbackAssetUri}/${N}`}:null}function te(U,N){const q=U.properties?U.properties.filter(X=>X.key===N):[],W=q.length>0&&q[0].value;return W?W.split(",").map(X=>(0,d.adoptToGalleryExtensionId)(X)):[]}function ue(U){const N=U.properties?U.properties.filter(q=>q.key===y.Engine):[];return N.length>0&&N[0].value||""}function ae(U){const N=U.properties?U.properties.filter(W=>W.key===y.LocalizedLanguages):[],q=N.length>0&&N[0].value||"";return q?q.split(","):[]}function B(U){return U.indexOf("preview")!==-1}function ne(U){return U.targetPlatform?(0,D.toTargetPlatform)(U.targetPlatform):"undefined"}function M(U){const N=(0,C.distinct)(U.versions.map(ne)),q=!!U.tags?.includes(D.WEB_EXTENSION_TAG),W=N.indexOf("web");return q?W===-1&&N.push("web"):W!==-1&&N.splice(W,1),N}function A(U,N){const q=(0,D.getFallbackTargetPlarforms)(N);for(let W=0;W<U.length;W++){const X=U[W];if(X.version===U[W-1]?.version){let Q=W;const se=ne(X);if(se===N)for(;Q>0&&U[Q-1].version===X.version;)Q--;else if(q.includes(se))for(;Q>0&&U[Q-1].version===X.version&&ne(U[Q-1])!==N;)Q--;Q!==W&&(U.splice(W,1),U.splice(Q,0,X))}}return U}t.sortExtensionVersions=A;function x(U,N,q,W,X){const Q=M(U);let se=U.versions[0];return se=U.versions.find(re=>re.version===se.version&&(0,D.isTargetPlatformCompatible)(ne(re),Q,X))||se,G(U,se,Q,N,q,W)}function G(U,N,q,W,X,Q){const se={manifest:oe(N,a.Manifest),readme:oe(N,a.Details),changelog:oe(N,a.Changelog),license:oe(N,a.License),repository:z(N),download:K(N),icon:Z(N),coreTranslations:F(N)};return{identifier:{id:(0,d.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,description:U.shortDescription||"",installCount:T(U.statistics,"install"),rating:T(U.statistics,"averagerating"),ratingCount:T(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:q,assets:se,properties:{dependencies:te(N,y.Dependency),extensionPack:te(N,y.ExtensionPack),engine:ue(N),localizedLanguages:ae(N),targetPlatform:ne(N)},preview:B(U.flags),telemetryData:{index:(X.pageNumber-1)*X.pageSize+W,querySource:Q}}}let ie=class{constructor(N,q,W,X,Q,se,re,me){this.requestService=q,this.logService=W,this.environmentService=X,this.telemetryService=Q,this.fileService=se,this.productService=re,this.configurationService=me;const ye=re.extensionsGallery;this.extensionsGalleryUrl=ye&&ye.serviceUrl,this.extensionsControlUrl=ye&&ye.controlUrl,this.commonHeadersPromise=_(re.version,re,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,q){const W=[];let X=new m().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,N.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...N.map(({id:se})=>se.toLowerCase()));N.every(se=>!se.version)&&(X=X.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:Q}=await this.queryGallery(X,e,I.CancellationToken.None);for(let se=0;se<Q.length;se++){const re=Q[se];if(!re.versions.length)continue;const me=(0,d.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),ye=N.find(fe=>(0,d.areSameExtensions)(fe,{id:me}))?.version;if(ye){const fe=re.versions.find(Ie=>Ie.version===ye);fe&&W.push(G(re,fe,M(re),se,X))}else W.push(x(re,se,X,void 0,e))}return W}async getCompatibleExtension(N,q){const W=(0,D.isIExtensionIdentifier)(N)?null:N;if(W){if((0,D.isNotWebExtensionInWebTargetPlatform)(W.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(W,q))return W}const{id:X,uuid:Q}=W?W.identifier:N;let se=new m().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?se=se.withFilter(r.ExtensionId,Q):se=se.withFilter(r.ExtensionName,X);const{galleryExtensions:re}=await this.queryGallery(se,q,I.CancellationToken.None),[me]=re;if(!me||!me.versions.length)return null;const ye=M(me);if((0,D.isNotWebExtensionInWebTargetPlatform)(ye,q))return null;for(let fe of me.versions){if(!ue(fe)){const Ie=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:y.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(fe,ye,q))return G(me,fe,ye,0,se)}return null}async isExtensionCompatible(N,q){if(!(0,D.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,q))return!1;let W=N.properties.engine;if(!W){const X=await this.getManifest(N,I.CancellationToken.None);if(!X)throw new Error("Manifest was not found");W=X.engines.vscode}return(0,b.isEngineValid)(W,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,q,W){if(!(0,D.isTargetPlatformCompatible)(ne(N),q,W))return!1;const X=await this.getEngine(N);return(0,b.isEngineValid)(X,this.productService.version,this.productService.date)}async query(N,q){const W=I.CancellationToken.isCancellationToken(N)?{}:N,X=I.CancellationToken.isCancellationToken(N)?N:q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Q=W.text||"";const se=(0,P.getOrDefault)(W,pe=>pe.pageSize,50);let re=new m().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,se).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ee,Fe)=>(re=re.withFilter(r.Category,Fe||Ee),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ee,Fe)=>(re=re.withFilter(r.Tag,Fe||Ee),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),re=re.withFilter(r.SearchText,Q)),re=re.withSortBy(0)):W.ids?re=re.withFilter(r.ExtensionId,...W.ids):W.names?re=re.withFilter(r.ExtensionName,...W.names):re=re.withSortBy(4),typeof W.sortBy=="number"&&(re=re.withSortBy(W.sortBy)),typeof W.sortOrder=="number"&&(re=re.withSortOrder(W.sortOrder));const{galleryExtensions:me,total:ye}=await this.queryGallery(re,e,X),fe=me.map((pe,Ee)=>x(pe,Ee,re,W.source,e)),Ie=async(pe,Ee)=>{if(Ee.isCancellationRequested)throw(0,S.canceled)();const Fe=re.withPage(pe+1),{galleryExtensions:Me}=await this.queryGallery(Fe,e,Ee);return Me.map((ze,xe)=>x(ze,xe,Fe,W.source,e))};return{firstPage:fe,total:ye,pageSize:re.pageSize,getPage:Ie}}async queryGallery(N,q,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,i.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,n(i.Unpublished));const X=await this.commonHeadersPromise,Q=JSON.stringify(N.raw),se={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},re=new Date().getTime();let me,ye,fe=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:se},W),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:fe};const Ie=await(0,p.asJson)(me);if(Ie){const pe=Ie.results[0],Ee=pe.extensions;Ee.forEach(Me=>A(Me.versions,q));const Fe=pe.resultMetadata&&pe.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return fe=Fe&&Fe.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:fe}}return{galleryExtensions:[],total:fe}}catch(Ie){throw ye=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-re,success:!!me&&(0,p.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ye?(0,S.isPromiseCanceledError)(ye)?"canceled":(0,S.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(N,q,W,X){if(!this.isEnabled())return;const Q=R.isWeb?this.api(`/itemName/${N}.${q}/version/${W}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${q}/${W}/stats?statType=${X}`),se=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Q,headers:me},I.CancellationToken.None)}catch(ye){}}async download(N,q,W){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const X=(0,d.getGalleryExtensionTelemetryData)(N),Q=new Date().getTime(),se=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),re=W===1?"install":W===2?"update":"",me=re?{uri:`${N.assets.download.uri}${l.URI.parse(N.assets.download.uri).query?"&":"?"}${re}=true`,fallbackUri:`${N.assets.download.fallbackUri}${l.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${re}=true`}:N.assets.download,ye=await this.getAsset(me);await this.fileService.writeFile(q,ye.stream),se(new Date().getTime()-Q)}async getReadme(N,q){if(N.assets.readme){const W=await this.getAsset(N.assets.readme,{},q);return await(0,p.asText)(W)||""}return""}async getManifest(N,q){if(N.assets.manifest){const W=await this.getAsset(N.assets.manifest,{},q),X=await(0,p.asText)(W);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(N,q){const W=oe(N,a.Manifest);if(!W)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Q=await this.getAsset(W,{headers:X});return await(0,p.asJson)(Q)}async getCoreTranslation(N,q){const W=N.assets.coreTranslations.filter(X=>X[0]===q.toUpperCase())[0];if(W){const X=await this.getAsset(W[1]),Q=await(0,p.asText)(X);return Q?JSON.parse(Q):null}return null}async getChangelog(N,q){if(N.assets.changelog){const W=await this.getAsset(N.assets.changelog,{},q);return await(0,p.asText)(W)||""}return""}async getAllCompatibleVersions(N,q){let W=new m().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?W=W.withFilter(r.ExtensionId,N.identifier.uuid):W=W.withFilter(r.ExtensionName,N.identifier.id);const{galleryExtensions:X}=await this.queryGallery(W,q,I.CancellationToken.None);if(!X.length)return[];const Q=M(X[0]);if((0,D.isNotWebExtensionInWebTargetPlatform)(Q,q))return[];const se=[];for(const re of X[0].versions)try{se[se.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,Q,q)&&se.push({version:re.version,date:re.lastUpdated})}catch(me){}return se}async getAsset(N,q={},W=I.CancellationToken.None){const X=await this.commonHeadersPromise,Q={type:"GET"},se={...X,...q.headers||{}};q={...q,...Q,headers:se};const re=N.uri,me=N.fallbackUri,ye={...q,url:re};try{const fe=await this.requestService.request(ye,W);if(fe.res.statusCode===200)return fe;const Ie=await(0,p.asText)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${Ie}`)}catch(fe){if((0,S.isPromiseCanceledError)(fe))throw fe;const Ie=(0,S.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:re,message:Ie});const pe={...q,url:me};return this.requestService.request(pe,W)}}async getEngine(N){let q=ue(N);if(!q){const W=await this.getManifestFromRawExtensionVersion(N,I.CancellationToken.None);if(!W)throw new Error("Manifest was not found");q=W.engines.vscode}return q}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,p.asJson)(N),W=new Map;if(q)for(const X of q.malicious){const Q=W.get(X)||{id:{id:X},malicious:!0,slow:!1};Q.malicious=!0,W.set(X,Q)}return[...W.values()]}};ie=de([ce(1,p.IRequestService),ce(2,c.ILogService),ce(3,E.IEnvironmentService),ce(4,o.ITelemetryService),ce(5,u.IFileService),ce(6,v.IProductService),ce(7,g.IConfigurationService)],ie);let H=class extends ie{constructor(N,q,W,X,Q,se,re,me){super(N,q,W,X,Q,se,re,me)}};H=de([ce(0,f.IStorageService),ce(1,p.IRequestService),ce(2,c.ILogService),ce(3,E.IEnvironmentService),ce(4,o.ITelemetryService),ce(5,u.IFileService),ce(6,v.IProductService),ce(7,g.IConfigurationService)],H),t.ExtensionGalleryService=H;let ee=class extends ie{constructor(N,q,W,X,Q,se,re){super(void 0,N,q,W,X,Q,se,re)}};ee=de([ce(0,p.IRequestService),ce(1,c.ILogService),ce(2,E.IEnvironmentService),ce(3,o.ITelemetryService),ce(4,u.IFileService),ce(5,v.IProductService),ce(6,g.IConfigurationService)],ee),t.ExtensionGalleryServiceWithNoStorageService=ee;async function _(U,N,q,W,X,Q){const se={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},re=await(0,h.getServiceMachineId)(q,X,Q);return(0,s.supportsTelemetry)(N,q)&&(0,s.getTelemetryLevel)(W)===3&&(se["X-Market-User-Id"]=re),se}t.resolveMarketplaceHeaders=_}),define(J[119],Y([0,1,2,18,11,27,85,26,34,33,25,29,37]),function(V,t,C,I,S,P,R,L,l,g,E,D,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let b=class{constructor(v,p){this._configurationService=p,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let h of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,P.escapeRegExpCharacters)(h),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(h=>{const f=/^[a-f0-9]+$/i.test(h["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(v,p){this._experimentProperties[v]=p}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let p=v.sessionID,h=v["common.instanceId"],f=v["common.machineId"],o=v["common.firstSessionDate"],s=v["common.msftInternal"];return{sessionId:p,instanceId:h,machineId:f,firstSessionDate:o,msftInternal:s}}dispose(){this._disposables.dispose()}_log(v,p,h,f){return this.telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(o=>{h=(0,I.mixin)(h,o),h=(0,I.mixin)(h,this._experimentProperties),h=(0,I.cloneAndChange)(h,s=>{if(typeof s=="string")return this._cleanupInfo(s,f)}),this._appenders.forEach(s=>s.log(v,h))},o=>{console.error(o)})}publicLog(v,p,h){return this._log(v,3,p,h)}publicLog2(v,p,h){return this.publicLog(v,p,h)}publicLogError(v,p){return this.sendErrorTelemetry?this._log(v,2,p,!0):Promise.resolve(void 0)}publicLogError2(v,p){return this.publicLogError(v,p)}_anonymizeFilePaths(v){let p=v;const h=[];for(let e of this._cleanupPatterns)for(;;){const i=e.exec(v);if(!i)break;h.push([i.index,e.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(p="";;){const e=o.exec(v);if(!e)break;!f.test(e[0])&&h.every(([i,n])=>e.index<i||e.index>=n)&&(p+=v.substring(s,e.index)+"<REDACTED: user-file-path>",s=o.lastIndex)}return s<v.length&&(p+=v.substr(s)),p}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const p=v.toLowerCase(),h=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(p)?"<REDACTED: secret>":h.test(p)?"<REDACTED: email>":v}_cleanupInfo(v,p){let h=v;p&&(h=this._anonymizeFilePaths(h));for(let f of this._cleanupPatterns)h=h.replace(f,"");return h=this._removePropertiesWithPossibleUserInfo(h),h}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=de([ce(1,L.IConfigurationService)],b),t.TelemetryService=b;function u(){const c=(0,R.localize)(0,null,g.default.nameLong),v=g.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=S.isWeb?"":(0,R.localize)(3,null),h=(0,R.localize)(4,null),f=(0,R.localize)(5,null),o=(0,R.localize)(6,null),s=(0,R.localize)(7,null),e=`
|       | ${h} | ${f} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,R.localize)(8,null);return`
${c} ${v} ${p}

&nbsp;

${s}
${e}

&nbsp;

${i}
`}E.Registry.as(l.Extensions.Configuration).registerConfiguration({id:D.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(9,null),properties:{[D.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(l.Extensions.Configuration).registerConfiguration({id:D.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[D.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,R.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,R.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${D.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[120],Y([0,1,9,18,37]),function(V,t,C,I,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function P(L){const l=await new Promise((E,D)=>{V(["applicationinsights"],E,D)});let g;return l.defaultClient?(g=new l.TelemetryClient(L),g.channel.setUseDiskRetryCaching(!0)):(l.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=l.defaultClient),L.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class R{constructor(l,g,E){this._eventPrefix=l,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof E=="function"?this._aiClient=E():this._aiClient=E,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=P(this._aiClient)),this._asyncAIClient.then(g=>{l(g)},g=>{(0,C.onUnexpectedError)(g),console.error(g)})}}log(l,g){!this._aiClient||(g=(0,I.mixin)(g,this._defaultData),g=(0,S.validateTelemetryData)(g),this._withAIClient(E=>E.trackEvent({name:this._eventPrefix+"/"+l,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=R}),define(J[121],Y([0,1,8,12]),function(V,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function S(P,R){const L=Object.create(null),l=(E,D)=>{const d=JSON.parse(E);L[D]=d};if(R){const E=[],D=await I.Promises.readdir(R);for(const b of D)try{(await I.Promises.stat((0,C.join)(R,b))).isDirectory()&&E.push(b)}catch{}const d=[];for(const b of E)(await I.Promises.readdir((0,C.join)(R,b))).filter(c=>c==="telemetry.json").length===1&&d.push(b);for(const b of d){const u=(await I.Promises.readFile((0,C.join)(R,b,"telemetry.json"))).toString();l(u,b)}}let g=(await I.Promises.readFile((0,C.join)(P,"telemetry-core.json"))).toString();return l(g,"vscode-core"),g=(await I.Promises.readFile((0,C.join)(P,"telemetry-extensions.json"))).toString(),l(g,"vscode-extensions"),JSON.stringify(L,null,4)}t.buildTelemetryMessage=S}),define(J[45],Y([0,1,48,6,8,10,12,71,133,134]),function(V,t,C,I,S,P,R,L,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class E extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=E;function D(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function d(s){if(s instanceof E)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new E(e,s)}function b(s,e,i,n,r,a){const y=S.dirname(e),w=S.join(n,y);if(!w.startsWith(n))return Promise.reject(new Error(L.localize(0,null,e)));const O=S.join(n,e);let m;return a.onCancellationRequested(()=>{m&&m.destroy()}),Promise.resolve(R.Promises.mkdir(w,{recursive:!0})).then(()=>new Promise((T,F)=>{if(!a.isCancellationRequested)try{m=(0,C.createWriteStream)(O,{mode:i}),m.once("close",()=>T()),m.once("error",F),s.once("error",F),s.pipe(m)}catch(z){F(z)}}))}function u(s,e,i,n){let r=(0,I.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((y,w)=>{const O=new I.Sequencer,m=T=>{T.isCancellationRequested||(a++,s.readEntry())};s.once("error",w),s.once("close",()=>r.then(()=>{n.isCancellationRequested||s.entryCount===a?y():w(new E("Incomplete",new Error(L.localize(1,null,a,s.entryCount))))},w)),s.readEntry(),s.on("entry",T=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(T.fileName)){m(n);return}const F=T.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(F)){const Z=S.join(e,F);r=(0,I.createCancelablePromise)(oe=>R.Promises.mkdir(Z,{recursive:!0}).then(()=>m(oe)).then(void 0,w));return}const z=v(s,T),K=D(T);r=(0,I.createCancelablePromise)(Z=>O.queue(()=>z.then(oe=>b(oe,F,K,e,i,Z).then(()=>m(Z)))).then(null,w))})})}function c(s,e=!1){return new Promise((i,n)=>{(0,l.open)(s,e?{lazyEntries:!0}:void 0,(r,a)=>{r?n(d(r)):i((0,P.assertIsDefined)(a))})})}function v(s,e){return new Promise((i,n)=>{s.openReadStream(e,(r,a)=>{r?n(d(r)):i((0,P.assertIsDefined)(a))})})}function p(s,e){return new Promise((i,n)=>{const r=new g.ZipFile;e.forEach(y=>{y.contents?r.addBuffer(typeof y.contents=="string"?Buffer.from(y.contents,"utf8"):y.contents,y.path):y.localPath&&r.addFile(y.localPath,y.path)}),r.end();const a=(0,C.createWriteStream)(s);r.outputStream.pipe(a),r.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(s))})}t.zip=p;function h(s,e,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=c(s,!0);return i.overwrite&&(a=a.then(y=>R.Promises.rm(e).then(()=>y))),a.then(y=>u(y,e,{sourcePathRegex:r},n))}t.extract=h;function f(s,e){return c(s).then(i=>new Promise((n,r)=>{i.on("entry",a=>{a.fileName===e&&v(i,a).then(y=>n(y),y=>r(y))}),i.once("close",()=>r(new Error(L.localize(2,null,e))))}))}function o(s,e){return f(s,e).then(i=>new Promise((n,r)=>{const a=[];i.once("error",r),i.on("data",y=>a.push(y)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=o}),define(J[122],Y([0,1,45,78]),function(V,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function S(P){return(0,C.buffer)(P,"extension/package.json").then(R=>{try{return JSON.parse(R.toString("utf8"))}catch(L){throw new Error((0,I.localize)(0,null))}})}t.getManifest=S}),define(J[123],Y([0,1,20,6,9,2,5,8,11,19,43,7,31,12,45,79,21,22,23,89,16,14,41]),function(V,t,C,I,S,P,R,L,l,g,E,D,d,b,u,c,v,p,h,f,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",r="extracting",a="deleting",y="renaming";let w=class extends P.Disposable{constructor(m,T,F,z,K){super();this.beforeRemovingExtension=m,this.fileService=T,this.logService=F,this.environmentService=z,this.productService=K,this._devSystemExtensionsPath=null,this.systemExtensionsPath=z.builtinExtensionsPath,this.extensionsPath=z.extensionsPath,this.uninstalledPath=L.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new I.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(m){const T=[];(m===null||m===0)&&T.push(this.scanSystemExtensions().then(null,F=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(F).message,i)))),(m===null||m===1)&&T.push(this.scanUserExtensions(!0).then(null,F=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(F).message,n))));try{const F=await Promise.all(T);return(0,C.flatten)(F)}catch(F){throw this.joinErrors(F)}}async scanUserExtensions(m){this.logService.trace("Started scanning user extensions");let[T,F]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return F=F.filter(z=>!T[new h.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]),m&&(F=(0,h.groupByExtension)(F,K=>K.identifier).map(K=>K.sort((Z,oe)=>E.rcompare(Z.manifest.version,oe.manifest.version))[0])),this.logService.trace("Scanned user extensions:",F.length),F}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(m,T,F,z){const K=m.key(),Z=L.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),oe=L.join(this.extensionsPath,K);try{await b.Promises.rm(oe)}catch(ue){try{await b.Promises.rm(oe)}catch(ae){}throw new p.ExtensionManagementError((0,c.localize)(0,null,oe,m.id),a)}await this.extractAtLocation(m,T,Z,z);let te=await this.scanExtension(D.URI.file(Z),1);if(!te)throw new Error((0,c.localize)(1,null,Z));await this.storeMetadata(te,{...F,installedTimestamp:Date.now()});try{await this.rename(m,Z,oe,Date.now()+2*60*1e3),this.logService.info("Renamed to",oe)}catch(ue){try{await b.Promises.rm(Z)}catch(ae){}if(ue.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",m.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(ue)}. Deleted from extracted location`,Z),ue}try{te=await this.scanExtension(D.URI.file(oe),1)}catch(ue){}if(te)return te;throw new Error((0,c.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(m,T){return this.setMetadata(m,T),await this.storeMetadata(m,{...T,installedTimestamp:m.installedTimestamp}),m}async storeMetadata(m,T){T.isMachineScoped=T.isMachineScoped||void 0,T.isBuiltin=T.isBuiltin||void 0,T.installedTimestamp=T.installedTimestamp||void 0;const F=L.join(m.location.fsPath,"package.json"),z=await b.Promises.readFile(F,"utf8"),{manifest:K}=await this.parseManifest(z);return K.__metadata=T,await b.Promises.writeFile(F,JSON.stringify(K,null,"	")),m}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...m){const T=m.map(F=>new h.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version));await this.withUninstalledExtensions(F=>{T.forEach(z=>F[z.key()]=!0)})}async setInstalled(m){await this.withUninstalledExtensions(z=>delete z[m.key()]);const F=(await this.scanExtensions(1)).find(z=>new h.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).equals(m))||null;return F?(await this.storeMetadata(F,{installedTimestamp:Date.now()}),this.scanExtension(F.location,1)):null}async withUninstalledExtensions(m){return this.uninstalledFileLimiter.queue(async()=>{let T;try{T=await b.Promises.readFile(this.uninstalledPath,"utf8")}catch(z){if(z.code!=="ENOENT")throw z}let F={};if(T)try{F=JSON.parse(T)}catch(z){}return m&&(m(F),Object.keys(F).length?await b.Promises.writeFile(this.uninstalledPath,JSON.stringify(F)):await b.Promises.rm(this.uninstalledPath)),F})}async removeExtension(m,T){this.logService.trace(`Deleting ${T} extension from disk`,m.identifier.id,m.location.fsPath),await b.Promises.rm(m.location.fsPath),this.logService.info("Deleted from disk",m.identifier.id,m.location.fsPath)}async removeUninstalledExtension(m){await this.removeExtension(m,"uninstalled"),await this.withUninstalledExtensions(T=>delete T[new h.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()])}async extractAtLocation(m,T,F,z){this.logService.trace(`Started extracting the extension from ${T} to ${F}`);try{await b.Promises.rm(F)}catch(K){throw new p.ExtensionManagementError(this.joinErrors(K).message,a)}try{await(0,u.extract)(T,F,{sourcePath:"extension",overwrite:!0},z),this.logService.info(`Extracted extension to ${F}:`,m.id)}catch(K){try{await b.Promises.rm(F)}catch(Z){}throw new p.ExtensionManagementError(K.message,K instanceof u.ExtractError&&K.type?K.type:r)}}async rename(m,T,F,z){try{await b.Promises.rename(T,F)}catch(K){if(l.isWindows&&K&&K.code==="EPERM"&&Date.now()<z)return this.logService.info(`Failed renaming ${T} to ${F} with 'EPERM' error. Trying again...`,m.id),this.rename(m,T,F,z);throw new p.ExtensionManagementError(K.message||(0,c.localize)(3,null,T,F),K.code||y)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const m=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return m;const T=this.scanDevSystemExtensions(),[F,z]=await Promise.all([m,T]);return[...F,...z]}async scanExtensionsInDir(m,T){const F=new I.Limiter(10),z=await this.fileService.resolve(D.URI.file(m));return z.children?(await Promise.all(z.children.filter(Z=>Z.isDirectory).map(Z=>F.queue(async()=>T===1&&(0,g.basename)(Z.resource).indexOf(".")===0?null:this.scanExtension(Z.resource,T))))).filter(Z=>Z&&Z.identifier):[]}async scanExtension(m,T){try{const F=await this.fileService.resolve(m);if(F.children){const{manifest:z,metadata:K}=await this.readManifest(m.fsPath),Z=F.children.find(({name:ae})=>/^readme(\.txt|\.md|)$/i.test(ae))?.resource,oe=F.children.find(({name:ae})=>/^changelog(\.txt|\.md|)$/i.test(ae))?.resource,te={id:(0,h.getGalleryExtensionId)(z.publisher,z.name)},ue={type:T,identifier:te,manifest:z,location:m,readmeUrl:Z,changelogUrl:oe,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:T===0};return K&&(this.setMetadata(ue,K),ue.installedTimestamp=K.installedTimestamp),ue}}catch(F){T!==0&&this.logService.trace(F)}return null}async scanDefaultSystemExtensions(){const m=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",m.length),m}async scanDevSystemExtensions(){const m=this.getDevSystemExtensionsList();if(m.length){const T=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",T.length),T.filter(F=>m.some(z=>(0,h.areSameExtensions)(F.identifier,{id:z})))}else return[]}setMetadata(m,T){m.publisherDisplayName=T.publisherDisplayName||null,m.publisherId=T.publisherId||null,m.identifier.uuid=T.id,m.isMachineScoped=!!T.isMachineScoped,m.isBuiltin=m.type===0||!!T.isBuiltin}async removeUninstalledExtensions(){const m=await this.getUninstalledExtensions(),T=await this.scanAllUserExtensions(),F=new Set;for(const Z of T)m[new h.ExtensionIdentifierWithVersion(Z.identifier,Z.manifest.version).key()]||F.add(Z.identifier.id.toLowerCase());const z=(0,h.groupByExtension)(T,Z=>Z.identifier);await I.Promises.settled(z.map(async Z=>{const oe=Z.sort((te,ue)=>E.rcompare(te.manifest.version,ue.manifest.version))[0];F.has(oe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(oe)}));const K=T.filter(Z=>m[new h.ExtensionIdentifierWithVersion(Z.identifier,Z.manifest.version).key()]);await I.Promises.settled(K.map(Z=>this.removeUninstalledExtension(Z)))}async removeOutdatedExtensions(){const m=await this.scanAllUserExtensions(),T=[],F=(0,h.groupByExtension)(m,z=>z.identifier);T.push(...(0,C.flatten)(F.map(z=>z.sort((K,Z)=>E.rcompare(K.manifest.version,Z.manifest.version)).slice(1)))),await I.Promises.settled(T.map(z=>this.removeExtension(z,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(m=>m.name)}joinErrors(m){const T=Array.isArray(m)?m:[m];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((F,z)=>new Error(`${F.message}${F.message?",":""}${z instanceof Error?z.message:z}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=L.normalize(L.join(R.FileAccess.asFileUri("",V).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(m){const T=[b.Promises.readFile(L.join(m,"package.json"),"utf8").then(Z=>this.parseManifest(Z)),b.Promises.readFile(L.join(m,"package.nls.json"),"utf8").then(void 0,Z=>Z.code!=="ENOENT"?Promise.reject(Z):"{}").then(Z=>JSON.parse(Z))],[{manifest:F,metadata:z},K]=await Promise.all(T);return{manifest:(0,f.localizeManifest)(F,K),metadata:z}}parseManifest(m){return new Promise((T,F)=>{try{const z=JSON.parse(m),K=z.__metadata||null;T({manifest:z,metadata:K})}catch(z){F(new Error((0,c.localize)(4,null)))}})}};w=de([ce(1,o.IFileService),ce(2,s.ILogService),ce(3,v.INativeEnvironmentService),ce(4,e.IProductService)],w),t.ExtensionsScanner=w}),define(J[124],Y([0,1,30,9,5,8,11,28,19,43,7,31,12,45,77,52,21,117,22,23,107,97,122,108,123,109,50,16,15,14,33,29]),function(V,t,C,I,S,P,R,L,l,g,E,D,d,b,u,c,v,p,h,f,o,s,e,i,n,r,a,y,w,O,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const F="unsetUninstalled",z="downloading";let K=class extends p.AbstractExtensionManagementService{constructor(B,ne,M,A,x,G,ie){super(B,ne,M);this.environmentService=A,this.downloadService=x,this.fileService=ie;const H=this._register(G.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(n.ExtensionsScanner,_=>H.postUninstall(_))),this.manifestCache=this._register(new i.ExtensionsManifestCache(A,this)),this.extensionsDownloader=this._register(G.createInstance(o.ExtensionsDownloader));const ee=this._register(new r.ExtensionsWatcher(this,ie,A,M));this._register(ee.onDidChangeExtensionsByAnotherSource(({added:_,removed:U})=>{_.length&&this._onDidInstallExtensions.fire(_.map(N=>({identifier:N.identifier,operation:0,local:N}))),U.forEach(N=>this._onDidUninstallExtension.fire({identifier:N}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const B=await this.isAlpineLinux(),ne=(0,h.getTargetPlatform)(B?"alpine":R.platform,L.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",ne),ne})()),this._targetPlatformPromise}async isAlpineLinux(){if(!R.isLinux)return!1;let B;try{B=(await this.fileService.readFile(E.URI.file("/etc/os-release"))).value.toString()}catch(ne){try{B=(await this.fileService.readFile(E.URI.file("/usr/lib/os-release"))).value.toString()}catch(M){this.logService.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(M))}}return!!B&&(B.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const ne=await this.collectFiles(B),M=await(0,b.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,D.generateUuid)()).fsPath,ne);return E.URI.file(M)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const ne=await this.downloadVsix(B),M=P.resolve(ne.fsPath);return(0,e.getManifest)(M)}getInstalled(B=null){return this.extensionsScanner.scanExtensions(B)}async install(B,ne={}){this.logService.trace("ExtensionManagementService#install",B.toString());const M=await this.downloadVsix(B),A=await(0,e.getManifest)(P.resolve(M.fsPath));if(A.engines&&A.engines.vscode&&!(0,a.isEngineValid)(A.engines.vscode,m.default.version,m.default.date))throw new Error(u.localize(0,null,(0,f.getGalleryExtensionId)(A.publisher,A.name),m.default.version));return this.installExtension(A,M,ne)}async updateMetadata(B,ne){return this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},...ne}),this.manifestCache.invalidate(),B}async updateExtensionScope(B,ne){return this.logService.trace("ExtensionManagementService#updateExtensionScope",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},isMachineScoped:ne}),this.manifestCache.invalidate(),B}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(B){if(B.scheme===S.Schemas.file)return B;const ne=(0,l.joinPath)(this.environmentService.tmpDir,(0,D.generateUuid)());return await this.downloadService.download(B,ne),ne}createInstallExtensionTask(B,ne,M){return E.URI.isUri(ne)?new te(B,ne,M,this.galleryService,this.extensionsScanner,this.logService):new oe(ne,M,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(B,ne){return new ue(B,ne,this.extensionsScanner)}async collectFiles(B){const ne=async A=>{let x=await d.Promises.readdir(A);x=x.map(H=>P.join(A,H));const G=await Promise.all(x.map(H=>d.Promises.stat(H)));let ie=Promise.resolve([]);return G.forEach((H,ee)=>{const _=x[ee];H.isFile()&&(ie=ie.then(U=>[...U,_])),H.isDirectory()&&(ie=ie.then(U=>ne(_).then(N=>[...U,...N])))}),ie};return(await ne(B.location.fsPath)).map(A=>({path:`extension/${P.relative(B.location.fsPath,A)}`,localPath:A}))}};K=de([ce(0,h.IExtensionGalleryService),ce(1,T.ITelemetryService),ce(2,O.ILogService),ce(3,v.INativeEnvironmentService),ce(4,c.IDownloadService),ce(5,w.IInstantiationService),ce(6,y.IFileService)],K),t.ExtensionManagementService=K;class Z extends p.AbstractExtensionTask{constructor(B,ne,M,A){super();this.identifier=B,this.source=ne,this.extensionsScanner=M,this.logService=A,this._operation=1}get operation(){return this._operation}async installExtension(B,ne){try{const M=await this.unsetUninstalledAndGetLocal(B.identifierWithVersion);if(M)return B.metadata?this.extensionsScanner.saveMetadataForLocalExtension(M,B.metadata):M}catch(M){throw R.isMacintosh?new h.ExtensionManagementError(u.localize(1,null),F):new h.ExtensionManagementError(u.localize(2,null),F)}return this.extract(B,ne)}async unsetUninstalledAndGetLocal(B){if(!await this.isUninstalled(B))return null;this.logService.trace("Removing the extension from uninstalled list:",B.id);const M=await this.extensionsScanner.setInstalled(B);return this.logService.info("Removed the extension from uninstalled list:",B.id),M}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.key()]}async extract({zipPath:B,identifierWithVersion:ne,metadata:M},A){let x=await this.extensionsScanner.extractUserExtension(ne,B,M,A);return this.logService.info("Extracting completed.",ne.id),x}}class oe extends Z{constructor(B,ne,M,A,x){super(B.identifier,B,A,x);this.gallery=B,this.options=ne,this.extensionsDownloader=M}async doRun(B){const M=(await this.extensionsScanner.scanExtensions(null)).find(x=>(0,f.areSameExtensions)(x.identifier,this.gallery.identifier));M&&(this._operation=2);const A=await this.downloadInstallableExtension(this.gallery,this._operation);A.metadata.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,A.metadata.isBuiltin=this.options.isBuiltin||M?.isBuiltin;try{const x=await this.installExtension(A,B);return M&&g.neq(M.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(M),x}catch(x){throw await this.deleteDownloadedVSIX(A.zipPath),x}}async deleteDownloadedVSIX(B){try{await this.extensionsDownloader.delete(E.URI.file(B))}catch(ne){this.logService.warn("Error while deleting the downloaded vsix",B.toString(),(0,I.getErrorMessage)(ne))}}async downloadInstallableExtension(B,ne){const M={id:B.identifier.uuid,publisherId:B.publisherId,publisherDisplayName:B.publisherDisplayName};let A;try{this.logService.trace("Started downloading extension:",B.identifier.id),A=(await this.extensionsDownloader.downloadExtension(B,ne)).fsPath,this.logService.info("Downloaded extension:",B.identifier.id,A)}catch(x){throw new h.ExtensionManagementError((0,p.joinErrors)(x).message,z)}try{const x=await(0,e.getManifest)(A);return{zipPath:A,identifierWithVersion:new f.ExtensionIdentifierWithVersion(B.identifier,x.version),metadata:M}}catch(x){throw await this.deleteDownloadedVSIX(A),new h.ExtensionManagementError((0,p.joinErrors)(x).message,p.INSTALL_ERROR_VALIDATING)}}}class te extends Z{constructor(B,ne,M,A,x,G){super({id:(0,f.getGalleryExtensionId)(B.publisher,B.name)},ne,x,G);this.manifest=B,this.location=ne,this.options=M,this.galleryService=A}async doRun(B){const ne=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),A=(await this.extensionsScanner.scanExtensions(1)).find(G=>(0,f.areSameExtensions)(this.identifier,G.identifier)),x=await this.getMetadata(this.identifier.id,B);if(x.isMachineScoped=this.options.isMachineScoped||A?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||A?.isBuiltin,A)if(this._operation=2,ne.equals(new f.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version)))try{await this.extensionsScanner.removeExtension(A,"existing")}catch(G){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else g.gt(A.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(A);else{const G=await this.unsetUninstalledAndGetLocal(ne);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch(ie){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:P.resolve(this.location.fsPath),identifierWithVersion:ne,metadata:x},B)}async getMetadata(B,ne){try{const M=(await this.galleryService.query({names:[B],pageSize:1},ne)).firstPage[0];if(M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId}}catch(M){}return{}}}class ue extends p.AbstractExtensionTask{constructor(B,ne,M){super();this.extension=B,this.options=ne,this.extensionsScanner=M}async doRun(B){const ne=[],M=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const A=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);ne.push(...M.filter(x=>A.equals(new f.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version))))}else ne.push(...M.filter(A=>(0,f.areSameExtensions)(A.identifier,this.extension.identifier)));if(!ne.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ne),this.options.remove)for(const A of ne)try{B.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(A)}catch(x){throw new Error(u.localize(6,null,(0,C.toErrorMessage)(x)))}}}}),define(J[125],Y([0,1,113,17,9,2,10,26,21,91,14,112,135]),function(V,t,C,I,S,P,R,L,l,g,E,D,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let b=class extends P.Disposable{constructor(c,v,p){super();this.environmentService=v,this.logService=p,this.configure(c.getValue()),this._register(c.onDidChangeConfiguration(()=>this.configure(c.getValue()),this))}configure(c){this.proxyUrl=c.http&&c.http.proxy,this.strictSSL=!!(c.http&&c.http.proxyStrictSSL),this.authorization=c.http&&c.http.proxyAuthorization}async request(c,v){this.logService.trace("RequestService#request",c.url);const{proxyUrl:p,strictSSL:h}=this;let f;try{f=await(0,g.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(e){this.logService.error("RequestService#request resolving shell environment failed",e)}const o={...process.env,...f},s=c.agent?c.agent:await(0,D.getProxyAgent)(c.url||"",o,{proxyUrl:p,strictSSL:h});return c.agent=s,c.strictSSL=h,this.authorization&&(c.headers={...c.headers||{},"Proxy-Authorization":this.authorization}),this._request(c,v)}async getNodeRequest(c){return((0,C.parse)(c.url).protocol==="https:"?await new Promise((h,f)=>{V(["https"],h,f)}):await new Promise((h,f)=>{V(["http"],h,f)})).request}_request(c,v){return new Promise(async(p,h)=>{let f;const o=(0,C.parse)(c.url),s=c.getRawRequest?c.getRawRequest(c):await this.getNodeRequest(c),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,R.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(e.auth=c.user+":"+c.password),f=s(e,i=>{const n=(0,R.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...c,url:i.headers.location,followRedirects:n-1},v).then(p,h);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,d.createGunzip)())),p({res:i,stream:(0,I.streamToBufferReadableStream)(r)})}}),f.on("error",h),c.timeout&&f.setTimeout(c.timeout),c.data&&typeof c.data=="string"&&f.write(c.data),f.end(),v.onCancellationRequested(()=>{f.abort(),h((0,S.canceled)())})})}async resolveProxy(c){}};b=de([ce(0,L.IConfigurationService),ce(1,l.INativeEnvironmentService),ce(2,E.ILogService)],b),t.RequestService=b}),define(J[136],Y([0,1,48,137,35,6,17,30,9,2,5,8,28,7,12,26,104,52,111,21,88,118,22,106,124,16,99,101,51,96,53,54,110,14,98,33,41,44,125,116,29,119,37,120,121]),function(V,t,C,I,S,P,R,L,l,g,E,D,d,b,u,c,v,p,h,f,o,s,e,i,n,r,a,y,w,O,m,T,F,z,K,Z,oe,te,ue,ae,B,ne,M,A,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class G extends g.Disposable{constructor(ee){super();this.argv=ee,(0,I.gracefulify)(C),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ee,_]=await this.initServices();return ee.invokeFunction(async U=>{const N=U.get(z.ILogService),q=U.get(r.IFileService),W=U.get(f.INativeEnvironmentService),X=U.get(e.IExtensionManagementCLIService);N.info("CLI main",this.argv),this.registerErrorHandler(N),await this.doRun(W,X,q),await Promise.all(_.map(Q=>{(0,P.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const ee=new m.ServiceCollection,_={_serviceBrand:void 0,...Z.default};ee.set(oe.IProductService,_);const U=new o.NativeEnvironmentService(this.argv,_);ee.set(f.INativeEnvironmentService,U),await Promise.all([U.appSettingsHome.fsPath,U.extensionsPath].map(me=>me?u.Promises.mkdir(me,{recursive:!0}):void 0));const N=(0,z.getLogLevel)(U),q=[];q.push(new K.SpdLogLogger("cli",(0,D.join)(U.logsPath,"cli.log"),!0,N)),N===z.LogLevel.Trace&&q.push(new z.ConsoleLogger(N));const W=this._register(new z.MultiplexLogService(q));ee.set(z.ILogService,W);const X=this._register(new a.FileService(W));ee.set(r.IFileService,X);const Q=this._register(new y.DiskFileSystemProvider(W));X.registerProvider(E.Schemas.file,Q);const se=this._register(new v.ConfigurationService(U.settingsResource,X));ee.set(c.IConfigurationService,se),await se.initialize(),ee.set(te.IRequestService,new w.SyncDescriptor(ue.RequestService)),ee.set(p.IDownloadService,new w.SyncDescriptor(h.DownloadService)),ee.set(e.IExtensionManagementService,new w.SyncDescriptor(n.ExtensionManagementService)),ee.set(e.IExtensionGalleryService,new w.SyncDescriptor(s.ExtensionGalleryServiceWithNoStorageService)),ee.set(e.IExtensionManagementCLIService,new w.SyncDescriptor(i.ExtensionManagementCLIService)),ee.set(T.ILocalizationsService,new w.SyncDescriptor(F.LocalizationsService));const re=[];if((0,M.supportsTelemetry)(_,U)){_.aiConfig&&_.aiConfig.asimovKey&&re.push(new A.AppInsightsAppender("monacoworkbench",null,_.aiConfig.asimovKey));const{appRoot:me,extensionsPath:ye,installSourcePath:fe}=U,Ie={appenders:re,sendErrorTelemetry:!1,commonProperties:(async()=>{let pe;try{const Ee=await u.Promises.readFile((0,D.join)(U.userDataPath,"storage.json"));pe=JSON.parse(Ee.toString())[B.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&W.error(Ee)}return(0,ae.resolveCommonProperties)(X,(0,S.release)(),(0,S.hostname)(),process.arch,_.commit,_.version,pe,_.msftInternalDomains,fe)})(),piiPaths:[me,ye]};ee.set(B.ITelemetryService,new w.SyncDescriptor(ne.TelemetryService,[Ie]))}else ee.set(B.ITelemetryService,M.NullTelemetryService);return[new O.InstantiationService(ee),re]}registerErrorHandler(ee){(0,l.setUnexpectedErrorHandler)(_=>{const U=(0,L.toErrorMessage)(_,!0);!U||ee.error(`[uncaught exception in CLI]: ${U}`)}),process.on("uncaughtException",_=>(0,l.onUnexpectedError)(_)),process.on("unhandledRejection",_=>(0,l.onUnexpectedError)(_))}async doRun(ee,_,U){if(this.argv["install-source"])return this.setInstallSource(ee,U,this.argv["install-source"]);if(this.argv["list-extensions"])return _.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return _.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return _.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return _.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,x.buildTelemetryMessage)(ee.appRoot,ee.extensionsPath))}asExtensionIdOrVSIX(ee){return ee.map(_=>/\.vsix$/i.test(_)?b.URI.file((0,D.isAbsolute)(_)?_:(0,D.join)((0,d.cwd)(),_)):_)}async setInstallSource(ee,_,U){await _.writeFile(b.URI.file(ee.installSourcePath),R.VSBuffer.fromString(U.slice(0,30)))}}async function ie(H){const ee=new G(H);try{await ee.run()}finally{ee.dispose()}}t.main=ie})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d817eda05fc021eefb82d24e4d95554c043b6ec7/core/vs/code/node/cliProcessMain.js.map
